var laya = (function (exports) {
    'use strict';

    class IntervalDisplayAD {
        constructor(ServerConfigKey) {
            this.ServerConfigKey = "";
            this.last_display_time = 0;
            this.is_check = true;
            this.ServerConfigKey = ServerConfigKey;
            this.last_display_time = 0;
        }
        has() {
            if (!this.is_check)
                return true;
            let is_visible = GameSDK$1.isConfigUIModel(this.ServerConfigKey);
            if (!is_visible)
                return false;
            let interval = GameSDK$1.getConfigUIModelInterval(this.ServerConfigKey);
            if (this.ServerConfigKey == "" || interval == 0) {
                return true;
            }
            let now = Math.floor(Date.now() / 1000);
            let sub = 0;
            if (is_visible) {
                sub = now - this.last_display_time;
                if (interval != 0) {
                    if (sub >= interval) {
                        sub = now - IntervalDisplayAD.last_display_time;
                        interval = GameSDK$1.sdk.data[IntervalDisplayAD.ServerConfigKey];
                        if (typeof interval == "string")
                            interval = Number(interval);
                        else if (interval == undefined)
                            interval = 0;
                        if (sub >= interval) {
                            is_visible = true;
                        }
                        else {
                            is_visible = false;
                            console.log("后台控制广告显隐-", this.ServerConfigKey, "-全局间隔时间未达到", sub, interval);
                        }
                    }
                    else
                        is_visible = false;
                }
                this.last_display_time = now;
            }
            if (is_visible) {
                IntervalDisplayAD.last_display_time = now;
                console.log("后台控制广告显隐-", this.ServerConfigKey, "-: visible", is_visible, interval, sub);
            }
            return is_visible;
        }
    }
    IntervalDisplayAD.last_display_time = 0;
    IntervalDisplayAD.ServerConfigKey = "ad_all_interval";

    class BannerMgr {
        constructor() {
            this.IntervalDisplayADBanner = new IntervalDisplayAD("is_banner");
            this._enable_banner_count = 0;
            this._enable_banner_show = false;
        }
        show() {
            this.enable_banner(true);
        }
        hide() {
            this.enable_banner(false);
        }
        has() {
            return this._enable_banner_count != 0;
        }
        checkDelayIsBanner() {
            let delay = GameSDK$1.sdk.data.IntervalAdTime || 0;
            if (!GameSDK$1.isOpenBanner() && delay != 0) {
                Laya.timer.once(delay * 1000 + 200, null, () => {
                    this.check_banner_enable(true);
                });
            }
        }
        enable_banner(is_show) {
            if (is_show)
                this._enable_banner_count++;
            else
                this._enable_banner_count--;
            if (!GameSDK$1.isOpenBanner())
                return;
            Laya.timer.once(200, this, this.check_banner_enable, [is_show], true);
        }
        check_banner_enable(is_show) {
            console.log("banner:", (is_show ? "显示" : "隐藏"), ", 引用计数:", this._enable_banner_count);
            if (this._enable_banner_count > 0 && !this._enable_banner_show) {
                this._enable_banner_show = true;
                if (GameSDK$1.isOpenBanner()) {
                    if (!this.IntervalDisplayADBanner.has())
                        return;
                    GameSDK$1.sdk.showBanner();
                    console.log("banner:", "真正显示");
                }
            }
            if (this._enable_banner_count <= 0 && this._enable_banner_show) {
                this._enable_banner_show = false;
                if (GameSDK$1.isOpenBanner()) {
                    GameSDK$1.sdk.hideBanner();
                    console.log("banner:", "真正隐藏");
                }
            }
        }
    }

    class SDKConfig {
    }
    SDKConfig.getLocation = false;
    SDKConfig.useOpenid = false;
    SDKConfig.GAMEID = "";
    SDKConfig.VIVO_VERSION = "";
    SDKConfig.OPPO_VERSION = "";
    SDKConfig.TOUTIAO_GAME_NAME = "";
    SDKConfig.TOUTIAO_VERSION = "";
    SDKConfig.SHARE_CONTENT = [];
    SDKConfig.TOUTIAO_SHARECONTENT = [];
    SDKConfig.TOUTIAO_SHARETEMPLATEID = [];
    SDKConfig.WECHAT_GAME_NAME = "";
    SDKConfig.WECHAT_VERSION = "";
    SDKConfig.WECHAT_SHARECONTENT = [];
    SDKConfig.WECHAT_SHARETEMPLATEID = [];
    SDKConfig.HBS_VERSION = "";
    SDKConfig.GAME233_APPKEY = "";
    SDKConfig.GAME233_POS = "";
    SDKConfig.APP_IOS_APPID = "";
    SDKConfig.MOMOYU_VERSION = "";

    class ToolSDK {
        static GET_PLT() {
            let plat_type = PlatType$1.WEB;
            let bridge = this.getBridge("demo.JSBridge");
            let plt_str = "浏览器";
            if (bridge != undefined) {
                let platrom = bridge.call("platform");
                if (platrom == "Game233") {
                    plat_type = PlatType$1.GAME233;
                    plt_str = "233乐园";
                }
                else if (platrom == "momoyu") {
                    plat_type = PlatType$1.MOMOYU;
                    plt_str = "摸摸鱼";
                }
                else if (platrom == "meizu") {
                    plat_type = PlatType$1.MEIZU;
                    plt_str = "魅族";
                }
            }
            else {
                if (window['kwaigame']) {
                    plat_type = PlatType$1.KUAIGAME;
                    plt_str = "快手";
                }
                else if (window["tt"] && Laya.Browser["onTTMiniGame"]) {
                    plat_type = PlatType$1.TOUTIAO;
                    plt_str = "头条";
                }
                else if (window['uc']) {
                    plat_type = PlatType$1.GAMEUC;
                    plt_str = "uc浏览器";
                }
                else if (window["qg"]) {
                    if (Laya.Browser.onQGMiniGame) {
                        plat_type = PlatType$1.OPPO;
                        plt_str = "OPPO";
                    }
                    else if (Laya.Browser.onVVMiniGame) {
                        plat_type = PlatType$1.VIVO;
                        plt_str = "VIVO";
                    }
                    else
                        plat_type = PlatType$1.WEB;
                }
                else if (window["hbs"] && Laya.Browser["onHWMiniGame"]) {
                    plat_type = PlatType$1.HBS;
                    plt_str = "华为";
                }
                else if (window["wx"]) {
                    if (Laya.Browser.onWeiXin) {
                        plat_type = PlatType$1.WECHAT;
                        plt_str = "微信";
                    }
                    else if (window["qq"]) {
                        plat_type = PlatType$1["SQQ"];
                        plt_str = "QQ";
                    }
                    else
                        plat_type = PlatType$1.WEB;
                }
                else
                    plat_type = PlatType$1.WEB;
            }
            console.log("自动获取平台:" + plt_str);
            return plat_type;
        }
        static getBridge(pathClass) {
            if (window['conchConfig'] == undefined) {
                return undefined;
            }
            let os = window['conchConfig'].getOS();
            if (os != "Conch-android") {
                return undefined;
            }
            return window['PlatformClass'].createClass(pathClass);
        }
        static randomItem(array) {
            if (array && array.length > 0) {
                return array[this.random(0, array.length - 1)];
            }
            else {
                return null;
            }
        }
        static random(min, max) {
            return Math.round(Math.random() * (max - min) + min);
        }
        static get_cache(key) {
            let data = Laya.LocalStorage.getItem(key);
            if (data == null || data == "null" || data == undefined || data == "" || data == "NaN") {
                return null;
            }
            return data;
        }
        ;
        static set_cache(key, value) {
            Laya.LocalStorage.setItem(key, value);
        }
        ;
        static has(key) {
            return !!this.get_cache(key);
        }
        static delete_cache(key) {
            Laya.LocalStorage.removeItem(key);
        }
        ;
        static clear_cache() {
            Laya.LocalStorage.clear();
        }
        static stopSound() {
            Laya.SoundManager.setMusicVolume(0);
        }
        static replaySound() {
            Laya.SoundManager.setMusicVolume(1);
        }
    }

    class NavigateItem {
    }

    class Handler {
        constructor(caller = null, method = null, args = null, once = false) {
            this.once = false;
            this._id = 0;
            this.setTo(caller, method, args, once);
        }
        setTo(caller, method, args, once = false) {
            this._id = Handler._gid++;
            this.caller = caller;
            this.method = method;
            this.args = args;
            this.once = once;
            return this;
        }
        run() {
            if (this.method == null)
                return null;
            var id = this._id;
            var result = this.method.apply(this.caller, this.args);
            this._id === id && this.once && this.recover();
            return result;
        }
        runWith(data) {
            if (this.method == null)
                return null;
            var id = this._id;
            if (data == null)
                var result = this.method.apply(this.caller, this.args);
            else if (!this.args && !data.unshift)
                result = this.method.call(this.caller, data);
            else if (this.args)
                result = this.method.apply(this.caller, this.args.concat(data));
            else
                result = this.method.apply(this.caller, data);
            this._id === id && this.once && this.recover();
            return result;
        }
        clear() {
            this.caller = null;
            this.method = null;
            this.args = null;
            return this;
        }
        recover() {
            if (this._id > 0) {
                this._id = 0;
                Handler._pool.push(this.clear());
            }
        }
        static create(caller, method, args = null, once = true) {
            if (Handler._pool.length)
                return Handler._pool.pop().setTo(caller, method, args, once);
            return new Handler(caller, method, args, once);
        }
    }
    Handler._pool = [];
    Handler._gid = 1;

    class SxyGame {
        static get instance() {
            return SxyGame._instance || (SxyGame._instance = new SxyGame);
        }
        init() {
        }
        getPlatform() {
            if (typeof window["tt"] != "undefined") {
                SxyGame.platform = window["tt"];
                SxyGame.platformFlag = true;
                console.log("当前平台：头条");
            }
            else if (typeof wx != "undefined") {
                SxyGame.platform = wx;
                SxyGame.platformFlag = true;
                console.log("当前平台：微信");
            }
            else {
                return;
            }
        }
        static sendVideo(data) {
            return;
        }
        static sendEvent(name, params = "") {
            return;
        }
        checkSDK() {
            return;
        }
        getUUID() {
            return;
        }
        setNewPlayer() {
            return;
        }
        static formatDate(date) {
            return;
        }
        getOpenid() {
            return;
        }
        create_uuid() {
            return;
        }
        send(data, action) {
            return;
        }
        sendOpenid(openid) {
            return;
        }
        static paramJoin(data) {
        }
    }
    SxyGame.localVersion = "1.2.0";
    SxyGame.logerUrl = "";
    SxyGame.gameId = '';
    SxyGame.openid = '';
    SxyGame.getLocation = false;
    SxyGame.useOpenid = false;
    SxyGame.platformFlag = false;
    SxyGame.stage = {
        "onStart": function (data) {
            data.method = 'start';
            SxyGame.instance.send(data, "stage");
        },
        "onRunning": function (data) {
            data.method = 'running';
            SxyGame.instance.send(data, "stage");
        },
        "onEnd": function (data) {
            data.method = 'end';
            SxyGame.instance.send(data, "stage");
        }
    };

    var PlayerFlag;
    (function (PlayerFlag) {
        PlayerFlag[PlayerFlag["NO_AD"] = 0] = "NO_AD";
        PlayerFlag[PlayerFlag["NOMAL_HAS_AD"] = 1] = "NOMAL_HAS_AD";
        PlayerFlag[PlayerFlag["CHANNEL0"] = 2] = "CHANNEL0";
    })(PlayerFlag || (PlayerFlag = {}));
    var ErrorCountType;
    (function (ErrorCountType) {
        ErrorCountType[ErrorCountType["VIDEO"] = 0] = "VIDEO";
        ErrorCountType[ErrorCountType["BANNER"] = 1] = "BANNER";
        ErrorCountType[ErrorCountType["NATIVE"] = 2] = "NATIVE";
    })(ErrorCountType || (ErrorCountType = {}));
    class BaseSDK {
        constructor() {
            this._sdkGameData = {};
            this._version = "1.0.10";
            this.onADViewComplete = null;
            this.configURL = "";
            this.data = {};
            this.isShortCutInstalled = false;
            this._isBannerShowing = false;
            this._navigateList = [];
            this._isInitNavigate = false;
            this.cityData = { "code": 200, "loc": ["中国"], "ip": "", "env": "", "nowtime": "" };
            this.defaultServerConfig = {
                "is_AddDesk": { state: "1" },
                "is_AvdFloat": { state: "1" },
                "is_AvdList": { state: "1" },
                "is_GameNative": { state: "1", interval: 5 },
                "is_MoreGameBtn": { state: "0" },
                "is_PropSceneUI": { state: "1", interval: 5 },
                "is_banner": { state: "1", interval: 5 },
                "ad_all_interval": 10,
            };
            this.playerFlag = PlayerFlag.NOMAL_HAS_AD;
            this.mousedowntime = 0;
            var data = ToolSDK.get_cache(("GameData" + SDKConfig.GAMEID));
            if (data) {
                this._sdkGameData = JSON.parse(data);
            }
            else {
                this._sdkGameData = {};
            }
            this.mousedowntime = Date.now();
            Laya.stage.on(Laya.Event.MOUSE_DOWN, this, this.onStageMouseDown);
            Laya.timer.loop(1000, this, () => {
                if (Date.now() - this.mousedowntime > 20 * 1000) {
                    SDKEventMgr.Int.emit(SDKEventName.OpenAutoFN);
                    this.mousedowntime = Date.now();
                    SDKEventMgr.Int.emit(SDKEventName.LONG_TIME_NO_OPERATION);
                }
            });
            SDKEventMgr.Int.on(SDKEventName.OpenAutoFN, this.OpenAutoFN, this);
        }
        get version() {
            return this._version;
        }
        onStageMouseDown() {
            this.mousedowntime = Date.now();
        }
        get sdkGameData() {
            return this._sdkGameData;
        }
        avdErrorLevel() {
            if (this.data.ErrorLevel == undefined) {
                return 0;
            }
            return parseInt(this.data.ErrorLevel);
        }
        errorMaxCount(type) {
            if (type == ErrorCountType.BANNER) {
                if (this.data.ErrorCountB == undefined) {
                    return 0;
                }
                return parseInt(this.data.ErrorCountB);
            }
            else if (type == ErrorCountType.VIDEO) {
                if (this.data.ErrorCountV == undefined) {
                    return 0;
                }
                return parseInt(this.data.ErrorCountV);
            }
            else if (type == ErrorCountType.NATIVE) {
                if (this.data.ErrorCount == undefined) {
                    return 0;
                }
                return parseInt(this.data.ErrorCount);
            }
        }
        checkIsTody(time) {
            var date = new Date(time);
            var dateNow = new Date();
            let bNewDay = false;
            if (date.getFullYear() == dateNow.getFullYear() &&
                date.getMonth() == dateNow.getMonth() &&
                date.getDate() == dateNow.getDate()) {
                bNewDay = true;
            }
            return bNewDay;
        }
        errorCount(type) {
            if (!this._sdkGameData.time)
                this._sdkGameData.time = Date.now();
            if (!this.checkIsTody(this._sdkGameData.time)) {
                this._sdkGameData.curErrorCountB = 0;
                this._sdkGameData.curErrorCountV = 0;
                this._sdkGameData.curErrorCount = 0;
                ToolSDK.set_cache(("GameData" + SDKConfig.GAMEID), JSON.stringify(this._sdkGameData));
            }
            if (type == ErrorCountType.BANNER) {
                if (this._sdkGameData.curErrorCountB == undefined) {
                    return 0;
                }
                return this._sdkGameData.curErrorCountB;
            }
            else if (type == ErrorCountType.VIDEO) {
                if (this._sdkGameData.curErrorCountV == undefined) {
                    return 0;
                }
                return this._sdkGameData.curErrorCountV;
            }
            else if (type == ErrorCountType.NATIVE) {
                if (this._sdkGameData.curErrorCount == undefined) {
                    return 0;
                }
                return this._sdkGameData.curErrorCount;
            }
        }
        updataAvdErrorCount(value, type) {
            this._sdkGameData.time = Date.now();
            if (type == ErrorCountType.BANNER) {
                if (this._sdkGameData.curErrorCountB == value) {
                    return false;
                }
                this._sdkGameData.curErrorCountB = value;
                ToolSDK.set_cache(("GameData" + SDKConfig.GAMEID), JSON.stringify(this._sdkGameData));
                return true;
            }
            else if (type == ErrorCountType.VIDEO) {
                if (this._sdkGameData.curErrorCountV == value) {
                    return false;
                }
                this._sdkGameData.curErrorCountV = value;
                ToolSDK.set_cache(("GameData" + SDKConfig.GAMEID), JSON.stringify(this._sdkGameData));
                return true;
            }
            else if (type == ErrorCountType.NATIVE) {
                if (this._sdkGameData.curErrorCount == value) {
                    return false;
                }
                this._sdkGameData.curErrorCount = value;
                ToolSDK.set_cache(("GameData" + SDKConfig.GAMEID), JSON.stringify(this._sdkGameData));
                return true;
            }
        }
        avdErrorProp() {
            if (this.data.ErrorProba == undefined) {
                return 0;
            }
            return parseFloat(this.data.ErrorProba);
        }
        playGameErrorProp() {
            if (this.data.PlayGameAdProba == undefined) {
                return 0;
            }
            return parseFloat(this.data.PlayGameAdProba);
        }
        enterGameVideoProp() {
            if (this.data.EnterAdProba == undefined) {
                return 0;
            }
            return parseFloat(this.data.EnterAdProba);
        }
        waterFallErrorProp() {
            if (this.data.WaterfallProba == undefined) {
                return 0;
            }
            return parseFloat(this.data.WaterfallProba);
        }
        playGameLevel() {
            if (this.data.PlayGameAd == undefined) {
                return 0;
            }
            return parseInt(this.data.PlayGameAd);
        }
        isCurrentVersion() {
            return true;
        }
        byteToString(arr) {
            if (typeof arr === 'string') {
                return arr;
            }
            var str = '', _arr = arr;
            for (var i = 0; i < _arr.length; i++) {
                var one = _arr[i].toString(2), v = one.match(/^1+?(?=0)/);
                if (v && one.length == 8) {
                    var bytesLength = v[0].length;
                    var store = _arr[i].toString(2).slice(7 - bytesLength);
                    for (var st = 1; st < bytesLength; st++) {
                        store += _arr[st + i].toString(2).slice(2);
                    }
                    str += String.fromCharCode(parseInt(store, 2));
                    i += bytesLength - 1;
                }
                else {
                    str += String.fromCharCode(_arr[i]);
                }
            }
            return str;
        }
        getBytes(str) {
            var bytes = [];
            for (var i = 0; i < str.length; i++) {
                bytes.push(str.charCodeAt(i));
            }
            return bytes;
        }
        decode(data) {
            let bytes = this.getBytes(data);
            for (var i = 0; i < bytes.length; i++) {
                bytes[i] = bytes[i] ^ 359;
            }
            return this.byteToString(bytes);
        }
        initConfig(cb) {
            let count_call = 2;
            let cb_call = () => {
                count_call--;
                if (count_call <= 0) {
                    for (let key in this.defaultServerConfig) {
                        if (this.data[key] == undefined) {
                            this.data[key] = this.defaultServerConfig[key];
                        }
                    }
                    this.onConfigLoad();
                    if (cb)
                        cb();
                }
            };
            Laya.timer.once(5000, this, () => {
                if (count_call > 0) {
                    this.onConfigLoad();
                    if (cb)
                        cb();
                }
            });
            if (GameSDK$1.isDecode)
                this.configURL = this.configURL.replace("api.json", "apijson_en");
            this.request({
                url: this.configURL + "?a=" + Math.random(),
                success: (res) => {
                    if (res.code == 200) {
                        if (GameSDK$1.isDecode) {
                            res = JSON.parse(this.decode(res.data));
                        }
                        else {
                            res = JSON.parse(res.data);
                        }
                        console.log("-------------initConfig--------------", res);
                        for (let key in res) {
                            this.data[key] = res[key];
                        }
                        cb_call();
                    }
                }
            });
            this.request({
                url: "",
                success: (res) => {
                    console.log("-------------initCity--------------", res.data);
                    this.cityData = JSON.parse(res.data);
                    cb_call();
                }
            });
        }
        hasShareRecorder() {
            return false;
        }
        getNavigateList() {
            if (this._isInitNavigate) {
                return this._navigateList;
            }
            let list = this.data.applist || this.data.navigateAppList;
            let len = list.length;
            let item;
            let info;
            for (let i = 0; i < len; i += 1) {
                info = list[i];
                item = new NavigateItem();
                item.appId = info.appid;
                item.name = info.name;
                item.iconPath = info.iconPath.split(",");
                item.videoId = info.videoId;
                item.weight = info.weight;
                this._navigateList.push(item);
            }
            this.shuffle(this._navigateList);
            this._isInitNavigate = true;
            return this._navigateList;
        }
        shuffle(arr, isChangeOriginal = true) {
            if (!isChangeOriginal) {
                let tmp = arr.concat();
                tmp.sort((a, b) => {
                    return Math.random() > .5 ? 1 : -1;
                });
                return tmp;
            }
            else {
                arr.sort((a, b) => {
                    return Math.random() > .5 ? 1 : -1;
                });
                return arr;
            }
        }
        OpenAutoFN() {
        }
        shortCutInstalled(onComplete) { }
        checkShortcut(onComplete) { }
        getLogicScene(onComplete) { }
        navigateToMiniGame(msg) {
        }
        createBanner() {
        }
        showBanner() {
            this._isBannerShowing = true;
        }
        hideBanner() {
            this._isBannerShowing = false;
        }
        isBannerShow() {
            return this._isBannerShowing;
        }
        showADVideo(caller, onComplete, reason, args) {
            this.noticeOpenVideo(reason);
            if (onComplete) {
                this.onADViewComplete = Handler.create(caller, onComplete, args);
                this.onADViewComplete.runWith(true);
            }
        }
        showADInsert() {
        }
        noticeOpenVideo(reason) {
            this.sendVideo({ 'point': reason, 'status': 0 });
        }
        noticeCloseVideo(reason) {
            this.sendVideo({ 'point': reason, 'status': 1 });
        }
        startVideoRecord(time, callback) {
        }
        pauseVideoRecord() {
        }
        resumeVideoRecord() {
        }
        stopVideoRecord() {
        }
        shareVideoRecord(callback) {
            console.log("ADBase.shareVideoRecord");
            if (callback)
                callback(true);
        }
        isSupportShareVideo() {
            return true;
        }
        isSupportErrorClick() {
            return false;
        }
        vibrateShort(type) {
        }
        vibrateLong() {
        }
        createNative(value) {
        }
        showToast(str, time) { }
        onConfigLoad() {
        }
        sendVideo(data) {
        }
        stageOnStart(data) {
            SxyGame.stage.onStart(data);
        }
        statgeOnRunning(data) {
            SxyGame.stage.onRunning(data);
        }
        stageOnEnd(data) {
            SxyGame.stage.onEnd(data);
        }
        sendEvent(name, params = "") {
        }
        request(value) {
            console.log("PlatformVirtual.request", value);
            var xmlhttp;
            if (window.XMLHttpRequest) {
                xmlhttp = new XMLHttpRequest();
            }
            else {
                xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
            }
            xmlhttp.onreadystatechange = function () {
                if (xmlhttp.readyState == 4 && xmlhttp.status == 200) {
                    if (value.success) {
                        var jsonData = null;
                        if (xmlhttp.responseText && xmlhttp.responseText != "")
                            jsonData = xmlhttp.responseText;
                        value.success({ code: xmlhttp.status, data: jsonData });
                    }
                }
            };
            var url = value.url;
            if (value.data) {
                let params = Object.keys(value.data).map(function (key) {
                    return encodeURIComponent(key) + "=" + encodeURIComponent(value.data[key]);
                }).join("&");
                url += "?" + params;
            }
            xmlhttp.open("GET", url, true);
            xmlhttp.send();
        }
        loadSubpackage(pack, zipFileName, topath, comlete, progress) {
            if (comlete)
                comlete(true);
        }
        shareMsg(caller, onComplete, reason, args) {
        }
        showGameBanner() {
        }
        hideGameBanner() {
        }
        showGamePortal() {
        }
        closeCustomAd() { }
        closeBoxPortalAd() { }
        closeBoxBanner() { }
        showCustomAd(isPaster) { }
        checkFollowState(callback) {
            if (callback)
                callback(true);
        }
        openUserProfile(callback) {
            if (callback)
                callback();
        }
        getUserInfo(callback, isTips = true, target = undefined) {
            callback.call(target, { avatarUrl: "", nickName: "测试数据" });
            callback.call(target);
        }
    }

    const cityData$1 = {
        "code": 200,
        "loc": ["中国", "四川", "成都", "武侯", "电信", "104.04303", "30.64235"],
        "ip": "171.221.145.138",
        "env": "",
        "nowtime": "2020-12-30 16:54:16"
    };
    const apiData$1 = {
        "offcitys": [],
        "aderrormaxcount": 0,
        "version": "1.0.1",
        "waterfall": "1",
        "textDelay": 0,
        "isaggreation": 5,
        "advertmaxcount": 5,
        "aderrorrate": 0.2,
        "NativeAd": { "HomeNativeAd": 272469, "WinNativeAd": 272469, "FailNativeAd": 272469 },
        "BannerAd": "272470",
        "RewardedVideoAd": "272471",
        "appid": "30312415",
        "NativeAvd": false,
        "IntervalAdTime": 3,
        "navigateAppList": [],
        "shareList": [],
        "is_AddDesk": { state: "0" },
        "is_AvdFloat": { state: "0" },
        "is_AvdList": { state: "0" },
        "is_GameNative": { state: "0", interval: 5 },
        "is_MoreGameBtn": { state: "0" },
        "is_PropSceneUI": { state: "0", interval: 5 },
        "is_banner": { state: "0", interval: 5 },
        "ad_all_interval": 10,
    };
    class Game233 extends BaseSDK {
        constructor() {
            super();
            this._requestList = [];
            this._isRequest = false;
            this._bridge = ToolSDK.getBridge("demo.JSBridge");
            this.configURL = ``;
            this._bridge.callWithBack(function (res) {
                console.log(res);
            }, "initSdk", SDKConfig.GAME233_APPKEY);
        }
        showADVideo(caller, onComplete, reason, args) {
            if (this._bridge == undefined) {
                return;
            }
            this._bridge.callWithBack(function (value) {
                var obj = JSON.parse(value);
                if (obj.code == 0) {
                    onComplete.call(caller, true);
                }
                else {
                    onComplete.call(caller, false);
                    console.log(obj.message);
                }
            }, "showADVideo", SDKConfig.GAME233_POS);
        }
        initConfig(cb) {
            this.cityData = cityData$1;
            this.data = apiData$1;
            console.log("使用自定义城市配置 方便测试:", this.cityData);
            console.log("使用自定义后台数据配置 方便测试:", this.data);
            this.onConfigLoad();
            if (cb)
                cb();
        }
        request(value) {
            console.log("Game233.request", value);
            this._requestList.push(value);
            this.htmlRequest();
        }
        htmlRequest() {
            if (this._requestList.length <= 0 || this._isRequest) {
                return;
            }
            if (this._bridge == undefined) {
                return;
            }
            let value = this._requestList[0];
            var url = value.url;
            if (value.data) {
                let params = Object.keys(value.data).map(function (key) {
                    return encodeURIComponent(key) + "=" + encodeURIComponent(value.data[key]);
                }).join("&");
                url += "?" + params;
            }
            this._bridge.callWithBack(function (data) {
                var jsonData = JSON.parse(data);
                value.success({ code: 200, data: jsonData });
                this._requestList.splice(0, 1);
                this.htmlRequest();
            }.bind(this), "htmlRequest", url);
        }
    }

    const cityData = {
        "code": 200,
        "loc": ["中国", "四川", "成都", "武侯", "电信", "104.04303", "30.64235"],
        "ip": "171.221.145.138",
        "env": "",
        "nowtime": "2020-12-30 16:54:16"
    };
    const apiData = {
        "offcitys": [],
        "aderrormaxcount": 0,
        "version": "1.0.1",
        "waterfall": "1",
        "textDelay": 0,
        "isaggreation": 5,
        "advertmaxcount": 5,
        "aderrorrate": 0.2,
        "NativeAd": { "HomeNativeAd": 272469, "WinNativeAd": 272469, "FailNativeAd": 272469 },
        "BannerAd": "272470",
        "RewardedVideoAd": "272471",
        "appid": "30312415",
        "NativeAvd": false,
        "IntervalAdTime": 3,
        "navigateAppList": [],
        "shareList": [],
        "is_AddDesk": { state: "0" },
        "is_AvdFloat": { state: "0" },
        "is_AvdList": { state: "0" },
        "is_GameNative": { state: "0", interval: 5 },
        "is_MoreGameBtn": { state: "0" },
        "is_PropSceneUI": { state: "0", interval: 5 },
        "is_banner": { state: "0", interval: 5 },
        "ad_all_interval": 10,
    };
    class GameUC extends BaseSDK {
        constructor() {
            super();
            this._closeCallback = null;
            this.defaultServerConfig = {
                "is_AddDesk": { state: "1" },
                "is_AvdFloat": { state: "1" },
                "is_AvdList": { state: "1" },
                "is_GameNative": { state: "1", interval: 5 },
                "is_MoreGameBtn": { state: "1" },
                "is_PropSceneUI": { state: "1", interval: 5 },
                "is_banner": { state: "1", interval: 5 },
                "ad_all_interval": 10,
            };
            this.isShowBanner = false;
            this._version = "1.0.0";
            this.configURL = ``;
            this.uc = Laya.Browser.window.uc;
            this._systemInfo = JSON.parse(this.uc.getSystemInfoSync());
            this._navigateList = new Array();
        }
        onConfigLoad() {
        }
        initConfig(cb) {
            this.cityData = cityData;
            this.data = apiData;
            console.log("使用自定义城市配置 方便测试:", this.cityData);
            console.log("使用自定义后台数据配置 方便测试:", this.data);
            super.initConfig(cb);
        }
        navigateToMiniGame(msg) {
        }
        shortCutInstalled(onComplete) {
        }
        createBanner() {
            const deviceWidth = this._systemInfo.screenWidth > this._systemInfo.screenHeight ? this._systemInfo.screenHeight : this._systemInfo.screenWidth;
            const width = deviceWidth / 2;
            const height = width * 194 / 345;
            this._bannerNode = this.uc.createBannerAd({
                style: {
                    width: width,
                    height: height,
                    gravity: 7,
                }
            });
        }
        showBanner() {
            if (!this._bannerNode) {
                this.createBanner();
                console.warn("createBanner", this._bannerNode);
            }
            this._bannerNode.onError(err => {
                console.warn("Banner广告加载eror", err);
            });
            this._bannerNode.onLoad(() => {
                console.warn('Banner广告加载成功');
            });
            this._bannerNode.show();
        }
        hideBanner() {
            console.warn("gameSDk hidebanner 22", this._bannerNode);
            if (this._bannerNode) {
                console.warn("   gameSDk hidebanner 333");
                this._bannerNode.hide();
                this._bannerNode.destroy();
                this._bannerNode = null;
            }
        }
        showADVideo(caller, onComplete, reason, args) {
            if (this.uc == undefined)
                return;
            if (this._videoNode) {
                return;
            }
            this.noticeOpenVideo(reason);
            this._videoNode = this.uc.createRewardVideoAd();
            this._videoNode.show().then().catch(err => {
                console.log(err);
                this._videoNode = undefined;
                if (onComplete)
                    onComplete.call(caller, false);
                onComplete = null;
            });
            this._videoNode.onLoad(() => {
                console.log("广告加载成功");
            });
            this._videoNode.onError((error) => {
                console.log('show excitation ad error: ', error);
                this.showToast(error, 2000);
                if (onComplete)
                    onComplete.call(caller, false);
                onComplete = null;
                this._videoNode = undefined;
                ToolSDK.replaySound();
            });
            this._videoNode.onClose((res) => {
                if (res && res.isEnded) {
                    this.showToast('正常播放结束');
                    this.noticeCloseVideo(reason);
                    if (onComplete)
                        onComplete.call(caller, true);
                }
                else {
                    this.showToast('中途退出');
                    this.noticeCloseVideo(reason);
                    if (onComplete)
                        onComplete.call(caller, false);
                }
                onComplete = null;
                ToolSDK.replaySound();
                this._videoNode = undefined;
                GameSDK$1.TestFun();
            });
        }
        showVidwo(reason) {
            var self = this;
            if (this.isShowBanner)
                this._bannerNode.hide();
            this._videoNode.show();
            this._closeCallback && this._videoNode.offClose(this._closeCallback);
            this._closeCallback = function (res) {
                if (self.isShowBanner)
                    self._bannerNode.show();
                self.resumeVideoRecord();
                if (res && res.isEnded || res === undefined) {
                    self.noticeCloseVideo(reason);
                    self.onADViewComplete.runWith(true);
                }
                else {
                    self.onADViewComplete.runWith(false);
                }
                ToolSDK.replaySound();
            };
            this._videoNode.onClose(this._closeCallback);
        }
        createNative(navigateId) {
        }
        showToast(message, time = 2000) {
            this.uc.showToast({
                content: message,
                duration: time
            });
        }
        showADInsert(callBack) {
            const interstitialAd = this.uc.createInterstitialAd();
            interstitialAd.show().then().catch(err => console.log(err));
            interstitialAd.onLoad(() => {
                console.log('插屏-广告加载成功');
            });
            interstitialAd.onError(err => {
                console.log('插屏-广告加载失败', err);
            });
            interstitialAd.onClose(res => {
                console.log('插屏-关闭');
                if (callBack) {
                    callBack();
                }
                callBack = null;
            });
        }
    }

    class Hbs extends BaseSDK {
        constructor() {
            super();
            this._closeCallback = null;
            this.defaultServerConfig = {
                "is_AddDesk": { state: "0" },
                "is_AvdFloat": { state: "0" },
                "is_AvdList": { state: "0" },
                "is_GameNative": { state: "1", interval: 5 },
                "is_MoreGameBtn": { state: "0" },
                "is_PropSceneUI": { state: "0", interval: 5 },
                "is_banner": { state: "0", interval: 5 },
                "ad_all_interval": 10,
            };
            this.isShowBanner = false;
            this.isLoading = false;
            this._version = SDKConfig.HBS_VERSION;
            this.configURL = ``;
            this.hbs = Laya.Browser.window.hbs;
            this.hbs.hasShortcutInstalled({
                success: function (res) {
                    this.isShortCutInstalled = res;
                },
                fail: function () {
                    this.isShortCutInstalled = false;
                }
            });
            this.hbs.onShow(() => {
                ToolSDK.replaySound();
                this.initConfig(null);
            });
            this.hbs.onHide(() => {
            });
        }
        onConfigLoad() {
            this.hbs.gameLoginWithReal({
                forceLogin: 0,
                appid: this.data.appid
            });
        }
        navigateToMiniGame(msg) {
            this.hbs && this.hbs.navigateToQuickApp({
                packageName: msg.packageName,
                extraData: msg.data,
                success: function () {
                    console.log("-----------跳转小游戏:" + msg.name + "成功-----------");
                },
                fail: function (res) {
                    console.log("-----------跳转小游戏:" + msg.name + "失败-----------");
                    console.log(JSON.stringify(res));
                }
            });
        }
        shortCutInstalled(onComplete) {
            var self = this;
            this.hbs.installShortcut({
                message: 'Adds the shortcut to the desktop for convenient use next time.',
                success: function (ret) {
                    console.log('handling install success');
                    onComplete && onComplete(true);
                },
                fail: function (erromsg, errocode) {
                    console.log('handling install fail: ' + erromsg + ", errocode: " + errocode);
                    onComplete && onComplete(false);
                },
                complete: function () {
                    console.log("handling install  complete");
                    self.showToast("桌面图标已创建", 1000);
                }
            });
        }
        createBanner() {
            var self = this;
            this.hbs.getSystemInfoSync();
            this._bannerNode = this.hbs.createBannerAd({
                adUnitId: this.data.BannerAd,
                style: {
                    top: 20,
                    left: 20,
                    height: 57,
                    width: 360
                }
            });
            this._bannerNode.onLoad(function () {
                if (!self.isShowBanner)
                    self._bannerNode.hide();
            });
            this._bannerNode.onError(function (err) {
                console.log("Banner error:", err);
            });
        }
        showBanner() {
            if (this._bannerNode) {
                this.isShowBanner = true;
                this._bannerNode.show();
            }
        }
        hideBanner() {
            if (this._bannerNode)
                this._bannerNode.hide();
            this.isShowBanner = false;
        }
        showADVideo(caller, onComplete, reason, args) {
            let data = GameSDK$1.data;
            if (data && !data.is_load_ad) {
                Handler.create(caller, onComplete, args).runWith(true);
                return;
            }
            var self = this;
            if (typeof (this.hbs.createRewardedVideoAd) == 'undefined')
                return;
            if (this.isLoading)
                return;
            this.showLoading();
            this.noticeOpenVideo(reason);
            this.onADViewComplete = Handler.create(caller, onComplete, args);
            if (!this._videoNode) {
                console.log("广告id:" + this.data.RewardedVideoAd);
                this._videoNode = this.hbs.createRewardedVideoAd({ adUnitId: this.data.RewardedVideoAd });
                this._videoNode.onLoad((e) => {
                    console.log("视频加载成功:", JSON.stringify(e));
                    if (self.showTime)
                        clearTimeout(self.showTime);
                    self.hideLoading();
                    self.showVidwo(reason);
                    ToolSDK.stopSound();
                });
                this._videoNode.onError((err) => {
                    console.log("视频加载失败:", JSON.stringify(err));
                    if (self.showTime)
                        clearTimeout(self.showTime);
                    self.hideLoading();
                    self.showToast("暂无视频", 2000);
                    ToolSDK.replaySound();
                });
            }
            if (this.showTime)
                clearTimeout(this.showTime);
            this._videoNode.load();
            this.showTime = setTimeout(this.hideLoading, 3000);
        }
        showVidwo(reason) {
            var self = this;
            if (this.isShowBanner)
                this._bannerNode.hide();
            this._videoNode.show();
            this._closeCallback && this._videoNode.offClose(this._closeCallback);
            this._closeCallback = function (res) {
                if (self.isShowBanner)
                    self._bannerNode.show();
                self.resumeVideoRecord();
                if (res && res.isEnded || res === undefined) {
                    self.noticeCloseVideo(reason);
                    self.onADViewComplete.runWith(true);
                }
                else {
                    self.onADViewComplete.runWith(false);
                }
                ToolSDK.replaySound();
            };
            this._videoNode.onClose(this._closeCallback);
        }
        showLoading() {
            this.isLoading = true;
            if (this.hbs && this.hbs.showLoading) {
                this.hbs.showLoading({ title: "请求中，请稍后..." });
            }
        }
        hideLoading() {
            this.isLoading = false;
            if (this.hbs && this.hbs.hideLoading) {
                this.hbs.hideLoading({});
            }
        }
        showToast(message, time) {
            this.hbs.showToast({
                title: message,
                icon: "none",
                duration: time
            });
        }
        createNative(navigateId) {
            console.log("广告id:" + navigateId);
            let nativeNode = this.hbs.createNativeAd({
                adUnitId: navigateId
            });
            return nativeNode;
        }
        get addelay() {
            if (!this.data)
                return 0;
            return this.data.textDelay * 1000;
        }
        vibrateShort() {
            this.hbs.vibrateShort({
                success: function () {
                    console.log("log----vibrateShort-----");
                },
                fail: function () { },
                complete: function () { },
            });
        }
        vibrateLong() {
            this.hbs.vibrateLong({
                success: function () {
                    console.log("log----vibrateLong-----");
                },
                fail: function () { },
                complete: function () { },
            });
        }
        loadSubpackage(pack, zipFileName, topath, comlete, progress) {
            this.hbs.getSystemInfoSync();
            let loadTask = this.hbs.loadSubpackage({
                subpackage: pack,
                success: function (info) {
                    if (comlete) {
                        comlete(info);
                    }
                },
                fail: function (info) {
                },
                complete: function () {
                }
            });
            loadTask.onprogress(res => {
                console.log('下载进度', res.progress);
                console.log('已经下载的数据长度', res.loadSize);
                console.log('预期需要下载的数据总长度', res.totalSize);
                if (progress) {
                    progress(res);
                }
            });
        }
        showADInsert() {
            let insertAdNode = this.hbs.createInterstitialAd({
                posId: this.data.InterstitialAd,
            });
            insertAdNode.onError(err => {
                console.log("插屏广告加载失败", err);
            });
            insertAdNode.onLoad(function (data) {
                console.log('onLoad data ' + JSON.stringify(data));
                insertAdNode.show();
            });
            insertAdNode.load();
        }
    }

    class KuaiGame extends BaseSDK {
        constructor() {
            super();
            this._closeCallback = null;
            this._recoderData = undefined;
            this.defaultServerConfig = {
                Offcitys: [],
                aderrormaxcount: 0,
                Version: "1.0.1",
                waterfall: "1",
                textDelay: 0,
                BtnTime: 3,
                isaggreation: 5,
                advertmaxcount: 5,
                aderrorrate: 0.2,
                NativeAd: { HomeNativeAd: 272469, WinNativeAd: 272469, FailNativeAd: 272469 },
                BannerAd: "272470",
                RewardAd: "2300002553_01",
                appid: "30312415",
                NativeAvd: false,
                IntervalAdTime: 3,
                navigateAppList: [],
                shareList: [],
                is_AddDesk: { state: "0" },
                is_AvdFloat: { state: "0" },
                is_AvdList: { state: "0" },
                is_GameNative: { state: "0", interval: 5 },
                is_MoreGameBtn: { state: "0" },
                is_PropSceneUI: { state: "0", interval: 5 },
                is_banner: { state: "0", interval: 5 },
                ad_all_interval: 10,
            };
            this.isShowBanner = false;
            this._isRecordStart = false;
            this._tickRecordBegin = 0;
            this.isLoading = false;
            this._version = SDKConfig.OPPO_VERSION;
            this.configURL = ``;
            this.ks = Laya.Browser.window.ks;
            let that = this;
            console.log("进入快手");
            this.ks.getSystemInfo({
                response: (result) => {
                    that._systemInfo = JSON.stringify(result);
                    console.log("获取系统信息:" + that._systemInfo);
                },
            });
            this._navigateList = new Array();
            this.ks.getSystemInfo({
                response: (result) => {
                    that._systemInfo = JSON.stringify(result);
                    console.log("获取系统信息:" + that._systemInfo);
                    GameSDK$1.platform = result.platform;
                }
            });
        }
        onConfigLoad() {
            this.mediaRecorder = this.ks.getGameRecorder();
            if (this.mediaRecorder === null) {
                console.log("当前版本 App 不支持录屏");
            }
            this.mediaRecorder.on("start", () => {
                this._tickRecordBegin = Date.now();
                this._isRecordStart = true;
            });
            this.mediaRecorder.on("stop", (res) => {
                if (res && res.videoID) {
                    console.log(`videoID is ${res.videoID}`);
                    console.log(`录屏停止，录制成功`);
                    if (this._tickRecordBegin && Date.now() - this._tickRecordBegin < 3000) {
                        this._recoderData = null;
                    }
                    else {
                        this._recoderData = res.videoID;
                    }
                    this._isRecordStart = false;
                }
                else {
                    console.log(`录屏停止，录制失败`);
                }
            });
            this.mediaRecorder.on("error", (err) => {
                console.log(`发生录屏错误 ${JSON.stringify(err)}`);
            });
        }
        navigateToMiniGame(msg) { }
        shortCutInstalled(onComplete) { }
        createBanner() { }
        showBanner() {
            if (this._bannerNode) {
                this.isShowBanner = true;
                this._bannerNode.show();
            }
        }
        hideBanner() {
            if (this._bannerNode) {
                this._bannerNode.hide();
                this.isShowBanner = false;
            }
        }
        showADVideo(caller, onComplete, reason, args) {
            if (GameSDK$1.platform == 'ios') {
                onComplete.call(caller, true);
                return;
            }
            var self = this;
            if (typeof this.ks.createRewardedVideoAd == "undefined")
                return;
            if (this.isLoading)
                return;
            this.showLoading();
            this.noticeOpenVideo(reason);
            this.onADViewComplete = onComplete;
            console.log("开始播放视频:" + reason);
            if (!this._videoAd) {
                console.log("视频ID === " + this.data.RewardAd);
                this._videoAd = this.ks.createRewardedVideoAd({ adUnitId: this.data.RewardAd });
                let that = this;
                this._videoAd.onClose((result) => {
                    console.log("激励视频关闭回调: " + JSON.stringify(result));
                    if (result && result.isEnded) {
                        console.log("激励视频奖励回调: " + JSON.stringify(result));
                        that.onADViewComplete(true);
                    }
                    else {
                        that.onADViewComplete(false);
                        console.log("激励视频播放失败: " + JSON.stringify(result));
                        self.hideLoading();
                    }
                });
            }
            this._videoAd.show({
                success: () => {
                    console.log("激励视频播放成功");
                    self.hideLoading();
                },
                fail: (result) => {
                    console.log("激励视频播放失败: " + JSON.stringify(result));
                    self.hideLoading();
                },
            });
        }
        pauseVideoRecord() {
            if (this.mediaRecorder === null) {
                console.log("返回 null 时表示当前 APP 版本不支持录屏");
                return;
            }
            this.mediaRecorder.pause();
        }
        resumeVideoRecord() {
            if (this.mediaRecorder === null) {
                console.log("返回 null 时表示当前 APP 版本不支持录屏");
                return;
            }
            this.mediaRecorder.resume();
        }
        stopVideoRecord() {
            if (this.mediaRecorder === null) {
                console.log("返回 null 时表示当前 APP 版本不支持录屏");
                return;
            }
            if (this._isRecordStart) {
                console.log("停止录屏");
                this.mediaRecorder.stop();
            }
            this._isRecordStart = false;
        }
        startVideoRecord(time, callback) {
            if (this.mediaRecorder === null) {
                console.log("返回 null 时表示当前 APP 版本不支持录屏");
                return;
            }
            if (this._isRecordStart) {
                this.stopVideoRecord();
                return;
            }
            this.mediaRecorder.start();
        }
        hasShareRecorder() {
            if (this.mediaRecorder == undefined) {
                return;
            }
            if (this._tickRecordBegin && Date.now() - this._tickRecordBegin < 3000)
                return false;
            return true;
        }
        showLoading() {
            this.isLoading = true;
        }
        hideLoading() {
            this.isLoading = false;
        }
        showToast(message, time) {
            console.log(message, time);
        }
        onShareAppMessage() {
            if (this._recoderData)
                this.shareVideoRecord();
        }
        shareVideoRecord(callback) {
            if (this.ks == null)
                return;
            let self = this;
            if (this._recoderData == null)
                return;
            console.log(`录制ID === ：`, self._recoderData);
            this.mediaRecorder.publishVideo({
                video: self._recoderData,
                callback: (error) => {
                    if (error) {
                        console.log(`发布录屏失败： ${JSON.stringify(error)}`);
                        if (callback)
                            callback(false);
                    }
                    else {
                        console.log("分享录屏成功");
                        self._recoderData = null;
                        if (callback)
                            callback(true);
                    }
                },
            });
        }
        loadSubpackage(pack, zipFileName, topath, comlete, progress) {
            let loadTask = this.ks.loadSubpackage({
                name: pack,
                success: function (info) {
                    console.log("分包加载完成1111");
                    if (comlete) {
                        comlete(true);
                        console.log("分包加载完成1111");
                    }
                },
                fail: function (err) {
                    if (comlete) {
                        comlete(false);
                    }
                    console.info("加载分包 sub1Name 失败", err, pack);
                },
                complete: function () {
                },
            });
            loadTask.onProgressUpdate((res) => {
                console.log("下载进度", res.progress);
                console.log("已经下载的数据长度", res.totalBytesWritten);
                console.log("预期需要下载的数据总长度", res.totalBytesExpectedToWrite);
                if (progress) {
                    progress(res);
                }
            });
        }
        vibrateShort() { }
        vibrateLong() { }
        get addelay() {
            if (!this.data)
                return 0;
            return this.data.BtnTime * 1000;
        }
        checkFollowState(callback) {
            this.ks.checkFollowState({
                accountType: "CPServiceAccount",
                callback: (result) => {
                    `check Follow MiniGame Official Account, result:${JSON.stringify(result)}`;
                    if (result.errorCode == 1 && result.hasFollow) {
                        console.log("关注成功");
                        if (callback) {
                            callback(true);
                        }
                    }
                    else {
                        console.log("关注错误信息 :" + result.errorMsg);
                        if (callback) {
                            callback(false);
                        }
                    }
                },
            });
        }
        openUserProfile(callback) {
            this.ks.openUserProfile({
                accountType: "CPServiceAccount",
                callback: (result) => {
                    `open CP Profile, result: ${JSON.stringify(result)}`;
                    if (result.errorCode == 1) {
                        this.checkFollowState(callback);
                    }
                },
            });
        }
        showADInsert() {
            if (GameSDK$1.platform == 'ios') {
                return;
            }
            let param = {};
            param.adUnitId = this.data.InterstAd;
            let interstitialAd = this.ks.createInterstitialAd(param);
            if (interstitialAd) {
                interstitialAd.onClose((res) => {
                });
                interstitialAd.onError((res) => {
                });
                let p = interstitialAd.show();
                p.then(function (result) {
                    console.log(`show interstitial ad success, result is ${result}`);
                }).catch(function (error) {
                    console.log(`show interstitial ad failed, error is ${error}`);
                    if (error.code === -10005) ;
                });
            }
            else {
                console.log("创建插屏广告组件失败");
            }
        }
    }

    class Times$3 {
        constructor(time) {
            this.time = 0;
            if (time) {
                this.time = time;
            }
            else {
                this.time = Times$3.now;
            }
        }
        static get now() {
            return new Date().getTime();
        }
        static getDate() {
            return new Date().getDate();
        }
        static console(key) {
            this._console[key] = Times$3.now;
        }
        static consoleEnd(key, ...args) {
            console.log("执行耗时 ", key, (Times$3.now - (this._console[key] || Times$3.now)) / 1000, ...args);
        }
        static get Date() {
            return new Date();
        }
        static day(time) {
            return Math.floor(this.hour(time) / 24);
        }
        static hour(time) {
            return Math.floor(this.minute(time) / 60);
        }
        static minute(time) {
            return Math.floor(this.second(time) / 60);
        }
        static second(time) {
            if (time == null || time == undefined)
                time = this.now;
            return Math.floor(time / 1000);
        }
        static numHour(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time) % 60) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            if (this.minute() >= 60) {
                res = this.converMinTen(this.hour(time)) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        static numMinute(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time)) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        static numSecond(time) {
            return this.converMinTen(this.second(time));
        }
        static chinaHour(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "秒";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time) % 60) + "分" + res;
            }
            if (this.minute() >= 60) {
                res = this.converMinTen(this.hour(time)) + "时" + res;
            }
            return res;
        }
        static chinaMinute(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "秒";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time)) + "分" + res;
            }
            return res;
        }
        static chinaSecond(time) {
            return this.converMinTen(this.second(time)) + "秒";
        }
        static converMinTen(num) {
            return num < 10 ? ("0" + num) : num.toString();
        }
        add(time) {
            this.time += time;
            return this;
        }
        sub(time) {
            this.time -= time;
            return this;
        }
        get now() { return this.time; }
        ;
        get day() {
            return Math.floor(this.hour / 24);
        }
        get hour() {
            return Math.floor(this.minute / 60);
        }
        get minute() {
            return Math.floor(this.second / 60);
        }
        ;
        get second() {
            return Math.floor(this.time / 1000);
        }
        get numHour() {
            let res;
            res = this.converMinTen(this.second % 60) + "";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute % 60) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            if (this.minute >= 60) {
                res = this.converMinTen(this.hour) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        get numMinute() {
            let res;
            res = this.converMinTen(this.second % 60) + "";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        get numSecond() {
            return this.converMinTen(this.second);
        }
        get chinaHour() {
            let res;
            res = this.converMinTen(this.second % 60) + "秒";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute % 60) + "分" + res;
            }
            if (this.minute >= 60) {
                res = this.converMinTen(this.hour) + "时" + res;
            }
            return res;
        }
        get chinaMinute() {
            let res;
            res = this.converMinTen(this.second % 60) + "秒";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute) + "分" + res;
            }
            return res;
        }
        get chinaSecond() {
            return this.converMinTen(this.second) + "秒";
        }
        converMinTen(num) {
            return num < 10 ? ("0" + num) : num.toString();
        }
        static isSameDay(t) {
            return new Date(t).toLocaleDateString() === new Date().toLocaleDateString();
        }
        static compare_time(time) {
            var today_end = this.get_endtime();
            var time_old = time;
            if (today_end == time_old) {
                return 1;
            }
            else {
                return 0;
            }
        }
        static get_endtime() {
            var time_end = new Date(new Date(new Date().toLocaleDateString()).getTime() + 24 * 60 * 60 * 1000 - 1);
            var time_format = this.format_date(time_end);
            return time_format;
        }
        static format_date(now) {
            var year = now.getFullYear();
            var month = now.getMonth() + 1;
            var day = now.getDate();
            var hh = now.getHours();
            var mm = now.getMinutes();
            var ss = now.getSeconds();
            var clock = year + "";
            if (month < 10) {
                clock += "0";
            }
            clock += month + "";
            if (day < 10) {
                clock += "0";
            }
            clock += day + "";
            if (hh < 10) {
                clock += "0";
            }
            clock += hh + "";
            if (mm < 10) {
                clock += '0';
            }
            clock += mm;
            if (ss < 10) {
                clock += '0';
            }
            clock += ss;
            return clock;
        }
    }
    Times$3._console = {};

    class Oppo extends BaseSDK {
        constructor() {
            super();
            this._closeCallback = null;
            this.isShowBanner = false;
            this.showVideoTime = 0;
            this.isLoading = false;
            this._version = SDKConfig.OPPO_VERSION;
            this.configURL = ``;
            let self = this;
            this.qg.getLaunchOptionsSync();
            this.qg.hasShortcutInstalled({
                success: function (res) {
                    self.isShortCutInstalled = res;
                },
                fail: function () {
                    self.isShortCutInstalled = false;
                }
            });
            this._navigateList = new Array();
        }
        get qg() {
            if (!this._qg) {
                this._qg = Laya.Browser.window.qg;
            }
            return this._qg;
        }
        onConfigLoad() {
            this.createBanner();
            this.createGamePortalAd();
            this.createGameBannerAd();
        }
        navigateToMiniGame(msg) {
            this.qg && this.qg.navigateToMiniGame({
                pkgName: msg.packageName,
                extraData: msg.data,
                success: function () {
                    console.log("-----------跳转小游戏:" + msg.name + "成功-----------");
                },
                fail: function (res) {
                    console.log("-----------跳转小游戏:" + msg.name + "失败-----------");
                    console.log(JSON.stringify(res));
                }
            });
        }
        shortCutInstalled(onComplete) {
            var self = this;
            this.qg.hasShortcutInstalled({
                success: function (res) {
                    if (res == false) {
                        self.qg.installShortcut({
                            success: function () {
                                onComplete && onComplete(true);
                            },
                            fail: function () {
                                onComplete && onComplete(false);
                            }
                        });
                    }
                    else {
                        self.showToast("桌面图标已创建", 1000);
                    }
                },
                fail: function () {
                    onComplete && onComplete(false);
                }
            });
        }
        createBanner() {
            var self = this;
            var system = this.qg.getSystemInfoSync();
            this._bannerNode = this.qg.createBannerAd({ posId: this.data.BannerAd, adIntervals: 30 });
            this._bannerNode.onResize(function (e) {
                self._bannerNode.style = { top: system.windowHeight - e.height };
            });
            this._bannerNode.onLoad(function () {
                if (!self.isShowBanner)
                    self._bannerNode.hide();
            });
            this._bannerNode.onError(function (err) {
                console.log("Banner error:", err);
            });
        }
        showBanner() {
            if (this._bannerNode) {
                this.isShowBanner = true;
                this._bannerNode.show();
            }
        }
        hideBanner() {
            if (this._bannerNode)
                this._bannerNode.hide();
            this.isShowBanner = false;
        }
        showADVideo(caller, onComplete, reason, args) {
            var self = this;
            if (typeof (this.qg.createRewardedVideoAd) == 'undefined')
                return;
            if (this.isLoading)
                return;
            this.showLoading();
            this.noticeOpenVideo(reason);
            this.onADViewComplete = Handler.create(caller, onComplete, args);
            if (!this._videoNode) {
                this._videoNode = this.qg.createRewardedVideoAd({ posId: this.data.RewardAd });
                this._videoNode.onLoad(() => {
                    if (self.showTime)
                        clearTimeout(self.showTime);
                    self.hideLoading();
                    self.showVidwo(reason);
                    ToolSDK.stopSound();
                });
                this._videoNode.onError((err) => {
                    if (self.showTime)
                        clearTimeout(self.showTime);
                    self.hideLoading();
                    self.showToast("暂无视频", 2000);
                    ToolSDK.replaySound();
                });
            }
            if (this.showTime)
                clearTimeout(this.showTime);
            this._videoNode.load();
            this.showTime = setTimeout(this.hideLoading, 3000);
        }
        showVidwo(reason) {
            var self = this;
            if (this.isShowBanner)
                this._bannerNode.hide();
            this._videoNode.show();
            this.showVideoTime = Times$3.now;
            this._closeCallback && this._videoNode.offClose(this._closeCallback);
            this._closeCallback = function (res) {
                if (self.isShowBanner)
                    self._bannerNode.show();
                self.resumeVideoRecord();
                if (Times$3.now - self.showVideoTime >= 30 * 1000) {
                    if (!res)
                        res = { isEnded: true };
                    else
                        res.isEnded = true;
                }
                if (res && res.isEnded || res === undefined) {
                    self.noticeCloseVideo(reason);
                    self.onADViewComplete.runWith(true);
                }
                else {
                    self.onADViewComplete.runWith(false);
                }
                ToolSDK.replaySound();
            };
            this._videoNode.onClose(this._closeCallback);
        }
        showLoading() {
            this.isLoading = true;
            if (this.qg && this.qg.showLoading) {
                this.qg.showLoading({ title: "请求中，请稍后..." });
            }
        }
        hideLoading() {
            this.isLoading = false;
            if (this.qg && this.qg.hideLoading) {
                this.qg.hideLoading({});
            }
        }
        createNative(navigateId) {
            let nativeNode = this.qg.createNativeAd({
                posId: navigateId
            });
            return nativeNode;
        }
        showToast(message, time) {
            this.qg.showToast({
                title: message,
                icon: "none",
                duration: time
            });
        }
        vibrateShort() {
            this.qg.vibrateShort({
                success: function () {
                    console.log("log----vibrateShort-----");
                },
                fail: function () { },
                complete: function () { },
            });
        }
        vibrateLong() {
            this.qg.vibrateLong({
                success: function () {
                    console.log("log----vibrateLong-----");
                },
                fail: function () { },
                complete: function () { },
            });
        }
        loadSubpackage(pack, zipFileName, topath, comlete, progress) {
            let loadTask = this.qg.loadSubpackage({
                name: pack,
                success: function (info) {
                    if (comlete) {
                        comlete(true);
                    }
                },
                fail: function (err) {
                    if (comlete) {
                        comlete(false);
                    }
                    console.info('加载分包 sub1Name 失败', err, pack);
                },
                complete: function () {
                }
            });
            loadTask.onProgressUpdate(res => {
                console.log('下载进度', res.progress);
                console.log('已经下载的数据长度', res.totalBytesWritten);
                console.log('预期需要下载的数据总长度', res.totalBytesExpectedToWrite);
                if (progress) {
                    progress(res);
                }
            });
        }
        createGameBannerAd() {
            this.gameBannerAd = this.qg.createGameBannerAd({
                adUnitId: this.data.GameBanner
            });
            console.log("<<<<<<<<<<创建横幅互推盒子>>>>>>>>>", this.gameBannerAd);
        }
        showGameBanner() {
            console.log("<<<<<<<<<<展示互推盒子>>>>>>>>>", this.gameBannerAd);
            if (!this.gameBannerAd) {
                this.createGameBannerAd();
            }
            if (this.gameBannerAd) {
                this.gameBannerAd.show();
            }
        }
        hideGameBanner() {
            if (this.gameBannerAd) {
                this.gameBannerAd.hide();
            }
        }
        createGamePortalAd() {
        }
        showGamePortal() {
            if (this.qg.getSystemInfoSync().platformVersionCode >= 1076) {
                var gamePortalAd = this.qg.createGamePortalAd({
                    adUnitId: this.data.GamePortal
                });
            }
            else {
                console.log('快应用平台版本号低于1076，暂不支持互推盒子相关 API');
            }
            gamePortalAd.load().then(function () {
                console.log('load success');
            }).catch(function (error) {
                console.log('load fail with:' + error.errCode + ',' + error.errMsg);
            });
            gamePortalAd.show().then(function () {
                console.log('show success');
            }).catch(function (error) {
                console.log('show fail with:' + error.errCode + ',' + error.errMsg);
            });
            gamePortalAd.onLoad(function () {
                console.log('互推盒子九宫格广告加载成功');
                gamePortalAd.show();
            });
        }
        isSupportShareVideo() {
            return false;
        }
    }

    class Times$2 {
        constructor(time) {
            this.time = 0;
            if (time) {
                this.time = time;
            }
            else {
                this.time = Times$2.now;
            }
        }
        static get now() {
            return new Date().getTime();
        }
        static getDate() {
            return new Date().getDate();
        }
        static console(key) {
            this._console[key] = Times$2.now;
        }
        static consoleEnd(key, ...args) {
            console.log("执行耗时 ", key, (Times$2.now - (this._console[key] || Times$2.now)) / 1000, ...args);
        }
        static get Date() {
            return new Date();
        }
        static day(time) {
            return Math.floor(this.hour(time) / 24);
        }
        static hour(time) {
            return Math.floor(this.minute(time) / 60);
        }
        static minute(time) {
            return Math.floor(this.second(time) / 60);
        }
        static second(time) {
            if (time == null || time == undefined)
                time = this.now;
            return Math.floor(time / 1000);
        }
        static numHour(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time) % 60) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            if (this.minute() >= 60) {
                res = this.converMinTen(this.hour(time)) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        static numMinute(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time)) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        static numSecond(time) {
            return this.converMinTen(this.second(time));
        }
        static chinaHour(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "秒";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time) % 60) + "分" + res;
            }
            if (this.minute() >= 60) {
                res = this.converMinTen(this.hour(time)) + "时" + res;
            }
            return res;
        }
        static chinaMinute(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "秒";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time)) + "分" + res;
            }
            return res;
        }
        static chinaSecond(time) {
            return this.converMinTen(this.second(time)) + "秒";
        }
        static converMinTen(num) {
            return num < 10 ? ("0" + num) : num.toString();
        }
        add(time) {
            this.time += time;
            return this;
        }
        sub(time) {
            this.time -= time;
            return this;
        }
        get now() { return this.time; }
        ;
        get day() {
            return Math.floor(this.hour / 24);
        }
        get hour() {
            return Math.floor(this.minute / 60);
        }
        get minute() {
            return Math.floor(this.second / 60);
        }
        ;
        get second() {
            return Math.floor(this.time / 1000);
        }
        get numHour() {
            let res;
            res = this.converMinTen(this.second % 60) + "";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute % 60) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            if (this.minute >= 60) {
                res = this.converMinTen(this.hour) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        get numMinute() {
            let res;
            res = this.converMinTen(this.second % 60) + "";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        get numSecond() {
            return this.converMinTen(this.second);
        }
        get chinaHour() {
            let res;
            res = this.converMinTen(this.second % 60) + "秒";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute % 60) + "分" + res;
            }
            if (this.minute >= 60) {
                res = this.converMinTen(this.hour) + "时" + res;
            }
            return res;
        }
        get chinaMinute() {
            let res;
            res = this.converMinTen(this.second % 60) + "秒";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute) + "分" + res;
            }
            return res;
        }
        get chinaSecond() {
            return this.converMinTen(this.second) + "秒";
        }
        converMinTen(num) {
            return num < 10 ? ("0" + num) : num.toString();
        }
        static isSameDay(t) {
            return new Date(t).toLocaleDateString() === new Date().toLocaleDateString();
        }
        static compare_time(time) {
            var today_end = this.get_endtime();
            var time_old = time;
            if (today_end == time_old) {
                return 1;
            }
            else {
                return 0;
            }
        }
        static get_endtime() {
            var time_end = new Date(new Date(new Date().toLocaleDateString()).getTime() + 24 * 60 * 60 * 1000 - 1);
            var time_format = this.format_date(time_end);
            return time_format;
        }
        static format_date(now) {
            var year = now.getFullYear();
            var month = now.getMonth() + 1;
            var day = now.getDate();
            var hh = now.getHours();
            var mm = now.getMinutes();
            var ss = now.getSeconds();
            var clock = year + "";
            if (month < 10) {
                clock += "0";
            }
            clock += month + "";
            if (day < 10) {
                clock += "0";
            }
            clock += day + "";
            if (hh < 10) {
                clock += "0";
            }
            clock += hh + "";
            if (mm < 10) {
                clock += '0';
            }
            clock += mm;
            if (ss < 10) {
                clock += '0';
            }
            clock += ss;
            return clock;
        }
    }
    Times$2._console = {};

    class Toutiao extends BaseSDK {
        constructor() {
            super();
            this._bannerWidth = 240;
            this._closeCallback = null;
            this.showADInsertTime = 0;
            this.videoId = "1blh62fqv795ij05l5";
            this.bannerId = "1l6b6hm5fec54gmbc0";
            this.insertId = "110d6e8f93b5gjgb9a";
            this.gameId = "ttb34ac5f72c74400402";
            this.shareId = "afl2f234065787e2jl";
            this.isShowBanner = false;
            this.openAutoFNTime = 0;
            this.isReadyVieoAd = false;
            this.errorAdCount = 0;
            this.isAdVideoShow = false;
            this._isRecordStart = false;
            this._tickRecordBegin = 0;
            this._tickRecordEnd = 0;
            this.isShareVideo = false;
            this.isShowInterstitial = true;
            this.isInsertAdLoaded = false;
            this.isShowADInsert = false;
            this.InterstAdIndex = 0;
            this.checkUpdate();
            this._version = SDKConfig.TOUTIAO_VERSION;
            this.configURL = ``;
        }
        get tt() {
            if (!this._tt) {
                this._tt = Laya.Browser.window.tt;
            }
            return this._tt;
        }
        getStorageSync(key, def) {
            if (!key)
                return;
            var data = def ? def : null;
            try {
                data = window["tt"].getStorageSync(key);
            }
            catch (error) { }
            return data;
        }
        setStorageSync(key, data) {
            try {
                window["tt"].setStorageSync(key, data);
            }
            catch (error) { }
        }
        checkUpdate() {
            try {
                if (window["tt"]) {
                    if ("function" == typeof window["tt"].getUpdateManager) {
                        const updateManager = window["tt"].getUpdateManager();
                        updateManager.onCheckForUpdate(function (t) {
                            console.log(t.hasUpdate);
                        });
                        updateManager.onUpdateReady(() => {
                            window["tt"].showModal({
                                title: "更新提示",
                                content: "有新版本啦！赶快开启新的历程吧~",
                                success: function (res) {
                                    if (res.confirm) {
                                        updateManager.applyUpdate();
                                    }
                                    else {
                                        window["tt"].showToast({
                                            icon: "none",
                                            title: "下一次启动时会使用新版本",
                                        });
                                    }
                                },
                            });
                        });
                        updateManager.onUpdateFailed(function () {
                            console.log("新的版本下载失败");
                        });
                    }
                }
            }
            catch (e) {
                console.log(" error checkUpdate");
            }
            this.startRefeshInsertAd();
        }
        onAppShow(res) {
            console.log("onShow: " + JSON.stringify(res.query));
            console.log("onAppShow");
        }
        onAppHide(res) {
            console.log("onAppHide", res);
            let TAG_COUNT = "HIDE_REWARDAD_COUNT";
            let TAG_TIME = "HIDE_REWARDAD_TIME";
            if (this.isShareVideo || !this.isDouyin || this._isRecordStart)
                return;
            let needCount = Math.random();
            let count = this.data.HIDE_REWARDAD_RATE;
            let rewardAd = this.data.HIDE_REWARDAD_MAX;
            let hideRewardAdCount = this.getStorageSync(TAG_COUNT, 0);
            let nowTime = Times$2.now;
            let hideRewardAdTime = this.getStorageSync(TAG_TIME, nowTime);
            if (!Times$2.isSameDay(hideRewardAdTime)) {
                hideRewardAdCount = 0;
                this.setStorageSync(TAG_COUNT, 0);
                this.setStorageSync(TAG_TIME, nowTime);
            }
            if (GameSDK$1.isOpenCitys() && !GameSDK$1.isCurrentVersion && this._videoAd && needCount < count && hideRewardAdCount < rewardAd) {
                this.showADInsert();
                Laya.MouseManager.enabled = true;
                this._videoAd.show().then(() => {
                    this.setStorageSync(TAG_COUNT, hideRewardAdCount + 1);
                    this.sendEvent("视频H");
                });
            }
        }
        onLoginSuccess(data) {
            this.tt.showShareMenu({
                withShareTicket: true,
            });
            this.tt.onShareAppMessage(() => {
                return {
                    title: ToolSDK.randomItem(SDKConfig.TOUTIAO_SHARECONTENT),
                    templateId: ToolSDK.randomItem(SDKConfig.TOUTIAO_SHARETEMPLATEID),
                };
            });
            this.createBanner();
        }
        isSupportShareVideo() {
            if (this.videoPath == null) {
                return false;
            }
            else {
                return true;
            }
        }
        showBanner() {
            if (this._bannerNode) {
                this.isShowBanner = true;
                this._bannerNode.show();
            }
        }
        hideBanner() {
            if (this._bannerNode) {
                this.isShowBanner = false;
                this._bannerNode.hide();
            }
        }
        createBanner() {
            if (!this.insertId || this.insertId == "")
                return;
            var self = this;
            console.log("***********banner 广告刷新************", this._bannerWidth);
            var system = this.tt.getSystemInfoSync();
            this._bannerNode = this.tt.createBannerAd({
                adUnitId: this.bannerId,
                adIntervals: 30,
                style: {
                    top: system.windowHeight - 110,
                    left: 0,
                    width: system.windowWidth,
                },
            });
            this._bannerNode.onResize(function (e) {
                self._bannerNode.style.left = (system.windowWidth - e.width) / 2;
                self._bannerNode.style.top = system.windowHeight - e.height;
            });
            this._bannerNode.onLoad(function () {
                if (!self.isShowBanner)
                    self._bannerNode.hide();
            });
            this._bannerNode.onError(function (err) {
                console.log("Banner error:", err);
            });
        }
        OpenAutoFN() {
            if (!this.isDouyin)
                return;
            let nowTime = Times$2.now;
            if (nowTime - this.openAutoFNTime <= 10000)
                return;
            let TAG_COUNT = "REWARDAD_COUNT";
            let TAG_TIME = "REWARDAD_TIME";
            let needCount = Math.random();
            let count = this.data.REWARDAD_RATE;
            let rewardAd = this.data.REWARDAD_MAX;
            let rewardAdCount = this.getStorageSync(TAG_COUNT, 0);
            let rewardAdTime = this.getStorageSync(TAG_TIME, nowTime);
            if (!Times$2.isSameDay(rewardAdTime)) {
                rewardAdCount = 0;
                this.setStorageSync(TAG_TIME, nowTime);
                this.setStorageSync(TAG_COUNT, 0);
            }
            if (GameSDK$1.isOpenCitys() && !GameSDK$1.isCurrentVersion && this._videoAd && rewardAdCount <= rewardAd && needCount < count) {
                Laya.MouseManager.enabled = true;
                console.log("OpenAutoFN Log");
                this._videoAd
                    .show()
                    .then(() => {
                    this._videoAd
                        .destroy()
                        .then(() => { })
                        .catch(() => { });
                    this._videoAd.offClose(this._onCloseVideoHandler.bind(this));
                    this._videoAd.offLoad(this._onLoadVideoHandler.bind(this));
                    this._videoAd.offError(this._onErrorVideoHandler.bind(this));
                    this._videoAd = null;
                    Laya.timer.once(8000, this, () => {
                        this.createAdVideo("");
                    });
                    this.setStorageSync(TAG_COUNT, rewardAdCount + 1);
                    this.openAutoFNTime = Times$2.now;
                    this.sendEvent("视频A");
                })
                    .catch(() => { });
            }
        }
        _onErrorVideoHandler(err) {
            let self = this;
            self.isReadyVieoAd = false;
            Laya.MouseManager.enabled = true;
            if (self.isAdVideoShow) {
                self.sendEvent("激励广告错误" + err.errCode);
                self.showTips("暂无视频", 1000);
                if (err.errCode == 1004) ;
                else {
                    Laya.timer.clear(self, self.onPreloadAdHandler);
                    Laya.timer.once(8000, self, self.onPreloadAdHandler);
                }
            }
        }
        _onCloseVideoHandler(res) {
            this.isReadyVieoAd = false;
            Laya.MouseManager.enabled = true;
            this.startRefeshInsertAd();
            this.resumeVideoRecord();
            ToolSDK.replaySound();
            if ((res && res.isEnded) || res === undefined) {
                this.noticeCloseVideo(this.videoAdReason);
                if (this.isAdVideoShow)
                    this.onADViewComplete.runWith(true);
            }
            else {
                if (this.isAdVideoShow) {
                    this.onADViewComplete.runWith(false);
                    this.showTips("需要看完视频才能获得奖励！", 1000);
                }
            }
            this.isAdVideoShow = false;
            Laya.timer.once(3000, this, this.onPreloadAdHandler);
        }
        _onLoadVideoHandler(res) {
            this.errorAdCount = 0;
            this.isReadyVieoAd = true;
            Laya.MouseManager.enabled = true;
            if (this.isAdVideoShow) {
                this.pauseVideoRecord();
                this._videoAd.show().then(() => {
                    this.stopRefeshInsertAd();
                    this.noticeOpenVideo(this.videoAdReason);
                });
                Laya.timer.clear(this, this.onPreloadAdHandler);
            }
        }
        createAdVideo(reason) {
            if (!this._videoAd) {
                this._videoAd = this.tt.createRewardedVideoAd({ adUnitId: this.videoId });
                this.videoAdReason = reason;
                this._videoAd.onLoad(this._onLoadVideoHandler.bind(this));
                this._videoAd.onError(this._onErrorVideoHandler.bind(this));
                this._videoAd.onClose(this._onCloseVideoHandler.bind(this));
            }
        }
        showADVideo(caller, onComplete, reason, args) {
            if (GameSDK$1.isDebug) {
                if (onComplete) {
                    this.onADViewComplete = Handler.create(caller, onComplete, args);
                    this.onADViewComplete.runWith(true);
                }
                return;
            }
            if (typeof this.tt.createRewardedVideoAd == "undefined")
                return;
            Laya.MouseManager.enabled = false;
            this.isAdVideoShow = true;
            this.onADViewComplete = Handler.create(caller, onComplete, args);
            this.createAdVideo(reason);
            if (this.isReadyVieoAd) {
                this._videoAd.show().then(() => {
                    this.noticeOpenVideo(reason);
                });
            }
            else {
                this._videoAd.load();
            }
            if (!Laya.MouseManager.enabled) {
                Laya.timer.once(1500, this, function () {
                    Laya.MouseManager.enabled = true;
                });
            }
        }
        onPreloadAdHandler() {
            if (this._videoAd) {
                this._videoAd.load();
            }
        }
        showModal(pars) {
            this.tt.showModal({
                title: pars.title || "提示",
                content: pars.content || "内容",
                confirmText: pars.confirmText || "确定",
                cancelText: pars.cancelText || "取消",
                showCancel: pars.showCancel || true,
                success(res) {
                    if (res.confirm) {
                        pars && pars.success && pars.success();
                    }
                    if (res.cancel) {
                        pars && pars.fail && pars.fail();
                    }
                },
                fail(res) {
                    pars && pars.fail && pars.fail();
                },
            });
        }
        loadRewardedVideo() {
            console.log("loadRewardedVideo", this.tt);
            if (this.tt) {
                this._videoAd = this.tt.createRewardedVideoAd({ adUnitId: this.videoId });
                this._videoAd.onLoad(() => {
                });
                this._videoAd.onError((err) => {
                });
            }
        }
        pauseVideoRecord() {
            this.tt.getGameRecorderManager().pause();
        }
        resumeVideoRecord() {
            this.tt.getGameRecorderManager().resume();
        }
        stopVideoRecord() {
            console.log("======> stopVideoRecord <======");
            this.startRefeshInsertAd();
            var recorder = this.tt.getGameRecorderManager();
            if (this._isRecordStart) {
                console.log("停止录屏");
                recorder.stop();
            }
            this._isRecordStart = false;
        }
        startVideoRecord(time, callback) {
            this.stopRefeshInsertAd();
            if (this.tt == null)
                return;
            var recorder = this.tt.getGameRecorderManager();
            if (this._isRecordStart) {
                this._isRecordStart = false;
                recorder.stop();
                return;
            }
            recorder.start({
                duration: time || 300,
            });
            recorder.onStart((res) => {
                this._tickRecordBegin = Times$2.now;
                console.log("======> startVideoRecord <====== onStart");
                if (callback)
                    callback("start");
                this._isRecordStart = true;
            });
            recorder.onStop((res) => {
                console.log(res, res.videoPath);
                console.log("======> startVideoRecord <====== onStop");
                this._tickRecordEnd = Times$2.now;
                if (this._tickRecordBegin && this._tickRecordEnd - this._tickRecordBegin < 3000) {
                    this.showToast("录屏时间小于3秒", 2000);
                }
                else {
                    this.videoPath = res.videoPath;
                }
                if (callback)
                    callback("end");
                this._isRecordStart = false;
            });
        }
        startRefeshInsertAd() {
            this.stopRefeshInsertAd();
            Laya.timer.loop(5000, this, this.refeshInsertAd);
        }
        refeshInsertAd() {
            if (!GameSDK$1.isCurrentVersion) {
                var nowTime = Times$2.now;
                if (nowTime - this.showADInsertTime >= 30000) {
                    this.showADInsert();
                }
            }
        }
        stopRefeshInsertAd() {
            Laya.timer.clear(this, this.refeshInsertAd);
        }
        hasShareRecorder() {
            console.log("hasShareRecorder time : " + (this._tickRecordEnd - this._tickRecordBegin));
            if (this._tickRecordBegin && this._tickRecordEnd - this._tickRecordBegin < 3000)
                return false;
            return true;
        }
        showLoading() {
            if (this.tt && this.tt.showLoading) {
                this.tt.showLoading({
                    title: "请求中，请稍后...",
                    success(res) {
                        console.log(`${res}`);
                    },
                    fail(res) {
                        console.log(`showLoading调用失败`);
                    },
                });
            }
        }
        hideLoading() {
            if (this.tt && this.tt.hideLoading) {
                this.tt.hideLoading({
                    success(res) {
                        console.log(`${res}`);
                    },
                    fail(res) {
                        console.log(`showLoading调用失败`);
                    },
                });
            }
        }
        showTips(message, time) {
            this.tt.showToast({
                title: message,
                icon: "none",
                duration: time,
            });
        }
        showToast(message, time) {
            console.log(message, time);
            this.tt.showToast({
                title: message,
                duration: time,
            });
        }
        onShareAppMessage() {
            if (this.videoPath)
                this.shareVideoRecord();
        }
        onConfigLoad() {
            console.warn("SDKBytedance.onRemoteConfigLoad,远程配置初始化", this.data);
            if (this.data.Shareid) {
                SDKConfig.TOUTIAO_SHARETEMPLATEID = this.data.Shareid;
            }
            this.tt.setKeepScreenOn({ keepScreenOn: true });
            this.createAdVideo(null);
            let id = this.gameId;
            this.tt.login({
                force: false,
                success: (i) => {
                    console.log("O_O SDKBytedance.init", i);
                    var data = {
                        gameId: id,
                        code: i.code,
                        anonymousCode: i.anonymousCode,
                    };
                    this.onLoginSuccess(data);
                },
                fail: function (e) { },
            });
            this.tt.onShow(this.onAppShow.bind(this));
            this.tt.onHide(this.onAppHide.bind(this));
        }
        shareVideoRecord(callback) {
            if (this.tt == null)
                return;
            console.log("=====> 开始分享视频 <====== path: " + this.videoPath);
            if (!this.hasShareRecorder()) {
                this.showToast("录屏时间小于3秒", 2000);
                if (callback)
                    callback(false);
                return;
            }
            if (this.videoPath == null) {
                this.showToast("录屏时间小于3秒", 2000);
                if (callback)
                    callback(false);
                return;
            }
            this.isShareVideo = true;
            let self = this;
            let successFunc = function (res) {
                self.isShareVideo = false;
                console.log("分享视频成功", res);
                if (self.getVersion("1.40.0")) ;
                self.copyFileSync();
                if (callback)
                    callback(true);
            };
            let failFunc = function (res) {
                self.isShareVideo = false;
                console.log("分享视频失败:", JSON.stringify(res));
                if (callback)
                    callback(false);
            };
            this.tt.shareAppMessage({
                channel: "video",
                title: ToolSDK.randomItem(SDKConfig.SHARE_CONTENT),
                desc: ToolSDK.randomItem(SDKConfig.SHARE_CONTENT),
                imageUrl: "",
                templateId: ToolSDK.randomItem(SDKConfig.TOUTIAO_SHARETEMPLATEID),
                query: "",
                extra: {
                    videoPath: this.videoPath,
                    videoTopics: [SDKConfig.TOUTIAO_GAME_NAME, "抖音小游戏"],
                    hashtag_list: [SDKConfig.TOUTIAO_GAME_NAME, "抖音小游戏"],
                    video_title: ToolSDK.randomItem(SDKConfig.TOUTIAO_SHARECONTENT),
                    withVideoId: true,
                },
                success: successFunc,
                fail: failFunc,
            });
        }
        copyFileSync() {
            const fileSystemManager = this.tt.getFileSystemManager();
            try {
                let destPath = "ttfile://user/shareVideo.mp4";
                fileSystemManager.copyFileSync(this.videoPath, destPath);
                console.log("====> 拷贝成功 <=======");
                this.videoPath = destPath;
            }
            catch (err) {
                console.log("====> 拷贝失败 <=======", JSON.stringify(err));
            }
        }
        navigateToMiniGame(msg) {
            if (!this.getVersion("1.40.0")) {
                console.log("当前版本不支持");
                return;
            }
            this.tt &&
                this.tt.navigateToVideoView({
                    videoId: msg.videoId,
                    success: function () {
                        console.log("-----------跳转小游戏:" + msg.name + "成功-----------");
                    },
                    fail: function (res) {
                        console.log("-----------跳转小游戏:" + msg.name + "失败-----------");
                        console.log(JSON.stringify(res));
                    },
                });
        }
        vibrateShort() {
            this.tt.vibrateShort({
                success(res) { },
                fail(res) { },
            });
        }
        vibrateLong() {
            this.tt.vibrateLong({
                success(res) { },
                fail(res) { },
            });
        }
        onCloseHandle() {
            this.OpenAutoFN();
            this.showADInsertTime = Times$2.now;
            this.startRefeshInsertAd();
            this.isInsertAdLoaded = false;
            this.isShowADInsert = false;
        }
        onErrorHandle() {
        }
        onLoadHandle() {
            this.isInsertAdLoaded = true;
        }
        showADInsert() {
            if (!this.insertId || this.insertId == "")
                return;
            var self = this;
            if (this.insertAdNode) {
                self.insertAdNode.offClose(this.onCloseHandle.bind(this));
                self.insertAdNode.offLoad(this.onLoadHandle.bind(this));
                self.insertAdNode.offError(this.onErrorHandle.bind(this));
                self.insertAdNode = null;
            }
            if (!this.insertAdNode || this.isInsertAdLoaded) {
                var adids = this.insertId;
                this.InterstAdIndex++;
                if (this.InterstAdIndex >= this.data.InterstAds.length) {
                    this.InterstAdIndex = 0;
                }
                this.insertAdNode = this.tt.createInterstitialAd({
                    adUnitId: adids,
                });
                if (this.insertAdNode) {
                    this.insertAdNode.onClose(this.onCloseHandle.bind(this));
                    this.insertAdNode.onError(this.onErrorHandle.bind(this));
                    this.insertAdNode.onLoad(this.onLoadHandle.bind(this));
                }
            }
            if (this.insertAdNode) {
                this.insertAdNode
                    .show()
                    .then(() => {
                    this.sendEvent("插屏广告显示");
                    this.stopRefeshInsertAd();
                    this.isShowADInsert = true;
                })
                    .catch((e) => {
                });
            }
        }
        getVersion(version) {
            let systemInfo = this.tt.getSystemInfoSync();
            var curVersion = systemInfo.SDKVersion;
            var isDouyin = systemInfo.appName === "Douyin";
            return isDouyin && GameSDK$1.compareVersion(curVersion, version) >= 0;
        }
        get isDouyin() {
            let systemInfo = this.tt.getSystemInfoSync();
            systemInfo.SDKVersion;
            return systemInfo.appName === "Douyin";
        }
        loadSubpackage(packName, zipFileName, topath, callbackSuccess, callbackProgress) {
            if (this.tt) {
                this.tt.loadSubpackage({
                    name: packName,
                    success: (res) => {
                        console.log("字节分包加载成功！", res);
                        if (callbackSuccess)
                            callbackSuccess();
                    },
                    fail: (res) => {
                        console.log("字节分包加载失败！", res);
                        if (callbackProgress)
                            callbackProgress();
                    },
                });
            }
        }
        shortCutInstalled(callback) {
            if (this.tt) {
                console.log("====添加到桌面====");
                this.tt.addShortcut({
                    success: function (res) {
                        callback(true);
                    },
                    fail: function (res) {
                        console.log("" + res.errMsg);
                        callback(false);
                    },
                });
            }
        }
        checkShortcut(callback) {
            if (this.tt) {
                console.log("====检查添加到桌面====");
                this.tt.checkShortcut({
                    success: function (res) {
                        callback(res.status.exist);
                    },
                    fail: function (res) {
                        console.log("res: " + JSON.stringify(res));
                        callback(false);
                    },
                });
            }
            else {
                callback(false);
            }
        }
        getLogicScene(callback) {
            if (this.tt) {
                var options = this.tt.getLaunchOptionsSync();
                callback(options.scene);
                console.log("options: " + options);
                console.log("options: " + JSON.stringify(options));
                console.log("query: " + JSON.stringify(options.query));
                console.log("extra: " + JSON.stringify(options.extra));
            }
            else {
                callback("");
            }
        }
        setClipboardData(data, callback) {
            if (this.tt && this.tt.setClipboardData) {
                this.tt.setClipboardData({
                    data,
                    success(res) {
                        console.log(`setClipboardData调用成功`);
                        callback(true);
                    },
                    fail(res) {
                        console.log(`setClipboardData调用失败`);
                        callback(false);
                    },
                });
            }
            else {
                callback(true);
            }
        }
        getClipboardData(callback) {
            if (this.tt && this.tt.getClipboardData) {
                this.tt.getClipboardData({
                    success(res) {
                        console.log("getClipboardData调用成功：" + `${res.data}`);
                        callback(res.data);
                    },
                    fail(res) {
                        console.log(`getClipboardData调用失败`);
                        callback("");
                    },
                });
            }
            else {
                callback("");
            }
        }
        shareMsg(caller, onComplete, reason, args) {
            this.tt.shareAppMessage({
                title: "疯狂赛冰箱咯!",
                desc: "疯狂赛冰箱咯!",
                imageUrl: "",
                query: "",
                success() {
                    console.warn("分享成功");
                },
                fail(e) {
                    console.warn("分享失败");
                },
            });
        }
    }

    class Vivo extends BaseSDK {
        constructor() {
            super();
            this._closeCallback = null;
            this.isShowBanner = false;
            this.isLoading = false;
            this._version = SDKConfig.VIVO_VERSION;
            this.configURL = ``;
            let self = this;
            this.qg = Laya.Browser.window.qg;
            this.qg.hasShortcutInstalled({
                success: function (res) {
                    self.isShortCutInstalled = res;
                },
                fail: function () {
                    self.isShortCutInstalled = false;
                }
            });
        }
        onConfigLoad() {
            this.createBanner();
        }
        shortCutInstalled(onComplete) {
            var self = this;
            this.qg.hasShortcutInstalled({
                success: function (res) {
                    if (res == false) {
                        self.qg.installShortcut({
                            success: function () {
                                onComplete && onComplete(true);
                            },
                            fail: function () {
                                onComplete && onComplete(false);
                            }
                        });
                    }
                    else {
                        self.showToast("桌面图标已创建", 1000);
                        onComplete && onComplete(true);
                    }
                },
                fail: function () {
                    onComplete && onComplete(false);
                }
            });
        }
        createBanner() {
            var self = this;
            var system = this.qg.getSystemInfoSync();
            this._bannerNode = this.qg.createBannerAd({ posId: "a55ad964cda64321b85934f2a39a49c2", adIntervals: 15, });
            this._bannerNode.onResize(function (e) {
                self._bannerNode.style = { top: system.windowHeight - e.height };
            });
            this._bannerNode.onLoad(function () {
                if (!self.isShowBanner)
                    self._bannerNode.hide();
            });
            this._bannerNode.onError(function (err) {
                console.log("Banner error:", err);
            });
        }
        showBanner() {
            if (this._bannerNode) {
                this.isShowBanner = true;
                this._bannerNode.show();
            }
        }
        hideBanner() {
            if (this._bannerNode)
                this._bannerNode.hide();
            this.isShowBanner = false;
        }
        showADVideo(caller, onComplete, reason, args) {
            var self = this;
            if (typeof (this.qg.createRewardedVideoAd) == 'undefined')
                return;
            if (this.isLoading)
                return;
            this.showLoading();
            this.noticeOpenVideo(reason);
            this.onADViewComplete = Handler.create(caller, onComplete, args);
            if (!this._videoNode) {
                this._videoNode = this.qg.createRewardedVideoAd({ posId: "2b540e3d24f744368049c4a24f77b472" });
                this._videoNode.onLoad(() => {
                    if (self.showTime)
                        clearTimeout(self.showTime);
                    self.hideLoading();
                    self.showVidwo(reason);
                    ToolSDK.stopSound();
                });
                this._videoNode.onError((err) => {
                    if (self.showTime)
                        clearTimeout(self.showTime);
                    self.hideLoading();
                    self.showToast("暂无视频", 2000);
                    ToolSDK.replaySound();
                });
            }
            if (this.showTime)
                clearTimeout(this.showTime);
            this._videoNode.load();
            this.showTime = setTimeout(this.hideLoading, 3000);
        }
        showVidwo(reason) {
            var self = this;
            if (this.isShowBanner)
                this._bannerNode.hide();
            this._videoNode.show();
            this._closeCallback && this._videoNode.offClose(this._closeCallback);
            this._closeCallback = function (res) {
                if (self.isShowBanner)
                    self._bannerNode.show();
                self.resumeVideoRecord();
                if (res && res.isEnded || res === undefined) {
                    self.noticeCloseVideo(reason);
                    self.onADViewComplete.runWith(true);
                }
                else {
                    self.onADViewComplete.runWith(false);
                }
                ToolSDK.replaySound();
            };
            this._videoNode.onClose(this._closeCallback);
        }
        showLoading() {
            this.isLoading = true;
            if (this.qg && this.qg.showLoading) {
                this.qg.showLoading({ title: "请求中，请稍后..." });
            }
        }
        hideLoading() {
            this.isLoading = false;
            if (this.qg && this.qg.hideLoading) {
                this.qg.hideLoading({});
            }
        }
        showToast(message, time) {
            this.qg.showToast({
                title: message,
                icon: "none",
                duration: time
            });
        }
        createNative(navigateId) {
            let nativeNode = this.qg.createNativeAd({
                posId: navigateId
            });
            return nativeNode;
        }
        vibrateShort() {
            this.qg.vibrateShort({
                success: function () {
                    console.log("log----vibrateShort-----");
                },
                fail: function () { },
                complete: function () { },
            });
        }
        vibrateLong() {
            this.qg.vibrateLong({
                success: function () {
                    console.log("log----vibrateLong-----");
                },
                fail: function () { },
                complete: function () { },
            });
        }
        loadSubpackage(pack, zipFileName, topath, comlete, progress) {
            this.qg.getSystemInfoSync();
            let loadTask = this.qg.loadSubpackage({
                name: pack,
                success: function (info) {
                    console.warn("VIVo加载分包成功", pack);
                    if (comlete) {
                        comlete(info);
                    }
                },
                fail: function (info) {
                },
                complete: function () {
                }
            });
            loadTask.onProgressUpdate(res => {
                console.log('下载进度', res.progress);
                console.log('已经下载的数据长度', res.totalBytesWriqgen);
                console.log('预期需要下载的数据总长度', res.totalBytesExpectedToWrite);
                if (progress) {
                    progress(res);
                }
            });
        }
        get addelay() {
            if (!this.data)
                return 0;
            return this.data.BtnTime * 1000;
        }
        isSupportShareVideo() {
            return false;
        }
        showGamePortal() {
            var self = this;
            if (this.qg.createBoxPortalAd) {
                this.boxPortalAd = this.qg.createBoxPortalAd({
                    posId: "1914247627794f289f16e3d32ab2b966"
                });
                this.boxPortalAd.onError(function (err) {
                    console.log("九宫格错误 : ", err);
                    self.showToast("暂无更多游戏", 1000);
                });
                this.boxPortalAd.onClose(function () {
                    console.log('close');
                    if (this.boxPortalAd.isDestroyed) {
                        return;
                    }
                    this.boxPortalAd.show();
                });
                this.boxPortalAd.show().then(function () {
                    console.log('show success九宫格');
                });
            }
            else {
                self.showToast("暂无更多游戏", 1000);
                console.log('暂不支持互推盒子相关 API');
            }
        }
        closeBoxPortalAd() {
            if (this.boxPortalAd != null) {
                this.boxPortalAd.hide().then(function () {
                    console.log('hide success');
                }).catch(function (error) {
                    console.log('hide fail with:' + error.errCode + ',' + error.errMsg);
                });
                this.boxPortalAd.isDestroyed = true;
                this.boxPortalAd.destroy().then(function () {
                    console.log('boxPortalAddestroy success');
                }).catch(function (error) {
                    console.log('boxPortalAddestroy fail with:' + error.errCode + ',' + error.errMsg);
                });
            }
        }
        createGameBannerAd() {
            var self = this;
            if (this.qg.createBoxBannerAd) {
                this.gameBannerAd = this.qg.createBoxBannerAd({
                    posId: "b0b4e03aa0f64e3a8039f843f954705e"
                });
            }
            else {
                self.showToast("暂不支持互推盒子相关", 1000);
                console.log('暂不支持互推盒子相关 API');
            }
            this.showGameBanner();
        }
        showGameBanner() {
            if (!this.gameBannerAd) {
                this.createGameBannerAd();
            }
            this.gameBannerAd.show().then(function () {
                console.log('show success横幅');
            }).catch(function (error) {
                console.log("盒子错误 : ", error);
                console.log('show fail with:' + error.errCode + ',' + error.errMsg);
            });
        }
        hideGameBanner() {
            this.gameBannerAd.hide().then(function () {
                console.log('hide success');
            }).catch(function (error) {
                console.log('hide fail with:' + error.errCode + ',' + error.errMsg);
            });
        }
        closeBoxBanner() {
            if (this.gameBannerAd != null) {
                this.gameBannerAd.destroy();
            }
        }
        showADInsert() {
            console.log("插屏ID === ", this.data.InterstAd);
            let insertAdNode = this.qg.createInterstitialAd({
                posId: "4c86b2c6f0a64d89b6464f7d7a1b90cf"
            });
            insertAdNode.onError(err => {
                console.log("插屏广告加载失败", err);
            });
            insertAdNode.show().then(() => {
                console.log('插屏广告展示完成');
            }).catch((err) => {
                console.log('插屏广告展示失败', JSON.stringify(err));
            });
        }
        showCustomAd(isPatch) {
            this.closeCustomAd();
            this.qg.getSystemInfoSync();
            let customId = "8e83c29f06ba43d6a173afc785b4b200";
            let idList = ["8e83c29f06ba43d6a173afc785b4b200", "93f567694f5c477cbcdd3ff3725667e7"];
            if (isPatch == "big") {
                customId = idList[ToolSDK.random(0, 1)];
                if (this.qg.createCustomAd) {
                    this._customAd = this.qg.createCustomAd({
                        posId: customId,
                        style: {}
                    });
                    this._customAd.onError(err => {
                        console.log("原生模板广告加载失败", err);
                    });
                    this._customAd.show().then(() => {
                        console.log('原生模板广告展示完成');
                    }).catch((err) => {
                        console.log('原生模板广告展示失败', JSON.stringify(err));
                    });
                }
            }
            else {
                customId = idList[ToolSDK.random(0, 1)];
                if (this.qg.createCustomAd) {
                    this._customAd = this.qg.createCustomAd({
                        posId: customId,
                        style: {}
                    });
                    this._customAd.onError(err => {
                        console.log("原生模板广告加载失败", err);
                    });
                    this._customAd.show().then(() => {
                        console.log('原生模板广告展示完成');
                    }).catch((err) => {
                        console.log('原生模板广告展示失败', JSON.stringify(err));
                    });
                }
            }
        }
        closeCustomAd() {
            if (this._customAd) {
                this._customAd.hide();
                this._customAd.destroy();
            }
        }
        setClipboardData(data, callback) {
            if (this.qg && this.qg.setClipboardData) {
                this.qg.setClipboardData({
                    data,
                    success(res) {
                        console.log(`setClipboardData调用成功`);
                        callback(true);
                    },
                    fail(res) {
                        console.log(`setClipboardData调用失败`);
                        callback(false);
                    },
                });
            }
            else {
                callback(true);
            }
        }
        getClipboardData(callback) {
            if (this.qg && this.qg.getClipboardData) {
                this.qg.getClipboardData({
                    success(res) {
                        console.log("getClipboardData调用成功：" + `${res.data}`);
                        callback(res.data);
                    },
                    fail(res) {
                        console.log(`getClipboardData调用失败`);
                        callback("");
                    },
                });
            }
            else {
                callback("");
            }
        }
    }

    const PI$1 = Math.PI;
    const _d2r$1 = PI$1 / 180.0;
    const _r2d$1 = 180.0 / PI$1;
    class Maths$1 {
        static formula2(value, start, length) {
            return (value + (start % length)) % length;
        }
        static formula(value, mul) {
            let res = mul * value;
            while (value--)
                res += value;
            return res;
        }
        static isEven(value) {
            return value % 2 == 0;
        }
        static toRadian(a) {
            return a * _d2r$1;
        }
        static converGold(value) {
            return "";
        }
        static equallyNum(value, count, randMin, randMax, isPositive = false) {
            let equally = Math.floor(value / count);
            if (isPositive)
                randMax = equally - 1;
            let res = [];
            let lastRand = 0;
            let is = true;
            for (let i = 0; i < count; i++) {
                if (is) {
                    is = false;
                    lastRand = this.minToMax(randMin, randMax);
                    res.push(equally + lastRand);
                }
                else {
                    is = true;
                    res.push(equally - lastRand);
                }
            }
            return res;
        }
        static decimal(value) {
            value = value - (Math.floor(value));
            return value;
        }
        static toDegree(a, is_ormalize = true) {
            if (a == undefined)
                return 0;
            if (is_ormalize)
                a = this.normalizeAngle(a);
            return a * _r2d$1;
        }
        static normalizeAngle(angle) {
            angle = angle % (2 * PI$1);
            if (angle < 0) {
                angle += (2 * PI$1);
            }
            return angle;
        }
        static checkRange(value, value2, range) {
            return Math.abs(value - value2) <= range;
        }
        static isTargetRange(value, target, range) {
            if (value >= target - range)
                return true;
            if (value <= target + range)
                return true;
            return false;
        }
        static zeroEqually(space, index, length) {
            return (index - (length - 1) / 2) * space;
        }
        static equally(count = 1, min, max) {
            count++;
            let equally = [];
            let space = ((max - min) / count);
            for (let i = 1; i < count; i++) {
                equally.push(~~(min + space * i));
            }
            return equally;
        }
        static abs_sub_length(value1, value2) {
            return Math.abs(value1 - value2);
        }
        static add_arrs(values) {
            let count = 0;
            for (let value of values)
                count += value;
            return count;
        }
        static lerp(a, b, r) {
            return a + (b - a) * r;
        }
        static clamp01(value) {
            return value < 0 ? 0 : value < 1 ? value : 1;
        }
        static clampf(value, min, max) {
            if (min > max) {
                var temp = min;
                min = max;
                max = temp;
            }
            return value < min ? min : value < max ? value : max;
        }
        static isClampf(value, min, max) {
            if (min > max) {
                var temp = min;
                min = max;
                max = temp;
            }
            if (value <= max && value >= min)
                return true;
            else
                return false;
        }
        static create_arr_num(max) {
            let values = [];
            for (let i = 0; i < max; i++)
                values.push(i);
            return values;
        }
        static isRandom(value) {
            if (!value)
                return false;
            if (value >= 1)
                return true;
            if (value <= 0)
                return false;
            return value > Math.random();
        }
        static zeroToMax(max) {
            if (max <= 1)
                return 0;
            let random = Math.random();
            return ~~((random == 1 ? 0.5 : random) * max);
        }
        static minToMax(min, max, is_int = true) {
            if (min == max)
                return min;
            if (min < 0) {
                if (is_int)
                    return Math.round(Math.random() * (Math.abs(min) + max)) + min;
                else
                    return Math.random() * (Math.abs(min) + max) + min;
            }
            if (is_int)
                return Math.round(Math.random() * (max - min)) + min;
            else
                return Math.random() * (max - min) + min;
        }
        static converNumber(value) {
            if (typeof value == "string")
                return Number(value);
        }
        static find_num_section(arr, num, out, is_contain_num = false) {
            if (!out)
                out = { i: 0, count: 0 };
            out.i = arr.length;
            out.count = 0;
            for (let i = 0; i < arr.length; i++) {
                out.count += arr[i];
                if (is_contain_num) {
                    if (num <= out.count) {
                        out.i = i;
                        return out;
                    }
                }
                else if (num < out.count) {
                    out.i = i;
                    return out;
                }
            }
            return out;
        }
        static find_num_section_random(arr) {
            let all = this.add_arrs(arr);
            let last = 0;
            let rand = this.zeroToMax(all - 1);
            for (let i = 0; i < arr.length; i++) {
                let value = arr[i];
                if (rand >= last && rand < last + value)
                    return i;
                last += value;
            }
            return arr.length;
        }
    }

    new Laya.Vector3();
    const v3_zeor = new Laya.Vector3();
    new Laya.Vector3(1, 1, 1);
    new Laya.Vector3(0, 1, 0);
    new Laya.Vector3(0, 0, 1);
    new Laya.Vector3(0, 180, 0);
    new Laya.Point();
    new Laya.Quaternion();

    const isValid$1 = function (key) {
        if (key == null || key == undefined || key === false)
            return false;
        else
            return true;
    };
    const minxi$1 = function (value) {
        if (value === null || value === undefined || value === 0 || value === "")
            return value;
        let _getPropertyDescriptor = function (obj, name) {
            while (obj) {
                let pd = Object.getOwnPropertyDescriptor(obj, name);
                if (pd) {
                    return pd;
                }
                obj = Object.getPrototypeOf(obj);
            }
            return null;
        };
        let _copyprop = function (name, source, target) {
            let pd = _getPropertyDescriptor(source, name);
            Object.defineProperty(target, name, pd);
        };
        let _mixin = function (obj, ...sourceObj) {
            obj = obj || {};
            for (let i = 1, length = arguments.length; i < length; i++) {
                let source = arguments[i];
                if (source) {
                    if (typeof source !== "object") {
                        continue;
                    }
                    for (let name in source) {
                        _copyprop(name, source, obj);
                    }
                }
            }
            return obj;
        };
        let target = null;
        if (typeof value === "object") {
            target = _mixin(Array.isArray(value) ? [] : {}, value);
        }
        else {
            target = value;
        }
        return target;
    };
    const str_indexOf$1 = function (value, str, start = 0) {
        return value.indexOf(str, start);
    };
    const str_lastIndexOf$1 = function (value, str) {
        let index = str_indexOf$1(value, str);
        if (index == -1) {
            return -1;
        }
        return index + str.length;
    };
    const random = function (min, max) {
        return Math.round(Math.random() * (max - min) + min);
    };
    function WorldToScreen2(camera, point) {
        let p = new Laya.Vector4();
        camera.worldToViewportPoint(point, p);
        var value = new Laya.Vector3(p.x, p.y, p.z);
        return value;
    }
    function isEmpty(val) {
        if (val !== null && val !== undefined && val !== "") {
            return false;
        }
        return true;
    }

    class Sets$1 {
        constructor(isRepeat = true, ...values) {
            this.sets = [];
            this.isRepeat = true;
            this.isRepeat = isRepeat;
            this.add(...values);
        }
        static delete(arr, value) {
            if (arr.length == 0)
                return false;
            let index = arr.indexOf(value);
            if (index == -1)
                return false;
            arr.splice(index, 1);
            return true;
        }
        static map(arr, cb) {
            let set = [];
            for (let i = 0; i < arr.length; i++) {
                let data = cb(arr[i], i, arr);
                set.push(data);
            }
            return set;
        }
        static has(arr, value, stringCompare = false) {
            if (arr.length == 0)
                return false;
            let index;
            if (stringCompare)
                index = this.map(arr, v => v.toString()).indexOf(value.toString());
            else
                index = arr.indexOf(value);
            return index != -1;
        }
        static add(arr, ...values) {
            for (let i = 0; i < values.length; i++) {
                let value = values[i];
                if (this.has(arr, value))
                    continue;
                arr.push(value);
            }
        }
        static random(value, exclude) {
            if (value.length == 0)
                return null;
            if (exclude) {
                let values = [];
                for (let i = 0, l = value.length; i < l; i++)
                    if (!exclude(value[i], i))
                        values.push(values[i]);
                return this.random(values);
            }
            return value[Maths$1.zeroToMax(value.length)];
        }
        static getAt(value, index) {
            index = Maths$1.clampf(index, 0, value.length - 1);
            return value[index];
        }
        static filterValue(values, cb) {
            let idx = this.filterOf(values, cb);
            if (idx == -1) {
                return null;
            }
            return values[idx];
        }
        static filterOf(values, cb) {
            let idx = -1;
            for (let i = 0; i < values.length; i++) {
                if (values[i] && cb(values[i], i)) {
                    return i;
                }
            }
            return idx;
        }
        static filter(values, cb, out) {
            if (!out)
                out = [];
            for (let i = 0; i < values.length; i++) {
                if (values[i] && cb(values[i], i)) {
                    out.push(values[i]);
                }
            }
            return out;
        }
        static push(values, push) {
            for (let value of push)
                values.push(value);
            return values;
        }
        static sort(values, cb) {
            return values.sort(cb);
        }
        static shuffle(arr, isChangeOriginal = true) {
            if (!isChangeOriginal) {
                let tmp = arr.concat();
                tmp.sort((a, b) => {
                    return Math.random() > .5 ? 1 : -1;
                });
                return tmp;
            }
            else {
                arr.sort((a, b) => {
                    return Math.random() > .5 ? 1 : -1;
                });
                return arr;
            }
        }
        static random_arr(vlaues, count = 1) {
            let res = this.shuffle(vlaues, false), arr = [];
            for (let i = 0; i < count; i++)
                if (isValid$1(res[i]))
                    arr.push(res[i]);
            return arr;
        }
        add(...values) {
            for (let i = 0; i < values.length; i++) {
                let value = values[i];
                if (this.has(value) && this.isRepeat)
                    continue;
                this.sets.push(value);
            }
            return this;
        }
        delete(value) {
            return Sets$1.delete(this.sets, value);
        }
        get size() {
            return this.sets.length;
        }
        indexOf(value) {
            return this.sets.indexOf(value);
        }
        has(value, stringCompare = false) {
            return Sets$1.has(this.sets, value, stringCompare);
        }
        hasOf(index) {
            return isValid$1(this.sets[index]);
        }
        clear() {
            this.sets.length = 0;
        }
        shift(isOrign = true) {
            if (isOrign) {
                return this.sets.shift();
            }
            else {
                return this.sets.concat()[0];
            }
        }
        toString() {
            return this.sets.toString();
        }
        forEach(cb) {
            this.sets.forEach(cb);
            return this;
        }
        map(cb) {
            return Sets$1.map(this.sets, cb);
        }
        findContinueIndexs(cb) {
            let values = this.map(cb);
            let indexs = [];
            for (let i = 0; i < values.length; i++) {
                let continueIndexs = [];
                for (let j = 0; j < values.length - i; j++) {
                    let cur = values[i + j];
                    let last = values[i] + j;
                    if (cur == last)
                        continueIndexs.push(values.indexOf(cur));
                    else
                        break;
                }
                if (continueIndexs.length > 1)
                    indexs.push(continueIndexs);
            }
            let res = [];
            for (let i = 0; i < indexs.length; i++) {
                let self = indexs[i];
                let id = this._findContinueIndexs(res, self);
                if (id == -1)
                    res.push(self);
                else if (res[id].length < self.length)
                    res[id] = self;
            }
            return res;
        }
        _findContinueIndexs(maxs, min) {
            for (let i = 0; i < maxs.length; i++) {
                for (let j = 0; j < maxs[i].length; j++) {
                    if (min.indexOf(maxs[i][j]) != -1) {
                        return i;
                    }
                }
            }
            return -1;
        }
        findEquallyIndexs() {
            let indexs = new Sets$1();
            for (let i = 0; i < this.sets.length; i++) {
                let self = this.sets[i];
                let equally = [];
                for (let j = 0; j < this.sets.length; j++) {
                    let all = this.sets[j];
                    if (self == all) {
                        equally.push(j);
                    }
                }
                if (equally.length > 1) {
                    if (!indexs.has(equally, true)) {
                        indexs.add(equally);
                    }
                }
            }
            return indexs;
        }
        sort(cb) {
            Sets$1.sort(this.sets, cb);
            return this;
        }
        deleteFilterOf(cb) {
            let idx = this.filterOf(cb);
            if (idx == -1) {
                return false;
            }
            this.splice(idx);
            return true;
        }
        filterOf(cb) {
            return Sets$1.filterOf(this.sets, cb);
        }
        filterValue(cb) {
            return Sets$1.filterValue(this.sets, cb);
        }
        filter(cb) {
            let tmp = new Sets$1(this.isRepeat);
            for (let i = 0; i < this.sets.length; i++) {
                let data = this.sets[i];
                if (cb(data, i, this.sets)) {
                    tmp.add(data);
                }
            }
            return tmp;
        }
        deletePops(count = 1, cb) {
            for (let i = 0; i < count; i++) {
                let pop = this.pop();
                pop && cb && cb(pop);
            }
        }
        splice(start, deleteCount = 1) {
            return this.sets.splice(start, deleteCount);
        }
        unShift() {
        }
        pop(remove = true) {
            return Sets$1.pop(this.sets, remove);
        }
        static pop(values, remove = true) {
            if (remove) {
                return values.pop();
            }
            else {
                return values[values.length - 1] || null;
            }
        }
        lastValueOf(index) {
            return this.sets[this.sets.length - index - 1] || null;
        }
        valuesOf(index) {
            return this.sets[index] || null;
        }
        randomOf() {
            if (this.size == 0)
                return null;
            return this.sets[Maths$1.zeroToMax(this.sets.length)];
        }
        addRandomSelf() {
            if (this.size == 0)
                return false;
            let data = this.sets[Maths$1.zeroToMax(this.sets.length)];
            this.add(data);
            return true;
        }
        shuffle(isChangeOriginal = true) {
            return Sets$1.shuffle(this.sets, isChangeOriginal);
        }
        deep() {
            let deep = JSON.parse(JSON.stringify(this.sets));
            return new Sets$1(this.isRepeat, ...deep);
        }
        concat(...value) {
            return new Sets$1(this.isRepeat, ...this.sets.concat(value));
        }
    }

    let value$1 = null;
    let valueType$1 = null;
    let index$1 = 0;
    class LocalCache$1 {
        static get setCatchKeyPrefix() {
            return this._setCatchKeyPrefix;
        }
        static converKey(key) {
            if (key.indexOf(this.setCatchKeyPrefix) == -1)
                return this.setCatchKeyPrefix + key;
            return key;
        }
        static set(key, value, isDelay = true) {
            key = this.converKey(key);
            if (!this.checkCacheValue(value))
                return;
            this.cache[key] = value;
            Sets$1.add(this.updateCache, key);
            if (isDelay)
                Laya.timer.once(this.delayCache, this, this.onSet, null, true);
            else
                this.onSet();
        }
        static get(key, defaultValue = null) {
            key = this.converKey(key);
            value$1 = this.cache[key];
            if (!this.checkCacheValue(value$1)) {
                value$1 = Laya.LocalStorage.getItem(key);
                if (!this.checkCacheValue(value$1)) {
                    value$1 = minxi$1(defaultValue);
                    this.cache[key] = value$1;
                    this.set(key, this.cache[key], false);
                }
                else {
                    index$1 = value$1.indexOf("-");
                    valueType$1 = value$1.substring(0, index$1);
                    value$1 = value$1.substring(index$1 + 1);
                    switch (valueType$1) {
                        case "boolean":
                            this.cache[key] = value$1 == "true";
                            break;
                        case "number":
                            this.cache[key] = Number(value$1);
                            break;
                        case "object":
                            this.cache[key] = JSON.parse(value$1);
                            break;
                        case "string":
                            this.cache[key] = value$1;
                            break;
                        default:
                            value$1 = minxi$1(defaultValue);
                            this.cache[key] = value$1;
                            break;
                    }
                }
            }
            return this.cache[key];
        }
        static checkCacheValue(value) {
            if (value == null || value == "null" || value == undefined)
                return false;
            return true;
        }
        static onSet() {
            for (let key of this.updateCache) {
                value$1 = this.cache[key];
                valueType$1 = typeof value$1;
                switch (valueType$1) {
                    case "boolean":
                        value$1 = value$1 + "";
                        break;
                    case "number":
                        value$1 = value$1 + "";
                        break;
                    case "object":
                        value$1 = JSON.stringify(value$1);
                        break;
                    case "string":
                        break;
                    default:
                        value$1 = null;
                        break;
                }
                if (value$1 != null)
                    Laya.LocalStorage.setItem(key, valueType$1 + "-" + value$1);
            }
            this.updateCache.length = 0;
        }
        static has(key) {
            key = this.converKey(key);
            return !!this.get(key);
        }
        static delete(key) {
            key = this.converKey(key);
            delete this.cache[key];
            Laya.LocalStorage.removeItem(key);
        }
        ;
        static clear() {
            this.cache = {};
            Laya.LocalStorage.clear();
        }
    }
    LocalCache$1.cache = {};
    LocalCache$1.updateCache = [];
    LocalCache$1._setCatchKeyPrefix = "";
    LocalCache$1.delayCache = 200;

    class Web extends BaseSDK {
        constructor() {
            super();
            this._version = "1.0.0";
            this.configURL = ``;
            LocalCache$1._setCatchKeyPrefix = SDKConfig.GAMEID + "-";
        }
        initConfig(cb) {
            this.onConfigLoad();
            if (cb)
                cb();
            Laya.Browser.window.h5api.canPlayAd(callback);
            Laya.Browser.window.h5api.showRecommend();
        }
        showADVideo(caller, onComplete, reason, args) {
            Laya.Browser.window.h5api.playAd((data) => {
                if (data.code === 10000) ;
                else if (data.code === 10001) {
                    Laya.timer.once(1000, this, () => {
                        onComplete.call(caller, true);
                    });
                }
                else ;
            });
            GameSDK$1.TestFun();
        }
    }
    function callback(data) {
        console.log("是否可播放广告", data.canPlayAd, "剩余次数", data.remain);
    }

    const EventName = {
        WECHAT_HIDE: "WECHAT_HIDE",
        WECHAT_CLOSE: "WECHAT_CLOSE",
        WECHAT_TOUCH_BANNER_AD: "WECHAT_TOUCH_BANNER_AD",
        WECHAT_HOME: "WECHAT_HOME",
        WECHAT_TOUSU: "WECHAT_TOUSU",
        WECHAT_JUMP_GAME: "WECHAT_JUMP_GAME",
        WECHAT_SHARE: "WECHAT_SHARE",
        WECHAT_SHARE_SNS: "WECHAT_SHARE_SNS",
        WECHAT_ABOUT: "WECHAT_ABOUT",
        WECHAT_CONFIG: "WECHAT_CONFIG",
        WECHAT_COLLECT: "WECHAT_COLLECT",
    };
    class WeChat extends BaseSDK {
        constructor() {
            super();
            this._closeCallback = null;
            this.videoId = "adunit-6e428e74c14eb1f9";
            this.bannerId = "adunit-b3ff83944de3dd57";
            this.insertId = "adunit-1b7b57063945cf54";
            this.gameId = "wxff6356c364b0e69c";
            this.shareId = "";
            this.defaultServerConfig = {
                is_AddDesk: { state: "1" },
                is_AvdFloat: { state: "1" },
                is_AvdList: { state: "1" },
                is_GameNative: { state: "0", interval: 0 },
                is_MoreGameBtn: { state: "1" },
                is_PropSceneUI: { state: "1", interval: 0 },
                is_banner: { state: "1", interval: 0 },
                ad_all_interval: 0,
            };
            this.isShowBanner = false;
            this._todayVideoKey = "LocalCache._todayVideoKey";
            this._lastVideoKey = "LocalCache._lastVideoKey";
            this.errorAdCount = 0;
            this.RewardedVideoAdIndex = 0;
            this.isAutoPlayVidoeAd = false;
            this.clickTime = 0;
            this.isLoading = false;
            this.shareTime = 0;
            this.isShare = false;
            this._customLog = true;
            this._customAdArr = [];
            this._customAdShow = [];
            this._customAdState = [];
            this._version = SDKConfig.WECHAT_VERSION;
            this.configURL = ``;
            this.wx = Laya.Browser.window.wx;
            let self = this;
            this.wx.onShow((res) => {
                ToolSDK.replaySound();
                self.initConfig(null);
                console.log("展示：", res);
                let newTime = Date.now();
                if (self.isShare) {
                    this.sendEvent({ share: this.reason, status: 1 });
                    if (self.shareTime > 0 && newTime - self.shareTime >= 3000) {
                        self.onShareComplete && self.onShareComplete.runWith(true);
                    }
                    else {
                        self.onShareComplete && self.onShareComplete.runWith(false);
                    }
                }
                self.isShare = false;
                let str = JSON.stringify(res);
                try {
                    if (this.data.Channel0 && this.data.Channel0 != "") {
                        if (str.indexOf(this.data.Channel0) != -1) {
                            this.playerFlag = PlayerFlag.CHANNEL0;
                            console.log("标配为渠道0");
                        }
                    }
                }
                catch (error) { }
            });
            this.wx.onShareAppMessage(() => {
                let info = ToolSDK.randomItem(SDKConfig.WECHAT_SHARETEMPLATEID);
                let uid;
                return {
                    title: info.title,
                    imageUrl: info.iconPath,
                    query: uid == undefined ? "" : `invite_uid=${uid}`
                };
            });
            let systemInfo = wx.getSystemInfoSync();
            this.wx.onHide((res) => {
                ToolSDK.stopSound();
                console.log("隐藏：", res);
                SDKEventMgr.Int.emit(EventName.WECHAT_HIDE, res);
                if (!res || !res.mode) {
                    return;
                }
                if ("close" === res.mode) {
                    return SDKEventMgr.Int.emit(EventName.WECHAT_CLOSE, res);
                }
                let _path = res.targetPagePath;
                if (!_path) {
                    if ("android" === systemInfo.platform && "hide" === res.mode && 10 === res.targetAction) {
                        SDKEventMgr.Int.emit(EventName.WECHAT_TOUSU, res);
                        this.playerFlag = PlayerFlag.NO_AD;
                    }
                    return;
                }
                if (8 === res.targetAction) {
                    let pathArr = _path.split(".");
                    switch (pathArr.pop()) {
                        case "SelectConversationUI":
                        case "MMUINavigationController":
                            SDKEventMgr.Int.emit(EventName.WECHAT_SHARE, res);
                            break;
                        case "SnsAdNativeLandingPagesPreviewUI":
                            res.adType = "app";
                            SDKEventMgr.Int.emit(EventName.WECHAT_TOUCH_BANNER_AD, res);
                            break;
                        case "SnsUploadUI":
                            SDKEventMgr.Int.emit(EventName.WECHAT_SHARE_SNS, res);
                            break;
                        case "AppBrandProfileUI":
                        case "NewWAProfileViewController":
                            SDKEventMgr.Int.emit(EventName.WECHAT_ABOUT, res);
                            this.playerFlag = PlayerFlag.NO_AD;
                            break;
                        case "AppBrandAuthorizeUI":
                        case "WAAppAuthorizationViewController":
                            SDKEventMgr.Int.emit(EventName.WECHAT_CONFIG, res);
                            this.playerFlag = PlayerFlag.NO_AD;
                            break;
                        case "AppBrandProcessProxyUI":
                            SDKEventMgr.Int.emit(EventName.WECHAT_COLLECT, res);
                            break;
                    }
                }
                else if (9 === res.targetAction || 10 === res.targetAction) {
                    if (-1 !== _path.indexOf("weixinadinfo") && -1 !== _path.indexOf("gdt_vid")) {
                        if (9 === res.targetAction) {
                            res.appId = _path.substring(0, 18);
                        }
                        res.adType = 10 === res.targetAction ? "h5" : "program";
                        return SDKEventMgr.Int.emit(EventName.WECHAT_TOUCH_BANNER_AD, res);
                    }
                    if (9 === res.targetAction) {
                        let appid = _path.substring(0, 18);
                        res.appId = appid;
                        SDKEventMgr.Int.emit(EventName.WECHAT_JUMP_GAME, res);
                    }
                    else if (10 === res.targetAction) {
                        if (-1 !== _path.indexOf("wapreportwxadevlog")) {
                            SDKEventMgr.Int.emit(EventName.WECHAT_TOUSU, res);
                            this.playerFlag = PlayerFlag.NO_AD;
                        }
                    }
                }
            });
            this.wx.showShareMenu({
                withShareTicket: true,
                menus: ['shareAppMessage', 'shareTimeline']
            });
            Laya.stage.on(Laya.Event.MOUSE_DOWN, this, this.onMouseHandler);
            Laya.stage.on(Laya.Event.MOUSE_MOVE, this, this.onMouseHandler);
        }
        login() {
            return new Promise((resolve, reject) => {
                this.wx.login({
                    success: (res) => {
                        let option = this.wx.getLaunchOptionsSync();
                        let data = { code: res.code };
                        data.clue_token = (!!option && !!option.query && !!option.query.clue_token) ? option.query.clue_token : null;
                        data.invite_uid = (!!option && !!option.query && option.query.invite_uid != undefined) ? option.query.invite_uid : null;
                        console.warn("邀请人信息==>", data.invite_uid);
                        resolve(data);
                    },
                    fail: function (e) {
                        console.error("wx login fail=>", e);
                        reject(e);
                    },
                });
            });
        }
        onConfigLoad() {
            if (this.data.shareList && this.data.shareList.length > 0) {
                SDKConfig.WECHAT_SHARETEMPLATEID = this.data.shareList;
            }
            if (this._bannerNode) {
                this._bannerNode.destroy();
                this._bannerNode = null;
            }
            if (this._insertAdNode) {
                this._insertAdNode.destroy();
                this._insertAdNode = null;
            }
            this.createBanner();
            try {
                var obj = this.wx.getLaunchOptionsSync();
                let str = JSON.stringify(obj);
                if (this.data.Channel0 && this.data.Channel0 != "") {
                    if (str.indexOf(this.data.Channel0) != -1) {
                        this.playerFlag = PlayerFlag.CHANNEL0;
                        console.log("标配为渠道0");
                    }
                }
            }
            catch (error) { }
            this.startRefeshInsertAd();
            return;
        }
        getLaunchOptionsSync() {
            return this.wx.getLaunchOptionsSync();
        }
        onLoginSuccess(data) {
        }
        createBanner() {
            return new Promise((resolve, reject) => {
                var self = this;
                var system = this.wx.getSystemInfoSync();
                this._bannerNode = this.wx.createBannerAd({
                    adUnitId: !!this.data.BannerAd ? this.data.BannerAd : this.bannerId,
                    adIntervals: 30,
                    style: {
                        top: system.windowHeight - 100,
                        left: 0,
                        width: system.windowWidth,
                        height: 100,
                    },
                });
                this._bannerNode.onResize(function (e) {
                    self._bannerNode.style.top = system.screenHeight - e.height;
                });
                this._bannerNode.onLoad(function () {
                    if (!self.isShowBanner)
                        self._bannerNode.hide();
                    resolve();
                });
                this._bannerNode.onError(function (err) {
                    self._bannerNode.destroy();
                    self._bannerNode = null;
                    console.log("Banner error:", err);
                    reject();
                });
            });
        }
        showBanner() {
            if (this._bannerNode) {
                this.isShowBanner = true;
                this._bannerNode.show();
            }
        }
        resetBanner() {
            if (!!this._bannerNode) {
                this._bannerNode.destroy();
                this._bannerNode = null;
            }
            this.createBanner().then(() => {
                if (this.isShowBanner) {
                    this.showBanner();
                }
                else {
                    this.hideBanner();
                }
            });
        }
        hideBanner() {
            if (this._bannerNode)
                this._bannerNode.hide();
            this.isShowBanner = false;
        }
        showADInsert() {
            if (!this._insertAdNode) {
                this._insertAdNode = this.wx.createInterstitialAd({
                    adUnitId: this.data.InterstAd,
                });
                let self = this;
                this._insertAdNode.onLoad(() => {
                    self.showADInsert();
                });
                this._insertAdNode.onError(() => {
                    self._insertAdNode = null;
                });
            }
            else {
                this._insertAdNode.show();
            }
        }
        _checkTodayVideoCount() {
            if (this._lastVideoTime == undefined) {
                this._lastVideoTime = LocalCache$1.get(this._lastVideoKey, "");
            }
            if (!!!this._todayVideoCount == undefined) {
                this._todayVideoCount = LocalCache$1.get(this._todayVideoKey, 0);
            }
            this._resetLastVideoTime();
            if (this._todayVideoCount < (this.data.TodayVideoMax || 10)) {
                return true;
            }
            return false;
        }
        _resetLastVideoTime() {
            let time = new Date().toLocaleDateString();
            if (this._lastVideoTime != time) {
                this._todayVideoCount = 0;
                LocalCache$1.set(this._todayVideoKey, this._todayVideoCount);
            }
            this._lastVideoTime = time;
            LocalCache$1.set(this._lastVideoKey, this._lastVideoTime);
        }
        _addTodayVideoCount() {
            this._resetLastVideoTime();
            this._todayVideoCount++;
            LocalCache$1.set(this._todayVideoKey, this._todayVideoCount);
        }
        showADVideo(caller, onComplete, reason, args) {
            var self = this;
            this.onADViewComplete = Handler.create(caller, onComplete, args);
            if (!this._checkTodayVideoCount()) {
                this.onADViewComplete.runWith(false);
                self.showToast("播放过于频繁，建议明日进行尝试", 1500);
                return;
            }
            if (typeof (this.wx.createRewardedVideoAd) == 'undefined') {
                this.onADViewComplete.runWith(false);
                return;
            }
            if (this.data.RewardedVideoAd == "") {
                self.showToast("暂无视频", 1000);
                this.onADViewComplete.runWith(false);
                return;
            }
            Laya.MouseManager.enabled = false;
            this.noticeOpenVideo(reason);
            this.isAutoPlayVidoeAd = true;
            this._videoReason = reason;
            if (!this._videoAd) {
                console.log("创建视频");
                let adlist = this.data.RewardedVideoAd.split(",");
                this._videoAd = this.wx.createRewardedVideoAd({ adUnitId: adlist[self.RewardedVideoAdIndex % 2], multiton: true });
                this._videoAd.onLoad(() => {
                    self.errorAdCount = 0;
                    Laya.MouseManager.enabled = true;
                    self.pauseVideoRecord();
                    if (self.isAutoPlayVidoeAd) {
                        self._videoAd.show().then(() => {
                            self._addTodayVideoCount();
                            self.noticeOpenVideo(this._videoReason);
                        }).catch(() => {
                            self._videoAd.load();
                        });
                    }
                });
                this._videoAd.onError((err) => {
                    Laya.MouseManager.enabled = true;
                    self.sendEvent("激励广告错误" + err.errCode);
                    self.showToast("暂无视频", 1000);
                    if (err.errCode == 1004) {
                        self.showADInsert();
                    }
                    self.onADViewComplete.runWith(false);
                });
                this._videoAd.onClose((res) => {
                    self.RewardedVideoAdIndex++;
                    Laya.MouseManager.enabled = true;
                    self.isAutoPlayVidoeAd = false;
                    self.resumeVideoRecord();
                    ToolSDK.replaySound();
                    if ((res && res.isEnded) || (res === undefined)) {
                        self.noticeCloseVideo(this._videoReason);
                        self.onADViewComplete.runWith(true);
                    }
                    else {
                        self.onADViewComplete.runWith(false);
                        self.showToast("需要看完视频才能获得奖励！", 1000);
                    }
                    if (GameSDK$1.isOpenCitys() && !GameSDK$1.isCurrentVersion && self.data.DOPEN == 1) {
                        setTimeout(function () {
                            self._videoAd.destroy();
                            self._videoAd = null;
                            console.log('插屏广告 销毁');
                        }, 480);
                    }
                });
            }
            else {
                Laya.MouseManager.enabled = true;
                this._videoAd.show().then(() => {
                    self._addTodayVideoCount();
                    self.noticeOpenVideo(this._videoReason);
                }).catch(() => {
                    self._videoAd.load();
                });
            }
            if (!Laya.MouseManager.enabled) {
                Laya.timer.once(2000, this, function () {
                    Laya.MouseManager.enabled = true;
                });
            }
        }
        onMouseHandler() {
            this.clickTime = Date.now();
        }
        stopRefeshInsertAd() {
            Laya.timer.clear(this, this.refeshInsertAd);
        }
        startRefeshInsertAd() {
            this.stopRefeshInsertAd();
            Laya.timer.loop(1000, this, this.refeshInsertAd);
        }
        refeshInsertAd() {
            if (!GameSDK$1.isCurrentVersion) {
                let nowTime = Date.now();
                if (!!!this.clickTime) {
                    this.clickTime = nowTime - 1000;
                    return;
                }
                if (nowTime - this.clickTime >= 20000) {
                    this.clickTime = nowTime;
                    this.showADInsert();
                }
            }
        }
        showLoading() {
            this.isLoading = true;
            if (this.wx && this.wx.showLoading) ;
        }
        hideLoading() {
            this.isLoading = false;
            if (this.wx && this.wx.hideLoading) ;
        }
        createNative(navigateId) {
            return null;
        }
        showToast(message, time = 2000) {
            console.log(message, time);
            this.wx.showToast({
                title: message,
                icon: "none",
                duration: time
            });
        }
        navigateToMiniGame(msg) {
            this.wx &&
                this.wx.navigateToMiniProgram({
                    appId: msg.appId,
                    path: "",
                    success: function () {
                        console.log("-----------跳转小游戏:" + msg.name + "成功-----------");
                    },
                    fail: function (res) {
                        console.log("-----------跳转小游戏:" + msg.name + "失败-----------");
                        console.log(JSON.stringify(res));
                    },
                });
        }
        vibrateShort(type) {
            this.wx &&
                this.wx.vibrateShort({
                    type: type,
                });
            console.log("短振动");
        }
        vibrateLong() {
            this.wx && this.wx.vibrateLong();
            console.log("长振动");
        }
        loadSubpackage(packName, zipFileName, topath, callbackSuccess, callbackProgress) {
            let self = this;
            console.log("O_O 微信下载分包 开始");
            let wx = Laya.Browser.window.wx;
            var fileManager = wx.getFileSystemManager();
            try {
                fileManager.accessSync(zipFileName);
                this.unZip(zipFileName, topath, callbackSuccess);
            }
            catch (e) {
                const loadTask = wx.loadSubpackage({
                    name: packName,
                    success: function (res) {
                        self.unZip(zipFileName, topath, callbackSuccess);
                    },
                    fail: function (res) { },
                    complete: function () {
                        console.log("加载精度");
                    },
                });
                if (loadTask) {
                    loadTask.onProgressUpdate((res) => {
                        console.log("下载进度", res.progress);
                        console.log("已经下载的数据长度", res.totalBytesWritten);
                        console.log("预期需要下载的数据总长度", res.totalBytesExpectedToWrite);
                        if (callbackProgress) {
                            callbackProgress(res.progress);
                        }
                    });
                }
            }
        }
        unZip(zipFileName, path = "", callbackSuccess = undefined, callbackFailed = undefined) {
            let wx = Laya.Browser.window.wx;
            if (wx) {
                var fileManager = wx.getFileSystemManager();
                var targetPath = Laya.Browser.window.wx.env.USER_DATA_PATH;
                if (path != undefined && path.length > 0) {
                    targetPath += "/" + path;
                }
                fileManager.unzip({
                    zipFilePath: zipFileName,
                    targetPath: targetPath,
                    success: function (res) {
                        console.log("解压成功:" + zipFileName);
                        Laya.URL.basePath = wx["env"].USER_DATA_PATH + "/res/";
                        if (callbackSuccess) {
                            callbackSuccess();
                        }
                    },
                    fail: function (res) {
                        console.log("解压失败:" + zipFileName);
                        if (callbackFailed) {
                            callbackFailed();
                        }
                    },
                });
            }
            else {
                return callbackSuccess();
            }
        }
        shareMsg(caller, onComplete, reason, args) {
            this.onShareComplete = Handler.create(caller, onComplete, args);
            this.shareTime = Date.now();
            this.reason = reason;
            this.sendEvent({ share: reason, status: 0 });
            this.isShare = true;
            console.warn("分享时间：", this.shareTime);
            let info = ToolSDK.randomItem(SDKConfig.WECHAT_SHARETEMPLATEID);
            console.warn("分享info", info);
            this.wx.shareAppMessage({
                title: info.title,
                imageUrl: info.iconPath,
                query: "" 
            });
        }
        isShortScreen() {
            let info = wx.getSystemInfoSync();
            let rate = info.windowHeight / info.windowWidth;
            return rate <= 1.8;
        }
        get _customCfg() {
            return this.data.customCfg;
        }
        showCustomAd(type, top) {
            return new Promise((resolve, reject) => {
                let self = this;
                top = this._checkCustomLimit(type, top);
                this._customAdShow[type] = true;
                let curAd = this._customAdArr[type];
                if (!!!curAd) {
                    this.createCustomAd(type, top).then(s => {
                        resolve(s);
                    });
                }
                else {
                    if (!!this._customAdState[type]) {
                        resolve(false);
                        return;
                    }
                    if (this._customLog) {
                        console.log("ready show custom", type);
                    }
                    curAd.show().then(() => {
                        let show = self._customAdShow[type];
                        if (this._customLog) {
                            console.log("show custom " + type + " success:", show);
                        }
                        if (!show) {
                            self.hideCustomAd(type);
                            resolve(false);
                        }
                        else {
                            resolve(true);
                        }
                    });
                }
            });
        }
        createCustomAd(type, top) {
            return new Promise((resolve, reject) => {
                let self = this;
                let systemInfo = wx.getSystemInfoSync();
                if (!!this._customAdArr[type]) {
                    this._destroyCustomAd(type);
                }
                if (!!this._customAdState[type]) {
                    resolve(false);
                    return;
                }
                this._customAdState[type] = 1;
                top = this._checkCustomLimit(type, top);
                let base = top;
                top = (top / 1334) * systemInfo.screenHeight;
                let curAd = this.wx.createCustomAd({
                    adUnitId: this._customCfg[type].id,
                    style: {
                        left: this._customCfg[type].side == 0 ? this._customCfg[type].left : (this._customCfg[type].side == 1 ? (systemInfo.screenWidth + this._customCfg[type].left) >> 1 : systemInfo.screenWidth + this._customCfg[type].left),
                        top: top,
                        width: 750,
                        fixed: true
                    }
                });
                curAd.onLoad(() => {
                    let show = self._customAdShow[type];
                    if (this._customLog) {
                        console.log("create custom " + type + " success:", show);
                    }
                    self._customAdState[type] = 0;
                    if (!show) {
                        self.hideCustomAd(type);
                        resolve(false);
                    }
                    else {
                        self.showCustomAd(type, base).then(s => {
                            resolve(s);
                        });
                    }
                });
                curAd.onError((e) => {
                    resolve(false);
                    console.error("custom " + type + " create fail", e);
                    let show = self._customAdShow[type];
                    self._destroyCustomAd(type);
                    self._customAdShow[type] = show;
                    Laya.timer.once(10000, self, self.createBanner, [type, base]);
                });
                curAd.onClose(() => {
                    self.hideCustomAd(type);
                });
                this._customAdArr[type] = curAd;
            });
        }
        _checkCustomLimit(type, top) {
            let destroy = false;
            top = (top == undefined || top == null) ? this._customCfg[type].top : top;
            if (type == CustomType.Bottom_Roll) {
                top = this.data.bannertop || top;
            }
            destroy = this._customCfg[type].top != top;
            this._customCfg[type].top = top;
            if (destroy) {
                this._destroyCustomAd(type);
            }
            return top;
        }
        _destroyCustomAd(type) {
            let curAd = this._customAdArr[type];
            if (!!curAd) {
                curAd.offLoad();
                curAd.offError();
                curAd.offClose();
                curAd.destroy();
            }
            this._customAdShow[type] = false;
            this._customAdArr[type] = null;
            this._customAdState[type] = 0;
        }
        hideCustomAd(type) {
            if (type == undefined) {
                for (let i = CustomType.Left_Grid; i <= CustomType.Main_Rect; ++i) {
                    this.hideCustomAd(i);
                }
            }
            else {
                this._customAdShow[type] = false;
                if (!!this._customAdState[type]) {
                    return;
                }
                let curAd = this._customAdArr[type];
                if (!!curAd) {
                    let self = this;
                    if (this._customLog) {
                        console.log("ready hide custom", type);
                    }
                    curAd.hide().then(() => {
                        let show = self._customAdShow[type];
                        if (this._customLog) {
                            console.log("hide custom " + type + " success:", show);
                        }
                        if (show) {
                            self.showCustomAd(type);
                        }
                    });
                }
            }
        }
    }

    class ViewBase extends fgui.GComponent {
        constructor() {
            super(...arguments);
            this.ServerConfigKey = "";
        }
        static find_parent_component_once_node(node, comp) {
            if (!(node instanceof fairygui.GComponent))
                return null;
            let parent = node.parent;
            while (parent) {
                if (parent instanceof comp) {
                    break;
                }
                parent = parent.parent;
            }
            return parent;
        }
        constructFromXML() {
            super.constructFromXML(undefined);
            this.displayObject.onAwake = this._onAwake.bind(this);
            this.displayObject.onDestroy = this._onDestroy.bind(this);
            if (this.onClickByView)
                this.onClick(this, this.onClickByView);
            if (this.onCreate)
                this.onCreate();
        }
        _onAwake() {
            if (this.ServerConfigKey && !ViewBase.find_parent_component_once_node(this, ViewBase)) {
                if (!GameSDK$1.isConfigUIModel(this.ServerConfigKey))
                    this.visible = false;
            }
            if (this.onLoaded)
                this.onLoaded();
        }
        _onDestroy() {
            Laya.timer.clearAll(this);
            if (this.onDestroyed)
                this.onDestroyed();
        }
        random(min, max) {
            return Math.round(Math.random() * (max - min) + min);
        }
        randomItem(array) {
            if (array && array.length > 0) {
                return array[this.random(0, array.length - 1)];
            }
            else {
                return null;
            }
        }
    }

    class AvdCell extends ViewBase {
        onCreate() {
            this._icon = this.getChildByPath("img").asLoader;
            this._nameLab = this.getChildByPath("name").asTextField;
        }
        onClickByView() {
            if (this._data) {
                GameSDK$1.navigateToMiniGame(this._data);
            }
        }
        updataData(data) {
            if (this._data == data) {
                return;
            }
            this._data = data;
            if (data) {
                let bgs = [];
                for (var i = 1; i <= 6; ++i) {
                    let bg = this.getChild("bg" + i);
                    if (bg)
                        bgs.push(bg.asImage);
                }
                let index = this.random(0, bgs.length - 1);
                bgs.map((a, i) => {
                    a.visible = i == index;
                });
                this._icon.url = this.randomItem(data.iconPath);
                this._nameLab.text = data.name;
            }
        }
    }

    class AvdFloat extends ViewBase {
        constructor() {
            super(...arguments);
            this.ServerConfigKey = "is_AvdFloat";
        }
        onCreate() {
            this._icon = this.getChildByPath("icon.img").asLoader;
            this._nameLab = this.getChildByPath("name").asTextField;
            let timeOut = 3;
            if (this.data) {
                parseFloat(this.data.toString());
            }
            this._Listata = GameSDK$1.getNavigateList();
            if (this._Listata.length <= 0)
                return;
            Laya.timer.clear(this, this._freamtimeHandler);
            Laya.timer.loop(timeOut * 1000, this, this._freamtimeHandler);
            this._freamtimeHandler();
        }
        onClickByView(evet) {
            evet._stoped = true;
            if (this._data) {
                GameSDK$1.navigateToMiniGame(this._data);
            }
        }
        _freamtimeHandler() {
            let index = Math.floor(Math.random() * this._Listata.length);
            let info = this._Listata[index];
            this._icon.url = this.randomItem(info.iconPath);
            this._nameLab.text = info.name;
            this._data = info;
        }
    }

    class AvdList extends ViewBase {
        constructor() {
            super(...arguments);
            this.ServerConfigKey = "is_AvdList";
            this._data = [];
        }
        onCreate() {
            this._list = this.getChildByPath("leftBoxList").asList;
            this._list.itemRenderer = Laya.Handler.create(this, this.updataCellHandler, null, false);
            this.changeAll();
            Laya.timer.loop(3 * 1000, this, this.changeAll);
        }
        changeAll() {
            this._data = [];
            let list = GameSDK.getNavigateList();
            let _index = this.random(0, list.length - 5);
            if (_index < 0)
                return;
            for (var i = _index; i < _index + 4; ++i) {
                if (list[i])
                    this._data.push(list[i]);
            }
            this._list.numItems = this._data.length;
            var children = this._list._children;
            var index = Math.floor(Math.random() * children.length);
            let tmp = children[index];
            this.aniro(tmp, 10, () => {
                this.aniro(tmp, -10, () => {
                    this.aniro(tmp, 10, () => {
                        this.aniro(tmp, -10, () => {
                            this.aniro(tmp, 0, () => {
                            });
                        });
                    });
                });
            });
        }
        aniro(node, angle, callback) {
            Laya.Tween.to(node, { rotation: angle }, 300, null, Laya.Handler.create(this, () => {
                callback();
            }, null, false));
        }
        updataCellHandler(index, view) {
            view.updataData(this._data[index]);
        }
    }

    class MoreGameBtn extends ViewBase {
        onCreate() {
            if (GameSDK.type == PlatType.TOUTIAO) {
                let systemInfo = window["tt"].getSystemInfoSync();
                var isDouyin = systemInfo.appName === "Douyin";
                this.visible = isDouyin && !GameSDK.isCurrentVersion && MoreGameBtn.IntervalDisplayAD.has();
            }
        }
        onClickByView() {
            if (GameSDK.type == PlatType.OPPO) {
                GameSDK.showGamePortal();
            }
            else if (GameSDK.type == PlatType.WECHAT) {
                SDKViewMgr.popUpView(PropType.SmallItem);
            }
            else {
                SDKViewMgr.moreView();
            }
        }
    }
    MoreGameBtn.ServerConfigKey = "is_MoreGameBtn";
    MoreGameBtn.IntervalDisplayAD = new IntervalDisplayAD(MoreGameBtn.ServerConfigKey);

    class PropSceneUI extends ViewBase {
        constructor() {
            super(...arguments);
            this.ServerConfigKey = PropSceneUI.ServerConfigKey;
            this.navigatedata = [];
            this.pasue_end_time = 0;
            this.index = 0;
            this._dirction = 1;
            this.maxPosY = 10;
            this.posY = 0;
            this._list_speed = 3;
            this.level = Number.MAX_SAFE_INTEGER;
            this.bclick = false;
        }
        moveDownHandler(evet) {
            this.pasue_end_time = Date.now() + 300;
            Laya.stage.once(Laya.Event.MOUSE_UP, this, this.moveUpHandler);
        }
        moveUpHandler(evet) {
            Laya.stage.off(Laya.Event.MOUSE_UP, this, this.moveUpHandler);
            this.posY = this._list.scrollPane.posY;
        }
        randomOpenView() {
            if (GameSDK$1.isOffCitys()) {
                console.log("城市屏蔽");
                return;
            }
            if (GameSDK$1.isCurrentVersion) {
                console.log("版本屏蔽");
                return;
            }
            var children = this._list._children;
            var index = Math.floor(Math.random() * children.length);
            children[index].onClickByView();
        }
        enterframe() {
            if (Date.now() < this.pasue_end_time)
                return;
            this.posY = this._list.scrollPane.posY;
            this.posY += this._list_speed;
            if (this.posY >= this.maxPosY) {
                this.posY = this.maxPosY;
                this._list_speed *= -1;
            }
            else if (this.posY <= 0) {
                this.posY = 0;
                this._list_speed *= -1;
            }
            this._list.scrollPane.setPosY(this.posY);
        }
        onCreate() {
            SDKEventMgr.Int.on(EventName.WECHAT_TOUCH_BANNER_AD, this.touch_banner_close, this);
            this.on(Laya.Event.MOUSE_DOWN, this, this.moveDownHandler);
            this.getChild("btn_continue").onClick(this, this.click_continue);
            this.navigatedata = GameSDK$1.getNavigateList();
            this._list = this.getChild("list").asList;
            this._list.itemRenderer = Laya.Handler.create(this, this.updataCellHandler, null, false);
            this._list.numItems = this.navigatedata.length;
            Laya.timer.frameLoop(1, this, this.enterframe);
            Laya.timer.frameOnce(1, this, () => {
                this.maxPosY = this._list.scrollPane["_overlapSize"].y;
            });
            this.randomOpenView();
        }
        touch_banner_close() {
            PropSceneUI.lastbannertime = Date.now();
            SDKEventMgr.Int.off(EventName.WECHAT_TOUCH_BANNER_AD, this.touch_banner_close, this);
            GameSDK$1.updateErrorCount(ErrorCountType.BANNER);
            if (this._completeHandler) {
                this._completeHandler();
                this._completeHandler = null;
            }
            console.log("PropSceneUI----销毁");
            this.dispose();
        }
        onDestroyed() {
            console.log("-------------onDestroyed");
            SDKEventMgr.Int.off(EventName.WECHAT_TOUCH_BANNER_AD, this.touch_banner_close, this);
        }
        updataCellHandler(index, view) {
            view.updataData(this.navigatedata[index]);
        }
        setCallback(level, callBack) {
            this.level = level;
            this._completeHandler = callBack;
        }
        click_continue() {
            if (!this.bclick && Date.now() - PropSceneUI.lastbannertime > 10000 && GameSDK$1.canClick({ level: this.level }, ClickType.WaterFall)) {
                this.getChild("btn_continue").offClick(this, this.click_continue);
                this.bclick = true;
                console.log("banner");
                Laya.timer.once(800, this, () => {
                    Laya.timer.once(1800, this, () => {
                        this.getChild("btn_continue").onClick(this, this.click_continue);
                    });
                });
            }
            else {
                if (this._completeHandler) {
                    this._completeHandler();
                    this._completeHandler = null;
                }
                SDKEventMgr.Int.off(EventName.WECHAT_TOUCH_BANNER_AD, this.touch_banner_close.bind(this), this);
                this.dispose();
            }
        }
    }
    PropSceneUI.ServerConfigKey = "is_PropSceneUI";
    PropSceneUI.IntervalDisplayAD = new IntervalDisplayAD(PropSceneUI.ServerConfigKey);
    PropSceneUI.lastbannertime = 0;

    class NativeBanner extends ViewBase {
        constructor() {
            super(...arguments);
            this._info = { NativeType: 0 };
        }
        onCreate() {
            this._iconLoader = this.getChildByPath("icon").asLoader;
            this.getChild("n3").asCom.onClick(this, this.clickViewHandler);
            if (this.data) {
                try {
                    this._info = JSON.parse(this.data.toString());
                }
                catch (error) {
                    this._info = { NativeType: 0 };
                }
            }
            if (!this._info)
                this._info = { NativeType: 0 };
            this.createNative();
        }
        showView() {
            if (!GameSDK$1.isShowTime()) {
                Laya.timer.callLater(this, this.removeView);
            }
            else {
                if (this._nativeNode)
                    this._nativeNode.load();
            }
        }
        clickNativeBannerView() {
            this.removeView();
            this.reportAdClick();
        }
        clickViewHandler(evet) {
            evet._stoped = true;
            this.removeView();
        }
        createNative() {
            let self = this;
            let data = GameSDK$1.data;
            let nativeId = data.NativeAd;
            this._nativeNode = GameSDK$1.createNative(nativeId);
            if (!this._nativeNode)
                return;
            this._nativeNode.onError(function (e) {
                console.log("=========>oppo 原生广告加载失败", e);
                self.displayObject.event("LoadFailNativeBanner");
            });
            this._nativeNode.onLoad(function (res) {
                console.log("=========>oppo 原生广告加载成功", res);
                if (res && res.adList) {
                    let nativeInfo = res.adList[res.adList.length - 1];
                    console.log("原生广告数据：", nativeInfo);
                    self.initNatveView(nativeInfo);
                    self.displayObject.event("LoadSuccessNativeBanner");
                }
            });
        }
        initNatveView(nativeInfo) {
            if (nativeInfo.imgUrlList && nativeInfo.imgUrlList.length > 0) {
                this._iconLoader.url = nativeInfo.imgUrlList[0];
            }
            else if (nativeInfo.iconUrlList && nativeInfo.iconUrlList.length > 0) {
                this._iconLoader.url = nativeInfo.iconUrlList[0];
            }
            else {
                this.removeView();
                return;
            }
            this._useNtAdId = nativeInfo.adId;
            this.reportAdShow();
        }
        reportAdClick() {
            if (this._useNtAdId != null && this._nativeNode)
                this._nativeNode.reportAdClick({ adId: this._useNtAdId.toString() });
        }
        reportAdShow() {
            if (this._useNtAdId != null && this._nativeNode)
                this._nativeNode.reportAdShow({ adId: this._useNtAdId.toString() });
        }
        removeView() {
            this.displayObject.event("CloseNativeBanner");
        }
    }

    class AddDesk extends ViewBase {
        constructor() {
            super(...arguments);
            this.ServerConfigKey = "is_AddDesk";
        }
        onCreate() {
            if (GameSDK$1.isShortCutInstalled) {
                this.visible = false;
            }
        }
        onClickByView() {
            GameSDK$1.shortCutInstalled((is_succes) => {
                console.log("添加到桌面:", is_succes);
            });
        }
    }

    class GameNative extends ViewBase {
        constructor() {
            super(...arguments);
            this.ServerConfigKey = GameNative.ServerConfigKey;
        }
        onCreate() {
            this._showNative = this.getChild("n0");
        }
        showNativeView(avdBtn, continueBtn, compete, loadSucces, loadFail, plevel) {
            this._showNativeBtn = avdBtn;
            this._continueBtn = continueBtn;
            this._showNativeBtn.onClick(this, this.onShowNativeBannerHandler);
            if (this._continueBtn)
                this._continueBtn.onClick(this, this.onContinueHandler);
            this._cometeHandler = compete;
            this._loadFail = loadFail;
            this._loadSucces = loadSucces;
            this._showNative.displayObject.on("CloseNativeBanner", this, this.onCloseHandler);
            this._showNative.displayObject.on("LoadFailNativeBanner", this, this.onLoadFailHandler);
            this._showNative.displayObject.on("LoadSuccessNativeBanner", this, this.onLoadSuccessHandler);
            this._level = plevel;
            this._showNative.showView();
        }
        onShowNativeBannerHandler() {
            this._showNative.clickNativeBannerView();
        }
        onContinueHandler() {
            if (GameSDK$1.canClick({ "level": this._level }, ClickType.NativeAd)) {
                this._showNative.clickNativeBannerView();
            }
            else {
                this.onCloseHandler();
            }
        }
        onCloseHandler() {
            this._showNative.displayObject.off("LoadFailNativeBanner", this, this.onLoadFailHandler);
            this._showNative.displayObject.off("CloseNativeBanner", this, this.onCloseHandler);
            this._showNative.displayObject.off("LoadSuccessNativeBanner", this, this.onCloseHandler);
            if (this._cometeHandler) {
                this._cometeHandler();
            }
        }
        onLoadFailHandler() {
            console.log("原生广告成功回调===> 失败 : ", this._loadFail);
            this._showNative.displayObject.off("LoadFailNativeBanner", this, this.onLoadFailHandler);
            this._showNative.displayObject.off("CloseNativeBanner", this, this.onCloseHandler);
            this._showNative.displayObject.off("LoadSuccessNativeBanner", this, this.onCloseHandler);
            if (this._loadFail) {
                this._loadFail();
            }
        }
        onLoadSuccessHandler() {
            console.log("原生广告成功回调：", this._loadSucces);
            this._showNative.displayObject.off("LoadFailNativeBanner", this, this.onLoadFailHandler);
            this._showNative.displayObject.off("LoadSuccessNativeBanner", this, this.onCloseHandler);
            if (this._loadSucces) {
                this._loadSucces();
            }
        }
    }
    GameNative.ServerConfigKey = "is_GameNative";
    GameNative.IntervalDisplayAD = new IntervalDisplayAD(GameNative.ServerConfigKey);

    class ButtonEffect extends Laya.Script {
        onAwake() {
            this.node = fgui.GObject.cast(this.owner);
        }
        onEnable() {
            if (this._tween)
                this._tween.clear();
            if (GameSDK$1.isShow) {
                Laya.timer.once(1300, this, () => {
                    this.showBtnMaxEffect();
                });
            }
        }
        showBtnMaxEffect() {
            if (this._tween)
                this._tween.clear();
            this._tween = Laya.Tween.to(this.node, { scaleX: 1.2, scaleY: 1.1 }, 600, null, Laya.Handler.create(this, () => {
                this._tween.clear();
                this.showBtnMinEffect();
            }));
        }
        showBtnMinEffect() {
            if (this._tween)
                this._tween.clear();
            this._tween = Laya.Tween.to(this.node, { scaleX: 1, scaleY: 1 }, 600, null, Laya.Handler.create(this, () => {
                this._tween.clear();
                this.showBtnMaxEffect();
            }));
        }
        onDestroy() {
            if (this._tween)
                this._tween.clear();
        }
    }

    class CfgParser {
        static loadJson4Laya(path, func) {
            Laya.loader.load(path, Laya.Handler.create(this, this.onCfgJson4Laya, [path, func]), null, Laya.Loader.JSON);
        }
        static onCfgJson4Laya(path, func) {
            if (func) {
                func(Laya.loader.getRes(path));
            }
        }
        static parseTypeValue(typeOrigin, data, itemData, field) {
            let typeOriginSplit = typeOrigin.split(":");
            let type = typeOriginSplit[0];
            let typeSub = "";
            if (typeOriginSplit.length > 1) {
                typeSub = typeOriginSplit[1];
            }
            let value = null;
            if (typeSub == "A") {
                value = [];
                let dataArr = data.toString().split(";");
                switch (type) {
                    case 'B':
                        for (let subData of dataArr) {
                            if (typeof (subData) == "number") {
                                value = subData == 1;
                            }
                            else {
                                value = (subData.toLowerCase() == "true");
                            }
                        }
                        break;
                    case 'I':
                        for (let subData of dataArr) {
                            value.push(Number(subData));
                        }
                        break;
                    case 'S':
                        for (let subData of dataArr) {
                            value.push(subData);
                        }
                        break;
                    case 'J':
                        for (let subData of dataArr) {
                            value.push(JSON.parse(subData));
                        }
                        break;
                    default:
                        if (data === "")
                            return null;
                        for (let subData of dataArr) {
                            let queueItem = {
                                __item__: value,
                                __field__: field,
                                __type__: type,
                                __data__: subData,
                                __type_sub__: typeSub,
                            };
                            this.relationQueue.push(queueItem);
                        }
                        break;
                }
            }
            else {
                switch (type) {
                    case 'B':
                        if (typeof (data) == "number") {
                            value = data == 1;
                        }
                        else {
                            value = (data.toLowerCase() == "true");
                        }
                        break;
                    case 'I':
                        value = Number(data);
                        break;
                    case 'S':
                        value = data;
                        break;
                    case 'T':
                        value = JSON.parse(data);
                        break;
                    default:
                        if (data === "")
                            return null;
                        value = {
                            __item__: itemData,
                            __field__: field,
                            __type__: type,
                            __data__: data,
                        };
                        this.relationQueue.push(value);
                        break;
                }
            }
            if (itemData && field)
                itemData[field] = value;
            return value;
        }
        static parseRelation(dataMap) {
            for (let item of this.relationQueue) {
                if (item.__item__ && item.__data__ != "") {
                    if (item.__type_sub__ == "A") {
                        item.__item__.push(dataMap[item.__type__][item.__data__]);
                    }
                    else {
                        item.__item__[item.__field__] = dataMap[item.__type__][item.__data__];
                    }
                }
            }
            this.relationQueue.length = 0;
        }
        static putItemInData(item, data, rules, fields) {
            switch (rules) {
                case 'm':
                    var key = item[fields[0]];
                    if (data[key]) {
                        console.log("putItemInData[m] Error: duplicate key", key);
                    }
                    data[key] = item;
                    return;
                case 'mm':
                    var key1 = item[fields[0]];
                    var key2 = item[fields[1]];
                    var data1 = data[key1];
                    if (data1 == null) {
                        data1 = {};
                        data[key1] = data1;
                    }
                    if (data1[key2]) {
                        console.log("putItemInData[mm] Error: duplicate key", key1, key2);
                    }
                    data1[key2] = item;
                    return;
                case 'kv':
                    var key = item[fields[0]];
                    var type = item[fields[1]];
                    var value = item[fields[2]];
                    data[key] = this.parseTypeValue(type, value);
                    return;
                default:
                    console.error("putItemInData: not found rule", rules);
                    return;
            }
        }
        static parseJsonData(jsonData, rules) {
            var types = jsonData.types;
            var fields = jsonData.fields;
            var values = jsonData.values;
            var data = {};
            for (var j = 0; j < values.length; j++) {
                var value = values[j];
                var itemData = {};
                for (var i = 0; i < types.length; i++) {
                    var type = types[i];
                    var field = fields[i];
                    var item = value[i];
                    this.parseTypeValue(type, item, itemData, field);
                }
                this.putItemInData(itemData, data, rules, fields);
            }
            return data;
        }
        static parseJsonString(jsonStr, rules) {
            return this.parseJsonData(JSON.parse(jsonStr), rules);
        }
    }
    CfgParser.relationQueue = [];

    class GameData {
        static init(onComplete, pathPre) {
            this.onComplete = onComplete;
            if (!pathPre)
                pathPre = "";
            CfgParser.loadJson4Laya(pathPre + "res/game_data.json", this.onJsonLoad.bind(this));
        }
        static onJsonLoad(json) {
            this.dataRaw = json;
            for (let dbName in this.dataRaw) {
                let jsonData = this.dataRaw[dbName];
                this.dataMap[dbName] = CfgParser.parseJsonData(jsonData, jsonData.rule);
            }
            CfgParser.parseRelation(this.dataMap);
            if (this.onComplete)
                this.onComplete();
        }
        static getPriceItem(key1) { return this.dataMap['Price'][key1]; }
        static getPrice() { return this.dataMap['Price']; }
        static getlevelItem(key1) { return this.dataMap['level'][key1]; }
        static getlevel() { return this.dataMap['level']; }
        static getIconItem(key1) { return this.dataMap['Icon'][key1]; }
        static getIcon() { return this.dataMap['Icon']; }
        static getConfigDataItem(key1) { return this.dataMap['ConfigData'][key1]; }
        static getConfigData() { return this.dataMap['ConfigData']; }
        static getBaoXiangItem(key1) { return this.dataMap['BaoXiang'][key1]; }
        static getBaoXiang() { return this.dataMap['BaoXiang']; }
        static getTalkItem(key1) { return this.dataMap['Talk'][key1]; }
        static getTalk() { return this.dataMap['Talk']; }
        static getlevelupItem(key1) { return this.dataMap['levelup'][key1]; }
        static getlevelup() { return this.dataMap['levelup']; }
        static getPlayerNumItem(key1) { return this.dataMap['PlayerNum'][key1]; }
        static getPlayerNum() { return this.dataMap['PlayerNum']; }
        static getPlayerSpeedItem(key1) { return this.dataMap['PlayerSpeed'][key1]; }
        static getPlayerSpeed() { return this.dataMap['PlayerSpeed']; }
        static getWaiterNumItem(key1) { return this.dataMap['WaiterNum'][key1]; }
        static getWaiterNum() { return this.dataMap['WaiterNum']; }
        static getWaiterSpeedItem(key1) { return this.dataMap['WaiterSpeed'][key1]; }
        static getWaiterSpeed() { return this.dataMap['WaiterSpeed']; }
        static getCookNumItem(key1) { return this.dataMap['CookNum'][key1]; }
        static getCookNum() { return this.dataMap['CookNum']; }
        static getCookSpeedItem(key1) { return this.dataMap['CookSpeed'][key1]; }
        static getCookSpeed() { return this.dataMap['CookSpeed']; }
        static getFishNumItem(key1) { return this.dataMap['FishNum'][key1]; }
        static getFishNum() { return this.dataMap['FishNum']; }
        static getFishSpeedItem(key1) { return this.dataMap['FishSpeed'][key1]; }
        static getFishSpeed() { return this.dataMap['FishSpeed']; }
        static getAbilityLevelItem(key1) { return this.dataMap['AbilityLevel'][key1]; }
        static getAbilityLevel() { return this.dataMap['AbilityLevel']; }
        static getGuideTipItem(key1) { return this.dataMap['GuideTip'][key1]; }
        static getGuideTip() { return this.dataMap['GuideTip']; }
        static getGoodsItem(key1) { return this.dataMap['Goods'][key1]; }
        static getGoods() { return this.dataMap['Goods']; }
        static getEffectItem(key1) { return this.dataMap['Effect'][key1]; }
        static getEffect() { return this.dataMap['Effect']; }
        static getsceneItem(key1) { return this.dataMap['scene'][key1]; }
        static getscene() { return this.dataMap['scene']; }
        static getLvUpItem(key1) { return this.dataMap['LvUp'][key1]; }
        static getLvUp() { return this.dataMap['LvUp']; }
        static getSkinItem(key1) { return this.dataMap['Skin'][key1]; }
        static getSkin() { return this.dataMap['Skin']; }
        static getSignItem(key1) { return this.dataMap['Sign'][key1]; }
        static getSign() { return this.dataMap['Sign']; }
        static getBreakpropItem(key1) { return this.dataMap['Breakprop'][key1]; }
        static getBreakprop() { return this.dataMap['Breakprop']; }
        static getUnlockItem(key1) { return this.dataMap['Unlock'][key1]; }
        static getUnlock() { return this.dataMap['Unlock']; }
        static getSolutionItem(key1) { return this.dataMap['Solution'][key1]; }
        static getSolution() { return this.dataMap['Solution']; }
        static getTurntableConfigItem(key1) { return this.dataMap['TurntableConfig'][key1]; }
        static getTurntableConfig() { return this.dataMap['TurntableConfig']; }
        static getPropItem(key1) { return this.dataMap['Prop'][key1]; }
        static getProp() { return this.dataMap['Prop']; }
        static getSoundItem(key1) { return this.dataMap['Sound'][key1]; }
        static getSound() { return this.dataMap['Sound']; }
        static getCustomerCountItem(key1) { return this.dataMap['CustomerCount'][key1]; }
        static getCustomerCount() { return this.dataMap['CustomerCount']; }
        static getColorItem(key1) { return this.dataMap['Color'][key1]; }
        static getColor() { return this.dataMap['Color']; }
    }
    GameData.dataRaw = {};
    GameData.dataMap = {};
    GameData.onComplete = null;

    var EventType$1;
    (function (EventType) {
        EventType["START_GAME"] = "START_GAME";
        EventType["GAME_OVER"] = "GAME_OVER";
        EventType["PROP_CHANGE"] = "PROP_CHANGE";
        EventType["UPDATE_SKIN"] = "UPDATE_SKIN";
        EventType["PLAYER_MOVE"] = "PLAYER_MOVE";
        EventType["INIT_BTN_POS"] = "INIT_BTN_POS";
        EventType["INIT_ANSWER"] = "INIT_ANSWER";
        EventType["SHOW_ANSWER"] = "SHOW_ANSWER";
        EventType["INIT_PASSLEVEL"] = "INIT_PASSLEVEL";
        EventType["NO_BIG"] = "NO_BIG";
        EventType["NO_BIGER"] = "NO_BIGER";
        EventType["MACKYES"] = "MACKYES";
        EventType["MACKFAIL"] = "MACKFAIL";
        EventType["SHOW_LREWARD"] = "SHOW_LREWARD";
        EventType["RESTART_GAME"] = "RESTART_GAME";
        EventType["SHOW_LEVEL_UP"] = "SHOW_LEVEL_UP";
        EventType["SHOW_PLAYER_SELECT"] = "SHOW_PLAYER_SELECT";
        EventType["SHOW_ANSWER_END"] = "SHOW_ANSWER_END";
        EventType["TIMER_UPDATE"] = "TIMER_UPDATE";
        EventType["SHOW_KEYANI"] = "SHOW_KEYANI";
        EventType["BOX_CLICK"] = "BOX_CLICK";
        EventType["MOVE_END"] = "MOVE_END";
        EventType["LITTLE_ENEMY_OVER"] = "LITTLE_ENEMY_OVER";
        EventType["BOOM_POS"] = "BOOM_POS";
        EventType["SHOT_Y"] = "SHOT_Y";
        EventType["LITTLE_PASS_OVER"] = "LITTLE_PASS_OVER";
        EventType["CHANGE_SKIN"] = "CHANGE_SKIN";
        EventType["ENEMY_DIE"] = "ENEMY_DIE";
        EventType["RL_START_GAME"] = "RL_START_GAME";
        EventType["STOP_GUIDE"] = "STOP_GUIDE";
        EventType["SHAK_GUN"] = "SHAK_GUN";
        EventType["HANDINMONEY"] = "HANDINMONEY";
        EventType["UPDATE_CHAOPIAO"] = "UPDATE_CHAOPIAO";
        EventType["BUCK_SOURCE"] = "BUCK_SOURCE";
        EventType["BUCK_SELL"] = "BUCK_SELL";
        EventType["UPDATE_POS"] = "UPDATE_POS";
        EventType["UPDATE_OFFER_POS"] = "UPDATE_OFFER_POS";
        EventType["UPDATE_GUIDE_COMPERA"] = "UPDATE_GUIDE_COMPERA";
        EventType["SHOW_PAIMAI"] = "SHOW_PAIMAI";
        EventType["ADDFOOD"] = "ADDFOOD";
        EventType["STOPGUIDE3"] = "STOPGUIDE3";
        EventType["HIDE_PAIMAI"] = "HIDE_PAIMAI";
        EventType["SHOOT"] = "SHOOT";
        EventType["ON_CREATE_COMP"] = "ON_CREATE_COMP";
        EventType["ONBALLBOOM"] = "ONBALLBOOM";
        EventType["ADDLEVELITEM"] = "ADDLEVELITEM";
        EventType["DOG_MOVE"] = "DOG_MOVE";
        EventType["ANIEVENT"] = "ANIEVENT";
        EventType["GESTURES"] = "GESTURES";
        EventType["UPDATE_HOME"] = "UPDATE_HOME";
        EventType["DOG_TALK"] = "DOG_TALK";
        EventType["OPEN_KIND"] = "OPEN_KIND";
        EventType["HIDE_FLAG"] = "HIDE_FLAG";
        EventType["SHOW_FLAG"] = "SHOW_FLAG";
        EventType["UP_SPRIT"] = "UP_SPRIT";
        EventType["HIDE_GROUND"] = "HIDE_GROUND";
        EventType["HIDE_THORN"] = "HIDE_THORN";
        EventType["SHOW_THORN"] = "SHOW_THORN";
        EventType["SHOW_ENEMY_ALL"] = "SHOW_ENEMY_ALL";
        EventType["ADD_ICE_VALUE"] = "ADD_ICE_VALUE";
        EventType["HIDE_BRICK"] = "HIDE_BRICK";
        EventType["BOX_OPEN_ALL"] = "BOX_OPEN_ALL";
        EventType["HUN_LUAN"] = "HUN_LUAN";
        EventType["GUIDE_FLAG"] = "GUIDE_FLAG";
        EventType["UPDATE_SOURCE"] = "UPDATE_SOURCE";
        EventType["SHOW_TEXT"] = "SHOW_TEXT";
        EventType["UPDATE_POWER"] = "UPDATE_POWER";
        EventType["GOODS_SHACK"] = "GOODS_SHACK";
        EventType["UPDATE_BATLLE"] = "UPDATE_BATLLE";
        EventType["UPDATE_BATLLE2"] = "UPDATE_BATLLE2";
        EventType["NO_CHEHUI"] = "NO_CHEHUI";
        EventType["SHOW_TEXT_GOOD"] = "SHOW_TEXT_GOOD";
        EventType["HIDE_CHEHUI"] = "HIDE_CHEHUI";
        EventType["SHOW_CHEHUI"] = "SHOW_CHEHUI";
        EventType["FOOD_POS"] = "FOOD_POS";
        EventType["ADD_POWER_LEVEL"] = "ADD_POWER_LEVEL";
        EventType["STEP_UPDATE"] = "STEP_UPDATE";
        EventType["INIT_UPLEVEL"] = "INIT_UPLEVEL";
        EventType["UPDATE_UPLEVEL"] = "UPDATE_UPLEVEL";
        EventType["UPDATE_FOODMENU"] = "UPDATE_FOODMENU";
        EventType["JIESUO_TIP1"] = "JIESUO_TIP1";
        EventType["SHIP_ENTER"] = "SHIP_ENTER";
        EventType["INIT_TRAVL"] = "INIT_TRAVL";
        EventType["INIT_BIGFISH_TIP"] = "INIT_BIGFISH_TIP";
        EventType["UPLEVE_CUR_GOLD"] = "UPLEVE_CUR_GOLD";
        EventType["INIT_VIP_SHOW"] = "INIT_VIP_SHOW";
        EventType["MONEY_DUIDUI"] = "MONEY_DUIDUI";
        EventType["TRIGGER_MONEY"] = "TRIGGER_MONEY";
        EventType["TEMP_HIDE_AD"] = "TEMP_HIDE_AD";
        EventType["RESUME_AD"] = "RESUME_AD";
    })(EventType$1 || (EventType$1 = {}));
    class EventMgr$1 {
        constructor() {
            this._eventMap = [];
            this.m_events = new Map();
        }
        static get Int() {
            if (!this._Int) {
                this._Int = new EventMgr$1();
            }
            return this._Int;
        }
        on(name, callBack, caller) {
            if (!callBack || !caller)
                return;
            let event = this.m_events.get(name);
            if (!event) {
                event = [];
                this.m_events.set(name, event);
            }
            event.push({ callBack, caller });
        }
        emit(name, ...param) {
            let events = this.m_events.get(name);
            if (!events) {
                return;
            }
            for (let i = 0; i < events.length; i++) {
                let value = events[i];
                if (value)
                    value.callBack.call(value.caller, ...param);
            }
        }
        off(name, callBack, caller) {
            let events = this.m_events.get(name);
            if (!events)
                return;
            for (let i = 0; i < events.length; i++) {
                let value = events[i];
                if (value)
                    if (value.callBack == callBack && value.caller == caller) {
                        events.splice(i, 1);
                        return;
                    }
            }
        }
        offAll(name) {
            let events = this.m_events.get(name);
            if (!events) {
                return;
            }
            events.length = 0;
        }
    }

    class Maps$1 {
        constructor(obj) {
            this._maps = {};
            this.isKeyNumber = false;
            if (obj)
                this._maps = obj;
        }
        static filterValue(values, cb) {
            let key = this.filterKey(values, cb);
            if (!key) {
                return null;
            }
            return values[key];
        }
        static size(value) {
            let count = 0;
            for (let k in value)
                count++;
            return count;
        }
        static filterKey(values, cb) {
            for (let key in values) {
                if (cb(values[key], key))
                    return key;
            }
            return null;
        }
        static shiftKey(value) {
            for (let k in value)
                return k;
            return "";
        }
        static shiftValue(value) {
            for (let k in value)
                return value[k];
            return null;
        }
        static converValueArray(value) {
            let values = [];
            for (let key in value)
                values.push(value[key]);
            return values;
        }
        static forEach(value, cb) {
            for (let k in value) {
                let v = value[k];
                if (!v)
                    continue;
                cb && cb(v, k);
            }
        }
        get maps() { return this._maps; }
        set maps(value) {
            this._maps = value;
        }
        set(key, value) {
            this.isKeyNumber = (typeof key == "number");
            this._maps[key] = value;
            return this;
        }
        has(key) {
            return isValid$1(this._maps[key]);
        }
        get(key) {
            if (!this.has(key))
                return null;
            return this._maps[key];
        }
        gets(keys) {
            let values = [];
            for (let i = 0; i < keys.length; i++) {
                let value = this.get(keys[i]);
                if (value)
                    values.push(value);
            }
            return values;
        }
        delete(key) {
            delete this._maps[key];
        }
        forEach(cb) {
            Maps$1.forEach(this._maps, cb);
            return this;
        }
        clear() {
            this._maps = {};
        }
        get size() {
            return Maps$1.size(this._maps);
        }
        keys() {
            let keys = new Array();
            for (let k in this._maps) {
                keys.push(this.conver_key(k));
            }
            return keys;
        }
        values() {
            let values = [];
            for (let k in this._maps) {
                values.push(this._maps[k]);
            }
            return values;
        }
        valuesMap(cb) {
            let values = [];
            for (let k in this._maps) {
                values.push(cb(this.conver_key(k), this._maps[k]));
            }
            return values;
        }
        get valusSize() {
            let count = 0;
            let values = this.values;
            for (let i = 0; i < values.length; i++) {
                let value = values[i];
                if (value instanceof Sets$1) {
                    count += value.size;
                }
                else {
                    if (!Array.isArray(value))
                        return 0;
                    count += value.length;
                }
            }
            return count;
        }
        shiftValue() {
            return Maps$1.shiftValue(this._maps);
        }
        map_values(cb) {
            for (let key in this._maps) {
                if (!cb(this.conver_key(key), this._maps[key])) {
                    return false;
                }
            }
            return true;
        }
        map() {
        }
        indexOf() {
        }
        keyOf() {
            return;
        }
        conver_key(key) {
            return this.isKeyNumber ? Number(key) : key;
        }
        filterValue(cb, test) {
            for (let key in this._maps) {
                if (cb(this._maps[key])) {
                    return { "key": this.converKey(key), "value": this._maps[key] };
                }
            }
            return null;
        }
        filter_key(cb, out = []) {
            for (let key in this._maps) {
                if (cb(this._maps[key], this.conver_key(key)))
                    out.push(this.conver_key(key));
            }
            return out;
        }
        filter_value(cb, out = []) {
            for (let key in this._maps) {
                if (cb(this._maps[key], this.conver_key(key)))
                    out.push(this._maps[key]);
            }
            return out;
        }
        hasValue(cb) {
            for (let key in this._maps) {
                if (cb(this._maps[key], this.conver_key(key)))
                    return this.conver_key(key);
            }
            return null;
        }
        randomValueOf() {
            if (this.size == 0)
                return null;
            let values = this.values();
            return values[Maths$1.zeroToMax(values.length)];
        }
        toString() {
        }
        converValueArr() {
            return Maps$1.converValueArray(this._maps);
        }
    }

    class QueueCount$1 {
        constructor(count, cb) {
            this.count = 0;
            this.cb = null;
            this.ctor(count, cb);
        }
        set_count(value) {
            this.count = value;
        }
        ctor(count, cb) {
            this.count = count;
            this.cb = cb;
        }
        use() {
            this.count--;
            if (this.count == 0) {
                if (this.cb) {
                    this.cb();
                }
                this.reset();
            }
        }
        reset() {
            this.count = 0;
            this.cb = null;
        }
    }

    class ResourcesMgr$1 {
        constructor() {
            this.is_log = true;
            this.load_cache = new Maps$1();
            this.load_cb = new Maps$1();
            this.load_current = new Sets$1();
            this.fguiUrls = [];
        }
        load(url, cb, onProgress, isCache = true) {
            if (!url) {
                cb && cb(null);
                return;
            }
            let loader_res = Laya.Loader.getRes(url);
            let type = this.getUrlType(url);
            if (type == "UIPackage")
                loader_res = Laya.Loader.getRes(url + "." + fgui.UIConfig.packageFileExtension);
            if (!loader_res) {
                this.load_cache.delete(url);
            }
            let cacheRes = this.load_cache.get(url);
            if (cacheRes && loader_res) {
                cb && cb(cacheRes);
                return;
            }
            let cbs = this.load_cb.get(url);
            if (!cbs) {
                cbs = new Sets$1(false);
                this.load_cb.set(url, cbs);
            }
            cb && cbs.add(cb);
            if (this.load_current.has(url))
                return;
            this.load_current.add(url);
            if (this.is_log)
                console.log("进入加载 url:", url);
            switch (type) {
                case "scene3D":
                    Laya.loader.create(url, Laya.Handler.create(this, this._loaded_finish, [url, isCache]), Laya.Handler.create(this, onProgress), Laya.Scene3D.HIERARCHY);
                    break;
                case "bin":
                    Laya.loader.load(url, Laya.Handler.create(this, this._loaded_finish, [url, isCache]), Laya.Handler.create(this, onProgress));
                    break;
                case "UIPackage":
                    fgui.UIPackage.loadPackage(url, Laya.Handler.create(this, this._loaded_finish, [url, isCache, { UIPackage: url }]));
                    break;
                case "mesh":
                    Laya.Mesh.load(url, Laya.Handler.create(this, this._loaded_finish, [url, isCache]));
                    break;
            }
        }
        getUrlType(url) {
            let scene_ls = str_lastIndexOf$1(url, ".ls");
            let scene_lh = str_lastIndexOf$1(url, ".lh");
            if (scene_ls != -1 || scene_lh != -1)
                return "scene3D";
            let fgui = Sets$1.filterValue(this.fguiUrls, v => str_indexOf$1(url, v) != -1);
            if (fgui)
                return "UIPackage";
            let mesh_lm = str_lastIndexOf$1(url, ".lm");
            if (mesh_lm != -1)
                return "mesh";
            return "bin";
        }
        _loaded_finish(url, isCache, res) {
            if (this.is_log)
                console.log("加载资源完成 url:", url);
            let allCbs = this.load_cb.get(url);
            if (!res) {
                console.log("加载资源失败 loadRes resources:", url, "err:", res);
                if (allCbs)
                    allCbs.forEach((v) => v && v(null));
                return;
            }
            if (isCache) {
                this.load_cache.set(url, res);
            }
            if (allCbs)
                allCbs.forEach((v) => v && v(res));
            this.load_current.delete(url);
            this.load_cb.delete(url);
        }
        get(url) {
            return this.load_cache.get(url) || null;
        }
        loadDir(urls, cb, onProgress, isCache = true) {
            let l = urls.length;
            if (l == 0) {
                if (cb)
                    cb();
                return;
            }
            let count = new QueueCount$1(l, cb);
            if (onProgress) {
                let ratio_all = {};
                let _ratio = 0;
                let progressLength = 0;
                for (let url of urls) {
                    if (this.getUrlType(url) != "UIPackage")
                        progressLength++;
                    this.load(url, count.use.bind(count), (ratio) => {
                        ratio_all[url] = ratio;
                        _ratio = 0;
                        for (let key in ratio_all)
                            _ratio += ratio_all[key];
                        onProgress(_ratio / progressLength);
                    }, isCache);
                }
            }
            else {
                for (let url of urls) {
                    this.load(url, count.use.bind(count), null, isCache);
                }
            }
        }
        release(url) {
            this.load_cache.delete(url);
            let res = Laya.Loader.getRes(url);
            if (res) {
                if (res["destroy"])
                    res["destroy"]();
                Laya.Loader.clearRes(url);
            }
        }
    }
    ResourcesMgr$1.instance = new ResourcesMgr$1();

    class LogicShock$1 {
        constructor() {
            this._is_open = null;
        }
        initData() {
        }
        is_open() {
            if (this._is_open == null) {
                let _is_open = LocalCache$1.get("LogicShock._is_open");
                if (_is_open == "open") {
                    this._is_open = true;
                }
                else if (_is_open == "close")
                    this._is_open = false;
                else
                    this._is_open = true;
            }
            return this._is_open;
        }
        close() {
            this._is_open = false;
            LocalCache$1.set("LogicShock._is_open", "close");
        }
        open() {
            this._is_open = true;
            LocalCache$1.set("LogicShock._is_open", "open");
        }
    }
    LogicShock$1.instance = new LogicShock$1();

    var E_AudioState$1;
    (function (E_AudioState) {
        E_AudioState[E_AudioState["none"] = 0] = "none";
        E_AudioState[E_AudioState["pause"] = 1] = "pause";
        E_AudioState[E_AudioState["pauseLoop"] = 2] = "pauseLoop";
        E_AudioState[E_AudioState["play"] = 3] = "play";
        E_AudioState[E_AudioState["playLoop"] = 4] = "playLoop";
        E_AudioState[E_AudioState["load"] = 5] = "load";
        E_AudioState[E_AudioState["hide"] = 6] = "hide";
    })(E_AudioState$1 || (E_AudioState$1 = {}));
    class AudioMgr$1 {
        constructor() {
            this.loadUrl = "res/sound/";
            this.m_map_cache = new Maps$1();
            this.m_map_is_load = new Maps$1();
            this.music = null;
            this.last_music_name = null;
            this._getNameByConfig = {};
        }
        set is_music(value) {
            LocalCache$1.set("AudioMgr.is_music", value + "");
        }
        get is_music() {
            return LocalCache$1.get("AudioMgr.is_music", "true") === "true";
        }
        set is_sound(value) {
            LocalCache$1.set("AudioMgr.is_sound", value + "");
        }
        get is_sound() {
            return LocalCache$1.get("AudioMgr.is_sound", "true") === "true";
        }
        get_path(audio_name, isbag = false) {
            let url;
            if (window["conch"]) {
                if (!isbag)
                    url = audio_name + ".wav";
                else
                    url = audio_name + ".mp3";
            }
            else {
                url = audio_name + ".mp3";
            }
            if (this.loadUrl)
                return this.loadUrl + url;
            return url;
        }
        play_sound(audio_name, loop = false) {
            audio_name = this.converAudioName(audio_name);
            if (!this.is_sound)
                return;
            let path = this.get_path(audio_name);
            if (this.m_map_is_load.has(audio_name)) {
                let config = this.getNameByConfig(audio_name);
                if (config) {
                    if (config.LoopInterval != 0) {
                        let sound = Laya.SoundManager.playSound(path, 1);
                        if (sound) {
                            sound["timerCallBack"] = function () {
                                if (sound && config.Volume)
                                    sound.volume = config.Volume;
                            };
                            Laya.timer.clear(sound, sound["timerCallBack"]);
                            Laya.timer.loop(config.LoopInterval * 1000, sound, sound["timerCallBack"]);
                        }
                    }
                    else {
                        let sound = Laya.SoundManager.playSound(path, config.Count);
                        if (sound && config.Volume)
                            sound.volume = config.Volume;
                    }
                }
                else
                    Laya.SoundManager.playSound(path, loop ? 0 : 1);
            }
            else
                this.load(audio_name, () => {
                    this.play_sound(audio_name, loop);
                });
        }
        getNameByConfig(audio_name) {
            if (!this._getNameByConfig[audio_name])
                this._getNameByConfig[audio_name] = Maps$1.filterValue(GameData.getSound(), (v) => v && v.AudioName == audio_name);
            return this._getNameByConfig[audio_name];
        }
        converAudioName(audio_name) {
            if (typeof audio_name == "number") {
                let config = GameData.getSoundItem(audio_name);
                if (config)
                    audio_name = config.AudioName;
                else
                    audio_name = "";
            }
            return audio_name;
        }
        play_music(audio_name, loop = true) {
            audio_name = this.converAudioName(audio_name);
            this.last_music_name = audio_name;
            if (!this.is_music)
                return;
            let path = this.get_path(audio_name);
            if (this.m_map_is_load.has(audio_name)) {
                Laya.SoundManager.playMusic(path, loop ? 0 : 1, null);
            }
            else
                this.load(audio_name, () => {
                    this.music = Laya.SoundManager.playMusic(path, loop ? 0 : 1, null);
                });
        }
        stop_music() {
            if (this.music)
                this.music.stop();
            Laya.SoundManager.stopMusic();
        }
        pause_music() {
            if (this.music)
                this.music.pause();
        }
        resume_music() {
            if (this.music)
                this.music.resume();
        }
        stop_sound() {
            Laya.SoundManager.stopAllSound();
        }
        stop_tpSound(audio_name) {
            audio_name = this.converAudioName(audio_name);
            if (!this.is_sound)
                return;
            let path = this.get_path(audio_name);
            Laya.SoundManager.stopSound(path);
        }
        stopAll() {
            Laya.SoundManager.stopAll();
        }
        open_sound() {
            this.is_sound = true;
        }
        close_sound() {
            this.is_sound = false;
            this.stop_sound();
        }
        open_music() {
            this.is_music = true;
            this.play_music(this.last_music_name);
        }
        close_music() {
            this.is_music = false;
            this.stop_music();
        }
        load(audio_name, cb) {
            if (!audio_name)
                return;
            let path = this.get_path(audio_name);
            ResourcesMgr$1.instance.load(path, (res) => {
                this.m_map_is_load.set(audio_name, true);
                if (cb)
                    cb(res);
            });
        }
        vibrateShort(type) {
            if (LogicShock$1.instance.is_open()) {
                GameSDK$1.vibrateShort(type);
            }
        }
        vibrateLong() {
            if (LogicShock$1.instance.is_open()) {
                GameSDK$1.vibrateLong();
            }
        }
        a() {
            Laya.SoundManager;
        }
    }
    AudioMgr$1.instance = new AudioMgr$1();

    const auto_btn_click_prefix$3 = "click_";
    const auto_btn_click_node_prefix$3 = "btn_";
    const auto_transition_prefix$3 = "trans_";
    const auto_add_member_node_prefix$3 = "c_";
    const auto_add_member_ok_node_prefix$3 = [
        "text_",
        "btn_",
        "progress_",
        "comp_",
        "list_",
        "loader_",
        "img_",
        "graph_",
        "input_",
        "group_",
    ];
    class FguiBase$3 extends fairygui.GComponent {
        constructor() {
            super(...arguments);
            this._controllerOnce = null;
        }
        static setExtension(packageName, compName, userClass) {
            fgui.UIObjectFactory.setExtension("ui://" + packageName + "/" + compName, userClass);
        }
        static button_disable(button) {
            if (button.filters && button.filters.length > 0) {
                let colorFilter = button.filters[0];
                colorFilter.gray();
            }
            button.enabled = false;
        }
        static button_enable(button) {
            if (button.filters && button.filters.length > 0) {
                let colorFilter = button.filters[0];
                colorFilter.reset();
            }
            button.enabled = true;
        }
        static get_transition(node, transName) {
            if (transName)
                return node.getTransition(transName);
            else
                return node.getTransitionAt(0);
        }
        static get_transition_all(node, transName) {
            let values = [];
            for (let value of node._transitions)
                if (value.name.indexOf(transName) == 0)
                    values.push(value);
            return values;
        }
        static find_children_transition_once(node, transName) {
            if (!(node instanceof fairygui.GComponent))
                return null;
            let res = null;
            res = node.getTransition(transName);
            if (res)
                return res;
            let _children = node._children;
            for (let value of _children) {
                if (value instanceof fairygui.GComponent) {
                    res = value.getTransition(transName);
                    if (res)
                        break;
                    res = this.find_children_transition_once(value, transName);
                    if (res)
                        break;
                }
            }
            return res;
        }
        static find_children_transition_names(node, trans_name) {
            let values = [];
            if (!(node instanceof fairygui.GComponent))
                return values;
            if (!trans_name)
                return values;
            let _children = node["_children"];
            for (let value of _children) {
                if (node instanceof fairygui.GComponent) {
                    let trans = this.get_transition_all(node, trans_name);
                    if (trans.length > 0)
                        values.push(...trans);
                    Sets$1.push(values, this.find_children_transition_names(value, trans_name));
                }
            }
            return values;
        }
        static find_children_names_once_node(node, name) {
            if (!(node instanceof fairygui.GComponent))
                return null;
            let _children = node._children;
            let res = null;
            for (let value of _children) {
                if (value.name == name) {
                    res = value;
                    break;
                }
                if (node instanceof fairygui.GComponent)
                    res = this.find_children_names_once_node(value, name);
                if (res)
                    break;
            }
            return res;
        }
        static find_children_names(node, names, cb) {
            let values = [];
            for (let i = 0, l = names.length; i < l; i++) {
                let value = names[i];
                let data = this.find_children_names_once_node(node, value);
                if (data) {
                    values.push(data);
                    if (cb)
                        cb(data, value, i);
                }
            }
            return values;
        }
        static find_children_names_node(node, node_name) {
            let values = [];
            if (!(node instanceof fairygui.GComponent))
                return values;
            if (!node_name)
                return values;
            let _children = node["_children"];
            for (let value of _children) {
                if (value.name == node_name) {
                    values.push(value);
                }
                if (node instanceof fairygui.GComponent)
                    Sets$1.push(values, this.find_children_names_node(value, node_name));
            }
            return values;
        }
        static find_children_names_node_prefix(node, prefix) {
            let values = [];
            if (!(node instanceof fairygui.GComponent))
                return values;
            let _children = node["_children"];
            for (let value of _children) {
                if (str_indexOf$1(value.name, prefix) == 0) {
                    values.push(value);
                }
                if (node instanceof fairygui.GComponent)
                    Sets$1.push(values, this.find_children_names_node_prefix(value, prefix));
            }
            return values;
        }
        static match_children_to_member(parent, caller) {
            for (let key in caller) {
                if (caller[key] != null)
                    continue;
                let member_index = str_indexOf$1(key, auto_add_member_node_prefix$3);
                if (member_index == 0) {
                    let last_index = str_lastIndexOf$1(key, auto_add_member_node_prefix$3);
                    let children_name = key.slice(last_index);
                    for (let value of auto_add_member_ok_node_prefix$3) {
                        let index = str_indexOf$1(children_name, value);
                        if (index != -1) {
                            let node = FguiBase$3.find_children_names_once_node(parent, children_name);
                            if (!node) ;
                            else {
                                caller[key] = node;
                            }
                            break;
                        }
                    }
                }
            }
        }
        static match_transition_prefix(node, caller) {
            for (let key in caller) {
                if (caller[key] != null)
                    continue;
                let member_index = str_indexOf$1(key, auto_transition_prefix$3);
                if (member_index == 0) {
                    let last_index = str_lastIndexOf$1(key, auto_transition_prefix$3);
                    let transition_name = key.slice(last_index);
                    let transition = this.find_children_transition_once(node, transition_name);
                    if (transition) {
                        caller[key] = transition;
                        console.log("自动添加成员动画 动画名", transition_name, "成员函数名:", key);
                    }
                }
            }
        }
        static onClick(node, cb, caller) {
            node.onClick(caller, (e) => {
                if (!FguiBase$3.enableClick) {
                    console.log("按钮事件已屏蔽");
                    return;
                }
                e.stopPropagation();
                if (FguiBase$3.clickSoundName)
                    AudioMgr$1.instance.play_sound(FguiBase$3.clickSoundName);
                cb.call(caller, e);
            });
        }
        static match_children_btn_event(parent, caller) {
            let btns = FguiBase$3.find_children_names_node_prefix(parent, auto_btn_click_node_prefix$3);
            for (let node of btns) {
                if (str_indexOf$1(node.name, auto_btn_click_node_prefix$3) == 0) {
                    let node_name = node.name.slice(str_lastIndexOf$1(node.name, auto_btn_click_node_prefix$3));
                    let member_name = auto_btn_click_prefix$3 + node_name;
                    if (caller[member_name] && typeof caller[member_name] == "function") {
                        this.onClick(node, caller[member_name], caller);
                    }
                }
            }
        }
        static get_controller(node, name) {
            if (name)
                return node.getController(name);
            else {
                return node.controllers[0] || null;
            }
        }
        static createPackageItem(packageName, resName, userClass) {
            return fairygui.UIPackage.createObject(packageName, resName, userClass);
        }
        static insert_child(parent, level) {
            let node_name = level.toString();
            for (let i = 0, children = parent._children, length = children.length; i < length; i++) {
                let value = children[i];
                if (value.name == node_name)
                    return value;
                if (Number(value.name) > level) {
                    let childrenParent = new fairygui.GComponent();
                    childrenParent.name = node_name;
                    childrenParent.setPivot(0, 0);
                    parent.addChildAt(childrenParent, i);
                    return childrenParent;
                }
            }
            let childrenParent = new fairygui.GComponent();
            childrenParent.name = node_name;
            childrenParent.setPivot(0, 0);
            parent.addChild(childrenParent);
            return childrenParent;
        }
        constructFromXML() {
            super.constructFromXML(undefined);
            FguiBase$3.match_children_to_member(this, this);
            FguiBase$3.match_children_btn_event(this, this);
            FguiBase$3.match_transition_prefix(this, this);
            if (this.onConstructFromXML)
                this.onConstructFromXML();
        }
        dispose() {
            Laya.timer.clearAll(this);
            if (this.onDispose)
                this.onDispose();
            this._controllerOnce = null;
            super.dispose();
        }
        get_controller(name) {
            return FguiBase$3.get_controller(this, name);
        }
        get controllerOnce() {
            if (this._controllerOnce == null)
                this._controllerOnce = this.get_controller();
            return this._controllerOnce;
        }
        get_transition(transName) {
            return FguiBase$3.get_transition(this, transName);
        }
        find_children_names_node_prefix(prefix) {
            return FguiBase$3.find_children_names_node_prefix(this, prefix);
        }
        find_children_names_node(node_name) {
            return FguiBase$3.find_children_names_node(this, node_name);
        }
        find_children_names_once_node(node_name) {
            return FguiBase$3.find_children_names_once_node(this, node_name);
        }
        find_children_names(node_names, cb) {
            return FguiBase$3.find_children_names(this, node_names, cb);
        }
    }
    FguiBase$3.enableClick = true;
    FguiBase$3.clickSoundName = 0;

    const PI = Math.PI;
    const _d2r = PI / 180.0;
    const _r2d = 180.0 / PI;
    class Maths {
        static formula2(value, start, length) {
            return (value + (start % length)) % length;
        }
        static formula(value, mul) {
            let res = mul * value;
            while (value--)
                res += value;
            return res;
        }
        static isEven(value) {
            return value % 2 == 0;
        }
        static toRadian(a) {
            return a * _d2r;
        }
        static converGold(value) {
            return "";
        }
        static equallyNum(value, count, randMin, randMax, isPositive = false) {
            let equally = Math.floor(value / count);
            if (isPositive)
                randMax = equally - 1;
            let res = [];
            let lastRand = 0;
            let is = true;
            for (let i = 0; i < count; i++) {
                if (is) {
                    is = false;
                    lastRand = this.minToMax(randMin, randMax);
                    res.push(equally + lastRand);
                }
                else {
                    is = true;
                    res.push(equally - lastRand);
                }
            }
            return res;
        }
        static decimal(value) {
            value = value - (Math.floor(value));
            return value;
        }
        static toDegree(a, is_ormalize = true) {
            if (a == undefined)
                return 0;
            if (is_ormalize)
                a = this.normalizeAngle(a);
            return a * _r2d;
        }
        static normalizeAngle(angle) {
            angle = angle % (2 * PI);
            if (angle < 0) {
                angle += (2 * PI);
            }
            return angle;
        }
        static checkRange(value, value2, range) {
            return Math.abs(value - value2) <= range;
        }
        static isTargetRange(value, target, range) {
            if (value >= target - range)
                return true;
            if (value <= target + range)
                return true;
            return false;
        }
        static zeroEqually(space, index, length) {
            return (index - (length - 1) / 2) * space;
        }
        static equally(count = 1, min, max) {
            count++;
            let equally = [];
            let space = ((max - min) / count);
            for (let i = 1; i < count; i++) {
                equally.push(~~(min + space * i));
            }
            return equally;
        }
        static abs_sub_length(value1, value2) {
            return Math.abs(value1 - value2);
        }
        static add_arrs(values) {
            let count = 0;
            for (let value of values)
                count += value;
            return count;
        }
        static lerp(a, b, r) {
            return a + (b - a) * r;
        }
        static clamp01(value) {
            return value < 0 ? 0 : value < 1 ? value : 1;
        }
        static clampf(value, min, max) {
            if (min > max) {
                var temp = min;
                min = max;
                max = temp;
            }
            return value < min ? min : value < max ? value : max;
        }
        static isClampf(value, min, max) {
            if (min > max) {
                var temp = min;
                min = max;
                max = temp;
            }
            if (value <= max && value >= min)
                return true;
            else
                return false;
        }
        static create_arr_num(max) {
            let values = [];
            for (let i = 0; i < max; i++)
                values.push(i);
            return values;
        }
        static isRandom(value) {
            if (!value)
                return false;
            if (value >= 1)
                return true;
            if (value <= 0)
                return false;
            return value > Math.random();
        }
        static zeroToMax(max) {
            if (max <= 1)
                return 0;
            let random = Math.random();
            return ~~((random == 1 ? 0.5 : random) * max);
        }
        static minToMax(min, max, is_int = true) {
            if (min == max)
                return min;
            if (min < 0) {
                if (is_int)
                    return Math.round(Math.random() * (Math.abs(min) + max)) + min;
                else
                    return Math.random() * (Math.abs(min) + max) + min;
            }
            if (is_int)
                return Math.round(Math.random() * (max - min)) + min;
            else
                return Math.random() * (max - min) + min;
        }
        static converNumber(value) {
            if (typeof value == "string")
                return Number(value);
        }
        static find_num_section(arr, num, out, is_contain_num = false) {
            if (!out)
                out = { i: 0, count: 0 };
            out.i = arr.length;
            out.count = 0;
            for (let i = 0; i < arr.length; i++) {
                out.count += arr[i];
                if (is_contain_num) {
                    if (num <= out.count) {
                        out.i = i;
                        return out;
                    }
                }
                else if (num < out.count) {
                    out.i = i;
                    return out;
                }
            }
            return out;
        }
        static find_num_section_random(arr) {
            let all = this.add_arrs(arr);
            let last = 0;
            let rand = this.zeroToMax(all - 1);
            for (let i = 0; i < arr.length; i++) {
                let value = arr[i];
                if (rand >= last && rand < last + value)
                    return i;
                last += value;
            }
            return arr.length;
        }
    }

    new Laya.Vector3();
    new Laya.Vector3();
    new Laya.Vector3(1, 1, 1);
    new Laya.Vector3(0, 1, 0);
    new Laya.Vector3(0, 0, 1);
    new Laya.Vector3(0, 180, 0);
    new Laya.Point();
    new Laya.Quaternion();

    const isValid = function (key) {
        if (key == null || key == undefined || key === false)
            return false;
        else
            return true;
    };
    const minxi = function (value) {
        if (value === null || value === undefined || value === 0 || value === "")
            return value;
        let _getPropertyDescriptor = function (obj, name) {
            while (obj) {
                let pd = Object.getOwnPropertyDescriptor(obj, name);
                if (pd) {
                    return pd;
                }
                obj = Object.getPrototypeOf(obj);
            }
            return null;
        };
        let _copyprop = function (name, source, target) {
            let pd = _getPropertyDescriptor(source, name);
            Object.defineProperty(target, name, pd);
        };
        let _mixin = function (obj, ...sourceObj) {
            obj = obj || {};
            for (let i = 1, length = arguments.length; i < length; i++) {
                let source = arguments[i];
                if (source) {
                    if (typeof source !== "object") {
                        continue;
                    }
                    for (let name in source) {
                        _copyprop(name, source, obj);
                    }
                }
            }
            return obj;
        };
        let target = null;
        if (typeof value === "object") {
            target = _mixin(Array.isArray(value) ? [] : {}, value);
        }
        else {
            target = value;
        }
        return target;
    };
    const str_indexOf = function (value, str, start = 0) {
        return value.indexOf(str, start);
    };
    const str_lastIndexOf = function (value, str) {
        let index = str_indexOf(value, str);
        if (index == -1) {
            return -1;
        }
        return index + str.length;
    };

    class Sets {
        constructor(isRepeat = true, ...values) {
            this.sets = [];
            this.isRepeat = true;
            this.isRepeat = isRepeat;
            this.add(...values);
        }
        static delete(arr, value) {
            if (arr.length == 0)
                return false;
            let index = arr.indexOf(value);
            if (index == -1)
                return false;
            arr.splice(index, 1);
            return true;
        }
        static map(arr, cb) {
            let set = [];
            for (let i = 0; i < arr.length; i++) {
                let data = cb(arr[i], i, arr);
                set.push(data);
            }
            return set;
        }
        static has(arr, value, stringCompare = false) {
            if (arr.length == 0)
                return false;
            let index;
            if (stringCompare)
                index = this.map(arr, v => v.toString()).indexOf(value.toString());
            else
                index = arr.indexOf(value);
            return index != -1;
        }
        static add(arr, ...values) {
            for (let i = 0; i < values.length; i++) {
                let value = values[i];
                if (this.has(arr, value))
                    continue;
                arr.push(value);
            }
        }
        static random(value, exclude) {
            if (value.length == 0)
                return null;
            if (exclude) {
                let values = [];
                for (let i = 0, l = value.length; i < l; i++)
                    if (!exclude(value[i], i))
                        values.push(values[i]);
                return this.random(values);
            }
            return value[Maths.zeroToMax(value.length)];
        }
        static getAt(value, index) {
            index = Maths.clampf(index, 0, value.length - 1);
            return value[index];
        }
        static filterValue(values, cb) {
            let idx = this.filterOf(values, cb);
            if (idx == -1) {
                return null;
            }
            return values[idx];
        }
        static filterOf(values, cb) {
            let idx = -1;
            for (let i = 0; i < values.length; i++) {
                if (values[i] && cb(values[i], i)) {
                    return i;
                }
            }
            return idx;
        }
        static filter(values, cb, out) {
            if (!out)
                out = [];
            for (let i = 0; i < values.length; i++) {
                if (values[i] && cb(values[i], i)) {
                    out.push(values[i]);
                }
            }
            return out;
        }
        static push(values, push) {
            for (let value of push)
                values.push(value);
            return values;
        }
        static sort(values, cb) {
            return values.sort(cb);
        }
        static shuffle(arr, isChangeOriginal = true) {
            if (!isChangeOriginal) {
                let tmp = arr.concat();
                tmp.sort((a, b) => {
                    return Math.random() > .5 ? 1 : -1;
                });
                return tmp;
            }
            else {
                arr.sort((a, b) => {
                    return Math.random() > .5 ? 1 : -1;
                });
                return arr;
            }
        }
        static random_arr(vlaues, count = 1) {
            let res = this.shuffle(vlaues, false), arr = [];
            for (let i = 0; i < count; i++)
                if (isValid(res[i]))
                    arr.push(res[i]);
            return arr;
        }
        add(...values) {
            for (let i = 0; i < values.length; i++) {
                let value = values[i];
                if (this.has(value) && this.isRepeat)
                    continue;
                this.sets.push(value);
            }
            return this;
        }
        delete(value) {
            return Sets.delete(this.sets, value);
        }
        get size() {
            return this.sets.length;
        }
        indexOf(value) {
            return this.sets.indexOf(value);
        }
        has(value, stringCompare = false) {
            return Sets.has(this.sets, value, stringCompare);
        }
        hasOf(index) {
            return isValid(this.sets[index]);
        }
        clear() {
            this.sets.length = 0;
        }
        shift(isOrign = true) {
            if (isOrign) {
                return this.sets.shift();
            }
            else {
                return this.sets.concat()[0];
            }
        }
        toString() {
            return this.sets.toString();
        }
        forEach(cb) {
            this.sets.forEach(cb);
            return this;
        }
        map(cb) {
            return Sets.map(this.sets, cb);
        }
        findContinueIndexs(cb) {
            let values = this.map(cb);
            let indexs = [];
            for (let i = 0; i < values.length; i++) {
                let continueIndexs = [];
                for (let j = 0; j < values.length - i; j++) {
                    let cur = values[i + j];
                    let last = values[i] + j;
                    if (cur == last)
                        continueIndexs.push(values.indexOf(cur));
                    else
                        break;
                }
                if (continueIndexs.length > 1)
                    indexs.push(continueIndexs);
            }
            let res = [];
            for (let i = 0; i < indexs.length; i++) {
                let self = indexs[i];
                let id = this._findContinueIndexs(res, self);
                if (id == -1)
                    res.push(self);
                else if (res[id].length < self.length)
                    res[id] = self;
            }
            return res;
        }
        _findContinueIndexs(maxs, min) {
            for (let i = 0; i < maxs.length; i++) {
                for (let j = 0; j < maxs[i].length; j++) {
                    if (min.indexOf(maxs[i][j]) != -1) {
                        return i;
                    }
                }
            }
            return -1;
        }
        findEquallyIndexs() {
            let indexs = new Sets();
            for (let i = 0; i < this.sets.length; i++) {
                let self = this.sets[i];
                let equally = [];
                for (let j = 0; j < this.sets.length; j++) {
                    let all = this.sets[j];
                    if (self == all) {
                        equally.push(j);
                    }
                }
                if (equally.length > 1) {
                    if (!indexs.has(equally, true)) {
                        indexs.add(equally);
                    }
                }
            }
            return indexs;
        }
        sort(cb) {
            Sets.sort(this.sets, cb);
            return this;
        }
        deleteFilterOf(cb) {
            let idx = this.filterOf(cb);
            if (idx == -1) {
                return false;
            }
            this.splice(idx);
            return true;
        }
        filterOf(cb) {
            return Sets.filterOf(this.sets, cb);
        }
        filterValue(cb) {
            return Sets.filterValue(this.sets, cb);
        }
        filter(cb) {
            let tmp = new Sets(this.isRepeat);
            for (let i = 0; i < this.sets.length; i++) {
                let data = this.sets[i];
                if (cb(data, i, this.sets)) {
                    tmp.add(data);
                }
            }
            return tmp;
        }
        deletePops(count = 1, cb) {
            for (let i = 0; i < count; i++) {
                let pop = this.pop();
                pop && cb && cb(pop);
            }
        }
        splice(start, deleteCount = 1) {
            return this.sets.splice(start, deleteCount);
        }
        unShift() {
        }
        pop(remove = true) {
            return Sets.pop(this.sets, remove);
        }
        static pop(values, remove = true) {
            if (remove) {
                return values.pop();
            }
            else {
                return values[values.length - 1] || null;
            }
        }
        lastValueOf(index) {
            return this.sets[this.sets.length - index - 1] || null;
        }
        valuesOf(index) {
            return this.sets[index] || null;
        }
        randomOf() {
            if (this.size == 0)
                return null;
            return this.sets[Maths.zeroToMax(this.sets.length)];
        }
        addRandomSelf() {
            if (this.size == 0)
                return false;
            let data = this.sets[Maths.zeroToMax(this.sets.length)];
            this.add(data);
            return true;
        }
        shuffle(isChangeOriginal = true) {
            return Sets.shuffle(this.sets, isChangeOriginal);
        }
        deep() {
            let deep = JSON.parse(JSON.stringify(this.sets));
            return new Sets(this.isRepeat, ...deep);
        }
        concat(...value) {
            return new Sets(this.isRepeat, ...this.sets.concat(value));
        }
    }

    class Maps {
        constructor(obj) {
            this._maps = {};
            this.isKeyNumber = false;
            if (obj)
                this._maps = obj;
        }
        static filterValue(values, cb) {
            let key = this.filterKey(values, cb);
            if (!key) {
                return null;
            }
            return values[key];
        }
        static size(value) {
            let count = 0;
            for (let k in value)
                count++;
            return count;
        }
        static filterKey(values, cb) {
            for (let key in values) {
                if (cb(values[key], key))
                    return key;
            }
            return null;
        }
        static shiftKey(value) {
            for (let k in value)
                return k;
            return "";
        }
        static shiftValue(value) {
            for (let k in value)
                return value[k];
            return null;
        }
        static converValueArray(value) {
            let values = [];
            for (let key in value)
                values.push(value[key]);
            return values;
        }
        static forEach(value, cb) {
            for (let k in value) {
                let v = value[k];
                if (!v)
                    continue;
                cb && cb(v, k);
            }
        }
        get maps() { return this._maps; }
        set maps(value) {
            this._maps = value;
        }
        set(key, value) {
            this.isKeyNumber = (typeof key == "number");
            this._maps[key] = value;
            return this;
        }
        has(key) {
            return isValid(this._maps[key]);
        }
        get(key) {
            if (!this.has(key))
                return null;
            return this._maps[key];
        }
        gets(keys) {
            let values = [];
            for (let i = 0; i < keys.length; i++) {
                let value = this.get(keys[i]);
                if (value)
                    values.push(value);
            }
            return values;
        }
        delete(key) {
            delete this._maps[key];
        }
        forEach(cb) {
            Maps.forEach(this._maps, cb);
            return this;
        }
        clear() {
            this._maps = {};
        }
        get size() {
            return Maps.size(this._maps);
        }
        keys() {
            let keys = new Array();
            for (let k in this._maps) {
                keys.push(this.conver_key(k));
            }
            return keys;
        }
        values() {
            let values = [];
            for (let k in this._maps) {
                values.push(this._maps[k]);
            }
            return values;
        }
        valuesMap(cb) {
            let values = [];
            for (let k in this._maps) {
                values.push(cb(this.conver_key(k), this._maps[k]));
            }
            return values;
        }
        get valusSize() {
            let count = 0;
            let values = this.values;
            for (let i = 0; i < values.length; i++) {
                let value = values[i];
                if (value instanceof Sets) {
                    count += value.size;
                }
                else {
                    if (!Array.isArray(value))
                        return 0;
                    count += value.length;
                }
            }
            return count;
        }
        shiftValue() {
            return Maps.shiftValue(this._maps);
        }
        map_values(cb) {
            for (let key in this._maps) {
                if (!cb(this.conver_key(key), this._maps[key])) {
                    return false;
                }
            }
            return true;
        }
        map() {
        }
        indexOf() {
        }
        keyOf() {
            return;
        }
        conver_key(key) {
            return this.isKeyNumber ? Number(key) : key;
        }
        filterValue(cb, test) {
            for (let key in this._maps) {
                if (cb(this._maps[key])) {
                    return { "key": this.converKey(key), "value": this._maps[key] };
                }
            }
            return null;
        }
        filter_key(cb, out = []) {
            for (let key in this._maps) {
                if (cb(this._maps[key], this.conver_key(key)))
                    out.push(this.conver_key(key));
            }
            return out;
        }
        filter_value(cb, out = []) {
            for (let key in this._maps) {
                if (cb(this._maps[key], this.conver_key(key)))
                    out.push(this._maps[key]);
            }
            return out;
        }
        hasValue(cb) {
            for (let key in this._maps) {
                if (cb(this._maps[key], this.conver_key(key)))
                    return this.conver_key(key);
            }
            return null;
        }
        randomValueOf() {
            if (this.size == 0)
                return null;
            let values = this.values();
            return values[Maths.zeroToMax(values.length)];
        }
        toString() {
        }
        converValueArr() {
            return Maps.converValueArray(this._maps);
        }
    }

    let value = null;
    let valueType = null;
    let index = 0;
    class LocalCache {
        static get setCatchKeyPrefix() {
            return this._setCatchKeyPrefix;
        }
        static converKey(key) {
            if (key.indexOf(this.setCatchKeyPrefix) == -1)
                return this.setCatchKeyPrefix + key;
            return key;
        }
        static set(key, value, isDelay = true) {
            key = this.converKey(key);
            if (!this.checkCacheValue(value))
                return;
            this.cache[key] = value;
            Sets.add(this.updateCache, key);
            if (isDelay)
                Laya.timer.once(this.delayCache, this, this.onSet, null, true);
            else
                this.onSet();
        }
        static get(key, defaultValue = null) {
            key = this.converKey(key);
            value = this.cache[key];
            if (!this.checkCacheValue(value)) {
                value = Laya.LocalStorage.getItem(key);
                if (!this.checkCacheValue(value)) {
                    value = minxi(defaultValue);
                    this.cache[key] = value;
                    this.set(key, this.cache[key], false);
                }
                else {
                    index = value.indexOf("-");
                    valueType = value.substring(0, index);
                    value = value.substring(index + 1);
                    switch (valueType) {
                        case "boolean":
                            this.cache[key] = value == "true";
                            break;
                        case "number":
                            this.cache[key] = Number(value);
                            break;
                        case "object":
                            this.cache[key] = JSON.parse(value);
                            break;
                        case "string":
                            this.cache[key] = value;
                            break;
                        default:
                            value = minxi(defaultValue);
                            this.cache[key] = value;
                            break;
                    }
                }
            }
            return this.cache[key];
        }
        static checkCacheValue(value) {
            if (value == null || value == "null" || value == undefined)
                return false;
            return true;
        }
        static onSet() {
            for (let key of this.updateCache) {
                value = this.cache[key];
                valueType = typeof value;
                switch (valueType) {
                    case "boolean":
                        value = value + "";
                        break;
                    case "number":
                        value = value + "";
                        break;
                    case "object":
                        value = JSON.stringify(value);
                        break;
                    case "string":
                        break;
                    default:
                        value = null;
                        break;
                }
                if (value != null)
                    Laya.LocalStorage.setItem(key, valueType + "-" + value);
            }
            this.updateCache.length = 0;
        }
        static has(key) {
            key = this.converKey(key);
            return !!this.get(key);
        }
        static delete(key) {
            key = this.converKey(key);
            delete this.cache[key];
            Laya.LocalStorage.removeItem(key);
        }
        ;
        static clear() {
            this.cache = {};
            Laya.LocalStorage.clear();
        }
    }
    LocalCache.cache = {};
    LocalCache.updateCache = [];
    LocalCache._setCatchKeyPrefix = "";
    LocalCache.delayCache = 200;

    class QueueCount {
        constructor(count, cb) {
            this.count = 0;
            this.cb = null;
            this.ctor(count, cb);
        }
        set_count(value) {
            this.count = value;
        }
        ctor(count, cb) {
            this.count = count;
            this.cb = cb;
        }
        use() {
            this.count--;
            if (this.count == 0) {
                if (this.cb) {
                    this.cb();
                }
                this.reset();
            }
        }
        reset() {
            this.count = 0;
            this.cb = null;
        }
    }

    class ResourcesMgr {
        constructor() {
            this.is_log = true;
            this.load_cache = new Maps();
            this.load_cb = new Maps();
            this.load_current = new Sets();
            this.fguiUrls = [];
        }
        load(url, cb, onProgress, isCache = true) {
            if (!url) {
                cb && cb(null);
                return;
            }
            let loader_res = Laya.Loader.getRes(url);
            let type = this.getUrlType(url);
            if (type == "UIPackage")
                loader_res = Laya.Loader.getRes(url + "." + fgui.UIConfig.packageFileExtension);
            if (!loader_res) {
                this.load_cache.delete(url);
            }
            let cacheRes = this.load_cache.get(url);
            if (cacheRes && loader_res) {
                cb && cb(cacheRes);
                return;
            }
            let cbs = this.load_cb.get(url);
            if (!cbs) {
                cbs = new Sets(false);
                this.load_cb.set(url, cbs);
            }
            cb && cbs.add(cb);
            if (this.load_current.has(url))
                return;
            this.load_current.add(url);
            if (this.is_log)
                console.log("进入加载 url:", url);
            switch (type) {
                case "scene3D":
                    Laya.loader.create(url, Laya.Handler.create(this, this._loaded_finish, [url, isCache]), Laya.Handler.create(this, onProgress), Laya.Scene3D.HIERARCHY);
                    break;
                case "bin":
                    Laya.loader.load(url, Laya.Handler.create(this, this._loaded_finish, [url, isCache]), Laya.Handler.create(this, onProgress));
                    break;
                case "UIPackage":
                    fgui.UIPackage.loadPackage(url, Laya.Handler.create(this, this._loaded_finish, [url, isCache, { UIPackage: url }]));
                    break;
                case "mesh":
                    Laya.Mesh.load(url, Laya.Handler.create(this, this._loaded_finish, [url, isCache]));
                    break;
            }
        }
        getUrlType(url) {
            let scene_ls = str_lastIndexOf(url, ".ls");
            let scene_lh = str_lastIndexOf(url, ".lh");
            if (scene_ls != -1 || scene_lh != -1)
                return "scene3D";
            let fgui = Sets.filterValue(this.fguiUrls, v => str_indexOf(url, v) != -1);
            if (fgui)
                return "UIPackage";
            let mesh_lm = str_lastIndexOf(url, ".lm");
            if (mesh_lm != -1)
                return "mesh";
            return "bin";
        }
        _loaded_finish(url, isCache, res) {
            if (this.is_log)
                console.log("加载资源完成 url:", url);
            let allCbs = this.load_cb.get(url);
            if (!res) {
                console.log("加载资源失败 loadRes resources:", url, "err:", res);
                if (allCbs)
                    allCbs.forEach((v) => v && v(null));
                return;
            }
            if (isCache) {
                this.load_cache.set(url, res);
            }
            if (allCbs)
                allCbs.forEach((v) => v && v(res));
            this.load_current.delete(url);
            this.load_cb.delete(url);
        }
        get(url) {
            return this.load_cache.get(url) || null;
        }
        loadDir(urls, cb, onProgress, isCache = true) {
            let l = urls.length;
            if (l == 0) {
                if (cb)
                    cb();
                return;
            }
            let count = new QueueCount(l, cb);
            if (onProgress) {
                let ratio_all = {};
                let _ratio = 0;
                let progressLength = 0;
                for (let url of urls) {
                    if (this.getUrlType(url) != "UIPackage")
                        progressLength++;
                    this.load(url, count.use.bind(count), (ratio) => {
                        ratio_all[url] = ratio;
                        _ratio = 0;
                        for (let key in ratio_all)
                            _ratio += ratio_all[key];
                        onProgress(_ratio / progressLength);
                    }, isCache);
                }
            }
            else {
                for (let url of urls) {
                    this.load(url, count.use.bind(count), null, isCache);
                }
            }
        }
        release(url) {
            this.load_cache.delete(url);
            let res = Laya.Loader.getRes(url);
            if (res) {
                if (res["destroy"])
                    res["destroy"]();
                Laya.Loader.clearRes(url);
            }
        }
    }
    ResourcesMgr.instance = new ResourcesMgr();

    class LogicShock {
        constructor() {
            this._is_open = null;
        }
        initData() {
        }
        is_open() {
            if (this._is_open == null) {
                let _is_open = LocalCache.get("LogicShock._is_open");
                if (_is_open == "open") {
                    this._is_open = true;
                }
                else if (_is_open == "close")
                    this._is_open = false;
                else
                    this._is_open = true;
            }
            return this._is_open;
        }
        close() {
            this._is_open = false;
            LocalCache.set("LogicShock._is_open", "close");
        }
        open() {
            this._is_open = true;
            LocalCache.set("LogicShock._is_open", "open");
        }
    }
    LogicShock.instance = new LogicShock();

    var E_AudioState;
    (function (E_AudioState) {
        E_AudioState[E_AudioState["none"] = 0] = "none";
        E_AudioState[E_AudioState["pause"] = 1] = "pause";
        E_AudioState[E_AudioState["pauseLoop"] = 2] = "pauseLoop";
        E_AudioState[E_AudioState["play"] = 3] = "play";
        E_AudioState[E_AudioState["playLoop"] = 4] = "playLoop";
        E_AudioState[E_AudioState["load"] = 5] = "load";
        E_AudioState[E_AudioState["hide"] = 6] = "hide";
    })(E_AudioState || (E_AudioState = {}));
    class AudioMgr {
        constructor() {
            this.loadUrl = "res/sound/";
            this.m_map_cache = new Maps();
            this.m_map_is_load = new Maps();
            this.music = null;
            this.last_music_name = null;
            this._getNameByConfig = {};
        }
        set is_music(value) {
            LocalCache.set("AudioMgr.is_music", value + "");
        }
        get is_music() {
            return LocalCache.get("AudioMgr.is_music", "true") === "true";
        }
        set is_sound(value) {
            LocalCache.set("AudioMgr.is_sound", value + "");
        }
        get is_sound() {
            return LocalCache.get("AudioMgr.is_sound", "true") === "true";
        }
        get_path(audio_name, isbag = false) {
            let url;
            if (window["conch"]) {
                if (!isbag)
                    url = audio_name + ".wav";
                else
                    url = audio_name + ".mp3";
            }
            else {
                url = audio_name + ".mp3";
            }
            if (this.loadUrl)
                return this.loadUrl + url;
            return url;
        }
        play_sound(audio_name, loop = false) {
            audio_name = this.converAudioName(audio_name);
            if (!this.is_sound)
                return;
            let path = this.get_path(audio_name);
            if (this.m_map_is_load.has(audio_name)) {
                let config = this.getNameByConfig(audio_name);
                if (config) {
                    if (config.LoopInterval != 0) {
                        let sound = Laya.SoundManager.playSound(path, 1);
                        if (sound) {
                            sound["timerCallBack"] = function () {
                                if (sound && config.Volume)
                                    sound.volume = config.Volume;
                            };
                            Laya.timer.clear(sound, sound["timerCallBack"]);
                            Laya.timer.loop(config.LoopInterval * 1000, sound, sound["timerCallBack"]);
                        }
                    }
                    else {
                        let sound = Laya.SoundManager.playSound(path, config.Count);
                        if (sound && config.Volume)
                            sound.volume = config.Volume;
                    }
                }
                else
                    Laya.SoundManager.playSound(path, loop ? 0 : 1);
            }
            else
                this.load(audio_name, () => {
                    this.play_sound(audio_name, loop);
                });
        }
        getNameByConfig(audio_name) {
            if (!this._getNameByConfig[audio_name])
                this._getNameByConfig[audio_name] = Maps.filterValue(GameData.getSound(), (v) => v && v.AudioName == audio_name);
            return this._getNameByConfig[audio_name];
        }
        converAudioName(audio_name) {
            if (typeof audio_name == "number") {
                let config = GameData.getSoundItem(audio_name);
                if (config)
                    audio_name = config.AudioName;
                else
                    audio_name = "";
            }
            return audio_name;
        }
        play_music(audio_name, loop = true) {
            audio_name = this.converAudioName(audio_name);
            this.last_music_name = audio_name;
            if (!this.is_music)
                return;
            let path = this.get_path(audio_name);
            if (this.m_map_is_load.has(audio_name)) {
                Laya.SoundManager.playMusic(path, loop ? 0 : 1, null);
            }
            else
                this.load(audio_name, () => {
                    this.music = Laya.SoundManager.playMusic(path, loop ? 0 : 1, null);
                });
        }
        stop_music() {
            if (this.music)
                this.music.stop();
            Laya.SoundManager.stopMusic();
        }
        pause_music() {
            if (this.music)
                this.music.pause();
        }
        resume_music() {
            if (this.music)
                this.music.resume();
        }
        stop_sound() {
            Laya.SoundManager.stopAllSound();
        }
        stop_tpSound(audio_name) {
            audio_name = this.converAudioName(audio_name);
            if (!this.is_sound)
                return;
            let path = this.get_path(audio_name);
            Laya.SoundManager.stopSound(path);
        }
        stopAll() {
            Laya.SoundManager.stopAll();
        }
        open_sound() {
            this.is_sound = true;
        }
        close_sound() {
            this.is_sound = false;
            this.stop_sound();
        }
        open_music() {
            this.is_music = true;
            this.play_music(this.last_music_name);
        }
        close_music() {
            this.is_music = false;
            this.stop_music();
        }
        load(audio_name, cb) {
            if (!audio_name)
                return;
            let path = this.get_path(audio_name);
            ResourcesMgr.instance.load(path, (res) => {
                this.m_map_is_load.set(audio_name, true);
                if (cb)
                    cb(res);
            });
        }
        vibrateShort(type) {
            if (LogicShock.instance.is_open()) {
                GameSDK$1.vibrateShort(type);
            }
        }
        vibrateLong() {
            if (LogicShock.instance.is_open()) {
                GameSDK$1.vibrateLong();
            }
        }
        a() {
            Laya.SoundManager;
        }
    }
    AudioMgr.instance = new AudioMgr();

    const auto_btn_click_prefix$2 = "click_";
    const auto_btn_click_node_prefix$2 = "btn_";
    const auto_transition_prefix$2 = "trans_";
    const auto_add_member_node_prefix$2 = "c_";
    const auto_add_member_ok_node_prefix$2 = [
        "text_",
        "btn_",
        "progress_",
        "comp_",
        "list_",
        "loader_",
        "img_",
        "graph_",
        "input_",
        "group_",
    ];
    class FguiBase$2 extends fairygui.GComponent {
        constructor() {
            super(...arguments);
            this._controllerOnce = null;
        }
        static setExtension(packageName, compName, userClass) {
            fgui.UIObjectFactory.setExtension("ui://" + packageName + "/" + compName, userClass);
        }
        static button_disable(button) {
            if (button.filters && button.filters.length > 0) {
                let colorFilter = button.filters[0];
                colorFilter.gray();
            }
            button.enabled = false;
        }
        static button_enable(button) {
            if (button.filters && button.filters.length > 0) {
                let colorFilter = button.filters[0];
                colorFilter.reset();
            }
            button.enabled = true;
        }
        static get_transition(node, transName) {
            if (transName)
                return node.getTransition(transName);
            else
                return node.getTransitionAt(0);
        }
        static get_transition_all(node, transName) {
            let values = [];
            for (let value of node._transitions)
                if (value.name.indexOf(transName) == 0)
                    values.push(value);
            return values;
        }
        static find_children_transition_once(node, transName) {
            if (!(node instanceof fairygui.GComponent))
                return null;
            let res = null;
            res = node.getTransition(transName);
            if (res)
                return res;
            let _children = node._children;
            for (let value of _children) {
                if (value instanceof fairygui.GComponent) {
                    res = value.getTransition(transName);
                    if (res)
                        break;
                    res = this.find_children_transition_once(value, transName);
                    if (res)
                        break;
                }
            }
            return res;
        }
        static find_children_transition_names(node, trans_name) {
            let values = [];
            if (!(node instanceof fairygui.GComponent))
                return values;
            if (!trans_name)
                return values;
            let _children = node["_children"];
            for (let value of _children) {
                if (node instanceof fairygui.GComponent) {
                    let trans = this.get_transition_all(node, trans_name);
                    if (trans.length > 0)
                        values.push(...trans);
                    Sets.push(values, this.find_children_transition_names(value, trans_name));
                }
            }
            return values;
        }
        static find_children_names_once_node(node, name) {
            if (!(node instanceof fairygui.GComponent))
                return null;
            let _children = node._children;
            let res = null;
            for (let value of _children) {
                if (value.name == name) {
                    res = value;
                    break;
                }
                if (node instanceof fairygui.GComponent)
                    res = this.find_children_names_once_node(value, name);
                if (res)
                    break;
            }
            return res;
        }
        static find_children_names(node, names, cb) {
            let values = [];
            for (let i = 0, l = names.length; i < l; i++) {
                let value = names[i];
                let data = this.find_children_names_once_node(node, value);
                if (data) {
                    values.push(data);
                    if (cb)
                        cb(data, value, i);
                }
            }
            return values;
        }
        static find_children_names_node(node, node_name) {
            let values = [];
            if (!(node instanceof fairygui.GComponent))
                return values;
            if (!node_name)
                return values;
            let _children = node["_children"];
            for (let value of _children) {
                if (value.name == node_name) {
                    values.push(value);
                }
                if (node instanceof fairygui.GComponent)
                    Sets.push(values, this.find_children_names_node(value, node_name));
            }
            return values;
        }
        static find_children_names_node_prefix(node, prefix) {
            let values = [];
            if (!(node instanceof fairygui.GComponent))
                return values;
            let _children = node["_children"];
            for (let value of _children) {
                if (str_indexOf(value.name, prefix) == 0) {
                    values.push(value);
                }
                if (node instanceof fairygui.GComponent)
                    Sets.push(values, this.find_children_names_node_prefix(value, prefix));
            }
            return values;
        }
        static match_children_to_member(parent, caller) {
            for (let key in caller) {
                if (caller[key] != null)
                    continue;
                let member_index = str_indexOf(key, auto_add_member_node_prefix$2);
                if (member_index == 0) {
                    let last_index = str_lastIndexOf(key, auto_add_member_node_prefix$2);
                    let children_name = key.slice(last_index);
                    for (let value of auto_add_member_ok_node_prefix$2) {
                        let index = str_indexOf(children_name, value);
                        if (index != -1) {
                            let node = FguiBase$2.find_children_names_once_node(parent, children_name);
                            if (!node) ;
                            else {
                                caller[key] = node;
                            }
                            break;
                        }
                    }
                }
            }
        }
        static match_transition_prefix(node, caller) {
            for (let key in caller) {
                if (caller[key] != null)
                    continue;
                let member_index = str_indexOf(key, auto_transition_prefix$2);
                if (member_index == 0) {
                    let last_index = str_lastIndexOf(key, auto_transition_prefix$2);
                    let transition_name = key.slice(last_index);
                    let transition = this.find_children_transition_once(node, transition_name);
                    if (transition) {
                        caller[key] = transition;
                        console.log("自动添加成员动画 动画名", transition_name, "成员函数名:", key);
                    }
                }
            }
        }
        static onClick(node, cb, caller) {
            node.onClick(caller, (e) => {
                if (!FguiBase$2.enableClick) {
                    console.log("按钮事件已屏蔽");
                    return;
                }
                e.stopPropagation();
                if (FguiBase$2.clickSoundName)
                    AudioMgr.instance.play_sound(FguiBase$2.clickSoundName);
                cb.call(caller, e);
            });
        }
        static match_children_btn_event(parent, caller) {
            let btns = FguiBase$2.find_children_names_node_prefix(parent, auto_btn_click_node_prefix$2);
            for (let node of btns) {
                if (str_indexOf(node.name, auto_btn_click_node_prefix$2) == 0) {
                    let node_name = node.name.slice(str_lastIndexOf(node.name, auto_btn_click_node_prefix$2));
                    let member_name = auto_btn_click_prefix$2 + node_name;
                    if (caller[member_name] && typeof caller[member_name] == "function") {
                        this.onClick(node, caller[member_name], caller);
                    }
                }
            }
        }
        static get_controller(node, name) {
            if (name)
                return node.getController(name);
            else {
                return node.controllers[0] || null;
            }
        }
        static createPackageItem(packageName, resName, userClass) {
            return fairygui.UIPackage.createObject(packageName, resName, userClass);
        }
        static insert_child(parent, level) {
            let node_name = level.toString();
            for (let i = 0, children = parent._children, length = children.length; i < length; i++) {
                let value = children[i];
                if (value.name == node_name)
                    return value;
                if (Number(value.name) > level) {
                    let childrenParent = new fairygui.GComponent();
                    childrenParent.name = node_name;
                    childrenParent.setPivot(0, 0);
                    parent.addChildAt(childrenParent, i);
                    return childrenParent;
                }
            }
            let childrenParent = new fairygui.GComponent();
            childrenParent.name = node_name;
            childrenParent.setPivot(0, 0);
            parent.addChild(childrenParent);
            return childrenParent;
        }
        constructFromXML() {
            super.constructFromXML(undefined);
            FguiBase$2.match_children_to_member(this, this);
            FguiBase$2.match_children_btn_event(this, this);
            FguiBase$2.match_transition_prefix(this, this);
            if (this.onConstructFromXML)
                this.onConstructFromXML();
        }
        dispose() {
            Laya.timer.clearAll(this);
            if (this.onDispose)
                this.onDispose();
            this._controllerOnce = null;
            super.dispose();
        }
        get_controller(name) {
            return FguiBase$2.get_controller(this, name);
        }
        get controllerOnce() {
            if (this._controllerOnce == null)
                this._controllerOnce = this.get_controller();
            return this._controllerOnce;
        }
        get_transition(transName) {
            return FguiBase$2.get_transition(this, transName);
        }
        find_children_names_node_prefix(prefix) {
            return FguiBase$2.find_children_names_node_prefix(this, prefix);
        }
        find_children_names_node(node_name) {
            return FguiBase$2.find_children_names_node(this, node_name);
        }
        find_children_names_once_node(node_name) {
            return FguiBase$2.find_children_names_once_node(this, node_name);
        }
        find_children_names(node_names, cb) {
            return FguiBase$2.find_children_names(this, node_names, cb);
        }
    }
    FguiBase$2.enableClick = true;
    FguiBase$2.clickSoundName = 0;

    const auto_btn_click_prefix$1 = "click_";
    const auto_btn_click_node_prefix$1 = "btn_";
    const auto_transition_prefix$1 = "trans_";
    const auto_add_member_node_prefix$1 = "c_";
    const auto_add_member_ok_node_prefix$1 = [
        "text_",
        "btn_",
        "progress_",
        "comp_",
        "list_",
        "loader_",
        "img_",
        "graph_",
        "input_",
        "group_",
    ];
    class FguiBase$1 extends fairygui.GComponent {
        constructor() {
            super(...arguments);
            this._controllerOnce = null;
        }
        static setExtension(packageName, compName, userClass) {
            fgui.UIObjectFactory.setExtension("ui://" + packageName + "/" + compName, userClass);
        }
        static button_disable(button) {
            if (button.filters && button.filters.length > 0) {
                let colorFilter = button.filters[0];
                colorFilter.gray();
            }
            button.enabled = false;
        }
        static button_enable(button) {
            if (button.filters && button.filters.length > 0) {
                let colorFilter = button.filters[0];
                colorFilter.reset();
            }
            button.enabled = true;
        }
        static get_transition(node, transName) {
            if (transName)
                return node.getTransition(transName);
            else
                return node.getTransitionAt(0);
        }
        static get_transition_all(node, transName) {
            let values = [];
            for (let value of node._transitions)
                if (value.name.indexOf(transName) == 0)
                    values.push(value);
            return values;
        }
        static find_children_transition_once(node, transName) {
            if (!(node instanceof fairygui.GComponent))
                return null;
            let res = null;
            res = node.getTransition(transName);
            if (res)
                return res;
            let _children = node._children;
            for (let value of _children) {
                if (value instanceof fairygui.GComponent) {
                    res = value.getTransition(transName);
                    if (res)
                        break;
                    res = this.find_children_transition_once(value, transName);
                    if (res)
                        break;
                }
            }
            return res;
        }
        static find_children_transition_names(node, trans_name) {
            let values = [];
            if (!(node instanceof fairygui.GComponent))
                return values;
            if (!trans_name)
                return values;
            let _children = node["_children"];
            for (let value of _children) {
                if (node instanceof fairygui.GComponent) {
                    let trans = this.get_transition_all(node, trans_name);
                    if (trans.length > 0)
                        values.push(...trans);
                    Sets.push(values, this.find_children_transition_names(value, trans_name));
                }
            }
            return values;
        }
        static find_children_names_once_node(node, name) {
            if (!(node instanceof fairygui.GComponent))
                return null;
            let _children = node._children;
            let res = null;
            for (let value of _children) {
                if (value.name == name) {
                    res = value;
                    break;
                }
                if (node instanceof fairygui.GComponent)
                    res = this.find_children_names_once_node(value, name);
                if (res)
                    break;
            }
            return res;
        }
        static find_children_names(node, names, cb) {
            let values = [];
            for (let i = 0, l = names.length; i < l; i++) {
                let value = names[i];
                let data = this.find_children_names_once_node(node, value);
                if (data) {
                    values.push(data);
                    if (cb)
                        cb(data, value, i);
                }
            }
            return values;
        }
        static find_children_names_node(node, node_name) {
            let values = [];
            if (!(node instanceof fairygui.GComponent))
                return values;
            if (!node_name)
                return values;
            let _children = node["_children"];
            for (let value of _children) {
                if (value.name == node_name) {
                    values.push(value);
                }
                if (node instanceof fairygui.GComponent)
                    Sets.push(values, this.find_children_names_node(value, node_name));
            }
            return values;
        }
        static find_children_names_node_prefix(node, prefix) {
            let values = [];
            if (!(node instanceof fairygui.GComponent))
                return values;
            let _children = node["_children"];
            for (let value of _children) {
                if (str_indexOf(value.name, prefix) == 0) {
                    values.push(value);
                }
                if (node instanceof fairygui.GComponent)
                    Sets.push(values, this.find_children_names_node_prefix(value, prefix));
            }
            return values;
        }
        static match_children_to_member(parent, caller) {
            for (let key in caller) {
                if (caller[key] != null)
                    continue;
                let member_index = str_indexOf(key, auto_add_member_node_prefix$1);
                if (member_index == 0) {
                    let last_index = str_lastIndexOf(key, auto_add_member_node_prefix$1);
                    let children_name = key.slice(last_index);
                    for (let value of auto_add_member_ok_node_prefix$1) {
                        let index = str_indexOf(children_name, value);
                        if (index != -1) {
                            let node = FguiBase$1.find_children_names_once_node(parent, children_name);
                            if (!node) ;
                            else {
                                caller[key] = node;
                            }
                            break;
                        }
                    }
                }
            }
        }
        static match_transition_prefix(node, caller) {
            for (let key in caller) {
                if (caller[key] != null)
                    continue;
                let member_index = str_indexOf(key, auto_transition_prefix$1);
                if (member_index == 0) {
                    let last_index = str_lastIndexOf(key, auto_transition_prefix$1);
                    let transition_name = key.slice(last_index);
                    let transition = this.find_children_transition_once(node, transition_name);
                    if (transition) {
                        caller[key] = transition;
                        console.log("自动添加成员动画 动画名", transition_name, "成员函数名:", key);
                    }
                }
            }
        }
        static onClick(node, cb, caller) {
            node.onClick(caller, (e) => {
                if (!FguiBase$1.enableClick) {
                    console.log("按钮事件已屏蔽");
                    return;
                }
                e.stopPropagation();
                if (FguiBase$1.clickSoundName)
                    AudioMgr.instance.play_sound(FguiBase$1.clickSoundName);
                cb.call(caller, e);
            });
        }
        static match_children_btn_event(parent, caller) {
            let btns = FguiBase$1.find_children_names_node_prefix(parent, auto_btn_click_node_prefix$1);
            for (let node of btns) {
                if (str_indexOf(node.name, auto_btn_click_node_prefix$1) == 0) {
                    let node_name = node.name.slice(str_lastIndexOf(node.name, auto_btn_click_node_prefix$1));
                    let member_name = auto_btn_click_prefix$1 + node_name;
                    if (caller[member_name] && typeof caller[member_name] == "function") {
                        this.onClick(node, caller[member_name], caller);
                    }
                }
            }
        }
        static get_controller(node, name) {
            if (name)
                return node.getController(name);
            else {
                return node.controllers[0] || null;
            }
        }
        static createPackageItem(packageName, resName, userClass) {
            return fairygui.UIPackage.createObject(packageName, resName, userClass);
        }
        static insert_child(parent, level) {
            let node_name = level.toString();
            for (let i = 0, children = parent._children, length = children.length; i < length; i++) {
                let value = children[i];
                if (value.name == node_name)
                    return value;
                if (Number(value.name) > level) {
                    let childrenParent = new fairygui.GComponent();
                    childrenParent.name = node_name;
                    childrenParent.setPivot(0, 0);
                    parent.addChildAt(childrenParent, i);
                    return childrenParent;
                }
            }
            let childrenParent = new fairygui.GComponent();
            childrenParent.name = node_name;
            childrenParent.setPivot(0, 0);
            parent.addChild(childrenParent);
            return childrenParent;
        }
        constructFromXML() {
            super.constructFromXML(undefined);
            FguiBase$1.match_children_to_member(this, this);
            FguiBase$1.match_children_btn_event(this, this);
            FguiBase$1.match_transition_prefix(this, this);
            if (this.onConstructFromXML)
                this.onConstructFromXML();
        }
        dispose() {
            Laya.timer.clearAll(this);
            if (this.onDispose)
                this.onDispose();
            this._controllerOnce = null;
            super.dispose();
        }
        get_controller(name) {
            return FguiBase$1.get_controller(this, name);
        }
        get controllerOnce() {
            if (this._controllerOnce == null)
                this._controllerOnce = this.get_controller();
            return this._controllerOnce;
        }
        get_transition(transName) {
            return FguiBase$1.get_transition(this, transName);
        }
        find_children_names_node_prefix(prefix) {
            return FguiBase$1.find_children_names_node_prefix(this, prefix);
        }
        find_children_names_node(node_name) {
            return FguiBase$1.find_children_names_node(this, node_name);
        }
        find_children_names_once_node(node_name) {
            return FguiBase$1.find_children_names_once_node(this, node_name);
        }
        find_children_names(node_names, cb) {
            return FguiBase$1.find_children_names(this, node_names, cb);
        }
    }
    FguiBase$1.enableClick = true;
    FguiBase$1.clickSoundName = 0;

    var EventType;
    (function (EventType) {
        EventType["START_GAME"] = "START_GAME";
        EventType["GAME_OVER"] = "GAME_OVER";
        EventType["PROP_CHANGE"] = "PROP_CHANGE";
        EventType["UPDATE_SKIN"] = "UPDATE_SKIN";
        EventType["PLAYER_MOVE"] = "PLAYER_MOVE";
        EventType["INIT_BTN_POS"] = "INIT_BTN_POS";
        EventType["INIT_ANSWER"] = "INIT_ANSWER";
        EventType["SHOW_ANSWER"] = "SHOW_ANSWER";
        EventType["INIT_PASSLEVEL"] = "INIT_PASSLEVEL";
        EventType["NO_BIG"] = "NO_BIG";
        EventType["NO_BIGER"] = "NO_BIGER";
        EventType["MACKYES"] = "MACKYES";
        EventType["MACKFAIL"] = "MACKFAIL";
        EventType["SHOW_LREWARD"] = "SHOW_LREWARD";
        EventType["RESTART_GAME"] = "RESTART_GAME";
        EventType["SHOW_LEVEL_UP"] = "SHOW_LEVEL_UP";
        EventType["SHOW_PLAYER_SELECT"] = "SHOW_PLAYER_SELECT";
        EventType["SHOW_ANSWER_END"] = "SHOW_ANSWER_END";
        EventType["TIMER_UPDATE"] = "TIMER_UPDATE";
        EventType["SHOW_KEYANI"] = "SHOW_KEYANI";
        EventType["BOX_CLICK"] = "BOX_CLICK";
        EventType["MOVE_END"] = "MOVE_END";
        EventType["LITTLE_ENEMY_OVER"] = "LITTLE_ENEMY_OVER";
        EventType["BOOM_POS"] = "BOOM_POS";
        EventType["SHOT_Y"] = "SHOT_Y";
        EventType["LITTLE_PASS_OVER"] = "LITTLE_PASS_OVER";
        EventType["CHANGE_SKIN"] = "CHANGE_SKIN";
        EventType["ENEMY_DIE"] = "ENEMY_DIE";
        EventType["RL_START_GAME"] = "RL_START_GAME";
        EventType["STOP_GUIDE"] = "STOP_GUIDE";
        EventType["SHAK_GUN"] = "SHAK_GUN";
        EventType["HANDINMONEY"] = "HANDINMONEY";
        EventType["UPDATE_CHAOPIAO"] = "UPDATE_CHAOPIAO";
        EventType["BUCK_SOURCE"] = "BUCK_SOURCE";
        EventType["BUCK_SELL"] = "BUCK_SELL";
        EventType["UPDATE_POS"] = "UPDATE_POS";
        EventType["UPDATE_OFFER_POS"] = "UPDATE_OFFER_POS";
        EventType["UPDATE_GUIDE_COMPERA"] = "UPDATE_GUIDE_COMPERA";
        EventType["SHOW_PAIMAI"] = "SHOW_PAIMAI";
        EventType["ADDFOOD"] = "ADDFOOD";
        EventType["STOPGUIDE3"] = "STOPGUIDE3";
        EventType["HIDE_PAIMAI"] = "HIDE_PAIMAI";
        EventType["SHOOT"] = "SHOOT";
        EventType["ON_CREATE_COMP"] = "ON_CREATE_COMP";
        EventType["ONBALLBOOM"] = "ONBALLBOOM";
        EventType["ADDLEVELITEM"] = "ADDLEVELITEM";
        EventType["DOG_MOVE"] = "DOG_MOVE";
        EventType["ANIEVENT"] = "ANIEVENT";
        EventType["GESTURES"] = "GESTURES";
        EventType["UPDATE_HOME"] = "UPDATE_HOME";
        EventType["DOG_TALK"] = "DOG_TALK";
        EventType["OPEN_KIND"] = "OPEN_KIND";
        EventType["HIDE_FLAG"] = "HIDE_FLAG";
        EventType["SHOW_FLAG"] = "SHOW_FLAG";
        EventType["UP_SPRIT"] = "UP_SPRIT";
        EventType["HIDE_GROUND"] = "HIDE_GROUND";
        EventType["HIDE_THORN"] = "HIDE_THORN";
        EventType["SHOW_THORN"] = "SHOW_THORN";
        EventType["SHOW_ENEMY_ALL"] = "SHOW_ENEMY_ALL";
        EventType["ADD_ICE_VALUE"] = "ADD_ICE_VALUE";
        EventType["HIDE_BRICK"] = "HIDE_BRICK";
        EventType["BOX_OPEN_ALL"] = "BOX_OPEN_ALL";
        EventType["HUN_LUAN"] = "HUN_LUAN";
        EventType["GUIDE_FLAG"] = "GUIDE_FLAG";
        EventType["UPDATE_SOURCE"] = "UPDATE_SOURCE";
        EventType["SHOW_TEXT"] = "SHOW_TEXT";
        EventType["UPDATE_POWER"] = "UPDATE_POWER";
        EventType["GOODS_SHACK"] = "GOODS_SHACK";
        EventType["UPDATE_BATLLE"] = "UPDATE_BATLLE";
        EventType["UPDATE_BATLLE2"] = "UPDATE_BATLLE2";
        EventType["NO_CHEHUI"] = "NO_CHEHUI";
        EventType["SHOW_TEXT_GOOD"] = "SHOW_TEXT_GOOD";
        EventType["HIDE_CHEHUI"] = "HIDE_CHEHUI";
        EventType["SHOW_CHEHUI"] = "SHOW_CHEHUI";
        EventType["FOOD_POS"] = "FOOD_POS";
        EventType["ADD_POWER_LEVEL"] = "ADD_POWER_LEVEL";
        EventType["STEP_UPDATE"] = "STEP_UPDATE";
        EventType["INIT_UPLEVEL"] = "INIT_UPLEVEL";
        EventType["UPDATE_UPLEVEL"] = "UPDATE_UPLEVEL";
        EventType["UPDATE_FOODMENU"] = "UPDATE_FOODMENU";
        EventType["JIESUO_TIP1"] = "JIESUO_TIP1";
        EventType["SHIP_ENTER"] = "SHIP_ENTER";
        EventType["INIT_TRAVL"] = "INIT_TRAVL";
        EventType["INIT_BIGFISH_TIP"] = "INIT_BIGFISH_TIP";
        EventType["UPLEVE_CUR_GOLD"] = "UPLEVE_CUR_GOLD";
        EventType["INIT_VIP_SHOW"] = "INIT_VIP_SHOW";
        EventType["MONEY_DUIDUI"] = "MONEY_DUIDUI";
        EventType["TRIGGER_MONEY"] = "TRIGGER_MONEY";
        EventType["TEMP_HIDE_AD"] = "TEMP_HIDE_AD";
        EventType["RESUME_AD"] = "RESUME_AD";
    })(EventType || (EventType = {}));
    class EventMgr {
        constructor() {
            this._eventMap = [];
            this.m_events = new Map();
        }
        static get Int() {
            if (!this._Int) {
                this._Int = new EventMgr();
            }
            return this._Int;
        }
        on(name, callBack, caller) {
            if (!callBack || !caller)
                return;
            let event = this.m_events.get(name);
            if (!event) {
                event = [];
                this.m_events.set(name, event);
            }
            event.push({ callBack, caller });
        }
        emit(name, ...param) {
            let events = this.m_events.get(name);
            if (!events) {
                return;
            }
            for (let i = 0; i < events.length; i++) {
                let value = events[i];
                if (value)
                    value.callBack.call(value.caller, ...param);
            }
        }
        off(name, callBack, caller) {
            let events = this.m_events.get(name);
            if (!events)
                return;
            for (let i = 0; i < events.length; i++) {
                let value = events[i];
                if (value)
                    if (value.callBack == callBack && value.caller == caller) {
                        events.splice(i, 1);
                        return;
                    }
            }
        }
        offAll(name) {
            let events = this.m_events.get(name);
            if (!events) {
                return;
            }
            events.length = 0;
        }
    }

    class Times$1 {
        constructor(time) {
            this.time = 0;
            if (time) {
                this.time = time;
            }
            else {
                this.time = Times$1.now;
            }
        }
        static get now() {
            return new Date().getTime();
        }
        static getDate() {
            return new Date().getDate();
        }
        static console(key) {
            this._console[key] = Times$1.now;
        }
        static consoleEnd(key, ...args) {
            console.log("执行耗时 ", key, (Times$1.now - (this._console[key] || Times$1.now)) / 1000, ...args);
        }
        static get Date() {
            return new Date();
        }
        static day(time) {
            return Math.floor(this.hour(time) / 24);
        }
        static hour(time) {
            return Math.floor(this.minute(time) / 60);
        }
        static minute(time) {
            return Math.floor(this.second(time) / 60);
        }
        static second(time) {
            if (time == null || time == undefined)
                time = this.now;
            return Math.floor(time / 1000);
        }
        static numHour(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time) % 60) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            if (this.minute() >= 60) {
                res = this.converMinTen(this.hour(time)) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        static numMinute(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time)) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        static numSecond(time) {
            return this.converMinTen(this.second(time));
        }
        static chinaHour(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "秒";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time) % 60) + "分" + res;
            }
            if (this.minute() >= 60) {
                res = this.converMinTen(this.hour(time)) + "时" + res;
            }
            return res;
        }
        static chinaMinute(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "秒";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time)) + "分" + res;
            }
            return res;
        }
        static chinaSecond(time) {
            return this.converMinTen(this.second(time)) + "秒";
        }
        static converMinTen(num) {
            return num < 10 ? ("0" + num) : num.toString();
        }
        add(time) {
            this.time += time;
            return this;
        }
        sub(time) {
            this.time -= time;
            return this;
        }
        get now() { return this.time; }
        ;
        get day() {
            return Math.floor(this.hour / 24);
        }
        get hour() {
            return Math.floor(this.minute / 60);
        }
        get minute() {
            return Math.floor(this.second / 60);
        }
        ;
        get second() {
            return Math.floor(this.time / 1000);
        }
        get numHour() {
            let res;
            res = this.converMinTen(this.second % 60) + "";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute % 60) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            if (this.minute >= 60) {
                res = this.converMinTen(this.hour) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        get numMinute() {
            let res;
            res = this.converMinTen(this.second % 60) + "";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        get numSecond() {
            return this.converMinTen(this.second);
        }
        get chinaHour() {
            let res;
            res = this.converMinTen(this.second % 60) + "秒";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute % 60) + "分" + res;
            }
            if (this.minute >= 60) {
                res = this.converMinTen(this.hour) + "时" + res;
            }
            return res;
        }
        get chinaMinute() {
            let res;
            res = this.converMinTen(this.second % 60) + "秒";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute) + "分" + res;
            }
            return res;
        }
        get chinaSecond() {
            return this.converMinTen(this.second) + "秒";
        }
        converMinTen(num) {
            return num < 10 ? ("0" + num) : num.toString();
        }
        static isSameDay(t) {
            return new Date(t).toLocaleDateString() === new Date().toLocaleDateString();
        }
        static compare_time(time) {
            var today_end = this.get_endtime();
            var time_old = time;
            if (today_end == time_old) {
                return 1;
            }
            else {
                return 0;
            }
        }
        static get_endtime() {
            var time_end = new Date(new Date(new Date().toLocaleDateString()).getTime() + 24 * 60 * 60 * 1000 - 1);
            var time_format = this.format_date(time_end);
            return time_format;
        }
        static format_date(now) {
            var year = now.getFullYear();
            var month = now.getMonth() + 1;
            var day = now.getDate();
            var hh = now.getHours();
            var mm = now.getMinutes();
            var ss = now.getSeconds();
            var clock = year + "";
            if (month < 10) {
                clock += "0";
            }
            clock += month + "";
            if (day < 10) {
                clock += "0";
            }
            clock += day + "";
            if (hh < 10) {
                clock += "0";
            }
            clock += hh + "";
            if (mm < 10) {
                clock += '0';
            }
            clock += mm;
            if (ss < 10) {
                clock += '0';
            }
            clock += ss;
            return clock;
        }
    }
    Times$1._console = {};

    var E_UI_Parent$1;
    (function (E_UI_Parent) {
        E_UI_Parent[E_UI_Parent["none"] = 0] = "none";
        E_UI_Parent[E_UI_Parent["fight_ui"] = 1] = "fight_ui";
        E_UI_Parent[E_UI_Parent["fgui"] = 99] = "fgui";
        E_UI_Parent[E_UI_Parent["diamondsFly"] = 100] = "diamondsFly";
        E_UI_Parent[E_UI_Parent["tip"] = 101] = "tip";
    })(E_UI_Parent$1 || (E_UI_Parent$1 = {}));
    var E_UI_State$1;
    (function (E_UI_State) {
        E_UI_State[E_UI_State["None"] = 0] = "None";
        E_UI_State[E_UI_State["Load"] = 1] = "Load";
        E_UI_State[E_UI_State["Show"] = 2] = "Show";
        E_UI_State[E_UI_State["Hide"] = 3] = "Hide";
        E_UI_State[E_UI_State["Wait"] = 4] = "Wait";
        E_UI_State[E_UI_State["LoadError"] = 5] = "LoadError";
        E_UI_State[E_UI_State["LoadClose"] = 6] = "LoadClose";
    })(E_UI_State$1 || (E_UI_State$1 = {}));
    class UIMgr$1 {
        constructor() {
            this.loadUrl = "";
            this.m_map_ui = new Maps();
            this.openUICount = {};
            this.isLoadCommonPackage = false;
        }
        getFguiUrl() {
            let urls = [];
            for (let key in Config) {
                let value = Config[key];
                Sets.add(urls, value.loadUrl);
            }
            return urls;
        }
        openUIByCompName(compName) {
            let ui_name = Maps.filterKey(Config, (v) => v.component_name == compName);
            this.openUI(ui_name);
        }
        openUI(ui_name, openData, openCb, closeCb) {
            let path = this.getPath(ui_name);
            if (!path) {
                console.error("openUI: 检查配置", ui_name);
                return;
            }
            this.getUIData(ui_name).closeCb = closeCb;
            let ui = this.getUIData(ui_name).ui;
            if (ui) {
                this.openUIed(ui, openData, openCb);
                return;
            }
            this.getUIData(ui_name).state = E_UI_State$1.Load;
            let isShowLoad = Config[ui_name].isShowLoad;
            if (isShowLoad)
                this.openUI("UILoad");
            this.load(ui_name, () => {
                if (isShowLoad)
                    this.closeUI("UILoad");
                if (this.getUIData(ui_name).state == E_UI_State$1.None) {
                    return;
                }
                ui = this.createUI(ui_name);
                this.openUIed(ui, openData, openCb);
            });
        }
        closeUI(ui_name, destroy = false) {
            let path = this.getPath(ui_name);
            if (!path) {
                console.error("closeUI: 检查配置", ui_name);
                return;
            }
            let state = this.getUIData(ui_name).state;
            switch (state) {
                case E_UI_State$1.None:
                    break;
                case E_UI_State$1.Show:
                    let ui = this.getUIData(ui_name).ui;
                    if (!ui) {
                        return;
                    }
                    let closeCb = this.getUIData(ui_name).closeCb;
                    if (destroy) {
                        this.destroyUI(ui_name);
                        this.emimOpenByCloseCb(ui_name, closeCb);
                    }
                    else {
                        this.getUIData(ui_name).state = E_UI_State$1.Hide;
                        this.setUIActive(ui, false, true);
                        this.emimOpenByCloseCb(ui_name, closeCb);
                        this.checkWaitUI();
                    }
                    break;
                case E_UI_State$1.Load:
                    this.getUIData(ui_name).state = E_UI_State$1.LoadClose;
                    break;
                case E_UI_State$1.Wait:
                    this.getUIData(ui_name).state = E_UI_State$1.Hide;
                    break;
                case E_UI_State$1.Hide:
                    break;
            }
        }
        emimOpenByCloseCb(ui_name, cb) {
            this.getUIData(ui_name).closeCb = null;
            if (cb) {
                cb();
            }
        }
        releaseUIPackage(ui_name) {
            let config = Config[ui_name];
            fgui.UIPackage.removePackage(config.package_name);
            ResourcesMgr.instance.release(this.getPath(ui_name) + "." + fgui.UIConfig.packageFileExtension);
        }
        destroyUI(ui_name) {
            let ui = this.getUIData(ui_name).ui;
            if (!ui) {
                console.error("请配置ui:", ui_name);
                return;
            }
            this.m_map_ui.delete(ui_name);
            this.setUIActive(ui, false, true);
            ui._onDestroy();
            ui.dispose();
            this.checkWaitUI();
        }
        closeAll(destroy = false) {
            this.m_map_ui.forEach((value, key) => {
                let state = this.getUIData(key).state;
                switch (state) {
                    case E_UI_State$1.Show:
                        this.getUIData(key).state = E_UI_State$1.Hide;
                        break;
                    case E_UI_State$1.Load:
                        this.getUIData(key).state = E_UI_State$1.LoadClose;
                        break;
                    case E_UI_State$1.Wait:
                        this.getUIData(key).state = E_UI_State$1.Hide;
                        break;
                }
                let closeCb = this.getUIData(key).closeCb;
                if (destroy)
                    this.destroyUI(key);
                else
                    this.setUIActive(this.getUIData(key).ui, false, true);
                this.emimOpenByCloseCb(key, closeCb);
            });
            if (destroy) {
                this.m_map_ui.clear();
            }
        }
        getPath(ui_name) {
            if (!Config[ui_name])
                return "";
            return this.loadUrl + Config[ui_name].loadUrl + Config[ui_name].package_name;
        }
        getUIData(ui_name) {
            if (ui_name == null) {
                return;
            }
            let value = this.m_map_ui.get(ui_name);
            if (!value) {
                value = {
                    state: E_UI_State$1.None,
                    ui: null,
                    closeCb: null,
                };
                this.m_map_ui.set(ui_name, value);
            }
            return value;
        }
        setUIActive(ui, value, is_cb) {
            let state = ui.visible;
            if (value) {
                ui.visible = true;
                if (!state && is_cb)
                    ui._onOpen();
            }
            else {
                ui.visible = false;
                if (state && is_cb) {
                    ui._onClose();
                }
            }
        }
        createUI(ui_name) {
            let value = Config[ui_name];
            if (!value) {
                console.error("请配置ui:", ui_name);
                return null;
            }
            if (value.setExtension)
                for (let key in value.setExtension)
                    FguiBase$2.setExtension(value.package_name, key, value.setExtension[key]);
            let ui = fairygui.UIPackage.createObject(value.package_name, value.component_name, value.class);
            if (!ui) {
                console.error("创建ui失败:", ui_name, value);
                return null;
            }
            ui.UI_NAME = ui_name;
            ui.name = ui_name;
            this.getUIData(ui_name).ui = ui;
            ui.makeFullScreen();
            if (this.getUIData(ui_name).state != E_UI_State$1.LoadClose) {
                this.getUIData(ui_name).state = E_UI_State$1.Hide;
            }
            let ui_parent = this.getParent(E_UI_Parent$1.fgui);
            let parent = FguiBase$2.insert_child(ui_parent, ui.layer);
            parent.addChild(ui);
            ui._onCreate();
            this.setUIActive(ui, false, false);
            return ui;
        }
        getParent(type) {
            if (!fgui.GRoot.inst.displayObject.parent) {
                Laya.stage.addChild(fgui.GRoot.inst.displayObject);
            }
            return FguiBase$2.insert_child(fgui.GRoot.inst, type);
        }
        checkWaitUI() {
            let wait_ui = this.findWaitUIMaxLevel();
            if (wait_ui) {
                console.log("close_ui 派发等待ui name:", wait_ui.UI_NAME);
                this.getUIData(wait_ui.UI_NAME).state = E_UI_State$1.Show;
                this.setUIActive(wait_ui, true, true);
            }
        }
        load(ui_name, cb) {
            Times$1.console("加载ui");
            if (ui_name == "Loading") {
                let urls = [this.getPath(ui_name)];
                let preUrls = Config[ui_name].preUrls;
                if (preUrls) {
                    if (typeof preUrls == "function")
                        urls.push(...preUrls());
                    else
                        urls.push(...preUrls);
                }
                ResourcesMgr.instance.loadDir(urls, () => {
                    Times$1.consoleEnd("加载ui", ui_name);
                    if (cb)
                        cb();
                });
                return;
            }
            this.loadCommonPackage(() => {
                let urls = [this.getPath(ui_name)];
                let preUrls = Config[ui_name].preUrls;
                if (preUrls) {
                    if (typeof preUrls == "function")
                        urls.push(...preUrls());
                    else
                        urls.push(...preUrls);
                }
                ResourcesMgr.instance.loadDir(urls, () => {
                    Times$1.consoleEnd("加载ui", ui_name);
                    if (cb)
                        cb();
                });
            });
        }
        loadCommonPackage(cb) {
            if (this.isLoadCommonPackage)
                cb();
            else
                ResourcesMgr.instance.load(ConfigCommonPackageUrl, cb);
        }
        openUIed(ui, openData, openCb) {
            let state = this.getUIData(ui.UI_NAME).state;
            if (this.openUICount[ui.UI_NAME] == undefined)
                this.openUICount[ui.UI_NAME] = 0;
            this.openUICount[ui.UI_NAME]++;
            switch (state) {
                case E_UI_State$1.Wait:
                    this.getUIData(ui.UI_NAME).state = E_UI_State$1.Hide;
                    this.openUIed(ui, openData, openCb);
                    break;
                case E_UI_State$1.Show:
                    if (openCb)
                        openCb(ui);
                    break;
                case E_UI_State$1.Hide:
                    let sameUI = this.find_show_and_level_ui(ui);
                    if (sameUI) {
                        this.getUIData(sameUI).state = E_UI_State$1.Wait;
                        this.setUIActive(this.getUIData(sameUI).ui, false, true);
                    }
                    this.getUIData(ui.UI_NAME).state = E_UI_State$1.Show;
                    ui.openData = openData;
                    this.setUIActive(ui, true, true);
                    if (openCb)
                        openCb(ui);
                    break;
                case E_UI_State$1.None:
                    break;
                case E_UI_State$1.Load:
                    break;
                case E_UI_State$1.LoadClose:
                    this.getUIData(sameUI).state = E_UI_State$1.Hide;
                    break;
                case E_UI_State$1.LoadError:
                    break;
            }
        }
        find_show_and_level_ui(ui) {
            let map = this.m_map_ui.maps;
            for (let key in map) {
                if (this.getUIData(key).state == E_UI_State$1.Show) {
                    if (ui.layer == this.getUIData(key).ui.layer)
                        return key;
                }
            }
            return null;
        }
        findWaitUIMaxLevel() {
            let map = this.m_map_ui.maps;
            let maxLayer = 0;
            let ui = null;
            for (let key in map) {
                if (this.getUIData(key).state == E_UI_State$1.Wait) {
                    let other_ui = this.getUIData(key).ui;
                    if (other_ui.layer >= maxLayer) {
                        maxLayer = other_ui.layer;
                        ui = other_ui;
                    }
                }
            }
            return ui;
        }
        getWaitUIs() {
            let map = this.m_map_ui.maps;
            let ui_names = [];
            for (let key in map) {
                if (this.getUIData(key).state == E_UI_State$1.Wait)
                    ui_names.push(key);
            }
            return ui_names;
        }
        hasOnceUIShow(ui_name) {
            let map = this.m_map_ui.maps;
            for (let key in map) {
                if (ui_name != key) {
                    if (this.getUIData(key).state == E_UI_State$1.Show)
                        return false;
                }
            }
            return true;
        }
        getOpenUICount(ui_name) {
            return this.openUICount[ui_name] || 0;
        }
        iconUrl(iconName, packagename = "common") {
            return "ui://" + packagename + "/" + iconName;
        }
        exchangeBtn(btn1, btn2, force = false) {
            if ((force || Math.floor(Math.random() * 100 + 1) < (GameSDK$1.data.ExchangeBtn || 0)) && btn1.parent == btn2.parent) {
                let pos = new Laya.Point(btn1.x, btn1.y);
                btn1.setXY(btn2.x, btn2.y);
                btn2.setXY(pos.x, pos.y);
                let parent = btn1.parent;
                let index = parent.getChildIndex(btn2);
                parent._children[parent.getChildIndex(btn1)] = btn2;
                parent._children[index] = btn1;
                return true;
            }
            else {
                return false;
            }
        }
    }
    UIMgr$1.instance = new UIMgr$1();

    var EPropNameById$2;
    (function (EPropNameById) {
        EPropNameById[EPropNameById["diamonds"] = 1] = "diamonds";
        EPropNameById[EPropNameById["key"] = 2] = "key";
        EPropNameById[EPropNameById["suipian"] = 3] = "suipian";
    })(EPropNameById$2 || (EPropNameById$2 = {}));
    class LogicProp$2 {
        initData() { }
        add(id, count, isShowUI = false, mul = 1, closeCb = null) {
            let key = this.getCacheKey(id);
            let cur = this.get(id);
            let _useNumber = Maths.clampf(cur + count * mul, 0, this.config(id).MaxCount);
            if (cur != _useNumber)
                LocalCache.set(key, _useNumber);
            EventMgr.Int.emit(EventType.PROP_CHANGE, id);
            if (isShowUI) {
                UIMgr$1.instance.openUI("UIGlodAnimFly");
            }
        }
        has(id, count, isShowUI = false) {
            if (this.get(id) < count) {
                return false;
            }
            return true;
        }
        config(id) {
            return GameData.getPropItem(id);
        }
        get(id) {
            let key = this.getCacheKey(id);
            let count = this.config(id).StartCount;
            count = LocalCache.get(key, count);
            return count;
        }
        getCacheKey(type) {
            return "Prop_" + type;
        }
    }
    LogicProp$2.instance = new LogicProp$2();

    class ConfigUI$1 {
        constructor(value) {
            this.ui = null;
            this.value = null;
            this._event_refresh_gold_node = null;
            if (value)
                this.value = value;
            else
                this.value = {};
        }
        destroy() {
            this.ui = null;
            this.value = null;
            this._event_refresh_gold_node = null;
        }
        set_controller() {
            if (!this.value.open_controller_config || this.value.open_controller_config.length == 0)
                return;
            for (let value of this.value.open_controller_config) {
                let index = typeof value.index == "function" ? value.index() : value.index;
                FguiBase$1.get_controller(this.ui, value.name).selectedIndex = index;
            }
        }
        add_event(...event) {
            if (!this.value.event)
                this.value.event = [];
            this.value.event.push(...event);
        }
        auto_rigst_gold() {
            if (this.value.event_refresh_gold_node) {
                let node_name = typeof this.value.event_refresh_gold_node == "string" ? this.value.event_refresh_gold_node : this.value.event_refresh_gold_node.node_name;
                this._event_refresh_gold_node = this.ui.find_children_names_once_node(node_name);
                if (this._event_refresh_gold_node)
                    this.add_event({
                        type: EventType.PROP_CHANGE,
                        caller: this,
                        callback: this.on_event_use_gold,
                        enableCall: [EPropNameById$2.diamonds],
                    });
            }
        }
        on_event_use_gold(id) {
            if (id != EPropNameById$2["diamonds"])
                return;
            if (!this._event_refresh_gold_node)
                return;
            this._event_refresh_gold_node.text = LogicProp$2.instance.get(EPropNameById$2["diamonds"]) + "";
            if (this.value.event_refresh_gold_node && this.value.event_refresh_gold_node.cb)
                this.value.event_refresh_gold_node.cb.call(this.value.event_refresh_gold_node.caller || this.ui);
        }
        enable_refresh_event() {
            if (!this.value.event || this.value.event.length == 0)
                return;
            for (let value of this.value.event) {
                if (value.enableCall) {
                    value.callback.apply(value.caller || this.ui, value.enableCall);
                }
            }
        }
        rigst_event(is_on) {
            if (!this.value.event || this.value.event.length == 0)
                return;
            for (let value of this.value.event) {
                if (value.node) {
                    let node = typeof value.node == "function" ? value.node() : value.node;
                    if (is_on)
                        node.on(value.type, value.caller || this.ui, value.callback);
                    else
                        node.off(value.type, value.caller || this.ui, value.callback);
                }
                else {
                    if (is_on)
                        EventMgr.Int.on(value.type, value.callback, value.caller || this.ui);
                    else
                        EventMgr.Int.off(value.type, value.callback, value.caller || this.ui);
                }
            }
        }
        play_sound() {
            let sound = Config[this.ui.UI_NAME].enable_play_sound;
            if (sound != undefined)
                AudioMgr.instance.play_sound(sound);
        }
        node_delay_show() {
            if (!this.value.enable_node_delay_show || this.value.enable_node_delay_show.length == 0)
                return;
            for (let value of this.value.enable_node_delay_show) {
                let delay = typeof value.delay == "number" ? value.delay : value.delay();
                if (delay != 0) {
                    let node = this.ui.find_children_names_once_node(value.node_name);
                    if (node) {
                        console.log(this.ui.UI_NAME, " 按钮延迟显示:", value.node_name);
                        node.visible = false;
                        Laya.timer.once(delay, this.ui, () => {
                            node.visible = true;
                        });
                    }
                }
            }
        }
        get banner_state() {
            return Config[this.ui.UI_NAME].banner_state;
        }
        show_banner() {
            console.log("bannerState:", this.banner_state);
            if (this.banner_state == E_UI_Banner_Type.SHOW)
                GameSDK$1.banner.show();
            else if (this.banner_state == E_UI_Banner_Type.HIDE)
                GameSDK$1.banner.hide();
        }
        hide_banner() {
            if (this.banner_state == E_UI_Banner_Type.SHOW)
                GameSDK$1.banner.hide();
            else if (this.banner_state == E_UI_Banner_Type.HIDE)
                GameSDK$1.banner.show();
        }
    }

    class UIBase$1 extends FguiBase$2 {
        constructor() {
            super(...arguments);
            this.UI_NAME = "";
            this.ConfigUI = new ConfigUI$1({});
            this.openTrans = null;
            this.cache = {};
        }
        get fguiConfig() {
            return Config[this.UI_NAME];
        }
        _onCreate() {
            console.log(this.UI_NAME, ": _onCreate");
            this.ConfigUI.ui = this;
            this.openTrans = FguiBase$2.find_children_transition_names(this, "openPlay");
            this.ConfigUI.auto_rigst_gold();
            if (this.onMouseDown)
                this.ConfigUI.add_event({
                    type: Laya.Event.MOUSE_DOWN,
                    callback: this.onMouseDown,
                    node: this,
                });
            if (this.onMouseMove)
                this.ConfigUI.add_event({
                    type: Laya.Event.MOUSE_MOVE,
                    callback: this.onMouseMove,
                    node: this,
                });
            if (this.onMouseUp)
                this.ConfigUI.add_event({
                    type: Laya.Event.MOUSE_UP,
                    callback: this.onMouseUp,
                    node: this,
                });
            if (this.onCreate)
                this.onCreate();
        }
        _onOpen() {
            console.log(this.UI_NAME, ": _onOpen");
            this.ConfigUI.set_controller();
            this.ConfigUI.rigst_event(true);
            this.ConfigUI.play_sound();
            this.ConfigUI.node_delay_show();
            this.ConfigUI.show_banner();
            this.ConfigUI.enable_refresh_event();
            for (let value of this.openTrans)
                value.play();
            if (this.onOpen)
                this.onOpen();
            this.open_loop();
        }
        open_loop() {
            if (this.onUpdate) {
                Laya.timer.clear(this, this._onUpdate);
                Laya.timer.frameLoop(1, this, this._onUpdate);
            }
        }
        _onUpdate() {
            if (this.onUpdate)
                this.onUpdate();
        }
        _onClose() {
            console.log(this.UI_NAME, ": _onClose");
            this.ConfigUI.rigst_event(false);
            this.ConfigUI.hide_banner();
            Laya.timer.clearAll(this);
            if (this.onClose)
                this.onClose();
        }
        _onDestroy() {
            console.log(this.UI_NAME, ": _onDestroy");
            this.ConfigUI.destroy();
            Laya.timer.clearAll(this);
            if (this.onDestroy)
                this.onDestroy();
        }
        createPackageItem(resName) {
            return FguiBase$2.createPackageItem(this.fguiConfig.package_name, resName, Config[this.UI_NAME].setExtension[resName]);
        }
        setExtension(compName, userClass) {
            FguiBase$2.setExtension(this.fguiConfig.package_name, compName, userClass);
        }
        closeUI(destroy = false) {
            UIMgr$1.instance.closeUI(this.UI_NAME, destroy);
        }
        click_close() {
            this.closeUI(Config[this.UI_NAME].click_close_destroy || false);
        }
        get layer() {
            return Config[this.UI_NAME].layer;
        }
        GetGameObject(name) {
            let tmp = this.cache[name];
            if (tmp)
                return tmp;
            tmp = FguiBase$2.find_children_names_once_node(this, name);
            if (tmp)
                this.cache[name] = tmp;
            return tmp;
        }
    }

    class UILoading extends UIBase$1 {
        constructor() {
            super(...arguments);
            this.c_progress_ratio = null;
            this.c_progress_ratio1 = null;
            this.c_progress_ratio2 = null;
            this.count = 0;
            this.count2 = 0;
            this.c_progress_jiazai = null;
        }
        onOpen() {
            this.on_event_progress();
            this.controllerOnce.selectedIndex = 0;
        }
        onUpdate() {
            this.on_event_progress();
        }
        on_event_progress() {
            this.count += 1;
            this.c_progress_ratio.tweenValue(this.count, 0.1);
            if (this.count >= this.c_progress_ratio.max)
                this.count = this.c_progress_ratio.min;
            this.count2 += 5;
            this.c_progress_ratio2.tweenValue(this.count2, 0.1);
            if (this.count2 >= this.c_progress_ratio2.max)
                this.count2 = this.c_progress_ratio2.min;
        }
    }

    var ModuleType;
    (function (ModuleType) {
        ModuleType["Loading"] = "Loading";
        ModuleType["Main"] = "Main";
        ModuleType["Battle"] = "Battle";
        ModuleType["Game"] = "Game";
        ModuleType["Skin"] = "Skin";
        ModuleType["Sign"] = "Sign";
        ModuleType["Eggs"] = "Eggs";
        ModuleType["DeskTop"] = "DeskTop";
        ModuleType["FreeMoney"] = "FreeMoney";
        ModuleType["Invate"] = "Invate";
        ModuleType["ClipDoll"] = "ClipDoll";
        ModuleType["ClipDollEntry"] = "ClipDollEntry";
        ModuleType["UIFreeMap"] = "UIFreeMap";
        ModuleType["ExChangeCode"] = "ExChangeCode";
        ModuleType["UILong"] = "UILong";
        ModuleType["UIRobot"] = "UIRobot";
        ModuleType["End"] = "End";
        ModuleType["Share"] = "Share";
        ModuleType["Reward"] = "Reward";
        ModuleType["UITurntable"] = "UITurntable";
        ModuleType["UIAdExchangeMoney"] = "UIAdExchangeMoney";
        ModuleType["UIGlodAnimFly"] = "UIGlodAnimFly";
        ModuleType["UISetting"] = "UISetting";
        ModuleType["FinalTrySkin"] = "FinalTrySkin";
        ModuleType["TrySkin"] = "TrySkin";
        ModuleType["UITest"] = "UITest";
        ModuleType["UITicket"] = "UITicket";
        ModuleType["UIFloorChoose"] = "UIFloorChoose";
        ModuleType["UILoad"] = "UILoad";
        ModuleType["UIGuanZu"] = "UIGuanZu";
        ModuleType["UISouSuo"] = "UISouSuo";
        ModuleType["UIThings"] = "UIThings";
        ModuleType["UITebie"] = "UITebie";
        ModuleType["UIBoxList"] = "UIBoxList";
        ModuleType["UIQuwei"] = "UIQuwei";
        ModuleType["UIMakeGun"] = "UIMakeGun";
        ModuleType["UICoffeeShop"] = "UICoffeeShop";
        ModuleType["UIPaimai"] = "UIPaimai";
        ModuleType["UIRoom"] = "UIRoom";
        ModuleType["UICreateLevel"] = "UICreateLevel";
        ModuleType["UILevel"] = "UILevel";
        ModuleType["UITalk"] = "UITalk";
        ModuleType["UIMap"] = "UIMap";
        ModuleType["UIBreed"] = "UIBreed";
        ModuleType["UIGrow"] = "UIGrow";
        ModuleType["UITishi"] = "UITishi";
        ModuleType["UIZahuodian"] = "UIZahuodian";
        ModuleType["UIFreeVideo"] = "UIFreeVideo";
        ModuleType["UIFreeBackVideo"] = "UIFreeBackVideo";
        ModuleType["UIQiehuan"] = "UIQiehuan";
        ModuleType["UIOffline"] = "UIOffline";
    })(ModuleType || (ModuleType = {}));
    class RescoureData {
        static getPreFromPrefabs(name) {
            if (name == undefined)
                debugger;
            return RescoureData.PREFABS_SCENE + name + ".lh";
        }
        static getPreFromPrefabs1(name) {
            if (name == undefined)
                debugger;
            return RescoureData.PREFABS_SCENE1 + name + ".lh";
        }
        static getPreFromPrefabs2(name) {
            if (name == undefined)
                debugger;
            return RescoureData.PREFABS_SCENE2 + name + ".lh";
        }
        static getPreFromPrefabs3(name) {
            if (name == undefined)
                debugger;
            return RescoureData.PREFABS_SCENE3 + name + ".lh";
        }
        static getPreFromPrefabs5(name) {
            if (name == undefined)
                debugger;
            return RescoureData.PREFABS_SCENE5 + name + ".lh";
        }
        static getPreFromPlayer(name) {
            if (name == undefined)
                debugger;
            return RescoureData.PLAYER_SCENE + name + ".lh";
        }
        static getPreFromPlayer2(name) {
            if (name == undefined)
                debugger;
            return RescoureData.PLAYER_SCENE + name;
        }
        static getPic(name) {
            if (name == undefined)
                debugger;
            return RescoureData.QUESTION_PIC + name + ".jpg";
        }
        static getRandomPlayer() {
            let name = "Player0" + Math.floor(Math.random() * 9 + 1);
            return RescoureData.PLAYER_SCENE + name + ".lh";
        }
        static getWaterTextuer(name) {
            if (name == undefined)
                debugger;
            return RescoureData.WATER_PIC + name + ".png";
        }
        static getColorMat(name) {
            if (name == undefined)
                debugger;
            return RescoureData.color_url + name + ".lmat";
        }
        static getSkyMat(name) {
            if (name == undefined)
                debugger;
            return RescoureData.sky_url + name + ".lmat";
        }
        static getSkyImage(name) {
            if (name == undefined)
                debugger;
            return RescoureData.skyImage_url + name + ".png";
        }
        static getLevelJson(name) {
            if (name == undefined)
                debugger;
            return RescoureData.levelJson_url + name + ".txt";
        }
        static getNodeJson(name) {
            if (name == undefined)
                debugger;
            return RescoureData.nodeJson_url + name + ".json";
        }
        static YsceUrl(name) {
            return RescoureData.Ysce + name + ".ls";
        }
        static GetSpineUrl(name) {
            return this.spineHead + name + "/skeleton.bin";
        }
        static GetBoxTexture(name) {
            return "res/icon/icebox/" + name + ".jpg";
        }
        static GetTieTexture(name) {
            return "res/icon/tiezhi/" + name + ".png";
        }
        static GetDatasJson(name) {
            return RescoureData.DATASJSON + name + ".json";
        }
    }
    RescoureData.URL = "";
    RescoureData.MAIN_SCENE = RescoureData.URL + "unity/Conventional/Main.ls";
    RescoureData.MEMU_SCENE = RescoureData.URL + "unity/Conventional/Menu.ls";
    RescoureData.PREFABS_SCENE = RescoureData.URL + "unity/Conventional/";
    RescoureData.PREFABS_SCENE1 = RescoureData.URL + "unity1/Conventional/";
    RescoureData.PREFABS_SCENE2 = RescoureData.URL + "unity2/Conventional/";
    RescoureData.PREFABS_SCENE3 = RescoureData.URL + "unity3/Conventional/";
    RescoureData.PREFABS_SCENE5 = RescoureData.URL + "unity5/Conventional/";
    RescoureData.PLAYER_SCENE = RescoureData.URL + "unity/Conventional/";
    RescoureData.FACE_URL = RescoureData.URL + "unity/Conventional/face.lh";
    RescoureData.EFFECT_SCENE = RescoureData.URL + "unity/Conventional/";
    RescoureData.PLAYER_MODEL = RescoureData.URL + "unity/Conventional/Player.lh";
    RescoureData.WATER_PIC = "res/water/";
    RescoureData.DATASJSON = "res/datas/";
    RescoureData.color_url = RescoureData.URL + "unity/Conventional/Assets/new_game/Assets/Materials/";
    RescoureData.sky_url = RescoureData.URL + "unity/Conventional/Assets/_res/mat/cj/";
    RescoureData.skyImage_url = RescoureData.URL + "unity/Conventional/Assets/new_game/Assets/Images/";
    RescoureData.levelJson_url = "res/levels/";
    RescoureData.nodeJson_url = "res/";
    RescoureData.QUESTION_PIC = "pictures/";
    RescoureData.Ysce = RescoureData.URL + "unity1/Conventional/";
    RescoureData.spineHead = "res/spine/";
    RescoureData.uArr = ["Drawing_Room_garden", "Party_environment"];

    const auto_btn_click_prefix = "click_";
    const auto_btn_click_node_prefix = "btn_";
    const auto_transition_prefix = "trans_";
    const auto_add_member_node_prefix = "c_";
    const auto_add_member_ok_node_prefix = [
        "text_",
        "btn_",
        "progress_",
        "comp_",
        "list_",
        "loader_",
        "img_",
        "graph_",
        "input_",
        "group_",
    ];
    class FguiBase extends fairygui.GComponent {
        constructor() {
            super(...arguments);
            this._controllerOnce = null;
        }
        static setExtension(packageName, compName, userClass) {
            fgui.UIObjectFactory.setExtension("ui://" + packageName + "/" + compName, userClass);
        }
        static button_disable(button) {
            if (button.filters && button.filters.length > 0) {
                let colorFilter = button.filters[0];
                colorFilter.gray();
            }
            button.enabled = false;
        }
        static button_enable(button) {
            if (button.filters && button.filters.length > 0) {
                let colorFilter = button.filters[0];
                colorFilter.reset();
            }
            button.enabled = true;
        }
        static get_transition(node, transName) {
            if (transName)
                return node.getTransition(transName);
            else
                return node.getTransitionAt(0);
        }
        static get_transition_all(node, transName) {
            let values = [];
            for (let value of node._transitions)
                if (value.name.indexOf(transName) == 0)
                    values.push(value);
            return values;
        }
        static find_children_transition_once(node, transName) {
            if (!(node instanceof fairygui.GComponent))
                return null;
            let res = null;
            res = node.getTransition(transName);
            if (res)
                return res;
            let _children = node._children;
            for (let value of _children) {
                if (value instanceof fairygui.GComponent) {
                    res = value.getTransition(transName);
                    if (res)
                        break;
                    res = this.find_children_transition_once(value, transName);
                    if (res)
                        break;
                }
            }
            return res;
        }
        static find_children_transition_names(node, trans_name) {
            let values = [];
            if (!(node instanceof fairygui.GComponent))
                return values;
            if (!trans_name)
                return values;
            let _children = node["_children"];
            for (let value of _children) {
                if (node instanceof fairygui.GComponent) {
                    let trans = this.get_transition_all(node, trans_name);
                    if (trans.length > 0)
                        values.push(...trans);
                    Sets$1.push(values, this.find_children_transition_names(value, trans_name));
                }
            }
            return values;
        }
        static find_children_names_once_node(node, name) {
            if (!(node instanceof fairygui.GComponent))
                return null;
            let _children = node._children;
            let res = null;
            for (let value of _children) {
                if (value.name == name) {
                    res = value;
                    break;
                }
                if (node instanceof fairygui.GComponent)
                    res = this.find_children_names_once_node(value, name);
                if (res)
                    break;
            }
            return res;
        }
        static find_children_names(node, names, cb) {
            let values = [];
            for (let i = 0, l = names.length; i < l; i++) {
                let value = names[i];
                let data = this.find_children_names_once_node(node, value);
                if (data) {
                    values.push(data);
                    if (cb)
                        cb(data, value, i);
                }
            }
            return values;
        }
        static find_children_names_node(node, node_name) {
            let values = [];
            if (!(node instanceof fairygui.GComponent))
                return values;
            if (!node_name)
                return values;
            let _children = node["_children"];
            for (let value of _children) {
                if (value.name == node_name) {
                    values.push(value);
                }
                if (node instanceof fairygui.GComponent)
                    Sets$1.push(values, this.find_children_names_node(value, node_name));
            }
            return values;
        }
        static find_children_names_node_prefix(node, prefix) {
            let values = [];
            if (!(node instanceof fairygui.GComponent))
                return values;
            let _children = node["_children"];
            for (let value of _children) {
                if (str_indexOf$1(value.name, prefix) == 0) {
                    values.push(value);
                }
                if (node instanceof fairygui.GComponent)
                    Sets$1.push(values, this.find_children_names_node_prefix(value, prefix));
            }
            return values;
        }
        static match_children_to_member(parent, caller) {
            for (let key in caller) {
                if (caller[key] != null)
                    continue;
                let member_index = str_indexOf$1(key, auto_add_member_node_prefix);
                if (member_index == 0) {
                    let last_index = str_lastIndexOf$1(key, auto_add_member_node_prefix);
                    let children_name = key.slice(last_index);
                    for (let value of auto_add_member_ok_node_prefix) {
                        let index = str_indexOf$1(children_name, value);
                        if (index != -1) {
                            let node = FguiBase.find_children_names_once_node(parent, children_name);
                            if (!node) ;
                            else {
                                caller[key] = node;
                            }
                            break;
                        }
                    }
                }
            }
        }
        static match_transition_prefix(node, caller) {
            for (let key in caller) {
                if (caller[key] != null)
                    continue;
                let member_index = str_indexOf$1(key, auto_transition_prefix);
                if (member_index == 0) {
                    let last_index = str_lastIndexOf$1(key, auto_transition_prefix);
                    let transition_name = key.slice(last_index);
                    let transition = this.find_children_transition_once(node, transition_name);
                    if (transition) {
                        caller[key] = transition;
                        console.log("自动添加成员动画 动画名", transition_name, "成员函数名:", key);
                    }
                }
            }
        }
        static onClick(node, cb, caller) {
            node.onClick(caller, (e) => {
                if (!FguiBase.enableClick) {
                    console.log("按钮事件已屏蔽");
                    return;
                }
                e.stopPropagation();
                if (FguiBase.clickSoundName)
                    AudioMgr$1.instance.play_sound(FguiBase.clickSoundName);
                cb.call(caller, e);
            });
        }
        static match_children_btn_event(parent, caller) {
            let btns = FguiBase.find_children_names_node_prefix(parent, auto_btn_click_node_prefix);
            for (let node of btns) {
                if (str_indexOf$1(node.name, auto_btn_click_node_prefix) == 0) {
                    let node_name = node.name.slice(str_lastIndexOf$1(node.name, auto_btn_click_node_prefix));
                    let member_name = auto_btn_click_prefix + node_name;
                    if (caller[member_name] && typeof caller[member_name] == "function") {
                        this.onClick(node, caller[member_name], caller);
                    }
                }
            }
        }
        static get_controller(node, name) {
            if (name)
                return node.getController(name);
            else {
                return node.controllers[0] || null;
            }
        }
        static createPackageItem(packageName, resName, userClass) {
            return fairygui.UIPackage.createObject(packageName, resName, userClass);
        }
        static insert_child(parent, level) {
            let node_name = level.toString();
            for (let i = 0, children = parent._children, length = children.length; i < length; i++) {
                let value = children[i];
                if (value.name == node_name)
                    return value;
                if (Number(value.name) > level) {
                    let childrenParent = new fairygui.GComponent();
                    childrenParent.name = node_name;
                    childrenParent.setPivot(0, 0);
                    parent.addChildAt(childrenParent, i);
                    return childrenParent;
                }
            }
            let childrenParent = new fairygui.GComponent();
            childrenParent.name = node_name;
            childrenParent.setPivot(0, 0);
            parent.addChild(childrenParent);
            return childrenParent;
        }
        constructFromXML() {
            super.constructFromXML(undefined);
            FguiBase.match_children_to_member(this, this);
            FguiBase.match_children_btn_event(this, this);
            FguiBase.match_transition_prefix(this, this);
            if (this.onConstructFromXML)
                this.onConstructFromXML();
        }
        dispose() {
            Laya.timer.clearAll(this);
            if (this.onDispose)
                this.onDispose();
            this._controllerOnce = null;
            super.dispose();
        }
        get_controller(name) {
            return FguiBase.get_controller(this, name);
        }
        get controllerOnce() {
            if (this._controllerOnce == null)
                this._controllerOnce = this.get_controller();
            return this._controllerOnce;
        }
        get_transition(transName) {
            return FguiBase.get_transition(this, transName);
        }
        find_children_names_node_prefix(prefix) {
            return FguiBase.find_children_names_node_prefix(this, prefix);
        }
        find_children_names_node(node_name) {
            return FguiBase.find_children_names_node(this, node_name);
        }
        find_children_names_once_node(node_name) {
            return FguiBase.find_children_names_once_node(this, node_name);
        }
        find_children_names(node_names, cb) {
            return FguiBase.find_children_names(this, node_names, cb);
        }
    }
    FguiBase.enableClick = true;
    FguiBase.clickSoundName = 0;

    var EPropNameById$1;
    (function (EPropNameById) {
        EPropNameById[EPropNameById["diamonds"] = 1] = "diamonds";
        EPropNameById[EPropNameById["key"] = 2] = "key";
        EPropNameById[EPropNameById["suipian"] = 3] = "suipian";
    })(EPropNameById$1 || (EPropNameById$1 = {}));
    class LogicProp$1 {
        initData() { }
        add(id, count, isShowUI = false, mul = 1, closeCb = null) {
            let key = this.getCacheKey(id);
            let cur = this.get(id);
            let _useNumber = Maths$1.clampf(cur + count * mul, 0, this.config(id).MaxCount);
            if (cur != _useNumber)
                LocalCache$1.set(key, _useNumber);
            EventMgr$1.Int.emit(EventType$1.PROP_CHANGE, id);
            if (isShowUI) {
                UIMgr.instance.openUI("UIGlodAnimFly");
            }
        }
        has(id, count, isShowUI = false) {
            if (this.get(id) < count) {
                return false;
            }
            return true;
        }
        config(id) {
            return GameData.getPropItem(id);
        }
        get(id) {
            let key = this.getCacheKey(id);
            let count = this.config(id).StartCount;
            count = LocalCache$1.get(key, count);
            return count;
        }
        getCacheKey(type) {
            return "Prop_" + type;
        }
    }
    LogicProp$1.instance = new LogicProp$1();

    class ConfigUI {
        constructor(value) {
            this.ui = null;
            this.value = null;
            this._event_refresh_gold_node = null;
            if (value)
                this.value = value;
            else
                this.value = {};
        }
        destroy() {
            this.ui = null;
            this.value = null;
            this._event_refresh_gold_node = null;
        }
        set_controller() {
            if (!this.value.open_controller_config || this.value.open_controller_config.length == 0)
                return;
            for (let value of this.value.open_controller_config) {
                let index = typeof value.index == "function" ? value.index() : value.index;
                FguiBase.get_controller(this.ui, value.name).selectedIndex = index;
            }
        }
        add_event(...event) {
            if (!this.value.event)
                this.value.event = [];
            this.value.event.push(...event);
        }
        auto_rigst_gold() {
            if (this.value.event_refresh_gold_node) {
                let node_name = typeof this.value.event_refresh_gold_node == "string" ? this.value.event_refresh_gold_node : this.value.event_refresh_gold_node.node_name;
                this._event_refresh_gold_node = this.ui.find_children_names_once_node(node_name);
                if (this._event_refresh_gold_node)
                    this.add_event({
                        type: EventType$1.PROP_CHANGE,
                        caller: this,
                        callback: this.on_event_use_gold,
                        enableCall: [EPropNameById$1.diamonds],
                    });
            }
        }
        on_event_use_gold(id) {
            if (id != EPropNameById$1["diamonds"])
                return;
            if (!this._event_refresh_gold_node)
                return;
            this._event_refresh_gold_node.text = LogicProp$1.instance.get(EPropNameById$1["diamonds"]) + "";
            if (this.value.event_refresh_gold_node && this.value.event_refresh_gold_node.cb)
                this.value.event_refresh_gold_node.cb.call(this.value.event_refresh_gold_node.caller || this.ui);
        }
        enable_refresh_event() {
            if (!this.value.event || this.value.event.length == 0)
                return;
            for (let value of this.value.event) {
                if (value.enableCall) {
                    value.callback.apply(value.caller || this.ui, value.enableCall);
                }
            }
        }
        rigst_event(is_on) {
            if (!this.value.event || this.value.event.length == 0)
                return;
            for (let value of this.value.event) {
                if (value.node) {
                    let node = typeof value.node == "function" ? value.node() : value.node;
                    if (is_on)
                        node.on(value.type, value.caller || this.ui, value.callback);
                    else
                        node.off(value.type, value.caller || this.ui, value.callback);
                }
                else {
                    if (is_on)
                        EventMgr$1.Int.on(value.type, value.callback, value.caller || this.ui);
                    else
                        EventMgr$1.Int.off(value.type, value.callback, value.caller || this.ui);
                }
            }
        }
        play_sound() {
            let sound = Config[this.ui.UI_NAME].enable_play_sound;
            if (sound != undefined)
                AudioMgr$1.instance.play_sound(sound);
        }
        node_delay_show() {
            if (!this.value.enable_node_delay_show || this.value.enable_node_delay_show.length == 0)
                return;
            for (let value of this.value.enable_node_delay_show) {
                let delay = typeof value.delay == "number" ? value.delay : value.delay();
                if (delay != 0) {
                    let node = this.ui.find_children_names_once_node(value.node_name);
                    if (node) {
                        console.log(this.ui.UI_NAME, " 按钮延迟显示:", value.node_name);
                        node.visible = false;
                        Laya.timer.once(delay, this.ui, () => {
                            node.visible = true;
                        });
                    }
                }
            }
        }
        get banner_state() {
            return Config[this.ui.UI_NAME].banner_state;
        }
        show_banner() {
            console.log("bannerState:", this.banner_state);
            if (this.banner_state == E_UI_Banner_Type.SHOW)
                GameSDK$1.banner.show();
            else if (this.banner_state == E_UI_Banner_Type.HIDE)
                GameSDK$1.banner.hide();
        }
        hide_banner() {
            if (this.banner_state == E_UI_Banner_Type.SHOW)
                GameSDK$1.banner.hide();
            else if (this.banner_state == E_UI_Banner_Type.HIDE)
                GameSDK$1.banner.show();
        }
    }

    class UIBase extends FguiBase$3 {
        constructor() {
            super(...arguments);
            this.UI_NAME = "";
            this.ConfigUI = new ConfigUI({});
            this.openTrans = null;
            this.cache = {};
        }
        get fguiConfig() {
            return Config[this.UI_NAME];
        }
        _onCreate() {
            console.log(this.UI_NAME, ": _onCreate");
            this.ConfigUI.ui = this;
            this.openTrans = FguiBase$3.find_children_transition_names(this, "openPlay");
            this.ConfigUI.auto_rigst_gold();
            if (this.onMouseDown)
                this.ConfigUI.add_event({
                    type: Laya.Event.MOUSE_DOWN,
                    callback: this.onMouseDown,
                    node: this,
                });
            if (this.onMouseMove)
                this.ConfigUI.add_event({
                    type: Laya.Event.MOUSE_MOVE,
                    callback: this.onMouseMove,
                    node: this,
                });
            if (this.onMouseUp)
                this.ConfigUI.add_event({
                    type: Laya.Event.MOUSE_UP,
                    callback: this.onMouseUp,
                    node: this,
                });
            if (this.onCreate)
                this.onCreate();
        }
        _onOpen() {
            console.log(this.UI_NAME, ": _onOpen");
            this.ConfigUI.set_controller();
            this.ConfigUI.rigst_event(true);
            this.ConfigUI.play_sound();
            this.ConfigUI.node_delay_show();
            this.ConfigUI.show_banner();
            this.ConfigUI.enable_refresh_event();
            for (let value of this.openTrans)
                value.play();
            if (this.onOpen)
                this.onOpen();
            this.open_loop();
        }
        open_loop() {
            if (this.onUpdate) {
                Laya.timer.clear(this, this._onUpdate);
                Laya.timer.frameLoop(1, this, this._onUpdate);
            }
        }
        _onUpdate() {
            if (this.onUpdate)
                this.onUpdate();
        }
        _onClose() {
            console.log(this.UI_NAME, ": _onClose");
            this.ConfigUI.rigst_event(false);
            this.ConfigUI.hide_banner();
            Laya.timer.clearAll(this);
            if (this.onClose)
                this.onClose();
        }
        _onDestroy() {
            console.log(this.UI_NAME, ": _onDestroy");
            this.ConfigUI.destroy();
            Laya.timer.clearAll(this);
            if (this.onDestroy)
                this.onDestroy();
        }
        createPackageItem(resName) {
            return FguiBase$3.createPackageItem(this.fguiConfig.package_name, resName, Config[this.UI_NAME].setExtension[resName]);
        }
        setExtension(compName, userClass) {
            FguiBase$3.setExtension(this.fguiConfig.package_name, compName, userClass);
        }
        closeUI(destroy = false) {
            UIMgr.instance.closeUI(this.UI_NAME, destroy);
        }
        click_close() {
            this.closeUI(Config[this.UI_NAME].click_close_destroy || false);
        }
        get layer() {
            return Config[this.UI_NAME].layer;
        }
        GetGameObject(name) {
            let tmp = this.cache[name];
            if (tmp)
                return tmp;
            tmp = FguiBase$3.find_children_names_once_node(this, name);
            if (tmp)
                this.cache[name] = tmp;
            return tmp;
        }
    }

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    var E_CLIPDOLL_REWARD;
    (function (E_CLIPDOLL_REWARD) {
        E_CLIPDOLL_REWARD[E_CLIPDOLL_REWARD["COIN"] = 1] = "COIN";
        E_CLIPDOLL_REWARD[E_CLIPDOLL_REWARD["SKIN"] = 2] = "SKIN";
        E_CLIPDOLL_REWARD[E_CLIPDOLL_REWARD["THING"] = 3] = "THING";
    })(E_CLIPDOLL_REWARD || (E_CLIPDOLL_REWARD = {}));

    class LogicSkin {
        constructor() {
            this.unlocks_temp = [];
        }
        initData() {
            for (let key in GameData.getSkin()) {
                let skin = GameData.getSkinItem(key);
                if (skin.UnLockType.indexOf(0) >= 0) {
                    LocalCache$1.get("LogicSkin._skin" + skin.Type, key);
                    this.getSkin(skin.Id, false);
                }
            }
        }
        getSkinID(type = 1) {
            return LocalCache$1.get("LogicSkin._skin" + type, -1);
        }
        config(id) {
            return GameData.getSkinItem(id);
        }
        get unlocks() {
            return LocalCache$1.get("LogicSkin._unlocks", this.unlocks_temp);
        }
        get noUnlocks() {
            let res = [];
            for (let key in GameData.getSkin()) {
                if (!this.has(Number(key)))
                    res.push(Number(key));
            }
            return res;
        }
        getSkin(id, isShowUI = false, closeCb = null) {
            if (this.has(id))
                return;
            this.clearTry(id);
            this.unlocks.push(id);
            LocalCache$1.set("LogicSkin._unlocks", this.unlocks);
            if (isShowUI) {
                UIMgr.instance.openUI(ModuleType.Reward, { Type: E_CLIPDOLL_REWARD.SKIN, SkinId: id }, null, closeCb);
            }
            AudioMgr$1.instance.play_sound(4);
        }
        has(id) {
            return Sets$1.has(this.unlocks, id);
        }
        getSkinCache(id) {
            return LocalCache$1.get("LogicSkin.trySkin" + id, { type: 0, tryTime: Times$2.now, tryCount: 0, watchAdCount: 0, finalTryCount: 0 });
        }
        wathchAd(id) {
            let itemData = this.config(id);
            let tryData = LocalCache$1.get("LogicSkin.trySkin" + id, { type: 0, tryTime: Times$2.now, tryCount: 0, watchAdCount: 0, finalTryCount: 0 });
            tryData.watchAdCount += 1;
            let index = itemData.UnLockType.indexOf(8);
            if (index >= 0 && tryData.watchAdCount >= itemData.UnLockValue[index]) {
                this.getSkin(id, false);
                this.use(id);
                if (itemData.Type == 2) {
                    LogicData.instance.AddTiezhi(itemData.Id);
                }
            }
            index = itemData.UnLockType.indexOf(4);
            if (index >= 0 && itemData.UnLockValue[index] != 0 && tryData.watchAdCount >= itemData.UnLockValue[index]) {
                this.getSkin(id, false);
                this.use(id);
            }
            else {
                LocalCache$1.set("LogicSkin.trySkin" + id, tryData);
            }
        }
        use(id, callback = null) {
            let itemData = this.config(id);
            if (!this.has(id)) {
                let tryData = LocalCache$1.get("LogicSkin.trySkin" + id, { type: 0, tryTime: Times$2.now, tryCount: 0, watchAdCount: 0, finalTryCount: 0 });
                tryData.watchAdCount += 1;
                let index = itemData.UnLockType.indexOf(6);
                if (index >= 0 && tryData.watchAdCount >= itemData.UnLockValue[index]) {
                    this.getSkin(id, true, callback);
                    this.use(id);
                }
                else {
                    LocalCache$1.set("LogicSkin.trySkin" + id, tryData);
                    if (callback)
                        callback();
                }
            }
            else {
                LocalCache$1.set("LogicSkin._skin" + itemData.Type, id);
                if (callback)
                    callback();
            }
        }
        trySub(id) {
            return 0;
        }
        clearTry(id) {
            LocalCache$1.delete("LogicSkin.trySkin" + id);
        }
        getRandomUnlockId() {
            let skins = Sets$1.filter(this.noUnlocks, (v) => {
                let types = this.config(v).UnLockType;
                if (types.indexOf(1) >= 0)
                    return true;
                return false;
            });
            let id = Sets$1.random(skins);
            if (!id)
                return -1;
            return id;
        }
        getEndRandomUnlockId(types = 1) {
            let skins = Sets$1.filter(this.noUnlocks, (v) => {
                if (this.config(v).Id == 0 && GameSDK$1.isCurrentVersion)
                    return false;
                let type = this.config(v).UnLockType;
                if (type.indexOf(types) >= 0)
                    return true;
                return false;
            });
            let id = Sets$1.random(skins);
            if (!id)
                return -1;
            return id;
        }
        loadNode(PrefabName, callHandler = null) {
            let path = RescoureData.getPreFromPrefabs(PrefabName);
            Laya.loader.create(path, callHandler);
        }
        loadTingNode(PrefabName, callHandler = null) {
            let path = RescoureData.getPreFromPrefabs(PrefabName);
            Laya.loader.create(path, callHandler);
        }
    }
    LogicSkin.instance = new LogicSkin();

    var GoodsType;
    (function (GoodsType) {
        GoodsType[GoodsType["all"] = 0] = "all";
        GoodsType[GoodsType["food"] = 1] = "food";
        GoodsType[GoodsType["dish"] = 2] = "dish";
    })(GoodsType || (GoodsType = {}));
    class CanteenGoods extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this._goodsId = 1;
            this._goodsData = null;
            this._model = null;
            this._oPackge = null;
            this.localPos = null;
            this.localRot = null;
            this._index = 0;
            this.aimPos = null;
            this.moveSpeed = 1;
            this._np_pos = null;
            this._np_rot = null;
            this.offy = 0;
            this.isCurve = false;
            this.yoff = 0.1;
        }
        InitId(id) {
            this._goodsId = id;
        }
        get GoodsId() {
            return this._goodsId;
        }
        get MakeId() {
            return this._goodsData.MakeId;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this._goodsData = GameData.getGoodsItem(this._goodsId);
        }
        onEnable() { }
        onUpdate() {
            if (this._oPackge) {
                if (this.isCurve) {
                    this.CurveUpdate();
                }
                else {
                    let pPos = this._oPackge.Trans.position.clone();
                    let pRot;
                    if (this.localRot) {
                        pRot = this.localRot.clone();
                    }
                    else {
                        pRot = this._oPackge.Trans.rotationEuler.clone();
                    }
                    Laya.Vector3.add(pPos, this.localPos, pPos);
                    let sPos = this._transform.position.clone();
                    Laya.Vector3.lerp(sPos, pPos, (-0.03 * this._index + 1) * this.moveSpeed, pPos);
                    this._transform.position = pPos;
                    this._transform.rotationEuler = pRot;
                }
            }
            else {
                if (this._np_pos && this._np_rot) {
                    let sPos = this._transform.position.clone();
                    Laya.Vector3.lerp(sPos, this._np_pos, 0.2, sPos);
                    sPos.y += this.offy;
                    let sRot = this._transform.rotationEuler.clone();
                    Laya.Vector3.lerp(sRot, this._np_rot, 0.1, sRot);
                    this._transform.position = sPos;
                    this._transform.rotationEuler = sRot;
                }
            }
        }
        onDisable() {
            Laya.timer.clear(this, this.NoAdd);
            Laya.timer.clear(this, this.StopCurve);
            Laya.Tween.clearAll(this);
        }
        onDestroy() {
            Laya.timer.clear(this, this.NoAdd);
            Laya.timer.clear(this, this.StopCurve);
            Laya.Tween.clearAll(this);
        }
        SetPosRot(pos, rot) {
            this._np_pos = pos;
            this._np_rot = rot;
            this.offy = 1;
            Laya.Tween.to(this, { offy: 0 }, 400);
        }
        Hide() {
            this._obj.active = false;
        }
        Show() {
            this._obj.active = true;
            let pPos = this._oPackge.Trans.position.clone();
            let pRot;
            if (this.localRot) {
                pRot = this.localRot.clone();
            }
            else {
                pRot = this._oPackge.Trans.rotationEuler.clone();
            }
            Laya.Vector3.add(pPos, this.localPos, pPos);
            this._transform.position = pPos;
            this._transform.rotationEuler = pRot;
        }
        get Price() {
            return this._goodsData.Price;
        }
        get Type() {
            return this._goodsData.Type;
        }
        MoveTo(v3) {
            this._np_pos = v3;
            this._np_rot = new Laya.Vector3();
            this.offy = 0.5;
            Laya.Tween.to(this, { offy: 0 }, 200);
        }
        SetPackge(pkg, i, to = true, local = null, rot = null) {
            this._oPackge = pkg;
            this._index = i;
            if (this._oPackge == null)
                return;
            if (local) {
                this.localPos = local.clone();
                this.localRot = rot.clone();
            }
            else {
                this.localRot = null;
                if (pkg.XYX == 0) {
                    this.localPos = new Laya.Vector3(-i * 0.2, 0, 0);
                }
                else if (pkg.XYX == 1) {
                    this.localPos = new Laya.Vector3(0, i * 0.2, 0);
                }
                else {
                    this.localPos = new Laya.Vector3(i * 0.2, 0, 0);
                }
            }
            if (to) {
                let pPos = this._oPackge.Trans.position.clone();
                let pRot;
                if (this.localRot) {
                    pRot = this.localRot.clone();
                }
                else {
                    pRot = this._oPackge.Trans.rotationEuler.clone();
                }
                Laya.Vector3.add(pPos, this.localPos, pPos);
                this._transform.position = pPos;
                this._transform.rotationEuler = pRot;
            }
        }
        OnAdd(to = true) {
            this.moveSpeed = 0.01;
            Laya.timer.clear(this, this.NoAdd);
            Laya.timer.once(200, this, this.NoAdd);
            if (!to) {
                this.CurveTo();
            }
        }
        NoAdd() {
            this.moveSpeed = 1;
        }
        CurveTo() {
            this.isCurve = true;
            this.yoff = 1;
            Laya.Tween.to(this, { yoff: 0 }, 400, null, Laya.Handler.create(this, this.StopCurve));
            Laya.timer.once(800, this, this.StopCurve);
        }
        CurveUpdate() {
            let pPos = this._oPackge.Trans.position.clone();
            Laya.Vector3.add(pPos, this.localPos, pPos);
            let sPos = this._transform.position.clone();
            Laya.Vector3.lerp(sPos, pPos, 0.08, pPos);
            pPos.y += this.yoff;
            this._transform.position = pPos;
            let sRot = this._transform.rotationEuler.clone();
            let rot = this._oPackge.Trans.rotationEuler.clone();
            Laya.Vector3.lerp(sRot, rot, 0.1, sRot);
            this._transform.rotationEuler = sRot;
        }
        StopCurve() {
            this.isCurve = false;
        }
        Des() {
            if (this._obj) {
                this._obj.destroy();
                this._obj = null;
            }
        }
        get Pos() {
            if (!this._transform)
                return new Laya.Vector3();
            return this._transform.position.clone();
        }
    }

    class GoodsMgr {
        constructor() {
            this._goodsArr = [];
            this.GoodsNode = null;
        }
        static get Int() {
            if (!this._Int) {
                this._Int = new GoodsMgr();
            }
            return this._Int;
        }
        Init() {
            this.GoodsNode = CanteenMgr.Int.scene.getChildByName("GoodsNode");
        }
        AddGoods(id, pos = null) {
            let data = GameData.getGoodsItem(id);
            let sp;
            if (data.StageId == 1) {
                sp = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs(data.PrefabName)).clone();
            }
            else {
                sp = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs5(data.PrefabName)).clone();
            }
            if (pos) {
                sp.transform.position = pos.clone();
            }
            let scr = sp.addComponent(CanteenGoods);
            scr.InitId(id);
            this._goodsArr.push(scr);
            this.GoodsNode.addChild(sp);
            return scr;
        }
        SubGoods(scr) {
            let i = this._goodsArr.indexOf(scr);
            this._goodsArr.splice(i, 1);
            scr.destroy();
        }
        ClearAll() {
            let array = this._goodsArr;
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                element.Des();
            }
            this._goodsArr = [];
        }
    }

    class StopCar extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.obj = null;
            this.modelName = "pinhengce";
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this.obj = this._obj.getChildAt(0);
        }
        onUpdate() {
            if (this._transform) {
                this.obj.transform.localRotationEulerY += 0.5;
            }
        }
        SetCarActive(b) {
            this.obj.active = b;
        }
        SetStopActive(b) {
            this._obj.active = b;
        }
        get Pos() {
            return this._transform.position.clone();
        }
        get IsShow() {
            return this._obj.active == true;
        }
        LoadModel() {
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(this.modelName), (res) => {
                this.AddModel(res);
            });
        }
        AddModel(res) {
            let sp = res.clone();
            this._obj.getChildAt(0).addChild(sp);
            sp.transform.localPosition = new Laya.Vector3();
            sp.transform.localRotationEuler = new Laya.Vector3();
        }
    }

    var ReportType;
    (function (ReportType) {
        ReportType["LOADING_START"] = "\u52A0\u8F7D\u5F00\u59CB";
        ReportType["LOADING_END"] = "\u52A0\u8F7D\u7ED3\u675F";
        ReportType["CLOSE_ALERT"] = "\u5173\u95ED\u5BF9\u8BDD\u6846";
        ReportType["FIRST_TOUCH"] = "\u9996\u6B21\u70B9\u51FB";
        ReportType["FIRST_MOVE"] = "\u89D2\u8272\u9996\u6B21\u79FB\u52A8";
        ReportType["GET_BIKE"] = "\u6C38\u4E45\u89E3\u9501\u5E73\u8861\u8F66";
        ReportType["FIRST_FISHING"] = "\u9996\u6B21\u9493\u9C7C";
        ReportType["FIRST_GETFISH"] = "\u9996\u6B21\u62FF\u8D77\u9C7C";
        ReportType["FIRST_PUTFISH"] = "\u9996\u6B21\u5C06\u9C7C\u653E\u5230\u5427\u53F0";
        ReportType["FIRST_COOK"] = "\u9996\u6B21\u70F9\u996A";
        ReportType["FIRST_GOGETMONEY"] = "\u9996\u6B21\u7ED3\u8D26";
        ReportType["FIRST_GETMONEY"] = "\u9996\u6B21\u83B7\u53D6\u6536\u94F6\u53F0\u91D1\u94B1";
        ReportType["FIRST_GETDISH"] = "\u9996\u6B21\u6536\u53D6\u9910\u76D8";
        ReportType["FIRST_USEWASHMC"] = "\u9996\u6B21\u4F7F\u7528\u6D17\u7897\u673A";
    })(ReportType || (ReportType = {}));

    class ReportMgr {
        constructor() {
            this._reportNoSave = [];
            this._reportNoSuf = [ReportType.LOADING_START, ReportType.LOADING_END];
        }
        static get inst() {
            if (!!!this._inst) {
                this._inst = new ReportMgr();
            }
            return this._inst;
        }
        sendReport(type, addSuf = true, args) {
            let copy = type;
            try {
                if (addSuf) {
                    if (this._reportNoSave.indexOf(type) < 0) {
                        if (this._hasLocal(type)) {
                            return;
                        }
                        else {
                            this._addLocal(type);
                        }
                    }
                }
                if (GameSDK$1.isNewPlayer) {
                    type = "新用户-" + type;
                }
                else {
                    type = "老用户-" + type;
                }
                type = this._getVersionStr(GameSDK$1.sdk.version) + "-" + type;
                GameSDK$1.sdk.sendEvent(type + (!!args ? JSON.stringify(args) : ""));
            }
            catch (e) {
                GameSDK$1.sdk.sendEvent("上报事件失败-" + copy + (!!e ? ("-" + JSON.stringify(e)) : ""));
            }
        }
        get _local() {
            return LocalCache$1.get("LogickData._reportGuide", "");
        }
        _hasLocal(report) {
            return this._local.indexOf(report) >= 0;
        }
        _addLocal(report) {
            let str = this._local + report + ",";
            LocalCache$1.set("LogickData._reportGuide", str);
        }
        _getVersionStr(version) {
            if (!!!version) {
                version = "";
            }
            return version.replace(/\./g, "");
        }
        getNextIdByWorkType(type) {
            let id = LocalCache$1.get("解锁类型_1_" + type, 0);
            id++;
            LocalCache$1.set("解锁类型_1_" + type, id);
            return id;
        }
        getNextIdByUpType(type) {
            let id = LocalCache$1.get("解锁类型_2_" + type, 0);
            id++;
            LocalCache$1.set("解锁类型_2_" + type, id);
            return id;
        }
        getNextIdByBuild(type) {
            let id = LocalCache$1.get("解锁类型_3_" + type, 0);
            id++;
            LocalCache$1.set("解锁类型_3_" + type, id);
            return id;
        }
    }

    class MyInstrument extends Laya.Script {
        constructor() {
            super();
            if (MyInstrument.instance == null) {
                MyInstrument.instance = this;
            }
        }
        static get Inst() {
            return MyInstrument.instance || new MyInstrument();
        }
        static Lerp(a, b, t) {
            return a + (b - a) * this.Clamp01(t);
        }
        static Clamp01(value) {
            if (value < 0) {
                return 0;
            }
            if (value > 1) {
                return 1;
            }
            return value;
        }
        randomExt(a, min, max) {
            var b = Math.floor(Math.random() * (max - min + 1));
            if (b != a) {
                return b;
            }
            else {
                this.randomExt(a, min, max);
            }
        }
        static getTheAngle(a, b) {
            Laya.Vector2.normalize(a, a);
            Laya.Vector2.normalize(b, b);
            var c = Laya.Vector2.dot(a, b);
            var zou = a.x * b.y - a.y * b.x;
            if (zou <= 0) {
                var d = (Math.acos(c) * 180) / Math.PI;
            }
            else {
                var d = (Math.acos(c) * 180) / Math.PI;
                d = -d;
            }
            return d;
        }
        static getFanShe(i, n) {
            let r = new Laya.Vector3();
            let use_i = i.clone();
            let use_n = n.clone();
            Laya.Vector3.normalize(use_i, use_i);
            Laya.Vector3.normalize(use_n, use_n);
            let nubsc = 2 * Laya.Vector3.dot(use_i, use_n);
            Laya.Vector3.scale(use_n, nubsc, use_n);
            Laya.Vector3.subtract(use_i, use_n, r);
            Laya.Vector3.normalize(r, r);
            return r;
        }
        static glrot(angle, old, x, y, z) {
            let c = Math.cos((angle / 180) * Math.PI);
            let s = Math.sin((angle / 180) * Math.PI);
            let new_x = (x * x * (1 - c) + c) * old.x + (x * y * (1 - c) - z * s) * old.y + (x * z * (1 - c) + y * s) * old.z;
            let new_y = (y * x * (1 - c) + z * s) * old.x + (y * y * (1 - c) + c) * old.y + (y * z * (1 - c) - x * s) * old.z;
            let new_z = (x * z * (1 - c) - y * s) * old.x + (y * z * (1 - c) + x * s) * old.y + (z * z * (1 - c) + c) * old.z;
            return new Laya.Vector3(new_x, new_y, new_z);
        }
        static WorldToLocal(sp, v3) {
            let pos2local = new Laya.Vector3(0, 0, 0);
            let m = new Laya.Matrix4x4();
            sp.transform.worldMatrix.invert(m);
            Laya.Vector3.transformCoordinate(v3, m, pos2local);
            return pos2local;
        }
        static GetChildByName(obj, name) {
            if (obj == null)
                return null;
            if (obj.name == name) {
                return obj;
            }
            let length = obj.numChildren;
            for (let i = 0; i < length; i++) {
                let c_obj = obj.getChildAt(i);
                let tc_cld = this.GetChildByName(c_obj, name);
                if (tc_cld != null)
                    return tc_cld;
            }
            return null;
        }
        static ChangeMesh(obj, obj2) {
            if (!obj.meshFilter)
                return;
            if (!obj2.meshFilter)
                return;
            obj.meshFilter.sharedMesh = obj2.meshFilter.sharedMesh;
        }
        static createTriangle(long = 1, height = 1, width = 1) {
            long === void 0 && (long = 1);
            height === void 0 && (height = 1);
            width === void 0 && (width = 1);
            var vertexDeclaration = Laya.VertexMesh.getVertexDeclaration("POSITION,NORMAL,UV");
            var halfLong = long / 2;
            var halfHeight = height / 2;
            var halfWidth = width / 2;
            var vertices = new Float32Array([
                -halfLong,
                halfHeight,
                -halfWidth,
                0,
                1,
                0,
                0,
                0,
                halfLong,
                halfHeight,
                -halfWidth,
                0,
                1,
                0,
                1,
                0,
                halfLong,
                halfHeight,
                halfWidth,
                0,
                1,
                0,
                1,
                1,
                -halfLong,
                -halfHeight,
                -halfWidth,
                0,
                -1,
                0,
                0,
                0,
                halfLong,
                -halfHeight,
                -halfWidth,
                0,
                -1,
                0,
                -1,
                0,
                halfLong,
                -halfHeight,
                halfWidth,
                0,
                -1,
                0,
                -1,
                -1,
                -halfLong,
                halfHeight,
                -halfWidth,
                0,
                -1,
                0,
                0,
                0,
                halfLong,
                halfHeight,
                -halfWidth,
                0,
                -1,
                0,
                -1,
                0,
                halfLong,
                -halfHeight,
                -halfWidth,
                0,
                -1,
                0,
                0,
                -1,
                -halfLong,
                -halfHeight,
                -halfWidth,
                0,
                -1,
                0,
                -1,
                -1,
                halfLong,
                halfHeight,
                -halfWidth,
                0,
                1,
                0,
                0,
                0,
                halfLong,
                halfHeight,
                halfWidth,
                0,
                1,
                0,
                1,
                0,
                halfLong,
                -halfHeight,
                -halfWidth,
                0,
                1,
                0,
                0,
                1,
                halfLong,
                -halfHeight,
                halfWidth,
                0,
                1,
                0,
                1,
                1,
                -halfLong,
                halfHeight,
                -halfWidth,
                0,
                1,
                0,
                0,
                0,
                halfLong,
                halfHeight,
                halfWidth,
                0,
                1,
                0,
                0,
                0,
                halfLong,
                -halfHeight,
                halfWidth,
                0,
                1,
                0,
                0,
                1,
                -halfLong,
                -halfHeight,
                -halfWidth,
                0,
                1,
                0,
                1,
                1,
            ]);
            var indices = new Uint16Array([
                0, 1, 2, 5, 4, 3, 6, 9, 8, 8, 7, 6, 11, 10, 12, 12, 13, 11, 14, 15, 16, 16, 17, 14,
            ]);
            return Laya.PrimitiveMesh._createMesh(vertexDeclaration, vertices, indices);
        }
        static changeColor(msp, col) {
            let mat = msp.meshRenderer.material;
            switch (col) {
                case "red":
                    mat.albedoColor.setValue(0.9, 0, 0, 1);
                    break;
            }
        }
        static RGBToHSV(R, G, B) {
            let max = Math.max(R, G, B);
            let min = Math.min(R, G, B);
            let c = max - min;
            let H;
            switch (c) {
                case 0:
                    H = 0;
                    break;
                case R:
                    H = 60 * (((G - B) / c) % 6);
                    break;
                case G:
                    H = 60 * ((B - R) / c + 2);
                    break;
                case B:
                    H = 60 * ((R - G) / c + 4);
                    break;
            }
            let S;
            if (max == 0) {
                S = 0;
            }
            else {
                S = c / max;
            }
            let V = max;
            return new Laya.Vector3(H, S, V);
        }
        static CompareRGB1(rgb1, rgb2) {
            let hsv1 = MyInstrument.RGBToHSV(rgb1.x, rgb1.y, rgb1.z);
            let hsv2 = MyInstrument.RGBToHSV(rgb2.x, rgb2.y, rgb2.z);
            let x1 = MyInstrument.r * hsv1.z * hsv1.y * Math.cos((hsv1.x / 180) * Math.PI);
            let y1 = MyInstrument.r * hsv1.z * hsv1.y * Math.sin((hsv1.x / 180) * Math.PI);
            let z1 = MyInstrument.h * (1 - hsv1.z);
            let x2 = MyInstrument.r * hsv2.z * hsv2.y * Math.cos((hsv2.x / 180) * Math.PI);
            let y2 = MyInstrument.r * hsv2.z * hsv2.y * Math.sin((hsv2.x / 180) * Math.PI);
            let z2 = MyInstrument.h * (1 - hsv2.z);
            let dx = x1 - x2;
            let dy = y1 - y2;
            let dz = z1 - z2;
            let cnum = Math.sqrt(dx * dx + dy * dy + dz * dz);
            let tnum = (87 - cnum) / 87;
            return tnum;
        }
        static CompareRGB2(rgb1, rgb2) {
            let rmean = (rgb1.x + rgb2.x) / 2;
            let R = rgb1.x - rgb2.x;
            let G = rgb1.y - rgb2.y;
            let B = rgb1.z - rgb2.z;
            let cnum = Math.sqrt((2 + rmean / 256) * (R * R) + 4 * (G * G) + (2 + (255 - rmean) / 256) * (B * B));
            cnum = (764.8339663572415 - cnum) / 764.8339663572415;
            return cnum;
        }
        static CompareRGB3(rgb1, rgb2) {
            let rmean = (rgb1.x + rgb2.x) / 2;
            let R = rgb1.x - rgb2.x;
            let G = rgb1.y - rgb2.y;
            let B = rgb1.z - rgb2.z;
            return Math.sqrt((2 + rmean / 256) * Math.pow(R, 2) + 4 * Math.pow(G, 2) + (2 + (255 - rmean) / 256) * Math.pow(B, 2));
        }
        static drawScreenshot() {
            if (!this.tempTexture2D) {
                this.tempTexture2D = new Laya.Texture2D(Laya.Browser.width, Laya.Browser.height);
            }
            if (!this.tempTexture) {
                this.tempTexture = new Laya.Texture(this.tempTexture2D);
            }
            let cans = document.getElementById("layaCanvas");
            Laya.timer.frameOnce(1, this, () => {
                this.tempTexture2D.loadImageSource(cans, true);
            });
            return this.tempTexture;
        }
        static getScreenTexture() {
            try {
                undefined;
                let _texture = null;
                let gl = Laya.WebGLContext.mainContext;
                let pixels = new Uint8Array(gl.drawingBufferWidth * gl.drawingBufferHeight * 4);
                gl.readPixels(0, 0, gl.drawingBufferWidth, gl.drawingBufferHeight, gl.RGBA, gl.UNSIGNED_BYTE, pixels);
                let w = gl.drawingBufferWidth;
                let h = gl.drawingBufferHeight;
                let texture2d = new Laya.Texture2D(w, h, Laya.TextureFormat.R8G8B8A8, false, false);
                texture2d.setPixels(pixels);
                _texture = new Laya.Texture(texture2d);
                _texture = Laya.stage.drawToTexture(Laya.stage.width, Laya.stage.height, 0, 0);
                return _texture;
            }
            catch (error) {
            }
            return null;
        }
    }
    MyInstrument.instance = null;
    MyInstrument.ToolTipTimeNum = 0;
    MyInstrument.h = 100 * Math.cos((30 / 180) * Math.PI);
    MyInstrument.r = 100 * Math.sin((30 / 180) * Math.PI);

    class AimPathMover extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this._speed = 0.05;
            this._aimArr = null;
            this._aimPos = null;
            this._index = 0;
            this._isAt = false;
            this._atHandler = null;
            this.t = 0;
            this.v3_up = new Laya.Vector3(0, 1, 0);
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
        }
        get IsAt() {
            return this._isAt;
        }
        SetPath(arr) {
            this._aimArr = arr;
            this.StartPath();
        }
        StartPath() {
            this._index = 0;
            this._aimPos = this._aimArr[this._index];
            this._isAt = false;
        }
        ArrivePos() {
            if (this._index < this._aimArr.length - 1) {
                this._index += 1;
                this._aimPos = this._aimArr[this._index];
                return;
            }
            this._isAt = true;
            this._aimArr = [];
            this._aimPos = null;
            if (this._atHandler) {
                this._atHandler.run();
                this._atHandler = null;
            }
        }
        SetHandler(hd) {
            this._atHandler = hd;
        }
        onLateUpdate() {
            if (Laya.timer.delta > 1000)
                return;
            this.t += Laya.timer.delta / 1000;
            while (this.t > 1 / 60) {
                this.t -= 1 / 60;
                this.onFixUpdate();
            }
        }
        onFixUpdate() {
            if (!this._aimPos)
                return;
            if (this._isAt)
                return;
            let tPos = this._transform.position.clone();
            let disSquared = Laya.Vector3.distanceSquared(this._aimPos, tPos);
            if (disSquared <= 0.004) {
                this.ArrivePos();
                return;
            }
            let v3 = new Laya.Vector3();
            Laya.Vector3.subtract(this._aimPos, tPos, v3);
            Laya.Vector3.normalize(v3, v3);
            Laya.Vector3.scale(v3, this._speed, v3);
            this._transform.translate(v3, false);
            this._obj.transform.lookAt(this._aimPos, this.v3_up, false);
            this._obj.transform.localRotationEulerY += 180;
        }
    }

    const PF = window["PF"];
    const MAPRATE = 1;
    class PathFindMgr {
        constructor() {
            this.minx = 0;
            this.miny = 0;
            this.grid = null;
            this.finder = null;
            this.initcomplete = false;
        }
        static get Int() {
            if (!this._Int) {
                this._Int = new PathFindMgr();
            }
            return this._Int;
        }
        drawPath(path) {
            return;
        }
        pos2mappos(pos) {
            return new Laya.Vector3(-Math.round(pos.x / MAPRATE), 0, Math.round(pos.z / MAPRATE));
        }
        mappos2pos(pos) {
            return new Laya.Vector3(-(pos[0] + this.minx) * MAPRATE - MAPRATE / 2, 0, (pos[1] + this.miny) * MAPRATE);
        }
        isSamePlace(start_world_position, end_world_position) {
            let map_pos1 = this.pos2mappos(start_world_position);
            let map_pos2 = this.pos2mappos(end_world_position);
            let p1 = [map_pos1.x - this.minx, map_pos1.z - this.miny];
            let p2 = [map_pos2.x - this.minx, map_pos2.z - this.miny];
            if (p1[0] == p2[0] && p1[1] == p2[1]) {
                return true;
            }
            return false;
        }
        findPath(start_world_position, end_world_position) {
            if (!this.finder) {
                this.finder = new PF.JumpPointFinder({});
            }
            let map_pos1 = this.pos2mappos(start_world_position);
            let map_pos2 = this.pos2mappos(end_world_position);
            let p1 = [map_pos1.x - this.minx, map_pos1.z - this.miny];
            let p2 = [map_pos2.x - this.minx, map_pos2.z - this.miny];
            if (p1[0] == p2[0] && p1[1] == p2[1]) {
                console.log("起点就是终点");
                return [];
            }
            this.grid.setWalkableAt(p2[0], p2[1], true);
            var path = this.finder.findPath(p1[0], p1[1], p2[0], p2[1], this.grid.clone());
            path = PF.Util.compressPath(path);
            var outpath = [];
            path.forEach((element) => {
                outpath.push(this.mappos2pos(element));
            });
            return outpath;
        }
        loadMap(scene, callback) {
            CanteenMgr.Int.scene.getChildByName("ttt");
            console.log("SCene --- ", scene);
            let ret = scene;
            var mapstr = ret.matrix;
            this.minx = parseInt(ret.minx);
            this.miny = parseInt(ret.miny);
            var matrix = [];
            var arr = mapstr.split("\n");
            arr.map(str => {
                var tmp = [];
                for (var i = 0; i < str.length; ++i) {
                    tmp.push(str[i] == "0" ? 1 : 0);
                }
                matrix.push(tmp);
            });
            var height = matrix.length;
            var width = matrix[0].length;
            this.grid = new PF.Grid(width, height, matrix);
            this.initcomplete = true;
            callback && callback();
        }
    }

    class FollowScript extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this._aim = null;
            this._isOpenFollow = false;
            this._localPos = null;
            this._speed = 0.9;
            this._lookSprite = null;
            this._isInter = true;
            this._isAimLocal = false;
            this._isRot = false;
            this.lockSub = false;
            this.aimDotArr = [];
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
        }
        onLateUpdate() {
            if (this._isOpenFollow && this._aim) {
                if (this.aimDotArr.length > 0) {
                    this.AimDotUpdate();
                }
                else {
                    this._transPos();
                }
            }
        }
        setAim(aim, localP = null, must = false) {
            !this._obj && (this._obj = this.owner);
            this._aim = aim;
            if (localP == null) {
                this._localPos = this._obj.transform.localPosition.clone();
            }
            else {
                this._localPos = localP;
            }
            this._isOpenFollow = true;
            if (must) {
                let aimPos = this._aim.transform.position.clone();
                let endPos = new Laya.Vector3();
                Laya.Vector3.add(aimPos, this._localPos, endPos);
                this._obj.transform.position = endPos;
            }
        }
        set localPos(value) {
            this._localPos = value;
        }
        get localPos() {
            return this._localPos;
        }
        set followOpen(value) {
            this._isOpenFollow = value;
        }
        get followOpen() {
            return this._isOpenFollow;
        }
        _transPos() {
            if (this._isAimLocal) {
                this.isLocal();
            }
            else {
                this.notLocal();
            }
        }
        notLocal() {
            let aimPos = this._aim.transform.position.clone();
            let endPos = new Laya.Vector3();
            Laya.Vector3.add(aimPos, this._localPos, endPos);
            if (!this._isInter) {
                this._obj.transform.position = endPos;
                return;
            }
            let starPos = this._obj.transform.position.clone();
            Laya.Vector3.lerp(starPos, endPos, 0.08, endPos);
            this._obj.transform.position = endPos;
        }
        isLocal() {
            let trans = this._aim.transform;
            let aimPos = trans.position.clone();
            let endPos = new Laya.Vector3();
            let forward = new Laya.Vector3();
            let right = new Laya.Vector3();
            let up = new Laya.Vector3();
            trans.getForward(forward);
            trans.getRight(right);
            trans.getUp(up);
            forward.x *= this.localPos.z;
            forward.y *= this.localPos.z;
            forward.z *= this.localPos.z;
            right.x *= this.localPos.x;
            right.y *= this.localPos.x;
            right.z *= this.localPos.x;
            up.x *= this.localPos.y;
            up.y *= this.localPos.y;
            up.z *= this.localPos.y;
            let rlLocalPos = new Laya.Vector3();
            rlLocalPos.x = forward.x + right.x + up.x;
            rlLocalPos.y = forward.y + right.y + up.y;
            rlLocalPos.z = forward.z + right.z + up.z;
            Laya.Vector3.add(aimPos, rlLocalPos, endPos);
            if (!this._isInter) {
                this._obj.transform.position = endPos;
                return;
            }
            let starPos = this._obj.transform.position.clone();
            Laya.Vector3.lerp(starPos, endPos, 0.08, endPos);
            this._obj.transform.position = endPos;
            this._isRot && this.updateRot(trans.rotationEuler.clone());
            this._lookSprite &&
                this._lookSprite.transform.lookAt(this._aim.transform.position, new Laya.Vector3(0, 1, 0), false);
        }
        updateRot(v3) {
            this._obj.transform.rotationEuler = v3;
        }
        StartDot(arr) {
            this.aimDotArr = this.aimDotArr.concat(arr);
        }
        SubDot() {
            this.lockSub = false;
            this.aimDotArr.splice(0, 1);
            if (this.aimDotArr.length == 0) {
                this.StopDot();
            }
        }
        StopDot() {
            this.aimDotArr = [];
        }
        AimDotUpdate() {
            let aimPos = this.aimDotArr[0];
            let starPos = this._transform.position.clone();
            let lerp = new Laya.Vector3();
            Laya.Vector3.lerp(starPos, aimPos, 0.05, lerp);
            this._transform.position = lerp;
            if (!this.lockSub) {
                let distq = Laya.Vector3.distanceSquared(aimPos, lerp);
                if (distq < 0.1) {
                    this.lockSub = true;
                    Laya.timer.once(1200, this, this.SubDot);
                }
            }
        }
    }

    var GuideType;
    (function (GuideType) {
        GuideType[GuideType["T_CameraMove"] = 0] = "T_CameraMove";
        GuideType[GuideType["T_Wait"] = 1] = "T_Wait";
        GuideType[GuideType["T_GuideArrow_Seat"] = 2] = "T_GuideArrow_Seat";
        GuideType[GuideType["T_GuideArrow_Seat_Counter"] = 3] = "T_GuideArrow_Seat_Counter";
        GuideType[GuideType["T_GuideArrow_StackPull"] = 4] = "T_GuideArrow_StackPull";
        GuideType[GuideType["T_GuideArrow_StackPull_Fishing"] = 5] = "T_GuideArrow_StackPull_Fishing";
        GuideType[GuideType["T_GuideArrow_StackPullSushibar"] = 6] = "T_GuideArrow_StackPullSushibar";
        GuideType[GuideType["T_GuideArrow_StackPush"] = 7] = "T_GuideArrow_StackPush";
        GuideType[GuideType["T_GuideArrow_PayToOpen"] = 8] = "T_GuideArrow_PayToOpen";
        GuideType[GuideType["T_StackCheck"] = 9] = "T_StackCheck";
        GuideType[GuideType["T_CookComplete"] = 10] = "T_CookComplete";
        GuideType[GuideType["T_OpenSushibar"] = 11] = "T_OpenSushibar";
        GuideType[GuideType["T_OpenTravel"] = 12] = "T_OpenTravel";
        GuideType[GuideType["T_CameraMoveEnterNpc"] = 13] = "T_CameraMoveEnterNpc";
        GuideType[GuideType["T_CameraMoveExitNpc"] = 14] = "T_CameraMoveExitNpc";
        GuideType[GuideType["T_OpenPort"] = 15] = "T_OpenPort";
        GuideType[GuideType["T_PortFreeEnd"] = 16] = "T_PortFreeEnd";
        GuideType[GuideType["T_AdsOn"] = 17] = "T_AdsOn";
        GuideType[GuideType["T_Review"] = 18] = "T_Review";
    })(GuideType || (GuideType = {}));
    class StepMgr {
        constructor() {
            this.StepData = null;
            this.StepData1 = [];
            this.StepData2 = [];
            this.CurStep = 0;
            this.CurStepData = null;
            this.guideIndex = 0;
            this.payIndex = 0;
            this.StageId = 1;
            this.ArrowTaget = null;
            this.ArrowWork = null;
            this.ArrowUnlock = null;
            this.PayTaget = null;
        }
        static get Int() {
            if (!this._Int) {
                this._Int = new StepMgr();
            }
            return this._Int;
        }
        Init(data) {
            this.StepData = data["myDate"];
            for (let index = 0; index < this.StepData.length; index++) {
                const element = this.StepData[index];
                let stageNo = element["StageNo"];
                if (stageNo == 1) {
                    this.StepData1.push(element);
                }
                else if (stageNo == 2) {
                    this.StepData2.push(element);
                }
            }
        }
        Start() {
            this.StageId = CanteenMgr.Int.StageId;
            this.InitLogic();
        }
        Stop() {
            this.ArrowTaget = null;
            this.ArrowUnlock = null;
            this.ArrowWork = null;
            this.PayTaget = null;
            this.CurStep = 0;
            this.CurStepData = null;
            this.guideIndex = 0;
            this.payIndex = 0;
        }
        InitLogic() {
            let sData;
            if (this.StageId === 1) {
                sData = LogicData.instance.Step_1;
            }
            else {
                sData = LogicData.instance.Step_2;
            }
            this.CurStep = sData.step;
            this.guideIndex = sData.gindex;
            this.payIndex = sData.pindex;
        }
        SaveLogic() {
            if (this.StageId == 1) {
                LogicData.instance.SaveStep_1(this.CurStep, this.guideIndex, this.payIndex);
            }
            else {
                LogicData.instance.SaveStep_2(this.CurStep, this.guideIndex, this.payIndex);
            }
        }
        GetStepData() {
            if (this.StageId == 1) {
                return this.StepData1;
            }
            else {
                return this.StepData2;
            }
        }
        StartStep() {
            console.warn("开始step步骤");
            this.InitLogic();
            this.CurStepData = this.GetStepData()[this.CurStep];
            this.DoGuide();
            this.DoPay();
        }
        NextStep() {
            this.CurStepData = this.GetStepData()[this.CurStep];
            this.guideIndex = 0;
            this.payIndex = 0;
            console.warn("========================当前步骤数据", this.CurStepData);
            this.DoGuide();
            this.DoPay();
            this.SaveLogic();
        }
        DoGuide(onWaitEnd) {
            if (!this.CurStepData)
                return;
            if (this.guideIndex == this.CurStepData.CSVProgressTutorialDatas.length) {
                let data = this.CurStepData;
                if (this.payIndex == data.CSVProgressPayToOpenDatas.length) {
                    this.FinshStep();
                }
                return;
            }
            let data = this.CurStepData.CSVProgressTutorialDatas[this.guideIndex];
            console.warn("========================guide     步骤data :", data.GuideType, data.Target);
            this.DoGuideAction(data.GuideType, data.Target, onWaitEnd);
        }
        FinshGuide(onWaitEnd) {
            if (!this.CurStepData)
                return;
            if (this.guideIndex == this.CurStepData.CSVProgressTutorialDatas.length) {
                return;
            }
            this.guideIndex += 1;
            this.SaveLogic();
            this.DoGuide(onWaitEnd);
        }
        DoPay() {
            if (!this.CurStepData)
                return;
            if (this.payIndex == this.CurStepData.CSVProgressPayToOpenDatas.length) {
                let data = this.CurStepData;
                if (this.guideIndex == data.CSVProgressTutorialDatas.length) {
                    this.FinshStep();
                }
                return;
            }
            let data = this.CurStepData.CSVProgressPayToOpenDatas[this.payIndex];
            this.DoPayAction(data.Target, data.Pay);
        }
        FinshPay() {
            if (!this.CurStepData)
                return;
            if (this.payIndex == this.CurStepData.CSVProgressPayToOpenDatas.length) {
                return;
            }
            this.payIndex += 1;
            this.SaveLogic();
            this.DoPay();
        }
        FinshStep() {
            this.CurStep += 1;
            this.NextStep();
            this.SaveLogic();
        }
        SetArrowTaget(taget) {
            let sp = CanteenMgr.Int.GetStageChild(taget);
            if (sp) {
                this.ArrowTaget = sp;
            }
        }
        SetArrowWork(taget) {
            let sp = CanteenMgr.Int.GetStageChild(taget);
            if (sp) {
                this.ArrowWork = sp;
            }
        }
        SetCameraAim(taget) {
            let sp = CanteenMgr.Int.GetStageChild(taget);
            if (sp) {
                CanteenMgr.Int.CameraScript.setAim(sp, new Laya.Vector3());
            }
        }
        DoGuideAction(tp, taget, onWaitEnd) {
            switch (tp) {
                case GuideType.T_CameraMove:
                    this.SetCameraAim(taget);
                    this.FinshGuide();
                    if (this.StageId == 1 && taget == "FishingPlace_01") {
                        UIMain$1.Int.InitGuideTip(1);
                    }
                    break;
                case GuideType.T_Wait:
                    let n = Number(taget);
                    Laya.timer.once(n * 1000, this, () => {
                        if (!!onWaitEnd) {
                            onWaitEnd.run();
                        }
                        this.FinshGuide();
                    });
                    break;
                case GuideType.T_GuideArrow_Seat:
                    this.SetArrowWork(taget);
                    break;
                case GuideType.T_GuideArrow_Seat_Counter:
                    this.SetArrowTaget(taget);
                    this.FinshGuide();
                case GuideType.T_GuideArrow_StackPull:
                    this.SetArrowTaget(taget);
                    break;
                case GuideType.T_GuideArrow_StackPull_Fishing:
                    this.SetArrowTaget(taget);
                    break;
                case GuideType.T_GuideArrow_StackPullSushibar:
                    this.FinshGuide();
                    break;
                case GuideType.T_GuideArrow_StackPush:
                    this.SetArrowTaget(taget);
                    break;
                case GuideType.T_GuideArrow_PayToOpen:
                    this.FinshGuide();
                    break;
                case GuideType.T_StackCheck:
                    if (taget == "FarmBranch_01") {
                        this.FinshGuide();
                    }
                    break;
                case GuideType.T_CookComplete:
                    break;
                case GuideType.T_OpenSushibar:
                    break;
                case GuideType.T_OpenTravel:
                    this.FinshGuide();
                    LogicData.instance.SetTravl(1);
                    break;
                case GuideType.T_CameraMoveEnterNpc:
                    this.SetCameraAim(taget);
                    break;
                case GuideType.T_CameraMoveExitNpc:
                    this.SetCameraAim("Player");
                    this.FinshGuide();
                    break;
                case GuideType.T_OpenPort:
                    this.FinshGuide(Laya.Handler.create(CanteenMgr.Int, CanteenMgr.Int.OpenProt));
                    break;
                case GuideType.T_PortFreeEnd:
                    this.FinshGuide();
                    break;
                case GuideType.T_AdsOn:
                    this.FinshGuide();
                    break;
                case GuideType.T_Review:
                    this.FinshGuide();
                    break;
            }
        }
        DoPayAction(taget, p) {
            EventMgr$1.Int.emit(EventType$1.UPDATE_UPLEVEL, taget);
            let sp = CanteenMgr.Int.GetStageChild(taget);
            if (taget == "CookHire_01") {
                UIMain$1.Int.InitGuideTip(10);
            }
            if (sp) {
                this.PayTaget = sp;
            }
            else {
                console.warn("没有找到指引的对象", taget, p);
            }
        }
        OnPayOpen(name) {
            if (this.PayTaget) {
                this.PayTaget = null;
                this.FinshPay();
            }
        }
        OnTagetArrow(name) {
            if (this.ArrowTaget) {
                this.ArrowTaget = null;
            }
        }
        OnWorkArrow(name) {
            if (this.ArrowWork) {
                this.ArrowWork = null;
            }
        }
        OnFinshGuide(tp, taget = null) {
            if (!this.CurStepData)
                return;
            let data = this.CurStepData.CSVProgressTutorialDatas[this.guideIndex];
            if (data && data.GuideType == tp) {
                if (taget == null || taget == data.Target) {
                    this.OnWorkArrow(null);
                    this.OnTagetArrow(null);
                    Laya.timer.frameOnce(1, this, this.FinshGuide);
                }
            }
        }
        OnFinshPay(taget) {
            if (!this.CurStepData)
                return;
            let data = this.CurStepData.CSVProgressPayToOpenDatas[this.payIndex];
            if (data) {
                if (taget == null || taget == data.Target) {
                    this.OnPayOpen(null);
                }
            }
        }
    }

    class FiniteStateMachine {
        constructor(taget) {
            this.curState = null;
            this.lastState = null;
            this.nextState = null;
            this.taget = taget;
            Laya.timer.frameLoop(1, this, this.update);
        }
        GetLastState() {
            return this.lastState;
        }
        GetCurState() {
            return this.curState;
        }
        SetCurState(value, saveLast = true) {
            if (this.curState == value) {
                return false;
            }
            let state;
            if (this.curState) {
                state = this.curState;
                if (saveLast) {
                    this.lastState = state;
                }
                else {
                    this.lastState = null;
                }
                this.curState = null;
                state.exit();
                state.SetCurStateMachine(null);
            }
            this.curState = value;
            if (this.curState) {
                this.curState.SetCurStateMachine(this);
                this.curState.enter();
            }
            return true;
        }
        update(time) { }
    }

    class BaseState {
        enter() {
        }
        exit() {
        }
        GetCurStateMachine() {
            return this.stateMachine;
        }
        SetCurStateMachine(value) {
            this.stateMachine = value;
        }
    }

    class IdleState extends BaseState {
        constructor() {
            super();
        }
        enter() {
            let taget = this.GetCurStateMachine().taget;
            taget.OnIdle();
        }
        exit() {
        }
    }

    class RunState extends BaseState {
        constructor() {
            super();
        }
        enter() {
            let taget = this.GetCurStateMachine().taget;
            taget.OnRun();
        }
        exit() {
        }
    }

    class EatState extends BaseState {
        constructor() {
            super();
        }
        enter() {
            let taget = this.GetCurStateMachine().taget;
            taget.OnStartEat();
        }
        exit() {
        }
    }

    var PhysicsGroup;
    (function (PhysicsGroup) {
        PhysicsGroup[PhysicsGroup["def"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_DEFAULTFILTER] = "def";
        PhysicsGroup[PhysicsGroup["all"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_ALLFILTER] = "all";
        PhysicsGroup[PhysicsGroup["gp1"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER1] = "gp1";
        PhysicsGroup[PhysicsGroup["gp2"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER2] = "gp2";
        PhysicsGroup[PhysicsGroup["gp3"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER3] = "gp3";
        PhysicsGroup[PhysicsGroup["gp4"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER4] = "gp4";
        PhysicsGroup[PhysicsGroup["gp5"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER5] = "gp5";
        PhysicsGroup[PhysicsGroup["gp6"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER6] = "gp6";
        PhysicsGroup[PhysicsGroup["gp7"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER7] = "gp7";
        PhysicsGroup[PhysicsGroup["gp8"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER8] = "gp8";
        PhysicsGroup[PhysicsGroup["gp9"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER9] = "gp9";
        PhysicsGroup[PhysicsGroup["gp10"] = Laya.Physics3DUtils.COLLISIONFILTERGROUP_CUSTOMFILTER10] = "gp10";
    })(PhysicsGroup || (PhysicsGroup = {}));

    class PackgeMgr {
        constructor() {
            this._packgeArr = [];
        }
        static get Int() {
            if (!this._Int) {
                this._Int = new PackgeMgr();
            }
            return this._Int;
        }
        AddPackge(pkg) {
            this._packgeArr.push(pkg);
        }
        SubInter(pkg) {
            let i = this._packgeArr.indexOf(pkg);
            if (i >= 0) {
                this._packgeArr.splice(i, 1);
            }
        }
        FindInterPackge(gtp, maxMin = 0) {
            let array = this._packgeArr;
            let scr = null;
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                if (element.cType == gtp) {
                    if (maxMin == 0) {
                        return element;
                    }
                    if (maxMin == -1) {
                        if (scr == null || scr.GoodsNum > element.GoodsNum) {
                            scr = element;
                        }
                    }
                    else if (maxMin == 1) {
                        if (scr == null || scr.GoodsNum < element.GoodsNum) {
                            scr = element;
                        }
                    }
                }
            }
            return scr;
        }
        ClearAll() {
            let array = this._packgeArr;
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                let sp = element.owner;
                if (sp) {
                    sp.destroy();
                    sp = null;
                }
            }
            this._packgeArr = [];
        }
    }

    class CPackge extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.GetType = GoodsType.all;
            this.cType = CanteenType.roleNpc;
            this.PackgeLevel = 0;
            this.OwnerScr = null;
            this._tagetPackges = [];
            this._tagetToPackge = null;
            this._goodsArr = [];
            this.max = 0;
            this._tagetTimer = 0;
            this._tagetTimerMax = 50;
            this.StartHandler = null;
            this.OnAddHandler = null;
            this.OverHandler = null;
            this.MaxHandler = null;
            this.BlankHandler = null;
            this.TagetMaxHandler = null;
            this.TagetBlankHandler = null;
            this.OnBreakHandler = null;
            this.GetNode = null;
            this.MustPos = false;
            this.GoodsPosArr = [];
            this.GoodsRotArr = [];
            this._onAddTween = false;
            this.LockJoin = false;
            this.xyx = 1;
            this.IsHide = false;
            this.tipArrow = null;
            this.tipId = 0;
            PackgeMgr.Int.AddPackge(this);
        }
        Init(size, level, gtp, owner, tween) {
            this.Size = size;
            this.PackgeLevel = level;
            this.GetType = gtp;
            this.OwnerScr = owner;
            this.cType = owner.cType;
            this._onAddTween = tween;
        }
        InitPosRot(posarr, rotarr) {
            this.GoodsPosArr = posarr;
            this.GoodsRotArr = rotarr;
            this.Size = posarr.length;
            this.MustPos = true;
        }
        LockTri() {
            let rig = this._obj.getComponent(Laya.Rigidbody3D);
            rig.collisionGroup = PhysicsGroup.gp10;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this.GetNode = this._obj.getChildByName("GetNode");
            let rig = this._obj.getComponent(Laya.Rigidbody3D);
            rig.collisionGroup = PhysicsGroup.all;
            rig.canCollideWith = PhysicsGroup.all ^ PhysicsGroup.gp10;
            this._tagetPackges = [];
            let r = this.GetNode.transform.localRotationEulerZ;
            if (r == 0) {
                this.xyx = 1;
            }
            else if (r > 0) {
                this.xyx = 2;
            }
            else if (r < 0) {
                this.xyx = 0;
            }
        }
        onUpdate() {
            if (this._tagetPackges.length > 0) {
                this._tagetTimer += Laya.timer.delta;
                if (this._tagetTimer >= this._tagetTimerMax) {
                    this._tagetTimer = 0;
                    this._tagetPackges.forEach((element) => {
                        element.OnTagets(this);
                    });
                }
            }
            this.updateTipPos();
        }
        onDestroy() {
            this.DesTip();
        }
        onTriggerEnter(other) {
            let scr = other.owner.getComponent(CPackge);
            if (scr && !this.IsHide) {
                scr.AddJoint(this);
            }
        }
        onTriggerExit(other) {
            let scr = other.owner.getComponent(CPackge);
            if (scr) {
                scr.SubJoint(this);
            }
        }
        AddJoint(scr, t = true) {
            if (this._tagetPackges.indexOf(scr) < 0) {
                this._tagetPackges.push(scr);
                scr.OnJoint(this);
            }
        }
        OnJoint(scr) {
            this._tagetToPackge = scr;
        }
        SubJoint(scr) {
            if (scr == null) {
                this.BreakAll();
                return;
            }
            let index = this._tagetPackges.indexOf(scr);
            if (index >= 0) {
                let pkg = this._tagetPackges.splice(index, 1)[0];
                pkg.OnBreak();
            }
            if (this._tagetPackges.length == 0) {
                if (this.OverHandler)
                    this.OverHandler.run();
            }
        }
        OnBreak() {
            this._tagetToPackge = null;
            this.OnBreakHandler && this.OnBreakHandler.run();
        }
        BreakPackge(scr = null) {
            this.SubJoint(scr);
        }
        BreakAll() {
            this._tagetPackges.forEach((element) => {
                element.OnBreak();
            });
            this._tagetPackges = [];
            if (this._tagetToPackge) {
                this._tagetToPackge.SubJoint(this);
            }
            if (this.OverHandler)
                this.OverHandler.run();
        }
        OnTagets(pkg) {
            if (this.LockJoin) {
                console.warn("锁定物品传输");
                return;
            }
            if (pkg.GoodsNum == 0) {
                return;
            }
            if (this._goodsArr.length == this.max) {
                return;
            }
            if (this.PackgeLevel > pkg.PackgeLevel) {
                let scr = pkg.Sub(this.GetType);
                if (scr) {
                    if (pkg && pkg.GoodsNum == 0) {
                        if (this.TagetBlankHandler)
                            this.TagetBlankHandler.run();
                    }
                    this.Add(scr);
                }
                else {
                    this.SubJoint(pkg);
                }
            }
        }
        Clear(des = true) {
            this._goodsArr.forEach((element) => {
                let sp = element.owner;
                if (sp) {
                    sp.removeSelf();
                    sp.destroy();
                    sp = null;
                }
            });
            this._goodsArr = [];
        }
        Add(goods) {
            this._goodsArr.push(goods);
            let to = !this._onAddTween;
            goods.OnAdd(to);
            if (this.PackgeLevel == 3) {
                AudioMgr$1.instance.play_sound(4);
                AudioMgr$1.instance.vibrateShort();
                if (goods.GoodsId == 2) {
                    ReportMgr.inst.sendReport(ReportType.FIRST_GETFISH);
                }
                if (goods.GoodsId == 1) {
                    StepMgr.Int.OnFinshGuide(GuideType.T_GuideArrow_StackPull, "ChairSeat_01_1");
                    ReportMgr.inst.sendReport(ReportType.FIRST_GETDISH);
                }
                else if (goods.GoodsId == 7) {
                    StepMgr.Int.OnFinshGuide(GuideType.T_GuideArrow_StackPull, "FarmBranch_01");
                }
                else {
                    StepMgr.Int.OnFinshGuide(GuideType.T_GuideArrow_StackPull_Fishing);
                }
                UIMain$1.Int.InitGuideTip(3, false);
                UIMain$1.Int.InitGuideTip(4);
            }
            if (this.PackgeLevel == 5) {
                ReportMgr.inst.sendReport(ReportType.FIRST_PUTFISH);
                StepMgr.Int.OnFinshGuide(GuideType.T_GuideArrow_StackPush);
                UIMain$1.Int.InitGuideTip(5, false);
                UIMain$1.Int.InitGuideTip(6);
            }
            if (this.PackgeLevel == 4) {
                AudioMgr$1.instance.play_sound(6);
            }
            this.updateGoodsIndex(to);
            if (this.OnAddHandler)
                this.OnAddHandler.run();
            if (this._goodsArr.length == this.max) {
                if (this.MaxHandler)
                    this.MaxHandler.run();
                return;
            }
        }
        Sub(type) {
            if (this._goodsArr.length == 0) {
                return null;
            }
            if (type == 0) {
                let scr = this._goodsArr.splice(this._goodsArr.length - 1, 1)[0];
                if (this._goodsArr.length == 0) {
                    if (this.BlankHandler)
                        this.BlankHandler.run();
                }
                this.updateGoodsIndex();
                return scr;
            }
            let goods = this.Find(type);
            if (!goods) {
                if (this.BlankHandler)
                    this.BlankHandler.run();
                return null;
            }
            let index = this._goodsArr.indexOf(goods);
            this._goodsArr.splice(index, 1);
            this.updateGoodsIndex();
            if (this._goodsArr.length == 0) {
                if (this.BlankHandler)
                    this.BlankHandler.run();
            }
            return goods;
        }
        updateGoodsIndex(to = true) {
            if (this.PackgeLevel == 3) {
                AudioMgr$1.instance.vibrateShort();
            }
            let array = this._goodsArr;
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                if (this.MustPos) {
                    element.SetPackge(this, index, true, this.GoodsPosArr[index], this.GoodsRotArr[index]);
                }
                else {
                    element.SetPackge(this, index, to);
                }
            }
            if (this.tipArrow) {
                if (this.Full) {
                    this.tipArrow.Show();
                }
                else {
                    this.tipArrow.Hide();
                }
            }
        }
        Find(type) {
            let array = this._goodsArr;
            for (let index = array.length - 1; index >= 0; index--) {
                const element = array[index];
                if (element.Type == type) {
                    return element;
                }
            }
            return null;
        }
        set Size(value) {
            this.max = value;
        }
        get Size() {
            return this.max;
        }
        get GoodsNum() {
            return this._goodsArr.length;
        }
        get GoodsType() {
            if (this._goodsArr.length == 0)
                return -1;
            return this._goodsArr[0].Type;
        }
        get Full() {
            return this._goodsArr.length == this.max;
        }
        get Trans() {
            return this.GetNode.transform || this._transform;
        }
        get GetTrans() {
            return this.GetNode.transform;
        }
        get XYX() {
            return this.xyx;
        }
        get Pos() {
            let pos = this._transform.position.clone();
            pos.y = 0;
            return pos;
        }
        AddBigFish(sp) {
            this.GetNode.addChild(sp);
            sp.transform.localPosition = new Laya.Vector3();
            sp.transform.localRotationEuler = new Laya.Vector3();
            this.HideGoods();
        }
        SubBigFish() {
            if (this.GetNode.numChildren > 0) {
                this.ShowGoods();
                return this.GetNode.removeChildAt(0);
            }
        }
        HideGoods() {
            if (this.IsHide)
                return;
            this.IsHide = true;
            this._goodsArr.forEach((element) => {
                element.Hide();
            });
        }
        ShowGoods() {
            if (!this.IsHide)
                return;
            this.IsHide = false;
            this._goodsArr.forEach((element) => {
                element.Show();
            });
        }
        InitTip(id) {
            if (!this.tipArrow) {
                this.tipId = id;
                console.warn("初始化箭头", this.tipId);
                this.tipArrow = fgui.UIPackage.createObjectFromURL(UIMain$1.Int.TipUrl);
                this.tipArrow.touchable = false;
                this.tipArrow.InitPic(this.tipId);
                UIMain$1.Int.AddTip(this.tipArrow);
                this.tipArrow.Hide();
            }
        }
        updateTipPos() {
            if (!this.tipArrow)
                return;
            if (!this.tipArrow.isShow)
                return;
            let pos = this._transform.position.clone();
            let v2 = WorldToScreen2(CanteenMgr.Int._camera, pos);
            let P = 1;
            let out = false;
            if (v2.y < 150) {
                v2.y = 150;
                P = 3;
                out = true;
            }
            else if (v2.y > Laya.stage.height - 100) {
                v2.y = Laya.stage.height - 100;
                P = 1;
                out = true;
            }
            if (v2.x < 50) {
                v2.x = 50;
                P = 0;
                out = true;
            }
            else if (v2.x > Laya.stage.width - 50) {
                v2.x = Laya.stage.width - 50;
                P = 2;
                out = true;
            }
            this.tipArrow.updatePos(v2.x, v2.y, P, out);
        }
        DesTip() {
            if (!this.tipArrow)
                return;
            this.tipArrow.removeFromParent();
            this.tipArrow.dispose();
            this.tipArrow = null;
        }
    }

    class Packger extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.packge = null;
            this.cType = null;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this.InitPackge();
        }
        InitPackge() {
            let packgeNode = MyInstrument.GetChildByName(this._obj, "packgeNode");
            if (packgeNode) {
                this.packge = packgeNode.addComponent(CPackge);
            }
        }
    }

    class WorkState extends BaseState {
        constructor() {
            super();
        }
        enter() {
            this.GetCurStateMachine().taget.OnWork();
        }
        exit() {
        }
    }

    class NoWorkState extends BaseState {
        constructor() {
            super();
        }
        enter() {
        }
        exit() {
        }
    }

    class RunStateHold extends BaseState {
        constructor() {
            super();
        }
        enter() {
            let taget = this.GetCurStateMachine().taget;
            taget.OnRunHold();
        }
        exit() {
        }
    }

    class IdleStateHold extends BaseState {
        constructor() {
            super();
        }
        enter() {
            let taget = this.GetCurStateMachine().taget;
            taget.OnIdleHold();
        }
        exit() {
        }
    }

    var HumanAni;
    (function (HumanAni) {
        HumanAni["Idle"] = "Idle";
        HumanAni["Idle_hold"] = "Idle_hold";
        HumanAni["Running"] = "Running";
        HumanAni["Running_hold"] = "Running_hold";
        HumanAni["FishingCastInit"] = "FishingCastInit";
        HumanAni["Fishing_Idle"] = "Fishing Idle";
        HumanAni["FishingCast"] = "FishingCast";
        HumanAni["Cooking"] = "Cooking";
        HumanAni["Nod"] = "Nod";
        HumanAni["SeatIdle"] = "SeatIdle";
        HumanAni["Seat2"] = "Seat2";
        HumanAni["Counter"] = "Counter";
        HumanAni["Walk"] = "Walk";
        HumanAni["Idle_Rich"] = "Idle_Rich";
    })(HumanAni || (HumanAni = {}));
    var RoleType;
    (function (RoleType) {
        RoleType[RoleType["normal"] = 0] = "normal";
        RoleType[RoleType["player"] = 1] = "player";
        RoleType[RoleType["client"] = 2] = "client";
        RoleType[RoleType["waiter"] = 3] = "waiter";
    })(RoleType || (RoleType = {}));
    class BaseRole extends Packger {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this._ani = null;
            this.Body = null;
            this.data = null;
            this.RoleType = RoleType.normal;
            this._workType = null;
            this._workTaget = null;
            this._mover = null;
            this._moveEndTaget = null;
            this.FMachine = null;
            this.idleState = new IdleState();
            this.idleHoldState = new IdleStateHold();
            this.runState = new RunState();
            this.runHoldState = new RunStateHold();
            this.eatState = new EatState();
            this.workState = new WorkState();
            this.noWorkState = new NoWorkState();
            this.isPay = false;
            this.HandNode = null;
            this.Knife = null;
            this.FishingLod = null;
            this.HandNode2 = null;
            this.DiaCane = null;
            this.EffNodeZZZ = null;
            this.bigFish = null;
            this.car = null;
            this.onCar = false;
            this.carTimer = -1;
            this.eatPirce = 0;
            this.eatDish = null;
            this.eatChair = null;
            this.cType = CanteenType.roleNpc;
        }
        onAwake() {
            super.onAwake();
            this.isPay = false;
            this._ani = this._obj.getChildAt(0).getComponent(Laya.Animator);
            this.Body = MyInstrument.GetChildByName(this._obj, "Body");
            this.HandNode = MyInstrument.GetChildByName(this._obj, "HandNode");
            this.HandNode2 = MyInstrument.GetChildByName(this._obj, "HandNode2");
            this.EffNodeZZZ = MyInstrument.GetChildByName(this._obj, "EffNodeZZZ");
            if (this.HandNode) {
                this.Knife = this.HandNode.getChildAt(0);
                this.FishingLod = this.HandNode.getChildAt(1);
                this.DiaCane = this.HandNode.getChildAt(2);
                this.Knife.active = false;
                this.FishingLod.active = false;
                this.DiaCane.active = false;
            }
            if (this.HandNode2) {
                this.HandNode2.active = false;
            }
            this.FMachine = new FiniteStateMachine(this);
            this.FMachine.SetCurState(this.idleState);
            this.InitComponent();
            this.StopNod();
            this.InitAni();
        }
        onUpdate() {
            if (this.carTimer > 0) {
                this.carTimer -= Laya.timer.delta;
                if (this.carTimer <= 0) {
                    this.carTimer = -1;
                    this.OffCar();
                    this.OnOfftry();
                }
            }
        }
        InitAni() {
            if (!this._ani)
                return;
            let state1 = this._ani.getControllerLayer().getAnimatorState(HumanAni.FishingCastInit);
            state1.speed = 1.5;
        }
        onDestroy() {
            this._transform = null;
            this._ani = null;
            this._obj.destroy();
            this._obj = null;
        }
        InitModel() {
            let juese_skin = MyInstrument.GetChildByName(this._obj, "juese_skin");
            let i = 2;
            switch (this.RoleType) {
                case RoleType.player:
                    i = 3;
                    break;
                case RoleType.client:
                    i = -1;
                    break;
                case RoleType.waiter:
                    if (this._workType == WorkType.fishing) {
                        i = 4;
                    }
                    else if (this._workType == WorkType.cook) {
                        i = 5;
                    }
                    else if (this._workType == WorkType.counter) {
                        i = 6;
                    }
                    else if (this._workType == WorkType.waiter) {
                        i = 7;
                    }
                    break;
            }
            for (let index = 3; index < juese_skin.numChildren; index++) {
                const element = juese_skin.getChildAt(index);
                if (index == i) {
                    element.active = true;
                }
                else {
                    element.active = false;
                }
            }
        }
        InitPackge() {
            super.InitPackge();
        }
        PlayAni(name) {
            if (!this._ani) {
                console.warn("没有找到动画组件");
                return;
            }
            this._ani.play(name);
        }
        Croos(name) {
            if (!this._ani) {
                console.warn("没有找到动画组件");
                return;
            }
            this._ani.crossFade(name, 0.2);
        }
        get isIdel() {
            return this.FMachine.GetCurState() == this.idleState;
        }
        OnRun() {
            this.PlayAni(HumanAni.Running);
            this.StopWork();
        }
        OnRunHold() {
            this.PlayAni(HumanAni.Running_hold);
            this.StopWork();
        }
        OnIdle() {
            this.PlayAni(HumanAni.Idle);
        }
        OnIdleHold() {
            this.PlayAni(HumanAni.Idle_hold);
        }
        OnWork(tp) {
            this.StopNod();
            switch (tp) {
                case WorkType.counter:
                    this.PlayAni(HumanAni.Counter);
                    if (this.cType == CanteenType.player) {
                        StepMgr.Int.OnFinshGuide(GuideType.T_GuideArrow_Seat);
                        AudioMgr$1.instance.vibrateShort();
                        let m = this._mover;
                        m.tagetY = 0;
                    }
                    break;
                case WorkType.cook:
                    this.PlayAni(HumanAni.Idle);
                    if (this.cType == CanteenType.player) {
                        StepMgr.Int.OnFinshGuide(GuideType.T_GuideArrow_Seat);
                        let m = this._mover;
                        m.tagetY = 0.7;
                    }
                    if (this.Knife) {
                        this.Knife.active = true;
                    }
                    this._transform.localPositionY = 0.7;
                    break;
                case WorkType.fishing:
                    this.DownFish();
                    if (this.cType == CanteenType.player) {
                        StepMgr.Int.OnFinshGuide(GuideType.T_GuideArrow_Seat, "BeachChair");
                        let m = this._mover;
                        m.tagetY = 0;
                    }
                    if (this.FishingLod) {
                        this.FishingLod.active = true;
                    }
                    break;
            }
            if (this.packge) {
                this.packge.HideGoods();
            }
        }
        OnStartEat() {
            this.PlayAni(HumanAni.Seat2);
            Laya.timer.once(2000, this, this.EatOver, null, false);
        }
        Eat(dish, chair) {
            this.eatDish = dish;
            this.eatChair = chair;
            this.eatPirce = this.eatDish.FoodPirce;
            return this.FMachine.SetCurState(this.eatState);
        }
        EatOver() {
            this.eatDish.OnFoodEat();
            this.eatChair.AddToPackge(this.eatDish);
            this.eatChair.LeaveClient();
        }
        OnWaitPay() {
            this._moveEndTaget = null;
        }
        Pay() {
            if (this.isPay)
                return 0;
            if (this.FMachine.GetCurState() != this.idleState)
                return 0;
            UIMain$1.Int.InitGuideTip(8, false);
            UIMain$1.Int.InitGuideTip(9);
            this.isPay = true;
            Laya.timer.once(500, this, this.PayOver, null, false);
            if (this._moveEndTaget) {
                this._moveEndTaget.SetClient(null);
            }
            this._moveEndTaget = null;
            AudioMgr$1.instance.play_sound(1);
            return this.eatPirce;
        }
        PayOver() {
            this.FMachine.SetCurState(this.idleState);
            this.OutSce();
            RoleMgr.Int.AutoSettle();
        }
        StartWork(inter) {
            if (this.packge)
                this.packge.BreakPackge();
            this.FMachine.SetCurState(this.workState);
            this._workTaget = inter;
            inter.SetTaget(this);
            this._transform.rotationEuler = inter.WorkRot.clone();
            this._transform.position = inter.WorkPos.clone();
            this.OnWork(inter.m_WorkerType);
            this.HideCar(false);
        }
        StopWork(call = true) {
            this._transform.localPositionY = 0;
            if (this.cType == CanteenType.player) {
                this.TryShow();
                let m = this._mover;
                if (this.onCar) {
                    m.tagetY = 0.4;
                }
                else {
                    m.tagetY = 0;
                }
            }
            this.StopNod();
            if (this._workTaget) {
                this.FMachine.SetCurState(this.idleState);
                Laya.timer.clearAll(this);
                let scr = null;
                if (call) {
                    scr = RoleMgr.Int.FindWorker(this._workTaget.m_WorkerType);
                }
                let t = null;
                if (scr) {
                    t = this._workTaget;
                }
                this._workTaget.SetTaget(null);
                this._workTaget = null;
                if (t) {
                    scr.InitWork();
                }
                if (this.FishingLod) {
                    this.FishingLod.active = false;
                }
                if (this.Knife) {
                    this.Knife.active = false;
                }
            }
            if (this.packge) {
                this.packge.ShowGoods();
            }
        }
        DragFish() {
            this.StopNod();
            this.PlayAni(HumanAni.FishingCastInit);
            Laya.timer.once(900, this, this.WaitFish);
            AudioMgr$1.instance.play_sound(5);
            if (this.packge.PackgeLevel == 3) {
                AudioMgr$1.instance.vibrateShort();
            }
        }
        DownFish() {
            this.PlayAni(HumanAni.FishingCast);
            Laya.timer.once(1000, this, this.WaitFish);
        }
        WaitFish() {
            this.Croos(HumanAni.Fishing_Idle);
        }
        InitWork() { }
        OutSce() { }
        MoveTo(v3) { }
        InitComponent() { }
        Nod() {
            this.PlayAni(HumanAni.Nod);
            this.EffNodeZZZ.active = true;
        }
        StopNod() {
            this.EffNodeZZZ.active = false;
        }
        get IsWorkIng() {
            return this.FMachine.GetCurState() == this.workState;
        }
        get Pos() {
            return this._transform.position.clone();
        }
        get viewPos() {
            return WorldToScreen2(CanteenMgr.Int._camera, this._transform.position.clone());
        }
        OnVipShowHand() {
            this.HandNode2.active = true;
            this.DiaCane.active = true;
        }
        OnVipHideHnad() {
            this.HandNode2.active = false;
            this.DiaCane.active = false;
        }
        TakeCar(t = null) {
            if (t != null) {
                this.carTimer = t;
                LogicData.instance.AddCarTime();
            }
            if (this.car) {
                this.ShowCar();
                return;
            }
            let self = this;
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs("pinhengce"), function (res) {
                self.AddCar(res);
            });
        }
        OffCar() {
            this.FMachine.SetCurState(this.idleState);
            this.HideCar(true);
            CanteenMgr.Int.OnTakeCarActive();
        }
        AddCar(res) {
            let car = res.clone();
            this._obj.addChild(car);
            this.car = car;
            car.transform.localPosition = new Laya.Vector3();
            car.transform.localRotationEuler = new Laya.Vector3();
            this.ShowCar();
            CanteenMgr.Int.OnTakeCarActive();
            this.FMachine.SetCurState(this.idleState);
        }
        TryShow() {
            if (this.onCar) {
                this.ShowCar();
            }
        }
        ShowCar() {
            if (!this.car)
                return;
            this.car.active = true;
            let m = this._mover;
            m.tagetY = 0.4;
            this.onCar = true;
        }
        HideCar(off = true) {
            if (!this.car)
                return;
            this.car.active = false;
            if (off) {
                let m = this._mover;
                m.tagetY = 0;
                this.onCar = false;
            }
        }
        OnOfftry() {
        }
    }

    class NpcRole extends BaseRole {
        constructor() {
            super();
            this._aimChair = null;
            this._moveEndTaget = null;
            this.readyOut = false;
        }
        onAwake() {
            super.onAwake();
            this.RoleType = RoleType.client;
            this.packge.LockTri();
            this.InitModel();
        }
        InitComponent() {
            this._mover = this._obj.addComponent(AimPathMover);
        }
        ToChair(chair) {
            this._aimChair = chair;
            this._moveEndTaget = chair;
            this.MoveTo(this._aimChair.MovePos);
        }
        ToPay() {
            if (this.isPay)
                return;
            UIMain$1.Int.InitGuideTip(7);
            this._moveEndTaget = CanteenMgr.Int.counter;
            this.MoveTo(CanteenMgr.Int.counter.PayPos);
            StepMgr.Int.OnFinshGuide(GuideType.T_CameraMoveEnterNpc);
        }
        OutSce() {
            this._moveEndTaget = null;
            RoleMgr.Int.SubSettle(this);
            this.MoveTo(CanteenMgr.Int.m_stage.RandomB());
            this.readyOut = true;
        }
        MoveTo(v3) {
            if (!this._mover)
                return;
            let mover = this._mover;
            this.FMachine.SetCurState(this.runState);
            let p = this._transform.localPosition.clone();
            v3.y = 0;
            let path = PathFindMgr.Int.findPath(p, v3);
            PathFindMgr.Int.drawPath(path);
            if (path.length <= 2) {
                path = [v3];
            }
            else if (path.length > 2) {
                let dis1 = Laya.Vector3.distanceSquared(path[path.length - 2], path[path.length - 1]);
                let dis2 = Laya.Vector3.distanceSquared(path[path.length - 2], v3);
                if (dis1 >= dis2) {
                    path[path.length - 1] = v3;
                }
                else {
                    path.push(v3);
                }
            }
            else ;
            mover.SetPath(path);
            mover.SetHandler(Laya.Handler.create(this, this.OnMoveOver, null, false));
        }
        OnMoveOver() {
            this.FMachine.SetCurState(this.idleState);
            if (this._moveEndTaget) {
                this._moveEndTaget.SetClient(this);
                if (this._moveEndTaget.cType == CanteenType.chair) {
                    this._transform.rotationEuler = this._moveEndTaget.WorkRot.clone();
                    this.PlayAni(HumanAni.SeatIdle);
                }
            }
            if (this.readyOut) {
                RoleMgr.Int.SubClient(this);
            }
        }
    }

    class MoveScript extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.MoveScale = 1;
            this.selfScale = 2;
            this.tagetY = 0;
            this._character = null;
            this._speed = new Laya.Vector3();
            this._nForward2 = new Laya.Vector2(0, 1);
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this._InitCharacter();
        }
        onUpdate() {
            this._transform.localPositionY = this.tagetY;
            this.Move(this._speed);
            this.UpdateDir();
        }
        get Speed() {
            return this._speed.clone();
        }
        set Speed(value) {
            this._speed = value;
        }
        _InitCharacter() {
            console.log("初始化角色控制器");
            this._character = this._obj.getComponent(Laya.CharacterController);
            if (!this._character) {
                this._character = this._obj.addComponent(Laya.CharacterController);
            }
            var sphereShape = new Laya.CapsuleColliderShape(0.5, 2);
            sphereShape.localOffset = new Laya.Vector3(0, 1, 0);
            this._character.colliderShape = sphereShape;
            this._character.gravity = new Laya.Vector3(0, 0, 0);
        }
        Move(v3) {
            if (!this._character)
                return;
            Laya.Vector3.scale(v3, this.MoveScale * this.selfScale, v3);
            this._character.move(v3);
        }
        UpdateDir() {
            if (this._speed.x == 0 && this._speed.z == 0)
                return;
            let speed = new Laya.Vector2(this._speed.x, this._speed.z);
            let angle = MyInstrument.getTheAngle(speed, this._nForward2);
            this._transform.localRotationEulerY = -angle;
        }
        Stop() {
            if (!this._character)
                return;
            this._character.move(new Laya.Vector3());
        }
        Jump() {
            if (!this._character)
                return;
            if (!this._character.isGrounded)
                return;
            this._character.jump();
        }
    }

    class MoneyScript extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.startPos = null;
            this.aimPos = null;
            this.offy = 0;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
        }
        onUpdate() {
            if (this.aimPos) {
                let sPos = this._transform.position.clone();
                if (this.offy == 0) {
                    Laya.Vector3.lerp(sPos, this.aimPos, 0.55, sPos);
                }
                else {
                    Laya.Vector3.lerp(sPos, this.aimPos, 0.1, sPos);
                    sPos.y += this.offy;
                }
                this._transform.position = sPos;
            }
        }
        onDestroy() {
            Laya.Tween.clearAll(this);
            Laya.timer.clearAll(this);
        }
        Init(aimPos) {
            this.aimPos = aimPos;
            this.offy = 1;
            Laya.Tween.to(this, { offy: 0 }, 400);
        }
        OnGetRole(pos) {
            this.aimPos = pos.clone();
            Laya.timer.once(500, this, this.Clear);
        }
        Clear() {
            this._obj.removeSelf();
            this._obj.destroy();
            this._obj = null;
        }
    }

    class MStack extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.curMoney = 0;
            this.Transform = null;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this.Transform = this._obj.getChildAt(0);
        }
        AddMoney(num, pos) {
            this.curMoney += num;
            this.AddModel(Math.floor(num / 5), pos);
        }
        SubMoney() {
            if (this.curMoney > 0) {
                UIMain$1.Int.InitGuideTip(9, false);
                this.curMoney -= 5;
                LogicProp.instance.add(EPropNameById.diamonds, 5);
                UIMain$1.Int.InitGuideTip(11, false);
                StepMgr.Int.OnFinshGuide(GuideType.T_GuideArrow_StackPull, "CounterSeat_01");
                this.OnSubModel();
            }
        }
        get Money() {
            return this.curMoney;
        }
        AddModel(num, pos) {
            console.warn("添加模型个数", num);
            if (this.Transform.numChildren >= 120) {
                return;
            }
            for (let index = 0; index < num; index++) {
                let sp = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs("Money")).clone();
                let scr = sp.addComponent(MoneyScript);
                this.Transform.addChild(sp);
                sp.transform.position = pos.clone();
                let n = this.Transform.numChildren;
                let tn = n - 1;
                let ceng = Math.floor(tn / 9);
                let tll = tn % 9;
                let x = tll % 3;
                let y = Math.floor(tll / 3);
                let v3 = this.Transform.transform.position.clone();
                Laya.Vector3.add(v3, new Laya.Vector3(x * 0.45, 0.25 * ceng, (y - 2) * 0.4), v3);
                scr.Init(v3);
                sp.transform.localScale = new Laya.Vector3(1, 1, 1);
            }
        }
        OnSubModel() {
            let num = Math.floor(this.curMoney / 5);
            let tNum = this.Transform.numChildren;
            UIMain$1.Int.AddMoneyFly();
            if (num < tNum) {
                AudioMgr$1.instance.play_sound(8);
                this.Transform.removeChildren(num - 1, tNum - 1);
            }
        }
    }

    class WorkNodeTri extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.ownerInter = null;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
        }
        InitInter(scr) {
            this.ownerInter = scr;
        }
    }

    class PlayerRole extends BaseRole {
        constructor() {
            super();
            this.cType = CanteenType.player;
            this.triWork = null;
            this.timer = 0;
            this._firstVideoKey = "LocalCache._firstVideoKey";
        }
        onAwake() {
            super.onAwake();
            EventMgr$1.Int.on(EventType$1.PLAYER_MOVE, this.Move, this);
            this.RoleType = RoleType.player;
            this.InitModel();
            this.InitPowerLevel();
            EventMgr$1.Int.on(EventType$1.ADD_POWER_LEVEL, this.InitPowerLevel, this);
            this.AddEff();
        }
        onUpdate() {
            super.onUpdate();
            if (this.triWork) {
                this.timer += Laya.timer.delta;
                if (this.timer >= 2000) {
                    this.TrigerWork();
                }
            }
        }
        onTriggerEnter(other) {
            let scr = other.owner.getComponent(WorkNodeTri);
            if (scr) {
                if (this.bigFish && scr.ownerInter.isTuna) {
                    scr.ownerInter.AddBigFish(this.bigFish);
                    this.SubBigFish();
                    this.bigFish = null;
                }
                this.triWork = scr.ownerInter;
                this.timer = 0;
            }
            this._triggerCar(other.owner.getComponent(StopCar));
        }
        _triggerCar(src) {
            if (src) {
                let t = LogicData.instance.TryCarTime;
                if (t >= 1 && LogicData.instance.CarNum < 2) ;
                else {
                    this.OnTriggerCarStop();
                }
            }
        }
        onTriggerStay(other) {
            let scr = other.owner.getComponent(MStack);
            if (scr) {
                if (this._firstVideo == undefined) {
                    this._firstVideo = LocalCache$1.get(this._firstVideoKey, true);
                }
                if (this._firstVideo) {
                    this._firstVideo = false;
                    LocalCache$1.set(this._firstVideoKey, false);
                    if (GameSDK$1.isAdUser() && +GameSDK$1.data.GetMoneyVideo == 1) {
                        GameSDK$1.showADVideo(this, (s) => { }, "第一次收银自动视频");
                    }
                }
                ReportMgr.inst.sendReport(ReportType.FIRST_GETMONEY);
                scr.SubMoney();
            }
        }
        onTriggerExit(other) {
            let scr = other.owner.getComponent(WorkNodeTri);
            if (scr) {
                this.triWork = null;
                this.timer = 0;
            }
        }
        onDestroy() {
            EventMgr$1.Int.off(EventType$1.PLAYER_MOVE, this.Move, this);
            EventMgr$1.Int.off(EventType$1.ADD_POWER_LEVEL, this.InitPowerLevel, this);
        }
        onDisable() {
            EventMgr$1.Int.off(EventType$1.PLAYER_MOVE, this.Move, this);
            EventMgr$1.Int.off(EventType$1.ADD_POWER_LEVEL, this.InitPowerLevel, this);
        }
        InitComponent() {
            this._mover = this._obj.addComponent(MoveScript);
        }
        InitPackge() {
            super.InitPackge();
            if (this.packge) {
                this.packge.Init(8, 3, GoodsType.all, this, true);
            }
        }
        InitPowerLevel() {
            let data = LogicData.instance.CanteenPowerLevel;
            let sLevel = GameData.getPlayerSpeedItem(data.PlayerSpeed);
            this._mover.MoveScale = sLevel.Speed;
            this.packge.Size = GameData.getPlayerNumItem(data.PlayerCarry).Speed;
        }
        OnRun() {
            if (this.onCar) {
                this.PlayAni(HumanAni.Idle);
            }
            else {
                this.PlayAni(HumanAni.Running);
            }
            this.StopWork();
        }
        OnRunHold() {
            if (this.onCar) {
                this.PlayAni(HumanAni.Idle_hold);
            }
            else {
                this.PlayAni(HumanAni.Running_hold);
            }
            this.StopWork();
        }
        Move(v3) {
            if (Laya.Vector3.scalarLengthSquared(v3) >= 0.01) {
                Laya.Vector3.normalize(v3, v3);
                Laya.Vector3.scale(v3, 0.1, v3);
            }
            this._mover.Speed = v3;
            if (v3.x != 0 || v3.z != 0) {
                if ((this.packge && this.packge.GoodsNum > 0) || this.bigFish) {
                    this.FMachine.SetCurState(this.runHoldState);
                }
                else {
                    this.FMachine.SetCurState(this.runState);
                }
            }
            else {
                if ((this.packge && this.packge.GoodsNum > 0) || this.bigFish) {
                    this.FMachine.SetCurState(this.idleHoldState);
                }
                else {
                    this.FMachine.SetCurState(this.idleState);
                }
            }
        }
        TrigerWork(scr = null) {
            this.timer = 0;
            this.triWork.SetMustTaget(this);
            this.InitWorkModel(this.triWork.m_WorkerType);
            this.triWork = null;
            console.warn("开始工作");
        }
        StopWork(call) {
            super.StopWork(call);
            this.InitWorkModel(null);
        }
        get TimerPro() {
            return (this.timer / 2000) * 100;
        }
        SubMoney(t = 1) {
            let num = LogicProp.instance.get(EPropNameById.diamonds);
            if (num >= t) {
                LogicProp.instance.add(EPropNameById.diamonds, -t);
                return true;
            }
            else {
                return false;
            }
        }
        AddBigFish() {
            this.bigFish = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs("Tuna")).clone();
            this.packge.AddBigFish(this.bigFish);
            LogicData.instance.AddBigFishTimes();
        }
        SubBigFish() {
            this.packge.SubBigFish();
        }
        AddEff() {
            let sp = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs("DustRun")).clone();
            let EffNode = MyInstrument.GetChildByName(this._obj, "EffNode");
            if (EffNode) {
                EffNode.destroyChildren();
                EffNode.addChild(sp);
                sp.transform.localPosition = new Laya.Vector3();
                sp.transform.localRotationEuler = new Laya.Vector3();
            }
        }
        InitWorkModel(tp) {
            let juese_skin = MyInstrument.GetChildByName(this._obj, "juese_skin");
            let i = -1;
            if (tp == WorkType.fishing) {
                i = 4;
            }
            else if (tp == WorkType.cook) {
                i = 5;
            }
            else if (tp == WorkType.counter) {
                i = 6;
            }
            else if (tp == WorkType.waiter) {
                i = 7;
            }
            else {
                i = 3;
            }
            for (let index = 3; index < juese_skin.numChildren; index++) {
                const element = juese_skin.getChildAt(index);
                if (index == i) {
                    element.active = true;
                }
                else {
                    element.active = false;
                }
            }
        }
        get WorkTimer() {
            if (this._workTaget) {
                return this._workTaget.TimerPro();
            }
            return 0;
        }
        OnTriggerCarStop() {
            let num = LogicData.instance.CarNum;
            let timer = null;
            if (num < 2) {
                timer = 30 * 1000;
            }
            if (this.onCar) {
                this.OffCar();
                return false;
            }
            else {
                this.TakeCar(timer);
                return true;
            }
        }
    }

    class VipRole extends BaseRole {
        constructor() {
            super();
            this.timer = 0;
            this.triRole = null;
            this.liveTimer = 5000;
            this.Money = 0;
            this.onOut = false;
            this.startEnter = false;
            this.maxTimer = 800;
            this.tipArrow = null;
            this.tipId = 0;
        }
        onAwake() {
            super.onAwake();
            this.liveTimer = 30000;
            this.packge.LockTri();
            this.InitModel();
            this.InitTrigger();
            this.OnVipHideHnad();
            this.EnterSce();
        }
        onUpdate() {
            console.log("***** ", GameSDK$1.videoShowing, this.onOut, this.startEnter, this.triRole);
            if (GameSDK$1.videoShowing)
                return;
            if (this.onOut)
                return;
            if (this.startEnter)
                return;
            if (this.triRole) {
                this.timer += Laya.timer.delta;
                if (this.timer >= this.maxTimer) {
                    if (this.onOut || this.startEnter) {
                        return;
                    }
                    console.warn("播放广告，回调给金币");
                    if (GameSDK$1.isCurrentVersion) {
                        this.OnRoleVip();
                    }
                    else {
                        if (!GameSDK$1.MyTurn) {
                            GameSDK$1.MyTurn = true;
                            GameSDK$1.showADVideo(this, (state) => {
                                if (state) {
                                    this.OnRoleVip();
                                }
                                else {
                                    this.timer = 0;
                                }
                            }, "VIP广告");
                        }
                    }
                }
            }
            else {
                this.liveTimer -= Laya.timer.delta;
                if (this.liveTimer <= 0) {
                    this.OutSce();
                }
            }
            this.updateTipPos();
        }
        onDestroy() {
            CanteenMgr.Int.Vip = null;
        }
        onTriggerEnter(other) {
            if (this.onOut || this.startEnter)
                return;
            let scr = other.owner.getComponent(PlayerRole);
            if (scr && this.Money > 0) {
                this.timer = 0;
                this.triRole = scr;
            }
        }
        onTriggerExit(other) {
            let scr = other.owner.getComponent(PlayerRole);
            if (scr) {
                this.timer = 0;
                this.triRole = null;
            }
        }
        InitComponent() {
            this._mover = this._obj.addComponent(AimPathMover);
        }
        InitTrigger() {
            let rig = this._obj.addComponent(Laya.Rigidbody3D);
            rig.isKinematic = true;
            rig.isTrigger = true;
            let cld = new Laya.SphereColliderShape(1.5);
            rig.colliderShape = cld;
        }
        InitModel() {
            let juese_skin = MyInstrument.GetChildByName(this._obj, "juese_skin");
            let i = 8;
            for (let index = 3; index < juese_skin.numChildren; index++) {
                const element = juese_skin.getChildAt(index);
                if (index == i) {
                    element.active = true;
                }
                else {
                    element.active = false;
                }
            }
        }
        MoveTo(v3) {
            if (!this._mover)
                return;
            let mover = this._mover;
            this.FMachine.SetCurState(this.runState);
            let p = this._transform.localPosition.clone();
            v3.y = 0;
            let path = PathFindMgr.Int.findPath(p, v3);
            PathFindMgr.Int.drawPath(path);
            if (path.length <= 2) {
                path = [v3];
            }
            else if (path.length > 2) {
                let dis1 = Laya.Vector3.distanceSquared(path[path.length - 2], path[path.length - 1]);
                let dis2 = Laya.Vector3.distanceSquared(path[path.length - 2], v3);
                if (dis1 >= dis2) {
                    path[path.length - 1] = v3;
                }
                else {
                    path.push(v3);
                }
            }
            mover.SetPath(path);
            mover.SetHandler(Laya.Handler.create(this, this.OnMoveOver, null, false));
        }
        OnMoveOver() {
            if (this.startEnter) {
                this.FMachine.SetCurState(this.idleState);
                this.PlayAni(HumanAni.Idle_Rich);
                this.startEnter = false;
                let t = LogicProp.instance.get(EPropNameById.diamonds);
                let num = Math.floor(t * 0.5 * (Math.random() + 1)) + 200;
                this.Money = num;
                this._transform.position = this._transform.position;
                this._transform.rotationEuler = new Laya.Vector3(0, 36, 0);
                this.OnVipShowHand();
                EventMgr$1.Int.emit(EventType$1.INIT_VIP_SHOW, this.Money);
                this.InitTip(4);
                EventMgr$1.Int.emit(EventType$1.MONEY_DUIDUI, [true, this.Money]);
                EventMgr$1.Int.on(EventType$1.TRIGGER_MONEY, this.OnRoleVip, this);
            }
            else {
                RoleMgr.Int.SubVip(this);
            }
        }
        get TimerPro() {
            return (this.timer / this.maxTimer) * 100;
        }
        OnRoleVip() {
            LogicProp.instance.add(EPropNameById.diamonds, this.Money);
            UIMain$1.Int.InitGuideTip(11, false);
            this.Money = 0;
            this.triRole = null;
            this.timer = 0;
            this.OutSce();
        }
        OutSce() {
            EventMgr$1.Int.off(EventType$1.TRIGGER_MONEY, this.OnRoleVip, this);
            EventMgr$1.Int.emit(EventType$1.MONEY_DUIDUI, [false]);
            this.onOut = true;
            this.Money = 0;
            this.triRole = null;
            this.timer = 0;
            this.MoveTo(CanteenMgr.Int.m_stage.RandomB());
            this.OnVipHideHnad();
            EventMgr$1.Int.emit(EventType$1.INIT_VIP_SHOW, 0);
            this.DesTip();
        }
        EnterSce() {
            this.startEnter = true;
            this.Money = 0;
            this.triRole = null;
            this.timer = 0;
            this.MoveTo(RoleMgr.Int.VipPos);
        }
        InitTip(id) {
            if (!this.tipArrow) {
                this.tipId = id;
                console.warn("初始化箭头", this.tipId);
                this.tipArrow = fgui.UIPackage.createObjectFromURL(UIMain$1.Int.TipUrl);
                this.tipArrow.touchable = false;
                this.tipArrow.InitPic(this.tipId);
                UIMain$1.Int.AddTip(this.tipArrow);
                this.tipArrow.Hide();
                this.tipArrow.Show();
            }
        }
        updateTipPos() {
            if (!this.tipArrow)
                return;
            if (!this.tipArrow.isShow)
                return;
            let pos = this._transform.position.clone();
            let v2 = WorldToScreen2(CanteenMgr.Int._camera, pos);
            let P = 1;
            let out = false;
            if (v2.y < 150) {
                v2.y = 150;
                P = 3;
                out = true;
            }
            else if (v2.y > Laya.stage.height - 100) {
                v2.y = Laya.stage.height - 100;
                P = 1;
                out = true;
            }
            if (v2.x < 50) {
                v2.x = 50;
                P = 0;
                out = true;
            }
            else if (v2.x > Laya.stage.width - 50) {
                v2.x = Laya.stage.width - 50;
                P = 2;
                out = true;
            }
            this.tipArrow.updatePos(v2.x, v2.y, P, out);
        }
        DesTip() {
            if (!this.tipArrow)
                return;
            this.tipArrow.removeFromParent();
            this.tipArrow.dispose();
            this.tipArrow = null;
        }
    }

    class RoleMgr {
        constructor() {
            this._clientArr = [];
            this._workerArr = [];
            this._waitArr = [];
            this._waitSettle = [];
            this._minClient = 0;
            this._maxClient = 0;
            this.PathNode = null;
            this.WatingPath = null;
            this.WatingCounterPath = null;
            this.VIPSeat = null;
            this.vipTimer = 0;
        }
        static get Int() {
            if (!this._Int) {
                this._Int = new RoleMgr();
            }
            return this._Int;
        }
        Init(pNode) {
            this.PathNode = pNode;
            this.ClearAll();
            this.WatingPath = this.PathNode.getChildByName("WatingPath");
            this.WatingCounterPath = this.PathNode.getChildByName("WatingCounterPath");
            this.VIPSeat = this.PathNode.getChildByName("VIPSeat");
            RoleMgr.Int.UpdateClientNum();
            Laya.timer.loop(1000, this, this.TimerUpdate);
        }
        ClearAll() {
            for (let index = 0; index < this._workerArr.length; index++) {
                const element = this._workerArr[index];
                let sp = element.owner;
                if (sp) {
                    sp.destroy();
                    sp = null;
                }
            }
            for (let index = 0; index < this._clientArr.length; index++) {
                const element = this._clientArr[index];
                let sp = element.owner;
                if (sp) {
                    sp.destroy();
                    sp = null;
                }
            }
            this._clientArr = [];
            this._workerArr = [];
            this._waitArr = [];
            this._waitSettle = [];
            this.vipTimer = 0;
            Laya.timer.clear(this, this.TimerUpdate);
        }
        TimerUpdate() {
            if (this._clientArr.length < this._minClient) {
                this.AddClient();
            }
            else if (this._clientArr.length < this._maxClient) {
                let rd = Math.random() * 100;
                if (rd > 90) {
                    this.AddClient();
                }
            }
            else ;
            if (CanteenMgr.Int.Vip == null) {
                this.vipTimer += 1;
                if (this.vipTimer > 60) {
                    this.AddVip();
                }
            }
        }
        FrameUpdate() { }
        AddPlayer(v3) {
            let Human = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs3("Human")).clone();
            Human.name = "Player";
            CanteenMgr.Int.Player = Human.addComponent(PlayerRole);
            CanteenMgr.Int.Stage.addChild(Human);
            Human.transform.position = v3.clone();
            CanteenMgr.Int.CameraScript = CanteenMgr.Int.CameraNode.getComponent(FollowScript);
            if (!CanteenMgr.Int.CameraScript) {
                CanteenMgr.Int.CameraScript = CanteenMgr.Int.CameraNode.addComponent(FollowScript);
            }
            CanteenMgr.Int.CameraScript.setAim(Human, new Laya.Vector3(), true);
        }
        UpdateClientNum() {
            let chairNum = ChairMgr.Int.ChairNum;
            let min = chairNum * 3;
            let max = chairNum * 5;
            if (max > 75) {
                min = 70;
                max = 75;
            }
            this._minClient = min;
            this._maxClient = max;
        }
        AddClient() {
            if (!CanteenMgr.Int.Stage)
                return;
            if (this._waitArr.length > 5)
                return;
            let Human = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs3("Human")).clone();
            Human.name = "NPC";
            let scr = Human.addComponent(NpcRole);
            let c = ChairMgr.Int.AllotChiar();
            CanteenMgr.Int.Stage.addChild(Human);
            Human.transform.position = CanteenMgr.Int.m_stage.RandomB();
            let juese_shenti = MyInstrument.GetChildByName(Human, "juese_shenti");
            if (juese_shenti) {
                let mats = juese_shenti.skinnedMeshRenderer.materials;
                let v = new Laya.Vector4(Math.random(), Math.random(), Math.random(), 1);
                mats.forEach((element) => {
                    element._Color = v.clone();
                });
            }
            if (c) {
                if (this._waitArr.length > 0) {
                    let wscr = this._waitArr.splice(0, 1)[0];
                    wscr.ToChair(c);
                    c.GetClient(wscr);
                    this.AddWait(scr);
                }
                else {
                    scr.ToChair(c);
                    c.GetClient(scr);
                }
            }
            else {
                this.AddWait(scr);
            }
            this._clientArr.push(scr);
        }
        SubClient(scr) {
            let i = this._clientArr.indexOf(scr);
            this._clientArr.splice(i, 1);
            scr.destroy();
        }
        AddWait(scr) {
            this._waitArr.push(scr);
            this.GetWaitPos(true);
        }
        AutoWait() {
            if (this._waitArr.length == 0)
                return;
            let c = ChairMgr.Int.AllotChiar();
            if (c) {
                let wscr = this._waitArr.splice(0, 1)[0];
                wscr.ToChair(c);
                c.GetClient(wscr);
                Laya.timer.clear(this, this.GetWaitPos);
                Laya.timer.frameOnce(1, this, this.GetWaitPos);
            }
        }
        AddWorker(tp, pos = null, rot = null) {
            let Human = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs3("Human")).clone();
            let scr = Human.addComponent(WorkRole);
            scr.InitType(tp);
            this._workerArr.push(scr);
            Human.name = tp.toString();
            if (rot) {
                Human.transform.rotationEuler = rot.clone();
            }
            if (pos) {
                Human.transform.position = new Laya.Vector3(pos.x + Math.random() - 0.5, 0, pos.z + Math.random() - 0.5);
            }
            else {
                Human.transform.position = new Laya.Vector3(Math.random() - 0.5, 0, Math.random() - 0.5);
            }
            CanteenMgr.Int.Stage.addChild(Human);
        }
        GetWaitPos(isLast = false) {
            if (CanteenMgr.Int.StageId == 1) {
                this.GetWaitPosStage1(isLast);
            }
            else {
                this.GetWaitPosStage2(isLast);
            }
        }
        GetWaitPosStage1(isLast = false) {
            if (isLast) {
                let index = this._waitArr.length - 1;
                let element = this._waitArr[index];
                if (index < 18) {
                    let t = this.WatingPath.getChildAt(0).transform.position.clone();
                    t.x -= index;
                    element.MoveTo(t);
                }
                else if (index < 22) {
                    let t = this.WatingPath.getChildAt(1).transform.position.clone();
                    t.z += index - 18;
                    element.MoveTo(t);
                }
                else if (index < 30) {
                    let t = this.WatingPath.getChildAt(2).transform.position.clone();
                    t.x += index - 22;
                    element.MoveTo(t);
                }
                else if (index < 34) {
                    let t = this.WatingPath.getChildAt(3).transform.position.clone();
                    t.z += index - 30;
                    element.MoveTo(t);
                }
                else if (index < 42) {
                    let t = this.WatingPath.getChildAt(4).transform.position.clone();
                    t.x -= index - 34;
                    element.MoveTo(t);
                }
                else if (index < 46) {
                    let t = this.WatingPath.getChildAt(5).transform.position.clone();
                    t.z += index - 42;
                    element.MoveTo(t);
                }
                else if (index < 54) {
                    let t = this.WatingPath.getChildAt(6).transform.position.clone();
                    t.x += index - 46;
                    element.MoveTo(t);
                }
                else if (index < 58) {
                    let t = this.WatingPath.getChildAt(7).transform.position.clone();
                    t.z += index - 54;
                    element.MoveTo(t);
                }
                else if (index < 66) {
                    let t = this.WatingPath.getChildAt(8).transform.position.clone();
                    t.x -= index - 58;
                    element.MoveTo(t);
                }
                else if (index < 70) {
                    let t = this.WatingPath.getChildAt(9).transform.position.clone();
                    t.z += index - 66;
                    element.MoveTo(t);
                }
                else {
                    let t = this.WatingPath.getChildAt(9).transform.position.clone();
                    t.z += index - 66;
                    element.MoveTo(t);
                }
            }
            else {
                let array = this._waitArr;
                for (let index = 0; index < array.length; index++) {
                    const element = array[index];
                    if (index < 18) {
                        let t = this.WatingPath.getChildAt(0).transform.position.clone();
                        t.x -= index;
                        element.MoveTo(t);
                    }
                    else if (index < 22) {
                        let t = this.WatingPath.getChildAt(1).transform.position.clone();
                        t.z += index - 18;
                        element.MoveTo(t);
                    }
                    else if (index < 30) {
                        let t = this.WatingPath.getChildAt(2).transform.position.clone();
                        t.x += index - 22;
                        element.MoveTo(t);
                    }
                    else if (index < 34) {
                        let t = this.WatingPath.getChildAt(3).transform.position.clone();
                        t.z += index - 30;
                        element.MoveTo(t);
                    }
                    else if (index < 42) {
                        let t = this.WatingPath.getChildAt(4).transform.position.clone();
                        t.x -= index - 34;
                        element.MoveTo(t);
                    }
                    else if (index < 46) {
                        let t = this.WatingPath.getChildAt(5).transform.position.clone();
                        t.z += index - 42;
                        element.MoveTo(t);
                    }
                    else if (index < 54) {
                        let t = this.WatingPath.getChildAt(6).transform.position.clone();
                        t.x += index - 46;
                        element.MoveTo(t);
                    }
                    else if (index < 58) {
                        let t = this.WatingPath.getChildAt(7).transform.position.clone();
                        t.z += index - 54;
                        element.MoveTo(t);
                    }
                    else if (index < 66) {
                        let t = this.WatingPath.getChildAt(8).transform.position.clone();
                        t.x -= index - 58;
                        element.MoveTo(t);
                    }
                    else if (index < 70) {
                        let t = this.WatingPath.getChildAt(9).transform.position.clone();
                        t.z += index - 66;
                        element.MoveTo(t);
                    }
                    else {
                        let t = this.WatingPath.getChildAt(9).transform.position.clone();
                        t.z += index - 66;
                        element.MoveTo(t);
                    }
                }
            }
        }
        GetWaitPosStage2(isLast = false) {
            if (isLast) {
                let index = this._waitArr.length - 1;
                let element = this._waitArr[index];
                if (index < 5) {
                    let t = this.WatingPath.getChildAt(0).transform.position.clone();
                    t.z -= index;
                    element.MoveTo(t);
                }
                else if (index < 25) {
                    let t = this.WatingPath.getChildAt(1).transform.position.clone();
                    t.x += index - 5;
                    element.MoveTo(t);
                }
                else if (index < 30) {
                    let t = this.WatingPath.getChildAt(2).transform.position.clone();
                    t.z += index - 25;
                    element.MoveTo(t);
                }
                else if (index < 35) {
                    let t = this.WatingPath.getChildAt(3).transform.position.clone();
                    t.x -= index - 30;
                    element.MoveTo(t);
                }
                else if (index < 55) {
                    let t = this.WatingPath.getChildAt(4).transform.position.clone();
                    t.z -= index - 35;
                    element.MoveTo(t);
                }
                else if (index < 60) {
                    let t = this.WatingPath.getChildAt(5).transform.position.clone();
                    t.x += index - 55;
                    element.MoveTo(t);
                }
                else if (index < 80) {
                    let t = this.WatingPath.getChildAt(6).transform.position.clone();
                    t.z -= index - 60;
                    element.MoveTo(t);
                }
                else if (index < 85) {
                    let t = this.WatingPath.getChildAt(7).transform.position.clone();
                    t.x -= index - 80;
                    element.MoveTo(t);
                }
                else {
                    let t = this.WatingPath.getChildAt(7).transform.position.clone();
                    t.x -= index - 80;
                    element.MoveTo(t);
                }
            }
            else {
                let array = this._waitArr;
                for (let index = 0; index < array.length; index++) {
                    const element = array[index];
                    if (index < 5) {
                        let t = this.WatingPath.getChildAt(0).transform.position.clone();
                        t.z -= index;
                        element.MoveTo(t);
                    }
                    else if (index < 25) {
                        let t = this.WatingPath.getChildAt(1).transform.position.clone();
                        t.x += index - 5;
                        element.MoveTo(t);
                    }
                    else if (index < 30) {
                        let t = this.WatingPath.getChildAt(2).transform.position.clone();
                        t.z += index - 25;
                        element.MoveTo(t);
                    }
                    else if (index < 35) {
                        let t = this.WatingPath.getChildAt(3).transform.position.clone();
                        t.x -= index - 30;
                        element.MoveTo(t);
                    }
                    else if (index < 55) {
                        let t = this.WatingPath.getChildAt(4).transform.position.clone();
                        t.z -= index - 35;
                        element.MoveTo(t);
                    }
                    else if (index < 60) {
                        let t = this.WatingPath.getChildAt(5).transform.position.clone();
                        t.x += index - 55;
                        element.MoveTo(t);
                    }
                    else if (index < 80) {
                        let t = this.WatingPath.getChildAt(6).transform.position.clone();
                        t.z -= index - 60;
                        element.MoveTo(t);
                    }
                    else if (index < 85) {
                        let t = this.WatingPath.getChildAt(7).transform.position.clone();
                        t.x -= index - 80;
                        element.MoveTo(t);
                    }
                    else {
                        let t = this.WatingPath.getChildAt(7).transform.position.clone();
                        t.x -= index - 80;
                        element.MoveTo(t);
                    }
                }
            }
        }
        AddWaitSettle(scr) {
            let index = this._waitSettle.indexOf(scr);
            if (index < 0) {
                this._waitSettle.push(scr);
            }
            if (this._waitSettle.length == 1) {
                this.AutoSettle();
            }
            else {
                this.GetWaitSettlePos();
            }
        }
        AutoSettle() {
            if (this._waitSettle.length > 0) {
                let wscr = this._waitSettle[0];
                wscr.ToPay();
                this.GetWaitSettlePos();
            }
        }
        SubSettle(scr) {
            let index = this._waitSettle.indexOf(scr);
            if (index >= 0) {
                this._waitSettle.splice(index, 1);
            }
        }
        GetWaitSettlePos() {
            if (CanteenMgr.Int.StageId == 1) {
                this.GetWaitSettlePosStage1();
            }
            else {
                this.GetWaitSettlePosStage2();
            }
        }
        GetWaitSettlePosStage1() {
            let array = this._waitSettle;
            for (let index = 1; index < array.length; index++) {
                const element = array[index];
                if (index < 4) {
                    let t = this.WatingCounterPath.getChildAt(0).transform.position.clone();
                    t.x += index;
                    element.MoveTo(t);
                }
                else if (index < 20) {
                    let t = this.WatingCounterPath.getChildAt(1).transform.position.clone();
                    t.z -= index - 4;
                    element.MoveTo(t);
                }
                else if (index < 22) {
                    let t = this.WatingCounterPath.getChildAt(2).transform.position.clone();
                    t.x -= index - 20;
                    element.MoveTo(t);
                }
                else if (index < 29) {
                    let t = this.WatingCounterPath.getChildAt(3).transform.position.clone();
                    t.z += index - 22;
                    element.MoveTo(t);
                }
                else if (index < 31) {
                    let t = this.WatingCounterPath.getChildAt(4).transform.position.clone();
                    t.x -= index - 29;
                    element.MoveTo(t);
                }
                else if (index < 38) {
                    let t = this.WatingCounterPath.getChildAt(5).transform.position.clone();
                    t.z -= index - 31;
                    element.MoveTo(t);
                }
                else {
                    let t = this.WatingCounterPath.getChildAt(5).transform.position.clone();
                    t.z -= index - 31;
                    element.MoveTo(t);
                }
                element.OnWaitPay();
            }
        }
        GetWaitSettlePosStage2() {
            let array = this._waitSettle;
            for (let index = 1; index < array.length; index++) {
                const element = array[index];
                if (index < 20) {
                    let t = this.WatingCounterPath.getChildAt(0).transform.position.clone();
                    t.x -= index;
                    element.MoveTo(t);
                }
                else if (index < 22) {
                    let t = this.WatingCounterPath.getChildAt(1).transform.position.clone();
                    t.z += index - 20;
                    element.MoveTo(t);
                }
                else if (index < 42) {
                    let t = this.WatingCounterPath.getChildAt(2).transform.position.clone();
                    t.x += index - 22;
                    element.MoveTo(t);
                }
                else if (index < 44) {
                    let t = this.WatingCounterPath.getChildAt(3).transform.position.clone();
                    t.z += index - 42;
                    element.MoveTo(t);
                }
                else if (index < 62) {
                    let t = this.WatingCounterPath.getChildAt(4).transform.position.clone();
                    t.x -= index - 44;
                    element.MoveTo(t);
                }
                else if (index < 64) {
                    let t = this.WatingCounterPath.getChildAt(5).transform.position.clone();
                    t.z += index - 62;
                    element.MoveTo(t);
                }
                else {
                    let t = this.WatingCounterPath.getChildAt(5).transform.position.clone();
                    t.z += index - 62;
                    element.MoveTo(t);
                }
                element.OnWaitPay();
            }
        }
        FindWorker(tp) {
            let array = this._workerArr;
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                if (element.WorkType == tp && !element.IsWorkIng) {
                    return element;
                }
            }
        }
        FindNpcByType(tp) {
            if (tp == null) {
                return [CanteenMgr.Int.Player.owner];
            }
            let array = this._workerArr;
            let arr = [];
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                if (element.WorkType == tp) {
                    arr.push(element.owner);
                }
            }
            return arr;
        }
        AddVip() {
            if (!CanteenMgr.Int.Stage)
                return;
            if (!ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs3("Human")))
                return;
            let Human = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs3("Human")).clone();
            Human.name = "VIP";
            CanteenMgr.Int.Vip = Human.addComponent(VipRole);
            CanteenMgr.Int.Stage.addChild(Human);
            Human.transform.position = CanteenMgr.Int.m_stage.RandomB();
        }
        SubVip(scr) {
            let sp = scr.owner;
            if (sp) {
                sp.destroy();
                sp = null;
            }
            CanteenMgr.Int.Vip = null;
        }
        get VipPos() {
            return this.VIPSeat.transform.position.clone();
        }
    }

    class ChairMgr {
        constructor() {
            this._chairArr = [];
        }
        static get Int() {
            if (!this._Int) {
                this._Int = new ChairMgr();
            }
            return this._Int;
        }
        AddChiar(chair) {
            this._chairArr.push(chair);
            RoleMgr.Int.UpdateClientNum();
        }
        SubChair(chair) {
            let index = this._chairArr.indexOf(chair);
            if (index < 0)
                return;
            this._chairArr.splice(index, 1);
            RoleMgr.Int.UpdateClientNum();
            let obj = chair.owner;
            obj.removeSelf();
            obj.destroy();
            obj = null;
        }
        AllotChiar() {
            let chair = this.FindNoFull();
            if (!chair)
                return null;
            return chair;
        }
        FindNoFull() {
            let array = this._chairArr;
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                if (element.Full == false) {
                    return element;
                }
            }
            return null;
        }
        get AllBlankDishNum() {
            let array = this._chairArr;
            let num = 0;
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                num += element.BlanDishNum;
            }
            return num;
        }
        get ChairNum() {
            return this._chairArr.length;
        }
        ClearAll() {
            this._chairArr = [];
        }
    }

    var WorkType;
    (function (WorkType) {
        WorkType[WorkType["normal"] = 0] = "normal";
        WorkType[WorkType["counter"] = 1] = "counter";
        WorkType[WorkType["waiter"] = 2] = "waiter";
        WorkType[WorkType["cook"] = 3] = "cook";
        WorkType[WorkType["fishing"] = 4] = "fishing";
    })(WorkType || (WorkType = {}));
    class WorkRole extends BaseRole {
        constructor() {
            super();
            this._aimPackge = null;
        }
        InitType(tp) {
            this._workType = tp;
        }
        onAwake() {
            super.onAwake();
            this.RoleType = RoleType.waiter;
            this.InitModel();
            this.InitPowerLevel();
        }
        onEnable() {
            this.InitWork();
        }
        onUpdate() {
            if (!this._mover.IsAt) {
                this.FMachine.SetCurState(this.runState);
            }
            else {
                if (this.FMachine.GetCurState() != this.workState) {
                    this.FMachine.SetCurState(this.idleState);
                }
            }
        }
        InitPowerLevel() {
            let data = LogicData.instance.CanteenPowerLevel;
            this._mover._speed = 0.05 * GameData.getWaiterSpeedItem(data.Speed3).Speed;
            this.packge.Size = GameData.getWaiterNumItem(data.ServingCarry).Speed;
        }
        InitWork() {
            switch (this._workType) {
                case WorkType.counter:
                    this.OnCounter();
                    break;
                case WorkType.waiter:
                    this.OnWaiter();
                    break;
                case WorkType.cook:
                    this.OnCook();
                    break;
                case WorkType.fishing:
                    this.OnFish();
                    break;
            }
        }
        NoWork() {
            if (this.FMachine.GetCurState() == this.noWorkState)
                return;
            this._moveEndTaget = null;
            this._aimPackge = null;
            this.MoveTo(CanteenMgr.Int.m_stage.RandomB());
        }
        InitComponent() {
            this._mover = this._obj.addComponent(AimPathMover);
        }
        InitPackge() {
            super.InitPackge();
            if (this.packge) {
                this.packge.Init(8, 2, GoodsType.all, this, true);
                this.packge.MaxHandler = Laya.Handler.create(this, this.OnPackgeOver, null, false);
                this.packge.BlankHandler = Laya.Handler.create(this, this.OnPackgeOver, null, false);
                this.packge.TagetMaxHandler = Laya.Handler.create(this, this.OnPackgeOver, null, false);
                this.packge.TagetBlankHandler = Laya.Handler.create(this, this.OnPackgeOver, null, false);
                this.packge.LockTri();
            }
        }
        OnPackgeOver() {
            if (this.packge)
                this.packge.BreakPackge();
            this.OnWaiter();
        }
        OnCounter() {
            if (CanteenMgr.Int.counter.FullWorker || !CanteenMgr.Int.counter.UnLock) {
                this.NoWork();
                return;
            }
            this._moveEndTaget = CanteenMgr.Int.counter;
            let v3 = CanteenMgr.Int.counter.WorkPos;
            this.MoveTo(v3);
        }
        OnWaiter() {
            let tp = this.packge.GoodsType;
            if (tp == -1) {
                if (ChairMgr.Int.AllBlankDishNum > 5) {
                    let rd = Math.random() * 100;
                    if (rd < 50) {
                        this.OnMoveFish();
                    }
                    else {
                        this.OnMoveDish();
                    }
                }
                else {
                    this.OnMoveFish();
                }
            }
            else if (tp == GoodsType.dish) {
                this.OnWashDish();
            }
            else if (tp == GoodsType.food) {
                this.OnFishToCook();
            }
        }
        OnCook() {
            this._moveEndTaget = InterMgr.Int.FindWork(WorkType.cook);
            if (this._moveEndTaget) {
                this._moveEndTaget.isYuYue = true;
                this.MoveTo(this._moveEndTaget.WorkPos);
            }
            else {
                this.NoWork();
            }
        }
        OnFish() {
            this._moveEndTaget = InterMgr.Int.FindWork(WorkType.fishing);
            if (this._moveEndTaget) {
                this._moveEndTaget.isYuYue = true;
                this.MoveTo(this._moveEndTaget.WorkPos);
            }
            else {
                console.warn("渔夫没有工作位置");
                this.NoWork();
            }
        }
        OnMoveFish() {
            let pkg = InterMgr.Int.FindInterPackge(CanteenType.fish, 1);
            if (!pkg) {
                console.warn("没有找到合适的位置");
                this.NoWork();
                return;
            }
            pkg.isYuYue = true;
            this._aimPackge = pkg;
            this.MoveTo(pkg.Pos);
        }
        OnFishToCook() {
            let pkg = InterMgr.Int.FindInterPackge(CanteenType.cook, -1);
            if (!pkg) {
                this.NoWork();
                return;
            }
            pkg.isYuYue = true;
            this._aimPackge = pkg;
            this.MoveTo(pkg.Pos);
        }
        OnMoveDish() {
            let pkg = InterMgr.Int.FindInterPackge(CanteenType.chair, 1);
            if (!pkg) {
                this.NoWork();
                return;
            }
            pkg.isYuYue = true;
            this._aimPackge = pkg;
            this.MoveTo(pkg.Pos);
        }
        OnWashDish() {
            let pkg = InterMgr.Int.FindInterPackge(CanteenType.dish, -1);
            if (!pkg) {
                this.NoWork();
                return;
            }
            pkg.isYuYue = true;
            this._aimPackge = pkg;
            let dis = this._aimPackge.OwnerScr;
            this.MoveTo(dis.NPCpos);
        }
        MoveTo(v3) {
            if (!this._mover)
                return;
            let mover = this._mover;
            this.FMachine.SetCurState(this.runState);
            let p = this._transform.localPosition.clone();
            v3.y = 0;
            let path = PathFindMgr.Int.findPath(p, v3);
            PathFindMgr.Int.drawPath(path);
            if (path.length <= 2) {
                path = [v3];
            }
            else if (path.length > 2) {
                let dis1 = Laya.Vector3.distanceSquared(path[path.length - 2], path[path.length - 1]);
                let dis2 = Laya.Vector3.distanceSquared(path[path.length - 2], v3);
                if (dis1 >= dis2) {
                    path[path.length - 1] = v3;
                }
                else {
                    path.push(v3);
                }
            }
            else {
                path = [v3];
            }
            mover.SetPath(path);
            mover.SetHandler(Laya.Handler.create(this, this.OnMoveOver, null, false));
        }
        OnMoveOver() {
            this.FMachine.SetCurState(this.idleState);
            if (this._moveEndTaget) {
                if (this._moveEndTaget.FullWorker) {
                    this.InitWork();
                }
                else {
                    this._moveEndTaget.SetTaget(this);
                }
                return;
            }
            if (this._aimPackge) {
                if (this.packge) {
                    if (this._aimPackge.PackgeLevel < this.packge.PackgeLevel) {
                        this._aimPackge.AddJoint(this.packge);
                    }
                    else {
                        this.packge.AddJoint(this._aimPackge);
                    }
                }
                return;
            }
            if (this.FMachine.GetCurState() == this.noWorkState)
                return;
            this.FMachine.SetCurState(this.noWorkState);
        }
        get WorkType() {
            return this._workType;
        }
    }

    class InterMgr {
        constructor() {
            this._interArr = [];
        }
        static get Int() {
            if (!this._Int) {
                this._Int = new InterMgr();
            }
            return this._Int;
        }
        ClearAll() {
            let array = this._interArr;
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                let sp = element.owner;
                if (sp) {
                    sp.destroy();
                    sp = null;
                }
            }
            this._interArr = [];
        }
        AddInter(inter) {
            this._interArr.push(inter);
        }
        SubInter(inter) {
            let i = this._interArr.indexOf(inter);
            if (i >= 0) {
                this._interArr.splice(i, 1);
            }
        }
        FindWork(tp) {
            if (tp == WorkType.fishing) {
                console.warn("渔夫找工作");
            }
            let array = this._interArr;
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                if (element.m_WorkerType == tp &&
                    !element.isYuYue &&
                    !element.FullWorker &&
                    element.UnLock &&
                    !element.isTuna) {
                    return element;
                }
            }
            return null;
        }
        FindInterPackge(gtp, maxMin = 0) {
            let array = this._interArr;
            let scr = null;
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                let packge = element.packge;
                if (packge && packge.cType == gtp && element.UnLock) {
                    if (maxMin == 0) {
                        return element;
                    }
                    if (maxMin == -1) {
                        if (scr == null || scr.GoodsNum > packge.GoodsNum) {
                            scr = packge;
                        }
                    }
                    else if (maxMin == 1) {
                        if (scr == null || scr.GoodsNum < packge.GoodsNum) {
                            scr = packge;
                        }
                    }
                }
            }
            return scr;
        }
    }

    class BigFish extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.pieceNum = 8;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this.InitPiece();
        }
        SubPiece() {
            if (this.pieceNum <= 0)
                return false;
            this.pieceNum -= 1;
            this.InitPiece();
            return true;
        }
        InitPiece() {
            for (let index = 1; index < this._obj.numChildren; index++) {
                const element = this._obj.getChildAt(index);
                if (index <= this.pieceNum) {
                    element.active = true;
                }
                else {
                    element.active = false;
                }
            }
        }
    }

    class EffectItem extends Laya.Script3D {
        constructor() {
            super();
            this.loopCount = 0;
        }
        onAwake() {
            this.node = this.owner;
        }
        onStart() {
            this.loopCount = this.data.LoopCount;
            this.onPlayEffect();
        }
        onPlayEffect() {
            let eff = this.node;
            if (eff && eff.particleSystem) {
                eff.particleSystem.play();
            }
            else {
                eff = this.node.getChildAt(0);
                if (eff && eff.particleSystem) {
                    eff.particleSystem.play();
                }
            }
            if (this.data) {
                Laya.timer.once(this.data.OffTime, this, this.onEffecEndHandler);
            }
        }
        onEffecEndHandler() {
            this.loopCount--;
            if (this.loopCount < 0) {
                this.onPlayEffect();
            }
            else {
                Laya.timer.clearAll(this);
                this.node.removeSelf();
                this.node.destroy(true);
                this.destroy();
            }
        }
    }
    class EffectMgr {
        constructor() {
            this._orgX = 0;
            this._orgY = 0;
            this._isShaking = false;
            this._offsetPos = [0, 0];
            this.shank_I = 0;
            this.cache = {};
        }
        static get Int() {
            if (EffectMgr._Int == null) {
                EffectMgr._Int = new EffectMgr();
            }
            return EffectMgr._Int;
        }
        showEffectPos(pos, raotion, effectId, sceId = 0) {
            let node = CanteenMgr.Int.scene;
            this.onLoadEffectHandler1(node, pos, raotion, effectId);
        }
        loadprefab(effectId) {
            let effData = GameData.getEffectItem(effectId);
            let path = RescoureData.EFFECT_SCENE + effData.PrefabName + ".lh";
            ResourcesMgr$1.instance.load(path, (enode) => {
                this.cache[path] = enode;
            });
        }
        onLoadEffectHandler1(node, pos, raotion, effectId) {
            let effData = GameData.getEffectItem(effectId);
            let path = RescoureData.EFFECT_SCENE + effData.PrefabName + ".lh";
            if (this.cache[path]) {
                var effect = this.cache[path].clone();
                node.addChild(effect);
                effect.transform.position = pos;
                if (raotion)
                    effect.transform.rotation = raotion;
                var effectView = effect.addComponent(EffectItem);
                effectView.data = effData;
                return;
            }
            ResourcesMgr$1.instance.load(path, (enode) => {
                this.cache[path] = enode;
                var effect = enode.clone();
                node.addChild(effect);
                effect.transform.position = pos;
                if (raotion)
                    effect.transform.rotation = raotion;
                var effectView = effect.addComponent(EffectItem);
                effectView.data = effData;
            });
        }
        showEffect(node, effectId) {
            this.onLoadEffectHandler(node, effectId);
        }
        onLoadEffectHandler(node, effectId) {
            let effData = GameData.getEffectItem(effectId);
            let path = RescoureData.EFFECT_SCENE + effData.PrefabName + ".lh";
            ResourcesMgr$1.instance.load(path, (enode) => {
                var effect = Laya.Sprite3D.instantiate(enode);
                node.addChild(effect);
                effect.transform.localPosition = v3_zeor;
                effect.transform.localRotationEuler = v3_zeor;
                effect.transform.localScale = new Laya.Vector3(1, 1, 1);
                var effectView = effect.addComponent(EffectItem);
                effectView.data = effData;
            });
        }
        showShockEffect(target, intensity, duration, radius) {
            if (this._isShaking) {
                return;
            }
            this._isShaking = true;
            this._startTime = Laya.timer.currTimer;
            this._target = target;
            this._orgX = target.transform.position.x;
            this._orgY = target.transform.position.y;
            this._offsetPos = [0, 0];
            this.shank_I = 0;
            Laya.timer.loop(intensity, this, this.onLoopUpdataHandler, [duration, radius]);
        }
        onLoopUpdataHandler(duration, radius) {
            this._offsetPos[this.shank_I % 2] = this._offsetPos[this.shank_I % 2] > 0 ? -radius : radius;
            this.shank_I++;
            this._target.transform.localPositionX += this._offsetPos[0];
            this._target.transform.localPositionY += this._offsetPos[1];
            if (Laya.timer.currTimer - this._startTime >= duration) {
                Laya.timer.clear(this, this.onLoopUpdataHandler);
                this.shank_I = 0;
                this._isShaking = false;
                this._target.transform.position.x = this._orgX;
                this._target.transform.position.y = this._orgY;
                this._target = null;
            }
        }
    }
    EffectMgr._Int = null;

    class LockScript extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.Unlock = false;
            this.Open = null;
            this.Close = null;
            this.Sign = null;
            this.uplevel = null;
            this.UnlockHandler = null;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this.Open = this._obj.getChildByName("Open");
            this.Close = this._obj.getChildByName("Close");
            if (!this.Open || !this.Close)
                return;
            this.InitLevel();
        }
        InitLevel() {
            this.Open.active = false;
            this.Close.active = true;
            this.Unlock = false;
        }
        UnLock(isInit) {
            if (!this.Open || !this.Close)
                return;
            if (this.Unlock)
                return;
            this.Unlock = true;
            this.Open.active = true;
            this.Close.active = false;
            EffectMgr.Int.showEffectPos(this._transform.position.clone(), new Laya.Vector3(), 1);
            if (this.UnlockHandler) {
                this.UnlockHandler.runWith(isInit);
            }
        }
        SetUplevelScript(scr) {
            this.uplevel = scr;
        }
        SetBuildId(num) {
            this.uplevel.InitUpLevelId(num);
        }
        get BuildId() {
            return 1;
        }
    }

    class CanteenInter extends Packger {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.isYuYue = false;
            this._tagetRole = null;
            this._clientRole = null;
            this._timer = 0;
            this._workPos = null;
            this._workRot = null;
            this.m_WorkerType = null;
            this._unlockTaget = null;
            this.timerMax = 2000;
            this.isTuna = false;
            this.bigFish = null;
            this.isBan = false;
            this.BuildId = 1;
        }
        onAwake() {
            super.onAwake();
            InterMgr.Int.AddInter(this);
            let WorkerNode = MyInstrument.GetChildByName(this._obj, "WorkerNode");
            if (WorkerNode) {
                this._workPos = WorkerNode.transform.position.clone();
                this._workRot = WorkerNode.transform.rotationEuler.clone();
                let scr = WorkerNode.addComponent(WorkNodeTri);
                scr.InitInter(this);
            }
            else {
                this._workPos = this._transform.position.clone();
                this._workRot = this._transform.rotationEuler.clone();
                this._workRot.y += 180;
            }
        }
        onEnable() {
            this._unlockTaget = this._obj.getComponent(LockScript);
            if (this._unlockTaget) {
                this._unlockTaget.SetBuildId(this.BuildId);
                this._unlockTaget.UnlockHandler = Laya.Handler.create(this, this.OnUnlock, null, false);
                if (this.packge) ;
            }
        }
        onUpdate() {
            if (!this._tagetRole)
                return;
            this._timer += Laya.timer.delta;
            if (this._timer >= this.timerMax) {
                this.TimerHandler();
            }
        }
        SetMustTaget(role) {
            let scr = this._tagetRole;
            if (scr) {
                scr.StopWork(false);
            }
            this.isYuYue = false;
            this._tagetRole = role;
            this._timer = 0;
            role.StartWork(this);
            if (scr) {
                scr.InitWork();
            }
        }
        SetTaget(role) {
            if (role && this._tagetRole) {
                return;
            }
            this.isYuYue = false;
            this._tagetRole = role;
            this._timer = 0;
            if (role) {
                role.StartWork(this);
            }
        }
        TimerHandler() {
            this._timer = 0;
        }
        SetClient(role) {
            if (role && this._clientRole) {
                return;
            }
            this._clientRole = role;
        }
        AddBigFish(sp) {
            this.SubBigFish();
            let TunaNode = this._obj.getChildByName("TunaNode");
            if (TunaNode) {
                TunaNode.addChild(sp);
                sp.transform.localPosition = new Laya.Vector3();
                sp.transform.localRotationEuler = new Laya.Vector3();
                let scr = sp.getComponent(BigFish);
                if (!scr) {
                    this.bigFish = sp.addComponent(BigFish);
                }
            }
        }
        SubBigFish() {
            let TunaNode = this._obj.getChildByName("TunaNode");
            if (TunaNode) {
                TunaNode.destroyChildren();
            }
            this.bigFish = null;
        }
        get WorkPos() {
            return this._workPos.clone();
        }
        get WorkRot() {
            return this._workRot.clone();
        }
        get FullWorker() {
            return this._tagetRole != null;
        }
        get UnLock() {
            if (this._unlockTaget) {
                return this._unlockTaget.Unlock;
            }
            return true;
        }
        TimerPro() {
            return (this._timer / this.timerMax) * 100;
        }
    }

    class CCounter extends CanteenInter {
        constructor() {
            super();
            this.PayNode = null;
            this.cType = CanteenType.counter;
            this.nodTimer = 0;
            this.mStack = null;
            this.tipArrow = null;
            this.tipId = 0;
            this.m_WorkerType = WorkType.counter;
            this.BuildId = 2;
        }
        onAwake() {
            super.onAwake();
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this.PayNode = this._obj.getChildByName("PayNode");
            this.InitPowerLevel();
            let MoneyStack = MyInstrument.GetChildByName(this._obj, "MoneyStack");
            this.mStack = MoneyStack.addComponent(MStack);
            this.InitTip(1);
        }
        onUpdate() {
            super.onUpdate();
            if (this._tagetRole) {
                this.nodTimer += Laya.timer.delta;
                if (this.nodTimer >= 8000) {
                    this.nodTimer = 0;
                    this._tagetRole.Nod();
                }
            }
            else {
                this.nodTimer = 0;
            }
            if (this._clientRole && !this._tagetRole) {
                this.tipArrow.Show();
            }
            else {
                this.tipArrow.Hide();
            }
            this.updateTipPos();
        }
        onDestroy() {
            this.DesTip();
        }
        InitPowerLevel() {
            this.timerMax = 700;
        }
        get PayPos() {
            return this.PayNode.transform.position.clone();
        }
        TimerHandler() {
            super.TimerHandler();
            if (this._tagetRole && this._clientRole) {
                this.nodTimer = 0;
                let n = this._clientRole.Pay();
                this.mStack.AddMoney(n, this.PayNode.transform.position.clone());
                this._tagetRole.OnWork(this.m_WorkerType);
            }
        }
        InitTip(id) {
            if (!this.tipArrow) {
                this.tipId = id;
                console.warn("初始化箭头", this.tipId);
                this.tipArrow = fgui.UIPackage.createObjectFromURL(UIMain$1.Int.TipUrl);
                this.tipArrow.touchable = false;
                this.tipArrow.InitPic(this.tipId);
                UIMain$1.Int.AddTip(this.tipArrow);
                this.tipArrow.Hide();
            }
        }
        updateTipPos() {
            if (!this.tipArrow)
                return;
            if (!this.tipArrow.isShow)
                return;
            let pos = this._transform.position.clone();
            let v2 = WorldToScreen2(CanteenMgr.Int._camera, pos);
            let P = 1;
            let out = false;
            if (v2.y < 150) {
                v2.y = 150;
                P = 3;
                out = true;
            }
            else if (v2.y > Laya.stage.height - 100) {
                v2.y = Laya.stage.height - 100;
                P = 1;
                out = true;
            }
            if (v2.x < 50) {
                v2.x = 50;
                P = 0;
                out = true;
            }
            else if (v2.x > Laya.stage.width - 50) {
                v2.x = Laya.stage.width - 50;
                P = 2;
                out = true;
            }
            this.tipArrow.updatePos(v2.x, v2.y, P, out);
        }
        DesTip() {
            if (!this.tipArrow)
                return;
            this.tipArrow.removeFromParent();
            this.tipArrow.dispose();
            this.tipArrow = null;
        }
        TimerPro() {
            return 0;
        }
        OnUnlock(isInit) {
            UIMain$1.Int.InitGuideTip(7, false);
            UIMain$1.Int.InitGuideTip(8);
            if (!isInit)
                ReportMgr.inst.sendReport("解锁收银台" + ReportMgr.inst.getNextIdByBuild(3));
        }
        SetTaget(role) {
            ReportMgr.inst.sendReport(ReportType.FIRST_GOGETMONEY);
            super.SetTaget(role);
        }
    }

    class CCrops extends CanteenInter {
        constructor() {
            super();
            this.makeId = 2;
            this.cType = CanteenType.fish;
            this.BranchNode = null;
            console.warn("农作物创建");
            this.BuildId = -1;
        }
        OnUnlock(isInit) {
            if (!isInit)
                ReportMgr.inst.sendReport("解锁农作物" + ReportMgr.inst.getNextIdByBuild(4));
        }
        onAwake() {
            super.onAwake();
            this._tagetRole = new BaseRole();
            this.BranchNode = MyInstrument.GetChildByName(this._obj, "BranchNode");
            this.InitPowerLevel();
        }
        onEnable() {
            this._unlockTaget = this._obj.getComponent(LockScript);
            if (this._unlockTaget) {
                this._unlockTaget.SetBuildId(this.BuildId);
            }
        }
        onUpdate() {
            if (this._unlockTaget && this._unlockTaget.Unlock) {
                this._timer += Laya.timer.delta;
                if (this._timer >= this.timerMax) {
                    this.TimerHandler();
                }
            }
        }
        SetMakeId(num) {
            this.makeId = num;
            if (this.makeId == 7) {
                this.packge.Size = 3;
                let posarr = [];
                let rotarr = [new Laya.Vector3(-90, 174, 0), new Laya.Vector3(-90, 0, 0), new Laya.Vector3(-90, 90, 0)];
                for (let index = 0; index < this.BranchNode.numChildren; index++) {
                    const element = this.BranchNode.getChildAt(index);
                    posarr.push(element.transform.localPosition.clone());
                }
                this.packge.InitPosRot(posarr, rotarr);
            }
            else {
                this.packge.Size = 1;
            }
        }
        InitPackge() {
            super.InitPackge();
            if (this.packge) {
                this.packge.Init(1, 0, GoodsType.food, this, false);
            }
        }
        InitPowerLevel() {
            let data = LogicData.instance.CanteenPowerLevel;
            this.timerMax = 4000 / GameData.getFishSpeedItem(data.Speed1).Speed;
        }
        TimerHandler() {
            super.TimerHandler();
            this.AddGoods();
        }
        AddGoods() {
            if (this.packge.Full) {
                return;
            }
            let scr = GoodsMgr.Int.AddGoods(this.makeId);
            this.packge.Add(scr);
        }
    }

    class CDishWasher extends CanteenInter {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.cType = CanteenType.dish;
            this.Open = null;
            this.Close = null;
            this.DishWasher_Cap = null;
            this.EffNode = null;
            this.NPCPOS = null;
            this.shackTween = null;
            this.BuildId = 3;
        }
        onAwake() {
            super.onAwake();
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this.EffNode = this._obj.getChildByName("EffNode");
            this.NPCPOS = this._obj.getChildByName("NPCPOS");
            this.Open = this._obj.getChildByName("Open");
            this.Close = this._obj.getChildByName("Close");
            this.DishWasher_Cap = MyInstrument.GetChildByName(this._obj, "DishWasher_Cap");
            this.OnShack(false);
            this.OnEff(0);
        }
        onDestroy() {
            this._obj = null;
            Laya.timer.clear(this, this.OnEff);
            Laya.Tween.clearAll(this.DishWasher_Cap.transform);
            if (this.shackTween) {
                this.shackTween.clear();
            }
        }
        InitPackge() {
            super.InitPackge();
            if (this.packge) {
                this.packge.Init(10, 4, GoodsType.dish, this, true);
                this.packge.OnAddHandler = Laya.Handler.create(this, this.OnPackgeAddGoods, null, false);
                this.packge.OverHandler = Laya.Handler.create(this, this.TryRinse, null, false);
                this.packge.OnBreakHandler = Laya.Handler.create(this, this.TryRinse, null, false);
            }
        }
        OnPackgeAddGoods() {
            if (this.packge.Full) {
                this.StartRinse();
            }
        }
        TryRinse() {
            if (this.packge.GoodsNum > 0) {
                this.StartRinse();
            }
        }
        StartRinse() {
            ReportMgr.inst.sendReport(ReportType.FIRST_USEWASHMC);
            AudioMgr$1.instance.play_sound(3);
            Laya.timer.once(3000, this, this.RinseOver);
            Laya.Tween.to(this.DishWasher_Cap.transform, { localPositionY: 4 }, 300);
            this.OnEff(2);
            this.OnShack(true);
        }
        RinseOver() {
            this.packge.Clear();
            Laya.Tween.to(this.DishWasher_Cap.transform, { localPositionY: 7 }, 300);
            this.OnEff(1);
            this.OnShack(false);
        }
        OnEff(num = 0) {
            if (num == 0) {
                this.EffNode.getChildAt(0).active = false;
                this.EffNode.getChildAt(1).active = false;
            }
            else if (num == 1) {
                this.EffNode.getChildAt(0).active = false;
                this.EffNode.getChildAt(1).active = true;
            }
            else if (num == 2) {
                this.EffNode.getChildAt(0).active = true;
                this.EffNode.getChildAt(1).active = false;
                Laya.timer.once(500, this, this.OnEff, [0]);
            }
        }
        OnShack(bl) {
            if (bl) {
                this.Shack();
            }
            else {
                if (this.shackTween) {
                    this.shackTween.clear();
                    Laya.Tween.clearAll(this._obj.transform);
                    this._obj.transform.localRotationEulerZ = 0;
                    this.shackTween = null;
                }
            }
        }
        Shack() {
            this.ShackLeft();
        }
        ShackLeft() {
            if (!this._obj)
                return;
            if (!this._obj.transform)
                return;
            this.shackTween = Laya.Tween.to(this._obj.transform, { localRotationEulerZ: 1 }, 50, null, Laya.Handler.create(this, this.ShackRght));
        }
        ShackRght() {
            if (!this._obj)
                return;
            if (!this._obj.transform)
                return;
            this.shackTween = Laya.Tween.to(this._obj.transform, { localRotationEulerZ: -1 }, 50, null, Laya.Handler.create(this, this.ShackLeft));
        }
        get NPCpos() {
            return this.NPCPOS.transform.position.clone();
        }
        OnUnlock(isInit) {
            if (!isInit)
                ReportMgr.inst.sendReport("解锁洗碗机" + ReportMgr.inst.getNextIdByBuild(5));
        }
    }

    class CFishing extends CanteenInter {
        constructor() {
            super();
            this.makeId = 2;
            this.cType = CanteenType.fish;
            this.FishingLod = null;
            this.EffNode = null;
            this.m_WorkerType = WorkType.fishing;
            this.BuildId = 18;
        }
        Init(i, stageId) {
            switch (i) {
                case 0:
                    if (stageId == 2) {
                        this.makeId = 8;
                    }
                    else {
                        this.makeId = 2;
                    }
                    break;
                case 1:
                    if (stageId == 2) {
                        this.makeId = 9;
                    }
                    else {
                        this.makeId = 3;
                    }
                    break;
                case 2:
                    if (stageId == 2) {
                        this.makeId = 10;
                    }
                    else {
                        this.makeId = 4;
                    }
                    break;
                case 3:
                    this.makeId = 5;
                    break;
                case 4:
                    this.makeId = 6;
                    break;
            }
        }
        onAwake() {
            super.onAwake();
            this.FishingLod = MyInstrument.GetChildByName(this._obj, "FishingLod");
            this.EffNode = MyInstrument.GetChildByName(this._obj, "EffNode");
            this.m_WorkerType = WorkType.fishing;
            this.InitPowerLevel();
            this.StopEff();
        }
        onDestroy() {
            Laya.timer.clear(this, this.StopEff);
            Laya.timer.clear(this, this.AddFishGoods);
            super.onDestroy();
        }
        InitPowerLevel() {
            let data = LogicData.instance.CanteenPowerLevel;
            this.timerMax = 5000 / GameData.getFishSpeedItem(data.Speed1).Speed;
            this.packge.Size = GameData.getFishNumItem(data.Storage1).Speed;
        }
        InitPackge() {
            super.InitPackge();
            if (this.packge) {
                this.packge.Init(10, 0, GoodsType.food, this, true);
                this.packge.InitTip(2);
            }
        }
        SetTaget(role) {
            ReportMgr.inst.sendReport(ReportType.FIRST_FISHING);
            super.SetTaget(role);
            if (role) {
                if (this.FishingLod)
                    this.FishingLod.active = false;
            }
            else {
                if (this.FishingLod)
                    this.FishingLod.active = true;
            }
        }
        TimerHandler() {
            super.TimerHandler();
            this.AddFish();
        }
        AddFish() {
            if (this.packge.Full) {
                this._tagetRole.Nod();
                return;
            }
            this.PlayEff();
            this._tagetRole.DragFish();
            Laya.timer.once(100, this, this.AddFishGoods);
            StepMgr.Int.OnFinshGuide(GuideType.T_StackCheck, "Icebox");
        }
        AddFishGoods() {
            UIMain$1.Int.InitGuideTip(2, false);
            UIMain$1.Int.InitGuideTip(3);
            let scr = GoodsMgr.Int.AddGoods(this.makeId, this.EffNode.transform.position.clone());
            this.packge.Add(scr);
        }
        PlayEff() {
            this.EffNode.active = true;
            Laya.timer.once(200, this, this.StopEff);
        }
        StopEff() {
            this.EffNode.active = false;
        }
        OnUnlock(isInit) {
            if (!isInit)
                ReportMgr.inst.sendReport("解锁钓鱼台" + ReportMgr.inst.getNextIdByBuild(6));
            UIMain$1.Int.InitGuideTip(1, false);
            UIMain$1.Int.InitGuideTip(2);
        }
    }

    class BezierScript extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.startPos = null;
            this.topPos = null;
            this.endPos = null;
            this.lerpNum = 0;
            this.lerpSpeed = 0.01;
            this.start = false;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
        }
        onUpdate() {
            if (!this.start)
                return;
            this.updateBezier();
        }
        BezierTo(sPos, ePos, tPos = null) {
            this.start = true;
            this.lerpNum = 0;
            this.startPos = sPos;
            this.endPos = ePos;
            if (tPos) {
                this.topPos = tPos;
            }
            else {
                let y = this.startPos.y;
                if (y < this.endPos.y) {
                    y = this.endPos.y;
                }
                this.topPos = new Laya.Vector3((this.startPos.x + this.endPos.x) / 2, y + 10, (this.startPos.z + this.endPos.z) / 2);
            }
        }
        updateBezier() {
            this.lerpNum += this.lerpSpeed;
            if (this.lerpNum > 1) {
                this.lerpNum = 1;
                this.updatePos();
                Laya.timer.clear(this, this.updateBezier);
                this.lerpNum = 0;
                this.start = false;
                return;
            }
            this.updatePos();
        }
        updatePos() {
            let pos = this.getLerpPos(this.startPos, this.topPos, this.endPos, this.lerpNum);
            this._transform.position = pos.clone();
        }
        getLerpPos(a, b, c, t) {
            if (t <= 0)
                return a.clone();
            if (t >= 1)
                return c.clone();
            let out1 = new Laya.Vector3();
            Laya.Vector3.subtract(b, a, out1);
            out1.x *= t;
            out1.y *= t;
            out1.z *= t;
            out1.x += a.x;
            out1.y += a.y;
            out1.z += a.z;
            Laya.Bezier;
            let out2 = new Laya.Vector3();
            Laya.Vector3.subtract(c, b, out2);
            out2.x *= t;
            out2.y *= t;
            out2.z *= t;
            out2.x += b.x;
            out2.y += b.y;
            out2.z += b.z;
            return new Laya.Vector3((out2.x - out1.x) * t + out1.x, (out2.y - out1.y) * t + out1.y, (out2.z - out1.z) * t + out1.z);
        }
    }

    class CShip extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.timer = 0;
            this.triRole = null;
            this.bigFish = false;
            this.Path = [];
            this.tt = null;
            this.bz = null;
            this.maxTimer = 800;
            this.modelName = "ShipModel";
            this.modelName2 = "Tuna";
            this.tipArrow = null;
            this.tipId = 0;
        }
        InitPath(arr) {
            this.Path = arr;
            EventMgr$1.Int.on(EventType$1.SHIP_ENTER, this.MakeFish, this);
            this.NoFish(true);
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this.bz = this._obj.addComponent(BezierScript);
            this.tt = MyInstrument.GetChildByName(this._obj, "tt");
            CanteenMgr.Int.Ship = this;
            this.LoadModel();
            this.LoadModel2();
        }
        onUpdate() {
            if (this.triRole) {
                console.log("YYYYYYYYYYY");
                this.timer += Laya.timer.delta;
                if (this.timer >= this.maxTimer) {
                    this.OnRoleFish();
                }
            }
            this.updateTipPos();
        }
        onDisable() {
            EventMgr$1.Int.off(EventType$1.SHIP_ENTER, this.MakeFish, this);
        }
        onDestroy() {
            EventMgr$1.Int.off(EventType$1.SHIP_ENTER, this.MakeFish, this);
        }
        onTriggerEnter(other) {
            let scr = other.owner.getComponent(PlayerRole);
            if (scr && this.bigFish) {
                this.timer = 0;
                this.triRole = scr;
            }
        }
        onTriggerExit(other) {
            let scr = other.owner.getComponent(PlayerRole);
            if (scr) {
                this.timer = 0;
                this.triRole = null;
            }
        }
        LoadModel() {
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(this.modelName), (res) => {
                this.AddModel(res);
            });
        }
        AddModel(res) {
            let sp = res.clone();
            this._obj.addChild(sp);
            sp.transform.localPosition = new Laya.Vector3(0, -3.5, 0);
            sp.transform.localRotationEuler = new Laya.Vector3();
        }
        LoadModel2() {
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(this.modelName2), (res) => {
                this.AddModel2(res);
            });
        }
        AddModel2(res) {
            let sp = res.clone();
            this._obj.getChildAt(0).addChild(sp);
            sp.transform.localPosition = new Laya.Vector3(0, 0, 0);
            sp.transform.localRotationEuler = new Laya.Vector3();
        }
        get TimerPro() {
            return (this.timer / this.maxTimer) * 100;
        }
        get Have() {
            return this.bigFish;
        }
        get Pos() {
            if (this.tt && this.tt.transform) {
                return WorldToScreen2(CanteenMgr.Int._camera, this.tt.transform.position.clone());
            }
            return null;
        }
        Enter() {
            this.bz.BezierTo(this.Path[2], this.Path[0], this.Path[1]);
        }
        Out(bl = false) {
            if (bl) {
                this._transform.position = this.Path[2];
            }
            else {
                this.bz.BezierTo(this.Path[0], this.Path[2], this.Path[1]);
            }
            let data = LogicData.instance.Prot_data;
            if (data[CanteenMgr.Int.StageId] == 1) {
                Laya.timer.once(bl ? 5000 : 30000, this, this.MakeFish);
            }
        }
        OnRoleFish() {
            let times = LogicData.instance.BigFishTimes;
            console.log("大鱼鱼鱼");
            if (times >= 1) {
                console.warn("播放广告，回调下发大鱼");
                if (GameSDK$1.isCurrentVersion) {
                    this.GiftFish();
                }
                else {
                    if (!GameSDK$1.MyTurn) {
                        GameSDK$1.MyTurn = true;
                        GameSDK$1.showADVideo(this, (state) => {
                            if (state) {
                                this.GiftFish();
                            }
                        }, "大鱼广告");
                    }
                }
                return;
            }
            this.GiftFish();
        }
        GiftFish() {
            let role = this.triRole;
            if (!role) {
                role = CanteenMgr.Int.Player;
            }
            if (!role) {
                console.warn("没有分配大鱼的对象");
                return;
            }
            role.AddBigFish();
            this.triRole = null;
            this.timer = 0;
            this.NoFish();
            Laya.timer.once(30000, this, this.MakeFish);
            StepMgr.Int.OnFinshGuide(GuideType.T_GuideArrow_StackPull, "Ship");
        }
        NoFish(init = false) {
            this.bigFish = false;
            this._obj.getChildAt(0).active = false;
            this.Out(init);
            this.tt.active = false;
            EventMgr$1.Int.emit(EventType$1.INIT_BIGFISH_TIP, [false]);
            this.DesTip();
        }
        MakeFish() {
            this.bigFish = true;
            this._obj.getChildAt(0).active = true;
            this.Enter();
            this.tt.active = true;
            EventMgr$1.Int.emit(EventType$1.INIT_BIGFISH_TIP, [true]);
            this.InitTip(3);
        }
        InitTip(id) {
            if (!this.tipArrow) {
                this.tipId = id;
                console.warn("初始化箭头", this.tipId);
                this.tipArrow = fgui.UIPackage.createObjectFromURL(UIMain$1.Int.TipUrl);
                this.tipArrow.touchable = false;
                this.tipArrow.InitPic(this.tipId);
                UIMain$1.Int.AddTip(this.tipArrow);
                this.tipArrow.Hide();
                this.tipArrow.Show();
            }
        }
        updateTipPos() {
            if (!this.tipArrow)
                return;
            if (!this.tipArrow.isShow)
                return;
            let pos = this._transform.position.clone();
            let v2 = WorldToScreen2(CanteenMgr.Int._camera, pos);
            let P = 1;
            let out = false;
            if (v2.y < 150) {
                v2.y = 150;
                P = 3;
                out = true;
            }
            else if (v2.y > Laya.stage.height - 100) {
                v2.y = Laya.stage.height - 100;
                P = 1;
                out = true;
            }
            if (v2.x < 50) {
                v2.x = 50;
                P = 0;
                out = true;
            }
            else if (v2.x > Laya.stage.width - 50) {
                v2.x = Laya.stage.width - 50;
                P = 2;
                out = true;
            }
            this.tipArrow.updatePos(v2.x, v2.y, P, out);
        }
        DesTip() {
            if (!this.tipArrow)
                return;
            this.tipArrow.removeFromParent();
            this.tipArrow.dispose();
            this.tipArrow = null;
        }
    }

    class CChair extends CanteenInter {
        constructor() {
            super();
            this.nearPos = new Laya.Vector3();
            this.seatPos = null;
            this.chackPos = null;
            this.foodPos = null;
            this.FoodTransform = null;
            this.cType = CanteenType.chair;
        }
        OnUnlock(isInit) {
            if (!isInit)
                ReportMgr.inst.sendReport("解锁餐位" + ReportMgr.inst.getNextIdByBuild(7));
        }
        onAwake() {
            super.onAwake();
            this.nearPos =
                MyInstrument.GetChildByName(this._obj, "SeatTransform").transform.position.clone() ||
                    this._transform.position.clone();
            this.chackPos = MyInstrument.GetChildByName(this._obj, "EatChecker").transform.position.clone();
            this.FoodTransform = MyInstrument.GetChildByName(this._obj, "FoodTransform");
            this.foodPos = this.FoodTransform.transform.position.clone();
            ChairMgr.Int.AddChiar(this);
        }
        onLateUpdate() {
            this.SendFoodPos();
        }
        InitPackge() {
            let packgeNode = MyInstrument.GetChildByName(this._obj, "packgeNode");
            if (packgeNode) {
                this.packge = packgeNode.addComponent(CPackge);
                this.packge.Init(10, 1, GoodsType.dish, this, false);
                this.packge.InitTip(5);
            }
        }
        get BlanDishNum() {
            return this.packge.GoodsNum;
        }
        SendFoodPos() {
            if (this._clientRole && this._clientRole.isIdel) {
                EventMgr$1.Int.emit(EventType$1.FOOD_POS, this);
            }
        }
        GetDish(dish) {
            if (!this._clientRole.isIdel) {
                console.warn("非idle状态,不允许吃东西");
                return false;
            }
            let bl = this._clientRole.Eat(dish, this);
            if (bl) {
                let foodObj = dish.owner;
                this.FoodTransform.addChild(foodObj);
                dish.MoveTo(this.foodPos.clone());
                StepMgr.Int.OnFinshGuide(GuideType.T_OpenSushibar);
            }
            return bl;
        }
        GetCacheDish(cache) {
            if (!this._clientRole.isIdel) {
                return false;
            }
            let bl = this._clientRole.Eat(cache.Dish, this);
            if (bl) {
                this.FoodTransform.addChild(cache.Dish.Obj);
                cache.Dish.MoveTo(this.foodPos.clone());
                cache.SubDish();
                StepMgr.Int.OnFinshGuide(GuideType.T_OpenSushibar);
            }
            return bl;
        }
        GetClient(client) {
            if (this._clientRole) {
                return;
            }
            this._clientRole = client;
        }
        LeaveClient() {
            if (!this._clientRole)
                return false;
            RoleMgr.Int.AddWaitSettle(this._clientRole);
            this._clientRole = null;
            RoleMgr.Int.AutoWait();
            return true;
        }
        AddToPackge(dish) {
            this.packge.Add(dish);
            AudioMgr$1.instance.play_sound(7);
        }
        get MovePos() {
            return this.nearPos.clone();
        }
        get Full() {
            return this._clientRole != null;
        }
        get ChackPos() {
            return this.chackPos.clone();
        }
        get CanGet() {
            if (!this._clientRole)
                return false;
            return this._clientRole.isIdel;
        }
    }

    class CanteenDish extends CanteenGoods {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this._foodId = -1;
        }
        InitFood(id) {
            this._foodId = id;
        }
        onAwake() {
            super.onAwake();
            this.LoadFood();
        }
        onDestroy() {
        }
        get Obj() {
            return this._obj;
        }
        OnFoodEat() {
            let id = this._foodId;
            let sp = this._obj.removeChildByName("food");
            sp && sp.destroy();
            this._foodId = -1;
            return id;
        }
        LoadFood() {
            let data = GameData.getGoodsItem(this._foodId);
            if (data.StageId == 1) {
                ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(data.PrefabName), (res) => {
                    this.LoadOver(res);
                });
            }
            else {
                ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs5(data.PrefabName), (res) => {
                    this.LoadOver(res);
                });
            }
        }
        get FoodPirce() {
            let data = GameData.getGoodsItem(this._foodId);
            return data.Price;
        }
        LoadOver(res) {
            let sp = res.clone();
            this._obj.addChild(sp);
            sp.name = "food";
            sp.transform.localRotationEuler = new Laya.Vector3(0, 0, 0);
            sp.transform.localPosition = new Laya.Vector3(0, 0, 0);
        }
    }

    class CCook extends CanteenInter {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.table = null;
            this.LockWaiter = false;
            this.checkPos = null;
            this.completeDish = null;
            this.FishParent = null;
            this.cType = CanteenType.cook;
            this.Knife = null;
            this.CuttingBoardParent = null;
            this.cookGoods = null;
            this.tryadd = false;
            this.m_WorkerType = WorkType.cook;
        }
        Init(table, isT, isB) {
            this.table = table;
            this.isTuna = isT;
            this.isBan = isB;
        }
        OnUnlock(isInit) {
            if (!isInit)
                ReportMgr.inst.sendReport("解锁做饭台" + ReportMgr.inst.getNextIdByBuild(2));
        }
        onAwake() {
            super.onAwake();
            this.checkPos = this._obj.getChildByName("SushibarChecker").transform.position.clone();
            this.FishParent = MyInstrument.GetChildByName(this._obj, "FishParent");
            this.Knife = MyInstrument.GetChildByName(this._obj, "Knife");
            this.CuttingBoardParent = MyInstrument.GetChildByName(this._obj, "CuttingBoardParent");
            this.m_WorkerType = WorkType.cook;
            this.InitPowerLevel();
            if (this.isTuna) {
                this.LockWaiter = true;
                let FishTable = this._obj.getChildByName("FishTable");
                FishTable.active = false;
            }
            if (this.isBan) {
                if (this.CuttingBoardParent) {
                    this.CuttingBoardParent.active = false;
                }
            }
        }
        onUpdate() {
            super.onUpdate();
            if (this.tryadd) {
                this.TryAddDishToTable();
            }
        }
        onDestroy() {
            Laya.timer.clear(this, this.StartTryAdd);
        }
        InitPowerLevel() {
            let data = LogicData.instance.CanteenPowerLevel;
            this.timerMax = 2000 / GameData.getCookSpeedItem(data.Speed2).Speed;
            if (this.packge) {
                this.packge.Size = GameData.getCookNumItem(data.Storage2).Speed;
            }
        }
        SetTaget(role) {
            ReportMgr.inst.sendReport(ReportType.FIRST_COOK);
            super.SetTaget(role);
            if (role) {
                if (this.Knife)
                    this.Knife.active = false;
            }
            else {
                if (this.Knife)
                    this.Knife.active = true;
            }
        }
        TimerHandler() {
            super.TimerHandler();
            this.MakeFood();
        }
        InitPackge() {
            if (!this.isTuna) {
                let packgeNode = MyInstrument.GetChildByName(this._obj, "packgeNode");
                if (packgeNode) {
                    this.packge = packgeNode.addComponent(CPackge);
                    this.packge.Init(10, 5, GoodsType.food, this, true);
                }
            }
        }
        MakeFood() {
            if (this.completeDish)
                return;
            if (this._tagetRole) {
                UIMain$1.Int.InitGuideTip(6, false);
                this._tagetRole.StopNod();
                let foodId = -1;
                if (this.isTuna) {
                    if (this.bigFish) {
                        AudioMgr$1.instance.play_sound(2);
                        if (this._tagetRole.cType == CanteenType.player) {
                            AudioMgr$1.instance.vibrateShort();
                        }
                        let bl = this.bigFish.SubPiece();
                        if (bl) {
                            foodId = 23;
                            this._tagetRole.PlayAni(HumanAni.Cooking);
                            let dish = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs("Dish")).clone();
                            let scr = dish.addComponent(CanteenDish);
                            scr.InitFood(23);
                            this.completeDish = scr;
                            CanteenMgr.Int.Stage.addChild(dish);
                            dish.transform.position = this.FishParent.transform.position.clone();
                            dish.transform.rotationEuler = new Laya.Vector3();
                        }
                    }
                }
                else {
                    if (this.cookGoods)
                        return;
                    this.cookGoods = this.packge.Sub(GoodsType.all);
                    if (this.cookGoods) {
                        this.cookGoods.SetPackge(null, 0);
                        AudioMgr$1.instance.play_sound(2);
                        if (this._tagetRole.cType == CanteenType.player) {
                            AudioMgr$1.instance.vibrateShort();
                        }
                        foodId = this.cookGoods.MakeId;
                        this.foodAddToBan();
                        StepMgr.Int.OnFinshGuide(GuideType.T_CookComplete, "None");
                    }
                    else {
                        this._tagetRole.Nod();
                    }
                }
                if (foodId > 0) {
                    LogicData.instance.AddFood(foodId);
                    this.tryadd = false;
                    Laya.timer.once(1000, this, this.StartTryAdd);
                }
            }
        }
        foodAddToBan() {
            this._tagetRole.PlayAni(HumanAni.Cooking);
            let v3 = this.FishParent.transform.position.clone();
            let rot = this.FishParent.transform.rotationEuler.clone();
            this.cookGoods.SetPosRot(v3, rot);
            Laya.timer.once(500, this, this.goodsToFood);
        }
        goodsToFood() {
            let dish = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs("Dish")).clone();
            let scr = dish.addComponent(CanteenDish);
            this.completeDish = scr;
            scr.InitFood(this.cookGoods.MakeId);
            CanteenMgr.Int.Stage.addChild(dish);
            let v3 = this.FishParent.transform.position.clone();
            dish.transform.position = v3.clone();
            dish.transform.rotationEuler = new Laya.Vector3();
            this.cookGoods.owner.destroy();
            this.cookGoods = null;
            if (this.isBan) {
                EffectMgr.Int.showEffectPos(v3, new Laya.Vector3(), 5);
            }
        }
        StartTryAdd() {
            this.tryadd = true;
        }
        TryAddDishToTable() {
            if (this.completeDish) {
                let bl = this.table.GetMakeFood(this.completeDish, this.checkPos);
                if (bl) {
                    this.tryadd = false;
                    this.completeDish = null;
                }
            }
        }
        TimerPro() {
            if (!this.packge)
                return 0;
            if (this.packge.GoodsNum == 0)
                return 0;
            return (this._timer / this.timerMax) * 100;
        }
    }

    class FoodCache extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.curDish = null;
            this.max = 0;
        }
        InitMax(x) {
            this.max = x;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            EventMgr$1.Int.on(EventType$1.FOOD_POS, this.ChackFood, this);
        }
        onDestroy() {
            EventMgr$1.Int.off(EventType$1.FOOD_POS, this.ChackFood, this);
        }
        ChackFood(chair) {
            if (!this.curDish)
                return;
            if (!chair.Full)
                return;
            let pos = chair.ChackPos;
            let disq = Laya.Vector3.distanceSquared(pos, this._transform.position.clone());
            if (disq <= 2) {
                chair.GetCacheDish(this);
            }
        }
        get Full() {
            return this.curDish != null;
        }
        get Dish() {
            return this.curDish;
        }
        get Pos() {
            return this._transform.position.clone();
        }
        GetDish(dish) {
            if (this.curDish)
                return false;
            this.curDish = dish;
            let foodObj = dish.owner;
            this._obj.addChild(foodObj);
            foodObj.transform.localPosition = new Laya.Vector3(0, 0, -0.6);
            return true;
        }
        SubDish() {
            let dish;
            if (this.curDish) {
                dish = this.curDish;
                this.curDish = null;
            }
            return dish;
        }
    }

    class TrackItem extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.minX = 0;
            this.maxX = 28;
            this.moveSpeed = 1;
            this.rotSpeed = 180;
            this.cIndex = 0;
            this.maxNum = 1;
        }
        Init(max, index, maxNum) {
            this.maxX = max;
            this.cIndex = index;
            this.maxNum = maxNum;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
        }
        onEnable() {
            let index = this.cIndex;
            if (index < this.maxNum / 2) {
                this._transform.localRotationEulerY = -180;
                this._transform.localPositionX = index;
            }
            else {
                this._transform.localRotationEulerY = 0;
                this._transform.localPositionX = index - Math.floor(this.maxNum / 2);
            }
        }
        onUpdate() {
            let t = Laya.timer.delta / 1000;
            if (this._transform.localPositionX <= this.minX && this._transform.localRotationEulerY != 0) {
                this._transform.localRotationEulerY -= this.rotSpeed * t;
                if (this._transform.localRotationEulerY <= -360) {
                    this._transform.localRotationEulerY = 0;
                }
            }
            else if (this._transform.localPositionX >= this.maxX && this._transform.localRotationEulerY != -180) {
                this._transform.localRotationEulerY -= this.rotSpeed * t;
                if (this._transform.localRotationEulerY <= -180) {
                    this._transform.localRotationEulerY = -180;
                }
            }
            else {
                if (this._transform.localRotationEulerY == 0) {
                    this._transform.localPositionX += this.moveSpeed * t;
                    if (this._transform.localPositionX >= this.maxX) {
                        this._transform.localPositionX = this.maxX;
                    }
                }
                else if (this._transform.localRotationEulerY == -180) {
                    this._transform.localPositionX -= this.moveSpeed * t;
                    if (this._transform.localPositionX <= this.minX) {
                        this._transform.localPositionX = this.minX;
                    }
                }
            }
        }
    }

    class CTable extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this._canCache = false;
            this._foodCacheArr = [];
            this._chairArr = [];
            this.Center = null;
            this.Right = null;
            this.CookT = null;
            this.ClientT = null;
            this.RollNode = null;
            this.isTuna = false;
            this.isBan = false;
            this.Index = 0;
            this.BuildId = 1;
            this._unlockTaget = null;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            if (this._obj.name == "ChefSeatTuna_01" || this._obj.name == "Sushibar_TableTuna") {
                this.isTuna = true;
            }
            if (this._obj.name == "Sushibar_Table") {
                this.isBan = true;
            }
            this.Center = MyInstrument.GetChildByName(this._obj, "Center");
            this.Right = MyInstrument.GetChildByName(this._obj, "Right");
            this.CookT = MyInstrument.GetChildByName(this._obj, "CookT");
            this.ClientT = MyInstrument.GetChildByName(this._obj, "ClientT");
            this.RollNode = MyInstrument.GetChildByName(this._obj, "RollNode");
            if (this.RollNode) {
                this.BuildId = 1;
            }
            if (this.isBan) {
                this.BuildId = 14;
            }
            if (this.isTuna) {
                this.BuildId = 13;
            }
        }
        onEnable() {
            let _unlockTagets = this._obj.getComponents(LockScript);
            for (let index = 0; index < _unlockTagets.length; index++) {
                const element = _unlockTagets[index];
                element.SetBuildId(this.BuildId);
            }
        }
        InitTable() {
            let normal = this.InitLevel();
            if (normal) {
                this.InitChairNum(this.ClientT.numChildren);
                this.InitCookNum(this.CookT.numChildren);
            }
        }
        UpdateLevel() {
            Laya.timer.clear(this, this.InitLevel);
            Laya.timer.frameOnce(1, this, this.InitLevel);
        }
        InitLevel() {
            if (this.isBan) {
                this.InitBan();
                return false;
            }
            if (this.RollNode) {
                this.InitRoll();
                return false;
            }
            return true;
        }
        InitRoll() {
            let level = LogicData.instance.TableLevel_1;
            if (level == 0)
                return true;
            let rNum = 8 * level + 2;
            let x = level * 4;
            let scl = 2 * level;
            this._canCache = true;
            this.RollNode.removeChildren();
            this.RollNode.destroyChildren();
            this._foodCacheArr = [];
            for (let index = 0; index < rNum; index++) {
                let roll = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs("Roll")).clone();
                let scr = roll.addComponent(FoodCache);
                scr.InitMax(x);
                let scr2 = roll.addComponent(TrackItem);
                scr2.Init(x, index, rNum);
                roll.transform.localPosition = new Laya.Vector3();
                this.RollNode.addChild(roll);
                this._foodCacheArr.push(scr);
            }
            this.Center.transform.localScaleX = scl;
            this.Right.transform.localPositionX = x;
            this.InitChairNum(level);
            this.InitCookNum(level);
        }
        InitChairNum(num) {
            for (let index = 0; index < num; index++) {
                let l = this.ClientT.getChildAt(index);
                if (l.numChildren == 0) {
                    let sp = l.addChild(this.AddChiar());
                    sp.transform.localPosition = new Laya.Vector3();
                }
            }
        }
        InitCookNum(num) {
            for (let index = 0; index < num; index++) {
                let c = this.CookT.getChildAt(index);
                if (c.numChildren == 0) {
                    let sp = c.addChild(this.AddCook());
                    sp.transform.localPosition = new Laya.Vector3();
                    sp.transform.position = sp.transform.position.clone();
                }
            }
        }
        AddChiar() {
            let Chair = ResourcesMgr$1.instance
                .get(RescoureData.getPreFromPrefabs("Chair_Conveyor"))
                .clone();
            let scr = Chair.addComponent(CChair);
            this._chairArr.push(scr);
            return Chair;
        }
        AddCook() {
            let cook = ResourcesMgr$1.instance
                .get(RescoureData.getPreFromPrefabs("ChefSeat_Conveyor"))
                .clone();
            let scr = cook.addComponent(CCook);
            scr.Init(this, this.isTuna, this.isBan);
            return cook;
        }
        GetMakeFood(dish, v3) {
            if (this._canCache) {
                let item = this.FindNoFull(v3);
                if (!item)
                    return false;
                return item.GetDish(dish);
            }
            else {
                let item = this.FindGetChair();
                if (!item)
                    return false;
                return item.GetDish(dish);
            }
        }
        FindNoFull(v3) {
            let array = this._foodCacheArr;
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                let disq = Laya.Vector3.distanceSquared(v3, element.Pos);
                if (element.Full == false && disq < 0.5) {
                    return element;
                }
            }
            return null;
        }
        FindGetChair() {
            let array = this._chairArr;
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                if (element.CanGet) {
                    return element;
                }
            }
            return null;
        }
        InitBan() {
            if (!this.isBan)
                return;
            let level = LogicData.instance.TableLevel_2;
            if (level <= 4) {
                level = 1;
            }
            else {
                if (level >= this.Index + 4) {
                    level = 2;
                }
                else {
                    level = 1;
                }
            }
            if (level > 1) {
                this.BigBan();
            }
            else {
                this.SmallBan();
            }
        }
        SmallBan() {
            this.Right.transform.localPositionX = -4;
            this.Center.transform.localScaleX = 1;
            for (let index = 0; index < 3; index++) {
                let l = this.ClientT.getChildAt(index);
                if (l.numChildren == 0) {
                    let sp = l.addChild(this.AddChiar());
                    sp.transform.localPosition = new Laya.Vector3();
                }
            }
            for (let index = 0; index < 1; index++) {
                let c = this.CookT.getChildAt(index);
                if (c.numChildren == 0) {
                    let sp = c.addChild(this.AddCook());
                    sp.transform.localPosition = new Laya.Vector3();
                }
            }
        }
        BigBan() {
            this.Right.transform.localPositionX = 0;
            this.Center.transform.localScaleX = 3;
            for (let index = 0; index < this.ClientT.numChildren; index++) {
                let l = this.ClientT.getChildAt(index);
                if (index == 0) {
                    if (l.numChildren > 0) {
                        let scr = l.getChildAt(0).getComponent(CChair);
                        if (scr) {
                            ChairMgr.Int.SubChair(scr);
                        }
                    }
                }
                else {
                    if (l.numChildren == 0) {
                        let sp = l.addChild(this.AddChiar());
                        sp.transform.localPosition = new Laya.Vector3();
                    }
                }
            }
            for (let index = 0; index < this.CookT.numChildren; index++) {
                let c = this.CookT.getChildAt(index);
                if (c.numChildren == 0) {
                    let sp = c.addChild(this.AddCook());
                    sp.transform.localPosition = new Laya.Vector3();
                }
            }
        }
    }

    class CTravel extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.modelName = "TravelModel";
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            EventMgr$1.Int.on(EventType$1.INIT_TRAVL, this.InitActive, this);
            this.InitActive();
            this.LoadModel();
        }
        InitActive() {
            let i = LogicData.instance.IsTravl;
            if (i == 0) {
                this._obj.active = false;
            }
            else {
                this._obj.active = true;
            }
        }
        onTriggerEnter(other) {
            let scr = other.owner.getComponent(PlayerRole);
            if (scr) {
                scr.Move(new Laya.Vector3());
                UIMgr.instance.openUI(ModuleType.UIQiehuan);
            }
        }
        LoadModel() {
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(this.modelName), (res) => {
                this.AddModel(res);
            });
        }
        AddModel(res) {
            let sp = res.clone();
            this._obj.addChild(sp);
            sp.transform.localPosition = new Laya.Vector3();
            sp.transform.localRotationEuler = new Laya.Vector3();
        }
    }

    class FishMenu extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.modelName = "MenuNode_";
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            EventMgr$1.Int.on(EventType$1.UPDATE_FOODMENU, this.InitMenu, this);
            this.InitMenu();
        }
        onDestroy() {
            EventMgr$1.Int.off(EventType$1.UPDATE_FOODMENU, this.InitMenu, this);
        }
        InitMenu() {
            if (this._obj.numChildren == 0)
                return;
            let obj = this._obj.getChildAt(0);
            let array = LogicData.instance.FoodArr;
            let tArr = [];
            for (let index = 0; index < array.length; index++) {
                let element = array[index];
                tArr.push(this.IndexToID(element));
            }
            for (let index = 0; index < obj.numChildren; index++) {
                const element = obj.getChildAt(index);
                if (tArr.indexOf(index) >= 0) {
                    element.active = true;
                }
                else {
                    element.active = false;
                }
            }
        }
        IndexToID(id) {
            if (id == 23) {
                return 5;
            }
            if (CanteenMgr.Int.StageId == 1) {
                if (id > 17) {
                    return -1;
                }
                else {
                    return GameData.getGoodsItem(id).MenuIndex - 1;
                }
            }
            else {
                if (id <= 17) {
                    return -1;
                }
                else {
                    return GameData.getGoodsItem(id).MenuIndex - 1;
                }
            }
        }
        LoadModel() {
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(this.modelName + CanteenMgr.Int.StageId), (res) => {
                this.AddModel(res);
            });
        }
        AddModel(res) {
            let sp = res.clone();
            this._obj.addChild(sp);
            sp.transform.localPosition = new Laya.Vector3();
            sp.transform.localRotationEuler = new Laya.Vector3();
            this.InitMenu();
        }
    }

    class MoneyBigScript extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.model = null;
            this.modelName = "BigMoneyModel";
            this.tipArrow = null;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this._obj.active = false;
            EventMgr$1.Int.on(EventType$1.MONEY_DUIDUI, this.InitActive, this);
            this.LoadModel();
        }
        onUpdate() {
            if (this.model) {
                this.model.getChildAt(0).transform.localRotationEulerY += 1;
            }
            this.updateTipPos();
        }
        LoadModel() {
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(this.modelName), (res) => {
                this.AddModel(res);
            });
        }
        AddModel(res) {
            this.model = res.clone();
            this._obj.addChild(this.model);
            this.model.transform.localPosition = new Laya.Vector3();
            this.model.transform.localRotationEuler = new Laya.Vector3();
        }
        onTriggerEnter(other) {
            let scr = other.owner.getComponent(PlayerRole);
            if (scr) {
                console.warn("玩家触发视频钱");
                GameSDK$1.showADVideo(this, (s) => {
                    if (s) {
                        EventMgr$1.Int.emit(EventType$1.TRIGGER_MONEY);
                    }
                }, "玩家触碰3D钱堆视频");
            }
        }
        onDestroy() {
            EventMgr$1.Int.off(EventType$1.MONEY_DUIDUI, this.InitActive, this);
        }
        InitActive(data) {
            if (!GameSDK$1.isAdUser() || +GameSDK$1.data.ShowTriggerOpen != 1) {
                return;
            }
            if (data[0] == false) {
                this.DesTip();
            }
            else {
                this.InitTip();
            }
            this._obj.active = data[0];
        }
        InitTip() {
            if (!this.tipArrow) {
                this.tipArrow = fgui.UIPackage.createObjectFromURL(UIMain$1.Int.BigMoneyUrl);
                this.tipArrow.touchable = false;
                this.tipArrow.InitNum(CanteenMgr.Int.Vip.Money);
                UIMain$1.Int.AddTip(this.tipArrow);
                this.tipArrow.Hide();
                this.tipArrow.Show();
            }
        }
        updateTipPos() {
            if (!this.tipArrow)
                return;
            if (!this.tipArrow.isShow)
                return;
            let pos = this._transform.position.clone();
            let v2 = WorldToScreen2(CanteenMgr.Int._camera, pos);
            let out = false;
            if (v2.y < 150) {
                v2.y = 150;
                out = true;
            }
            else if (v2.y > Laya.stage.height - 100) {
                v2.y = Laya.stage.height - 100;
                out = true;
            }
            if (v2.x < 50) {
                v2.x = 50;
                out = true;
            }
            else if (v2.x > Laya.stage.width - 50) {
                v2.x = Laya.stage.width - 50;
                out = true;
            }
            this.tipArrow.updatePos(v2.x, v2.y, out);
        }
        DesTip() {
            if (!this.tipArrow)
                return;
            this.tipArrow.removeFromParent();
            this.tipArrow.dispose();
            this.tipArrow = null;
        }
    }

    class CStage extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.counter = null;
            this.PathNode = null;
            this.PlayerPos = null;
            this.ClientEnter_posarr = [];
            this.ShipPath = [];
            this.ClientB_Arr = [];
            this.ClientEnter_Arr = [];
            this._stageId = 1;
            this.ModelNum = 0;
            this.NeedNum = 3;
            this.ModelOver = false;
            this.modelFish = "FishNode_";
            this.modelTable = "TableNode_";
            this.modelDish = "DishNode_";
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this.InitNode();
        }
        InitNode() {
            let stageId = CanteenMgr.Int.StageId;
            this._stageId = stageId;
            let Counter = this._obj.getChildByName("Counter");
            this.counter = Counter.addComponent(CCounter);
            this.PathNode = this._obj.getChildByName("PathNode");
            this.PlayerPos = this._obj.getChildByName("PlayerPos");
            let ClientB = this._obj.getChildByName("ClientB");
            for (let index = 0; index < ClientB.numChildren; index++) {
                const element = ClientB.getChildAt(index);
                this.ClientB_Arr.push(element.transform.position.clone());
            }
            console.warn("出生点数组", this.ClientB_Arr);
        }
        InitScript() {
            let ShipNode = this._obj.getChildByName("ShipNode");
            if (ShipNode) {
                let Ship = ShipNode.getChildAt(0);
                let scr = Ship.addComponent(CShip);
                let a = ShipNode.getChildAt(1);
                let b = ShipNode.getChildAt(2);
                let c = ShipNode.getChildAt(3);
                scr.InitPath([a.transform.position.clone(), b.transform.position.clone(), c.transform.position.clone()]);
            }
            let Farm_Branch = this._obj.getChildByName("Farm_Branch");
            if (Farm_Branch) {
                let c = Farm_Branch.getChildAt(0);
                for (let index = 0; index < c.numChildren; index++) {
                    const element = c.getChildAt(index);
                    let scr = element.addComponent(CCrops);
                    scr.SetMakeId(7);
                }
            }
            let Farm_Radish = this._obj.getChildByName("Farm_Radish");
            if (Farm_Radish) {
                let c = Farm_Radish.getChildAt(0);
                for (let index = 0; index < c.numChildren; index++) {
                    const element = c.getChildAt(index);
                    let scr = element.addComponent(CCrops);
                    scr.SetMakeId(11);
                }
            }
            let MenuNode = this._obj.getChildByName("MenuNode");
            MenuNode.addComponent(FishMenu);
            let Travel = this._obj.getChildByName("Travel");
            Travel.addComponent(CTravel);
            let BigMoneyNode = this._obj.getChildByName("BigMoneyNode");
            if (BigMoneyNode) {
                for (let index = 0; index < BigMoneyNode.numChildren; index++) {
                    const element = BigMoneyNode.getChildAt(index);
                    element.addComponent(MoneyBigScript);
                }
            }
            let CarNode = this._obj.getChildByName("CarNode");
            if (CarNode) {
                CanteenMgr.Int.CarNode = CarNode.addComponent(StopCar);
            }
            this.LoadModels();
        }
        RandomB() {
            let index = Math.floor(Math.random() * this.ClientB_Arr.length);
            return this.ClientB_Arr[index].clone();
        }
        LoadModels() {
            this.ModelNum = 0;
            this.ModelOver = false;
            this.LoadModelFish();
            this.LoadModelTable();
            this.LoadModelDish();
        }
        OnModelOver() {
            this.ModelNum++;
            if (this.ModelNum >= this.NeedNum) {
                this.ModelOver = true;
                CanteenMgr.Int.LateStarGame();
            }
        }
        LoadModelFish() {
            if (this._stageId == 1) {
                ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(this.modelFish + this._stageId), (res) => {
                    this.AddModelFish(res);
                });
            }
            else {
                ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs5(this.modelFish + this._stageId), (res) => {
                    this.AddModelFish(res);
                });
            }
        }
        AddModelFish(res) {
            if (!this._obj)
                return;
            let sp = res.clone();
            let parent = this._obj.getChildByName("FishN");
            parent.addChild(sp);
            for (let index = 0; index < sp.numChildren; index++) {
                const element = sp.getChildAt(index);
                let scr = element.addComponent(CFishing);
                scr.Init(index, CanteenMgr.Int.StageId);
            }
            sp.transform.localPosition = new Laya.Vector3();
            sp.transform.localRotationEuler = new Laya.Vector3();
            this.OnModelOver();
        }
        LoadModelTable() {
            if (this._stageId == 1) {
                ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(this.modelTable + this._stageId), (res) => {
                    this.AddModelTable(res);
                });
            }
            else {
                ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs5(this.modelTable + this._stageId), (res) => {
                    this.AddModelTable(res);
                });
            }
        }
        AddModelTable(res) {
            if (!this._obj)
                return;
            let sp = res.clone();
            let parent = this._obj.getChildByName("TableN");
            parent.addChild(sp);
            for (let index = 0; index < sp.numChildren; index++) {
                const element = sp.getChildAt(index);
                let scr = element.addComponent(CTable);
                scr.Index = index;
                scr.InitTable();
            }
            sp.transform.localPosition = new Laya.Vector3();
            sp.transform.localRotationEuler = new Laya.Vector3();
            this.OnModelOver();
        }
        LoadModelDish() {
            if (this._stageId == 1) {
                ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(this.modelDish + this._stageId), (res) => {
                    this.AddModelDish(res);
                });
            }
            else {
                ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs5(this.modelDish + this._stageId), (res) => {
                    this.AddModelDish(res);
                });
            }
        }
        AddModelDish(res) {
            if (!this._obj)
                return;
            let sp = res.clone();
            let parent = this._obj.getChildByName("DishN");
            parent.addChild(sp);
            for (let index = 0; index < sp.numChildren; index++) {
                const element = sp.getChildAt(index);
                element.addComponent(CDishWasher);
            }
            sp.transform.localPosition = new Laya.Vector3();
            sp.transform.localRotationEuler = new Laya.Vector3();
            this.OnModelOver();
        }
    }

    var CanteenType;
    (function (CanteenType) {
        CanteenType[CanteenType["player"] = 1] = "player";
        CanteenType[CanteenType["roleNpc"] = 2] = "roleNpc";
        CanteenType[CanteenType["fish"] = 3] = "fish";
        CanteenType[CanteenType["cook"] = 4] = "cook";
        CanteenType[CanteenType["chair"] = 5] = "chair";
        CanteenType[CanteenType["dish"] = 6] = "dish";
        CanteenType[CanteenType["counter"] = 7] = "counter";
        CanteenType[CanteenType["crops"] = 8] = "crops";
    })(CanteenType || (CanteenType = {}));
    class CanteenMgr {
        constructor() {
            this.SCENAME = RescoureData.YsceUrl("Main");
            this._scene = null;
            this.GameType = GameType$1.ready;
            this.StageId = 1;
            this.Player = null;
            this.StageNode = null;
            this.Stage = null;
            this.m_stage = null;
            this.CameraNode = null;
            this.CameraScript = null;
            this.counter = null;
            this.PathNode = null;
            this.Ship = null;
            this.Vip = null;
            this.CarNode = null;
            this.outLineTime = 0;
            this.outLineReward = 0;
            this.subOver = false;
            this.subHandler = null;
            this.subIndex = 0;
            this.resOver = false;
            this.subOver2 = false;
            this.subHandler2 = null;
            this._camera = null;
        }
        static get Int() {
            if (!this._Int) {
                this._Int = new CanteenMgr();
            }
            return this._Int;
        }
        get scene() {
            return this._scene;
        }
        enter(cb, load = false) {
            this._cb = cb;
            this.InitOutLine();
            this.GameType = GameType$1.load;
            if (load) {
                UIMgr.instance.openUI(ModuleType.UILoad);
            }
            this.loadRes(true);
            Laya.timer.loop(1000, this, this.TimerUpdate);
            Laya.timer.frameLoop(1, this, this.FrameUpdate);
        }
        InitOutLine() {
            this.outLineTime = Times$3.now - LogicData.instance.LoginTime;
            let t = Times$3.second(this.outLineTime);
            if (t > 120 * 60) {
                t = 120 * 60;
            }
            if (t < 60)
                return;
            this.outLineReward = Math.floor(t * 0.2);
            UIMgr.instance.openUI(ModuleType.UIOffline, this.outLineReward);
        }
        TimerUpdate() {
            LogicData.instance.SaveTime(Times$3.now);
        }
        FrameUpdate() { }
        out() {
            this.clearEvent();
            this.clearSce();
            this._scene.destroyChildren();
            this._scene.destroy();
            this._scene = null;
            UIMgr.instance.closeUI(ModuleType.Main);
        }
        loadRes(init = false) {
            let urls = [
                this.SCENAME,
                RescoureData.GetDatasJson("Progress"),
                RescoureData.GetDatasJson("Tilemap1"),
                RescoureData.GetDatasJson("Tilemap2"),
            ];
            ResourcesMgr$1.instance.loadDir(urls, () => {
                if (init) {
                    this.enterOverHandler(ResourcesMgr$1.instance.get(this.SCENAME));
                }
                else {
                    this.ReloadLevel();
                }
            }, null, true);
            Laya.Resource.destroyUnusedResources();
        }
        enterOverHandler(scene) {
            StepMgr.Int.Init(ResourcesMgr$1.instance.get(RescoureData.GetDatasJson("Progress")));
            console.log("场景加载完成");
            this._scene = scene;
            let handler = Laya.Handler.create(this, this.UIloadOver, null, false);
            this.initUI(handler);
        }
        initUI(handler) {
            UIMgr.instance.openUI(ModuleType.Main, [handler]);
        }
        UIloadOver() {
            GameSDK$1.sendEvent("进入主页");
            this.initEvent();
            this.initSce();
        }
        initSce() {
            console.warn("添加场景");
            Laya.stage.addChildAt(this._scene, 0);
            GoodsMgr.Int.Init();
            this.CameraNode = this._scene.getChildByName("CameraNode");
            this._camera = this.CameraNode.getChildAt(0);
            this._camera.enableHDR = false;
            this._camera.nearPlane = 10;
            this.StageNode = this._scene.getChildByName("StageNode");
            this.LoadStage();
        }
        LoadStage(id = 1) {
            PathFindMgr.Int.loadMap(ResourcesMgr$1.instance.get(RescoureData.GetDatasJson("Tilemap" + id)), null);
            Laya.timer.clear(this, this.LookTo);
            console.log("------加载餐厅--------");
            StepMgr.Int.Stop();
            ChairMgr.Int.ClearAll();
            GoodsMgr.Int.ClearAll();
            InterMgr.Int.ClearAll();
            PackgeMgr.Int.ClearAll();
            RoleMgr.Int.ClearAll();
            if (this.Stage) {
                this.Stage.destroy();
                this.Stage = null;
            }
            if (this.CameraScript) {
                this.CameraScript.setAim(null);
            }
            this.StageId = id;
            let url;
            if (id == 1) {
                url = RescoureData.getPreFromPrefabs1("Stage01");
            }
            else {
                url = RescoureData.getPreFromPrefabs2("Stage02");
            }
            let self = this;
            ResourcesMgr$1.instance.load(url, function (res) {
                self.AddStage(res);
            });
        }
        AddStage(res) {
            let stage = res.clone();
            this.StageNode.addChild(stage);
            this.Stage = stage;
            if (this._cb) {
                this._cb();
                this._cb = null;
            }
            UIMgr.instance.closeUI(ModuleType.UILoad);
            this.m_stage = this.Stage.addComponent(CStage);
            this.PathNode = this.m_stage.PathNode;
            this.counter = this.m_stage.counter;
            RoleMgr.Int.Init(this.PathNode);
            this.LoadSubUnity();
        }
        LateStarGame() {
            RoleMgr.Int.AddPlayer(this.m_stage.PlayerPos.transform.position.clone());
            StepMgr.Int.Start();
            StepMgr.Int.StartStep();
            EventMgr$1.Int.emit(EventType$1.INIT_UPLEVEL, true);
            this.StartGame();
            this.OnCarActive();
        }
        LoadSubUnity() {
            let self = this;
            self.subIndex = 0;
            self.LoadResUnity();
        }
        LoadResUnity() {
            let urls = [
                this.SCENAME,
                RescoureData.getPreFromPrefabs3("Human"),
                RescoureData.getPreFromPrefabs("Dish"),
                RescoureData.getPreFromPrefabs("Roll"),
                RescoureData.getPreFromPrefabs("Money"),
                RescoureData.getPreFromPrefabs("DustRun"),
                RescoureData.getPreFromPrefabs("Chair_Conveyor"),
                RescoureData.getPreFromPrefabs("ChefSeat_Conveyor"),
                RescoureData.getPreFromPrefabs("Fish_01"),
                RescoureData.getPreFromPrefabs("Fish_02"),
                RescoureData.getPreFromPrefabs("Fish_03"),
                RescoureData.getPreFromPrefabs("Fish_04"),
                RescoureData.getPreFromPrefabs("Fish_05"),
                RescoureData.getPreFromPrefabs("Sushi04"),
                RescoureData.getPreFromPrefabs("Sushi05"),
                RescoureData.getPreFromPrefabs("Sushi06"),
                RescoureData.getPreFromPrefabs("Sushi07"),
                RescoureData.getPreFromPrefabs("Sushi08"),
                RescoureData.getPreFromPrefabs("Tuna"),
                RescoureData.getPreFromPrefabs("TunaSashimi"),
            ];
            ResourcesMgr$1.instance.loadDir(urls, () => {
                this.resOver = true;
                this.m_stage.InitScript();
                this.LoadSubUnity2();
            }, null, true);
        }
        LoadSubUnity2() {
            let self = this;
            self.subIndex = 0;
            self.LoadResUnity2();
        }
        LoadResUnity2() {
            let self = this;
            let urls = [
                RescoureData.getPreFromPrefabs5("Branch"),
                RescoureData.getPreFromPrefabs5("Conch"),
                RescoureData.getPreFromPrefabs5("CowMeat"),
                RescoureData.getPreFromPrefabs5("Lobster"),
                RescoureData.getPreFromPrefabs5("Radish"),
                RescoureData.getPreFromPrefabs5("Eggplant"),
                RescoureData.getPreFromPrefabs5("Shell"),
                RescoureData.getPreFromPrefabs5("Steak"),
                RescoureData.getPreFromPrefabs5("LobsterFood"),
                RescoureData.getPreFromPrefabs5("Redradish"),
            ];
            ResourcesMgr$1.instance.loadDir(urls, () => {
                self.subOver2 = true;
                if (self.subHandler2)
                    self.subHandler2.run();
            }, null, true);
        }
        NotReadyStage2() {
            UIMgr.instance.openUI(ModuleType.UILoad);
            this.subHandler2 = Laya.Handler.create(this, this.ChangeStage, null);
        }
        clearSce() {
            UIMgr.instance.closeUI(ModuleType.Main);
        }
        ReloadLevel() {
            this.GameType == GameType$1.ready;
        }
        RestartLevel() {
            this.GameType == GameType$1.ready;
        }
        StartGame() {
            this.GameType = GameType$1.start;
            GameSDK$1.startVideoRecord();
            GameSDK$1.stageOnStart({
                stageId: LogicData.instance.level,
                stageName: "第" + LogicData.instance.level + "关",
            });
        }
        get IsSatrt() {
            return this.GameType == GameType$1.start;
        }
        dramCameraToImage(display) {
            display.graphics.clear();
            let camera = this._camera;
            if (!camera)
                return null;
            camera.renderTarget = new Laya.RenderTexture(display.width, display.height);
            var rtex = new Laya.Texture(camera.renderTarget, Laya.Texture.DEF_UV);
            display.graphics.drawTexture(rtex);
            Laya.timer.frameOnce(3, this, function () {
                camera.renderTarget = null;
            });
        }
        GameSettle() {
            this.GameType = GameType$1.settle;
        }
        GameOver(win, dTimer = 2000) {
            if (this.GameType != GameType$1.start)
                return;
            UIMgr.instance.closeUI(ModuleType.Main);
            this.GameType = GameType$1.settle;
            GameSDK$1.stageOnEnd({
                stageId: LogicData.instance.DogAge,
                stageName: "第" + LogicData.instance.DogAge + "关",
                event: win ? "complete" : "fail",
            });
            GameSDK$1.stopVideoRecord();
            if (GameSDK$1.type != PlatType$1.TOUTIAO) {
                Laya.timer.once(dTimer, this, function () {
                    UIMgr.instance.openUI(ModuleType.Share, null, null, () => {
                        this.onOpenEndHandler(100, win);
                    });
                });
            }
            else {
                Laya.timer.once(dTimer, this, function () {
                    UIMgr.instance.openUI(ModuleType.Share, null, null, () => {
                        this.onOpenEndHandler(100, win);
                    });
                });
            }
        }
        onOpenEndHandler(dTimer, win) {
            Laya.timer.once(dTimer, this, function () {
                UIMgr.instance.openUI(ModuleType.End, win);
            });
        }
        initEvent() {
            Laya.stage.on(Laya.Event.KEY_DOWN, this, this.onKeyDown);
        }
        clearEvent() {
            Laya.stage.off(Laya.Event.KEY_DOWN, this, this.onKeyDown);
        }
        onKeyDown(e) {
            if (e.keyCode == Laya.Keyboard.R) {
                this.Player.AddBigFish();
            }
            if (e.keyCode == Laya.Keyboard.T) {
                RoleMgr.Int.AddWorker(WorkType.counter);
            }
            if (e.keyCode == Laya.Keyboard.Y) {
                RoleMgr.Int.AddWorker(WorkType.waiter);
            }
            if (e.keyCode == Laya.Keyboard.U) {
                RoleMgr.Int.AddWorker(WorkType.cook);
            }
            if (e.keyCode == Laya.Keyboard.J) {
                this.Player.TakeCar(30 * 1000);
            }
            if (e.keyCode == Laya.Keyboard.K) {
                this.ChangeStage();
            }
        }
        GetStageChild(name) {
            return MyInstrument.GetChildByName(this.Stage, name);
        }
        ChangeStage() {
            if (this.StageId == 1) {
                this.LoadStage(2);
            }
            else {
                this.LoadStage();
            }
            UIMgr.instance.closeUI(ModuleType.UIQiehuan);
        }
        OpenProt() {
            LogicData.instance.SetProt(this.StageId, 1);
            EventMgr$1.Int.emit(EventType$1.SHIP_ENTER);
        }
        TipCar() {
            let b = LogicData.instance.SetCarNum(1);
            if (b) {
                this.OnCarActive();
                this.LookTo("CarNode");
                let n = "Player";
                Laya.timer.once(2000, this, this.LookTo, [n]);
            }
        }
        RewardCar() {
            let b = LogicData.instance.SetCarNum(2);
            b && this.OnCarActive();
        }
        OnCarActive() {
            if (!CanteenMgr.Int.CarNode)
                return;
            let num = LogicData.instance.CarNum;
            if (num >= 1) {
                CanteenMgr.Int.CarNode.SetStopActive(true);
            }
            else {
                CanteenMgr.Int.CarNode.SetStopActive(false);
            }
        }
        OnTakeCarActive() {
            if (!CanteenMgr.Int.CarNode)
                return;
            if (this.Player && this.Player.onCar) {
                CanteenMgr.Int.CarNode.SetCarActive(false);
            }
            else {
                CanteenMgr.Int.CarNode.SetCarActive(true);
            }
        }
        LookTo(n) {
            let sp = CanteenMgr.Int.GetStageChild(n);
            if (sp) {
                CanteenMgr.Int.CameraScript.setAim(sp, new Laya.Vector3());
            }
        }
    }
    var GameType$1;
    (function (GameType) {
        GameType[GameType["load"] = 0] = "load";
        GameType[GameType["ready"] = 1] = "ready";
        GameType[GameType["start"] = 2] = "start";
        GameType[GameType["settle"] = 3] = "settle";
        GameType[GameType["over"] = 4] = "over";
    })(GameType$1 || (GameType$1 = {}));

    class Times {
        constructor(time) {
            this.time = 0;
            if (time) {
                this.time = time;
            }
            else {
                this.time = Times.now;
            }
        }
        static get now() {
            return new Date().getTime();
        }
        static getDate() {
            return new Date().getDate();
        }
        static console(key) {
            this._console[key] = Times.now;
        }
        static consoleEnd(key, ...args) {
            console.log("执行耗时 ", key, (Times.now - (this._console[key] || Times.now)) / 1000, ...args);
        }
        static get Date() {
            return new Date();
        }
        static day(time) {
            return Math.floor(this.hour(time) / 24);
        }
        static hour(time) {
            return Math.floor(this.minute(time) / 60);
        }
        static minute(time) {
            return Math.floor(this.second(time) / 60);
        }
        static second(time) {
            if (time == null || time == undefined)
                time = this.now;
            return Math.floor(time / 1000);
        }
        static numHour(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time) % 60) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            if (this.minute() >= 60) {
                res = this.converMinTen(this.hour(time)) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        static numMinute(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time)) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        static numSecond(time) {
            return this.converMinTen(this.second(time));
        }
        static chinaHour(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "秒";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time) % 60) + "分" + res;
            }
            if (this.minute() >= 60) {
                res = this.converMinTen(this.hour(time)) + "时" + res;
            }
            return res;
        }
        static chinaMinute(time) {
            let res;
            res = this.converMinTen(this.second(time) % 60) + "秒";
            if (this.second() >= 60) {
                res = this.converMinTen(this.minute(time)) + "分" + res;
            }
            return res;
        }
        static chinaSecond(time) {
            return this.converMinTen(this.second(time)) + "秒";
        }
        static converMinTen(num) {
            return num < 10 ? ("0" + num) : num.toString();
        }
        add(time) {
            this.time += time;
            return this;
        }
        sub(time) {
            this.time -= time;
            return this;
        }
        get now() { return this.time; }
        ;
        get day() {
            return Math.floor(this.hour / 24);
        }
        get hour() {
            return Math.floor(this.minute / 60);
        }
        get minute() {
            return Math.floor(this.second / 60);
        }
        ;
        get second() {
            return Math.floor(this.time / 1000);
        }
        get numHour() {
            let res;
            res = this.converMinTen(this.second % 60) + "";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute % 60) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            if (this.minute >= 60) {
                res = this.converMinTen(this.hour) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        get numMinute() {
            let res;
            res = this.converMinTen(this.second % 60) + "";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute) + ":" + res;
            }
            else {
                res = "00:" + res;
            }
            return res;
        }
        get numSecond() {
            return this.converMinTen(this.second);
        }
        get chinaHour() {
            let res;
            res = this.converMinTen(this.second % 60) + "秒";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute % 60) + "分" + res;
            }
            if (this.minute >= 60) {
                res = this.converMinTen(this.hour) + "时" + res;
            }
            return res;
        }
        get chinaMinute() {
            let res;
            res = this.converMinTen(this.second % 60) + "秒";
            if (this.second >= 60) {
                res = this.converMinTen(this.minute) + "分" + res;
            }
            return res;
        }
        get chinaSecond() {
            return this.converMinTen(this.second) + "秒";
        }
        converMinTen(num) {
            return num < 10 ? ("0" + num) : num.toString();
        }
        static isSameDay(t) {
            return new Date(t).toLocaleDateString() === new Date().toLocaleDateString();
        }
        static compare_time(time) {
            var today_end = this.get_endtime();
            var time_old = time;
            if (today_end == time_old) {
                return 1;
            }
            else {
                return 0;
            }
        }
        static get_endtime() {
            var time_end = new Date(new Date(new Date().toLocaleDateString()).getTime() + 24 * 60 * 60 * 1000 - 1);
            var time_format = this.format_date(time_end);
            return time_format;
        }
        static format_date(now) {
            var year = now.getFullYear();
            var month = now.getMonth() + 1;
            var day = now.getDate();
            var hh = now.getHours();
            var mm = now.getMinutes();
            var ss = now.getSeconds();
            var clock = year + "";
            if (month < 10) {
                clock += "0";
            }
            clock += month + "";
            if (day < 10) {
                clock += "0";
            }
            clock += day + "";
            if (hh < 10) {
                clock += "0";
            }
            clock += hh + "";
            if (mm < 10) {
                clock += '0';
            }
            clock += mm;
            if (ss < 10) {
                clock += '0';
            }
            clock += ss;
            return clock;
        }
    }
    Times._console = {};

    let savepars = [];
    function save(target, propertyKey) {
        savepars.push(propertyKey);
    }
    class LogicData {
        constructor() {
            this.unlockValue = 0;
            this.thingInfo = {};
            this._level = 1;
            this.isShare = false;
            this._shareCount = 0;
            this.unlocks_level = [];
            this.skin_value = 0;
            this.unlocks_guns = [];
            this.girdLevel = 1;
            this.shotLevel = 1;
            this.weaponLevels = {
                8: 0,
                9: 0,
                10: 0,
            };
            this.shopLevel = 1;
            this.unlocks_shop = [1, 2, 3];
            this.levelSkin = 0;
            this.maxSource = 0;
            this.batteryLevel = 1;
            this.raftLevel = 1;
            this.batteryLevels = {
                1: 0,
                2: 0,
                3: 0,
                4: 0,
                5: 0,
            };
            this.foodColor = {};
            this.foodLevels = {
                1: 1,
                2: 0,
            };
            this.foodInfo = {};
            this.guideId = 0;
            this.levelData = { myData: [] };
            this.pngDatas = { myData: [] };
            this.levelTaget = 0;
            this.kennelLevel = 1;
            this.playArea = 0;
            this.decore = 0;
            this.dogAge = 0;
            this.familyId = 0;
            this.dogGoodValue = 0;
            this.dogGoodLast = 0;
            this.dogBadValue = 0;
            this.dogBadLast = 0;
            this.passGoodBad = {};
            this.outKind = false;
            this.videoLevel = [];
            this.videoLevelsc = [];
            this.playTimes = 0;
            this.tiezhi = [18, 19, 20];
            this.freeBack = 0;
            this.unlockgoods = [];
            this.freeVideo = 0;
            this.freeBackVideo = 0;
            this.freeDayVideo = 0;
            this.power = 5;
            this.readyArr_1 = [];
            this.readyArr_2 = [];
            this.canteenStep_1 = 1;
            this.tableLevel_1 = 1;
            this.tableLevel_2 = 0;
            this.canteenPowerLevel = {
                Speed1: 1,
                Speed2: 1,
                Speed3: 1,
                Storage1: 1,
                Storage2: 1,
                ServingCarry: 1,
                PlayerSpeed: 1,
                PlayerCarry: 1,
            };
            this.step_1 = {
                step: 0,
                gindex: 0,
                pindex: 0,
            };
            this.step_2 = {
                step: 0,
                gindex: 0,
                pindex: 0,
            };
            this.foodArr = [];
            this.prot_data = {
                1: 0,
                2: 0,
            };
            this.isTravl = 0;
            this.bigFishTimes = 0;
            this.tipId = 0;
            this.carNum = 0;
            this.tryCarTime = 0;
        }
        getLeveUnlockId() {
        }
        getRandomType(type) {
        }
        addThing(id, has = false) {
        }
        getThing(id) {
            let t = this.thingInfo[id];
            if (!t) {
                t = this.addThing(id);
                this.saveData();
            }
            return t;
        }
        buy(id) {
        }
        watchad(id, callback = null) {
        }
        get level() {
            return this._level;
        }
        set level(value) {
            this._level = value;
            this.saveData();
        }
        initData() {
            this.setData(LocalCache$1.get("LogickData", null));
        }
        get shareCount() {
            return this._shareCount;
        }
        set shareCount(value) {
            this._shareCount = value;
            this.saveData();
        }
        getShareReward() {
            let skinId = LogicSkin.instance.getEndRandomUnlockId(3);
            let shareGold = GameData.getConfigDataItem("ShareGold");
            if (skinId >= 0) {
                GameSDK$1.sendEvent("挂件分享解锁皮肤", "");
                LogicSkin.instance.getSkin(skinId, true);
            }
            else {
                LogicProp.instance.add(EPropNameById.diamonds, shareGold, true);
            }
        }
        setData(data) {
            if (!data)
                return;
            for (var i = 0; i < savepars.length; ++i) {
                const element = data[savepars[i]];
                if (element != null || element != undefined) {
                    if (Object.prototype.toString.call(element) == "[object Object]") {
                        for (const key in element) {
                            this[savepars[i]][key] = element[key];
                        }
                    }
                    else
                        this[savepars[i]] = element;
                }
            }
        }
        saveData() {
            var data = {};
            for (var i = 0; i < savepars.length; ++i) {
                data[savepars[i]] = this[savepars[i]];
            }
            LocalCache$1.set("LogickData", data);
        }
        get unlocks() {
            return LocalCache$1.get("LogicSkin._zichuangLevel", this.unlocks_level);
        }
        unLockPass(id) {
            let arr = this.unlocks;
            if (arr.indexOf(id) >= 0) {
                return;
            }
            arr.push(id);
            LocalCache$1.set("LogicSkin._zichuangLevel", arr);
        }
        get skinValue() {
            return LocalCache$1.get("LogicSkin._skin_value", this.skin_value);
        }
        addSkinValue(num) {
            let value = this.skinValue + num;
            LocalCache$1.set("LogicSkin._skin_value", value);
        }
        get unlocksGuns() {
            return LocalCache$1.get("LogicSkin._exGun", this.unlocks_guns);
        }
        unlockGun(id) {
            console.log("添加解锁特殊装备", id, this.unlocksGuns);
            let arr = this.unlocks;
            if (arr.indexOf(id) >= 0) {
                return;
            }
            arr.push(id);
            LocalCache$1.set("LogicSkin._exGun", arr);
        }
        get GirdLevel() {
            return LocalCache$1.get("LogicSkin._girdLevel", this.girdLevel);
        }
        AddGirdLevel(num) {
            let level = this.GirdLevel + num;
            if (level > 34)
                level = 34;
            LocalCache$1.set("LogicSkin._girdLevel", level);
        }
        get ShotLevel() {
            return LocalCache$1.get("LogicSkin._shotLevel", this.shotLevel);
        }
        AddShotLevel(num = 1) {
            console.log("升级射速", num);
            let level = this.ShotLevel + num;
            if (level > 90)
                level = 90;
            LocalCache$1.set("LogicSkin._shotLevel", level);
        }
        get WeaponLevels() {
            return LocalCache$1.get("LogicSkin._weaponLevels", this.weaponLevels);
        }
        AddWeaponLevels(id) {
            console.log("技能等级提升");
            let level = this.WeaponLevels[id] + 1;
            if (level > 30)
                level = 30;
            this.WeaponLevels[id] = level;
            LocalCache$1.set("LogicSkin._weaponLevels", this.WeaponLevels);
        }
        get ShopLevel() {
            return LocalCache$1.get("LogicSkin._shopLevel", this.shopLevel);
        }
        AddShopLevel() {
            let level = this.ShopLevel + 1;
            if (level > 43)
                level = 43;
            LocalCache$1.set("LogicSkin._shopLevel", level);
        }
        get unlocksShop() {
            return LocalCache$1.get("LogicSkin._unlocks_shop", this.unlocks_shop);
        }
        unlockShop(id) {
            console.log("添加解锁特殊装备", id, this.unlocksShop);
            let arr = this.unlocksShop;
            if (arr.indexOf(id) >= 0) {
                return;
            }
            arr.push(id);
            LocalCache$1.set("LogicSkin._unlocks_shop", arr);
        }
        get LevelSkin() {
            return LocalCache$1.get("LogicSkin._levelSkin", this.shopLevel);
        }
        AddLevelSkin(v) {
            let value = this.LevelSkin + v;
            if (value > 100)
                value = 100;
            LocalCache$1.set("LogicSkin._levelSkin", value);
        }
        get MaxSource() {
            return LocalCache$1.get("LogicSkin._maxSource", this.maxSource);
        }
        SetMaxSource(num) {
            LocalCache$1.set("LogicSkin._maxSource", num);
        }
        get BatteryLevel() {
            return LocalCache$1.get("LogicSkin.batteryLevel", this.batteryLevel);
        }
        AddBatteryLevel(num = 1) {
            let level = this.BatteryLevel + num;
            if (level > 50)
                level = 50;
            LocalCache$1.set("LogicSkin.batteryLevel", level);
        }
        get RaftLevel() {
            return LocalCache$1.get("LogicSkin.raftLevel", this.raftLevel);
        }
        AddRaftLevel(num = 1) {
            let level = this.RaftLevel + num;
            if (level > 50)
                level = 50;
            LocalCache$1.set("LogicSkin.raftLevel", level);
        }
        get BatteryLevels() {
            return LocalCache$1.get("LogicSkin.batteryLevels", this.batteryLevels);
        }
        AddBatteryLevels(id) {
            console.log("特殊炮台等级提升");
            let level = this.BatteryLevels[id] + 1;
            if (level > 3)
                level = 3;
            this.BatteryLevels[id] = level;
            LocalCache$1.set("LogicSkin.batteryLevels", this.BatteryLevels);
        }
        get FoodColor() {
            return LocalCache$1.get("LogicSkin.foodColor", this.foodColor);
        }
        AddFoodColor(id, color) {
            let info = this.FoodColor;
            info[id] = color;
            LocalCache$1.set("LogicSkin.foodColor", info);
        }
        get FoodLevels() {
            return LocalCache$1.get("LogicSkin.foodLevels", this.foodLevels);
        }
        AddFoodLevels(id) {
            let level = this.FoodLevels[id] + 1;
            if (id == 1) {
                if (level > 30)
                    level = 30;
            }
            if (id == 2) {
                if (level > 22)
                    level = 22;
            }
            let t = this.FoodLevels;
            t[id.toString()] = level;
            LocalCache$1.set("LogicSkin.foodLevels", t);
        }
        get FoodInfo() {
            return LocalCache$1.get("LogicSkin.foodInfo", this.foodInfo);
        }
        AddFoodInfo(id, value) {
            let info = this.FoodInfo;
            info[id] = value;
            LocalCache$1.set("LogicSkin.foodInfo", info);
        }
        get GuideId() {
            return LocalCache$1.get("LogicSkin.guideId", this.guideId);
        }
        AddGuideId(startNum, must = false) {
            if (must) {
                LocalCache$1.set("LogicSkin.guideId", startNum);
                EventMgr$1.Int.emit(EventType$1.UPDATE_GUIDE_COMPERA);
            }
            else {
                let t = this.GuideId;
                if (t != startNum)
                    return;
                t += 1;
                if (t > 6)
                    t = 6;
                LocalCache$1.set("LogicSkin.guideId", t);
                EventMgr$1.Int.emit(EventType$1.UPDATE_GUIDE_COMPERA);
            }
        }
        SetGuideId(num) {
            if (num >= 6)
                num = 6;
            LocalCache$1.set("LogicSkin.guideId", num);
        }
        get LevelData() {
            return LocalCache$1.get("LogicSkin.levelData", this.levelData);
        }
        AddLevelData(value) {
            let info = this.LevelData;
            info["myData"].push(value);
            LocalCache$1.set("LogicSkin.levelData", info);
            return info["myData"].length;
        }
        get PngDatas() {
            return LocalCache$1.get("LogicSkin.pngDatas", this.pngDatas);
        }
        AddPngData(value) {
            let info = this.PngDatas;
            info["myData"].push(value);
            LocalCache$1.set("LogicSkin.pngDatas", info);
            return info["myData"].length;
        }
        get LevelTaget() {
            return LocalCache$1.get("LogicSkin.levelTaget", this.levelTaget);
        }
        AddLevelTaget(num = 1) {
            console.log("添加通关标记", num);
            if (num == 0) {
                LocalCache$1.set("LogicSkin.levelTaget", 0);
                return;
            }
            let t = this.LevelTaget + num;
            if (t > 5)
                t = 5;
            LocalCache$1.set("LogicSkin.levelTaget", t);
        }
        get KennelLevel() {
            return LocalCache$1.get("LogicSkin.kennelLevel", this.kennelLevel);
        }
        AddKennelLevel(v = 1) {
            if (v == 0) {
                LocalCache$1.set("LogicSkin.kennelLevel", 0);
                return;
            }
            let t = this.KennelLevel + v;
            if (t > 10)
                t = 10;
            LocalCache$1.set("LogicSkin.kennelLevel", t);
        }
        get PlayArea() {
            return LocalCache$1.get("LogicSkin.playArea", this.playArea);
        }
        AddPlayArea(v = 1) {
            if (v == 0) {
                LocalCache$1.set("LogicSkin.playArea", 0);
                return;
            }
            let t = this.PlayArea + v;
            if (t > 10)
                t = 10;
            LocalCache$1.set("LogicSkin.playArea", t);
        }
        get Decore() {
            return LocalCache$1.get("LogicSkin.decore", this.decore);
        }
        AddDecore(v = 1) {
            if (v == 0) {
                LocalCache$1.set("LogicSkin.decore", 0);
                return;
            }
            let t = this.Decore + v;
            if (t > 8)
                t = 8;
            LocalCache$1.set("LogicSkin.decore", t);
        }
        get DogAge() {
            return LocalCache$1.get("LogicSkin.dogAge", this.dogAge);
        }
        AddDogAge(v = 1) {
            if (v == 0) {
                LocalCache$1.set("LogicSkin.dogAge", 0);
                return;
            }
            let t = this.DogAge + v;
            LocalCache$1.set("LogicSkin.dogAge", t);
        }
        get FamilyId() {
            return LocalCache$1.get("LogicSkin.familyId", this.familyId);
        }
        SetFamilyId(v = 1) {
            LocalCache$1.set("LogicSkin.familyId", v);
        }
        get DogGoodValue() {
            return LocalCache$1.get("LogicSkin.dogGoodValue", this.dogGoodValue);
        }
        AddDogGood(v = 1) {
            if (v == 0) {
                LocalCache$1.set("LogicSkin.dogGoodValue", 0);
                return;
            }
            let t = this.DogGoodValue + v;
            if (t > 120)
                t = 120;
            LocalCache$1.set("LogicSkin.dogGoodValue", t);
        }
        get DogGoodLast() {
            return LocalCache$1.get("LogicSkin.dogGoodLast", this.dogGoodLast);
        }
        SetDogGood(v) {
            LocalCache$1.set("LogicSkin.dogGoodLast", v);
        }
        get DogBadValue() {
            return LocalCache$1.get("LogicSkin.dogBadValue", this.dogBadValue);
        }
        AddDogBad(v = 1) {
            if (v == 0) {
                LocalCache$1.set("LogicSkin.dogBadValue", 0);
                return;
            }
            let t = this.DogBadValue + v;
            if (t > 120)
                t = 120;
            LocalCache$1.set("LogicSkin.dogBadValue", t);
        }
        get DogBadLast() {
            return LocalCache$1.get("LogicSkin.dogBadLast", this.dogBadLast);
        }
        SetDogBad(v) {
            LocalCache$1.set("LogicSkin.dogBadLast", v);
        }
        get PassGoodBad() {
            return LocalCache$1.get("LogicSkin.passGoodBad", this.passGoodBad);
        }
        AddPassGoodBad(id, value) {
            let info = this.PassGoodBad;
            info[id] = value;
            LocalCache$1.set("LogicSkin.passGoodBad", info);
        }
        get OutKind() {
            return LocalCache$1.get("LogicSkin.outKind", this.outKind);
        }
        set OutKind(Value) {
            LocalCache$1.set("LogicSkin.outKind", Value);
        }
        get VideoLevel() {
            return LocalCache$1.get("LogicSkin.videoLevel", this.videoLevel);
        }
        AddVideoLevel(id) {
            let arr = this.VideoLevel;
            console.log("添加视频前期解锁的关卡", id, arr);
            if (arr.indexOf(id) >= 0) {
                return;
            }
            arr.push(id);
            LocalCache$1.set("LogicSkin.videoLevel", arr);
        }
        get VideoLevelsc() {
            return LocalCache$1.get("LogicSkin.videoLevelsc", this.videoLevelsc);
        }
        AddVideoLevelsc(id) {
            let arr = this.VideoLevelsc;
            if (arr.indexOf(id) >= 0) {
                return;
            }
            arr.push(id);
            LocalCache$1.set("LogicSkin.videoLevelsc", arr);
        }
        get PlayTimes() {
            return LocalCache$1.get("LogicSkin.playTimes", this.playTimes);
        }
        AddPlayTimes(v = 1) {
            if (v == 0) {
                LocalCache$1.set("LogicSkin.playTimes", 0);
                return;
            }
            let t = this.PlayTimes + v;
            LocalCache$1.set("LogicSkin.playTimes", t);
        }
        get Tiezhi() {
            return LocalCache$1.get("LogicSkin.tiezhi", this.tiezhi);
        }
        AddTiezhi(id) {
            let arr = this.Tiezhi;
            if (arr.indexOf(id) >= 0) {
                return;
            }
            arr.push(id);
            LocalCache$1.set("LogicSkin.tiezhi", arr);
        }
        SubTiezhi(id) {
            let arr = this.Tiezhi;
            let index = arr.indexOf(id);
            if (index >= 0) {
                arr.splice(index, 1);
                LocalCache$1.set("LogicSkin.tiezhi", arr);
            }
        }
        get FreeBack() {
            return LocalCache$1.get("LogicSkin.freeBack", this.freeBack);
        }
        AddFreeBack() {
            let t = this.FreeBack + 1;
            LocalCache$1.set("LogicSkin.freeBack", t);
        }
        get Unlockgoods() {
            return LocalCache$1.get("LogicSkin.unlockgoods", this.unlockgoods);
        }
        AddUnlockgoods(id) {
            let arr = this.Unlockgoods;
            if (arr.indexOf(id) >= 0) {
                return;
            }
            arr.push(id);
            LocalCache$1.set("LogicSkin.unlockgoods", arr);
        }
        get FreeVideo() {
            return LocalCache$1.get("LogicSkin.freeVideo", this.freeVideo);
        }
        AddFreeVideo() {
            let t = this.FreeVideo + 1;
            if (t > 3)
                t = 3;
            LocalCache$1.set("LogicSkin.freeVideo", t);
        }
        get FreeBackVideo() {
            return LocalCache$1.get("LogicSkin.freeBackVideo", this.freeBackVideo);
        }
        AddFreeBackVideo() {
            let t = this.FreeBackVideo + 1;
            if (t > 2)
                t = 2;
            LocalCache$1.set("LogicSkin.freeBackVideo", t);
        }
        SubFreeBackVideo() {
            LocalCache$1.set("LogicSkin.freeBackVideo", 0);
        }
        get FreeDayVideo() {
            return LocalCache$1.get("LogicSkin.freeDayVideo");
        }
        setFreeDayVideo(t) {
            this.freeDayVideo = t;
            LocalCache$1.set("LogicSkin.freeDayVideo", t);
        }
        get Power() {
            return LocalCache$1.get("LogicSkin.power", this.power);
        }
        AddPower(num) {
            let t = this.Power + num;
            if (t < 0)
                t = 0;
            LocalCache$1.set("LogicSkin.power", t);
        }
        get ReadyArr_1() {
            return LocalCache$1.get("LogicSkin.readyArr_1", this.readyArr_1);
        }
        AddReadyArr_1(id) {
            let arr = this.ReadyArr_1;
            if (arr.indexOf(id) >= 0) {
                return;
            }
            arr.push(id);
            LocalCache$1.set("LogicSkin.readyArr_1", arr);
        }
        get ReadyArr_2() {
            return LocalCache$1.get("LogicSkin.readyArr_2", this.readyArr_2);
        }
        AddReadyArr_2(id) {
            let arr = this.ReadyArr_2;
            if (arr.indexOf(id) >= 0) {
                return;
            }
            arr.push(id);
            LocalCache$1.set("LogicSkin.readyArr_2", arr);
        }
        get CanteenStep_1() {
            return LocalCache$1.get("LogicSkin.canteenStep_1", this.canteenStep_1);
        }
        AddCanteenStep_1(num = 1) {
            let t = this.CanteenStep_1 + num;
            LocalCache$1.set("LogicSkin.canteenStep_1", t);
            EventMgr$1.Int.emit(EventType$1.STEP_UPDATE);
        }
        SetCanteenStep_1(num = 1) {
            if (num < this.canteenStep_1)
                return;
            LocalCache$1.set("LogicSkin.canteenStep_1", num);
            EventMgr$1.Int.emit(EventType$1.STEP_UPDATE);
        }
        get TableLevel_1() {
            return LocalCache$1.get("LogicSkin.tableLevel_1", this.tableLevel_1);
        }
        AddTableLevel_1(num = 1) {
            let t = this.TableLevel_1 + num;
            if (t > 7)
                return;
            LocalCache$1.set("LogicSkin.tableLevel_1", t);
        }
        SetTableLevel_1(num = 1) {
            let t = num;
            if (t > 7)
                return;
            LocalCache$1.set("LogicSkin.tableLevel_1", t);
        }
        get TableLevel_2() {
            return LocalCache$1.get("LogicSkin.tableLevel_2", this.tableLevel_2);
        }
        AddTableLevel_2(num = 1) {
            let t = this.TableLevel_1 + num;
            if (t > 8)
                return;
            LocalCache$1.set("LogicSkin.tableLevel_2", t);
        }
        SetTableLevel_2(num = 1) {
            let t = num;
            console.warn("解锁铁板", num);
            if (t > 8)
                return;
            if (num < this.TableLevel_2)
                return;
            LocalCache$1.set("LogicSkin.tableLevel_2", t);
        }
        get CanteenPowerLevel() {
            if (CanteenMgr.Int.StageId == 1) {
                return LocalCache$1.get("LogicSkin.canteenPowerLevel_1", this.canteenPowerLevel);
            }
            else {
                return LocalCache$1.get("LogicSkin.canteenPowerLevel_2", this.canteenPowerLevel);
            }
        }
        AddCanteenPowerLevel(str) {
            let level = this.CanteenPowerLevel[str] + 1;
            if (level > 5)
                return;
            let t = this.CanteenPowerLevel;
            t[str] = level;
            if (CanteenMgr.Int.StageId == 1) {
                LocalCache$1.set("LogicSkin.canteenPowerLevel_1", t);
            }
            else {
                LocalCache$1.set("LogicSkin.canteenPowerLevel_2", t);
            }
            EventMgr$1.Int.emit(EventType$1.ADD_POWER_LEVEL);
        }
        get Step_1() {
            return LocalCache$1.get("LogicSkin.step_1", this.step_1);
        }
        SaveStep_1(step, g, p) {
            this.step_1.step = step;
            this.step_1.gindex = g;
            this.step_1.pindex = p;
            LocalCache$1.set("LogicSkin.step_1", this.step_1);
        }
        get Step_2() {
            return LocalCache$1.get("LogicSkin.step_2", this.step_2);
        }
        SaveStep_2(step, g, p) {
            this.step_2.step = step;
            this.step_2.gindex = g;
            this.step_2.pindex = p;
            LocalCache$1.set("LogicSkin.step_2", this.step_2);
        }
        get FoodArr() {
            if (CanteenMgr.Int.StageId == 1) {
                return LocalCache$1.get("LogicSkin.foodArr_1", this.foodArr);
            }
            else {
                return LocalCache$1.get("LogicSkin.foodArr_2", this.foodArr);
            }
        }
        AddFood(id) {
            let arr = this.FoodArr;
            if (arr.indexOf(id) >= 0) {
                return;
            }
            arr.push(id);
            if (CanteenMgr.Int.StageId == 1) {
                LocalCache$1.set("LogicSkin.foodArr_1", arr);
            }
            else {
                LocalCache$1.set("LogicSkin.foodArr_2", arr);
            }
            EventMgr$1.Int.emit(EventType$1.UPDATE_FOODMENU);
        }
        get Prot_data() {
            return LocalCache$1.get("LogicSkin.prot_data", this.prot_data);
        }
        SetProt(stageid, num = 1) {
            let t = this.Prot_data;
            t[stageid] = num;
            LocalCache$1.set("LogicSkin.prot_data", t);
        }
        get IsTravl() {
            return LocalCache$1.get("LogicSkin.isTravl", this.isTravl);
        }
        SetTravl(num = 1) {
            LocalCache$1.set("LogicSkin.isTravl", num);
            EventMgr$1.Int.emit(EventType$1.INIT_TRAVL);
        }
        get BigFishTimes() {
            if (CanteenMgr.Int.StageId == 1) {
                return LocalCache$1.get("LogicSkin.bigFishTimes_1", this.bigFishTimes);
            }
            else {
                return LocalCache$1.get("LogicSkin.bigFishTimes_2", this.bigFishTimes);
            }
        }
        AddBigFishTimes(num = 1) {
            let t = this.BigFishTimes + num;
            if (CanteenMgr.Int.StageId == 1) {
                LocalCache$1.set("LogicSkin.bigFishTimes_1", t);
            }
            else {
                LocalCache$1.set("LogicSkin.bigFishTimes_2", t);
            }
        }
        get LoginTime() {
            let num = LocalCache$1.get("LogicSkin.login_time", Times.now);
            console.warn("ssssssssss", num);
            return num;
        }
        SaveTime(t) {
            LocalCache$1.set("LogicSkin.login_time", t);
        }
        get TipId() {
            return LocalCache$1.get("LogicSkin.tipId", this.tipId);
        }
        SetTipId(num) {
            if (num < this.TipId)
                return;
            if (num == 2) {
                if (+GameSDK$1.data.NewPlayerInsert == 1) {
                    GameSDK$1.showADInsert();
                }
            }
            LocalCache$1.set("LogicSkin.tipId", num);
        }
        get CarNum() {
            return LocalCache$1.get("LogicSkin.carNum", this.carNum);
        }
        SetCarNum(num) {
            if (num <= this.CarNum)
                return false;
            LocalCache$1.set("LogicSkin.carNum", num);
            return true;
        }
        get TryCarTime() {
            return LocalCache$1.get("LogicSkin.tryCarTime", this.tryCarTime);
        }
        AddCarTime(num = 1) {
            let t = this.TryCarTime + num;
            LocalCache$1.set("LogicSkin.tryCarTime", t);
        }
    }
    LogicData.instance = new LogicData();
    __decorate([
        save
    ], LogicData.prototype, "_level", void 0);
    __decorate([
        save
    ], LogicData.prototype, "_shareCount", void 0);

    class UIBattle extends UIBase {
        constructor() {
            super();
            this.ConfigUI = new ConfigUI({
                event_refresh_gold_node: "text_cur_gold_count",
            });
            this.text_chaopiao = null;
            this.c_comp_wenzimiaoshu = null;
            this.w = 0;
            this.h = 0;
            this.c_btn_xiayiguan = null;
            this.c_comp_zhiyin1 = null;
            this.c_comp_zhiyin2 = null;
            this.c_btn_zuo = null;
            this.c_btn_you = null;
            this.c_btn_shang = null;
            this.moveId = 0;
            this.zuoPos = null;
            this.shangPos = null;
            this.c_text_num1 = null;
            this.c_text_num2 = null;
            this.c_text_num3 = null;
            this.c_text_num4 = null;
            this.c_btn_fanhui2 = null;
            this.c_btn_queding = null;
            this.c_progress_jingdutioA = null;
            this.n2 = null;
            this.n3 = null;
            this.n4 = null;
            this.c_comp_wenzi = null;
            this.c_comp_guanka = null;
            this.n36 = null;
            this.c_comp_ray = null;
            this.c_comp_tili = null;
            this.c_text_cur_power_count = null;
            this.c_text_timer = null;
            this.c_comp_yd1 = null;
            this.c_comp_yd2 = null;
            this.c_comp_yd3 = null;
            this.c_img_sz = null;
            this.start_wenziy = 500;
            this.c_progress_wancheng = null;
            UIBattle._Int = this;
        }
        static get Int() {
            return this._Int;
        }
        onConstruct() {
            super.onConstruct();
        }
        onCreate() {
            if (!Times$3.isSameDay(LogicData.instance.FreeDayVideo)) {
                console.log("不是当日清零");
                LogicData.instance.SubFreeBackVideo();
            }
            else {
                console.log("是当日");
            }
        }
        onOpen() {
            this.c_btn_xiayiguan.visible = false;
            this.n36 = this.c_comp_guanka.getChild("n36").asTextField;
            if (this.openData) {
                this.openData[0].run();
            }
        }
        onUpdate() {
            this.update_timer();
        }
        onClose() {
            Laya.timer.clearAll(this);
        }
        update_timer() {
            if (CanteenMgr.Int.Player) {
                let v2 = CanteenMgr.Int.Player.viewPos;
                this.c_progress_wancheng.x = v2.x;
                this.c_progress_wancheng.y = v2.y;
            }
        }
        click_share() {
            console.log("SHARE------");
            GameSDK$1.shareMsg("", null, "");
        }
        OverChehui() {
            this.c_btn_fanhui2.selected = false;
            this.UpdateFanhui(false);
        }
        HideChehui() {
            this.OverChehui();
            this.c_btn_fanhui2.visible = false;
        }
        ShowChehui() {
            this.c_btn_fanhui2.visible = true;
        }
        UpdateGuide() {
            let gid = LogicData.instance.GuideId;
            this.getControllerAt(3).selectedIndex = gid;
            if (gid == 4) {
                this.c_comp_yd1.x = this.c_btn_fanhui2.x + this.c_btn_fanhui2.width / 2;
                this.c_comp_yd1.y = this.c_btn_fanhui2.y + this.c_btn_fanhui2.height / 2;
            }
            if (gid == 2) {
                this.c_comp_yd3.y = Laya.stage.height - 260;
            }
        }
        UpdateSource(v) {
            this.c_progress_jingdutioA.value = v;
            if (v >= 60) {
                this.controllerOnce.selectedIndex = 1;
            }
            else {
                this.controllerOnce.selectedIndex = 0;
            }
            if (v >= 95) {
                this.UpdateStart(3);
            }
            else if (v >= 60) {
                this.UpdateStart(2);
            }
            else if (v >= 30) {
                this.UpdateStart(1);
            }
            else {
                this.UpdateStart(0);
            }
        }
        ShowText() {
            if (this.c_comp_wenzi.visible == true)
                return;
            this.c_comp_wenzi.visible = true;
            this.c_comp_wenzi.alpha = 1;
            this.c_comp_wenzi.y = this.start_wenziy;
            this.c_comp_wenzi.getControllerAt(0).selectedIndex = Math.floor(Math.random() * 6);
            Laya.Tween.to(this.c_comp_wenzi, { alpha: 0, y: this.c_comp_wenzi.y - 100 }, 1000, null, Laya.Handler.create(this, this.HideText));
        }
        UpdateLevel() {
            this.n36.text = LogicData.instance.level.toString();
        }
        HideText() {
            this.c_comp_wenzi.visible = false;
        }
        UpdateBackText(u = true) {
            let t = LogicData.instance.FreeBack;
            if (t < 15) {
                this.c_btn_fanhui2.getControllerAt(1).selectedIndex = 0;
                this.c_btn_fanhui2.getChild("text_t").text = (15 - t).toString();
            }
            else {
                this.c_btn_fanhui2.getControllerAt(1).selectedIndex = 1;
                this.c_btn_fanhui2.getChild("text_t").text = "2";
                let d = LogicProp.instance.get(EPropNameById.diamonds);
                if (d < 2) {
                    this.c_btn_fanhui2.enabled = false;
                    return;
                }
                this.c_btn_fanhui2.enabled = true;
            }
            if (LogicData.instance.FreeBackVideo >= 2) {
                this.c_btn_fanhui2.getChild("text_t").visible = false;
                this.c_btn_fanhui2.getControllerAt(1).selectedIndex = 0;
                this.c_btn_fanhui2.enabled = true;
            }
        }
        ShowFreeVideo() {
            let level = LogicData.instance.level;
            if (LogicData.instance.FreeBackVideo < 2) {
                if (level % 2 == 0 || level % 4 == 0 || level % 6 == 0) {
                    UIMgr.instance.openUI(ModuleType.UIFreeBackVideo);
                }
            }
        }
        UpdatePower() {
            let p = LogicData.instance.Power;
            this.c_text_cur_power_count.text = p.toString();
        }
        UpdateStart(num) {
            if (num == 0) {
                this.n2.getControllerAt(0).selectedIndex = 1;
                this.n3.getControllerAt(0).selectedIndex = 1;
                this.n4.getControllerAt(0).selectedIndex = 1;
            }
            else if (num == 1) {
                this.n2.getControllerAt(0).selectedIndex = 0;
                this.n3.getControllerAt(0).selectedIndex = 1;
                this.n4.getControllerAt(0).selectedIndex = 1;
            }
            else if (num == 2) {
                this.n2.getControllerAt(0).selectedIndex = 0;
                this.n3.getControllerAt(0).selectedIndex = 0;
                this.n4.getControllerAt(0).selectedIndex = 1;
            }
            else if (num == 3) {
                this.n2.getControllerAt(0).selectedIndex = 0;
                this.n3.getControllerAt(0).selectedIndex = 0;
                this.n4.getControllerAt(0).selectedIndex = 0;
            }
        }
        UpdateBatlle() {
            if (IceBoxMgr.Int.IsOpenDoor) {
                this.getControllerAt(4).setSelectedIndex(1);
            }
            else {
                this.getControllerAt(4).setSelectedIndex(0);
            }
        }
        UpdateBatlle2() {
            if (IceBoxMgr.Int.curBox) {
                this.c_btn_queding.visible = true;
                this.c_btn_fanhui2.visible = true;
            }
            else {
                this.c_btn_queding.visible = false;
                this.c_btn_fanhui2.visible = false;
            }
        }
        UpdatePowerTimer() {
            let t = IceBoxMgr.Int.enterTimer * 1000;
            this.c_text_timer.text = Times$3.minute(t) + ":" + Times$3.second(t);
        }
        click_addPower() {
            GameSDK$1.showADVideo(this, (b) => {
                if (b) {
                    LogicData.instance.AddPower(1);
                    this.UpdatePower();
                }
            }, "皮肤商城");
        }
        click_tishi() {
            UIMgr.instance.openUI(ModuleType.UITishi);
        }
        click_fanhui() {
            UIMgr.instance.openUI(ModuleType.UISetting, 1);
        }
        click_fanhui2() {
            this.UpdateFanhui(true);
        }
        UpdateFanhui(isBtn = false) {
            IceBoxMgr.Int.UpdateRayKind(this.c_btn_fanhui2.selected ? 1 : 0, isBtn);
            if (!this.c_btn_fanhui2.selected) {
                this.UpdateBackText();
                EventMgr$1.Int.emit(EventType$1.GOODS_SHACK, false);
                this.c_img_sz.visible = false;
            }
            else {
                EventMgr$1.Int.emit(EventType$1.GOODS_SHACK, true);
                let t = LogicData.instance.FreeBack;
                if (t < 15) {
                    this.c_img_sz.visible = false;
                }
                else {
                    if (LogicData.instance.FreeBackVideo < 2) {
                        this.c_img_sz.visible = true;
                    }
                    else {
                        this.c_img_sz.visible = false;
                    }
                }
            }
        }
        click_queding() {
            IceBoxMgr.Int.BoxBack();
        }
        click_chonglai() {
            IceBoxMgr.Int.RestartLevel();
        }
        click_xiayiguajn() {
            GameSDK$1.showADVideo(this, (b) => {
                if (b) {
                    LogicData.instance.level += 1;
                    this.closeUI();
                    IceBoxMgr.Int.LoadNextLevel();
                    LogicData.instance.AddGuideId(6, true);
                }
            }, "视频跳关");
        }
        click_xiayiguan() {
            IceBoxMgr.Int.GameOver(IceBoxMgr.Int.curPSource);
        }
        click_shangdain() {
            UIMgr.instance.openUI(ModuleType.Skin);
        }
    }

    class CameraRay {
        constructor(sce, camera) {
            this._scene3d = null;
            this._camera = null;
            this._point = null;
            this._ray = null;
            this._outHitResult = null;
            this._handlerDown = null;
            this._handlerMove = null;
            this._handlerUp = null;
            this._sprite = null;
            this._cd = 0;
            this._maxCd = 0;
            this._dist = 40;
            this._scene3d = sce;
            this._camera = camera;
        }
        Init(handler, handler2, handler3, Sprite = null) {
            this._ray = new Laya.Ray(new Laya.Vector3(0, 0, 0), new Laya.Vector3(0, 0, 0));
            this._point = new Laya.Vector2();
            this._outHitResult = new Laya.HitResult();
            this._handlerDown = handler;
            this._handlerMove = handler2;
            this._handlerUp = handler3;
            if (Sprite) {
                this._sprite = Sprite;
            }
            else {
                this._sprite = Laya.stage;
            }
            this._sprite.on(Laya.Event.MOUSE_DOWN, this, this.OnMouseDown);
            this._sprite.on(Laya.Event.MOUSE_MOVE, this, this.OnMouseMove);
            this._sprite.on(Laya.Event.MOUSE_UP, this, this.OnMouseUp);
            Laya.timer.frameLoop(1, this, this.Update);
        }
        Clear() {
            this._sprite.off(Laya.Event.MOUSE_DOWN, this, this.OnMouseDown);
            this._sprite.off(Laya.Event.MOUSE_MOVE, this, this.OnMouseMove);
            this._sprite.off(Laya.Event.MOUSE_UP, this, this.OnMouseUp);
            Laya.timer.clearAll(this);
        }
        Update() {
            if (this._cd > 0) {
                this._cd -= Laya.timer.delta;
                if (this._cd < 0)
                    this._cd = 0;
            }
        }
        OnMouseDown(e) {
            this._cd = this._maxCd;
            this._point.x = e.stageX;
            this._point.y = e.stageY;
            this._camera.viewportPointToRay(this._point, this._ray);
            this._scene3d.physicsSimulation.rayCast(this._ray, this._outHitResult, 200, PhysicsGroup.def, PhysicsGroup.all ^ PhysicsGroup.gp10);
            if (this._outHitResult.succeeded) {
                if (this._handlerDown) {
                    this._handlerDown.runWith(this._outHitResult);
                }
                this._dist = 0;
            }
            else {
                this._dist = 40;
            }
        }
        OnMouseMove(e) {
            let v2 = new Laya.Vector2(e.stageX - this._point.x, e.stageY - this._point.y);
            let _dsq = Laya.Vector2.scalarLength(v2);
            this._dist += _dsq;
            if (this._dist < 40)
                return;
            if (_dsq >= 50) {
                console.log("插值射线");
                this._point.x = (e.stageX + this._point.x) / 2;
                this._point.y = (e.stageY + this._point.y) / 2;
                this._camera.viewportPointToRay(this._point, this._ray);
                this._scene3d.physicsSimulation.rayCast(this._ray, this._outHitResult, 200, PhysicsGroup.def, PhysicsGroup.all ^ PhysicsGroup.gp10);
                if (this._outHitResult.succeeded) {
                    if (this._handlerDown) {
                        let sc = this._handlerMove.runWith(this._outHitResult);
                        if (sc) {
                            this._dist = 0;
                        }
                    }
                }
            }
            this._point.x = e.stageX;
            this._point.y = e.stageY;
            this._camera.viewportPointToRay(this._point, this._ray);
            this._scene3d.physicsSimulation.rayCast(this._ray, this._outHitResult, 200, PhysicsGroup.def, PhysicsGroup.all ^ PhysicsGroup.gp10);
            if (this._outHitResult.succeeded) {
                if (this._handlerDown) {
                    let sc = this._handlerMove.runWith(this._outHitResult);
                    if (sc) {
                        this._dist = 0;
                    }
                }
            }
        }
        OnMouseUp(e) {
            this._point.x = e.stageX;
            this._point.y = e.stageY;
            this._camera.viewportPointToRay(this._point, this._ray);
            this._scene3d.physicsSimulation.rayCast(this._ray, this._outHitResult, 200, PhysicsGroup.def, PhysicsGroup.all ^ PhysicsGroup.gp10);
            if (this._outHitResult.succeeded) {
                if (this._handlerUp) {
                    this._handlerUp.runWith(this._outHitResult);
                }
            }
        }
    }

    class IceGoods extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this._goodsId = 1;
            this._goodsData = null;
            this._oldParent = null;
            this._oldPos = null;
            this._oldRot = null;
            this._ownerBasket = null;
            this._point = null;
            this._box = null;
            this._model = null;
            this.shackTween = null;
        }
        InitId(id, o) {
            this._goodsId = id;
            this._ownerBasket = o;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this._oldParent = this._obj.parent;
            this._oldPos = this._obj.transform.localPosition.clone();
            this._oldRot = this._obj.transform.localRotationEuler.clone();
            this._goodsData = GameData.getGoodsItem(this._goodsId);
            this.InitModel();
        }
        onEnable() {
            EventMgr$1.Int.on(EventType$1.GOODS_SHACK, this.OnShack, this);
        }
        onDisable() {
            this.OnShack(false);
            EventMgr$1.Int.off(EventType$1.GOODS_SHACK, this.OnShack, this);
        }
        onDestroy() {
            this.OnShack(false);
            EventMgr$1.Int.off(EventType$1.GOODS_SHACK, this.OnShack, this);
        }
        MoveToBox(point, box) {
            this._point = point.clone();
            this._box = box;
            this.SetCanRay(true);
        }
        BackToBasket() {
            this.OnShack(false);
            this._point = null;
            this._box = null;
            this._oldParent.addChild(this._obj);
            this._obj.transform.localPosition = this._oldPos.clone();
            this._obj.transform.localRotationEuler = this._oldRot.clone();
            this._ownerBasket.AddGoods();
            this.SetCanRay(false);
        }
        get InBox() {
            return this._point != null;
        }
        get Size() {
            return new Laya.Vector3(this._goodsData.Long, this._goodsData.Wide, this._goodsData.High);
        }
        get Point() {
            return this._point.clone();
        }
        get Price() {
            return this._goodsData.Price;
        }
        InitModel() {
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(this._goodsData.PrefabName), () => {
                this.AddModel();
            });
        }
        AddModel() {
            if (!this._obj)
                return;
            this._model = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs(this._goodsData.PrefabName)).clone();
            this._model.transform.localPosition = new Laya.Vector3();
            this._model.transform.localRotationEuler = new Laya.Vector3();
            this._obj.addChild(this._model);
            this.SetCanRay(false);
        }
        SetCanRay(v) {
            let obj = this._obj.getChildAt(0);
            let collider = obj.getComponent(Laya.PhysicsCollider);
            if (v) {
                collider.collisionGroup = PhysicsGroup.gp1;
            }
            else {
                collider.collisionGroup = PhysicsGroup.gp10;
            }
        }
        BigTween() {
            this._transform.setWorldLossyScale(new Laya.Vector3(0.5, 0.5, 0.5));
            let v = this._transform.getWorldLossyScale();
            Laya.Tween.to(v, { x: 1, y: 1, z: 1, update: Laya.Handler.create(this, this.tweenUpdate, [v], false) }, 240, Laya.Ease.backOut);
        }
        tweenUpdate(v3) {
            this._transform.setWorldLossyScale(v3.clone());
        }
        OnShack(bl) {
            if (this._box != IceBoxMgr.Int.curBox) {
                if (!bl) {
                    if (this.shackTween) {
                        this.shackTween.clear();
                        Laya.Tween.clearAll(this._model.transform);
                        this._model.transform.localRotationEulerY = 0;
                        this.shackTween = null;
                    }
                }
                return;
            }
            if (bl) {
                this.Shack();
            }
            else {
                if (this.shackTween) {
                    this.shackTween.clear();
                    Laya.Tween.clearAll(this._model.transform);
                    this._model.transform.localRotationEulerY = 0;
                    this.shackTween = null;
                }
            }
        }
        Shack() {
            if (!this.InBox)
                return;
            this.ShackLeft();
        }
        ShackLeft() {
            if (!this._model)
                return;
            if (!this._model.transform)
                return;
            this.shackTween = Laya.Tween.to(this._model.transform, { localRotationEulerY: 6 }, 100, null, Laya.Handler.create(this, this.ShackRght));
        }
        ShackRght() {
            this.shackTween = Laya.Tween.to(this._model.transform, { localRotationEulerY: -6 }, 100, null, Laya.Handler.create(this, this.ShackLeft));
        }
    }

    class Basket extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this._goodsId = -1;
            this._goodsNum = 0;
            this._goodsArr = null;
            this.shackTween = null;
            this.timer = 0;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this._goodsArr = [];
            EventMgr$1.Int.on(EventType$1.UPDATE_SKIN, this.InitSkin, this);
            this.InitSkin();
        }
        onDisable() {
            this.OnShack(false);
            EventMgr$1.Int.off(EventType$1.UPDATE_SKIN, this.InitSkin, this);
        }
        onDestroy() {
            this.OnShack(false);
            EventMgr$1.Int.off(EventType$1.UPDATE_SKIN, this.InitSkin, this);
        }
        InitSkin() {
            if (!this._obj)
                return;
            let id = LogicSkin.instance.getSkinID(4);
            let data = GameData.getSkinItem(id);
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(data.MeshName[0]), (e) => {
                MyInstrument.ChangeMesh(this._obj.getChildAt(0), e);
            });
        }
        Init(id, num) {
            this._goodsId = id;
            this._goodsNum = num;
        }
        InitGoodsModel() {
            for (let index = 0; index < this._goodsNum; index++) {
                this.AddGoodsModel();
            }
        }
        AddGoodsModel() {
            let goods = new Laya.Sprite3D();
            let scr = goods.addComponent(IceGoods);
            scr.InitId(this._goodsId, this);
            goods.transform.localPosition = new Laya.Vector3(Math.random() * 0.5 - 0.25, Math.random() * 0.6, Math.random() * 0.5 - 0.25);
            goods.transform.localRotationEuler = new Laya.Vector3(Math.random() * 30 - 15, Math.random() * 180, Math.random() * 30 - 15);
            goods.transform.localScale = new Laya.Vector3(1, 1, 1);
            this._obj.addChild(goods);
            this._goodsArr.push(scr);
        }
        InitGoodsPoint() {
            this._goodsArr.forEach((scr) => {
                if (scr && scr.InBox) {
                    console.warn("货物归为");
                    scr.BackToBasket();
                }
            });
        }
        AddGoods() {
            this._goodsNum += 1;
        }
        SubNum(num = 1) {
            this._goodsNum -= num;
            return this._obj.getChildAt(this._obj.numChildren - 1);
        }
        get GoodsId() {
            return this._goodsId;
        }
        get GoodsNum() {
            return this._goodsNum;
        }
        OnSelect() {
            this.BigTween();
            LogicData.instance.AddGuideId(2);
            AudioMgr$1.instance.play_sound(8);
        }
        OffSelect() {
            this.SmallTween();
        }
        BigTween() {
            let v = this._transform.getWorldLossyScale();
            Laya.Tween.to(v, { x: 1.2, y: 1.2, z: 1.2, update: Laya.Handler.create(this, this.tweenUpdate, [v], false) }, 240, Laya.Ease.backOut);
        }
        SmallTween() {
            let v = this._transform.getWorldLossyScale();
            Laya.Tween.to(v, { x: 1, y: 1, z: 1, update: Laya.Handler.create(this, this.tweenUpdate, [v], false) }, 240, Laya.Ease.backOut);
            this.OnShack(false);
        }
        tweenUpdate(v3) {
            this._transform.setWorldLossyScale(v3.clone());
        }
        OnShack(bl) {
            if (bl) {
                this.Shack();
            }
            else {
                if (this.shackTween) {
                    this.shackTween.clear();
                    Laya.Tween.clearAll(this._obj.transform);
                    this._obj.transform.localRotationEulerY = 0;
                    this.shackTween = null;
                    this.timer = 0;
                }
            }
        }
        Shack() {
            if (this.timer > 0)
                return;
            this.timer = 0;
            this.ShackLeft();
        }
        ShackLeft() {
            this.shackTween = Laya.Tween.to(this._obj.transform, { localRotationEulerY: 6 }, 100, null, Laya.Handler.create(this, this.ShackRght));
            this.AddTimer();
        }
        ShackRght() {
            this.shackTween = Laya.Tween.to(this._obj.transform, { localRotationEulerY: -6 }, 100, null, Laya.Handler.create(this, this.ShackLeft));
            this.AddTimer();
        }
        AddTimer() {
            this.timer += 1;
            if (this.timer >= 10) {
                this.OnShack(false);
            }
        }
        get CldIndex() {
            return this._obj.parent.getChildIndex(this._obj);
        }
    }

    class BasketCtr extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this._isStartDrag = false;
            this._startx = 0;
            this._movex = 0;
            this._basketNum = 0;
            this.aimz = 0;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            Laya.stage.on(Laya.Event.MOUSE_MOVE, this, this.MouseDrag);
            Laya.stage.on(Laya.Event.MOUSE_UP, this, this.StopDrag);
        }
        onUpdate() {
            if (this._isStartDrag)
                return;
            if (this.aimz < 0)
                return;
            this._transform.localPositionZ += (this.aimz - this._transform.localPositionZ) * 0.08;
        }
        AddBasket(sp) {
            this._obj.addChild(sp);
            let index = this._obj.getChildIndex(sp);
            sp.transform.localPosition = new Laya.Vector3(0, 0, index * -2);
            this._basketNum = this._obj.numChildren;
        }
        InitGoods() {
            for (let index = 0; index < this._obj.numChildren; index++) {
                const element = this._obj.getChildAt(index);
                let scr = element.getComponent(Basket);
                scr.InitGoodsModel();
            }
        }
        InitPoint() {
            for (let index = 0; index < this._obj.numChildren; index++) {
                const element = this._obj.getChildAt(index);
                let scr = element.getComponent(Basket);
                scr.InitGoodsPoint();
            }
            this._transform.localPositionZ = 0;
        }
        Clear() {
            this._obj.destroyChildren();
        }
        StartDrag() {
            if (this._isStartDrag)
                return;
            this._isStartDrag = true;
            this._startx = Laya.MouseManager.instance.mouseX;
            this._movex = 0;
        }
        StopDrag() {
            this._isStartDrag = false;
        }
        MouseDrag() {
            if (!this._isStartDrag)
                return;
            let ex = Laya.MouseManager.instance.mouseX;
            this._movex += -(ex - this._startx) / 120;
            let tx = this._transform.localPositionZ - (ex - this._startx) / 220;
            if (tx < 0)
                tx = 0;
            if (tx > this._basketNum * 1.8)
                tx = this._basketNum * 1.8;
            this._transform.localPositionZ = tx;
            this._startx = ex;
        }
        Toz(num) {
            this.aimz = num;
        }
    }

    class IceBoxList {
        constructor(size) {
            this._pointArr = [];
            this._pointArray = [];
            this._size = null;
            this._goodsNum = 0;
            this._size = size.clone();
            this._pointArr = new Array();
            this._pointArray = [];
            for (let i = 0; i <= size.x; i++) {
                let arr = new Array();
                this._pointArr.push(arr);
                for (let j = 0; j <= size.y; j++) {
                    let arr2 = new Array();
                    arr.push(arr2);
                    for (let k = 0; k <= size.z; k++) {
                        arr2.push(0);
                    }
                }
            }
        }
        Clear() {
            for (let i = 0; i <= this._size.x; i++) {
                for (let j = 0; j <= this._size.y; j++) {
                    for (let k = 0; k <= this._size.z; k++) {
                        this._pointArr[i][j][k] = 0;
                    }
                }
            }
        }
        MostNearPoint(v3) {
            let t = new Laya.Vector3();
            t.x = -Math.round(v3.x / IceBoxList._steplth);
            t.y = Math.round(v3.y / IceBoxList._steplth);
            t.z = -Math.round(v3.z / IceBoxList._steplth);
            return t.clone();
        }
        ToV3(point) {
            let c = IceBoxList._steplth;
            let t = new Laya.Vector3();
            t.x = -point.x * c;
            t.y = point.y * c;
            t.z = -point.z * c;
            return t.clone();
        }
        DrawPoint(parent) {
            for (let i = 0; i <= this._size.x; i++) {
                for (let j = 0; j <= this._size.y; j++) {
                    for (let k = 0; k <= this._size.z; k++) {
                        this.createPoint(parent, new Laya.Vector3(i, j, k));
                    }
                }
            }
        }
        createPoint(parent, point) {
            let box = new Laya.MeshSprite3D(Laya.PrimitiveMesh.createBox(0.05, 0.05, 0.05));
            let mat = new Laya.BlinnPhongMaterial();
            mat._Color = new Laya.Vector4(1, 0, 0, 1);
            box.meshRenderer.material = mat;
            parent.addChild(box);
            box.transform.localPosition = this.ToV3(point);
        }
        RootsCheck(point, size) {
            for (let i = 0; i < size.x; i++) {
                for (let k = 0; k < size.z; k++) {
                    for (let j = point.y - 1; j >= 0; j--) {
                        let iarr = this._pointArr[point.x + i];
                        if (!iarr) {
                            console.warn("数组越界");
                            return;
                        }
                        let jarr = iarr[j];
                        if (!jarr) {
                            console.warn("数组越界");
                            return;
                        }
                        let t = this._pointArr[point.x + i][j][point.z + k];
                        if (t == 0) {
                            return false;
                        }
                    }
                }
            }
            return true;
        }
        Add(point, size) {
            let pos = point.clone();
            let w = Math.floor(size.x / 2);
            let s = Math.floor(size.z / 2);
            pos.x -= w;
            pos.z -= s;
            if (pos.y < 0)
                return [false];
            if (pos.y + size.y > this._size.y)
                return [false, new Laya.Vector3(pos.x + w, pos.y, pos.z + s)];
            if (pos.x + size.x > this._size.x || pos.z + size.z > this._size.z || pos.x < 0 || pos.z < 0) {
                if (pos.x < 0 && pos.x > -10 && pos.z >= 0 && pos.z + size.z <= this._size.z) {
                    pos.x = 0;
                }
                else if (pos.z < 0 && pos.z > -10 && pos.x >= 0 && pos.x + size.x <= this._size.x) {
                    pos.z = 0;
                }
                else if (pos.x + size.x <= this._size.x + 3 * w && pos.z + size.z <= this._size.z) {
                    pos.x = this._size.x - size.x;
                }
                else if (pos.z + size.z <= this._size.z + 3 * s && pos.x + size.x <= this._size.x) {
                    pos.z = this._size.z - size.z;
                }
                else {
                    return [false, new Laya.Vector3(pos.x + w, pos.y, pos.z + s)];
                }
            }
            let check = this.RootsCheck(pos, size);
            if (!check)
                return [false, pos];
            for (let i = 0; i < size.x; i++) {
                for (let j = 0; j < size.y; j++) {
                    for (let k = 0; k < size.z; k++) {
                        let iarr = this._pointArr[pos.x + i];
                        if (!iarr) {
                            console.warn("数组越界");
                            return [false, new Laya.Vector3(pos.x + w, pos.y, pos.z + s)];
                        }
                        let jarr = iarr[pos.y + j];
                        if (!jarr) {
                            console.warn("数组越界");
                            return [false, new Laya.Vector3(pos.x + w, pos.y, pos.z + s)];
                        }
                        let t = this._pointArr[pos.x + i][pos.y + j][pos.z + k];
                        if (t == 1) {
                            console.warn("位置被占用，不能添加", pos.x + i, pos.y + j, pos.z + k);
                            return [false, new Laya.Vector3(pos.x + w, pos.y, pos.z + s)];
                        }
                        if (t == null || t == undefined) {
                            console.warn("位置越界,不能添加", pos.x + i, pos.y + j, pos.z + k);
                            return [false, new Laya.Vector3(pos.x + w, pos.y, pos.z + s)];
                        }
                    }
                }
            }
            for (let i = 0; i < size.x; i++) {
                for (let j = 0; j < size.y; j++) {
                    for (let k = 0; k < size.z; k++) {
                        this._pointArr[pos.x + i][pos.y + j][pos.z + k] = 1;
                    }
                }
            }
            console.warn("box数据add完毕");
            this._goodsNum += 1;
            if (this._goodsNum > 0) {
                EventMgr$1.Int.emit(EventType$1.SHOW_CHEHUI);
            }
            return [true, new Laya.Vector3(pos.x + w, pos.y, pos.z + s)];
        }
        Sub(point, size) {
            console.warn("移除起始位置", point, size);
            let pos = point.clone();
            pos.x -= Math.floor(size.x / 2);
            pos.z -= Math.floor(size.z / 2);
            console.warn("检测起始位置", pos);
            for (let i = 0; i < size.x; i++) {
                for (let j = 0; j < size.y; j++) {
                    for (let k = 0; k < size.z; k++) {
                        let iarr = this._pointArr[pos.x + i];
                        if (!iarr) {
                            console.warn("数组越界");
                            return;
                        }
                        let jarr = iarr[pos.y + j];
                        if (!jarr) {
                            console.warn("数组越界");
                            return;
                        }
                        let t = this._pointArr[pos.x + i][pos.y + j][pos.z + k];
                        if (t == 0) {
                            console.warn("移除出错,居然有没被填充的坑尝试移除");
                            return false;
                        }
                        if (t == null || t == undefined) {
                            console.warn("移除越界,不能移除");
                            return false;
                        }
                    }
                }
            }
            for (let i = 0; i < size.x; i++) {
                for (let j = 0; j < size.y; j++) {
                    for (let k = 0; k < size.z; k++) {
                        this._pointArr[pos.x + i][pos.y + j][pos.z + k] = 0;
                    }
                }
            }
            console.warn("box数据sub完毕");
            this._goodsNum -= 1;
            if (this._goodsNum <= 0) {
                EventMgr$1.Int.emit(EventType$1.HIDE_CHEHUI);
            }
            return true;
        }
        get GoodsNum() {
            return this._goodsNum;
        }
    }
    IceBoxList._steplth = 0.25;

    class IceBox extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this._sPos = null;
            this._sRot = null;
            this._iceBoxList = null;
            this._PointTrans = null;
            this.RewardedBox = null;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this._sPos = this._transform.position.clone();
            this._sRot = this._transform.rotation.clone();
            this._PointTrans = this._obj.getChildByName("PointTrans");
            this.RewardedBox = this._obj.getChildByName("RewardedBox");
            let c = IceBoxList._steplth;
            let y = 9;
            let scale = this._obj.getChildAt(0).transform.localScaleY;
            y = Math.floor(y * scale);
            if (this._obj.name.indexOf("Big_Box") >= 0) {
                this._iceBoxList = new IceBoxList(new Laya.Vector3(3 / c, y, 4 / c));
            }
            else if (this._obj.name.indexOf("Mid_Box") >= 0) {
                this._iceBoxList = new IceBoxList(new Laya.Vector3(3 / c, y, 2 / c));
            }
            else if (this._obj.name.indexOf("Small_box") >= 0) {
                this._iceBoxList = new IceBoxList(new Laya.Vector3(3 / c, 4, 1.5 / c));
            }
            else if (this._obj.name.indexOf("Small_Tall_box") >= 0) {
                this._iceBoxList = new IceBoxList(new Laya.Vector3(3 / c, y, 1.5 / c));
            }
            this.InitSkin();
            this.InitLock();
        }
        onEnable() {
            EventMgr$1.Int.on(EventType$1.UPDATE_SKIN, this.InitSkin, this);
        }
        onDisable() {
            EventMgr$1.Int.off(EventType$1.UPDATE_SKIN, this.InitSkin, this);
        }
        onDestroy() {
            EventMgr$1.Int.off(EventType$1.UPDATE_SKIN, this.InitSkin, this);
        }
        InitSkin() {
            if (!this._obj)
                return;
            let id = LogicSkin.instance.getSkinID(3);
            let data = GameData.getSkinItem(id);
            this.ChoutiMesh(data);
            this.ChoutiMat(data);
        }
        InitLock() {
            console.warn("当前box的名称", this._obj.name);
            if (this.RewardedBox) {
                let arr = this._obj.name.split("_");
                if (arr[arr.length - 1] == "s") {
                    this.RewardedBox.active = true;
                }
                else {
                    this.RewardedBox.active = false;
                }
            }
        }
        ChoutiMesh(data) {
            let index = 0;
            if (this._obj.name.indexOf("Small_box_1") >= 0) {
                index = 1;
            }
            if (this._obj.name.indexOf("Mid_Box") >= 0) {
                index = 2;
            }
            if (this._obj.name.indexOf("Small_Tall_box") >= 0) {
                index = 3;
            }
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(data.MeshName[index]), (e) => {
                let sp = this._obj.getChildAt(0);
                MyInstrument.ChangeMesh(sp, e);
                let id = LogicSkin.instance.getSkinID(5);
                let tdata = GameData.getSkinItem(id);
                this.Tiezhi(tdata);
                if (index == 0) {
                    if (data.MeshName[index] == "Big_Box_Open_1") {
                        sp.transform.localScaleZ = 1.2;
                    }
                    else {
                        sp.transform.localScaleZ = 1;
                    }
                }
            });
        }
        ChoutiMat(data) {
            let name;
            if (data.Id == 36) {
                name = "Big_Box_1";
            }
            else if (data.Id == 37) {
                name = "Big_Box_2";
            }
            else if (data.Id == 38) {
                name = "Big_Box_3";
            }
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(name), (e) => {
                let ms = this._obj.getChildAt(0);
                ms.meshRenderer.materials = e.meshRenderer.materials;
            });
        }
        Tiezhi(data) {
            if (data == undefined) {
                let Sticker_1 = MyInstrument.GetChildByName(this._obj, "Sticker_1");
                let Sticker_2 = MyInstrument.GetChildByName(this._obj, "Sticker_2");
                Sticker_1 && (Sticker_1.active = false);
                Sticker_2 && (Sticker_2.active = false);
                return;
            }
            ResourcesMgr$1.instance.load(RescoureData.GetTieTexture(data.NormalMapping), (e) => {
                let id = LogicSkin.instance.getSkinID(3);
                let Sticker_1 = MyInstrument.GetChildByName(this._obj, "Sticker_1");
                let Sticker_2 = MyInstrument.GetChildByName(this._obj, "Sticker_2");
                let ms;
                if (id != 36) {
                    ms = Sticker_2;
                    Sticker_1.active = false;
                }
                else {
                    ms = Sticker_1;
                    Sticker_2.active = false;
                }
                ms.active = true;
                let mat = ms.meshRenderer.material;
                mat.albedoTexture = e;
            });
        }
        Clear() {
            this._iceBoxList.Clear();
        }
        TryReadyOut(v3, rot, hd) {
            if (this.RewardedBox && this.RewardedBox.active == true) {
                GameSDK$1.showADVideo(this, (state) => {
                    if (state) {
                        this.RewardedBox.active = false;
                        this.ReadyOut(v3, rot, hd);
                    }
                    else {
                        hd.runWith(null);
                    }
                }, "视频获得抽屉");
            }
            else {
                this.ReadyOut(v3, rot, hd);
            }
        }
        ReadyOut(v3, rot, hd) {
            let v = this._sPos.clone();
            Laya.Tween.to(v, {
                x: v.x + 3,
                update: Laya.Handler.create(this, this.UpdatePos, [v], false),
            }, 120, null, Laya.Handler.create(this, this.ReadyOut1, [v3, rot, hd]));
            AudioMgr$1.instance.play_sound(2);
            LogicData.instance.AddGuideId(1);
        }
        ReadyOut1(v3, rot, hd) {
            let slef = this;
            let v = this._transform.position.clone();
            Laya.Tween.to(v, {
                x: v3.x,
                y: v3.y,
                z: v3.z,
                update: Laya.Handler.create(this, this.UpdatePos, [v], false),
            }, 380, null);
            let r = this._sRot.clone();
            Laya.Tween.to(r, {
                x: rot.x,
                y: rot.y,
                z: rot.z,
                w: rot.w,
                update: Laya.Handler.create(this, this.UpdateRot, [r], false),
            }, 500, null, Laya.Handler.create(this, function () {
                hd.runWith(slef);
            }));
        }
        ReadyBack() {
            let v = this._transform.position.clone();
            Laya.Tween.to(v, {
                x: this._sPos.x,
                y: this._sPos.y,
                z: this._sPos.z,
                update: Laya.Handler.create(this, this.UpdatePos, [v], false),
            }, 500);
            let r = this._transform.rotation.clone();
            Laya.Tween.to(r, {
                x: this._sRot.x,
                y: this._sRot.y,
                z: this._sRot.z,
                w: this._sRot.w,
                update: Laya.Handler.create(this, this.UpdateRot, [r], false),
            }, 500);
            AudioMgr$1.instance.play_sound(1);
        }
        UpdatePos(v) {
            this._transform.position = v.clone();
        }
        UpdateRot(r) {
            this._transform.rotation = r.clone();
        }
        get PointTrans() {
            return this._PointTrans;
        }
        get Obj() {
            return this._obj;
        }
        get iceList() {
            return this._iceBoxList;
        }
    }

    class RayBan extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this._cRig = null;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
        }
        Open() {
            this._obj.active = true;
        }
        Close() {
            this._obj.active = false;
        }
        get Pos() {
            return this._transform.position.clone();
        }
        get Rot() {
            return this._transform.rotation.clone();
        }
    }

    class Refrigerator extends Laya.Script3D {
        constructor() {
            super();
            this._obj = null;
            this._transform = null;
            this.Door_1 = null;
            this.shackTween = null;
            this.timer = 0;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            this.Door_1 = MyInstrument.GetChildByName(this._obj, "Door_1");
            this.InitSkin();
        }
        onEnable() {
            EventMgr$1.Int.on(EventType$1.UPDATE_SKIN, this.InitSkin, this);
        }
        onDisable() {
            EventMgr$1.Int.off(EventType$1.UPDATE_SKIN, this.InitSkin, this);
        }
        onDestroy() {
            EventMgr$1.Int.off(EventType$1.UPDATE_SKIN, this.InitSkin, this);
        }
        InitSkin() {
            this.InitMat();
            this.InitTie();
        }
        InitMat() {
            let id = LogicSkin.instance.getSkinID(1);
            let data = GameData.getSkinItem(id);
            if (id == -1)
                return;
            ResourcesMgr$1.instance.load(RescoureData.GetBoxTexture(data.NormalMapping), (e) => {
                let ms1 = MyInstrument.GetChildByName(this._obj, "Base");
                let mat1 = ms1.meshRenderer.material;
                mat1.albedoTexture = e;
                let ms2 = MyInstrument.GetChildByName(this._obj, "Door_1");
                let mat2 = ms2.meshRenderer.material;
                mat2.albedoTexture = e;
                let ms3 = MyInstrument.GetChildByName(this._obj, "Door_2");
                let mat3 = ms3.meshRenderer.material;
                mat3.albedoTexture = e;
            });
        }
        InitTie() {
            let nameArr = [];
            let arr = LogicData.instance.Tiezhi;
            for (let index = 0; index < arr.length; index++) {
                const element = arr[index];
                let tdata = GameData.getSkinItem(element);
                nameArr.push(tdata.NodesName);
            }
            let MagnetParent = MyInstrument.GetChildByName(this._obj, "MagnetParent");
            if (!MagnetParent) {
                console.warn("没有找到贴纸的父节点");
                return;
            }
            for (let index = 0; index < MagnetParent.numChildren; index++) {
                let t = MagnetParent.getChildAt(index);
                if (nameArr.indexOf(t.name) >= 0) {
                    t.active = true;
                }
                else {
                    t.active = false;
                }
            }
        }
        OpenDoor() {
            if (this.Door_1) {
                Laya.Tween.to(this.Door_1.transform, { localRotationEulerY: 110 }, 800, Laya.Ease.backOut);
                this.SetCanRay(false);
                AudioMgr$1.instance.vibrateShort();
                AudioMgr$1.instance.play_sound(5);
                LogicData.instance.AddGuideId(0);
                IceBoxMgr.Int.IsOpenDoor = true;
                EventMgr$1.Int.emit(EventType$1.UPDATE_BATLLE);
            }
        }
        CloseDoor() {
            if (this.Door_1) {
                Laya.Tween.to(this.Door_1.transform, { localRotationEulerY: 0 }, 1000, Laya.Ease.backIn, Laya.Handler.create(this, this.closeOver));
                this.SetCanRay(true);
                AudioMgr$1.instance.vibrateShort();
                AudioMgr$1.instance.play_sound(6);
            }
        }
        closeOver() {
            let pos = this.Door_1.transform.position.clone();
            pos.x += 2;
            let level = LogicData.instance.level;
            if (level == 1) {
                pos.y += 5;
            }
            else if (level == 2) {
                pos.y += 8;
            }
            else {
                pos.y += 9;
            }
            EffectMgr.Int.showEffectPos(pos, new Laya.Vector3(0, 0, 0), 1);
            this.OnShack(true);
        }
        OnShack(bl) {
            if (bl) {
                this.Shack();
            }
            else {
                if (this.shackTween) {
                    this.shackTween.clear();
                    Laya.Tween.clearAll(this._obj.transform);
                    this._obj.transform.localRotationEulerX = 0;
                    this.shackTween = null;
                    this.timer = 0;
                }
            }
        }
        Shack() {
            if (this.timer > 0)
                return;
            this.timer = 0;
            this.ShackLeft();
        }
        ShackLeft() {
            this.shackTween = Laya.Tween.to(this._obj.transform, { localRotationEulerX: 1 }, 100, null, Laya.Handler.create(this, this.ShackRght));
            this.AddTimer();
        }
        ShackRght() {
            this.shackTween = Laya.Tween.to(this._obj.transform, { localRotationEulerX: -1 }, 100, null, Laya.Handler.create(this, this.ShackLeft));
            this.AddTimer();
        }
        AddTimer() {
            this.timer += 1;
            if (this.timer >= 6) {
                this.OnShack(false);
            }
        }
        SetCanRay(v) {
            let obj = this.Door_1;
            let collider = obj.getComponent(Laya.PhysicsCollider);
            if (!collider)
                return;
            if (v) {
                collider.collisionGroup = PhysicsGroup.gp1;
            }
            else {
                collider.collisionGroup = PhysicsGroup.gp10;
            }
        }
    }

    var RayType;
    (function (RayType) {
        RayType[RayType["normal"] = 0] = "normal";
        RayType[RayType["goods"] = 1] = "goods";
        RayType[RayType["boxSelelct"] = 2] = "boxSelelct";
        RayType[RayType["ctrBasket"] = 3] = "ctrBasket";
    })(RayType || (RayType = {}));
    class IceBoxMgr {
        constructor() {
            this.SCENAME = RescoureData.YsceUrl("Main");
            this._scene = null;
            this.GameType = GameType.ready;
            this.camerRay = null;
            this.levelNode = null;
            this.refrigerator = null;
            this.curBox = null;
            this.boxArr = [];
            this.rayBan = null;
            this.basketCtr = null;
            this.curBasket = null;
            this.lastBasket = null;
            this._warnSprit = null;
            this.rayType = RayType.normal;
            this.levelData = null;
            this.rayGoodsKind = 0;
            this.aimSource = 0;
            this.curSource = 0;
            this.enterTimer = 0;
            this.IsOpenDoor = false;
            this.lastX = -1;
            this.xTimer = 0;
            this.lastY = -1;
            this.yTimer = 0;
            this.subOver = false;
            this.subHandler = null;
            this._camera = null;
            this.subNum = 0;
            this.aimView = 60;
        }
        static get Int() {
            if (!this._Int) {
                this._Int = new IceBoxMgr();
            }
            return this._Int;
        }
        get scene() {
            return this._scene;
        }
        enter(cb, load = true) {
            console.log("进入冰箱游戏");
            this._cb = cb;
            this.GameType = GameType.load;
            this.loadRes(true);
            Laya.timer.loop(1000, this, this.TimerUpdate);
            Laya.timer.frameLoop(1, this, this.FrameUpdate);
        }
        TimerUpdate() {
            this.enterTimer += 1;
            if (this.enterTimer >= 300) {
                this.FreeAddPower();
            }
        }
        FrameUpdate() {
            if (this._camera) {
                this._camera.fieldOfView += (this.aimView - this._camera.fieldOfView) * 0.04;
            }
        }
        FreeAddPower() {
            this.enterTimer = 0;
            LogicData.instance.AddPower(1);
            EventMgr$1.Int.emit(EventType$1.UPDATE_POWER);
        }
        out() {
            this.clearEvent();
            this.clearSce();
            this._scene.destroyChildren();
            this._scene.destroy();
            this._scene = null;
            UIMgr.instance.closeUI(ModuleType.Battle);
        }
        loadRes(init = false) {
            let arr = this.getNameArr();
            let urls = [this.SCENAME, RescoureData.getPreFromPrefabs("Basket")];
            urls = urls.concat(arr);
            ResourcesMgr$1.instance.loadDir(urls, () => {
                if (init) {
                    this.enterOverHandler(ResourcesMgr$1.instance.get(this.SCENAME));
                }
                else {
                    this.ReloadLevel();
                }
            }, null, true);
            Laya.Resource.destroyUnusedResources();
        }
        enterOverHandler(scene) {
            console.log("场景加载完成");
            this._scene = scene;
            let handler = Laya.Handler.create(this, this.UIloadOver, null, false);
            this.initUI(handler);
        }
        initUI(handler) {
            UIMgr.instance.openUI(ModuleType.Battle, [handler]);
        }
        UIloadOver() {
            if (this._cb) {
                this._cb();
                this._cb = null;
            }
            GameSDK$1.sendEvent("进入主页");
            this.initEvent();
            this.initSce();
            AudioMgr$1.instance.play_music(10);
        }
        initlevelData() {
            let level = LogicData.instance.level;
            let id = LogicData.instance.level % 27;
            if (level >= 27) {
                id += 1;
            }
            this.levelData = GameData.getlevelItem(id);
        }
        getNameArr() {
            this.initlevelData();
            let arr = [];
            this.aimSource = 0;
            this.curSource = 0;
            this.levelData.LevelItem.forEach((element) => {
                let data = GameData.getGoodsItem(element);
                let index = this.levelData.LevelItem.indexOf(element);
                this.aimSource += data.Price * this.levelData.ItemQuantity[index];
            });
            arr.push(RescoureData.getPreFromPrefabs("level" + this.levelData.Id));
            return arr;
        }
        initSce() {
            console.warn("添加场景");
            Laya.stage.addChildAt(this._scene, 0);
            let CameraNode = this._scene.getChildByName("CameraNode");
            this._camera = CameraNode.getChildAt(0);
            this._camera.transform.localPosition = new Laya.Vector3(3, 5, 0.15);
            this._camera.enableHDR = false;
            this.camerRay = new CameraRay(this._scene, this._camera);
            this.camerRay.Init(Laya.Handler.create(this, this.OnRayObjDown, null, false), Laya.Handler.create(this, this.OnRayObjMove, null, false), Laya.Handler.create(this, this.OnRayObjUp, null, false), UIBattle.Int.c_comp_ray);
            this.rayBan = this._scene.getChildByName("rayBan").addComponent(RayBan);
            let basketNode = this._scene.getChildByName("basketNode");
            this.basketCtr = basketNode.addComponent(BasketCtr);
            this.levelNode = this._scene.getChildByName("levelNode");
            this.ReloadLevel();
        }
        LoadSub() {
            this.subOver = true;
            let self = this;
            qgLoadSubpackge("unity", function () {
                Laya.loader.load([{ url: "unity/unity.zip", type: "plfb" }], Laya.Handler.create(this, () => {
                    self.subOver = true;
                    if (self.subHandler)
                        self.subHandler.run();
                }));
            });
        }
        clearSce() {
            UIMgr.instance.closeUI(ModuleType.Battle);
        }
        ReloadLevel() {
            this.GameType == GameType.ready;
            this.curBasket = null;
            this.LoadBasket(this.levelData.LevelItem, this.levelData.ItemQuantity);
            this.LoadIceBox();
            this.IsOpenDoor = false;
            EventMgr$1.Int.emit(EventType$1.UPDATE_BATLLE);
            this.curSource = 0;
            EventMgr$1.Int.emit(EventType$1.UPDATE_SOURCE, 0);
            this.StartGame();
            if (this._warnSprit) {
                this._warnSprit.removeSelf();
                this._warnSprit.destroy();
                this._warnSprit = null;
            }
            this._warnSprit = new Laya.MeshSprite3D();
            this._scene.addChild(this._warnSprit);
            this.SetView(60);
        }
        RestartLevel() {
            this.GameType == GameType.ready;
            this.refrigerator.CloseDoor();
            this.basketCtr.InitPoint();
            this.boxArr.forEach((element) => {
                element.Clear();
            });
            this.SelectBox(null);
            if (this.curBasket) {
                this.curBasket.OffSelect();
                this.curBasket = null;
            }
            this.curSource = 0;
            EventMgr$1.Int.emit(EventType$1.UPDATE_SOURCE, 0);
            this.IsOpenDoor = false;
            EventMgr$1.Int.emit(EventType$1.UPDATE_BATLLE);
            this.StartGame();
            if (this._warnSprit) {
                this._warnSprit.removeSelf();
                this._warnSprit.destroy();
                this._warnSprit = null;
            }
            this._warnSprit = new Laya.MeshSprite3D();
            this._scene.addChild(this._warnSprit);
            this.SetView(60);
        }
        LoadNextLevel() {
            this.GameType == GameType.ready;
            this.loadRes();
        }
        StartGame() {
            this.GameType = GameType.start;
            UIMgr.instance.openUI(ModuleType.Battle);
            console.warn("开始录屏=============================");
            GameSDK$1.startVideoRecord();
            GameSDK$1.stageOnStart({
                stageId: LogicData.instance.level,
                stageName: "第" + LogicData.instance.level + "关",
            });
        }
        get IsSatrt() {
            return this.GameType == GameType.start;
        }
        dramCameraToImage(display) {
            display.graphics.clear();
            let camera = this._camera;
            if (!camera)
                return null;
            camera.renderTarget = new Laya.RenderTexture(display.width, display.height);
            var rtex = new Laya.Texture(camera.renderTarget, Laya.Texture.DEF_UV);
            display.graphics.drawTexture(rtex);
            Laya.timer.frameOnce(3, this, function () {
                camera.renderTarget = null;
            });
        }
        GameSettle() {
            this.GameType = GameType.settle;
        }
        GameOver(win, dTimer = 2000) {
            if (this.GameType != GameType.start)
                return;
            UIMgr.instance.closeUI(ModuleType.Battle);
            LogicData.instance.AddGuideId(6, true);
            this.SelectBox(null);
            if (this.refrigerator) {
                this.refrigerator.CloseDoor();
            }
            this.SetView(70);
            this.GameType = GameType.settle;
            GameSDK$1.stageOnEnd({
                stageId: LogicData.instance.DogAge,
                stageName: "第" + LogicData.instance.DogAge + "关",
                event: win ? "complete" : "fail",
            });
            GameSDK$1.stopVideoRecord();
            if (GameSDK$1.type != PlatType$1.TOUTIAO) {
                Laya.timer.once(dTimer, this, function () {
                    UIMgr.instance.openUI(ModuleType.Share, null, null, () => {
                        this.onOpenEndHandler(100, win);
                    });
                });
            }
            else {
                Laya.timer.once(dTimer, this, function () {
                    UIMgr.instance.openUI(ModuleType.Share, null, null, () => {
                        this.onOpenEndHandler(100, win);
                    });
                });
            }
        }
        onOpenEndHandler(dTimer, win) {
            Laya.timer.once(dTimer, this, function () {
                UIMgr.instance.openUI(ModuleType.End, win);
            });
        }
        get curPSource() {
            return (this.curSource / this.aimSource) * 100;
        }
        initEvent() {
            Laya.stage.on(Laya.Event.KEY_DOWN, this, this.onKeyDown);
        }
        clearEvent() {
            Laya.stage.off(Laya.Event.KEY_DOWN, this, this.onKeyDown);
        }
        onKeyDown(e) {
            if (e.keyCode == Laya.Keyboard.A) {
                UIMgr.instance.openUI(ModuleType.Skin);
            }
            if (e.keyCode == Laya.Keyboard.S) {
                this.BoxBack();
            }
        }
        BoxBack() {
            if (this.curBox) {
                this.curBox.ReadyBack();
                this.SelectBox(null);
            }
        }
        OnRayGoods(result) {
            if (this.rayGoodsKind == 0) {
                let v3 = result.point.clone();
                let tv3 = MyInstrument.WorldToLocal(this.curBox.PointTrans, v3);
                let point = this.curBox.iceList.MostNearPoint(tv3);
                let pos = this.curBox.iceList.ToV3(point);
                return this.AddItem(point, pos);
            }
            else {
                let scr = result.collider.owner.parent.getComponent(IceGoods);
                if (scr && scr.InBox) {
                    this.SubItem(scr);
                    scr.BackToBasket();
                }
                LogicData.instance.AddGuideId(5);
                return false;
            }
        }
        OnRayObjDown(result) {
            if (!this.IsSatrt)
                return;
            if (result.collider.owner.name == "Basket") {
                console.warn("点中了购物篮1111");
                this.rayType = RayType.ctrBasket;
                this.basketCtr.StartDrag();
                return;
            }
            if (result.collider.owner.name == "Door_Box" || result.collider.owner.name == "Door_1") {
                this.refrigerator.OpenDoor();
                return;
            }
            if (this.curBox == null) {
                this.rayType = RayType.boxSelelct;
                let obj = result.collider.owner.parent;
                let scr = obj.getComponent(IceBox);
                if (scr) {
                    this.SelectBox(scr);
                }
                return;
            }
            this.OnRayGoods(result);
        }
        OnRayObjMove(result) {
            if (!this.IsSatrt)
                return false;
            if (this.rayType != RayType.normal && this.rayType != RayType.goods)
                return false;
            if (!this.curBox)
                return false;
            return this.OnRayGoods(result);
        }
        OnRayObjUp(result) {
            this._warnSprit.active = false;
            let obj = result.collider.owner;
            if (obj.name == "Basket") {
                let scr = obj.getComponent(Basket);
                this.rayType = RayType.normal;
                this.basketCtr.StopDrag();
                if (this.curBasket == scr) {
                    this.SelectBasket(null);
                }
                else {
                    if (this.curBasket) {
                        this.curBasket.OffSelect();
                    }
                    this.SelectBasket(scr);
                }
                return;
            }
        }
        SelectBasket(basket, evt = true) {
            if (!basket && this.curBasket) {
                this.curBasket.OffSelect();
            }
            this.curBasket = basket;
            if (this.curBasket) {
                this.curBasket.OnSelect();
                this.SelectBasketHandler();
                this.basketCtr.Toz(this.curBasket.CldIndex * 2);
            }
            else {
                this.basketCtr.Toz(-1);
            }
            if (evt) {
                EventMgr$1.Int.emit(EventType$1.NO_CHEHUI);
            }
        }
        SelectBasketHandler() {
            this._warnSprit.removeChildren();
            let data = GameData.getGoodsItem(this.curBasket.GoodsId);
            let sp = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs(data.PrefabName)).clone();
            this._warnSprit.addChild(sp);
            sp.transform.localPosition = new Laya.Vector3();
            sp.transform.localRotationEuler = new Laya.Vector3();
            let ms = sp.getChildAt(0);
            let mat = ms.meshRenderer.material;
            mat.albedoTexture = null;
            mat.renderMode = 2;
            mat.albedoColor = new Laya.Vector4(0.8, 0, 0, 0.2);
            let box = sp.getComponent(Laya.PhysicsCollider);
            box.destroy();
            box = null;
        }
        AddItem(point, v3) {
        }
        SubItem(scr) {
            this.rayType = RayType.goods;
            this.AddSource(-scr.Price);
            this.curBox.iceList.Sub(scr.Point, scr.Size);
            this.subNum += 1;
            AudioMgr$1.instance.vibrateShort();
            AudioMgr$1.instance.play_sound(7);
        }
        SelectBox(box) {
            if (this.curBox) {
                this.curBox.ReadyBack();
            }
            this.curBox = box;
            if (box) {
                box.TryReadyOut(this.rayBan.Pos, this.rayBan.Rot, Laya.Handler.create(this, this.SelectBoxHandler));
            }
            else {
                this.SelectBoxHandler(null);
            }
        }
        SelectBoxHandler(box) {
            if (box == null) {
                EventMgr$1.Int.emit(EventType$1.NO_CHEHUI);
            }
            this.curBox = box;
            if (box) {
                this.rayBan.Open();
            }
            else {
                this.rayBan.Close();
            }
            EventMgr$1.Int.emit(EventType$1.UPDATE_BATLLE2);
            if (this.curBox) {
                if (this.curBox.iceList.GoodsNum <= 0) {
                    EventMgr$1.Int.emit(EventType$1.HIDE_CHEHUI);
                }
                else {
                    EventMgr$1.Int.emit(EventType$1.SHOW_CHEHUI);
                }
            }
        }
        LoadIceBox() {
            if (this.levelNode) {
                this.levelNode.destroyChildren();
            }
            this.boxArr = [];
            let sp = ResourcesMgr$1.instance
                .get(RescoureData.getPreFromPrefabs("level" + this.levelData.Id))
                .clone();
            this.levelNode.addChild(sp);
            this.refrigerator = sp.addComponent(Refrigerator);
            for (let index = 1; index < sp.numChildren; index++) {
                const element = sp.getChildAt(index);
                let scr = element.addComponent(IceBox);
                this.boxArr.push(scr);
            }
            this.SelectBox(null);
        }
        LoadBasket(idarr, numarr) {
        }
        createBasket(id, num) {
            let tbasket = ResourcesMgr$1.instance.get(RescoureData.getPreFromPrefabs("Basket")).clone();
            let scr = tbasket.addComponent(Basket);
            scr.Init(id, num);
            this.basketCtr.AddBasket(tbasket);
        }
        LoadGoods() {
            this.basketCtr.InitGoods();
        }
        UpdateRayKind(v, selectLast) {
            this.rayGoodsKind = v;
            if (v == 0 && this.subNum > 0 && LogicData.instance.FreeBackVideo < 2) {
                LogicProp.instance.add(EPropNameById.diamonds, -2, false);
                LogicData.instance.AddFreeBack();
            }
            this.subNum = 0;
            LogicData.instance.AddGuideId(4);
            if (v == 1) {
                this.lastBasket = this.curBasket;
                this.SelectBasket(null, false);
            }
            if (v == 0 && selectLast) {
                this.SelectBasket(this.lastBasket, false);
            }
        }
        AddSource(num) {
            this.curSource += num;
            let v = (this.curSource / this.aimSource) * 100;
            EventMgr$1.Int.emit(EventType$1.UPDATE_SOURCE, v);
            if (v == 100) {
                this.GameOver(100);
            }
        }
        AddX(x) {
            if (x == this.lastX) {
                this.xTimer += 1;
                if (this.xTimer >= 3) {
                    this.xTimer = 0;
                    EventMgr$1.Int.emit(EventType$1.SHOW_TEXT_GOOD);
                }
            }
            else {
                this.lastX = x;
                this.xTimer = 0;
            }
        }
        AddY(y) {
            if (y == this.lastY) {
                this.yTimer += 1;
                if (this.yTimer >= 3) {
                    this.yTimer = 0;
                    EventMgr$1.Int.emit(EventType$1.SHOW_TEXT_GOOD);
                }
            }
            else {
                this.lastY = y;
                this.yTimer = 0;
            }
        }
        SetView(num) {
            this.aimView = num;
        }
    }
    var GameType;
    (function (GameType) {
        GameType[GameType["load"] = 0] = "load";
        GameType[GameType["ready"] = 1] = "ready";
        GameType[GameType["start"] = 2] = "start";
        GameType[GameType["settle"] = 3] = "settle";
        GameType[GameType["over"] = 4] = "over";
    })(GameType || (GameType = {}));

    class UIMain$1 extends UIBase {
        constructor() {
            super();
            this.ConfigUI = new ConfigUI({
                event_refresh_gold_node: "text_cur_gold_count",
            });
            this.c_btn_zichuang = null;
            this.c_btn_zuojia = null;
            this.c_comp_moveCtr = null;
            this.c_comp_zhiyin = null;
            this.c_comp_bad = null;
            this.c_comp_good = null;
            this.c_comp_level = null;
            this.c_btn_more = null;
            this.c_comp_kindSkin = null;
            this.c_comp_suipian = null;
            this.c_comp_aniGround = null;
            this.c_progress_wancheng = null;
            this.c_progress_wancheng1 = null;
            this.c_comp_bottomVideo = null;
            this.c_comp_jiesuo = null;
            this.c_comp_jiesuoshengji = null;
            this.c_comp_phcTip = null;
            this.c_comp_arrow = null;
            this.c_comp_arrow2 = null;
            this.c_comp_arrow3 = null;
            this.c_btn_qiehuan = null;
            this.c_progress_mianfei = null;
            this.c_comp_tipNode = null;
            this.c_comp_jinzhu = null;
            this.TipUrl = null;
            this.MoneyUrl = null;
            this.BigMoneyUrl = null;
            this.text_chaopiao = null;
            this.text_gold_account = null;
            this.text_money = null;
            this.c_btn_fenxiang = null;
            this.c_comp_moneyP = null;
            this.c_comp_zhiyin1 = null;
            this.c_text_zhiyin = null;
            this.c_comp_zhiyin3 = null;
            this.c_btn_addDesk = null;
            this._strAlert = "终于等到你！以后这家寿司店就交给你啦！";
            this._alertInt = 0;
            this._alertCount = 0;
            this._tempHide = false;
            this.up_v2 = new Laya.Vector2(0, 1);
            this.uplevelTip = null;
            this.cur_tipId = 0;
            UIMain$1._Int = this;
        }
        static get Int() {
            return this._Int;
        }
        onConstruct() {
            super.onConstruct();
            this.TipUrl = fgui.UIPackage.getItemURL("main", "comp_zhiyin");
            this.MoneyUrl = fgui.UIPackage.getItemURL("main", "comp_jinbidonghua_kekong2");
            this.BigMoneyUrl = fgui.UIPackage.getItemURL("main", "comp_bigMoney");
            Laya.stage.on(Laya.Event.MOUSE_DOWN, this, this._onMouseDown);
            Laya.stage.on(Laya.Event.MOUSE_MOVE, this, this._onMouseMove);
            Laya.stage.on(Laya.Event.MOUSE_OVER, this, this._onMouseUp);
            Laya.stage.on(Laya.Event.MOUSE_UP, this, this._onMouseUp);
            this.c_comp_bottomVideo.visible = false;
        }
        _onMouseDown(e) {
            this._mouseDownPos = new Laya.Point(e.stageX, e.stageY);
        }
        _onMouseMove(e) {
            if (!!this._mouseDownPos && this._mouseDownPos.distance(e.stageX, e.stageY) >= 20) {
                this._mouseDownPos = null;
            }
        }
        _onMouseUp(e) {
            if (!!this._mouseDownPos && this._mouseDownPos.x == e.stageX && this._mouseDownPos.y == e.stageY) {
                let cmp = this.c_comp_bottomVideo;
                if (cmp.visible &&
                    e.stageX >= cmp.x - (cmp.width * cmp.scaleX) / 2 &&
                    e.stageX <= cmp.x + (cmp.width * cmp.scaleX) / 2 &&
                    e.stageY >= cmp.y - cmp.height * cmp.scaleY &&
                    e.stageY <= cmp.y) {
                    this._clickBottomVideo();
                }
            }
        }
        click_addDesk() {
            GameSDK$1.shortCutInstalled((is_succes) => {
                this.c_btn_addDesk.visible = !is_succes;
                console.log("添加到桌面:", is_succes);
            });
        }
        _clickBottomVideo() {
            if (this.c_comp_bottomVideo.visible) {
                GameSDK$1.showADVideo(this, (s) => {
                    if (s) {
                        EventMgr$1.Int.emit(EventType$1.TRIGGER_MONEY);
                    }
                }, "主界面底部视频");
            }
        }
        showInsert() {
            GameSDK$1.showADInsert();
        }
        showAdd() {
            GameSDK$1.shortCutInstalled((is_succes) => {
                console.log("添加到桌面:", is_succes);
            });
        }
        showCustom() {
            GameSDK$1.showCustomAd("path");
        }
        onOpen() {
            console.log("GameSDK.isCurrentVersion --- ", GameSDK$1.isCurrentVersion);
            this.c_btn_addDesk.visible = false;
            this.c_btn_more.visible = false;
            if (GameSDK$1.type == PlatType$1.VIVO || GameSDK$1.type == PlatType$1.OPPO) {
                this.c_btn_addDesk.visible = !GameSDK$1.isShortCutInstalled;
            }
            if (this.openData) {
                this.openData[0].run();
            }
            if (GameSDK$1.type == PlatType$1.VIVO) {
                this.c_btn_more.visible = false;
            }
            EventMgr$1.Int.on(EventType$1.JIESUO_TIP1, this.initNormalTip, this);
            EventMgr$1.Int.on(EventType$1.INIT_TRAVL, this.InitTravl, this);
            EventMgr$1.Int.on(EventType$1.INIT_BIGFISH_TIP, this.UpdateBigFish, this);
            EventMgr$1.Int.on(EventType$1.INIT_VIP_SHOW, this.showVip, this);
            EventMgr$1.Int.on(EventType$1.MONEY_DUIDUI, this._onChangeMoney3D, this);
            EventMgr$1.Int.on(EventType$1.TEMP_HIDE_AD, this._tempHideBottomAd, this);
            EventMgr$1.Int.on(EventType$1.RESUME_AD, this._resumeBottomAd, this);
            this.c_comp_arrow.visible = false;
            this.c_comp_jiesuo.visible = false;
            this.c_comp_jiesuoshengji.visible = false;
            this.c_comp_phcTip.visible = false;
            this.c_progress_mianfei.visible = false;
            this.InitTravl();
            this.c_comp_tipNode.removeChildren(0, this.c_comp_tipNode.numChildren, true);
            this.c_comp_moneyP.removeChildren(0, this.c_comp_moneyP.numChildren, true);
            this.text_chaopiao = this.c_comp_jiesuoshengji.getChild("text_chaopiao").asTextField;
            this.text_gold_account = this.c_comp_jiesuo.getChild("text_gold_account").asTextField;
            this.text_money = this.c_comp_jinzhu.getChild("text_money").asTextField;
            if (GameSDK$1.type == PlatType$1.TOUTIAO) {
                this.c_btn_fenxiang.visible = true;
            }
            else {
                this.c_btn_fenxiang.visible = false;
            }
            this.cur_tipId = LogicData.instance.TipId;
            GameSDK$1.ShowInserAd();
        }
        _showAlert() {
            this.c_comp_zhiyin3.visible = false;
            Laya.timer.clear(this, this._alertTimer);
            this.c_comp_zhiyin3.offClick(this, this._hideAlert);
            this.c_comp_zhiyin3.visible = true;
            this.c_comp_zhiyin3.getChild("btn_kaishi").visible = false;
            this.c_comp_zhiyin3.getChild("text_wenzi").text = "";
            this._alertInt = 2000 / this._strAlert.length;
            this._alertCount = 0;
            Laya.timer.loop(this._alertInt, this, this._alertTimer);
        }
        _alertTimer() {
            this._alertCount++;
            this.c_comp_zhiyin3.getChild("text_wenzi").text = this._strAlert.substring(0, this._alertCount);
            if (this._alertCount >= this._strAlert.length) {
                Laya.timer.clear(this, this._alertTimer);
                this.c_comp_zhiyin3.getChild("btn_kaishi").visible = true;
                this.c_comp_zhiyin3.onClick(this, this._hideAlert);
            }
        }
        _hideAlert() {
            this.c_comp_zhiyin3.visible = false;
            Laya.timer.clear(this, this._alertTimer);
            this.c_comp_zhiyin3.offClick(this, this._hideAlert);
            if (Math.floor(Math.random() * 100 + 1) <= (+GameSDK$1.data.StartAlertVideo || 0)) {
                GameSDK$1.showADVideo(this, () => { }, "文字弹窗结束视频");
            }
            ReportMgr.inst.sendReport(ReportType.CLOSE_ALERT);
        }
        AddMoneyFly() {
            let c = fgui.UIPackage.createObjectFromURL(this.MoneyUrl);
            this.c_comp_moneyP.addChild(c);
            c.RandomPos();
        }
        AddTip(e) {
            this.c_comp_tipNode.addChild(e);
        }
        InitTravl() {
            let i = LogicData.instance.IsTravl;
            if (i == 0) {
                this.c_btn_qiehuan.visible = false;
            }
            else {
                this.c_btn_qiehuan.visible = true;
            }
        }
        onUpdate() {
            this.update_timer();
            this.update_arrow();
            this.update_arrow2();
            this.update_arrow3();
            this.updateMianfei();
            this.update_vip();
            this.update_WorkTimer();
            this.update_phc();
            if (this.uplevelTip) {
                this.text_chaopiao.text = this.uplevelTip.NeedMoney.toString();
                this.text_gold_account.text = this.uplevelTip.NeedMoney.toString();
            }
        }
        onClose() {
            EventMgr$1.Int.off(EventType$1.JIESUO_TIP1, this.initNormalTip, this);
            EventMgr$1.Int.off(EventType$1.INIT_TRAVL, this.InitTravl, this);
            EventMgr$1.Int.off(EventType$1.INIT_BIGFISH_TIP, this.UpdateBigFish, this);
            EventMgr$1.Int.off(EventType$1.INIT_VIP_SHOW, this.showVip, this);
            EventMgr$1.Int.off(EventType$1.MONEY_DUIDUI, this._onChangeMoney3D, this);
            EventMgr$1.Int.off(EventType$1.TEMP_HIDE_AD, this._tempHideBottomAd, this);
            EventMgr$1.Int.off(EventType$1.RESUME_AD, this._resumeBottomAd, this);
        }
        update_WorkTimer() {
            if (CanteenMgr.Int.Player) {
                let v = CanteenMgr.Int.Player.WorkTimer;
                if (v == 0) {
                    this.c_progress_wancheng1.visible = false;
                }
                else {
                    this.c_progress_wancheng1.visible = true;
                    let v2 = CanteenMgr.Int.Player.viewPos;
                    this.c_progress_wancheng1.x = v2.x;
                    this.c_progress_wancheng1.y = v2.y - 150;
                    this.c_progress_wancheng1.value = v;
                }
            }
            else {
                this.c_progress_wancheng1.visible = false;
            }
        }
        update_timer() {
            if (CanteenMgr.Int.Player) {
                let v = CanteenMgr.Int.Player.TimerPro;
                if (v == 0) {
                    this.c_progress_wancheng.visible = false;
                }
                else {
                    this.c_progress_wancheng.visible = true;
                    let v2 = CanteenMgr.Int.Player.viewPos;
                    this.c_progress_wancheng.x = v2.x;
                    this.c_progress_wancheng.y = v2.y - 150;
                    this.c_progress_wancheng.value = v;
                }
            }
            else {
                this.c_progress_wancheng.visible = false;
            }
        }
        update_vip() {
            if (this.c_comp_jinzhu.visible == true) {
                if (!CanteenMgr.Int.Vip) {
                    this.c_comp_jinzhu.visible = false;
                    return;
                }
                let v2 = WorldToScreen2(CanteenMgr.Int._camera, CanteenMgr.Int.Vip.Pos);
                this.c_comp_jinzhu.visible = true;
                this.c_comp_jinzhu.x = v2.x;
                this.c_comp_jinzhu.y = v2.y - 80;
                this.c_comp_jinzhu.asProgress.value = CanteenMgr.Int.Vip.TimerPro;
                if (GameSDK$1.isCurrentVersion) {
                    this.c_comp_jinzhu.getChildByPath("n7").visible = false;
                }
                else {
                    this.c_comp_jinzhu.getChildByPath("n7").visible = true;
                }
            }
        }
        _tempHideBottomAd() {
            this._tempHide = true;
            this.c_comp_bottomVideo.visible = false;
        }
        _resumeBottomAd() {
            this._tempHide = false;
            if (!!this._curAdState) {
                this._onChangeMoney3D(this._curAdState);
            }
        }
        _onChangeMoney3D(data) {
            if (+GameSDK$1.data.ShowTriggerOpen != 1) {
                return;
            }
            this._curAdState = data;
            if (this._tempHide) {
                return;
            }
            this.c_comp_bottomVideo.visible = data[0];
            if (!!data && data.length > 1) {
                this.c_comp_bottomVideo.getChild("text_account").text = "+" + data[1];
            }
        }
        showVip(money) {
            if (money > 0) {
                this.c_comp_jinzhu.visible = true;
                let v2 = WorldToScreen2(CanteenMgr.Int._camera, CanteenMgr.Int.Vip.Pos);
                this.c_comp_jinzhu.x = v2.x;
                this.c_comp_jinzhu.y = v2.y - 80;
                this.c_comp_jinzhu.asProgress.value = CanteenMgr.Int.Vip.TimerPro;
                this.text_money.text = CanteenMgr.Int.Vip.Money.toString();
                if (GameSDK$1.isCurrentVersion) {
                    this.c_comp_jinzhu.getChildByPath("n7").visible = false;
                }
                else {
                    this.c_comp_jinzhu.getChildByPath("n7").visible = true;
                }
            }
            else {
                this.c_comp_jinzhu.visible = false;
            }
        }
        update_arrow() {
            if (StepMgr.Int && StepMgr.Int.PayTaget) {
                let v2 = WorldToScreen2(CanteenMgr.Int._camera, StepMgr.Int.PayTaget.transform.position.clone());
                let tV2 = v2.clone();
                this.c_comp_jiesuoshengji.x = tV2.x;
                this.c_comp_jiesuoshengji.y = tV2.y;
                this.c_comp_jiesuo.x = tV2.x;
                this.c_comp_jiesuo.y = tV2.y;
                let isOut = false;
                if (v2.x < 120) {
                    v2.x = 120;
                    isOut = true;
                }
                else if (v2.x > Laya.stage.width - 120) {
                    v2.x = Laya.stage.width - 120;
                    isOut = true;
                }
                if (v2.y < 150) {
                    v2.y = 150;
                    isOut = true;
                }
                else if (v2.y > Laya.stage.height - 100) {
                    v2.y = Laya.stage.height - 100;
                    isOut = true;
                }
                this.c_comp_arrow.x = v2.x;
                this.c_comp_arrow.y = v2.y;
                if (isOut) {
                    this.c_comp_arrow.visible = true;
                    this.c_comp_arrow.rotation =
                        -MyInstrument.getTheAngle(this.up_v2, new Laya.Vector2(this.c_comp_arrow.x - Laya.stage.width / 2, this.c_comp_arrow.y - Laya.stage.height / 2)) + 180;
                }
                else {
                    this.c_comp_arrow.visible = false;
                    this.c_comp_arrow.rotation = 180;
                }
            }
            else {
                this.c_comp_arrow.visible = false;
                this.c_comp_jiesuo.visible = false;
                this.c_comp_jiesuoshengji.visible = false;
            }
        }
        update_arrow2() {
            if (StepMgr.Int && StepMgr.Int.ArrowWork) {
                let v2 = WorldToScreen2(CanteenMgr.Int._camera, StepMgr.Int.ArrowWork.transform.position.clone());
                this.c_comp_arrow2.visible = true;
                this.c_comp_arrow2.x = v2.x;
                this.c_comp_arrow2.y = v2.y - 80;
                this.c_comp_arrow2.rotation = 180;
            }
            else {
                this.c_comp_arrow2.visible = false;
            }
        }
        update_arrow3() {
            if (StepMgr.Int && StepMgr.Int.ArrowTaget) {
                let v2 = WorldToScreen2(CanteenMgr.Int._camera, StepMgr.Int.ArrowTaget.transform.position.clone());
                this.c_comp_arrow3.visible = true;
                let isOut = false;
                if (v2.x < 50) {
                    v2.x = 50;
                    isOut = true;
                }
                else if (v2.x > Laya.stage.width - 50) {
                    v2.x = Laya.stage.width - 50;
                    isOut = true;
                }
                if (v2.y < 150) {
                    v2.y = 150;
                    isOut = true;
                }
                else if (v2.y > Laya.stage.height - 100) {
                    v2.y = Laya.stage.height - 100;
                    isOut = true;
                }
                this.c_comp_arrow3.x = v2.x;
                this.c_comp_arrow3.y = v2.y - 110;
                if (isOut) {
                    this.c_comp_arrow3.rotation =
                        -MyInstrument.getTheAngle(this.up_v2, new Laya.Vector2(this.c_comp_arrow3.x - Laya.stage.width / 2, this.c_comp_arrow3.y - Laya.stage.height / 2)) + 180;
                }
                else {
                    this.c_comp_arrow3.rotation = 180;
                }
            }
            else {
                this.c_comp_arrow3.visible = false;
            }
        }
        update_phc() {
            if (CanteenMgr.Int.CarNode && CanteenMgr.Int.CarNode.IsShow) {
                let v2 = WorldToScreen2(CanteenMgr.Int._camera, CanteenMgr.Int.CarNode.Pos);
                this.c_comp_phcTip.visible = true;
                this.c_comp_phcTip.x = v2.x;
                this.c_comp_phcTip.y = v2.y - 80;
            }
            else {
                this.c_comp_phcTip.visible = false;
            }
        }
        updateMianfei() {
            let ship = CanteenMgr.Int.Ship;
            if (this.c_progress_mianfei.visible == true) {
                let v2 = CanteenMgr.Int.Ship.Pos;
                if (v2) {
                    this.c_progress_mianfei.x = v2.x;
                    this.c_progress_mianfei.y = v2.y - 100;
                    this.c_progress_mianfei.value = ship.TimerPro;
                }
            }
        }
        UpdateBigFish(bl) {
            this.c_progress_mianfei.visible = bl[0];
            if (bl) {
                let times = LogicData.instance.BigFishTimes;
                let c = this.c_progress_mianfei.getControllerAt(0);
                if (times <= 0) {
                    c.selectedIndex = 0;
                }
                else {
                    c.selectedIndex = 1;
                    if (GameSDK$1.isCurrentVersion) {
                        c.selectedIndex = 0;
                    }
                }
                let v2 = CanteenMgr.Int.Ship.Pos;
                if (v2) {
                    this.c_progress_mianfei.x = v2.x;
                    this.c_progress_mianfei.y = v2.y;
                }
            }
        }
        initNormalTip(tdata) {
            this.uplevelTip = tdata;
            this.c_comp_jiesuo.visible = false;
            this.c_comp_jiesuoshengji.visible = false;
            if (this.uplevelTip.UplevelId == -1) {
                this.initCropsTip(tdata);
                return;
            }
            let data = GameData.getIconItem(this.uplevelTip.UplevelId);
            if (!data) {
                this.uplevelTip = null;
                return;
            }
            let comp = this.c_comp_jiesuoshengji;
            comp.getChild("text_chaopiao").asTextField.text = tdata.money;
            comp.getChild("loader_tubiao").asLoader.url = UIMgr.instance.iconUrl(data.IconUrl, "main");
            comp.getChild("text_wenben").asTextField.text = data.Characters;
            comp.visible = true;
        }
        initCropsTip(tdata) {
            this.uplevelTip = tdata;
            let comp = this.c_comp_jiesuo;
            comp.getChild("text_gold_account").asTextField.text = this.uplevelTip.NeedMoney.toString();
            comp.visible = true;
        }
        InitGuideTip(id, ac = true) {
            if (id >= 12 || id == 0) {
                this.c_comp_zhiyin1.visible = false;
                return;
            }
            if (ac) {
                if (id < this.cur_tipId)
                    return;
                if (id == this.cur_tipId && this.c_comp_zhiyin1.visible == true)
                    return;
                this.cur_tipId = id;
                let data = GameData.getGuideTipItem(id);
                this.c_comp_zhiyin1.visible = true;
                this.c_text_zhiyin.text = data.Str;
            }
            else {
                if (this.cur_tipId == id) {
                    LogicData.instance.SetTipId(id + 1);
                    this.c_comp_zhiyin1.visible = false;
                }
            }
        }
        click_start() { }
        click_more() {
            console.log("MORE");
        }
        click_kaishiyouxi() {
            this.closeUI();
            IceBoxMgr.Int.StartGame();
        }
        click_zhuanpan() {
        }
        click_setting() {
            UIMgr.instance.openUI(ModuleType.UISetting);
        }
        click_shezhi() {
            UIMgr.instance.openUI(ModuleType.UISetting);
        }
        click_skin() {
        }
        click_shangdain() {
            UIMgr.instance.closeUI(ModuleType.Main);
            UIMgr.instance.openUI(ModuleType.Skin);
        }
        click_pifu() {
            UIMgr.instance.openUI(ModuleType.Skin);
        }
        click_thing() {
        }
        click_qiandao() {
        }
        click_zichuang() {
            UIMgr.instance.openUI(ModuleType.UIMap);
        }
        click_kaiju() {
        }
        UpdateLevel() {
        }
        click_guanqia() {
            UIMgr.instance.openUI(ModuleType.UIMap);
        }
        click_quanshe() {
        }
        click_yigui() {
            UIMgr.instance.closeUI(ModuleType.Main);
            UIMgr.instance.openUI(ModuleType.Skin);
        }
        click_zuojia() {
            UIMgr.instance.closeUI(ModuleType.Main);
            UIMgr.instance.openUI(ModuleType.Skin, 1);
        }
        click_qiehuan() {
            UIMgr.instance.openUI(ModuleType.UIQiehuan);
        }
        click_fenxiang() {
            UIMgr.instance.openUI(ModuleType.Share);
        }
    }

    var E_UISkinItem_state;
    (function (E_UISkinItem_state) {
        E_UISkinItem_state[E_UISkinItem_state["\u5DF2\u89E3\u9501"] = 0] = "\u5DF2\u89E3\u9501";
        E_UISkinItem_state[E_UISkinItem_state["\u6B63\u5728\u4F7F\u7528"] = 1] = "\u6B63\u5728\u4F7F\u7528";
        E_UISkinItem_state[E_UISkinItem_state["\u9009\u4E2D\u672A\u89E3\u9501"] = 2] = "\u9009\u4E2D\u672A\u89E3\u9501";
        E_UISkinItem_state[E_UISkinItem_state["\u672A\u89E3\u9501"] = 3] = "\u672A\u89E3\u9501";
    })(E_UISkinItem_state || (E_UISkinItem_state = {}));
    class UISkinItem extends FguiBase$3 {
        constructor() {
            super(...arguments);
            this.c_loader_icon = null;
            this.c_loder_icon = null;
            this.c_comp_get_type = null;
            this.c_text_name = null;
            this.value = null;
            this.isSelection = false;
            this.skinId = 0;
            this.c_text_ad = null;
        }
        init(id) {
            this.c_loder_icon = this.getChild("loder_icon").asLoader;
            this.skinId = id;
            if (id == -1) {
                this.value = null;
            }
            else {
                this.value = LogicSkin.instance.config(id);
                this.c_loder_icon.url = UIMgr.instance.iconUrl(this.value.ImgUrl);
            }
        }
        get cur() {
            return LogicSkin.instance.getSkinID(this.value.Type);
        }
        iceBoxRefresh(isSelection = false, type) {
            let c1 = this.controllerOnce;
            let has = LogicSkin.instance.has(this.value.Id);
            if (has) {
                if (isSelection) {
                    c1.setSelectedIndex(2);
                }
                else {
                    c1.setSelectedIndex(1);
                }
            }
            else {
                let index = this.value.UnLockType.indexOf(8);
                if (index >= 0) {
                    c1.selectedIndex = 4;
                    let info = LogicSkin.instance.getSkinCache(this.value.Id);
                    this.c_text_ad.text = info.watchAdCount + "/" + this.value.UnLockValue[index];
                }
                else {
                    c1.selectedIndex = 0;
                }
            }
        }
        refresh(isSelection = false, type) {
            let c1 = this.get_controller();
            this.isSelection = isSelection;
            if (this.value) {
                let has = LogicSkin.instance.has(this.value.Id);
                if (isSelection) {
                    c1.setSelectedIndex(has ? 2 : 0);
                }
                else {
                    c1.setSelectedIndex(has ? 1 : 0);
                }
                let c2 = this.c_comp_get_type.getController("c2");
                if (has) {
                    c2.selectedIndex = 0;
                }
                else {
                    c2.selectedIndex = this.value.UnLockType[this.value.UnLockType.length - 1];
                    let index = this.value.UnLockType.indexOf(8);
                    if (index >= 0) {
                        c2.selectedIndex = 8;
                        let info = LogicSkin.instance.getSkinCache(this.value.Id);
                        this.c_comp_get_type.getChild("text_ad").asTextField.text =
                            info.watchAdCount + "/" + this.value.UnLockValue[index];
                    }
                    else {
                        index = this.value.UnLockType.indexOf(1);
                        if (index >= 0) {
                            c2.selectedIndex = 1;
                            this.c_comp_get_type.getChild("text_gold").asTextField.text =
                                this.value.UnLockValue[index] + "";
                        }
                        else {
                            index = this.value.UnLockType.indexOf(10);
                            this.c_comp_get_type.getChild("n44").asTextField.text = this.value.UnLockValue[index] + "";
                        }
                    }
                }
            }
        }
        LoadSpine() {
            this.templet = new Laya.SpineTemplet(Laya.SpineVersion.v4_0);
            this.templet.loadAni(RescoureData.GetSpineUrl("skeleton"));
            this.templet.on(Laya.Event.COMPLETE, this, this.parseComplete);
            this.templet.on(Laya.Event.ERROR, this, this.onError);
        }
        parseComplete() {
            this.skeleton = this.templet.buildArmature();
            this.c_loader_icon.displayObject.addChild(this.skeleton);
            this.skeleton.x = 0;
            this.skeleton.y = 0;
            this.skeleton.scale(0.75, 0.75);
            this.skeleton.play(1, true);
            this.skeleton.showSkinByIndex(this.skinId);
            this.InitAction();
        }
        onError() {
            console.log("parse error");
        }
        InitAction() {
            if (!this.skeleton)
                return;
            if (this.isSelection) {
                this.skeleton.play(2, true);
            }
            else {
                this.skeleton.play(1, true);
            }
        }
    }

    class Pool {
        constructor(value) {
            this.value = null;
            this.pools = new Map();
            this.value = value;
        }
        get(path) {
            let value = this.pool(path).pop();
            if (!value)
                value = this.value.getRes(path);
            this.value.clearAttribute(value);
            if (this.value.onGet)
                this.value.onGet(value);
            return value;
        }
        put(value, path) {
            this.value.clearAttribute(value);
            let pool = this.pool(path);
            if (pool.length > this.value.maxCount) {
                if (this.value.destroy)
                    this.value.destroy(value);
            }
            else {
                if (this.value.onPut)
                    this.value.onPut(value);
                pool.push(value);
            }
        }
        pool(path) {
            let pool = this.pools.get(path);
            if (!pool) {
                pool = [];
                this.pools.set(path || "pool", pool);
            }
            return pool;
        }
        clear() {
            this.pools.forEach(pool => {
                for (let value of pool) {
                    this.value.clearAttribute(value);
                    if (this.value.destroy)
                        this.value.destroy(value);
                }
                pool.length = 0;
            });
            this.pools.clear();
        }
    }

    class TipsItem extends FguiBase$3 {
        constructor() {
            super(...arguments);
            this.c_text_str = null;
        }
        init(str) {
            this.touchable = false;
            this.c_text_str.text = str;
            this.y = 200;
            this.x = Laya.stage.width / 2;
            UIMgr.instance.getParent(E_UI_Parent.tip).addChild(this);
            this.alpha = 0;
            this.onStartHandler();
        }
        onStartHandler() {
            Laya.Tween.to(this, { alpha: 100 }, 1000, null, Laya.Handler.create(this, this.onCeneterHandler));
        }
        onCeneterHandler() {
            Laya.Tween.to(this, { alpha: 100 }, 1000, null, Laya.Handler.create(this, this.onEndHandler));
        }
        onEndHandler() {
            Laya.Tween.to(this, { alpha: 0 }, 1000, null, Laya.Handler.create(this, this.onMoveHandler));
        }
        onMoveHandler() {
            TipMgr.Int.pool.put(this);
        }
    }
    class UIDiamondsFlyItem extends FguiBase$3 {
        constructor() {
            super(...arguments);
            this.v2_temp = new Laya.Vector2();
        }
        init(startPoint, speed, id, endPos) {
            let delat = 0;
            if (id == EPropNameById.key) {
                this.scaleX = 5;
                this.scaleY = 5;
                delat = 1000;
                startPoint.x = startPoint.x - (this.width * this.scaleX) / 4;
                startPoint.y = startPoint.y - (this.height * this.scaleY) / 2;
            }
            let targetPos = endPos;
            this.setXY(startPoint.x, startPoint.y);
            this.v2_temp.x = startPoint.x - targetPos.x;
            this.v2_temp.y = startPoint.y - targetPos.y;
            let duration = Math.sqrt(this.v2_temp.x * this.v2_temp.x + this.v2_temp.y * this.v2_temp.y) / speed;
            Laya.Tween.to(this, { x: targetPos.x, y: targetPos.y, scaleX: 1, scaleY: 1 }, duration, null, Laya.Handler.create(this, this.tweenCb), delat);
            UIMgr.instance.getParent(E_UI_Parent.diamondsFly).addChild(this);
        }
        tweenCb() {
            TipMgr.Int.poolGold.put(this);
        }
    }
    class TipMgr {
        constructor() {
            this.pool = new Pool({
                maxCount: 5,
                getRes: () => FguiBase$3.createPackageItem("common", "comp_tips", TipsItem),
                clearAttribute: (value) => {
                    value.removeFromParent();
                },
                destroy: (value) => {
                    value.dispose();
                },
            });
            this.poolGold = new Pool({
                maxCount: 15,
                getRes: () => FguiBase$3.createPackageItem("common", "comp_diamonds", UIDiamondsFlyItem),
                clearAttribute: (value) => {
                    Laya.Tween.clearAll(value);
                    value.removeFromParent();
                },
                destroy: (value) => {
                    value.dispose();
                },
            });
            this.poolMoney = new Pool({
                maxCount: 15,
                getRes: () => FguiBase$3.createPackageItem("common", "comp_money", UIDiamondsFlyItem),
                clearAttribute: (value) => {
                    Laya.Tween.clearAll(value);
                    value.removeFromParent();
                },
                destroy: (value) => {
                    value.dispose();
                },
            });
            this._create = false;
            this.poolMoney2 = new Pool({
                maxCount: 15,
                getRes: () => FguiBase$3.createPackageItem("common", "comp_diamonds_1", UIDiamondsFlyItem),
                clearAttribute: (value) => {
                    Laya.Tween.clearAll(value);
                    value.removeFromParent();
                },
                destroy: (value) => {
                    value.dispose();
                },
            });
            this.poolKey = new Pool({
                maxCount: 15,
                getRes: () => FguiBase$3.createPackageItem("common", "comp_key", UIDiamondsFlyItem),
                clearAttribute: (value) => {
                    Laya.Tween.clearAll(value);
                    value.removeFromParent();
                },
                destroy: (value) => {
                    value.dispose();
                },
            });
        }
        static get Int() {
            if (!this._Int) {
                this._Int = new TipMgr();
            }
            return this._Int;
        }
        showTips(str) {
            if (!this._create) {
                this._create = true;
                FguiBase$3.setExtension("common", "comp_tips", TipsItem);
            }
            this.pool.get().init(str);
        }
        showGold(startPoint, speed, id, endPos = new Laya.Vector2(630, 120)) {
            if (!this._create) {
                this._create = true;
                FguiBase$3.setExtension("common", "comp_diamonds", UIDiamondsFlyItem);
            }
            this.poolGold.get().init(startPoint, speed, id, endPos);
        }
        showMoney(startPoint, speed, id, endPos = new Laya.Vector2(630, 120)) {
            if (!this._create) {
                this._create = true;
                FguiBase$3.setExtension("common", "comp_money", UIDiamondsFlyItem);
            }
            this.poolMoney.get().init(startPoint, speed, id, endPos);
        }
        showMoney2(startPoint, speed, id, endPos = new Laya.Vector2(630, 120)) {
            if (!this._create) {
                this._create = true;
                FguiBase$3.setExtension("common", "comp_diamonds_1", UIDiamondsFlyItem);
            }
            this.poolMoney2.get().init(startPoint, speed, id, endPos);
        }
        showKey(startPoint, speed, id, endPos = new Laya.Vector2(630, 120)) {
            if (!this._create) {
                this._create = true;
                FguiBase$3.setExtension("common", "comp_key", UIDiamondsFlyItem);
            }
            this.poolKey.get().init(startPoint, speed, EPropNameById.key, endPos);
        }
    }

    class SceneShow3D {
        constructor() {
            this.cameraNode = null;
            this._RenderTexture_sprite = null;
            this.initScene();
            this.initCamera();
            this.initLight();
        }
        initScene() {
            this.scene = new Laya.Scene3D();
            Laya.stage.addChildAt(this.scene, 0);
        }
        initCamera() {
            this.cameraNode = new Laya.Sprite3D();
            this.cameraNode.transform.position = new Laya.Vector3(0, 2, 5);
            this.cameraNode.transform.rotationEuler = new Laya.Vector3(0, 0, 0);
            this.scene.addChild(this.cameraNode);
            this.camera = new Laya.Camera(0, 0.01, 1000);
            this.cameraNode.addChild(this.camera);
            this.camera.transform.localPosition = new Laya.Vector3(0, 0, 0);
            this.camera.transform.localRotationEuler = new Laya.Vector3(0, 0, 0);
            this.scene.ambientColor = new Laya.Vector3(1, 1, 1);
        }
        initLight() {
            var directionLight = new Laya.DirectionLight();
            this.scene.addChild(directionLight);
            directionLight.color = new Laya.Vector3(174 / 255, 174 / 255, 174 / 255);
            directionLight.transform.rotationEuler = new Laya.Vector3(25, 0, 0);
            directionLight.intensity = 0.5;
        }
        clearRenderTexture() {
            if (this._RenderTexture_sprite)
                this._RenderTexture_sprite.graphics.clear();
            this._RenderTexture_sprite = null;
        }
        setRenderTexture(sprite) {
            this._RenderTexture_sprite = sprite;
            this.camera.clearColor.setValue(0, 0, 0, 0);
            this.camera.clearFlag = Laya.BaseCamera.CLEARFLAG_SKY;
            this.camera.renderingOrder = -1;
            this.camera.renderTarget = new Laya.RenderTexture(sprite.width, sprite.height, Laya.BaseTexture.FORMAT_R8G8B8A8);
            sprite.graphics.drawImage(new Laya.Texture(this.camera.renderTarget, Laya.Texture.DEF_UV));
        }
        addChild(node, zIndex = null) {
            if (zIndex == null)
                zIndex = this.scene.numChildren;
            this.scene.addChildAt(node, zIndex);
        }
        get playerNode() {
            if (!this._playerNode) {
                this._playerNode = new Laya.MeshSprite3D();
                if (this.scene)
                    this.scene.addChild(this._playerNode);
                this._playerNode.transform.localPosition = new Laya.Vector3(0, 0, 0);
                this._playerNode.transform.rotationEuler = new Laya.Vector3();
            }
            return this._playerNode;
        }
        destroy() {
            this.camera.renderTarget.destroy();
            this.clearRenderTexture();
            if (this.scene) {
                this.scene.destroy();
                this.scene = null;
            }
            this.camera = null;
        }
        TweenCameraNode(pos, rot, timer = 500) {
            let v = this.cameraNode.transform.position.clone();
            Laya.Tween.to(v, {
                x: pos.x,
                y: pos.y,
                z: pos.z,
                update: Laya.Handler.create(this, this.UpdatePos, [v], false),
            }, 500);
            let r = this.cameraNode.transform.localRotationEuler.clone();
            Laya.Tween.to(r, {
                x: rot.x,
                y: rot.y,
                z: rot.z,
                update: Laya.Handler.create(this, this.UpdateRot, [r], false),
            }, 500);
        }
        UpdatePos(v) {
            this.cameraNode.transform.position = v.clone();
        }
        UpdateRot(r) {
            this.cameraNode.transform.localRotationEuler = r.clone();
        }
    }

    class UISkin extends UIBase {
        constructor() {
            super(...arguments);
            this.ConfigUI = new ConfigUI({
                event_refresh_gold_node: "text_cur_gold_count",
            });
            this.c_loader_mode = null;
            this.c_list_pifu = null;
            this.c_list_02 = null;
            this._curSelectionId = -1;
            this.c_text_video_free_gold = null;
            this.closeHandler = null;
            this.c_btn_yifu = null;
            this.c_loader_model = null;
            this.c_loader_img = null;
            this.c_btn_goumai = null;
            this.c_btn_bofang = null;
            this.c_btn_qiuqiu = null;
            this.c_comp_suipian = null;
            this.c_btn_you = null;
            this.c_btn_zuo = null;
            this.c_btn_chaopiao = null;
            this.controllerT = null;
            this.showModel = null;
            this.curModelIndex = 1;
            this.listIdArr = [];
        }
        onOpen() {
            this._scene3D = new SceneShow3D();
            this._scene3D.setRenderTexture(this.c_loader_mode.displayObject);
            this.controllerT = this.getControllerAt(1);
            if (GameSDK$1.type == PlatType$1.KUAIGAME) {
                GameSDK$1.showADInsert();
            }
            this.controllerOnce.on(fgui.Events.STATE_CHANGED, this, this.onTabChange);
            this.controllerT.on(fgui.Events.STATE_CHANGED, this, this.onTabChange);
            this.selectTab(0);
        }
        updateSuipian() {
            let v = LogicProp.instance.get(EPropNameById.suipian);
            this.c_comp_suipian.getChild("text_cur_gold_count3").text = v.toString();
        }
        UpdateModel(id) {
            let arr = this.listIdArr;
            if (arr.length > 0) {
                let id = arr[arr.length - 1];
                let data = GameData.getSkinItem(id);
                if (data.UnLockType[0] == 1) {
                    this.c_btn_chaopiao.visible = true;
                    this.c_btn_chaopiao.getChild("text_goldnum").text = data.UnLockValue[0].toString();
                }
                else {
                    this.c_btn_chaopiao.visible = false;
                }
            }
            this.curModelIndex = id;
            let name = "";
            switch (this.curModelIndex) {
                case 1:
                    name = "Refrigerator";
                    break;
                case 2:
                    name = "Refrigerator";
                    break;
                case 3:
                    name = "Big_Box";
                    break;
                case 4:
                    name = "Basket";
                    break;
                case 5:
                    name = "Big_Box";
                    break;
            }
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(name), (node) => {
                if (!node)
                    return;
                this._scene3D.playerNode.destroyChildren();
                this.showModel = node.clone();
                this._scene3D.playerNode.addChild(this.showModel);
                this._scene3D.playerNode.transform.localPositionY = 0;
                this._scene3D.playerNode.transform.localRotationEuler = new Laya.Vector3(0, -90, 0);
                this.showModel.transform.localPosition = new Laya.Vector3(0, 0, 0);
                this.showModel.transform.localScale = new Laya.Vector3(0.25, 0.25, 0.25);
                switch (this.curModelIndex) {
                    case 1:
                        this._scene3D.TweenCameraNode(new Laya.Vector3(0, 2, 5), new Laya.Vector3());
                        this.UpdateMesh(2);
                        break;
                    case 2:
                        this._scene3D.TweenCameraNode(new Laya.Vector3(0, 2, 3.5), new Laya.Vector3());
                        this.UpdateMesh(1);
                        break;
                    case 3:
                        this._scene3D.TweenCameraNode(new Laya.Vector3(0, 1.5, 2), new Laya.Vector3(-30));
                        let Sticker_1 = MyInstrument.GetChildByName(this.showModel, "Sticker_1");
                        let Sticker_2 = MyInstrument.GetChildByName(this.showModel, "Sticker_2");
                        Sticker_1.active = false;
                        Sticker_2.active = false;
                        this.UpdateMesh(5);
                        break;
                    case 4:
                        this._scene3D.TweenCameraNode(new Laya.Vector3(0, 1, 1), new Laya.Vector3(-30));
                        break;
                    case 5:
                        this._scene3D.TweenCameraNode(new Laya.Vector3(0, 0.6, 2), new Laya.Vector3());
                        this.UpdateMesh(3);
                        break;
                }
                this.UpdateMesh();
            });
        }
        UpdateMesh(mustNum = null) {
            let index = mustNum || this.curModelIndex;
            let id = LogicSkin.instance.getSkinID(index);
            let data = GameData.getSkinItem(id);
            if (index == 5 || index == 3) {
                let tid = LogicSkin.instance.getSkinID(5);
                if (tid == -1) {
                    let Sticker_1 = MyInstrument.GetChildByName(this.showModel, "Sticker_1");
                    let Sticker_2 = MyInstrument.GetChildByName(this.showModel, "Sticker_2");
                    Sticker_1.active = false;
                    Sticker_2.active = false;
                }
            }
            if (id == -1) {
                return;
            }
            switch (index) {
                case 1:
                    ResourcesMgr$1.instance.load(RescoureData.GetBoxTexture(data.NormalMapping), (e) => {
                        let ms1 = this.showModel.getChildAt(0).getChildAt(0);
                        let mat1 = ms1.meshRenderer.material;
                        mat1.albedoTexture = e;
                        let ms2 = this.showModel.getChildAt(0).getChildAt(1);
                        let mat2 = ms2.meshRenderer.material;
                        mat2.albedoTexture = e;
                        let ms3 = this.showModel.getChildAt(0).getChildAt(2);
                        let mat3 = ms3.meshRenderer.material;
                        mat3.albedoTexture = e;
                    });
                    break;
                case 2:
                    let nameArr = [];
                    let arr = LogicData.instance.Tiezhi;
                    for (let index = 0; index < arr.length; index++) {
                        const element = arr[index];
                        let tdata = GameData.getSkinItem(element);
                        nameArr.push(tdata.NodesName);
                    }
                    let MagnetParent = MyInstrument.GetChildByName(this.showModel, "MagnetParent");
                    for (let index = 0; index < MagnetParent.numChildren; index++) {
                        let t = MagnetParent.getChildAt(index);
                        if (nameArr.indexOf(t.name) >= 0) {
                            t.active = true;
                        }
                        else {
                            t.active = false;
                        }
                    }
                    break;
                case 3:
                    this.ChoutiMesh(data);
                    this.ChoutiMat(data);
                    break;
                case 4:
                    ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(data.MeshName[0]), (e) => {
                        MyInstrument.ChangeMesh(this.showModel.getChildAt(0), e);
                    });
                    break;
                case 5:
                    if (!data.NormalMapping) {
                        return;
                    }
                    ResourcesMgr$1.instance.load(RescoureData.GetTieTexture(data.NormalMapping), (e) => {
                        let id = LogicSkin.instance.getSkinID(3);
                        let Sticker_1 = MyInstrument.GetChildByName(this.showModel, "Sticker_1");
                        let Sticker_2 = MyInstrument.GetChildByName(this.showModel, "Sticker_2");
                        let ms;
                        if (id != 36) {
                            ms = Sticker_2;
                            Sticker_1.active = false;
                        }
                        else {
                            ms = Sticker_1;
                            Sticker_2.active = false;
                        }
                        ms.active = true;
                        let mat = ms.meshRenderer.material;
                        mat.albedoTexture = e;
                    });
                    break;
            }
        }
        ChoutiMesh(data) {
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(data.MeshName[0]), (e) => {
                MyInstrument.ChangeMesh(this.showModel.getChildAt(0), e);
                let id = LogicSkin.instance.getSkinID(3);
                let Sticker_1 = MyInstrument.GetChildByName(this.showModel, "Sticker_1");
                let Sticker_2 = MyInstrument.GetChildByName(this.showModel, "Sticker_2");
                let tid = LogicSkin.instance.getSkinID(5);
                if (tid == -1) {
                    let Sticker_1 = MyInstrument.GetChildByName(this.showModel, "Sticker_1");
                    let Sticker_2 = MyInstrument.GetChildByName(this.showModel, "Sticker_2");
                    Sticker_1.active = false;
                    Sticker_2.active = false;
                }
                else {
                    if (id != 36) {
                        Sticker_1.active = false;
                        Sticker_2.active = true;
                    }
                    else {
                        Sticker_1.active = true;
                        Sticker_2.active = false;
                    }
                    console.warn("更新贴图节点显示");
                }
            });
        }
        ChoutiMat(data) {
            let name;
            if (data.Id == 36) {
                name = "Big_Box_1";
            }
            else if (data.Id == 37) {
                name = "Big_Box_2";
            }
            else if (data.Id == 38) {
                name = "Big_Box_3";
            }
            ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs(name), (e) => {
                let ms = this.showModel.getChildAt(0);
                ms.meshRenderer.materials = e.meshRenderer.materials;
            });
        }
        UpdateShow(id) {
        }
        selectTab(num) {
            this.controllerT.selectedIndex = num;
            this.onTabChange();
        }
        onTabChange() {
            let tab = this.controllerT.selectedIndex;
            let skins = GameData.getSkin();
            let arr = [];
            this.listIdArr = [];
            let all = false;
            let hot = this.controllerOnce.selectedIndex;
            if (tab == 2) {
                all = true;
                if (hot == 2) {
                    console.warn("抽屉时选择贴纸");
                    tab = 4;
                }
            }
            if (tab == 4) {
                all = true;
            }
            for (let key in skins) {
                if (skins[key].Type == tab + 1 && (skins[key].Category == hot + 1 || all)) {
                    arr.push(skins[key]);
                    this.listIdArr.push(skins[key].Id);
                }
            }
            let id = LogicSkin.instance.getSkinID(tab + 1);
            this._curSelectionId = id;
            console.log("获取到的皮肤数据", arr, tab);
            let list;
            list = this.c_list_pifu;
            list.removeChildren();
            let leng = arr.length;
            for (var i = 0; i < leng; i++) {
                let value = arr[i];
                list.addItem().init(Number(value.Id));
            }
            list.on(fairygui.Events.CLICK_ITEM, this, this.on_event_list_click_item);
            this.refresh_items();
            this.UpdateModel(tab + 1);
        }
        RandomUnlock() {
            let need = Number(this.c_btn_chaopiao.getChild("text_goldnum").text);
            let num = LogicProp.instance.get(EPropNameById.diamonds);
            if (need > num) {
                TipMgr.Int.showTips("钞票不足");
                return;
            }
            let arr = [];
            for (let index = 0; index < this.listIdArr.length; index++) {
                const element = this.listIdArr[index];
                let data = GameData.getSkinItem(element);
                if (LogicSkin.instance.has(element) == false && data.UnLockType.indexOf(1) >= 0) {
                    arr.push(element);
                }
            }
            if (arr.length <= 0) {
                console.warn("当前展示列表没有未解锁的");
                TipMgr.Int.showTips("已解锁全部");
                return null;
            }
            LogicProp.instance.add(EPropNameById.diamonds, -need, false);
            let id = arr[Math.floor(Math.random() * arr.length)];
            LogicSkin.instance.getSkin(id, false);
            LogicSkin.instance.use(id);
            let data = GameData.getSkinItem(id);
            if (data.Type == 2) {
                LogicData.instance.AddTiezhi(id);
            }
            this.refresh_items();
            this.UpdateMesh();
            return;
        }
        InitList(num = 1) {
            let skins = GameData.getSkin();
            let arr = [];
            for (let key in skins) {
                if (skins[key].Type == num) {
                    arr.push(skins[key]);
                }
            }
            let id = LogicSkin.instance.getSkinID(num);
            this._curSelectionId = id;
            console.log("获取到的皮肤数据", arr, num);
            let list;
            list = this.c_list_pifu;
            list.removeChildren();
            let leng = arr.length;
            for (var i = 0; i < leng; i++) {
                let value = arr[i];
                list.addItem().init(Number(value.Id));
            }
            list.on(fairygui.Events.CLICK_ITEM, this, this.on_event_list_click_item);
            this.refresh_items();
        }
        on_event_list_click_item(item, e) {
            if (!item.value)
                return;
            if (item instanceof UISkinItem) {
                this.clickSkin(item);
            }
        }
        clickSkin(item) {
            if (LogicSkin.instance.has(item.value.Id)) {
                LogicSkin.instance.use(item.value.Id);
                this._curSelectionId = item.value.Id;
                if (item.value.Type == 2) {
                    let arr = LogicData.instance.Tiezhi;
                    if (arr.indexOf(item.value.Id) >= 0) {
                        LogicData.instance.SubTiezhi(item.value.Id);
                    }
                    else {
                        LogicData.instance.AddTiezhi(item.value.Id);
                    }
                }
                this.UpdateMesh();
            }
            else {
                this._curSelectionId = item.value.Id;
                let index = item.value.UnLockType.indexOf(8);
                let indexJ = item.value.UnLockType.indexOf(1);
                let indexH = item.value.UnLockType.indexOf(10);
                if (index >= 0 || indexJ >= 0 || indexH >= 0) {
                    if (index >= 0) {
                        GameSDK$1.showADVideo(this, (b) => {
                            if (b) {
                                LogicSkin.instance.wathchAd(item.value.Id);
                                this.refresh_items();
                                this.UpdateMesh();
                            }
                        }, "皮肤商城");
                    }
                }
            }
            this.refresh_items();
        }
        clickWeapon(item) {
            let goldNum = LogicProp.instance.get(EPropNameById.diamonds);
            let needGold = 300;
            if (needGold <= goldNum) {
                LogicProp.instance.add(EPropNameById.diamonds, -needGold);
                LogicData.instance.AddWeaponLevels(item.value.Id);
            }
            else {
                TipMgr.Int.showTips("饼干不足");
            }
            this.refresh_items2();
        }
        refresh_items() {
            let list = this.c_list_pifu;
            let tiezhiArr = LogicData.instance.Tiezhi;
            for (let value of list._children) {
                if (value.value) {
                    if (value.value.Type == 2) {
                        if (tiezhiArr.indexOf(value.value.Id) >= 0) {
                            value.iceBoxRefresh(true, 0);
                        }
                        else {
                            value.iceBoxRefresh(false, 0);
                        }
                    }
                    else {
                        value.iceBoxRefresh(value.value.Id == this._curSelectionId, 0);
                    }
                }
                else {
                    value.iceBoxRefresh(false, 0);
                }
            }
        }
        refresh_items2() {
            let list = this.c_list_02;
            for (let value of list._children) {
                value.refresh();
            }
        }
        onClose() {
            this._scene3D.destroy();
            this.closeHandler && this.closeHandler.run();
            EventMgr$1.Int.emit(EventType$1.UPDATE_SKIN);
        }
        click_fanhui() {
            this.closeUI();
        }
        click_ad() {
            GameSDK$1.showADVideo(this, (b) => {
                if (b) {
                    AudioMgr$1.instance.play_sound(7);
                    Laya.timer.once(800, this, function () {
                        LogicProp.instance.add(EPropNameById.diamonds, GameData.getConfigDataItem("VIDEO_ADD_GOLD"), true);
                    });
                }
            }, "皮肤商城");
        }
        click_bofang2() {
            GameSDK$1.showADVideo(this, (b) => {
                if (b) {
                    AudioMgr$1.instance.play_sound(7);
                    LogicProp.instance.add(EPropNameById.diamonds, 100, true);
                }
            }, "皮肤商城");
        }
        click_zuo() {
            this.c_list_pifu.scrollPane.posX -= 286;
        }
        click_you() {
            this.c_list_pifu.scrollPane.posX += 286;
        }
        click_chaopiao() {
            console.log("尝试金币解锁");
            this.RandomUnlock();
        }
        click_suiji() {
            GameSDK$1.showADVideo(this, (b) => {
                if (b) {
                    LogicProp.instance.add(EPropNameById.diamonds, 500, true);
                }
            }, "皮肤商城获取钞票");
        }
    }

    class UIEnd extends UIBase {
        constructor() {
            super(...arguments);
            this.ConfigUI = new ConfigUI({
                event_refresh_gold_node: "text_cur_gold_count",
            });
            this.c_text_reward_gold = null;
            this.c_btn_share = null;
            this.c_comp_keyAni = null;
            this.c_comp_guang = null;
            this.c_comp_jiangli = null;
            this.c_comp_jiesuoxin = null;
            this.beiShu = 3;
            this._totalGold = 100;
            this.trans0 = null;
            this.isWin = 0;
            this.skinId = -1;
            this.keys = null;
            this.c_comp_yaoshi1 = null;
            this.c_comp_yaoshi2 = null;
            this.c_comp_yaoshi3 = null;
            this.c_comp_jiesuo = null;
            this.c_btn_zichuangzaici = null;
            this.c_btn_zaicitiaozhan = null;
            this.c_btn_tiaoguoguanqia = null;
            this.c_comp_jinagli1 = null;
            this.c_comp_jiangli2 = null;
            this.c_comp_jiangli3 = null;
            this.c_group_chenggonganniu = null;
            this.c_comp_fanbei = null;
            this.img_pointer = null;
            this.c_comp_star = null;
            this.c_progress_jindu = null;
            this.c_btn_sanbeilingqu = null;
            this.text_shuzi = null;
            this.c_comp_tiaozhanchenggong = null;
            this.c_btn_dianzan = null;
            this.c_comp_xin1 = null;
            this.c_comp_xin2 = null;
            this.c_comp_xin3 = null;
            this.starNum = 0;
            this.c_btn_zaicixiaozi = null;
            this._suiPian = 1;
            this.c_comp_suipian = null;
            this.c_loader_player = null;
            this.c_btn_fenxiang = null;
            this.c_text_level = null;
            this.starIndex = 0;
            this.startRot = true;
            this.speed = 3;
            this.max = 90;
            this.min = -90;
            this.sp = null;
        }
        onCreate() { }
        onOpen() {
            let c2 = this.getControllerAt(1);
            c2.selectedIndex = 0;
            GameData.getConfigDataItem("End_Gold");
            this._totalGold = Math.floor(this.openData);
            this.c_text_reward_gold.text = this._totalGold.toString();
            let source = this.openData;
            if (source == 0) {
                this.controllerOnce.selectedIndex = 1;
                this.c_btn_fenxiang.visible = true;
                let t = GameSDK$1.CloseType();
                if (t > 0 && t <= 2) {
                    c2.selectedIndex = GameSDK$1.CloseType();
                }
            }
            else {
                this.controllerOnce.selectedIndex = 0;
                this.c_progress_jindu.value = 0;
                Laya.Tween.to(this.c_progress_jindu, { value: source }, 200);
            }
            if (GameSDK$1.type == PlatType$1.KUAIGAME) {
                GameSDK$1.showADInsert();
            }
            this.c_text_level.text = LogicData.instance.level.toString();
            this.startStar();
            this.ShowZahuodian();
            this.LoadPart();
            AudioMgr$1.instance.play_sound(9);
        }
        ShowZahuodian() {
            let ldata = GameData.getlevelItem(LogicData.instance.level);
            if (ldata && ldata.LevelShop.length >= 2) {
                UIMgr.instance.openUI(ModuleType.UIZahuodian, ldata.LevelShop);
            }
        }
        updateSuipian() {
            let v = LogicProp$1.instance.get(EPropNameById$1.suipian);
            this.c_comp_suipian.getChild("text_cur_gold_count3").text = v.toString();
        }
        addSuipian(num) {
            LogicProp$1.instance.add(EPropNameById$1.suipian, num);
            this.updateSuipian();
        }
        updateBtn() {
            this.c_btn_sanbeilingqu.getChild("text_shuzi").text = (this._totalGold * 3).toString();
            this.c_btn_sanbeilingqu.getChild("n12").text = (this._suiPian * 2).toString();
            this.c_btn_zaicixiaozi.getChild("n12").text = this._suiPian.toString();
            this.c_btn_tiaoguoguanqia.getChild("n12").text = this._suiPian.toString();
        }
        LoadSpine() {
            if (this.skeleton) {
                this.updateSkin();
                return;
            }
            this.templet = new Laya.SpineTemplet(Laya.SpineVersion.v4_0);
            this.templet.loadAni(RescoureData.GetSpineUrl("skeleton"));
            this.templet.on(Laya.Event.COMPLETE, this, this.parseComplete);
        }
        parseComplete() {
            this.skeleton = this.templet.buildArmature();
            this.c_loader_player.displayObject.removeChildren();
            this.c_loader_player.displayObject.addChild(this.skeleton);
            this.skeleton.pos(0, 0);
            this.updateSkin();
        }
        updateSkin() {
            let id = LogicSkin.instance.getSkinID();
            this.skeleton.showSkinByIndex(id);
            this.skeleton.play(0, true, true);
        }
        startStar() {
            this.c_comp_xin1.getControllerAt(0).selectedIndex = 1;
            this.c_comp_xin2.getControllerAt(0).selectedIndex = 1;
            this.c_comp_xin3.getControllerAt(0).selectedIndex = 1;
            this.starNum = 0;
            if (this.openData >= 95) {
                this.starNum = 3;
            }
            else if (this.openData >= 60) {
                this.starNum = 2;
            }
            else if (this.openData >= 30) {
                this.starNum = 1;
            }
            else {
                this.starNum = 0;
            }
            Laya.timer.frameLoop(30, this, this.lightStar);
        }
        lightStar() {
            this.starIndex += 1;
            if (this.starIndex >= this.starNum) {
                Laya.timer.clear(this, this.lightStar);
            }
            let t = this["c_comp_xin" + this.starIndex];
            if (t) {
                let c = t.getControllerAt(0);
                c.selectedIndex = 0;
            }
        }
        checkKeyNum() {
            let kenum = LogicProp$1.instance.get(EPropNameById$1.key);
            if (kenum >= 3) {
                UIMgr.instance.openUI(ModuleType.UIBoxList);
            }
        }
        CheckShowBox() {
            LogicData.instance.AddPlayTimes();
            let t = LogicData.instance.PlayTimes;
            if (t % 3 == 0) {
                LogicData.instance.AddPlayTimes(0);
                UIMgr.instance.openUI(ModuleType.UIBoxList);
            }
        }
        onClose() {
            Laya.timer.clear(this, this.lightStar);
            Laya.Tween.clearAll(this.c_comp_jinagli1);
            Laya.Tween.clearAll(this.c_comp_jiangli2);
            Laya.Tween.clearAll(this.c_comp_jiangli3);
            Laya.Tween.clearAll(this.c_comp_jiangli);
            Laya.Tween.clearAll(this.c_group_chenggonganniu);
            EventMgr$1.Int.off(EventType$1.SHOW_KEYANI, this.showKeyAni, this);
        }
        click_zaicixiaozi() {
            GameSDK$1.showADVideo(this, (state) => {
                if (state) {
                    this.addSuipian(this._suiPian);
                    this.closeUI();
                    this.AddLevel();
                }
                else {
                    TipMgr.Int.showTips("看完整视频得奖励");
                }
            }, "跳过此关");
        }
        click_zhijielingqu() {
            LogicProp$1.instance.add(EPropNameById$1.diamonds, this._totalGold, true, 1);
            this.closeEnd();
        }
        click_zaicitiaozhan() {
            this.closeUI();
        }
        click_zichuangzaici() { }
        click_shaohoulingqu() {
            this.callBreakHandler();
        }
        callBreakHandler() {
            this.closeUI(true);
            UIMgr.instance.openUI(ModuleType.Main);
        }
        showBtnViewState(buttonA, buttonB) {
            let tempX = buttonA.x;
            let tempY = buttonA.y;
            let roadmCount = random(0, 100);
            if (roadmCount < 50) {
                buttonA.x = buttonB.x;
                buttonA.y = buttonB.y;
                buttonB.x = tempX;
                buttonB.y = tempY;
                if (!buttonB.displayObject.getComponent(ButtonEffect))
                    buttonB.displayObject.addComponent(ButtonEffect);
            }
            else {
                if (!buttonA.displayObject.getComponent(ButtonEffect))
                    buttonA.displayObject.addComponent(ButtonEffect);
            }
        }
        click_share() {
            GameSDK$1.shareVideoRecord((isSucces) => {
                if (isSucces) {
                    this.c_btn_share.visible = false;
                    LogicData.instance.getShareReward();
                }
            });
        }
        closeEnd() {
            this.closeUI(true);
        }
        click_tiaoguoguanqia() {
            GameSDK$1.showADVideo(this, (state) => {
                if (state) {
                    this.addSuipian(this._suiPian);
                }
                else {
                    TipMgr.Int.showTips("看完整视频得奖励");
                }
            }, "跳过此关");
        }
        click_fanhuishouye() {
            this.closeUI(true);
        }
        click_fenxiang() {
            let self = this;
            GameSDK$1.shareVideoRecord((isSucees) => {
                if (isSucees) {
                    LogicData.instance.isShare = true;
                    LogicProp$1.instance.add(EPropNameById$1.diamonds, 50, true);
                    self.c_btn_fenxiang.visible = false;
                }
            });
        }
        getBeiShuByAngle() {
            let x = this.img_pointer.x;
            if ((x >= 10 && x < 10 + 1 * 80) || (x > 10 + 4 * 80 && x <= 10 + 5 * 80)) {
                return 2;
            }
            else if ((x >= 10 + 1 * 80 && x < 10 + 2 * 80) || (x > 10 + 3 * 80 && x <= 10 + 4 * 80)) {
                return 3;
            }
            else {
                return 5;
            }
        }
        showKeyAni() {
            this.c_comp_keyAni.visible = true;
            this.c_comp_guang.visible = true;
            this.trans0.play();
        }
        click_jujue() {
            this.controllerOnce.setSelectedIndex(1);
        }
        click_chongwan() {
            this.closeEnd();
        }
        click_tiaoguo() {
            this.closeEnd();
            this.AddLevel();
        }
        click_zhijiexiaozi() {
            LogicProp$1.instance.add(EPropNameById$1.diamonds, this._totalGold, true, 1);
            this.closeEnd();
            this.AddLevel();
            UIMgr.instance.openUI(ModuleType.Main);
            this.wudian();
        }
        click_sanbeilingqu() {
            GameSDK$1.showADVideo(this, (state) => {
                if (state) {
                    this.addSuipian(this._suiPian * 2);
                    let _useNumber = this._totalGold * this.beiShu;
                    TipMgr.Int.showTips("恭喜获得" + _useNumber + "钞票");
                    LogicProp$1.instance.add(EPropNameById$1.diamonds, this._totalGold, true, this.beiShu);
                    this.AddLevel();
                    this.closeEnd();
                }
                else {
                    TipMgr.Int.showTips("看完整视频得奖励");
                    this.startRot = true;
                }
            }, "多倍领取");
        }
        click_duobei() {
            GameSDK$1.showADVideo(this, (state) => {
                if (state) {
                    let _useNumber = this._totalGold * this.beiShu;
                    TipMgr.Int.showTips("恭喜获得" + _useNumber + "金币");
                    LogicProp$1.instance.add(EPropNameById$1.diamonds, this._totalGold, true, this.beiShu);
                    this.AddLevel();
                    this.closeEnd();
                    IceBoxMgr.Int.loadRes();
                    AudioMgr$1.instance.play_sound(4);
                }
                else {
                    TipMgr.Int.showTips("看完整视频得奖励");
                }
            }, "多倍领取");
        }
        click_zj() {
            let _useNumber = this._totalGold;
            TipMgr.Int.showTips("恭喜获得" + _useNumber + "钞票");
            LogicProp$1.instance.add(EPropNameById$1.diamonds, this._totalGold, true);
            this.AddLevel();
            this.closeEnd();
            IceBoxMgr.Int.loadRes();
            AudioMgr$1.instance.play_sound(4);
        }
        click_fanhui() {
            this.closeEnd();
            UIMgr.instance.openUI(ModuleType.Main);
            this.wudian();
        }
        AddLevel() {
            LogicData.instance.level += 1;
        }
        wudian() {
            console.warn("尝试误触");
            if (GameSDK$1.type == PlatType$1.KUAIGAME &&
                !GameSDK$1.isOffCitys() &&
                !GameSDK$1.isCurrentVersion &&
                parseInt(GameSDK$1.data["JGRewardAd"]) > 0 &&
                parseInt(GameSDK$1.data["GKRewardAd"]) > 0) {
                GameSDK$1.showADVideo(this, (state) => { }, "结算误点广告");
            }
        }
        LoadPart() {
            if (this.sp) {
                this.PlayPart();
            }
            else {
                Laya.loader.load("Scene/openStar.part", Laya.Handler.create(this, this.onAssetsLoaded), null, Laya.Loader.JSON);
            }
        }
        onAssetsLoaded(settings) {
            this.sp = new Laya.Particle2D(settings);
            Laya.stage.addChild(this.sp);
            this.sp.x = Laya.stage.width / 2;
            this.sp.y = Laya.stage.height / 3;
            this.PlayPart();
        }
        PlayPart() {
            this.sp.emitter.start(1);
            this.sp.play();
        }
    }

    class UIShare extends UIBase {
        constructor() {
            super(...arguments);
            this.ConfigUI = new ConfigUI({
                event_refresh_gold_node: "text_cur_gold_count",
            });
            this.c_loader_img = null;
            this.c_loader_icon = null;
            this.c_text_count = null;
            this.c_comp_shareCom = null;
            this.c_comp_share = null;
            this.text_shuliang = null;
            this._shareCount = 0;
            this._skinId = 0;
            this._shareGold = 200;
        }
        onCreate() {
            this.c_comp_share.onClick(this, this.onShareClickHandler.bind(this));
        }
        onOpen() {
            GameSDK$1.stopVideoRecord();
            this.c_loader_img = this.c_comp_share.getChild("loader_img");
            this.text_shuliang = this.c_comp_shareCom.getChild("text_chaopiao");
            CanteenMgr.Int.dramCameraToImage(this.c_loader_img.displayObject);
            let controller = FguiBase$3.get_controller(this.c_comp_shareCom, "c1");
            this._skinId = -1;
            if (!GameSDK$1.isShow)
                this._skinId = -1;
            if (this._skinId <= 0) {
                controller.setSelectedIndex(0);
            }
            else {
                controller.setSelectedIndex(1);
                this._skin = GameData.getSkinItem(this._skinId);
                this.c_loader_icon.url = UIMgr.instance.iconUrl(this._skin.ImgUrl);
            }
            this._shareGold = GameData.getConfigDataItem("ShareGold");
            this.text_shuliang && (this.text_shuliang.text = "" + this._shareGold);
        }
        onShareClickHandler() {
            this.click_share();
        }
        click_share() {
            GameSDK$1.shareVideoRecord((isSucees) => {
                if (isSucees) {
                    LogicData.instance.isShare = true;
                    if (this._skinId != -1 && !LogicSkin.instance.has(this._skinId)) {
                        GameSDK$1.sendEvent("挂件分享解锁皮肤", "");
                        LogicSkin.instance.getSkin(this._skinId, true);
                    }
                    else {
                        LogicProp$1.instance.add(EPropNameById$1.diamonds, this._shareGold, true);
                        UIMain.Int.InitGuideTip(11, false);
                    }
                    this.closeUI(true);
                }
            });
        }
        click_fanhui() {
            UIMgr.instance.closeUI(ModuleType.Share);
        }
    }

    class UIAdExchangeMoney extends UIBase {
        constructor() {
            super(...arguments);
            this.ConfigUI = new ConfigUI({
                event_refresh_gold_node: "text_cur_gold_count",
            });
            this.c_btn_get = null;
        }
        onCreate() {
            this.c_btn_get.displayObject.addComponent(ButtonEffect);
        }
        onOpen() {
            FguiBase$3.find_children_names_once_node(this, "text_gold").asLabel.text = "+" + GameData.getConfigDataItem("VIDEO_ADD_GOLD");
        }
        click_get() {
            GameSDK$1.showADVideo(this, (state) => {
                if (state) {
                    LogicProp$1.instance.add(EPropNameById$1.diamonds, GameData.getConfigDataItem("VIDEO_ADD_GOLD"), true);
                    this.closeUI();
                }
            }, "免费补给");
        }
    }

    class UIGlodAnimFly extends UIBase {
        onCreate() {
            this.touchable = false;
        }
        onOpen() {
            this._anim = this.getTransition("t0");
            this._anim.play(Laya.Handler.create(this, this.onPlayEndHandler), 1, 0, 0);
            Laya.timer.once(5000, this, () => {
                try {
                    this.closeUI();
                }
                catch (error) {
                }
            });
        }
        onPlayEndHandler() {
            this.closeUI();
        }
    }

    var E_UISetting_Type;
    (function (E_UISetting_Type) {
        E_UISetting_Type[E_UISetting_Type["\u5F00\u542F"] = 0] = "\u5F00\u542F";
        E_UISetting_Type[E_UISetting_Type["\u5173\u95ED"] = 1] = "\u5173\u95ED";
    })(E_UISetting_Type || (E_UISetting_Type = {}));
    class UISetting extends UIBase {
        constructor() {
            super(...arguments);
            this.c_btn_yinyue = null;
            this.c_btn_yinxiao = null;
            this.c_btn_shock = null;
            this.c_btn_yinyue1 = null;
            this.c_btn_yinxiao1 = null;
            this.c_btn_shock1 = null;
            this.btn_guanqia = null;
            this.btn_chongwan = null;
            this.btn_jixu = null;
            this.n15 = null;
            this.c_btn_xieyi = null;
        }
        onOpen() {
            this.c_btn_xieyi.visible = false;
            GameSDK$1.closeCustomAd();
            GameSDK$1.showBanner();
            this.refresh();
            GameSDK$1.showADInsert();
        }
        click_yinyue() {
            if (AudioMgr$1.instance.is_music) {
                AudioMgr$1.instance.close_music();
            }
            else {
                AudioMgr$1.instance.open_music();
            }
            this.refresh();
        }
        click_xieyi() {
        }
        onClose() {
            GameSDK$1.hideBanner();
            GameSDK$1.showCustomAd("path");
        }
        click_yinxiao() {
            if (AudioMgr$1.instance.is_sound) {
                AudioMgr$1.instance.close_sound();
            }
            else {
                AudioMgr$1.instance.open_sound();
            }
            this.refresh();
        }
        click_shock() {
            if (LogicShock$1.instance.is_open())
                LogicShock$1.instance.close();
            else
                LogicShock$1.instance.open();
            this.refresh();
        }
        click_yinyue1() {
            if (AudioMgr$1.instance.is_music) {
                AudioMgr$1.instance.close_music();
            }
            else {
                AudioMgr$1.instance.open_music();
            }
            this.refresh();
        }
        click_yinxiao1() {
            if (AudioMgr$1.instance.is_sound) {
                AudioMgr$1.instance.close_sound();
            }
            else {
                AudioMgr$1.instance.open_sound();
            }
            this.refresh();
        }
        click_shock1() {
            if (LogicShock$1.instance.is_open())
                LogicShock$1.instance.close();
            else
                LogicShock$1.instance.open();
            this.refresh();
        }
        refresh() {
            if (this.c_btn_yinxiao) {
                this.c_btn_yinxiao.selected = !AudioMgr$1.instance.is_sound;
            }
            if (this.c_btn_yinyue) {
                this.c_btn_yinyue.selected = !AudioMgr$1.instance.is_music;
            }
            this.c_btn_shock.selected = !LogicShock$1.instance.is_open();
            if (this.c_btn_yinxiao1) {
                this.c_btn_yinxiao1.selected = !AudioMgr$1.instance.is_sound;
            }
            if (this.c_btn_yinyue1) {
                this.c_btn_yinyue1.selected = !AudioMgr$1.instance.is_music;
            }
        }
        click_caidanqiang() {
            UIMgr.instance.openUI(ModuleType.ExChangeCode);
            this.closeUI();
        }
        click_fanhui() {
            this.closeUI();
        }
    }

    class UITrySkin extends UIBase {
        constructor() {
            super(...arguments);
            this.c_loader_mode = null;
            this.c_btn_lijishiyong = null;
            this.skin = null;
            this.batteryId = 0;
            this.isStart = false;
            this.player = null;
        }
        onCreate() {
        }
        onOpen() {
            this._scene3D = new SceneShow3D();
            this._scene3D.setRenderTexture(this.c_loader_mode.displayObject);
            this.isStart = false;
            this.skin = null;
            this.batteryId = 0;
            if (this.openData[0]) {
                this.isStart = this.openData[0];
            }
            if (this.openData[1]) {
                let a = this.openData[1];
                if (a == 6) {
                    this.skin = GameData.getSkinItem(this.openData[1]);
                }
                else {
                    this.batteryId = a;
                }
            }
            if (this.skin != null) {
                this.refresh_mode(this.skin.Id);
            }
            else {
                this.refresh_mode2();
            }
            AudioMgr$1.instance.play_sound(21);
        }
        refresh_mode(id) {
        }
        refresh_mode2() {
        }
        click_zanbushiyong1() {
            if (this.isStart) {
                this.inGame();
            }
            this.closeUI();
        }
        click_lijishiyong1() {
            if (this.skin != null) {
                GameSDK$1.showADVideo(this, (state) => {
                    if (state) {
                        LogicSkin.instance.getSkin(this.skin.Id, true);
                        LogicSkin.instance.use(this.skin.Id);
                        if (this.isStart) {
                            this.inGame();
                        }
                        else {
                            this.closeUI(true);
                        }
                        EventMgr$1.Int.emit(EventType$1.UPDATE_SKIN);
                    }
                }, "免费试用" + this.skin.Name);
            }
            else {
                GameSDK$1.showADVideo(this, (state) => {
                    if (state) {
                        LogicData.instance.AddBatteryLevels(this.batteryId);
                        this.closeUI(true);
                    }
                }, "免费试用");
            }
        }
        inGame() {
        }
        onClose() {
            this._scene3D.destroy();
        }
        playIdel() {
            console.log("播放站立");
            let model = this.player;
            if (model) {
                let ani = model.getComponent(Laya.Animator);
                if (ani) {
                    ani.crossFade("Idle02", 0.1);
                }
            }
        }
    }

    class UIReward extends UIBase {
        constructor() {
            super(...arguments);
            this.ConfigUI = new ConfigUI({
                event_refresh_gold_node: "text_cur_gold_count",
            });
            this.c_text_num = null;
            this.closeHandler = null;
            this.c_loader_img = null;
            this.c_loader_icon = null;
            this.c_text_gouliang = null;
            this.player = null;
        }
        onOpen() {
            this.player = null;
            this._scene3D = new SceneShow3D(this.openData.Type == E_CLIPDOLL_REWARD.SKIN);
            this._scene3D.setRenderTexture(this.c_loader_icon.displayObject);
            console.log("当前奖励的id", this.openData);
            this.updateReward();
            if (this.openData.handler) {
                this.closeHandler = this.openData.handler;
            }
            else {
                this.closeHandler = null;
            }
        }
        updateReward() {
            this.c_loader_img.url = "";
            if (this.openData.IsBad) {
                this.getControllerAt(1).selectedIndex = 1;
            }
            else {
                this.getControllerAt(1).selectedIndex = 0;
            }
            if (this.openData.Type == E_CLIPDOLL_REWARD.COIN) {
                this.controllerOnce.selectedIndex = 0;
                this.c_loader_icon.scaleX = 1.5;
                this.c_loader_icon.scaleY = 1.5;
                this.c_loader_icon.setPivot(0.5, 0);
                this.c_loader_icon.url = this.openData.Icon_url;
                this.c_text_gouliang.text = this.openData.Value.toString();
            }
            else if (this.openData.Type == E_CLIPDOLL_REWARD.SKIN) {
                if (this.openData.isVideo) {
                    this.controllerOnce.selectedIndex = 2;
                }
                else {
                    this.controllerOnce.selectedIndex = 1;
                }
                let id = this.openData.SkinId == undefined ? this.openData.Value : this.openData.SkinId;
                let info = GameData.getSkinItem(id);
                this.c_loader_img.visible = true;
                this.c_loader_icon.visible = false;
                this.c_loader_img.url = "res/icon/" + info.ImgUrl + ".png";
            }
            else {
                console.log("不支持奖励类型");
            }
        }
        addReward(times = 1) {
            if (this.openData.Type == E_CLIPDOLL_REWARD.COIN) {
                LogicProp$1.instance.add(EPropNameById$1.diamonds, this.openData.Value * times, true);
            }
            else if (this.openData.Type == E_CLIPDOLL_REWARD.SKIN) {
                let id = this.openData.SkinId == undefined ? this.openData.Value : this.openData.SkinId;
                LogicSkin.instance.getSkin(id, true);
                LogicSkin.instance.use(id);
            }
            this.closeUI();
            EventMgr$1.Int.emit(EventType$1.UPDATE_SKIN);
        }
        click_gongxi() {
            GameSDK$1.showADVideo(this, (b) => {
                if (b) {
                    this.addReward();
                }
            }, "视频获得");
        }
        click_kaixinshouxi() {
            GameSDK$1.showADVideo(this, (b) => {
                if (b) {
                    this.addReward();
                }
            }, "视频获得");
        }
        click_jujue() {
            this.closeUI();
        }
        click_shouxi() {
            this.addReward();
        }
        click_lijilingqu() {
            this.addReward();
        }
        click_lijilingqu2() {
            this.addReward();
        }
        click_zhijielingqu() {
            this.addReward();
        }
        click_sanbeilingqu() {
            GameSDK$1.showADVideo(this, (b) => {
                if (b) {
                    this.addReward(3);
                }
            }, "娃娃机看广告");
        }
        click_huanyige() {
        }
        onClose() {
            Laya.timer.clear(this, this.playIdel);
            this._scene3D.destroy();
            if (this.closeHandler) {
                this.closeHandler.run();
            }
        }
        click_sousuo() {
            GameSDK$1.sendEvent("获得皮肤进入搜索页面", "1");
            UIMgr.instance.openUI(ModuleType.UISouSuo);
        }
        playIdel() {
            console.log("播放站立");
            let model = this.player;
            if (model) {
                let ani = model.getComponent(Laya.Animator);
                if (ani) {
                    ani.crossFade("Idle02", 0.1);
                }
            }
        }
    }

    class UILoad extends UIBase {
        onOpen() {
            console.warn("加载界面呗打开");
        }
        onClose() {
            console.warn("加载界面关闭");
            this.removeFromParent();
            this.dispose();
        }
    }

    class UIComboEffect extends UIBase {
        onCreate() {
            this.touchable = false;
        }
        onOpen() {
            this.controllerOnce.setSelectedIndex(this.openData);
            this._anim = this.getTransition("t0");
            this._anim.play(Laya.Handler.create(this, this.onPlayEndHandler), 1, 0, 0);
        }
        onPlayEndHandler() {
            this.click_close();
        }
    }

    class UIFailEffect extends UIBase {
        onCreate() {
            this.touchable = false;
        }
        onOpen() {
            this._anim = this.getTransition("t0");
            this._anim.play(Laya.Handler.create(this, this.onPlayEndHandler), 1, 0, 0);
        }
        onPlayEndHandler() {
            this.click_close();
        }
    }

    class UIExChangeCode extends UIBase {
        constructor() {
            super(...arguments);
            this.ConfigUI = new ConfigUI({
                event_refresh_gold_node: "text_cur_gold_count",
            });
            this.c_input_duihuanma = null;
        }
        onOpen() {
            this.c_input_duihuanma.text = "";
        }
        click_duihuan() {
            let code = this.c_input_duihuanma.text;
            this.c_input_duihuanma.text = "";
            if (isEmpty(code)) {
                TipMgr.Int.showTips("请输入兑换码");
                return;
            }
            let dan = null;
            let data;
            for (let key in dan) {
                if (dan[key].Code == code) {
                    data = dan[key];
                }
            }
            if (data) {
                if (code == data.Code) ;
            }
            else {
                TipMgr.Int.showTips("无效兑换码");
            }
        }
    }

    class BaseUI extends UIBase {
        findNode(node, path) {
            var list = path.split("/");
            for (var i = 0; i < list.length; i++) {
                node = node.getChild(list[i]).asCom;
                if (node == null) {
                    console.log("findNode: Not found", list[i]);
                    return null;
                }
            }
            return node;
        }
        childPath(path) {
            return this.findNode(this, path);
        }
        child(name) {
            return this.getChild(name);
        }
        childAt(index) {
            return this.getChildAt(index);
        }
        remove() {
            this.closeUI(true);
        }
        onDestroy() {
            this.onRemove();
        }
        onRemove() {
        }
        parseUI() {
        }
        onShow() { }
        ;
        onHide() { }
        ;
    }

    class UIThings extends UIBase {
        constructor() {
            super(...arguments);
            this.ConfigUI = new ConfigUI({
                event_refresh_gold_node: "text_cur_gold_count",
            });
            this.c_loader_mode = null;
            this.c_list_01 = null;
            this._curSelectionId = -1;
        }
        onCreate() {
        }
        onOpen() {
            this._scene3D = new SceneShow3D(false);
            this._scene3D.setRenderTexture(this.c_loader_mode.displayObject);
            this.onInitTabHandler();
        }
        onInitTabHandler() {
            let skins = GameData.getThing();
            let arr = [];
            this.c_list_01.removeChildren();
            for (let key in skins) {
                if (GameSDK.isCurrentVersion) {
                    if (skins[key].Id == 23 || skins[key].Id == 33 ||
                        skins[key].Id == 3 || skins[key].Id == 24 || skins[key].Id == 25
                        || skins[key].Id == 14) {
                        continue;
                    }
                }
                arr.push(skins[key]);
            }
            let arr2 = [];
            arr = arr.sort((a, b) => {
                return a.Sort - b.Sort;
            });
            arr = arr.sort((a, b) => {
                let infoa = LogicData.instance.getThing(a.Id);
                let infob = LogicData.instance.getThing(b.Id);
                return infob.time - infoa.time;
            });
            arr2 = arr2.sort((a, b) => {
                return a.Sort - b.Sort;
            });
            let arr3 = [arr.shift(), arr.shift(), arr.shift()];
            arr2.push(...arr);
            arr3.push(...arr2);
            for (var i = 0; i < arr3.length; ++i) {
                let value = arr3[i];
                if (value.UnLockType[0] == 0)
                    continue;
                this.c_list_01.addItem().init(Number(value.Id));
            }
            this.c_list_01.on(fairygui.Events.CLICK_ITEM, this, this.on_event_list_click_item);
            let skin = arr3[0].Id;
            this._curSelectionId = skin;
            this.refresh_mode(skin);
            this.refresh_items();
        }
        on_event_list_click_item(item, e) {
            if (!item.value)
                return;
            this._curSelectionId = item.value.Id;
            this.refresh_items();
            this.refresh_mode(this._curSelectionId);
        }
        refresh_mode(id) {
        }
        refresh_items() {
            for (let value of this.c_list_01._children) {
                if (value.value)
                    value.refresh(value.value.Id == this._curSelectionId, 0);
                else
                    value.refresh(false, 0);
            }
        }
        onClose() {
            this._scene3D.destroy();
        }
        click_suiji() {
            let skinId = LogicSkin.instance.getEndRandomUnlockId(1);
            if (skinId > 0) {
                let needCount = GameData.getConfigDataItem("RANDOM_UNLOCK_GOLD");
                if (LogicProp.instance.has(EPropNameById.diamonds, needCount, true)) {
                    LogicProp.instance.add(EPropNameById.diamonds, -needCount);
                    LogicSkin.instance.getSkin(skinId, true);
                    this.refresh_items();
                    this.closeUI();
                }
                else {
                    TipMgr.Int.showTips("金币不足");
                }
            }
            else {
                TipMgr.Int.showTips("敬请期待");
            }
        }
        click_ad() {
            GameSDK.showADVideo(this, (b) => {
                if (b) {
                    AudioMgr$1.instance.play_sound(7);
                    LogicProp.instance.add(EPropNameById.diamonds, GameData.getConfigDataItem("VIDEO_ADD_GOLD"), true);
                }
            }, "皮肤商城看广告获得金币");
        }
    }
    class UIThingItem extends BaseUI {
        constructor() {
            super(...arguments);
            this.value = null;
            this.c_text_name = null;
            this.c_loader_icon = null;
            this.c_btn_anniu = null;
        }
        init(i) {
            this.value = GameData.getThingItem(i);
            this.c_loader_icon.url = UIMgr.instance.iconUrl(this.value.ImgUrl);
            this.c_text_name.text = this.value.Name;
            let info = LogicData.instance.getThing(this.value.Id);
            if (info.has) {
                this.c_btn_anniu.getController("c1").selectedIndex = 3;
                return;
            }
            if (this.value.UnLockType.indexOf(7) != -1) {
                this.c_btn_anniu.getController("c1").selectedIndex = 2;
            }
            if (this.value.UnLockType.indexOf(8) != -1) {
                this.c_btn_anniu.getController("c1").selectedIndex = 0;
                let admax = this.value.UnLockValue[this.value.UnLockType.indexOf(8)];
                this.GetGameObject("text_ad").asLabel.text = info.watchad + "/" + admax;
            }
            if (this.value.UnLockType.indexOf(1) != -1) {
                this.c_btn_anniu.getController("c1").selectedIndex = 1;
                let coin = this.value.UnLockValue[this.value.UnLockType.indexOf(1)];
                this.GetGameObject("text_jinbi").asLabel.text = coin + "";
            }
        }
        click_anniu() {
            console.log(this.value);
            let info = LogicData.instance.getThing(this.value.Id);
            if (info.has)
                return;
            if (this.value.UnLockType.indexOf(8) != -1) {
                GameSDK.showADVideo(this, (b) => {
                    if (b) {
                        LogicData.instance.watchad(this.value.Id, () => {
                            try {
                                this.init(this.value.Id);
                            }
                            catch (error) {
                            }
                        });
                    }
                }, "道具商店");
            }
            else if (this.value.UnLockType.indexOf(1) != -1) {
                let coin = this.value.UnLockValue[this.value.UnLockType.indexOf(1)];
                if (LogicProp.instance.has(EPropNameById.diamonds, coin)) {
                    LogicProp.instance.add(EPropNameById.diamonds, -coin, false);
                    LogicData.instance.buy(this.value.Id);
                }
                else {
                    TipMgr.Int.showTips("金币不足");
                    return;
                }
                this.init(this.value.Id);
            }
        }
        refresh(isSelection = false, type) {
        }
    }

    class Compgunaqia extends FguiBase$3 {
        constructor() {
            super(...arguments);
            this.c_comp_gunaqia01 = null;
            this.c_comp_gunaqia02 = null;
            this.c_comp_gunaqia03 = null;
            this.c_comp_gunaqia04 = null;
            this.c_comp_gunaqia05 = null;
            this.arr = [];
        }
        init() {
            this.c_comp_gunaqia01 = this.getChild("comp_gunaqia01").asCom;
            this.c_comp_gunaqia02 = this.getChild("comp_gunaqia02").asCom;
            this.c_comp_gunaqia03 = this.getChild("comp_gunaqia03").asCom;
            this.c_comp_gunaqia04 = this.getChild("comp_gunaqia04").asCom;
            this.c_comp_gunaqia05 = this.getChild("comp_gunaqia05").asCom;
            this.arr = [this.c_comp_gunaqia01, this.c_comp_gunaqia02, this.c_comp_gunaqia03, this.c_comp_gunaqia04, this.c_comp_gunaqia05];
            this.updateLevel();
        }
        updateLevel() {
            let level = LogicData.instance.level;
            let startNum = level - 2;
            console.log("ttttt", level);
            for (let i = 0; i < 5; i++) {
                this.arr[i].getChild("text_guanqia").text = (startNum + i + 1).toString();
                if (level >= startNum + i + 1) {
                    this.arr[i].getController("c2").selectedIndex = 1;
                }
                else {
                    this.arr[i].getController("c2").selectedIndex = 0;
                }
            }
        }
    }

    class UITebietiaozhan extends UIBase {
        constructor() {
            super(...arguments);
            this.ConfigUI = new ConfigUI({
                event_refresh_gold_node: "text_cur_gold_count",
            });
            this.closeHandler = null;
            this.c_comp_teshutiaozhan = null;
            this.kind = 0;
            this.c_btn_answer_a = null;
            this.c_btn_answer_b = null;
            this.c_comp_tiaozhan1 = null;
            this.c_comp_tiaozhan2 = null;
            this.c_comp_tiaozhan3 = null;
            this.c_comp_tiaozhan4 = null;
            this.keys = null;
            this.c_comp_yaoshi1 = null;
            this.c_comp_yaoshi2 = null;
            this.c_comp_yaoshi3 = null;
            this.answerName = ["AnswerA", "AnswerB", "AnswerC", "AnswerD"];
        }
        onCreate() { }
        onOpen() {
            this.c_comp_teshutiaozhan.init();
            EventMgr$1.Int.on(EventType$1.INIT_ANSWER, this.updateBtn, this);
            EventMgr$1.Int.on(EventType$1.MACKYES, this.setYes, this);
            EventMgr$1.Int.on(EventType$1.MACKFAIL, this.setFail, this);
            EventMgr$1.Int.on(EventType$1.INIT_ANSWER, this.setCur, this);
            console.log("打开了特别挑战界面");
            this.keys = [this.c_comp_yaoshi1, this.c_comp_yaoshi2, this.c_comp_yaoshi3];
            this.kind = this.openData[0];
            this.initYes();
            this.getControllerAt(0).selectedIndex = this.kind;
            this.checkKeyNum();
            if (this.openData && this.openData[2]) {
                this.openData[2].run();
            }
        }
        checkKeyNum() {
            let kenum = LogicProp.instance.get(EPropNameById.key);
            for (let i = 0; i < this.keys.length; i++) {
                let cp = this.keys[i];
                if (i < kenum) {
                    cp.getControllerAt(0).selectedIndex = 1;
                }
                else {
                    cp.getControllerAt(0).selectedIndex = 0;
                }
            }
        }
        onClose() {
            EventMgr$1.Int.off(EventType$1.INIT_ANSWER, this.updatePic, this);
        }
        initYes() {
            this.c_comp_tiaozhan1.getControllerAt(0).selectedIndex = 1;
            this.c_comp_tiaozhan2.getControllerAt(0).selectedIndex = 1;
            this.c_comp_tiaozhan3.getControllerAt(0).selectedIndex = 1;
            this.c_comp_tiaozhan4.getControllerAt(0).selectedIndex = 1;
        }
        setCur() {
        }
        setFail() {
        }
        setYes() {
        }
        updatePic() {
            this.c_comp_teshutiaozhan.loadTexture();
        }
        updateBtn() {
        }
        initBtnColor() {
            this.c_btn_answer_a.getController("selectType").selectedIndex = 0;
            this.c_btn_answer_b.getController("selectType").selectedIndex = 0;
        }
        click_tiaozhan() {
            console.log("放弃进入特别奖励关卡");
            this.closeUI(true);
        }
        click_jujue() {
        }
        delatEnter() {
        }
        click_answer_a() {
            console.log("点击了a");
        }
        click_answer_b() {
            console.log("点击了b");
        }
    }

    class CompTeshu extends FguiBase$3 {
        constructor() {
            super();
            this.loader_pic = null;
            this.text_miaoshu = null;
            this.text_biaoti = null;
            this.text_teshu = null;
            this.progress_daojishi = null;
        }
        init() {
            console.log("初始化奖励关卡ui");
            this.loader_pic = this.getChild("loader_tupian");
            this.text_miaoshu = this.getChild("text_miaoshu");
            this.text_biaoti = this.getChild("text_biaoti");
            this.progress_daojishi = this.getChild("progress_daojishi");
            EventMgr$1.Int.on(EventType$1.TIMER_UPDATE, this.updateBar, this);
        }
        onDispose() {
            EventMgr$1.Int.off(EventType$1.TIMER_UPDATE, this.updateBar, this);
        }
        updateBar(num = 0) {
            if (this.progress_daojishi)
                this.progress_daojishi.value = (num / 100);
        }
        loadTexture() {
        }
        setMultiple(res) {
        }
    }

    class CompMoveCtr extends FguiBase$3 {
        constructor() {
            super();
            this.isOpen = false;
            this.dwon_pos = new Laya.Vector2();
            this.start_pos = new Laya.Vector2();
            this.ctPan = null;
            this.img_c = null;
            this._reportMove = false;
            this.v3_zero = new Laya.Vector3();
            this._reportTouch = false;
        }
        onConstruct() {
            this.initView();
        }
        initView() {
            this.addEvent();
        }
        initCtrView() {
            this.isOpen = false;
            this.ctPan = this.getChild("comp_pan").asCom;
            this.img_c = this.ctPan.getChild("img_c");
            this.ctPan.visible = false;
        }
        addEvent() {
            this.removeEvent();
            this.initCtrView();
            this.on(Laya.Event.MOUSE_DOWN, this, this.startCtr);
            this.on(Laya.Event.MOUSE_UP, this, this.stopDrag);
            this.on(Laya.Event.MOUSE_OUT, this, this.stopDrag);
            Laya.timer.frameLoop(1, this, this.update);
        }
        removeEvent() {
            this.off(Laya.Event.MOUSE_DOWN, this, this.startCtr);
            this.off(Laya.Event.MOUSE_UP, this, this.stopDrag);
            this.off(Laya.Event.MOUSE_OUT, this, this.stopDrag);
            Laya.timer.clear(this, this.update);
        }
        update() {
            if (this.isOpen && CanteenMgr.Int.IsSatrt) {
                this.dwon_pos.x = Laya.stage.mouseX;
                this.dwon_pos.y = Laya.stage.mouseY;
                let v3 = new Laya.Vector3((Laya.stage.mouseX - this.start_pos.x) / 1000, 0, (Laya.stage.mouseY - this.start_pos.y) / 1000);
                v3 = MyInstrument.glrot(15, v3, 0, 1, 0);
                EventMgr$1.Int.emit(EventType$1.PLAYER_MOVE, v3);
                let x = this.dwon_pos.x - this.ctPan.x;
                let y = this.dwon_pos.y - this.ctPan.y;
                let v2 = new Laya.Vector2(x, y);
                if (!this._reportMove && (v2.x != 0 || v2.y != 0)) {
                    this._reportMove = true;
                    ReportMgr.inst.sendReport(ReportType.FIRST_MOVE);
                }
                if (Laya.Vector2.scalarLength(v2) > 100) {
                    Laya.Vector2.normalize(v2, v2);
                    Laya.Vector2.scale(v2, 100, v2);
                }
                this.img_c.x = v2.x;
                this.img_c.y = v2.y;
            }
        }
        startCtr(e) {
            if (this.isOpen)
                return;
            if (!this._reportTouch) {
                this._reportTouch = true;
                ReportMgr.inst.sendReport(ReportType.FIRST_TOUCH);
            }
            this.isOpen = true;
            this.dwon_pos.x = Laya.stage.mouseX;
            this.dwon_pos.y = Laya.stage.mouseY;
            this.start_pos = this.dwon_pos.clone();
            this.ctPan.visible = true;
            this.ctPan.x = this.dwon_pos.x;
            this.ctPan.y = this.dwon_pos.y;
        }
        MustStartCtr(v2) {
            this.isOpen = true;
            this.dwon_pos.x = v2.x;
            this.dwon_pos.y = v2.y;
            this.start_pos = this.dwon_pos.clone();
        }
        stopDrag() {
            if (!this.isOpen)
                return;
            this.isOpen = false;
            this.ctPan.visible = false;
            EventMgr$1.Int.emit(EventType$1.PLAYER_MOVE, new Laya.Vector3());
        }
        Gestures(v2) {
            let angle = MyInstrument.getTheAngle(v2, new Laya.Vector2(0, -1));
            if (angle >= -45 && angle < 45) {
                return 0;
            }
            if (angle >= 45 && angle < 135) {
                return 1;
            }
            if (angle >= -135 && angle < -45) {
                return 3;
            }
            return 2;
        }
        IsMouseDown() {
            return this.isOpen;
        }
    }

    class CompDogKind extends FguiBase$3 {
        constructor() {
            super(...arguments);
            this.curKind = 0;
            this.c_btn_gou = null;
            this.c_list_gou = null;
        }
        onConstruct() {
            super.onConstruct();
            FguiBase$3.match_children_to_member(this, this);
        }
        Init() {
            this.InitKinds();
            this.InitIcon();
            this.controllerOnce.selectedIndex = 1;
            EventMgr$1.Int.off(EventType$1.UPDATE_SKIN, this.InitIcon, this);
            EventMgr$1.Int.on(EventType$1.UPDATE_SKIN, this.InitIcon, this);
        }
        InitIcon() {
            let id = LogicSkin.instance.getSkinID(3);
            let data = GameData.getSkinItem(id);
            this.c_btn_gou.getChild("icon").asLoader.url = "res/icon/" + data.ImgUrl + ".png";
            this.InitKinds();
        }
        InitKinds() {
            let skins = GameData.getSkin();
            let arr = [];
            for (let key in skins) {
                if (skins[key].Type == 3) {
                    arr.push(skins[key]);
                }
            }
            console.log("获取到的皮肤数据", arr);
            let list;
            list = this.c_list_gou;
            list.removeChildren();
            let leng = arr.length;
            for (var i = 0; i < leng; i++) {
                let value = arr[i];
                list.addItem().Init(Number(value.Id));
            }
        }
    }

    class DogKindItem extends FguiBase$3 {
        constructor() {
            super(...arguments);
            this.Id = -1;
            this.loader_icon = null;
            this.c1 = null;
            this.tdata = null;
        }
        Init(id) {
            this.loader_icon = this.getChild("loader_icon").asLoader;
            this.c1 = this.getControllerAt(1);
            this.Id = id;
            this.offClick(this, this.ItemClick);
            this.onClick(this, this.ItemClick);
            this.tdata = GameData.getSkinItem(id);
            this.loader_icon.url = "res/icon/" + this.tdata.ImgUrl + ".png";
            this.updateHas();
        }
        updateHas() {
            if (LogicSkin.instance.has(this.Id)) {
                this.c1.selectedIndex = 0;
                let uid = LogicSkin.instance.getSkinID(3);
                if (uid == this.Id) {
                    this.c1.selectedIndex = 1;
                }
            }
            else {
                this.c1.selectedIndex = 2;
            }
        }
        onDispose() {
            this.offClick(this, this.ItemClick);
        }
        ItemClick() {
            if (LogicSkin.instance.has(this.Id)) {
                LogicSkin.instance.use(this.Id);
                EventMgr$1.Int.emit(EventType$1.UPDATE_SKIN);
            }
            else {
                GameSDK$1.showADVideo(this, (b) => {
                    if (b) {
                        LogicSkin.instance.getSkin(this.Id, false);
                        LogicSkin.instance.use(this.Id);
                        EventMgr$1.Int.emit(EventType$1.UPDATE_SKIN);
                    }
                }, "皮肤商城");
            }
        }
    }

    class UIMap extends UIBase {
        constructor() {
            super(...arguments);
            this.ConfigUI = new ConfigUI({
                event_refresh_gold_node: "text_cur_gold_count",
            });
            this.c_list_guanqia = null;
            this.c_comp_suipian = null;
            this.c_list_biaoji = null;
        }
        onOpen() {
            console.log("打开关卡大厅界面");
            this.InitMapList();
            this.updateSuipian();
            this.c_list_guanqia.on(fgui.Events.SCROLL_END, this, this.updateDot);
            this.updateDot();
        }
        onClose() {
            this.c_list_guanqia.off(fgui.Events.XY_CHANGED, this, this.updateDot);
        }
        updateSuipian() {
            let v = LogicProp.instance.get(EPropNameById.suipian);
            this.c_comp_suipian.getChild("text_cur_gold_count3").text = v.toString();
        }
        InitMapList() {
            this.c_list_guanqia.numItems = 0;
            this.c_list_guanqia.itemRenderer = Laya.Handler.create(this, this.ListRender, null, false);
            this.c_list_guanqia.numItems = 30;
        }
        ListRender(index, item) {
            item.InitItem(index + 1);
        }
        SourceTo() {
            let age = LogicData.instance.DogAge;
            let index = Math.floor(age / 4);
            index >= 4 ? (index = 3) : null;
            this.c_list_guanqia.scrollToView(3 - index);
        }
        click_fanhui() {
            this.closeUI();
        }
        click_zuo() {
            this.c_list_guanqia.scrollPane.posX -= 2000;
            this.updateDot();
        }
        click_you() {
            this.c_list_guanqia.scrollPane.posX += 2000;
            this.updateDot();
        }
        updateDot() {
            let sc = this.c_list_guanqia.scrollPane.posX;
            if (sc <= 800) {
                this.c_list_biaoji.selectedIndex = 0;
            }
            else {
                this.c_list_biaoji.selectedIndex = 1;
            }
            console.warn("scorllend", sc);
        }
    }

    class MapItem extends FguiBase$3 {
        constructor() {
            super();
            this.n14 = null;
            this.tIndex = 0;
        }
        onConstruct() {
            super.onConstruct();
            FguiBase$3.match_children_to_member(this, this);
        }
        InitItem(index) {
            this.n14 = this.getChild("n14").asTextField;
            this.tIndex = index;
            this.onClick(this, this.ClickItem);
            this.n14.text = "";
            let arr = LogicData.instance.VideoLevel;
            let arrsc = LogicData.instance.VideoLevelsc;
            let level = LogicData.instance.level;
            if (this.tIndex < level || arr.indexOf(this.tIndex) >= 0) {
                this.controllerOnce.selectedIndex = 2;
                if (arrsc.indexOf(this.tIndex) >= 0) {
                    this.controllerOnce.selectedIndex = 2;
                }
                else {
                    this.controllerOnce.selectedIndex = 1;
                }
            }
            else if (this.tIndex == level) {
                this.controllerOnce.selectedIndex = 1;
            }
            else {
                this.controllerOnce.selectedIndex = 0;
            }
            if (this.tIndex < 10) {
                this.n14.text = "0" + this.tIndex.toString();
            }
            else {
                this.n14.text = this.tIndex.toString();
            }
        }
        onDispose() {
            this.offClick(this, this.ClickItem);
        }
        ClickItem() {
            console.warn("点击数字", this.tIndex);
            if (this.controllerOnce.selectedIndex == 0) {
                console.warn("看广告");
                GameSDK$1.showADVideo(this, (b) => {
                    if (b) {
                        UIMgr.instance.closeUI(ModuleType.UIMap);
                        UIMgr.instance.closeUI(ModuleType.Main);
                        LogicData.instance.AddVideoLevel(this.tIndex);
                    }
                }, "皮肤商城");
            }
            else {
                UIMgr.instance.closeUI(ModuleType.UIMap);
                UIMgr.instance.closeUI(ModuleType.Main);
            }
        }
    }

    var DressVS = "#if defined(GL_FRAGMENT_PRECISION_HIGH)\nprecision highp float;precision highp int;\n#else\nprecision mediump float;precision mediump int;\n#endif\n#include \"Lighting.glsl\";\n#include \"Shadow.glsl\";\nattribute vec4 a_Position;\n#ifdef GPU_INSTANCE\nattribute mat4 a_MvpMatrix;\n#else\nuniform mat4 u_MvpMatrix;\n#endif\nattribute vec2 a_Texcoord0;\n#if defined(DIFFUSEMAP)||((defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&(defined(SPECULARMAP)||defined(NORMALMAP)))||(defined(LIGHTMAP)&&defined(UV))\nvarying vec2 v_Texcoord0;\n#endif\n#ifdef ANIMATORTEXTURE\nuniform sampler2D u_AnimatorTexture;\n#endif\nuniform float u_Time;varying vec2 v_Texcoord1;attribute vec2 a_Texcoord1;\n#ifdef LIGHTMAP\nuniform vec4 u_LightmapScaleOffset;varying vec2 v_LightMapUV;\n#endif\n#ifdef COLOR\nattribute vec4 a_Color;varying vec4 v_Color;\n#endif\n#ifdef BONE\nconst int c_MaxBoneCount=24;attribute vec4 a_BoneIndices;attribute vec4 a_BoneWeights;uniform mat4 u_Bones[c_MaxBoneCount];\n#endif\nattribute vec3 a_Normal;varying vec3 v_Normal;\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\nuniform vec3 u_CameraPos;varying vec3 v_ViewDir;\n#endif\n#if defined(NORMALMAP)\nattribute vec4 a_Tangent0;varying vec3 v_Tangent;varying vec3 v_Binormal;\n#endif\n#ifdef GPU_INSTANCE\nattribute mat4 a_WorldMat;\n#else\nuniform mat4 u_WorldMat;\n#endif\n#if defined(POINTLIGHT)||defined(SPOTLIGHT)||(defined(CALCULATE_SHADOWS)&&defined(SHADOW_CASCADE))||defined(CALCULATE_SPOTSHADOWS)\nvarying vec3 v_PositionWorld;\n#endif\n#if defined(CALCULATE_SHADOWS)&&!defined(SHADOW_CASCADE)\nvarying vec4 v_ShadowCoord;\n#endif\n#if defined(CALCULATE_SPOTSHADOWS)\nvarying vec4 v_SpotShadowCoord;\n#endif\n#ifdef TILINGOFFSET\nuniform vec4 u_TilingOffset;\n#endif\nuniform float u_AniFrame;uniform vec2 u_TextureSize;uniform float u_VertexCount;uniform float u_blendshape0;uniform float u_blendshape1;uniform float u_blendshape2;uniform float u_blendshape3;uniform float u_blendshape4;uniform float u_blendshape5;uniform float u_blendshape6;uniform float u_blendshape7;uniform float u_blendshape8;uniform float u_blendshape9;uniform float u_blendshape10;uniform float u_blendshape11;uniform float u_blendshape12;uniform float u_blendshape13;uniform float u_blendshape14;uniform float u_blendshape15;uniform float u_blendshape16;uniform float u_blendshape17;uniform float u_blendshape18;uniform float u_blendshape19;uniform float u_maxblendshape;uniform vec3 u_add;uniform vec3 u_mul;struct BlendResult{vec3 position;vec3 normal;};BlendResult changeblendshape(vec3 normal,vec3 position,float id,float index,float blendshape){if(id<u_maxblendshape&&blendshape!=0.0){float verIndex=id*u_VertexCount+index;float now=(verIndex*3.0);vec2 uv_a=vec2(0.0,0.0);vec2 uv_b=vec2(0.0,0.0);vec2 uv_c=vec2(0.0,0.0);uv_a.x=(mod(now,u_TextureSize.x)+0.5)/u_TextureSize.x;uv_a.y=(floor(now/u_TextureSize.x)+0.5)/u_TextureSize.y;uv_b.x=(mod((now+1.0),u_TextureSize.x)+0.5)/u_TextureSize.x;uv_b.y=(floor((now+1.0)/u_TextureSize.x)+0.5)/u_TextureSize.y;uv_c.x=(mod((now+2.0),u_TextureSize.x)+0.5)/u_TextureSize.x;uv_c.y=(floor((now+2.0)/u_TextureSize.x)+0.5)/u_TextureSize.y;vec4 aniPos_a=texture2D(u_AnimatorTexture,uv_a);vec4 aniPos_b=texture2D(u_AnimatorTexture,uv_b);float x=(aniPos_a.r*255.0*256.0+aniPos_a.g*255.0)/65535.0;float y=(aniPos_a.b*255.0*256.0+aniPos_b.r*255.0)/65535.0;float z=(aniPos_b.g*255.0*256.0+aniPos_b.b*255.0)/65535.0;vec3 aniPos=vec3(x/u_mul.x+u_add.x,y/u_mul.y+u_add.y,z/u_mul.z+u_add.z);position.xyz+=mix(a_Position.xyz,aniPos.rgb,blendshape)-a_Position.xyz;vec4 nomalPos=texture2D(u_AnimatorTexture,uv_c);nomalPos.x=(nomalPos.x-0.5)*2.0;nomalPos.y=(nomalPos.y-0.5)*2.0;nomalPos.z=(nomalPos.z-0.5)*2.0;normal.xyz+=mix(a_Normal.xyz,nomalPos.rgb,blendshape)-a_Normal.xyz;}BlendResult o;o.position=position;o.normal=normal;return o;}void main(){vec4 position=a_Position;vec3 normal=a_Normal;\n#ifdef ANIMATORTEXTURE\nvec2 uv1=a_Texcoord1;float index=uv1.x*200.0*200.0+(1.0-uv1.y)*200.0;if(index-floor(index)>0.5){index=ceil(index);}else{index=floor(index);}BlendResult ret;ret=changeblendshape(a_Normal,a_Position.xyz,0.0,index,u_blendshape0);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,1.0,index,u_blendshape1);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,2.0,index,u_blendshape2);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,3.0,index,u_blendshape3);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,4.0,index,u_blendshape4);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,5.0,index,u_blendshape5);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,6.0,index,u_blendshape6);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,7.0,index,u_blendshape7);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,8.0,index,u_blendshape8);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,9.0,index,u_blendshape9);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,10.0,index,u_blendshape10);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,11.0,index,u_blendshape11);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,12.0,index,u_blendshape12);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,13.0,index,u_blendshape13);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,14.0,index,u_blendshape14);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,15.0,index,u_blendshape15);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,16.0,index,u_blendshape16);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,17.0,index,u_blendshape17);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,18.0,index,u_blendshape18);position.xyz=ret.position.xyz;normal=ret.normal;ret=changeblendshape(normal,position.xyz,16.0,index,u_blendshape19);position.xyz=ret.position.xyz;normal=ret.normal;\n#endif\n#ifdef GPU_INSTANCE\ngl_Position=a_MvpMatrix*position;\n#else\ngl_Position=u_MvpMatrix*position;\n#endif\nmat4 worldMat;\n#ifdef GPU_INSTANCE\nworldMat=a_WorldMat;\n#else\nworldMat=u_WorldMat;\n#endif\nmat3 _world2Object;_world2Object=INVERSE_MAT(mat3(worldMat));v_Normal=normalize(normal*_world2Object);\n#if defined(NORMALMAP)\nv_Tangent=normalize(a_Tangent0.xyz*_world2Object);v_Binormal=cross(v_Normal,v_Tangent)*a_Tangent0.w;\n#endif\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)||(defined(CALCULATE_SHADOWS)&&defined(SHADOW_CASCADE))||defined(CALCULATE_SPOTSHADOWS)\nvec3 positionWS=(worldMat*position).xyz;\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\nv_ViewDir=u_CameraPos-positionWS;\n#endif\n#if defined(POINTLIGHT)||defined(SPOTLIGHT)||(defined(CALCULATE_SHADOWS)&&defined(SHADOW_CASCADE))||defined(CALCULATE_SPOTSHADOWS)\nv_PositionWorld=positionWS;\n#endif\n#endif\n#if defined(DIFFUSEMAP)||((defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&(defined(SPECULARMAP)||defined(NORMALMAP)))\n#ifdef TILINGOFFSET\nv_Texcoord0=TransformUV(a_Texcoord0,u_TilingOffset);\n#else\nv_Texcoord0=a_Texcoord0;\n#endif\n#endif\nv_Texcoord1=a_Texcoord1;\n#ifdef LIGHTMAP\n#ifdef UV1\nv_LightMapUV=vec2(a_Texcoord1.x,1.0-a_Texcoord1.y)*u_LightmapScaleOffset.xy+u_LightmapScaleOffset.zw;\n#else\nv_LightMapUV=vec2(a_Texcoord0.x,1.0-a_Texcoord0.y)*u_LightmapScaleOffset.xy+u_LightmapScaleOffset.zw;\n#endif\nv_LightMapUV.y=1.0-v_LightMapUV.y;\n#endif\n#if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\nv_Color=a_Color;\n#endif\n#if defined(CALCULATE_SHADOWS)&&!defined(SHADOW_CASCADE)\nv_ShadowCoord=getShadowCoord(vec4(positionWS,1.0));\n#endif\n#if defined(CALCULATE_SPOTSHADOWS)\nv_SpotShadowCoord=u_SpotViewProjectMatrix*vec4(positionWS,1.0);\n#endif\ngl_Position=remapGLPositionZ(gl_Position);}";

    var DressFS = "#if defined(GL_FRAGMENT_PRECISION_HIGH)\nprecision highp float;precision highp int;\n#else\nprecision mediump float;precision mediump int;\n#endif\n#include \"Lighting.glsl\";\n#include \"Shadow.glsl\"\nuniform vec4 u_DiffuseColor;\n#if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\nvarying vec4 v_Color;\n#endif\n#ifdef ALPHATEST\nuniform float u_AlphaTestValue;\n#endif\n#ifdef DIFFUSEMAP\nuniform sampler2D u_DiffuseTexture;\n#endif\n#if defined(DIFFUSEMAP)||((defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT))&&(defined(SPECULARMAP)||defined(NORMALMAP)))\nvarying vec2 v_Texcoord0;\n#endif\nvarying vec2 v_Texcoord1;\n#ifdef LIGHTMAP\nvarying vec2 v_LightMapUV;uniform sampler2D u_LightMap;\n#ifdef LIGHTMAP_DIRECTIONAL\nuniform sampler2D u_LightMapDirection;\n#endif\n#endif\nvarying vec3 v_Normal;\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\nvarying vec3 v_ViewDir;uniform vec3 u_MaterialSpecular;uniform float u_Shininess;\n#ifdef LEGACYSINGLELIGHTING\n#ifdef DIRECTIONLIGHT\nuniform DirectionLight u_DirectionLight;\n#endif\n#ifdef POINTLIGHT\nuniform PointLight u_PointLight;\n#endif\n#ifdef SPOTLIGHT\nuniform SpotLight u_SpotLight;\n#endif\n#else\nuniform mat4 u_View;uniform vec4 u_ProjectionParams;uniform vec4 u_Viewport;uniform int u_DirationLightCount;uniform sampler2D u_LightBuffer;uniform sampler2D u_LightClusterBuffer;\n#endif\n#ifdef SPECULARMAP\nuniform sampler2D u_SpecularTexture;\n#endif\n#endif\n#ifdef NORMALMAP\nuniform sampler2D u_NormalTexture;varying vec3 v_Tangent;varying vec3 v_Binormal;uniform sampler2D u_ControlNormalTexture;\n#endif\nuniform vec3 u_CameraPos;\n#if defined(POINTLIGHT)||defined(SPOTLIGHT)||(defined(CALCULATE_SHADOWS)&&defined(SHADOW_CASCADE))||defined(CALCULATE_SPOTSHADOWS)\nvarying vec3 v_PositionWorld;\n#endif\n#include \"GlobalIllumination.glsl\";\n#if defined(CALCULATE_SHADOWS)&&!defined(SHADOW_CASCADE)\nvarying vec4 v_ShadowCoord;\n#endif\n#if defined(CALCULATE_SPOTSHADOWS)\nvarying vec4 v_SpotShadowCoord;\n#endif\nvarying vec3 v_Color2;void main(){vec3 normal;\n#if defined(NORMALMAP)\nvec3 controlMapSample=texture2D(u_ControlNormalTexture,v_Texcoord0).rgb;if(controlMapSample.r>0.5){normal=normalize(v_Normal);}else{vec3 normalMapSample=texture2D(u_NormalTexture,v_Texcoord0).rgb;normal=normalize(NormalSampleToWorldSpace(normalMapSample,v_Normal,v_Tangent,v_Binormal));}\n#else\nnormal=normalize(v_Normal);\n#endif\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\nvec3 viewDir=normalize(v_ViewDir);\n#endif\nLayaGIInput giInput;\n#ifdef LIGHTMAP\ngiInput.lightmapUV=v_LightMapUV;\n#endif\nvec3 globalDiffuse=layaGIBase(giInput,1.0,normal);vec4 mainColor=u_DiffuseColor;\n#ifdef DIFFUSEMAP\nvec4 difTexColor=texture2D(u_DiffuseTexture,v_Texcoord0);mainColor=mainColor*difTexColor;\n#endif\n#if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\nmainColor=mainColor*v_Color;\n#endif\n#ifdef ALPHATEST\nif(mainColor.a<u_AlphaTestValue)discard;\n#endif\nvec3 diffuse=vec3(0.0);vec3 specular=vec3(0.0);\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\nvec3 dif,spe;\n#ifdef SPECULARMAP\nvec3 gloss=texture2D(u_SpecularTexture,v_Texcoord0).rgb;\n#else\n#ifdef DIFFUSEMAP\nvec3 gloss=vec3(difTexColor.a);\n#else\nvec3 gloss=vec3(1.0);\n#endif\n#endif\n#endif\n#ifdef LEGACYSINGLELIGHTING\n#ifdef DIRECTIONLIGHT\nLayaAirBlinnPhongDiectionLight(u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,u_DirectionLight,dif,spe);\n#if defined(CALCULATE_SHADOWS)\n#ifdef SHADOW_CASCADE\nvec4 shadowCoord=getShadowCoord(vec4(v_PositionWorld,1.0));\n#else\nvec4 shadowCoord=v_ShadowCoord;\n#endif\nfloat shadowAttenuation=sampleShadowmap(shadowCoord);dif*=shadowAttenuation;spe*=shadowAttenuation;\n#endif\ndiffuse+=dif;specular+=spe;\n#endif\n#ifdef POINTLIGHT\nLayaAirBlinnPhongPointLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,u_PointLight,dif,spe);diffuse+=dif;specular+=spe;\n#endif\n#ifdef SPOTLIGHT\nLayaAirBlinnPhongSpotLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,u_SpotLight,dif,spe);\n#if defined(CALCULATE_SPOTSHADOWS)\nvec4 spotShadowcoord=v_SpotShadowCoord;float spotShadowAttenuation=sampleSpotShadowmap(spotShadowcoord);dif*=spotShadowAttenuation;spe*=spotShadowAttenuation;\n#endif\ndiffuse+=dif;specular+=spe;\n#endif\n#else\n#ifdef DIRECTIONLIGHT\nfor(int i=0;i<MAX_LIGHT_COUNT;i++){if(i>=u_DirationLightCount)break;DirectionLight directionLight=getDirectionLight(u_LightBuffer,i);\n#if defined(CALCULATE_SHADOWS)\nif(i==0){\n#ifdef SHADOW_CASCADE\nvec4 shadowCoord=getShadowCoord(vec4(v_PositionWorld,1.0));\n#else\nvec4 shadowCoord=v_ShadowCoord;\n#endif\ndirectionLight.color*=sampleShadowmap(shadowCoord);}\n#endif\nLayaAirBlinnPhongDiectionLight(u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,directionLight,dif,spe);diffuse+=dif;specular+=spe;}\n#endif\n#if defined(POINTLIGHT)||defined(SPOTLIGHT)\nivec4 clusterInfo=getClusterInfo(u_LightClusterBuffer,u_View,u_Viewport,v_PositionWorld,gl_FragCoord,u_ProjectionParams);\n#ifdef POINTLIGHT\nfor(int i=0;i<MAX_LIGHT_COUNT;i++){if(i>=clusterInfo.x)break;PointLight pointLight=getPointLight(u_LightBuffer,u_LightClusterBuffer,clusterInfo,i);LayaAirBlinnPhongPointLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,pointLight,dif,spe);diffuse+=dif;specular+=spe;}\n#endif\n#ifdef SPOTLIGHT\nfor(int i=0;i<MAX_LIGHT_COUNT;i++){if(i>=clusterInfo.y)break;SpotLight spotLight=getSpotLight(u_LightBuffer,u_LightClusterBuffer,clusterInfo,i);\n#if defined(CALCULATE_SPOTSHADOWS)\nif(i==0){vec4 spotShadowcoord=v_SpotShadowCoord;spotLight.color*=sampleSpotShadowmap(spotShadowcoord);}\n#endif\nLayaAirBlinnPhongSpotLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,spotLight,dif,spe);diffuse+=dif;specular+=spe;}\n#endif\n#endif\n#endif\ngl_FragColor=vec4(mainColor.rgb*(globalDiffuse+diffuse),mainColor.a);\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\ngl_FragColor.rgb+=specular;\n#endif\n}";

    class AnimatorTextureMaterial extends Laya.BlinnPhongMaterial {
        constructor() {
            super();
            this.setShaderName("AnimatorTexture");
        }
        setBlendShape(id, value) {
            value = Math.min(1.0, value);
            value = Math.max(0.0, value);
            this._shaderValues.setNumber(AnimatorTextureMaterial['u_blendshape' + id], value);
        }
        set controlTexture(value) {
            this._shaderValues.setTexture(AnimatorTextureMaterial.u_ControlNormalTexture, value);
        }
        get controlTexture() {
            return this._shaderValues.getTexture(AnimatorTextureMaterial.u_ControlNormalTexture);
        }
        set normalTexture(value) {
            if (value) {
                this._shaderValues.addDefine(AnimatorTextureMaterial.DEFINE_NORMALMAP);
            }
            else {
                this._shaderValues.removeDefine(AnimatorTextureMaterial.DEFINE_NORMALMAP);
            }
            this._shaderValues.setTexture(AnimatorTextureMaterial.u_NormalTexture, value);
        }
        get normalTexture() {
            return this._shaderValues.getTexture(AnimatorTextureMaterial.u_NormalTexture);
        }
        getBlendShape(id) {
            return this._shaderValues.getNumber(AnimatorTextureMaterial['u_blendshape' + id]) || 0;
        }
        setMaxblendshape(value) {
            this._shaderValues.setNumber(AnimatorTextureMaterial.u_maxblendshape, value);
        }
        set textureSize(value) {
            this._shaderValues.setVector2(AnimatorTextureMaterial.u_TextureSize, value);
        }
        set vertexCount(value) {
            this._shaderValues.setNumber(AnimatorTextureMaterial.u_VertexCount, value);
        }
        set add(value) {
            this._shaderValues.setNumber(AnimatorTextureMaterial.u_add, value);
        }
        set mul(value) {
            this._shaderValues.setNumber(AnimatorTextureMaterial.u_mul, value);
        }
        set animatorTexture(value) {
            if (value) {
                value.filterMode = Laya.FilterMode.Point;
                this._shaderValues.addDefine(AnimatorTextureMaterial.DEFINE_ANIMATORTEXTURE);
            }
            else {
                this._shaderValues.removeDefine(AnimatorTextureMaterial.DEFINE_ANIMATORTEXTURE);
            }
            this._shaderValues.setTexture(AnimatorTextureMaterial.u_AnimatorTexture, value);
        }
        get animatorTexture() {
            return this._shaderValues.getTexture(AnimatorTextureMaterial.u_AnimatorTexture);
        }
        clone() {
            var dest = new AnimatorTextureMaterial();
            this.cloneTo(dest);
            return dest;
        }
        static init() {
            var attributeMap = {
                'a_Position': Laya.VertexMesh.MESH_POSITION0,
                'a_Color': Laya.VertexMesh.MESH_COLOR0,
                'a_Normal': Laya.VertexMesh.MESH_NORMAL0,
                'a_Texcoord0': Laya.VertexMesh.MESH_TEXTURECOORDINATE0,
                'a_Texcoord1': Laya.VertexMesh.MESH_TEXTURECOORDINATE1,
                'a_BoneWeights': Laya.VertexMesh.MESH_BLENDWEIGHT0,
                'a_BoneIndices': Laya.VertexMesh.MESH_BLENDINDICES0,
                'a_Tangent0': Laya.VertexMesh.MESH_TANGENT0,
                'a_MvpMatrix': Laya.VertexMesh.MESH_MVPMATRIX_ROW0,
                'a_WorldMat': Laya.VertexMesh.MESH_WORLDMATRIX_ROW0
            };
            var uniformMap = {
                'u_Bones': Laya.Shader3D.PERIOD_CUSTOM,
                'u_DiffuseTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_SpecularTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_NormalTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_ControlNormalTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_AlphaTestValue': Laya.Shader3D.PERIOD_MATERIAL,
                'u_DiffuseColor': Laya.Shader3D.PERIOD_MATERIAL,
                'u_MaterialSpecular': Laya.Shader3D.PERIOD_MATERIAL,
                'u_Shininess': Laya.Shader3D.PERIOD_MATERIAL,
                'u_TilingOffset': Laya.Shader3D.PERIOD_MATERIAL,
                'u_WorldMat': Laya.Shader3D.PERIOD_SPRITE,
                'u_MvpMatrix': Laya.Shader3D.PERIOD_SPRITE,
                'u_LightmapScaleOffset': Laya.Shader3D.PERIOD_SPRITE,
                'u_LightMap': Laya.Shader3D.PERIOD_SPRITE,
                'u_LightMapDirection': Laya.Shader3D.PERIOD_SPRITE,
                'u_SimpleAnimatorTexture': Laya.Shader3D.PERIOD_SPRITE,
                'u_SimpleAnimatorParams': Laya.Shader3D.PERIOD_SPRITE,
                'u_SimpleAnimatorTextureSize': Laya.Shader3D.PERIOD_SPRITE,
                'u_CameraPos': Laya.Shader3D.PERIOD_CAMERA,
                'u_Viewport': Laya.Shader3D.PERIOD_CAMERA,
                'u_ProjectionParams': Laya.Shader3D.PERIOD_CAMERA,
                'u_View': Laya.Shader3D.PERIOD_CAMERA,
                'u_ViewProjection': Laya.Shader3D.PERIOD_CAMERA,
                'u_ReflectTexture': Laya.Shader3D.PERIOD_SCENE,
                'u_ReflectIntensity': Laya.Shader3D.PERIOD_SCENE,
                'u_Time': Laya.Shader3D.PERIOD_SCENE,
                'u_AnimatorTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_TextureSize': Laya.Shader3D.PERIOD_MATERIAL,
                'u_VertexCount': Laya.Shader3D.PERIOD_MATERIAL,
                'u_add': Laya.Shader3D.PERIOD_MATERIAL,
                'u_mul': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape0': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape1': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape2': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape3': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape4': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape5': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape6': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape7': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape8': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape9': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape10': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape11': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape12': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape13': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape14': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape15': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape16': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape17': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape18': Laya.Shader3D.PERIOD_MATERIAL,
                'u_blendshape19': Laya.Shader3D.PERIOD_MATERIAL,
                'u_maxblendshape': Laya.Shader3D.PERIOD_MATERIAL,
                'u_DirationLightCount': Laya.Shader3D.PERIOD_SCENE,
                'u_LightBuffer': Laya.Shader3D.PERIOD_SCENE,
                'u_LightClusterBuffer': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientColor': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowBias': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowLightDirection': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowMap': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowParams': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowSplitSpheres': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowMatrices': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowMapSize': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotShadowMap': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotViewProjectMatrix': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowLightPosition': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHAr': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHAg': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHAb': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHBr': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHBg': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHBb': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHC': Laya.Shader3D.PERIOD_SCENE,
                'u_DirectionLight.color': Laya.Shader3D.PERIOD_SCENE,
                'u_DirectionLight.direction': Laya.Shader3D.PERIOD_SCENE,
                'u_PointLight.position': Laya.Shader3D.PERIOD_SCENE,
                'u_PointLight.range': Laya.Shader3D.PERIOD_SCENE,
                'u_PointLight.color': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.position': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.direction': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.range': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.spot': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.color': Laya.Shader3D.PERIOD_SCENE,
                'u_OutlineWidth': Laya.Shader3D.PERIOD_MATERIAL,
                'u_OutlineLightness': Laya.Shader3D.PERIOD_MATERIAL,
                'u_OutlineColor': Laya.Shader3D.PERIOD_MATERIAL
            };
            var stateMap = {
                's_Cull': Laya.Shader3D.RENDER_STATE_CULL,
                's_Blend': Laya.Shader3D.RENDER_STATE_BLEND,
                's_BlendSrc': Laya.Shader3D.RENDER_STATE_BLEND_SRC,
                's_BlendDst': Laya.Shader3D.RENDER_STATE_BLEND_DST,
                's_DepthTest': Laya.Shader3D.RENDER_STATE_DEPTH_TEST,
                's_DepthWrite': Laya.Shader3D.RENDER_STATE_DEPTH_WRITE
            };
            var shader = Laya.Shader3D.add("AnimatorTexture");
            var subShader = new Laya.SubShader(attributeMap, uniformMap);
            shader.addSubShader(subShader);
            subShader.addShaderPass(DressVS, DressFS, stateMap, "Forward");
        }
    }
    AnimatorTextureMaterial.u_AnimatorTexture = Laya.Shader3D.propertyNameToID("u_AnimatorTexture");
    AnimatorTextureMaterial.u_TextureSize = Laya.Shader3D.propertyNameToID("u_TextureSize");
    AnimatorTextureMaterial.u_VertexCount = Laya.Shader3D.propertyNameToID("u_VertexCount");
    AnimatorTextureMaterial.u_add = Laya.Shader3D.propertyNameToID("u_add");
    AnimatorTextureMaterial.u_mul = Laya.Shader3D.propertyNameToID("u_mul");
    AnimatorTextureMaterial.u_blendshape0 = Laya.Shader3D.propertyNameToID("u_blendshape0");
    AnimatorTextureMaterial.u_blendshape1 = Laya.Shader3D.propertyNameToID("u_blendshape1");
    AnimatorTextureMaterial.u_blendshape2 = Laya.Shader3D.propertyNameToID("u_blendshape2");
    AnimatorTextureMaterial.u_blendshape3 = Laya.Shader3D.propertyNameToID("u_blendshape3");
    AnimatorTextureMaterial.u_blendshape4 = Laya.Shader3D.propertyNameToID("u_blendshape4");
    AnimatorTextureMaterial.u_blendshape5 = Laya.Shader3D.propertyNameToID("u_blendshape5");
    AnimatorTextureMaterial.u_blendshape6 = Laya.Shader3D.propertyNameToID("u_blendshape6");
    AnimatorTextureMaterial.u_blendshape7 = Laya.Shader3D.propertyNameToID("u_blendshape7");
    AnimatorTextureMaterial.u_blendshape8 = Laya.Shader3D.propertyNameToID("u_blendshape8");
    AnimatorTextureMaterial.u_blendshape9 = Laya.Shader3D.propertyNameToID("u_blendshape9");
    AnimatorTextureMaterial.u_blendshape10 = Laya.Shader3D.propertyNameToID("u_blendshape10");
    AnimatorTextureMaterial.u_blendshape11 = Laya.Shader3D.propertyNameToID("u_blendshape11");
    AnimatorTextureMaterial.u_blendshape12 = Laya.Shader3D.propertyNameToID("u_blendshape12");
    AnimatorTextureMaterial.u_blendshape13 = Laya.Shader3D.propertyNameToID("u_blendshape13");
    AnimatorTextureMaterial.u_blendshape14 = Laya.Shader3D.propertyNameToID("u_blendshape14");
    AnimatorTextureMaterial.u_blendshape15 = Laya.Shader3D.propertyNameToID("u_blendshape15");
    AnimatorTextureMaterial.u_blendshape16 = Laya.Shader3D.propertyNameToID("u_blendshape16");
    AnimatorTextureMaterial.u_blendshape17 = Laya.Shader3D.propertyNameToID("u_blendshape17");
    AnimatorTextureMaterial.u_blendshape18 = Laya.Shader3D.propertyNameToID("u_blendshape18");
    AnimatorTextureMaterial.u_blendshape19 = Laya.Shader3D.propertyNameToID("u_blendshape19");
    AnimatorTextureMaterial.u_ControlNormalTexture = Laya.Shader3D.propertyNameToID("u_ControlNormalTexture");
    AnimatorTextureMaterial.u_NormalTexture = Laya.Shader3D.propertyNameToID("u_NormalTexture");
    AnimatorTextureMaterial.u_maxblendshape = Laya.Shader3D.propertyNameToID("u_maxblendshape");
    AnimatorTextureMaterial.DEFINE_ANIMATORTEXTURE = Laya.Shader3D.getDefineByName("ANIMATORTEXTURE");
    AnimatorTextureMaterial.DEFINE_NORMALMAP = Laya.Shader3D.getDefineByName("NORMALMAP");

    class UIGrow extends UIBase {
        constructor() {
            super(...arguments);
            this.c_loader_icon = null;
            this.c_progress_grow = null;
            this.isUp = false;
            this.aimValue = 0;
            this.Mat = null;
        }
        onCreate() { }
        onOpen() {
            UIMgr.instance.closeUI(ModuleType.Loading);
            this._scene3D = new SceneShow3D();
            this._scene3D.setRenderTexture(this.c_loader_icon.displayObject);
            this.LoadRes();
            this.c_progress_grow.value = 0;
            this.AddEvent();
        }
        AddEvent() {
            this.on(Laya.Event.MOUSE_DOWN, this, this.AddSource);
        }
        onUpdate() {
            this._scene3D.playerNode.transform.localRotationEulerY += 1;
            this.c_progress_grow.value += (this.aimValue - this.c_progress_grow.value) * 0.02;
            if (this.c_progress_grow.value >= 99) {
                this.isUp = true;
                this.EnterGame();
            }
            if (this.Mat) {
                let value = (100 - this.c_progress_grow.value) / 100;
                this.Mat.setBlendShape(7, value);
                if (value > 0.5) {
                    this.Mat.renderMode = Laya.BlinnPhongMaterial.RENDERMODE_TRANSPARENT;
                }
                else {
                    this.Mat.renderMode = Laya.BlinnPhongMaterial.RENDERMODE_OPAQUE;
                }
            }
        }
        onClose() {
            this.off(Laya.Event.MOUSE_DOWN, this, this.AddSource);
        }
        AddSource() {
            if (this.isUp)
                return;
            this.aimValue += 5;
            if (this.aimValue > 100)
                this.aimValue = 100;
        }
        EnterGame() {
            this.closeUI();
        }
        LoadRes() {
            let self = this;
            Laya.loader.load("res/textures/GOLDEN RETREIVER_Mesh.json", Laya.Handler.create(self, function (jsonRes) {
                ResourcesMgr$1.instance.load(RescoureData.getPreFromPrefabs("LittleDog"), function (res) {
                    self.AddLittleDog(res.clone(), jsonRes);
                });
            }), null, Laya.Loader.JSON);
        }
        AddLittleDog(tnode, meshcfg) {
            let node = tnode.getChildAt(0);
            console.log(meshcfg);
            this.Mat = new AnimatorTextureMaterial();
            this.Mat.textureSize = new Laya.Vector2(meshcfg.width, meshcfg.width);
            this.Mat.vertexCount = meshcfg.verCount;
            this.Mat.add = new Laya.Vector3(meshcfg.add.x, meshcfg.add.y, meshcfg.add.z);
            this.Mat.mul = new Laya.Vector3(meshcfg.mul.x, meshcfg.mul.y, meshcfg.mul.z);
            this.Mat.setMaxblendshape(meshcfg.blendShapes);
            node.meshRenderer.material.cloneTo(this.Mat);
            Laya.loader.create("res/textures/GOLDEN RETREIVER_Mesh.png", Laya.Handler.create(this, (tex) => {
                this.Mat.animatorTexture = tex;
            }));
            node.meshRenderer.material = this.Mat;
            this.Mat.setBlendShape(7, 1);
            this._scene3D.playerNode.addChild(tnode);
            tnode.transform.position = new Laya.Vector3(0.4, -0.5, 0);
            tnode.transform.localScale = new Laya.Vector3(20, 20, 20);
            window["t"] = this.Mat;
        }
    }

    class Game extends UIBase {
        constructor() {
            super();
            this.ConfigUI = new ConfigUI({
                event_refresh_gold_node: "text_cur_gold_count",
            });
            this.GameScale = 1;
            this.c_comp_gameNode = null;
            Game._Int = this;
        }
        static get Int() {
            return this._Int;
        }
        AddItem(item) {
            this.c_comp_gameNode.addChild(item);
        }
        AddPlayer(item) {
            this.addChild(item);
        }
        onConstruct() {
            super.onConstruct();
        }
        onCreate() { }
        onOpen() {
            this.GameScale = 32.5 / 9 - Laya.Browser.width / Laya.Browser.height;
            this.c_comp_gameNode.scaleX = this.GameScale;
            this.c_comp_gameNode.scaleY = this.GameScale;
            if (this.openData) {
                this.openData[0].run();
            }
        }
        onUpdate() {
        }
        onClose() { }
    }

    class UITishi extends UIBase {
        constructor() {
            super(...arguments);
            this.c_comp_tishi1 = null;
            this.c_comp_tishi2 = null;
            this.c_comp_tishi3 = null;
            this.isMust = 0;
            this._suiPian = 1;
        }
        onOpen() {
            let s = GameData.getConfigDataItem("SkinFragments");
            this._suiPian = s || 1;
            console.warn("打开答案提示界面");
            this.isMust = 0;
            if (this.openData) {
                this.isMust = this.openData;
            }
            this.InitTips();
            this.updateBtn();
        }
        updateBtn() {
            this.c_comp_tishi1.getChild("btn_chakantishi").asCom.getChild("n12").text = this._suiPian.toString();
            this.c_comp_tishi1.getChild("btn_chakandaan").asCom.getChild("n12").text = this._suiPian.toString();
            this.c_comp_tishi2.getChild("btn_chakandaan").asCom.getChild("n12").text = this._suiPian.toString();
        }
        InitTips() {
        }
        CloseTishi() {
        }
        UpdateLevel() {
        }
        AddTipsLevel() {
        }
    }

    class UIZahuodian extends UIBase {
        constructor() {
            super(...arguments);
            this.c_comp_xianshi1 = null;
            this.c_comp_xianshi2 = null;
            this.c_comp_xianshi3 = null;
            this.goodsArr = [];
        }
        onOpen() {
            this.goodsArr = this.openData;
            this.c_comp_xianshi1.onClick(this, this.ClickGoods, [0]);
            this.c_comp_xianshi2.onClick(this, this.ClickGoods, [1]);
            this.c_comp_xianshi3.onClick(this, this.ClickGoods, [2]);
            this.InitGoods();
        }
        InitGoods() {
            for (let index = 1; index <= 3; index++) {
                const element = this["c_comp_xianshi" + index];
                if (index <= this.goodsArr.length) {
                    element.visible = true;
                    element.touchable = true;
                    let data = GameData.getGoodsItem(this.goodsArr[index - 1]);
                    let btn_anniu = element.getChild("btn_anniu").asButton;
                    let btn_xianshi = element.getChild("btn_xianshi").asButton;
                    btn_anniu.visible = true;
                    if (data.UnLockType[0] == 1) {
                        btn_anniu.title = data.UnLockValue.toString();
                    }
                    else {
                        btn_anniu.getControllerAt(0).selectedIndex = 2;
                    }
                    element.getChild("n5").getControllerAt(0).selectedIndex = data.NameID;
                    btn_xianshi.icon = UIMgr.instance.iconUrl(data.IconUrl);
                    btn_xianshi.getControllerAt(0).selectedIndex = 0;
                }
                else {
                    element.visible = false;
                }
            }
        }
        ClickGoods(index) {
            const element = this["c_comp_xianshi" + (index + 1)];
            let goodsdata = GameData.getGoodsItem(this.goodsArr[index]);
            AudioMgr$1.instance.play_sound(8);
            let btn_anniu = element.getChild("btn_anniu").asButton;
            if (btn_anniu.getControllerAt(0).selectedIndex == 2) {
                GameSDK$1.showADVideo(this, (b) => {
                    if (b) {
                        LogicData.instance.AddUnlockgoods(goodsdata.Id);
                        element.touchable = false;
                        element.getChild("btn_xianshi").asCom.getControllerAt(0).selectedIndex = 1;
                        element.getChild("btn_anniu").asCom.visible = false;
                    }
                }, "皮肤商城获取钞票");
            }
            else {
                let goldNum = LogicProp.instance.get(EPropNameById.diamonds);
                let needGold = goodsdata.UnLockValue[0];
                if (needGold <= goldNum) {
                    LogicProp.instance.add(EPropNameById.diamonds, -needGold);
                    LogicData.instance.AddUnlockgoods(goodsdata.Id);
                    element.touchable = false;
                    element.getChild("btn_xianshi").asCom.getControllerAt(0).selectedIndex = 1;
                    element.getChild("btn_anniu").asCom.visible = false;
                }
                else {
                    TipMgr.Int.showTips("钞票不足");
                }
            }
        }
        click_fnhui() {
            this.closeUI();
        }
    }

    class UIFreeVideo extends UIBase {
        constructor() {
            super(...arguments);
            this.c_btn_freeVideo = null;
            this.c_text_freeTimes = null;
        }
        onOpen() {
            this.UpdateTimes();
        }
        click_fnhui() {
            this.closeUI();
        }
        click_freeVideo() {
            GameSDK$1.showADVideo(this, (b) => {
                if (b) {
                    LogicData.instance.AddFreeBackVideo();
                    this.UpdateTimes();
                }
            }, "免广告视频");
        }
        UpdateTimes() {
            let t = LogicData.instance.FreeBackVideo;
            if (t >= 2) {
                LogicData.instance.setFreeDayVideo(new Date().getTime());
                this.c_btn_freeVideo.visible = false;
                this.closeUI();
                return;
            }
            else {
                this.c_btn_freeVideo.visible = true;
            }
            this.c_text_freeTimes.text = t + "/2";
        }
    }

    class UIFreeBackVideo extends UIBase {
        constructor() {
            super(...arguments);
            this.c_comp_mianguanggao = null;
            this.c_btn_freeVideo = null;
            this.c_text_freeTimes = null;
        }
        onOpen() {
            this.c_comp_mianguanggao.getController("c1").selectedIndex = 1;
            this.UpdateTimes();
        }
        click_fnhui() {
            this.closeUI();
        }
        click_freeVideo() {
            GameSDK$1.showADVideo(this, (b) => {
                if (b) {
                    LogicData.instance.AddFreeBackVideo();
                    this.UpdateTimes();
                }
            }, "免广告视频");
        }
        click_jujue() {
            this.closeUI();
        }
        UpdateTimes() {
            let t = LogicData.instance.FreeBackVideo;
            if (t >= 2) {
                LogicData.instance.setFreeDayVideo(new Date().getTime());
                this.c_btn_freeVideo.visible = false;
                this.closeUI();
                return;
            }
            else {
                this.c_btn_freeVideo.visible = true;
            }
            this.c_text_freeTimes.text = t + "/2";
        }
    }

    class UIQiehuan extends UIBase {
        constructor() {
            super(...arguments);
            this.ConfigUI = new ConfigUI({
                event_refresh_gold_node: "text_cur_gold_count",
            });
            this.c_comp_fandian1 = null;
            this.c_comp_fandian2 = null;
            this.c_comp_fandian3 = null;
            this.c_comp_fandian4 = null;
        }
        onOpen() {
            console.log("打开切换餐厅界面");
            this.c_comp_fandian1.InitItem(1);
            this.c_comp_fandian2.InitItem(2);
            this.c_comp_fandian3.InitItem(3);
            this.c_comp_fandian4.InitItem(4);
        }
        onClose() {
        }
    }

    class QiehuanItem extends FguiBase$3 {
        constructor() {
            super();
            this.c_btn_qianwang = null;
            this.tIndex = 0;
        }
        onConstruct() {
            super.onConstruct();
            FguiBase$3.match_children_to_member(this, this);
        }
        InitItem(index) {
            this.c_btn_qianwang.offClick(this, this.ClickTo);
            this.c_btn_qianwang.onClick(this, this.ClickTo);
            if (index < 3) {
                if (CanteenMgr.Int.StageId == index) {
                    this.controllerOnce.selectedIndex = 1;
                }
                else {
                    this.controllerOnce.selectedIndex = 0;
                }
            }
            else {
                this.controllerOnce.selectedIndex = 2;
            }
        }
        onDispose() {
            this.c_btn_qianwang.onClick(this, this.ClickTo);
        }
        ClickTo() {
            CanteenMgr.Int.ChangeStage();
        }
    }

    class ZhiyinTip extends FguiBase$3 {
        constructor() {
            super();
            this.isShow = true;
            this.c1 = null;
            this.c_loader_tubiao = null;
            this.tipId = 0;
        }
        onConstruct() {
            super.onConstruct();
            FguiBase$3.match_children_to_member(this, this);
        }
        InitPic(id) {
            this.tipId = id;
            this.c_loader_tubiao.url = UIMgr.instance.iconUrl("img_zhishi" + id, "main");
        }
        Hide() {
            if (!this.isShow)
                return;
            this.visible = false;
            this.isShow = false;
        }
        Show() {
            if (this.isShow)
                return;
            this.visible = true;
            this.isShow = true;
        }
        updatePos(x, y, p, o = false) {
            if (!this.isShow)
                return;
            this.controllerOnce.selectedIndex = p;
            if (this.tipId > 2) {
                if (o) {
                    this.visible = true;
                }
                else {
                    this.visible = false;
                }
            }
            if (p == 1) {
                this.x = x;
                this.y = y - 80;
            }
            else {
                this.x = x;
                this.y = y;
            }
            this.scaleX = this.scaleY = 0.8;
        }
        Reset() {
            this.removeFromParent();
        }
    }

    class UIFreeMoney extends UIBase {
        constructor() {
            super(...arguments);
            this.c_text_gold = null;
            this._taolu = false;
        }
        onOpen() {
            GameSDK$1.showBanner();
            this.c_text_gold.text = "" + this.openData;
            this._exchangeBtn = UIMgr.instance.exchangeBtn(this.getChild("btn_close"), this.getChild("btn_ad"));
            EventMgr$1.Int.emit(EventType$1.TEMP_HIDE_AD);
            this._taolu = false;
            if (GameSDK$1.isAdUser()) ;
            if (this._taolu) {
                this.getController("c1").selectedIndex = 0;
                Laya.timer.once((+GameSDK$1.data.BannerMoveShow || 0) * 1000, this, () => {
                });
                Laya.timer.once((+GameSDK$1.data.BannerMoveChange || 0) * 1000, this, () => {
                    this._taolu = false;
                    this.getController("c1").selectedIndex = 1;
                });
            }
            else {
                this.getController("c1").selectedIndex = 1;
            }
        }
        onClose() {
            if (this._exchangeBtn) {
                UIMgr.instance.exchangeBtn(this.getChild("btn_close"), this.getChild("btn_ad"), true);
            }
            GameSDK$1.hideBanner();
            GameSDK$1.resetBanner();
            EventMgr$1.Int.emit(EventType$1.RESUME_AD);
        }
        click_ad() {
            GameSDK$1.showADVideo(this, s => {
                if (s) {
                    LogicProp.instance.add(EPropNameById.diamonds, this.openData || 0);
                    UIMgr.instance.closeUI(ModuleType.FreeMoney);
                }
            }, "免费补给视频");
        }
        click_close() {
            if (this._taolu)
                return;
            super.click_close();
        }
    }

    class CompMoney extends FguiBase$3 {
        onConstruct() {
            super.onConstruct();
            this.touchable = false;
            FguiBase$3.match_children_to_member(this, this);
        }
        RandomPos() {
            this.x = -Math.random() * 300 - 100;
            this.y = Math.random() * 200 + 600;
            this.FlyTo();
        }
        onDispose() {
            Laya.Tween.clearAll(this);
        }
        FlyTo() {
            Laya.Tween.to(this, { x: 0, y: 0 }, 500, Laya.Ease.backIn, Laya.Handler.create(this, this.Clear));
        }
        Clear() {
            this.dispose();
        }
    }

    class UIOffline extends UIBase {
        constructor() {
            super(...arguments);
            this.rewardNum = 0;
            this.c_text_gold = null;
            this._taolu = false;
        }
        onOpen() {
            GameSDK$1.showBanner();
            this.rewardNum = this.openData;
            this.c_text_gold.text = this.rewardNum.toString();
            EventMgr$1.Int.emit(EventType$1.TEMP_HIDE_AD);
            this._taolu = false;
            if (GameSDK$1.isAdUser()) ;
            if (this._taolu) {
                this.getController("c1").selectedIndex = 0;
                Laya.timer.once(1200, this, () => {
                });
                Laya.timer.once(1500, this, () => {
                    this._taolu = false;
                    this.getController("c1").selectedIndex = 1;
                });
            }
            else {
                this.getController("c1").selectedIndex = 1;
            }
        }
        onClose() {
            GameSDK$1.hideBanner();
            GameSDK$1.resetBanner();
            EventMgr$1.Int.emit(EventType$1.RESUME_AD);
        }
        click_ad() {
            GameSDK$1.showADVideo(this, (b) => {
                if (b) {
                    this.GetReward(3);
                    this.closeUI();
                }
            }, "离线奖励");
        }
        click_close() {
            if (this._taolu)
                return;
            this.GetReward();
            super.click_close();
        }
        GetReward(bs = 1) {
            LogicProp.instance.add(EPropNameById.diamonds, this.rewardNum * bs, true);
        }
    }

    class UIInvate extends UIBase {
        constructor() {
            super(...arguments);
            this.c_comp_touxiang1 = null;
            this.c_comp_touxiang2 = null;
        }
        onOpen() {
            if (this.openData < 2) {
                this.c_comp_touxiang2.onClick(this, this.click_yaoqing);
            }
            if (this.openData < 1) {
                this.c_comp_touxiang1.onClick(this, this.click_yaoqing);
            }
            this.c_comp_touxiang1.getController("c1").selectedIndex = this.openData > 0 ? 1 : 0;
            this.c_comp_touxiang2.getController("c1").selectedIndex = this.openData > 1 ? 1 : 0;
        }
        onClose() {
            this.c_comp_touxiang2.offClick(this, this.click_yaoqing);
            this.c_comp_touxiang1.offClick(this, this.click_yaoqing);
        }
        click_fanhui() {
            super.click_close();
        }
        click_yaoqing() {
            GameSDK$1.shareMsg(this, s => {
            }, "邀请好友");
        }
        click_ad() {
            GameSDK$1.showADVideo(this, s => {
                if (s) {
                    CanteenMgr.Int.Player.TakeCar(30 * 60 * 1000);
                    super.click_close();
                }
            }, "邀请界面试用视频");
        }
    }

    class BigMoneyTip extends FguiBase$3 {
        constructor() {
            super();
            this.isShow = true;
            this.c_text_money = null;
        }
        onConstruct() {
            super.onConstruct();
            FguiBase$3.match_children_to_member(this, this);
        }
        InitNum(num) {
            this.c_text_money.text = "+" + num.toString();
        }
        Hide() {
            if (!this.isShow)
                return;
            this.visible = false;
            this.isShow = false;
        }
        Show() {
            if (this.isShow)
                return;
            this.visible = true;
            this.isShow = true;
        }
        updatePos(x, y, out) {
            if (!this.isShow)
                return;
            if (out) {
                this.visible = false;
            }
            else {
                this.visible = true;
            }
            this.x = x;
            this.y = y - 80;
            this.scaleX = this.scaleY = 0.8;
        }
        Reset() {
            this.removeFromParent();
        }
    }

    class UIyinsi2 extends UIBase$1 {
        onOpen() {
        }
        click_jixu() {
            UIMgr.instance.closeUI("UIyinsi1");
            UIMgr.instance.closeUI("UIyinsi2");
            Laya.LocalStorage.setItem("firstXieyi", "1");
        }
        click_tuichu() {
            let obj = {};
            qg.exitApplication(obj);
        }
        click_yinsizhengce() {
            UIMgr.instance.openUI("UIwendang", 1);
        }
        click_fuwuxieyi() {
            UIMgr.instance.openUI("UIwendang", 2);
        }
    }

    class UIwendang extends UIBase$1 {
        constructor() {
            super(...arguments);
            this.c_text_wenan = null;
            this.c_loader_biaoti = null;
        }
        onCreate() {
        }
        onOpen() {
            if (this.openData == 1) {
                this.c_text_wenan.text = "重庆乐义多科技有限公司隐私政策\n前言\n生效时间：2021年11月16日\n更新时间：2022年1月10日\n重庆乐义多科技有限公司产品与/或服务是由重庆乐义多科技有限公司（以下简称\“我们\”）为用户（以下简称\“您\”）提供的休闲娱乐产品与/或服务，包括但不限于\"重庆乐义多科技有限公司\"应用，详见关键词定义），以及我们不时为您提供的其他产品与/或服务。我们根据《中华人民共和国网络安全法》相关法律法规并参考《信息安全技术个人信息安全规范》（GB/T-35273），以及其他相关法律法规制定《重庆乐义多科技有限公司隐私政策》（以下简称\“本政策\”）并保护您的个人信息安全。所有重庆乐义多科技有限公司产品与或服务均适用本政策。重庆乐义多科技有限公司产品与/或服务的适用对象为\“通过平台验证/授权的用户\”。对于儿童，必须由其监护人阅读本政策并同意本政策的全部内容后，我们方才向该儿童提供重庆乐义多科技有限公司产品与/或服务。本政策介绍了我们向您提供重庆乐义多科技有限公司产品与/或服务过程中收集、使用、存储、委托处理、共享、转让、公开批露您个人信息的目的、方式、范围和信息安全保护措施，以及我们为您提供的访问、更新、删除等控制个人信息的权利和方法。请您结合我们的《重庆乐义多科技有限公司用户服务协议》阅读本政策。以下是我们的特别提示，请您重点关注：\n1.对所有重点内容，我们采用\“加粗\”的书写方式进行提示。\n2.对个人敏感信息，我们用\“加粗斜体\” 的书写方式进行特别提醒，希望您在阅读时特别关注。在您向我们提供您的任何个人敏感信息前，您已慎重考虑并在此确认该等提供是适当的，您在此同意您个人敏感信息可按照本政策所述的目的和方式进行处理。\n3.我们尤其重视对个人信息的保护。我们将遵循正当必要、知情同意、目的明确、安全保障、依法利用的原则，收集、使用、存储、委托处理、共享、转让、公开披露您的个人信息。根据中国法律法规，您确认并承诺您是使用重庆乐义多科技有限公司产品与/ 或服务的儿童的监护人，或者已满 18 周岁的成年用户。\n4.我们会严格依据本政策以及您的同意处理您的个人信息。如您不同意本政策，您应当停止使用重庆乐义多科技有限公司产品与 / 或服务。\n目录\n1.我们会获取哪些信息，作用用途说明\n2.如何使用 Cookie\n3.如何使用第三方 SDK 数据\n4.关于数据的跨境传输\n5.如何委托处理、共享、转让、公开披露您的个人信息\n6.您如何管理您的个人信息\n7.如何保护您的个人信息\n8.如何存储您的个人信息\n9.如何更新本政策\n10.如何联系我们\n11.附则\n12.关键词定义\n1. 我们会获取哪些信息，作用用途说明\n我们会根据合法正当、必要、透明的原则，基于本政策所述的目的，收集和使用您的个人信息。如果我们将您的个人信息用于本政策未载明的其它用途，或基于其他特定目的而收集您的个人信息，我们将以合理的方式告知您，并在使用前再次征得您的同意。\n1.1向您提供产品与/或服务过程中我们主动收集的个人信息\n在符合法律法规前提下，为了更好地为您提供优质的服务，我们会收集和使用您在使用重庆乐义多科技有限公司产品与/或服务过程中产生的如下信息：\n1.1.1设备信息\n当您使用\"重庆乐义多科技有限公司\"应用或应用切换到后台时，我们会收集您的设备信息，包括浏览器类型、运营商信息和使用情况、设备的相关信息（IP地址）、设备型号、操作系统版本号、AndoridID（仅限安卓）。这些信息是设备的唯一标识，我们可能会将这些信息进行关联，以便我们能够为您提供一致的服务。为免疑义，我们可能采集您设备的Mac地址、IMEI号上传到我们的服务器，仅用于产品BUG的实时排查和定位，监控产品稳定性。\n当您使用我们的软件时，我们可能会根据您在软件安装及使用中的具体权限，接收并记录您的相关设备信息，包括设备型号、唯一设备标识符、操作系统信息，以便我们为您提供一致的服务。\n1.1.2位置信息\n当您使用\"重庆乐义多科技有限公司\"应用时，我们使用的友盟sdk会自动收集您在使用\"重庆乐义多科技有限公司\"应用时的位置信息，友盟sdk收集位置信息，为开发者提供反舞弊功能，剔除作弊设备；同时校正用户的地域分布数据，使报表数据更加准确。\n1.1.3日志信息\n当您使用\"重庆乐义多科技有限公司\"应用时，我们会自动收集您在使用\"重庆乐义多科技有限公司\"应用时的详细情况并作为网络日志进行保存，包括浏览器类型、浏览记录、网络诊断、卡顿信息、点击事件、关卡成功或失败情况，以便我们统计\"重庆乐义多科技有限公司\"应用的使用情况，优化\"重庆乐义多科技有限公司\"应用，为您提供更好的服务体验。\n当您使用我们的软件时，我们会自动收集您使用的详细情况，并作为网络日志进行保存，包括您IP地址、浏览器类型、浏览记录，以便我们统计官网的使用情况，为您提供更好的体验和服务。\n1.1.4设备权限调用汇总\n我们在提供服务过程中，会调用您的主要设备权限汇总如下：\n权限名\n权限功能说明\n使用场景或目的\nINTERNET\n访问网络的权限\n请求广告,上报应用错误log时需要连接网络\nACCESS_NETWORK_STATE\n获取网络信息状态\n请求配置和广告时需要判断网络链接是否有效\nREAD_LOGS\n读取系统日志文件\nAPP出现错误或异常退出时需要上传日志\nACCESS_WIFI_STATE\n获取 WIFI 状态\n在下载应用、播放音频时，我们需要访问您的WIFI状态，我们将根据是否连接WiFi，来确定本应用、音频等资源加载方式，以优化您的使用体验。\nREAD_PHONE_STATE\n读取手机状态和身份：提供读取手机设备标识等信息\n读取设备通话状态和识别码，识别手机设备ID，用于信息展示、账号登录、安全保障等主要功能\nREAD_EXTERNAL_STORAGE\n读取SD上的内容：提供读取手机储存空间内数据的功能\n读取已下载的本应用文件,读取应用储存数据\nWRITE_EXTERNAL_STORAGE\n修改/删除SD卡中的内容：提供写入外部储存功能\n保存存储下载的本应用文件,保存应用使用数据\nREQUEST_INSTALL_PACKAGES\n允许安装第三方应用\n广告sdk会在用户同意后安装第三方app\nWAKE_LOCK\n屏幕常亮\n在播放激励视频广告时需要保持屏幕常亮，以免黑屏\nQUERY_ALL_PACKAGES\n读取已安装应用列表\n当用户点击广告后，sdk需要读取已安装应用列表判断是安装应用还是打开应用。\n详细内容请访问《权限使用说明》。您可以在设备的设置功能中选择关闭部分或全部权限。在不同设备中，权限显示方式及关闭方式可能有所不同，若您是安卓机型，您需要在手机【设置】-【应用设置】-【应用权限管理】中，选择本应用，并关闭您需要撤回的权限/信息。具体请参考设备及系统开发方说明或指引。\n1.2我们从第三方获取的您的个人信息\n1.2.1我们可能会在您的同意范围内从第三方（我们的合作方）处收集并使用您的个人信息。我们保证依照与第三方签订的合同以及相关法律规定处理您的个人信息，同时请您详细阅读该第三方的隐私政策/个人信息保护政策及用户协议。如您拒绝第三方在提供服务时收集、使用或者传递您的个人信息，将可能导致您无法使用重庆乐义多科技有限公司产品与/或服务。\n1.2.2第三方登录：当您使用第三方账号（包括微信、QQ、华为、OPPO账号、vivo账号等其他渠道）登录时，可选择授权我们读取并获得您在该第三方平台上公开的信息。当您使用微信账号等第三方账号登录时，第三方账号将与我们共享您的信息详情见此处。获取上述信息是为了记住您作为重庆乐义多科技有限公司用户的登录身份，以便向您提供更优质的产品与/或服务，并且我们仅会在您同意的范围内使用此类信息。当您使用第三方账号注册或登录后，您的第三方账号会与重庆乐义多科技有限公司账号进行绑定。\n1.3征得同意的例外\n根据法律法规，以下情形中收集和使用您的个人信息无需征得您的同意：\n1.3.1与履行法律法规规定的义务相关的；\n1.3.2与国家安全、国防安全直接相关的；\n1.3.3与公共安全、公共卫生、重大公共利益直接相关的；\n1.3.4与犯罪侦查、起诉、审判和判决执行等直接相关的；\n1.3.5出于维护您或其他用户的生命、财产等重大合法权益相关但又很难得到本人同意的；\n1.3.6所涉及的个人信息是您自行向社会公众公开的；\n1.3.7根据您要求签订和履行合同所必需的；\n1.3.8从合法公开披露的信息中收集个人信息的，如合法的新闻报道、政府信息公开等渠道；\n1.3.9维护所提供的重庆乐义多科技有限公司产品与/或服务的安全稳定运行所必需的，例如发现、处置重庆乐义多科技有限公司产品与/或服务的故障；\n1.3.10法律法规规定的其他情形。\n2. 如何使用 Cookie\n2.1Cookie\n当您使用重庆乐义多科技有限公司产品与/或服务时，我们会在您的计算机或移动设备上存储名为Cookie的小型数据文件，通常包含标识符、站点名称以及一些号码和字符。当您登录账号时，借助于Cookie，我们可以在您和使用重庆乐义多科技有限公司产品与/或服务时识别您是否属于我们的用户；还可以实现直接从一个页面跳转到另一个页面，而不必在每个页面上重新登录。\n2.2如何使用Cookie\n我们使用该等信息判断用户是否已经登录、提升服务/产品质量及优化用户体验。我们不会将Cookie用于本政策所述目的之外的任何其他用途。\n2.3如何管理追踪技术\n在网页端，我们不会将上述追踪技术用于本政策所述目的之外的任何用途。您可根据自己的偏好管理或删除某些类别的追踪技术。有关详情，请参见。另外，很多网络浏览器均设有\“禁止追踪\”（DoNotTrack）功能，该功能可向网站发布\“禁止追踪\”的请求。如果您的浏览器启用了\“禁止追踪\”功能，我们的所有网站都会尊重您的选择。如需详细了解如何更改浏览器设置，请访问相关链接。\n当您在非登陆状态下浏览页面时，为向您提供相应服务，我们会收集实现浏览功能所必需收集Cookie信息，但会在一个月内删除这些Cookie信息。\n请您知悉，倘若您拒绝使用或清除已有的追踪技术，则需要在每一次访问时亲自更改用户设置，并且，我们可能无法向您提供更加优质的使用体验，部分服务亦可能会无法正常运作。\n3. 如何使用第三方 SDK 数据\n3.1 我们的应用集成BuglySDK，为了更真实地为开发者还原Crash场景服务的，并不涉及用户隐私信息：\nCrash环境：Crash信息及线程堆栈，ROM/RAM/SD卡容量、网络/语言等状态。\nApp信息：包名、版本、所属进程名。\n设备信息：IMEI等设备识别，用于判断Crash设备统计。\n3.2 我们的应用集成第三方广告平台SDK，需要收集您的设备Mac地址、唯一设备识别码（IMEI/androidID/IDFA/OPENUDID/GUID、SIM卡IMSI信息）以提供统计分析服务。我们会对合作方获取信息的软件工具开发包（SDK）进行严格的安全检测，以保护数据安全。\n3.3 为方便阅读，其他更多SDK数据请查看接入的相关第三方SDK。\n4. 关于数据的跨境传输\n我们的产品不存在跨境传输的数据，且所有数据在传输前，均会事先获得您的明示授权或同意。\n5. 如何委托处理、共享、转让、公开披露您的个人信息\n5.1委托处理\n为了向您提供更完善、优质的产品和服务，某些功能可能由我们的技术服务合作方提供，我们可能会委托合作方处理您的某些个人信息。对我们委托处理您个人信息的公司、组织和个人，我们会与其签署严格的保密协定，明确双方责任、处理事项、处理期限、处理性质和处理目的等，要求他们仅按照我们的要求、本政策以及其他任何相关的保密和安全措施来处理个人信息。如果您拒绝我们的合作方在提供服务时收集为提供服务所必需的个人信息，将可能导致您无法使用重庆乐义多科技有限公司产品与/或服务来享用该合作方提供的服务。我们的合作伙伴包括：\n5.1.1分析与/或统计服务SDK提供商。为了更好地分析与/或统计重庆乐义多科技有限公司用户的使用情况，我们可能委托数据分析与/或统计的服务提供商处理您的设备信息、用户点击记录，用于维护或改进重庆乐义多科技有限公司产品与/或服务，并提升用户体验。\n5.1.2技术服务SDK提供商。我们可能会委托该服务的合作伙伴（如语音技术服务提供商、云服务提供商）处理您的语音，以便提供发音准确性测评，更好地提升用户体验。我们亦可能委托该服务的合作伙伴（如应用异常情况技术服务提供商）处理您系统版本、生成ID、手机样式，以便提供\"重庆乐义多科技有限公司\"应用的异常情况分析处理。\n5.2共享\n对于您的个人信息，我们仅在本政策所述的目的和范围内或根据法律法规的要求收集和使用，并严格保密。除非存在以下一种或多种情形（相关法域另有规定的除外），我们不会与第三方公司、组织或个人共享您的个人信息：\n5.2.1基于您自行提出的要求、或事先获得您的明示授权或同意；\n5.2.2与我们履行法律法规规定的义务相关的；\n5.2.3与国家安全、国防安全直接相关的；\n5.2.4与公共安全、公共卫生、重大公共利益直接相关的；\n5.2.5与犯罪侦查、起诉、审判和判决执行等直接相关的；\n5.2.6出于维护您和/或您孩子或其他个人的生命、财产等重大合法权益但又很难得到本人同意的；\n5.2.7您自行向社会公众公开的您和/或您孩子个人信息；\n5.2.8从合法公开披露的信息中收集个人信息的，如合法的新闻报道、政府信息公开等渠道。\n5.2.9与我们的业务合作伙伴进行必要的信息共享；\n为了向您提供更完善、优质的产品和服务，某些重庆乐义多科技有限公司服务将由合作方提供，因此，我们可能会与合作方共享您的某些个人信息。我们仅会出于合法、正当、必要、特定、明确的目的共享的个人信息，并且只会共享为您提供服务所必要的个人信息。我们不会共享可以识别您身份的个人信息，除非法律法规另有规定。该等共享的合作方为数据控制者，以其自己的名义获得您的同意以处理您的个人信息。合作方可能有其独立的隐私政策和用户协议，我们建议您认真阅读并遵守第三方的用户协议及隐私政策。如果您拒绝我们的合作方在提供服务时收集为提供服务所必需的个人信息，将可能导致您无法使用重庆乐义多科技有限公司产品与/或服务来享用该合作方提供的服务。在您购买重庆乐义多科技有限公司产品与/或服务时，我们可能会与我们的合作伙伴（含渠道合作方）共享您的信息，例如，我们向支付宝提供交易金额、交易商品、订单号、交易时间，以便您能够完成支付并顺利购买。\n请您知悉，随着服务的更新和升级，您可能通过使用我们的服务或第三方提供的功能，主动公开、共享您的相关信息（如微信好友/朋友圈/QQ等）。在这种情况下，共享信息将被视为即时并广泛的传播。一旦您进行了此类信息共享，很难确保当您需要删除信息时，您所共享的信息在所有接受转发的互联网平台中被全部删除。在一些情况下，即使您从我们的服务中删除了您共享的信息，该类信息仍然可能会留存在公众可获知的领域，仍可由其他用户或与我们没有关联且不受我们控制的第三方独立地缓存、复制或存储，以及通过其他用户或该等第三方在公众可获知的领域保存。\n5.2.10其他法律法规规定的情形。\n请您知悉：\n（1）我们共享您的个人信息仅为了更精准地向您提供服务。除此以外，我们不会共享可以识别您身份的个人信息，除非法律法规另有规定。\n（2）通过重庆乐义多科技有限公司产品与/或服务或第三方提供的功能，您可以主动公开、共享您的相关状态（如微信转发）。在这种情况下，共享信息将被视为即实并广泛的传播。一旦您进行了此等共享，很难确保当您需要删除信息时，您所共享的信息在所有接受转发的互联网平台中被全部删除。在一些情况下，即使您从重庆乐义多科技有限公司产品与/或服务中删除了被共享的信息，该等信息仍然可能会留存在公众可获知的领域，仍可由其他用户或与我们没有关联及不受我们控制的第三方独立地缓存、复制或存储，或通过其他用户或该等第三方在公众可获知的领域保存。\n5.3转让\n原则上我们不会将您的个人信息控制权向其它公司、组织或个人进行转让，但在以下情况除外：\n5.3.1基于您自行提出的要求、或事先获得您的明示授权或同意；\n5.3.2与我们履行法律法规规定的义务相关的；\n5.3.3与国家安全、国防安全直接相关的；\n5.3.4与公共安全、公共卫生、重大公共利益直接相关的；\n5.3.5与犯罪侦查、起诉、审判和判决执行等直接相关的；\n5.3.6出于维护您和/或您孩子或其他个人的生命、财产等重大合法权益但又很难得到本人同意的；\n5.3.7您自行向社会公众公开的个人信息；\n5.3.8从合法公开披露的信息中收集个人信息的，如合法的新闻报道、政府信息公开等渠道；\n5.3.9发生公司合并、收购或破产清算，运营主体的变更时的转让。\n请您知悉：如具备上述事由确需转让，我们将在转让前向您告知转让信息的目的、类型、信息受让方（如涉及敏感信息，我们还将告知涉及的敏感信息的内容），并在征得您同意后再转让，但法律法规另有规定的除外。\n5.4公开披露\n原则上我们不会向社会或不特定人群发布您的个人信息，但以下情况除外：\n5.4.1基于与您的约定的；\n5.4.2根据法律法规应当披露的。\n请您知悉：\n（1）如具备上述事由确需公开披露，我们会在披露前向您告知公开披露的目的、信息的类型（如涉及敏感信息，我们还将告知涉及的敏感信息的内容）并在征得您同意后再公开披露，但法律法规另有规定的除外。\n（2）即使已经取得您的同意，我们也仅会处于合法、正当、必要、特定、明确的目的公开披露您的个人信息，并尽量对公开披露内容中的个人信息进行去标识化处理。\n6. 您如何管理您的个人信息\n6.1访问或更正您的个人信息\n6.1.1您有权随时登录并访问您的账户，查看您个人信息，包括您的账号信息和您的个人档案。如您发现我们收集、存储、使用、披露的您的个人信息有错误的，或者在法律法规规定的其他情况下，您可以更正您的个人信息。\n6.1.2如您希望访问或更正您其他个人信息，或在行使上述权利过程中遇到困难，您可通过本政策第10条提供的联系方式联系我们，我们将在核实您的身份后15日内及时响应您的请求，但法律法规另有规定的或本政策另有约定的除外。\n6.2删除您的个人信息\n6.2.1在以下情形中，您可以向我们提出删除您个人信息的请求，但已做数据匿名化处理或法律法规另有规定的除外：\n6.2.1.1我们违反法律、行政法规的规定或与您的约定，收集、存储、使用、转移、披露您的个人信息的；\n6.2.1.2我们超出目的范围或者必要期限收集、存储、使用、转移、披露您个人信息的；\n6.2.1.3您撤回同意的；\n6.2.1.4您通过注销等方式终止使用重庆乐义多科技有限公司产品与/或服务的。\n6.2.1.5其他法律法规等规定的情形。\n6.2.2如您希望删除您的个人信息，您可以您可通过本政策第10条提供的联系方式联系我们。对于您的请求，我们原则上将于收到您的请求并在验证您用户身份后的15日内做出答复。\n6.2.3您在此同意，一旦删除请求被响应，您的个人信息将被删除。\n6.2.4请您知悉，我们可能不会将响应的信息立即从备份系统中删除，但会在备份系统更新时进行删除。\n6.3更改您授权同意的范围\n6.3.1请您知悉，为了您能正常使用重庆乐义多科技有限公司产品与/或服务，您需要向我们提供一些基本的个人信息。如果您希望更改或撤回您授权同意，您可以在设备的设置功能中选择关闭部分或全部权限。在不同设备中，权限显示方式及关闭方式可能有所不同，具体请参考设备及系统开发方说明或指引。您也可以通过本政策第10条提供的联系方式联系我们，对于您的请求，我们原则上将于收到您的请求并在验证您用户身份后的15日内做出答复。\n6.3.2当您更改您的同意范围后，我们将不再收集和使用您相应的个人信息，但请您理解，在您更改您的同意范围后，我们无法再为您提供与之对应的重庆乐义多科技有限公司产品与/或服务。您在此同意，您更改同意范围或撤回同意的行为不会影响我们基于您之前授权对您个人信息的处理和存储。\n6.4注销您的账号\n6.4.1除非法律法规另有规定或本政策另有约定，您也可以通过本政策第10条提供的联系方式联系我们来注销账号，对于您的请求，我们原则上将于收到您的请求并在验证您用户身份后的15日内做出答复。\n6.4.2请您知悉，在注销账号后，除非根据法律法规或根据监管部门的要求保留或存储您的个人信息，否则我们将即时删除您的个人信息或作匿名化处理。请您知悉，我们可能不会将该等信息立即从备份系统中删除，但会在备份系统更新时进行删除。\n6.4.3您注销账号的行为是不可逆的，一旦您的账号被注销，我们将不再收集您的个人信息，也不再为您提供重庆乐义多科技有限公司产品与/或服务。因此我们建议您谨慎选择注销账号。\n6.5获取您的个人信息副本\n6.5.1在技术措施允许的情况下，我们也可以根据您的要求，将您的个人信息提供给第三方。\n6.6响应您的上述请求\n6.6.1为实现本政策第6.1-6.6条所述的用户权利，请您通过Email: tangyongqin@newto.cn与我们联系。为确保安全，我们可能会先要求您通过提交相应证明以验证自己的身份，然后再处理您的请求。对于您的请求，我们原则上将于收到您的请求并在验证您用户身份后的15日内做出答复。\n6.6.2对于您合理的请求，我们原则上不收取费用。对于与您的身份不直接关联的信息、无端重复信息，或者需要过多技术手段（例如，需要开发新系统或从根本上改变现行惯例）、给他人合法权益带来风险或者不切实际的请求，我们可能会予以拒绝。\n6.6.3如您对您的数据主体权利存在任何疑问、意见或建议的，也可通过Email: tangyongqin@newto.cn联系我们。\n7. 如何保护您的个人信息\n我们十分重视您的个人信息安全，为此我们采用了符合行业标准的安全技术措施及配套的组织架构和管理体系等多层面保护措施，以最大程度防止您的个人信息被泄露、毁损、误用、未授权访问、未授权披露或更改，具体包括：\n7.1数据安全技术措施\n7.1.1在数据安全传输方面，我们采用了传输层安全协议等密码技术，通过Https等方式防止传输链路被窃听、截取，建立安全的隐私数据环境，保证数据的私密性和完整性。我们还对您的信息采取加密存储等额外的安全保护措施。\n7.1.2在数据访问和使用的安全控制方面，我们实施了严格的数据权限控制机制，采取多重身份认证技术，并对能够处理您的个人信息的行为进行监控，避免数据被违规访问和未授权使用。我们还对数据生命周期的全流程进行监控，防止您的个人信息遭遇未授权的访问、公开披露、使用、修改、人为或意外的损坏或丢失等。\n7.2数据安全组织和管理措施\n7.2.1根据有关法规要求，我们成立了专门负责个人信息保护的部门。我们还建立了相关的内控管理流程，对可能接触到您个人信息的工作人员以最小授权为原则，严格设定信息访问权限，控制个人信息的知悉范围。\n7.2.2我们建立了数据分级分类制度、业务数据安全使用规范、数据合作规范等障对您个人信息的处置在收集、传输、使用、存储、转移、销毁等环节均满足法律法规的安全要求。根据有关法规要求，对需要访问个人信息的工作人员，我们会要求其经过个人信息保护负责人或者其授权的管理人员审批，记录访问情况，并采取技术措施，避免违法复制、下载个人信息。\n7.2.3我们组织员工参加安全与隐私保护相关培训并要求其完成规定的考核，加强员工对于保护个人信息重要性的认知。\n7.2.4我们还采取了其他可行的安全组织和管理措施。\n7.3合作协议条款保证\n7.3.1在我们从第三方间接收集您的个人信息前，我们会明确以书面形式（如合作协议、承诺书）要求该第三方在已经取得您明示同意后收集以及处理（如共享等）您的个人信息，在书面协议层面要求第三方对个人信息来源的合法性和合规性作出承诺，如第三方有违反行为的，我们会明确要求对方承担相应的法律责任。\n7.3.2在我们向业务合作伙伴共享您的个人信息前，我们会严格要求合作伙伴承担信息保护义务与责任，为此，我们还会要求业务合作伙伴签署数据处理协议或在合作协议中列明有关数据保护的条款，并要求业务合作伙伴在合作前签署。协议严格约定了业务合作伙伴的用户信息保密义务，包括信息的保管、使用和流转等均应满足我们的管控要求，接受我们的审核、监督和审计，一旦有任何违反，我们会要求对方承担相应的法律责任。\n7.4安全事件的处理\n7.4.1如不幸发生个人信息安全事件，我们将立即启动应急预案，采取补救措施，如造成或可能造成严重后果，我们将立即向有关部门报告，并向您告知安全事件的基本情况和可能的影响、我们已采取或将要采取的处置措施、您可自主防范和降低风险的建议、对您的补救措施等。我们将及时将事件相关情况以邮件、电话等方式告知您，难以逐一告知时，我们会采取合理、有效的方式发布公告。\n7.4.2请您知悉并理解，互联网并非绝对安全的环境，我们强烈建议您通过安全方式、使用复杂密码，协助我们保证您的账号安全。如您发现自己的个人信息泄密，尤其是您的账号或密码发生泄露，请您立即根据本政策第10条提供的联系方式联络我们，以便我们采取相应措施来保护您的信息安全。\n8. 如何存储您的个人信息\n8.1 我们会将在中国境内收集和产生的个人信息存储在中国境内。\n8.2 如需发生数据跨境传输，我们会向您告知您数据出境的目的、接收方，并征得您的同意，我们会确保数据接收方有充足的数据保护能力来保护您的个人信息。\n8.3 我们承诺，除非法律法规另有要求，您个人信息的存储时间将处于实现您授权使用的目的所必需的最短时间。\n8.4 如我们因经营不善或其他原因出现停止运营的情况，除非法律法规另有要求，我们会将此类情况向您告知，停止对您个人信息的收集，并删除已收集的个人信息或做匿名化处理。\n9. 如何更新本政策\n9.1 我们保留不时更新或修改本政策的权利。我们会在本页面上发布对本政策所做的任何变更。但是未经您明确同意，我们不会削减您按照本政策所应享有的权利。该等变更构成本政策的一部分。历史版本可参见这里。\n9.2 请您仔细阅读变更后的本政策内容。如果您不同意本政策，或对本政策修改、更新的内容有异议，您可以选择注销账号并不再使用重庆乐义多科技有限公司产品与/或服务。但请您知悉，您账号注销之前、停止使用本服务之前的行为和活动仍受本政策的约束。如有资费相关问题，请阅读《重庆乐义多科技有限公司用户服务协议》。\n9.3 若涉及重大、实质性变更，我们会依据具体情况，以显著的方式通知您。\n重大、实质性变更的情形包括但不限于以下情形：\n9.3.1我们的服务模式发生重大变化。如处理个人信息的目的、处理的个人信息类型、个人信息的使用方式等；\n9.3.2您参与个人信息处理方面的权利及其行使方式发生重大变化。\n10. 如何联系我们\n10.1我们设立了专门负责个人信息保护的部门，如您在执行或使用重庆乐义多科技有限公司产品与/或服务时遇到与隐私保护相关的任何问题（包括问题咨询、投诉等），您可以通过以下方式与我们取得联系：（i）Email: tangyongqin@newto.cn；（ii）点击本应用APP中的【我的】-【联系我们】；（iii）我们提供的其他联系方式。\n11.2我们会在收到您的意见及建议并在验证您用户身份后的15日内尽快向您回复。如无法响应您的请求，我们会在法律规定的最大时限要求内，向您发送通知并解释原因。\n11.3如您对我们的回复不满意，或我们对您个人信息的处理方式侵害了您的合法权益，且在您向我们反馈后我们无法提供让您满意的回复且拒绝改进的，您可以向相关监管机构进行投诉和举报。\n11. 附则\n11.1本政策的解释及争议解决均应适用中国法律。与本政策相关的任何纠纷，双方应协商友好解决；若不能协商解决，您在此同意将争议提交至成都市高新区人民法院。\n11.2如果有管辖权的任何法院裁定或判决本政策的任何条款无效，则该条款将从本政策中移除，但该条款的无效不影响本政策其余条款的效力。本政策的其余条款将继续执行。\n11.3本政策的标题仅为方便阅读而设计，不影响本政策任何条款的含义或解释。\n12. 关键词定义\n12.1 用户或您：指使用重庆乐义多科技有限公司产品与/或服务的儿童的监护人、已满18周岁的成年用户。\n13.2 儿童或您孩子：指您所监护的年龄不超过14周岁的未成年人。\n13.3 个人信息：指以电子或者其他方式记录的能够单独或者与其他信息结合识别特定自然人身份或者反映特定自然人活动情况的各种信息。个人信息包括个人基本信息、个人身份信息、个人生物识别信息、网络身份标识信息、个人健康生理信息、个人教育工作信息、个人财产信息、个人通信信息、联系人信息、个人上网记录、个人常用设备信息等。为免疑义，个人信息包括但不限于个人敏感信息。\n12.4 个人敏感信息：指一旦泄露、非法提供或滥用可能危害人身和财产安全，极易导致个人名誉、身心健康受到损害或歧视性待遇等的个人信息。个人敏感信息包括个人财产信息、个人健康生理信息、个人生物识别信息、个人身份信息、网络身份标识信息等。\n12.5 去标识化：指通过对个人信息的技术处理，使其在不借助额外信息的情况下，无法识别您的过程。\n12.6 匿名化：指通过对个人信息的技术处理，使得您无法被识别，且处理后的信息不能被复原的过程。\n12.7 中国或中国境内：指中华人民共和国（仅为本政策之目的，不包含香港特别行政区、澳门特别行政区和台湾地区）。\n12.8 设备：设备是指可用于访问重庆乐义多科技有限公司产品和或或服务的装置，例如台式计算机、笔记本电脑、平板电脑、智能手机、智能大屏、智能手表、智能音箱等。\n更新时间：2021年10月14日";
                this.c_loader_biaoti.url = "ui://jyvm79orfkj2s";
            }
            else {
                this.c_text_wenan.text = "用户服务协议\n生效时间：2021年11月16日\n更新时间：2022年1月10日\n本合作协议是甲方（指重庆乐义多科技有限公司及/或其指定的关联公司，以下简称\“公司\”）与乙方（指以个人身份在重庆乐义多科技有限公司关联的玩家，以下简称\“用户\”）之间就重庆乐义多科技有限公司的应用（包括、APP、小程序等）使用事宜达成的具有法律效力的协议。\n为使用本软件及服务，您须仔细阅读并同意遵守《用户服务协议》（以下简称\“本协议\”）。您的下载、安装、使用、申请及获取账号、登录等行为即视为您已阅读并同意上述协议的约束。本公司有权不时地对本协议条款做任何修改和补充，并在本软件及服务中公布。对本协议条款的修改和补充将在公布时立即生效。您继续登录和使用本软件及服务即视为接受修订后的本协议。否则，您有权通过停止登录且拒绝使用本软件及服务的方式来终止本协议。\n您承诺遵守适用的法律、法规、规章及其他政府规定。用户发生违法或犯罪行为，或者本公司有相关证据合理怀疑用户可能存在违法、犯罪或违反本协议的行为的，本公司有权中止或终止对该用户的服务，有权在本公司及互联网络上公布该用户的违法、违约行为，有权向有关机关报案并配合有关机关的调查活动，包括但不限于披露该用户的所有用户信息、交易记录及其他信息，本公司实施上述任何及全部行为所造成的后果、风险及责任由用户自行承担。用户签署本协议即视为理解并接受上述条款，永久性不可撤销地授权本公司公开相关信息及采取相应措施。\n本协议内容包括本协议正文以及本公司已经发布的或将来可能发布的各类规则、声明、说明。所有规则、声明、说明为本协议不可分割的一部分，与本协议正文具有同等法律效力。\n如果您代表某个机构而非您个人注册、登录和使用本软件及服务，则您将被认为获得充分授权代表该机构同意本协议条款以及本协议条款不时的修改和补充。如果您未满18周岁，请在法定监护人的陪同下阅读本协议及其他上述协议，并在征得监护人同意的前提下使用本应用并特别注意本协议第十条约定的未成年人使用条款。未成年人行使和履行本协议项下的权利和义务即视为已获得了监护人的认可。\n乙方应仔细阅读并充分理解本协议后点击【\“同意\”】按钮。\n乙方应当清楚，当乙方点击【\“同意\”】按钮后，即表示乙方与\"重庆乐义多科技有限公司\"科技签订本协议并生效，乙方在使用\"重庆乐义多科技有限公司\"科技的产品及服务过程中不得违反本协议的约定。\n.总则\n签署本协议前，乙方已充分了解甲方软件的各项规则及要求，且有条件及有能力履行本协议约定的义务。乙方对本协议下所有条款及定义等内容均已明确知悉并有能力承担因此所产生的相应责任，并无疑义。\n1.本软件及服务可能不时开放不同功能，每一功能的使用及其限制将受制于针对该功能的特定业务规则。本公司有权制定及不时修订该等特定业务规则，并予以公示。您使用或继续使用该等功能即视为您同意并接受该等规则及其修订。\n2.账号的所有权归属本公司，用户完成注册手续后，仅获得账号的使用权，且该使用权仅属于申请注册人本人。账号申请注册人不得以任何方式向第三方有偿或无偿提供账号使用权，包括但不限于转让、赠与、租用、借用、许可使用。账号申请注册人违反上述约定的，因此导致的后果、责任均由其自行承担，给本公司造成损失的，应予全额赔偿，本公司并有权收回账户使用权。\n3.您应妥善保管账号及/或与账号绑定的微信账号，准确输入该等信息将作为您访问登录及使用本软件及服务的关键环节。您知悉并同意，任何在您账号项下发生的行为均将视为您或经您合法授权的行为，并将由您承担一切法律后果。如果您发现有人未经授权使用您的账号，您应立即向本公司反馈，否则未经授权的使用行为均视为用户本人行为。尽管有前述约定，任何情况下，本公司均不对您因账号、登录信息错误、遗失、被盗，或因您未能确保账号信息安全的其他情形而造成的任何损失或损害，承担任何责任。\n4.您在此授予本公司保护您账号安全的相关权利，本公司可定期或不定期采用不同的方式对您账号的使用安全进行检查、验证，包括但不限于主动联系您进行【身份验证、短消息验证、邮箱认证】等。如您无法完成验证或无正当理由拒绝验证的，本公司可合理怀疑您的账号出现异常或被盗，因而中止向该账号提供服务或采取进一步措施。\n.乙方\n为避免疑义，乙方特此确认其向甲方提供如下信息，并保证该信息真实、有效、完整：姓名、订单号、手机号码、商品信息、userID。\n1.甲方提供的应用分为免费和付费。对于现阶段免费提供的服务内容，甲方有权随时根据甲方政策的调整将其变更为收费服务，如果发生该等变更的，甲方将提前告知用户，如果用户不同意的，可以停止使用该服务。对于收费的服务内容，甲方有权自行确定该等服务的价格并不时调整，调整后的价格将在软件中进行公示，如果用户不同意调整后的价格的，则用户可以在其原购买的收费服务到期后停止付费购买收费服务。如果用户在甲方调整价格并公示后，仍继续购买收费服务的，则视为用户同意该调整后的价格。\n2.甲方不时将对付费服务提供优惠政策或开展优惠活动，该等优惠政策或优惠活动以软件上的实时信息为准，用户知悉并认可，甲方有权自行决定是否提供优惠政策或开展优惠互动，以及优惠政策或优惠活动的内容、条件和有效期，并不时进行调整或终止。\n3.如果用户通过合法方式获得了相关付费服务的优惠券或折扣等其他优惠方式的，则用户知悉并认可，该等优惠券或折扣必须满足一定条件才能使用，以优惠券上的信息提示和优惠券使用说明、或甲方公示的折扣使用说明为准。优惠券或折扣不兑现（即不直接兑换现金）、不找零（即订单金额不足抵用券金额的，抵用券剩余金额无效）、过期作废；优惠券或折扣仅限同一用户账号使用，严禁出售、转让或共享，如经甲方发现存在出售、转让或共享优惠券或折扣等其他优惠方式的，该优惠券或折扣将予以作废处理，且甲方有权视情节严重程度予以封号处理，并保留追究相关责任人法律责任的权利。\n.用户注意事项\n1.您理解并同意，本软件及服务的某些功能可能会让第三方知晓用户的信息，包括但不限于：用户的软件好友可以查询用户头像、名字等可公开的个人资料，您同意本公司无须就此类事项向您承担任何责任。\n2.基于互联网的开放性属性，您知悉用户将图片等资料上传到互联网上，有可能会被其他组织或个人复制、转载、擅改或做其它非法用途，您必须充分意识到此类风险的存在。您明确同意使用本软件及服务所存在的风险将完全由您自行承担；因您使用本软件及服务而产生的一切后果也由您自行承担。\n3.用户使用本软件及服务的特定功能时，本公司可能会调用第三方系统或者通过第三方支持用户的使用或访问，使用或访问的结果由该第三方提供（包括但不限于第三方通过本公司公众账号提供的服务，或通过开放平台接入的内容等），本公司不对第三方提供服务及内容的安全性、准确性、有效性及其他事项作出任何承诺或承担任何责任，相关风险及责任由用户自行承担。您在使用该等第三方产品或服务时，除遵守本协议约定外，还应遵守第三方的用户协议。如因本软件使用的第三方软件或技术引发的任何纠纷，应由该第三方负责解决，本公司不承担任何责任。本公司不对第三方软件或技术提供客服支持，若您需要获取支持，请与第三方联系。\n4.您理解并同意，不论在何种情况下，本公司均不对由于互联网连接故障，电脑、通讯或其他系统的故障，电力故障，罢工，劳动争议，暴乱，起义，骚乱，火灾，洪水，风暴，爆炸，不可抗力，战争，政府行为，国际、国内法院的命令，第三方的不作为或任何本公司不能合理控制的原因而造成的本软件及服务不能访问、信息及数据的延误、停滞或错误，不能提供或延迟提供服务，承担任何责任。\n5.您理解并同意，本公司有权决定将本软件及服务作商业用途，本公司承诺在推广过程中严格按照本协议约定保护您的个人信息，同时您亦可以根据系统设置选择屏蔽、拒绝接收相关推广信息。\n6.您理解并同意，本公司会将会尽其商业上的合理努力保障您在本软件及服务中的数据存储安全，但是，本公司并不能就此提供完全保证，包括但不限于以下情形：\n（1）本公司不对您在本软件及服务中相关数据的删除或储存失败负责；\n（2）本公司有权根据实际情况自行决定单个用户在本软件及服务中数据的最长储存期限，并在服务器上为其分配数据最大存储空间等。您可根据自己的需要自行备份本软件及服务中的相关数据；\n（3）如果您停止使用本软件及服务或服务被终止或取消，本公司可以从服务器上永久地删除您的数据。服务停止、终止或取消后，本公司没有义务向您返还任何数据。\n.软件安装、卸载及更新\n1.甲方可能为不同的终端设备开发了不同的软件版本，您应当根据实际情况选择下载合适的版本进行安装。\n2.下载安装程序后，您需要按照该程序提示的步骤正确安装。为提供更加优质、安全的服务，在本软件安装时甲方可能推荐您安装其他软件，您可以选择安装或不安装。如果您不再需要使用本软件或者需要安装新版软件，可以自行卸载。如果您愿意帮助甲方改进产品服务，请告知卸载的原因。\n3.为了改善用户体验、完善服务内容，本公司将不断努力开发新的功能或版本，并为您不时提供软件更新（这些更新可能会采取软件替换、修改、功能强化、版本升级等形式）。\n4.为了保证本软件及服务的安全性和功能的一致性，本公司有权不经向您特别通知而对本软件进行更新，或者对本软件的部分功能效果进行改变或限制。本软件新版本发布后，旧版本的软件可能无法使用，请您随时核对并下载最新版本，因未能及时下载及使用最新版本导致的使用不能及相关风险将由您承担。如果您继续使用本软件及服务，则视为您同意接受更新后的本软件及服务。如果您拒绝接受更新后的本软件及服务，您应立即停止登录及使用本软件及服务；该等情形下，您仍需就您在停止使用前已发生的行为承担全部责任。\n5.您理解并同意，本公司有权因本软件及服务维护、升级或其他原因而暂停服务、调整服务功能或终止服务，本公司将事先在软件上进行公示或通知。您同意本公司无须就此向您承担任何责任。\n.用户行为规范\n（一）信息内容合法性规范\n用户使用本软件及服务过程中所制作、复制、发布、传播的任何内容（包括但不限于应用账号头像、名字、用户说明等信息，或文字、语音、图片等发送、回复，以及使用应用账号或本软件及服务所产生的其他内容）的合法性。用户承诺不利用应用账号或本软件及服务制作、复制、发布、传播下干扰软件正常运营，以及侵犯其他用户或第三方合法权益的内容，包括但不限于：\n1.发布、传送、传播、储存法律法规禁止的内容。\n2.发布、传送、传播、储存侵害他人名誉权、肖像权、知识产权、商业秘密等合法权利的内容。\n3.涉及他人隐私、个人信息或资料的。\n4.发表、传送、传播骚扰、广告信息、过度营销信息及垃圾信息或含有任何性或性暗示的信息。\n5.违反中华人民共和国宪法确定的基本原则的，危害国家安全的、泄露国家秘密、颠覆国家政权、破坏国家统一的。\n6.煽动地域歧视、地域仇恨、民族仇恨、民族歧视、破坏民族团结的。\n7.破坏国家宗教政策，宣扬邪教和迷信的，以非法民间组织名义活动的。\n8.包含恐怖、淫秽、色情、赌博、暴力血腥、高危险性、凶杀恐怖、教唆犯罪、危害表演者自身或他人身心健康内容的。\n9.危害网络安全、利用网络从事危害国家安全、荣誉和利益的，不符合应当遵守法律法规、社会主义制度、国家利益、公民合法利益、公众秩序、社会道德风尚和信息真实性等\“七条底线\”要求的。\n10.含有虚假、有害、胁迫、侵害他人隐私、骚扰、侵害、中伤、粗俗、猥亵、或其它道德上令人反感的内容。\n11.其他违反法律法规、政策及公序良俗、社会公德或干扰软件正常运营和侵犯其他用户或第三方合法权益内容的信息。\n（二）软件使用合法性规范\n1.用户使用本软件及服务的行为须尊重及维护本公司对软件的知识产权及软件的正常稳定运营，用户承诺不实施任何可能侵犯软件知识产权或影响软件正常运营的行为，包括但不限于：\n（a）删除或修改本软件上关于著作权的信息；\n（b）对本软件进行反向工程、反向汇编、反向编译，或者以其他方式尝试发现本软件的源代码；\n（c）对本公司拥有知识产权的内容进行使用、出租、出借、复制、模仿修改、转载、汇编、发表、出版、建立镜像站点等；\n（d）对本软件或者本软件运行过程中释放到任何终端内存中的数据、软件运行过程中客户端与服务器端的交互数据，以及本软件运行所必需的系统数据，进行复制、修改、增加、删除、挂接运行或创作任何衍生作品，形式包括但不限于使用插件、外挂或非经授权的第三方工具/服务接入本软件和相关系统；\n（e）通过修改或伪造软件运行中的指令、数据，增加、删减、变动软件的功能或运行效果，或者将用于上述用途的软件、方法进行运营或向公众传播，无论这些行为是否为商业目的；\n（f）通过非本公司开发、授权的第三方软件、插件、外挂、系统，登录或使用本软件及服务，或制作、发布、传播上述工具；\n（g）自行或者授权他人、第三方软件对本软件及其组件、模块、数据进行干扰；\n（h）故意制作、传播计算机病毒等破坏性程序的；\n（i）其他违反法律法规规定、侵犯其他用户合法权益、干扰本软件及服务正常运营的行为。\n1.用户使用本软件及服务过程中不得发生下列行为：\n（a）提交、发布虚假信息，或冒充、利用他人名义的；\n（b）强制、诱导其他用户点击链接页面或分享信息的；\n（c）虚构事实、隐瞒真相以误导、欺骗他人的；\n（d）侵害他人名誉权、肖像权、知识产权、商业秘密等合法权利的；\n（e）将应用账号或其任何功能以任何方式提供给第三方，或用于任何商业性用途；\n（f）利用应用账号或本软件及服务从事任何违法犯罪活动的；\n（g）制作、发布与以上行为相关的方法、工具，或对此类方法、工具进行运营或传播，无论这些行为是否为商业目的；\n（h）利用技术手段批量建立虚假账号；\n（i）其他违反法律法规规定、侵犯其他用户合法权益、干扰本软件及服务正常运营的行为。\n（三）违约处理\n1.如果本公司发现或收到他人举报或投诉用户违反本协议约定，本公司有权不经通知随时对相关内容进行删除、屏蔽，并视行为情节对违规账号处以包括但不限于警告、限制、中断、终止或禁止使用部分或全部功能、账号封禁直至注销的处罚，并公告处理结果。\n2.您理解并同意，本公司有权依合理判断对违反有关法律法规或本协议规定的行为进行处罚，对违法违规的任何用户采取适当的法律行动，并依据法律法规保存有关信息向有关部门报告等，用户应独自承担由此而产生的一切法律责任。\n3.您理解并同意，因您违反本协议或相关服务条款的规定，导致或产生第三方主张的任何索赔、要求或损失，您应当独立承担责任；本公司因此遭受损失的，您也应当一并赔偿。\n4.您理解并同意，如果您注册的账号在任何连续【180】日内未实际使用，则本公司有权删除该账号并停止为该用户提供相关服务。\n.未成年人使用条款\n1.若用户是未满18周岁的未成年人，用户应在监护人的指导并获得监护人同意的情况下，认真阅读并同意本协议后，方可使用本软件及服务。\n2.本公司重视对未成年人个人信息的保护，未成年用户在填写个人信息时，请加强个人保护意识并谨慎对待，并应在取得监护人的同意以及在监护人指导下正确使用本软件及服务。\n3.为更好地保护未成年人隐私权益，本公司司特别提醒您慎重发布包含未成年人素材的内容，一经发布，即视为您已获得权利人同意在本软件及服务展示未成年人的肖像、声音等信息，且允许本公司司依据本协议使用、处理该等与未成年人相关的内容。\n4.监护人特别提示：如您的被监护人使用本软件及服务的，您作为监护人应指导并监督被监护人的注册和使用行为，如您的被监护人申请注册账号，公司将视为其已取得您的同意。\n5.未成年人用户及其监护人理解并确认，如您违反法律法规、本协议内容，则您及您的监护人应依照法律规定承担因此而可能导致的全部法律责任。\n.支付与资费政策\n1.我们在提供本应用应用产品与／或服务时，会对您（注册用户）需要提供付费服务，向您收取一定的费用，以完成付费充值。目前，充值服务类型主要有按特定时长的订阅服务（包括但不限于月卡、季卡、年卡）。如您不同意支付该等费用，则无法使用收费服务部分的内容。\n2.我们有权决定付费本应用应用产品与／或服务的资费标准。我们可能会因铁皮人产品与／或服务的服务类型和服务周期不同，制定不同的资费标准，详细约定以各款应用公布、实际展示的资费标准为准。\n此外，需要特别提示您，根据App Store、华为应用商店的政策，其可能会向您提供自动扣费服务，请您在选择使用前仔细阅读App Store、华为应用商店的相关政策。若您希望取消自动扣费功能的，请您根据App Store、华为应用商店的相关政策及退订规则操作或与苹果公司、华为公司取得联系。\n1.您理解并同意，您支付前述服务费用的方式包括通过我们接入的第三方支付工具（如微信支付、支付宝等）向我们进行付款，当然您也可以向App Store、华为应用商店等第三方应用商店进行充值以完成您的支付。如支付工具有更新，我们会在支付页面上及时更新支付规则并通知您，详细约定以本应用公布、实际展示的支付规则为准。\n2.您理解并同意，因使用第三方支付工具进行支付而可能产生的任何商业风险（包括但不限于交易信息输入错误、不法分子利用您账户或银行卡等有价卡等进行违法活动等）均有可能给您造成相应的经济损失。我们在充分履行本协议条款和规则的义务和符合法律规定的前提下，不对您的前述风险和损失承担任何责任。我们善意提醒您，在与第三方建立法律关系前，您应审慎阅读第三方的用户服务协议、隐私政策等法律文件。\n3.如您需取消当前订阅，请您联系Email: tangyongqin@newto.cn。但是，如您使用App Store、华为应用商店自动扣费服务的，可以根据App Store、华为应用商店的退款政策向苹果公司、华为公司主张取消订阅服务及／或处理退款事宜。\n.保密和知识产权保护\n1.受国际版权公约、中华人民共和国著作权法、专利法、及其他知识产权方面的法律法规的保护，甲方平台的产品与/或服务及所使用的软件、界面、交互等元素、LOGO、商标、标识、图形、文字、文本、声音、音频、视频、肖像、图片、技术、材料等的所有知识产权归甲方所有和享有。\“知识产权\”包括在专利法、版权法、商标法、反不正当竞争法中等法律规定的任何和所有权利、任何和所有其它所有权以及其中的任何和所有应用、更新、扩展和恢复。\n2.对于乙方发表到甲方平台上的任何内容，用户同意甲方在全世界范围内具有免费的、永久性的、不可撤销的、非独家的和完全再许可的权利和许可，以使用、复制、修改、改编、出版、翻译、据以创作衍生作品、传播、表演和展示此等内容（整体或部分），和/或将此等内容编入当前已知的或以后开发的其他任何形式的作品、媒体或技术中。并且，用户许可本公司有权利就任何主体侵权而单独采取法律行动（包括但不限于诉讼、举报、律师函等形式）。\n3.乙方对本协议的内容以及在本合同签订、履行过程中知悉、获取的甲方资料和信息，除甲方做出相反的书面说明外，均应视为甲方的商业秘密。未经甲方书面同意不得向任何第三方泄漏。乙方因违反保密义务而给甲方造成损失的，应负相应的赔偿责任。\n4.尽管有上述规定，但本条款不适用以下信息：\n.依据法律法规的规定应当提供，行政、司法等职权部门要求提供的信息；\n.披露方同意接受方向第三方提供的信息；\n.不违反本协议的情况下，接受方从第三方合法正当接受的，不受保密限制的信息；\n.接受方未违反本协议的情况下即已公开或可以公开获得的信息；\n.法律法规所要求披露的信息。\n1.无论本协议是否变更、解除或终止，本协议保密条款不受其限制而继续有效，双方都应继续承担保密条款约定的保密义务。\n2.甲方为培训课程所制作的全部资料，在教学过程中产生的全部资料，甲方网站上所显示、使用或提供的软件、程序及内容，未经甲方同意，乙方在任何时候均不得以商业目的（包括但不限于将资料上传到乙方或其他方自媒体平台等）对上述资料进行利用；不得以任何方式翻译、复制、传播、编辑上述资料；不得删除、掩盖或更改甲方的版权声明、商标或其他权利声明/标签。\n.违约责任\n1.用户发生如下情形之一的，视为违约：\n（1）使用平台服务时违反有关法律法规规定的；\n（2）违反本协议或平台发布的规则的。\n1.如果本公司发现或收到他人举报您有违约行为的，本公司有权根据自身的判断，不经通知直接采取以下一项或多项处理措施：\n（1）对相关内容进行删除、屏蔽；\n（2）书面警告，以短信、邮件、站内信等一种或多种形式通知您要求您限期纠正该等行为；\n（3）限制、暂停、终止您使用部分或全部服务；\n（4）不退还任何的服务费用，且不进行任何的赔偿或补偿；\n（5）其他根据平台规则可采取的措施。\n1.如您的行为使本公司遭受损失的（包括但不限于被相关行政机关进行行政处罚或被第三人主张赔偿的），您应赔偿本公司的全部损失（包括但不限于直接经济损失、商誉损失及对外支付的赔偿金、和解款、律师费、诉讼费等经济损失）。\n.不允诺担保、责任有限及免责\n1.不允诺担保：甲方软件的用户提问、回答、发言仅代表用户个人观点，与甲方无关，且甲方不对用户发表的回答或评论的正确性、准确性、真实性进行保证。甲方为按现状提供，包含瑕疵及缺陷，甲方不提供任何其他担保。甲方不允诺其他无论是明示的还是默示的保证和担保，包括但不限于对特定目的的适销性和适应性，不侵权，以及任何出自交易过程或商业惯例的保证和条件。从甲方或他处获取的任何建议或信息，不论是口头的还是书面的，都不会对甲方产生本协议明确约定之外的其他保证和担保。\n2.责任有限：适用法律所允许的最大范围内，不论出于何种原因，甲方对您的全部责任为您为使用甲方的产品和服务而向甲方支付的费用总额。如果甲方免费向您提供了甲方服务，则甲方无义务对您承担任何赔偿责任。任何情况下，甲方不对出自本协议或与本协议有关的或与甲方的运行有关的任何特殊的、偶然的、惩罚性或间接的损害（包括但不限于数据损失、利润损失或营业损失）或采购替代产品承担责任，不论该等责任是基于合同，担保，侵权（包括过失），严格责任或其他，也不论甲方是否被事先告知了损失或损害发生的可能性。即使本协议约定的有限补救措施未能实现其根本目的，前述的责任限制依然适用。\n3.免责：如因下所列任何原因而造成的用户资料泄露、丢失、被盗用或被篡改等，甲方均有权获得免责：\n（1）任何因政府管制而造成的暂时性关闭等影响网络正常浏览的不可抗力原因；\n（2）任何计算机系统问题、黑客攻击、计算机病毒侵入或发作的原因；\n（3）任何因网络安全问题导致的账户或银行卡信息泄露，该风险可能会给用户造成经济损失，用户承诺自行承担向侵权方追究责任及追究责任不能的后果；\n（4）任何因用户个人原因导致的用户资料泄露、丢失、被盗用或被篡改等；\n（5）其他不能归责于甲方的原因。\n.合同终止与解除\n1.存在以下情况之一的，本公司将有权终止协议：\n（1）您主动中止或终止，包括但不限于课程到期未进行续费等；\n（2）因为您的违约行为，本公司主动中止或终止提供服务的；\n（3）因国家或相关政府监管部门要求或发生不可抗力事件时，本公司中止或终止服务的；\n（4）其他根据法律法规应中止或终止服务的。\n1.中止或终止服务后，本公司有权利但无需确保您收到特别提示或通知。当您发现无法登录或享受服务时，可以咨询客服人员。\n2.中止或终止后的处理\n（1）除法律规定的责任外，本公司对本服务的中止或终止对您和第三人不承担任何责任；\n（2）已收取的费用按照退款制度予以退还；\n（3）在本公司正在进行的交易，本公司将根据情况合理判断，是否继续进行或终止相关交易，并视情况决定是否进行退费或扣除相关费用作为违约金。\n1.除本协议另有约定情况外，本协议自您选择接受或使用本服务后生效，直至您终止本服务/注销账号时终止。\n.争议解决\n1.在本协议执行期间如果双方发生争议，双方应友好协商解决。如果协商不成，任何一方可向甲方所在地有管辖权的人民法院提请诉讼。\n2.诉讼期间，除争议内容以外，双方均应继续履行本协议约定的其他内容。\n.其他\n1.本协议自乙方注册提交信息之日起生效，本协议最终解释权归本公司所有，并保留一切解释和修改的权力。本协议其他条款未明示授权的其他一切权利仍由甲方保留，您在行使这些权利时须另外取得甲方的书面许可。甲方如果未行使前述任何权利，并不构成对该权利的放弃。\n2.若本协议的任何条款被享有合法管辖权的法院裁定为无效或不可执行，则该等条款应在最低必要范围内予以限制或排除，并以最能体现本用户协议意图的新条款予以替换，以使本用户协议继续完全有效。\n3.本用户协议构成甲方及乙方之间使用本软件相关的整体协议，并在此取代及取消甲方及乙方之间先前存在的与该等使用相关的任何书面或口头协议或理解（如有）。\n4.本协议的任何条款无论因何种原因无效或不具可执行性，其余条款仍有效，对双方具有约束力。\n5.乙方注册的账号和/或与账号绑定的微信账号是乙方接受平台服务的唯一身份凭证，由乙方负责保管。如因乙方原因造成损失，由乙方承担。\n6.乙方在使用软件时不可将个人隐私、商业秘密、国家机密等不得公开的信息发表、上传至甲方软件，也不可将该等信息通过甲方软件的服务传播给其他人。如因乙方原因造成损失，由乙方承担。\n7.乙方注册的账号/或与账号绑定的微信账号是乙方接受平台服务的唯一身份凭证，由乙方自行负责保管，禁止赠与、借用、租用、转让或者售卖。如因此给甲方造成损害，由乙方承担。\n8.如果您对本协议有任何疑问、意见或建议，通过以下方式与甲方联系：Email: games@sxybyte.com。";
                this.c_loader_biaoti.url = "ui://jyvm79orfkj2t";
            }
        }
        click_fanhui() {
            UIMgr.instance.closeUI("UIwendang");
        }
    }

    class UIyinsi extends UIBase$1 {
        constructor() {
            super(...arguments);
            this.c_btn_butongyi = null;
        }
        onOpen() {
            if (this.openData && this.openData == 2) {
                this.c_btn_butongyi.visible = false;
            }
            else {
                this.c_btn_butongyi.visible = true;
            }
        }
        click_close() {
            if (this.openData == 2) {
                UIMgr.instance.closeUI("UIyinsi1");
            }
            else {
                UIMgr.instance.closeUI("UIyinsi1");
                UIMgr.instance.openUI("UIyinsi2");
            }
        }
        click_tongyi() {
            if (this.openData == 2) {
                UIMgr.instance.closeUI("UIyinsi1");
            }
            else {
                this.closeUI(true);
                Laya.LocalStorage.setItem("firstXieyi", "1");
                UIMgr.instance.closeUI("UIyinsi1");
            }
        }
        click_butongyi() {
            UIMgr.instance.closeUI("UIyinsi1");
            UIMgr.instance.openUI("UIyinsi2");
        }
        click_yonghuxieyi() {
            UIMgr.instance.openUI("UIwendang", 2);
            console.log("AAAAA");
        }
        click_chanpinyinsishuoming() {
            console.log("BBBBBB");
            UIMgr.instance.openUI("UIwendang", 1);
        }
    }

    var E_UI_Banner_Type;
    (function (E_UI_Banner_Type) {
        E_UI_Banner_Type[E_UI_Banner_Type["NONE"] = 0] = "NONE";
        E_UI_Banner_Type[E_UI_Banner_Type["SHOW"] = 1] = "SHOW";
        E_UI_Banner_Type[E_UI_Banner_Type["HIDE"] = 2] = "HIDE";
    })(E_UI_Banner_Type || (E_UI_Banner_Type = {}));
    const ConfigCommonPackageUrl = "res/fgui/common";
    const Config = {
        Loading: {
            class: UILoading,
            package_name: "loading",
            component_name: "ui_loading",
            loadUrl: "loading/",
            isShowLoad: false,
            layer: 5,
            destroy_release_package: true,
            banner_state: E_UI_Banner_Type.NONE,
            setExtension: {},
            preUrls: () => [],
        },
        Main: {
            class: UIMain$1,
            package_name: "main",
            component_name: "ui_zhujiemian",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 1,
            destroy_release_package: true,
            banner_state: E_UI_Banner_Type.NONE,
            setExtension: {
                comp_guanqiajindu: Compgunaqia,
                comp_moveCtr: CompMoveCtr,
                comp_gou: CompDogKind,
                btn_gou2: DogKindItem,
                comp_zhiyin: ZhiyinTip,
                comp_jinbidonghua_kekong2: CompMoney,
                comp_bigMoney: BigMoneyTip,
            },
            preUrls: () => [],
        },
        UIMap: {
            class: UIMap,
            package_name: "guanqia",
            component_name: "ui_map",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 3,
            destroy_release_package: true,
            banner_state: E_UI_Banner_Type.NONE,
            setExtension: {
                btn_guanqia: MapItem,
            },
            preUrls: () => [],
        },
        Battle: {
            class: UIBattle,
            package_name: "main",
            component_name: "ui_game",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 1,
            destroy_release_package: true,
            banner_state: E_UI_Banner_Type.NONE,
            setExtension: {
                comp_moveCtr: CompMoveCtr,
            },
            preUrls: () => [],
        },
        Game: {
            class: Game,
            package_name: "game",
            component_name: "game",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 0,
            destroy_release_package: true,
            banner_state: E_UI_Banner_Type.NONE,
            setExtension: {},
            preUrls: () => [],
        },
        End: {
            class: UIEnd,
            package_name: "jiesuan",
            component_name: "ui_jiesuan",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 3,
            destroy_release_package: true,
            banner_state: E_UI_Banner_Type.SHOW,
            setExtension: {},
            preUrls: () => [],
        },
        Share: {
            class: UIShare,
            package_name: "share",
            component_name: "ui_share",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            destroy_release_package: true,
            banner_state: E_UI_Banner_Type.HIDE,
            setExtension: {},
            preUrls: () => [],
        },
        FreeMoney: {
            class: UIFreeMoney,
            package_name: "tanchuang",
            component_name: "ui_mianfei",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            destroy_release_package: false,
            banner_state: E_UI_Banner_Type.HIDE,
            setExtension: {},
            preUrls: () => [],
        },
        Invate: {
            class: UIInvate,
            package_name: "tanchuang",
            component_name: "ui_fenxiang",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            destroy_release_package: false,
            banner_state: E_UI_Banner_Type.HIDE,
            setExtension: {},
            preUrls: () => [],
        },
        Reward: {
            class: UIReward,
            package_name: "common",
            component_name: "ui_huode",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            destroy_release_package: true,
            banner_state: E_UI_Banner_Type.HIDE,
            preUrls: () => [],
        },
        UIAdExchangeMoney: {
            class: UIAdExchangeMoney,
            package_name: "main",
            component_name: "ui_mianfeichaopiao",
            loadUrl: "res/fgui/",
            isShowLoad: true,
            layer: 3,
            banner_state: E_UI_Banner_Type.SHOW,
            destroy_release_package: false,
            setExtension: {},
        },
        UIGlodAnimFly: {
            class: UIGlodAnimFly,
            package_name: "common",
            component_name: "comp_jinbidonghua_kekong",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 8,
            banner_state: E_UI_Banner_Type.HIDE,
            destroy_release_package: false,
            setExtension: {},
        },
        UISetting: {
            class: UISetting,
            package_name: "setting",
            component_name: "ui_setting",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 3,
            banner_state: E_UI_Banner_Type.SHOW,
            destroy_release_package: false,
        },
        Skin: {
            class: UISkin,
            package_name: "pifu",
            component_name: "ui_pifu",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 3,
            banner_state: E_UI_Banner_Type.HIDE,
            destroy_release_package: false,
            setExtension: {
                btn_zhanshi: UISkinItem,
            },
        },
        UIThings: {
            class: UIThings,
            package_name: "daoju",
            component_name: "ui_daoju",
            loadUrl: "res/fgui/",
            isShowLoad: true,
            layer: 2,
            banner_state: E_UI_Banner_Type.HIDE,
            destroy_release_package: false,
            setExtension: {
                comp_caidankuang: UIThingItem,
            },
        },
        TrySkin: {
            class: UITrySkin,
            package_name: "main",
            component_name: "ui_suijishiyong",
            loadUrl: "res/fgui/",
            isShowLoad: true,
            layer: 5,
            banner_state: E_UI_Banner_Type.SHOW,
            destroy_release_package: false,
            setExtension: {},
        },
        CompBoEffect: {
            class: UIComboEffect,
            package_name: "main",
            component_name: "comp_lianjiwenzi",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 888,
            banner_state: E_UI_Banner_Type.NONE,
            destroy_release_package: false,
        },
        FailEffect: {
            class: UIFailEffect,
            package_name: "main",
            component_name: "comp_bad",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 888,
            banner_state: E_UI_Banner_Type.NONE,
            destroy_release_package: false,
        },
        UILoad: {
            class: UILoad,
            package_name: "common",
            component_name: "ui_loading2",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 999,
            banner_state: E_UI_Banner_Type.HIDE,
            destroy_release_package: false,
        },
        ExChangeCode: {
            class: UIExChangeCode,
            package_name: "setting",
            component_name: "ui_duihuan",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            banner_state: E_UI_Banner_Type.HIDE,
            destroy_release_package: false,
        },
        UITebie: {
            class: UITebietiaozhan,
            package_name: "main",
            component_name: "ui_tebietiaozhan",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            banner_state: E_UI_Banner_Type.HIDE,
            destroy_release_package: false,
            setExtension: {
                comp_teshu: CompTeshu,
            },
        },
        UIGrow: {
            class: UIGrow,
            package_name: "main",
            component_name: "ui_grow",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 2,
            banner_state: E_UI_Banner_Type.NONE,
            destroy_release_package: false,
            setExtension: {},
        },
        UITishi: {
            class: UITishi,
            package_name: "main",
            component_name: "ui_tishi",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            banner_state: E_UI_Banner_Type.NONE,
            destroy_release_package: false,
            setExtension: {},
        },
        UIZahuodian: {
            class: UIZahuodian,
            package_name: "zahuodian",
            component_name: "ui_zahhuodian",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            banner_state: E_UI_Banner_Type.NONE,
            destroy_release_package: false,
            setExtension: {},
        },
        UIFreeVideo: {
            class: UIFreeVideo,
            package_name: "mianguanggao",
            component_name: "ui_miangg",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            banner_state: E_UI_Banner_Type.NONE,
            destroy_release_package: false,
            setExtension: {},
        },
        UIFreeBackVideo: {
            class: UIFreeBackVideo,
            package_name: "mianguanggao",
            component_name: "ui_wuxianchehui",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            banner_state: E_UI_Banner_Type.NONE,
            destroy_release_package: false,
            setExtension: {},
        },
        UIQiehuan: {
            class: UIQiehuan,
            package_name: "main",
            component_name: "ui_qiehuan",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            banner_state: E_UI_Banner_Type.NONE,
            destroy_release_package: false,
            setExtension: {
                comp_fenlan: QiehuanItem,
            },
        },
        UIOffline: {
            class: UIOffline,
            package_name: "tanchuang",
            component_name: "ui_lixian",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            banner_state: E_UI_Banner_Type.NONE,
            destroy_release_package: false,
            setExtension: {},
        },
        "UIyinsi1": {
            class: UIyinsi,
            package_name: "yinsizhengce",
            component_name: "ui_yinsi1",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            banner_state: E_UI_Banner_Type.NONE,
            destroy_release_package: false,
        },
        "UIyinsi2": {
            class: UIyinsi2,
            package_name: "yinsizhengce",
            component_name: "ui_yinsi2",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            banner_state: E_UI_Banner_Type.NONE,
            destroy_release_package: false,
        },
        "UIwendang": {
            class: UIwendang,
            package_name: "yinsizhengce",
            component_name: "ui_wendang",
            loadUrl: "res/fgui/",
            isShowLoad: false,
            layer: 5,
            banner_state: E_UI_Banner_Type.NONE,
            destroy_release_package: false,
        },
    };

    var E_UI_Parent;
    (function (E_UI_Parent) {
        E_UI_Parent[E_UI_Parent["none"] = 0] = "none";
        E_UI_Parent[E_UI_Parent["fight_ui"] = 1] = "fight_ui";
        E_UI_Parent[E_UI_Parent["fgui"] = 99] = "fgui";
        E_UI_Parent[E_UI_Parent["diamondsFly"] = 100] = "diamondsFly";
        E_UI_Parent[E_UI_Parent["tip"] = 101] = "tip";
    })(E_UI_Parent || (E_UI_Parent = {}));
    var E_UI_State;
    (function (E_UI_State) {
        E_UI_State[E_UI_State["None"] = 0] = "None";
        E_UI_State[E_UI_State["Load"] = 1] = "Load";
        E_UI_State[E_UI_State["Show"] = 2] = "Show";
        E_UI_State[E_UI_State["Hide"] = 3] = "Hide";
        E_UI_State[E_UI_State["Wait"] = 4] = "Wait";
        E_UI_State[E_UI_State["LoadError"] = 5] = "LoadError";
        E_UI_State[E_UI_State["LoadClose"] = 6] = "LoadClose";
    })(E_UI_State || (E_UI_State = {}));
    class UIMgr {
        constructor() {
            this.loadUrl = "";
            this.m_map_ui = new Maps$1();
            this.openUICount = {};
            this.isLoadCommonPackage = false;
        }
        getFguiUrl() {
            let urls = [];
            for (let key in Config) {
                let value = Config[key];
                Sets$1.add(urls, value.loadUrl);
            }
            return urls;
        }
        openUIByCompName(compName) {
            let ui_name = Maps$1.filterKey(Config, (v) => v.component_name == compName);
            this.openUI(ui_name);
        }
        openUI(ui_name, openData, openCb, closeCb) {
            let path = this.getPath(ui_name);
            if (!path) {
                console.error("openUI: 检查配置", ui_name);
                return;
            }
            this.getUIData(ui_name).closeCb = closeCb;
            let ui = this.getUIData(ui_name).ui;
            if (ui) {
                this.openUIed(ui, openData, openCb);
                return;
            }
            this.getUIData(ui_name).state = E_UI_State.Load;
            let isShowLoad = Config[ui_name].isShowLoad;
            if (isShowLoad)
                this.openUI("UILoad");
            this.load(ui_name, () => {
                if (isShowLoad)
                    this.closeUI("UILoad");
                if (this.getUIData(ui_name).state == E_UI_State.None) {
                    return;
                }
                ui = this.createUI(ui_name);
                this.openUIed(ui, openData, openCb);
            });
        }
        closeUI(ui_name, destroy = false) {
            let path = this.getPath(ui_name);
            if (!path) {
                console.error("closeUI: 检查配置", ui_name);
                return;
            }
            let state = this.getUIData(ui_name).state;
            switch (state) {
                case E_UI_State.None:
                    break;
                case E_UI_State.Show:
                    let ui = this.getUIData(ui_name).ui;
                    if (!ui) {
                        return;
                    }
                    let closeCb = this.getUIData(ui_name).closeCb;
                    if (destroy) {
                        this.destroyUI(ui_name);
                        this.emimOpenByCloseCb(ui_name, closeCb);
                    }
                    else {
                        this.getUIData(ui_name).state = E_UI_State.Hide;
                        this.setUIActive(ui, false, true);
                        this.emimOpenByCloseCb(ui_name, closeCb);
                        this.checkWaitUI();
                    }
                    break;
                case E_UI_State.Load:
                    this.getUIData(ui_name).state = E_UI_State.LoadClose;
                    break;
                case E_UI_State.Wait:
                    this.getUIData(ui_name).state = E_UI_State.Hide;
                    break;
                case E_UI_State.Hide:
                    break;
            }
        }
        emimOpenByCloseCb(ui_name, cb) {
            this.getUIData(ui_name).closeCb = null;
            if (cb) {
                cb();
            }
        }
        releaseUIPackage(ui_name) {
            let config = Config[ui_name];
            fgui.UIPackage.removePackage(config.package_name);
            ResourcesMgr$1.instance.release(this.getPath(ui_name) + "." + fgui.UIConfig.packageFileExtension);
        }
        destroyUI(ui_name) {
            let ui = this.getUIData(ui_name).ui;
            if (!ui) {
                console.error("请配置ui:", ui_name);
                return;
            }
            this.m_map_ui.delete(ui_name);
            this.setUIActive(ui, false, true);
            ui._onDestroy();
            ui.dispose();
            this.checkWaitUI();
        }
        closeAll(destroy = false) {
            this.m_map_ui.forEach((value, key) => {
                let state = this.getUIData(key).state;
                switch (state) {
                    case E_UI_State.Show:
                        this.getUIData(key).state = E_UI_State.Hide;
                        break;
                    case E_UI_State.Load:
                        this.getUIData(key).state = E_UI_State.LoadClose;
                        break;
                    case E_UI_State.Wait:
                        this.getUIData(key).state = E_UI_State.Hide;
                        break;
                }
                let closeCb = this.getUIData(key).closeCb;
                if (destroy)
                    this.destroyUI(key);
                else
                    this.setUIActive(this.getUIData(key).ui, false, true);
                this.emimOpenByCloseCb(key, closeCb);
            });
            if (destroy) {
                this.m_map_ui.clear();
            }
        }
        getPath(ui_name) {
            if (!Config[ui_name])
                return "";
            return this.loadUrl + Config[ui_name].loadUrl + Config[ui_name].package_name;
        }
        getUIData(ui_name) {
            if (ui_name == null) {
                return;
            }
            let value = this.m_map_ui.get(ui_name);
            if (!value) {
                value = {
                    state: E_UI_State.None,
                    ui: null,
                    closeCb: null,
                };
                this.m_map_ui.set(ui_name, value);
            }
            return value;
        }
        setUIActive(ui, value, is_cb) {
            let state = ui.visible;
            if (value) {
                ui.visible = true;
                if (!state && is_cb)
                    ui._onOpen();
            }
            else {
                ui.visible = false;
                if (state && is_cb) {
                    ui._onClose();
                }
            }
        }
        createUI(ui_name) {
            let value = Config[ui_name];
            if (!value) {
                console.error("请配置ui:", ui_name);
                return null;
            }
            if (value.setExtension)
                for (let key in value.setExtension)
                    FguiBase$3.setExtension(value.package_name, key, value.setExtension[key]);
            let ui = fairygui.UIPackage.createObject(value.package_name, value.component_name, value.class);
            if (!ui) {
                console.error("创建ui失败:", ui_name, value);
                return null;
            }
            ui.UI_NAME = ui_name;
            ui.name = ui_name;
            this.getUIData(ui_name).ui = ui;
            ui.makeFullScreen();
            if (this.getUIData(ui_name).state != E_UI_State.LoadClose) {
                this.getUIData(ui_name).state = E_UI_State.Hide;
            }
            let ui_parent = this.getParent(E_UI_Parent.fgui);
            let parent = FguiBase$3.insert_child(ui_parent, ui.layer);
            parent.addChild(ui);
            ui._onCreate();
            this.setUIActive(ui, false, false);
            return ui;
        }
        getParent(type) {
            if (!fgui.GRoot.inst.displayObject.parent) {
                Laya.stage.addChild(fgui.GRoot.inst.displayObject);
            }
            return FguiBase$3.insert_child(fgui.GRoot.inst, type);
        }
        checkWaitUI() {
            let wait_ui = this.findWaitUIMaxLevel();
            if (wait_ui) {
                console.log("close_ui 派发等待ui name:", wait_ui.UI_NAME);
                this.getUIData(wait_ui.UI_NAME).state = E_UI_State.Show;
                this.setUIActive(wait_ui, true, true);
            }
        }
        load(ui_name, cb) {
            Times$2.console("加载ui");
            if (ui_name == "Loading") {
                let urls = [this.getPath(ui_name)];
                let preUrls = Config[ui_name].preUrls;
                if (preUrls) {
                    if (typeof preUrls == "function")
                        urls.push(...preUrls());
                    else
                        urls.push(...preUrls);
                }
                ResourcesMgr$1.instance.loadDir(urls, () => {
                    Times$2.consoleEnd("加载ui", ui_name);
                    if (cb)
                        cb();
                });
                return;
            }
            this.loadCommonPackage(() => {
                let urls = [this.getPath(ui_name)];
                let preUrls = Config[ui_name].preUrls;
                if (preUrls) {
                    if (typeof preUrls == "function")
                        urls.push(...preUrls());
                    else
                        urls.push(...preUrls);
                }
                ResourcesMgr$1.instance.loadDir(urls, () => {
                    Times$2.consoleEnd("加载ui", ui_name);
                    if (cb)
                        cb();
                });
            });
        }
        loadCommonPackage(cb) {
            if (this.isLoadCommonPackage)
                cb();
            else
                ResourcesMgr$1.instance.load(ConfigCommonPackageUrl, cb);
        }
        openUIed(ui, openData, openCb) {
            let state = this.getUIData(ui.UI_NAME).state;
            if (this.openUICount[ui.UI_NAME] == undefined)
                this.openUICount[ui.UI_NAME] = 0;
            this.openUICount[ui.UI_NAME]++;
            switch (state) {
                case E_UI_State.Wait:
                    this.getUIData(ui.UI_NAME).state = E_UI_State.Hide;
                    this.openUIed(ui, openData, openCb);
                    break;
                case E_UI_State.Show:
                    if (openCb)
                        openCb(ui);
                    break;
                case E_UI_State.Hide:
                    let sameUI = this.find_show_and_level_ui(ui);
                    if (sameUI) {
                        this.getUIData(sameUI).state = E_UI_State.Wait;
                        this.setUIActive(this.getUIData(sameUI).ui, false, true);
                    }
                    this.getUIData(ui.UI_NAME).state = E_UI_State.Show;
                    ui.openData = openData;
                    this.setUIActive(ui, true, true);
                    if (openCb)
                        openCb(ui);
                    break;
                case E_UI_State.None:
                    break;
                case E_UI_State.Load:
                    break;
                case E_UI_State.LoadClose:
                    this.getUIData(sameUI).state = E_UI_State.Hide;
                    break;
                case E_UI_State.LoadError:
                    break;
            }
        }
        find_show_and_level_ui(ui) {
            let map = this.m_map_ui.maps;
            for (let key in map) {
                if (this.getUIData(key).state == E_UI_State.Show) {
                    if (ui.layer == this.getUIData(key).ui.layer)
                        return key;
                }
            }
            return null;
        }
        findWaitUIMaxLevel() {
            let map = this.m_map_ui.maps;
            let maxLayer = 0;
            let ui = null;
            for (let key in map) {
                if (this.getUIData(key).state == E_UI_State.Wait) {
                    let other_ui = this.getUIData(key).ui;
                    if (other_ui.layer >= maxLayer) {
                        maxLayer = other_ui.layer;
                        ui = other_ui;
                    }
                }
            }
            return ui;
        }
        getWaitUIs() {
            let map = this.m_map_ui.maps;
            let ui_names = [];
            for (let key in map) {
                if (this.getUIData(key).state == E_UI_State.Wait)
                    ui_names.push(key);
            }
            return ui_names;
        }
        hasOnceUIShow(ui_name) {
            let map = this.m_map_ui.maps;
            for (let key in map) {
                if (ui_name != key) {
                    if (this.getUIData(key).state == E_UI_State.Show)
                        return false;
                }
            }
            return true;
        }
        getOpenUICount(ui_name) {
            return this.openUICount[ui_name] || 0;
        }
        iconUrl(iconName, packagename = "common") {
            return "ui://" + packagename + "/" + iconName;
        }
        exchangeBtn(btn1, btn2, force = false) {
            if ((force || Math.floor(Math.random() * 100 + 1) < (GameSDK$1.data.ExchangeBtn || 0)) && btn1.parent == btn2.parent) {
                let pos = new Laya.Point(btn1.x, btn1.y);
                btn1.setXY(btn2.x, btn2.y);
                btn2.setXY(pos.x, pos.y);
                let parent = btn1.parent;
                let index = parent.getChildIndex(btn2);
                parent._children[parent.getChildIndex(btn1)] = btn2;
                parent._children[index] = btn1;
                return true;
            }
            else {
                return false;
            }
        }
    }
    UIMgr.instance = new UIMgr();

    var EPropNameById;
    (function (EPropNameById) {
        EPropNameById[EPropNameById["diamonds"] = 1] = "diamonds";
        EPropNameById[EPropNameById["key"] = 2] = "key";
        EPropNameById[EPropNameById["suipian"] = 3] = "suipian";
    })(EPropNameById || (EPropNameById = {}));
    class LogicProp {
        initData() { }
        add(id, count, isShowUI = false, mul = 1, closeCb = null) {
            let key = this.getCacheKey(id);
            let cur = this.get(id);
            let _useNumber = Maths$1.clampf(cur + count * mul, 0, this.config(id).MaxCount);
            if (cur != _useNumber)
                LocalCache$1.set(key, _useNumber);
            EventMgr$1.Int.emit(EventType$1.PROP_CHANGE, id);
            if (isShowUI) {
                UIMgr.instance.openUI("UIGlodAnimFly");
            }
        }
        has(id, count, isShowUI = false) {
            if (this.get(id) < count) {
                return false;
            }
            return true;
        }
        config(id) {
            return GameData.getPropItem(id);
        }
        get(id) {
            let key = this.getCacheKey(id);
            let count = this.config(id).StartCount;
            count = LocalCache$1.get(key, count);
            return count;
        }
        getCacheKey(type) {
            return "Prop_" + type;
        }
    }
    LogicProp.instance = new LogicProp();

    class ClickGift extends ViewBase {
        constructor() {
            super(...arguments);
            this.progress = null;
            this.tip1 = null;
            this.tip2 = null;
            this.callback = null;
            this.n9 = null;
            this.n3 = null;
            this.showBannerRatio = 50;
            this.pause = false;
            this.target_value = 0;
        }
        onCreate() {
            SDKEventMgr.Int.on(EventName.WECHAT_TOUCH_BANNER_AD, this.touch_banner_close, this);
            this.progress = this.getChildInGroup("progress", this.getChild("group1").asGroup).asProgress;
            this.n3 = this.getChildInGroup("n3", this.getChild("group1").asGroup).asImage;
            this.n9 = this.getChildInGroup("n9", this.getChild("group1").asGroup).asImage;
            let gift = this.random(0, 3);
            [this.getChildInGroup("chest1", this.getChild("group1").asGroup),
                this.getChildInGroup("chest2", this.getChild("group1").asGroup),
            ].map((a, i) => {
                a.visible = i == gift;
            });
            this.progress.value = 0;
            this.getChild("btn_click").onClick(this, this.btn_click);
            this.tip1 = this.getChild("tip1").asImage;
            this.tip2 = this.getChild("tip2").asImage;
            this.tip2.visible = false;
            this.getChild("btn_click").displayObject.addComponent(ButtonEffect);
            Laya.timer.frameLoop(1, this, this.enterframe);
            Laya.timer.loop(500, this, () => {
                if (this.pause) {
                    this.tip1.visible = false;
                    this.tip2.visible = false;
                }
                else {
                    this.tip1.visible = !this.tip1.visible;
                    this.tip2.visible = !this.tip1.visible;
                }
            });
        }
        enterframe() {
            this.n3.rotation++;
            this.n9.rotation += 0.8;
            if (this.pause)
                return;
            this.target_value -= 0.8;
            if (this.target_value < 0)
                this.target_value = 0;
            this.progress.value += (this.target_value - this.progress.value) * 0.2;
        }
        touch_banner_close() {
            SDKEventMgr.Int.off(EventName.WECHAT_TOUCH_BANNER_AD, this.touch_banner_close, this);
            GameSDK.updateErrorCount(ErrorCountType.BANNER);
            this.dispose();
            LogicProp.instance.add(EPropNameById.diamonds, 200, true);
            if (this.callback) {
                this.callback();
                this.callback = null;
            }
        }
        btn_click() {
            if (this.pause)
                return;
            this.target_value += 20;
            if (this.target_value >= this.showBannerRatio) {
                GameSDK.showBanner();
                Laya.timer.once(300, this, () => {
                    GameSDK.hideBanner();
                });
                if (this.showBannerRatio == 50) {
                    this.showBannerRatio = 75;
                }
                else if (this.showBannerRatio == 75) {
                    this.showBannerRatio = 90;
                }
                else if (this.target_value >= 100) {
                    this.pause = true;
                    this.progress.value = 100;
                    GameSDK.showADVideo(this, (state) => {
                        this.touch_banner_close();
                    }, "点击开宝箱");
                }
            }
            console.log("btn_click");
        }
    }

    class MoreGameTT extends ViewBase {
        constructor() {
            super(...arguments);
            this.callback = null;
            this._list = null;
            this.navigatedata = [];
        }
        onCreate() {
            GameSDK.banner.hide();
            this.getChild("btn_close").onClick(this, this.onClickCloseHandler);
            this._hotItem = this.getChild("btn_zuire");
            this._newItem = this.getChild("btn_zuixin");
            this.navigatedata = GameSDK.getNavigateList();
            this._list = this.getChild("list_icon").asList;
            this._list.itemRenderer = Laya.Handler.create(this, this.updataCellHandler, null, false);
            this._list.numItems = this.navigatedata.length;
            this.initHotItem();
            this.initNewItem();
        }
        initHotItem() {
            for (let i = 0; i < this.navigatedata.length; i += 1) {
                let temp = this.navigatedata[i];
                if (temp.weight == 99) {
                    this._hotItem.updataData(temp);
                    break;
                }
                else if (i == this.navigatedata.length - 1) {
                    this._hotItem.updataData(this.navigatedata[0]);
                }
            }
        }
        initNewItem() {
            for (let i = 0; i < this.navigatedata.length; i += 1) {
                let temp = this.navigatedata[i];
                if (temp.weight == 88) {
                    this._newItem.updataData(temp);
                    break;
                }
                else if (i == this.navigatedata.length - 1) {
                    this._newItem.updataData(this.navigatedata[0]);
                }
            }
        }
        updataCellHandler(index, view) {
            view.updataData(this.navigatedata[index]);
        }
        onClickCloseHandler() {
            GameSDK.banner.show();
            this.dispose();
            if (this.callback) {
                this.callback();
                this.callback = null;
            }
        }
    }
    MoreGameTT.ServerConfigKey = "is_MoreGameBtn";
    MoreGameTT.IntervalDisplayAD = new IntervalDisplayAD(MoreGameTT.ServerConfigKey);

    class AvdCellTTSmall extends ViewBase {
        onCreate() {
            this._icon = this.getChildByPath("comp_icon.loader_icon").asLoader;
            this._nameLab = this.getChildByPath("text_name").asTextField;
        }
        onClickByView() {
            if (this._data) {
                GameSDK.navigateToMiniGame(this._data);
                this.touchable = false;
                Laya.timer.once(100, this, () => {
                    this.touchable = true;
                });
            }
        }
        updataData(data) {
            if (this._data == data) {
                return;
            }
            this._data = data;
            if (data) {
                this._icon.url = this.randomItem(data.iconPath);
                this._nameLab.text = data.name;
            }
        }
    }

    class AvdCellTTItem extends ViewBase {
        onCreate() {
            this._icon = this.getChildByPath("btn_icon.loader_icon").asLoader;
            this._nameLab = this.getChildByPath("text_name").asTextField;
            this._controller = this.getController("c1");
        }
        onClickByView() {
            if (this._data) {
                GameSDK.navigateToMiniGame(this._data);
                this.touchable = false;
                Laya.timer.once(100, this, () => {
                    this.touchable = true;
                });
            }
        }
        updataData(data) {
            if (this._data == data) {
                return;
            }
            this._data = data;
            if (data) {
                this._icon.url = this.randomItem(data.iconPath);
                this._nameLab.text = data.name;
                if (this._data.weight == 99) {
                    this._controller.setSelectedIndex(1);
                }
                else if (this._data.weight == 88) {
                    this._controller.setSelectedIndex(2);
                }
                else {
                    this._controller.setSelectedIndex(0);
                }
            }
        }
    }

    class SDKViewMgr {
        static init(path = "res/fgui/", cb = null) {
            this._registfguiClass("moreBtn", MoreGameBtn);
            this._registfguiClass("FloatAd", AvdFloat);
            this._registfguiClass("EndListAd", AvdList);
            this._registfguiClass("boxItemBig", AvdCell);
            this._registfguiClass("boxItemSmall", AvdCell);
            this._registfguiClass("btn_small", AvdCellTTSmall);
            this._registfguiClass("comp_iconzhanshi", AvdCellTTItem);
            this._registfguiClass("com_screen_big", PropSceneUI);
            this._registfguiClass("com_screen_small", PropSceneUI);
            this._registfguiClass("com_clickgift", ClickGift);
            this._registfguiClass("comp_douyinhudao", MoreGameTT);
            this._registfguiClass("NativeAdBanner", NativeBanner);
            this._registfguiClass("Native", GameNative);
            this._registfguiClass("addDesk", AddDesk);
            fgui.UIPackage.loadPackage(path + this.packageName, Laya.Handler.create(this, cb));
        }
        static _registfguiClass(resName, type) {
            fgui.UIObjectFactory.setExtension("ui://" + this.packageName + "/" + resName, type);
        }
        static createObject(resName) {
            return fairygui.UIPackage.createObject(this.packageName, resName);
        }
        static popUpView(type, back = undefined, level = Number.MAX_SAFE_INTEGER) {
            if (type == PropType.BigItem && !PropSceneUI.IntervalDisplayAD.has()) {
                if (back)
                    back();
                return;
            }
            let view = this.createObject(type == PropType.BigItem ? "com_screen_big" : "com_screen_small");
            view.setCallback(level, back);
            view.makeFullScreen();
            fairygui.GRoot.inst.addChild(view);
        }
        static clickgift(callback = null) {
            let view = this.createObject("com_clickgift");
            view.makeFullScreen();
            view.callback = callback;
            fairygui.GRoot.inst.addChild(view);
        }
        static moreView(back = undefined) {
            if (!MoreGameTT.IntervalDisplayAD.has()) {
                if (back)
                    back();
                return;
            }
            if (GameSDK$1.type == PlatType$1.TOUTIAO) {
                let systemInfo = window["tt"].getSystemInfoSync();
                var isDouyin = systemInfo.appName === "Douyin";
                if (!isDouyin)
                    return;
            }
            let view = this.createObject("comp_douyinhudao");
            view.callback = back;
            view.makeFullScreen();
            fairygui.GRoot.inst.addChild(view);
        }
        static showNativeUI(node, ad_comp_name, btn_look, btn_continue, level, cb, su, fa) {
            let native = node.getChild(ad_comp_name);
            console.log("注册原生广告事件成功 level:", level);
            if (native.showNativeView) {
                native.showNativeView(node.getChild(btn_look).asButton, node.getChild(btn_continue).asButton, () => {
                    console.log("广告-点击继续");
                    if (cb)
                        cb();
                }, () => {
                    if (su)
                        su();
                }, () => {
                    if (fa)
                        fa();
                }, level);
            }
            else {
                console.log("没有注册原生广告 直接回调");
                if (cb)
                    cb();
            }
        }
    }
    SDKViewMgr.packageName = "gamesdk";

    class Momoyu extends BaseSDK {
        constructor() {
            super();
            this._requestList = [];
            this._isRequest = false;
            this._version = SDKConfig.MOMOYU_VERSION;
            this._bridge = ToolSDK.getBridge("demo.JSBridge");
            this.configURL = ``;
        }
        showADVideo(caller, onComplete, reason, args) {
            if (this._bridge == undefined) {
                return;
            }
            this._bridge.callWithBack(function (value) {
                var obj = JSON.parse(value);
                if (obj.code == 0) {
                    onComplete.call(caller, true);
                }
                else {
                    onComplete.call(caller, false);
                    console.log(obj.message);
                }
            }, "showADVideo", "");
        }
        createBanner() {
            if (this._bridge == undefined) {
                return;
            }
            this._bridge.callWithBack(function (value) {
                var obj = JSON.parse(value);
                if (obj.code == 0) ;
                else {
                    console.log(obj.message);
                }
            }, "createBanner", "");
        }
        showBanner() {
            if (this._bridge == undefined) {
                return;
            }
            this._isBannerShowing = true;
            this._bridge.callWithBack(function (value) {
                var obj = JSON.parse(value);
                if (obj.code == 0) ;
                else {
                    console.log(obj.message);
                }
            }, "showBanner", "");
        }
        hideBanner() {
            if (this._bridge == undefined) {
                return;
            }
            this._isBannerShowing = false;
            this._bridge.callWithBack(function (value) {
                var obj = JSON.parse(value);
                if (obj.code == 0) ;
                else {
                    console.log(obj.message);
                }
            }, "hideBanner", "");
        }
        onConfigLoad() {
            this._bridge.callWithBack((res) => {
                console.log("初始SDK成功");
            }, "initSdk", JSON.stringify(this.data));
        }
        request(value) {
            console.log("Momoyu.request", value);
            this._requestList.push(value);
            this.htmlRequest();
        }
        htmlRequest() {
            if (this._requestList.length <= 0 || this._isRequest) {
                return;
            }
            if (this._bridge == undefined) {
                return;
            }
            let value = this._requestList[0];
            var url = value.url;
            if (value.data) {
                let params = Object.keys(value.data).map(function (key) {
                    return encodeURIComponent(key) + "=" + encodeURIComponent(value.data[key]);
                }).join("&");
                url += "?" + params;
            }
            this._bridge.callWithBack(function (data) {
                var jsonData = JSON.parse(data);
                value.success({ code: 200, data: jsonData });
                this._requestList.splice(0, 1);
                this.htmlRequest();
            }.bind(this), "htmlRequest", url);
        }
    }

    var PlatType$1;
    (function (PlatType) {
        PlatType[PlatType["AUTO"] = -2] = "AUTO";
        PlatType[PlatType["TEST"] = -1] = "TEST";
        PlatType[PlatType["WEB"] = 0] = "WEB";
        PlatType[PlatType["TOUTIAO"] = 1] = "TOUTIAO";
        PlatType[PlatType["VIVO"] = 2] = "VIVO";
        PlatType[PlatType["OPPO"] = 3] = "OPPO";
        PlatType[PlatType["WECHAT"] = 5] = "WECHAT";
        PlatType[PlatType["HBS"] = 8] = "HBS";
        PlatType[PlatType["GAME233"] = 9] = "GAME233";
        PlatType[PlatType["GAMEUC"] = 10] = "GAMEUC";
        PlatType[PlatType["KUAIGAME"] = 11] = "KUAIGAME";
        PlatType[PlatType["MOMOYU"] = 13] = "MOMOYU";
        PlatType[PlatType["OPOPOAPP"] = 14] = "OPOPOAPP";
        PlatType[PlatType["MEIZU"] = 15] = "MEIZU";
    })(PlatType$1 || (PlatType$1 = {}));
    var PropType;
    (function (PropType) {
        PropType[PropType["BigItem"] = 0] = "BigItem";
        PropType[PropType["SmallItem"] = 1] = "SmallItem";
    })(PropType || (PropType = {}));
    var ClickType;
    (function (ClickType) {
        ClickType[ClickType["NativeAd"] = 0] = "NativeAd";
        ClickType[ClickType["PlayGame"] = 1] = "PlayGame";
        ClickType[ClickType["WaterFall"] = 2] = "WaterFall";
        ClickType[ClickType["EnterGame"] = 3] = "EnterGame";
    })(ClickType || (ClickType = {}));
    class GameSDK$1 {
        static getUserInfo(callback, isTips = true, target = undefined) {
            GameSDK$1.sdk.getUserInfo(callback, isTips, target);
        }
        static ShowInserAd() {
            if (this.OnlyOneTimes) {
                return;
            }
            this.OnlyOneTimes = true;
            if (this.isCurrentVersion) {
                return;
            }
            Laya.timer.loop(60 * 1000, this, () => {
                GameSDK$1.showADInsert();
            });
            Laya.timer.loop(58 * 1000, this, () => {
                GameSDK$1.showBanner();
            });
        }
        static ctor(value) {
            this.ctorData = value;
            for (let key in value)
                if (value[key] != undefined && SDKConfig[key] != undefined)
                    SDKConfig[key] = value[key];
            if (value.PlatType == PlatType$1.AUTO)
                value.PlatType = ToolSDK.GET_PLT();
            GameSDK$1.type = value.PlatType;
            SxyGame.instance.init();
            this.startGameTime = Date.now();
            let js = Web;
            switch (GameSDK$1.type) {
                case PlatType$1.TEST:
                    js = Web;
                    break;
                case PlatType$1.WEB:
                    js = Web;
                    break;
                case PlatType$1.KUAIGAME:
                    js = KuaiGame;
                    break;
                case PlatType$1.OPPO:
                    js = Oppo;
                    break;
                case PlatType$1.TOUTIAO:
                    js = Toutiao;
                    break;
                case PlatType$1.VIVO:
                    js = Vivo;
                    break;
                case PlatType$1.WECHAT:
                    js = WeChat;
                    break;
                case PlatType$1.HBS:
                    js = Hbs;
                    break;
                case PlatType$1.GAME233:
                    js = Game233;
                    break;
                case PlatType$1.GAMEUC:
                    js = GameUC;
                    break;
                case PlatType$1.MOMOYU:
                    js = Momoyu;
                    break;
            }
            this.sdk = new js();
            if (value.PltDefaultConfig) {
                let defaultConfig = value.PltDefaultConfig.filter((v) => v.key == this.type);
                if (defaultConfig.length > 0)
                    this.sdk.data = defaultConfig[0].value;
            }
        }
        static initConfig(cb) {
            this.sdk.initConfig(() => {
                cb && cb();
                if (this.ctorData.use_count_banner)
                    this.banner.checkDelayIsBanner();
            });
        }
        static init(type = PlatType$1.TEST, callBack = null, fgui_sdk_path = "res/fgui/") {
            this.ctor({
                PlatType: type,
                callBack,
                fgui_sdk_path,
            });
        }
        static get data() {
            return this.sdk.data;
        }
        static playerLevel(level) {
            this.level = level;
            console.log("sdk玩家等级：" + level);
        }
        static get isShow() {
            if (this.isCurrentVersion)
                return false;
            return true;
        }
        static get isCurrentVersion() {
            return this.sdk.isCurrentVersion();
        }
        static sendVideo(data) {
            this.sdk.sendVideo(data);
        }
        static stageOnStart(data) {
            this.sdk.stageOnStart(data);
        }
        static statgeOnRunning(data) {
            this.sdk.statgeOnRunning(data);
        }
        static stageOnEnd(data) {
            this.sdk.stageOnEnd(data);
        }
        static sendEvent(name, params = "") {
            this.sdk.sendEvent(name, params);
        }
        static get Nativecache() {
            if (this.sdk.data.Nativecache) {
                return this.sdk.data.Nativecache;
            }
            return 2;
        }
        static canClick(data, type) {
            if (this.sdk.playerFlag == PlayerFlag.CHANNEL0)
                return true;
            if (!this.isSupportErrorClick(data, type)) {
                return false;
            }
            if (type == ClickType.NativeAd) {
                var prop = Math.random();
                if (prop <= this.sdk.avdErrorProp()) {
                    this.updateErrorCount(ErrorCountType.NATIVE);
                    return true;
                }
                else {
                    return false;
                }
            }
            else if (type == ClickType.PlayGame) {
                var prop = Math.random();
                if (prop <= this.sdk.playGameErrorProp()) {
                    this.updateErrorCount(ErrorCountType.VIDEO);
                    return true;
                }
                else {
                    return false;
                }
            }
            else if (type == ClickType.WaterFall) {
                var prop = Math.random();
                if (prop <= this.sdk.waterFallErrorProp()) {
                    return true;
                }
                else {
                    return false;
                }
            }
            else if (type == ClickType.EnterGame) {
                var prop = Math.random();
                if (prop <= this.sdk.enterGameVideoProp()) {
                    this.updateErrorCount(ErrorCountType.VIDEO);
                    return true;
                }
                else {
                    return false;
                }
            }
        }
        static updateErrorCount(type) {
            let cCount = this.sdk.errorCount(type);
            this.sdk.updataAvdErrorCount(cCount + 1, type);
            console.log("更新最大次数", cCount + 1);
        }
        static showNativeUI(node, ad_comp_name, btn_look, btn_continue, level, cb, su, fa) {
            SDKViewMgr.showNativeUI(node, ad_comp_name, btn_look, btn_continue, level, cb, su, fa);
        }
        static baseChek() {
            if (this.sdk.playerFlag == PlayerFlag.CHANNEL0)
                return true;
            if (this.sdk.playerFlag == PlayerFlag.NO_AD) {
                console.log("标记未无广告用户-屏蔽");
                return false;
            }
            if (this.isOffCitys()) {
                return false;
            }
            if (this.isCurrentVersion) {
                return false;
            }
            return true;
        }
        static isSupportErrorClick(data, type) {
            if (this.sdk.playerFlag == PlayerFlag.CHANNEL0)
                return true;
            if (!this.baseChek()) {
                return false;
            }
            if (type == ClickType.NativeAd) {
                if (this.sdk.errorMaxCount(ErrorCountType.NATIVE) == 0) {
                    console.warn("isSupportErrorClick-误点未配置-屏蔽");
                    return false;
                }
                let cCount = this.sdk.errorCount(ErrorCountType.NATIVE);
                if (this.sdk.errorMaxCount(ErrorCountType.NATIVE) <= cCount) {
                    console.warn("isSupportErrorClick-误点上限-屏蔽");
                    return false;
                }
                if (this.sdk.avdErrorLevel() == 0) {
                    console.warn("isSupportErrorClick-avdErrorLevel误点未配置-屏蔽");
                    return false;
                }
                if (this.sdk.avdErrorProp() == 0)
                    return false;
                if (data.level < this.sdk.avdErrorLevel()) {
                    console.warn("isSupportErrorClick-误点等级-屏蔽");
                    return false;
                }
            }
            else if (type == ClickType.PlayGame) {
                if (this.sdk.errorMaxCount(ErrorCountType.VIDEO) == 0) {
                    console.warn("isSupportErrorClick-误点未配置-屏蔽");
                    return false;
                }
                let cCount = this.sdk.errorCount(ErrorCountType.VIDEO);
                if (this.sdk.errorMaxCount(ErrorCountType.VIDEO) <= cCount) {
                    console.warn("isSupportErrorClick-误点上限-屏蔽");
                    return false;
                }
                if (this.sdk.playGameLevel() == 0) {
                    console.warn("isSupportErrorClick-playGameLevel误点未配置-屏蔽");
                    return false;
                }
                if (this.sdk.playGameErrorProp() == 0)
                    return false;
                if (data.level < this.sdk.playGameLevel()) {
                    console.warn("isSupportErrorClick-误点等级-屏蔽");
                    return false;
                }
            }
            else if (type == ClickType.WaterFall) {
                if (this.sdk.errorMaxCount(ErrorCountType.BANNER) == 0) {
                    console.warn("isSupportErrorClick-误点未配置-屏蔽");
                    return false;
                }
                let cCount = this.sdk.errorCount(ErrorCountType.BANNER);
                if (this.sdk.errorMaxCount(ErrorCountType.BANNER) <= cCount) {
                    console.warn("isSupportErrorClick-误点上限-屏蔽");
                    return false;
                }
                if (this.sdk.waterFallErrorProp() == 0)
                    return false;
            }
            else if (type == ClickType.EnterGame) {
                if (this.sdk.errorMaxCount(ErrorCountType.VIDEO) == 0) {
                    console.warn("isSupportErrorClick-误点未配置-屏蔽");
                    return false;
                }
                let cCount = this.sdk.errorCount(ErrorCountType.VIDEO);
                if (this.sdk.errorMaxCount(ErrorCountType.VIDEO) <= cCount) {
                    console.warn("isSupportErrorClick-误点上限-屏蔽");
                    return false;
                }
                if (this.sdk.enterGameVideoProp() == 0)
                    return false;
            }
            return true;
        }
        static openMoreGameView(level) {
            if (this.isCurrentVersion)
                return false;
            if (!this.sdk.data)
                return false;
            if (!this.sdk.data.VideoJumpStartLevel)
                return false;
            if (!this.sdk.data.VideoJumpInterval)
                return false;
            if (level < parseInt(this.sdk.data.VideoJumpStartLevel))
                return false;
            if (level % parseInt(this.sdk.data.VideoJumpInterval) != 0)
                return false;
            SDKViewMgr.moreView(null);
            return true;
        }
        static EnterGame(level, back) {
            if (!this.baseChek())
                return false;
            if (!this.newenter) {
                if (back)
                    back();
                return false;
            }
            this.newenter = false;
            if (!GameSDK$1.canClick({ level: level }, ClickType.EnterGame)) {
                if (back)
                    back();
                return false;
            }
            if (this.sdk.data.Channel0Rule == undefined) {
                this.sdk.data.Channel0Rule = "1";
            }
            var Channel0Rule = parseInt(this.sdk.data.Channel0Rule);
            if (this.sdk.playerFlag == PlayerFlag.CHANNEL0) {
                console.log("渠道0用户", "渠道规则", Channel0Rule);
                if (Channel0Rule == 1) {
                    this.showADVideo(this, (state) => {
                        this.popUpClickGift(level, back);
                    }, "主动弹出广告");
                }
                else {
                    this.popUpClickGift(level, () => {
                        this.showADVideo(this, (state) => {
                            if (back)
                                back(state);
                        }, "主动弹出广告");
                    });
                }
            }
            else if (this.sdk.playerFlag == PlayerFlag.NOMAL_HAS_AD) {
                console.warn("EnterAd show");
                GameSDK$1.showADVideo(this, (state) => {
                    if (back)
                        back(state);
                }, "主动弹出广告");
                return true;
            }
            else {
                if (back)
                    back();
            }
        }
        static PlayGameAd(level, back) {
            if (!this.baseChek()) {
                if (back)
                    back();
                return false;
            }
            if (this.sdk.data.PlayGameAd == undefined) {
                console.warn("PlayGameAd-PlayGameAd-屏蔽");
                if (back)
                    back();
                return false;
            }
            var limitLevel = parseInt(this.sdk.data.PlayGameAd);
            if (limitLevel <= 0) {
                console.warn("PlayGameAd-limitLevel-屏蔽");
                if (back)
                    back();
                return false;
            }
            if (level < limitLevel) {
                console.warn("PlayGameAd-limitLevel-屏蔽");
                if (back)
                    back();
                return false;
            }
            if (!this.canClick({ level }, ClickType.PlayGame)) {
                if (back)
                    back();
                return false;
            }
            console.warn("EnterAd show");
            GameSDK$1.showADVideo(this, (state) => {
                if (back)
                    back(state);
            }, "点击开始游戏");
            return true;
        }
        static popUpClickGift(level, back) {
            if (this.sdk.playerFlag == PlayerFlag.CHANNEL0) {
                SDKViewMgr.clickgift(back);
                return true;
            }
            if (!this.baseChek()) {
                if (back)
                    back();
                return false;
            }
            let cCount = this.sdk.errorCount(ErrorCountType.BANNER);
            if (this.sdk.errorMaxCount(ErrorCountType.BANNER) <= cCount) {
                console.warn("isSupportErrorClick-误点上限-屏蔽");
                if (back)
                    back();
                return false;
            }
            if (this.sdk.data.ClickGift == undefined) {
                console.warn("popUpClickGift-ClickGift-屏蔽");
                if (back)
                    back();
                return false;
            }
            var limitLevel = parseInt(this.sdk.data.ClickGift);
            if (limitLevel <= 0) {
                console.warn("popUpClickGift-limitLevel-屏蔽");
                if (back)
                    back();
                return false;
            }
            if (level < limitLevel) {
                console.warn("popUpClickGift-limitLevel-屏蔽");
                if (back)
                    back();
                return false;
            }
            SDKViewMgr.clickgift(back);
            return true;
        }
        static popUPFullScreen(fullData, back) {
            console.log("popUPFullScreen");
            if (this.sdk.playerFlag == PlayerFlag.CHANNEL0) {
                if (fullData.proptype == PropType.BigItem) {
                    console.log("创建大界面");
                    SDKViewMgr.popUpView(PropType.BigItem, () => {
                        console.log("大界面关闭创建小界面");
                        SDKViewMgr.popUpView(PropType.SmallItem, back, fullData.level);
                    }, fullData.level);
                }
                else {
                    console.log("创建小界面");
                    SDKViewMgr.popUpView(PropType.SmallItem, back, fullData.level);
                }
                return true;
            }
            if (this.sdk.playerFlag == PlayerFlag.NO_AD) {
                console.log("标记未无广告用户-屏蔽");
                if (back)
                    back();
                return false;
            }
            if (this.isOffCitys()) {
                console.warn("popUPFullScreen-城市屏蔽");
                if (back)
                    back();
                return false;
            }
            if (this.isCurrentVersion) {
                console.warn("popUPFullScreen-版本屏蔽");
                if (back)
                    back();
                return false;
            }
            if (this.sdk.data.WaterfallAd == undefined) {
                console.warn("popUPFullScreen-WaterfallAd-屏蔽");
                if (back)
                    back();
                return false;
            }
            var limitLevel = parseInt(this.sdk.data.WaterfallAd);
            if (limitLevel <= 0) {
                console.warn("popUPFullScreen-limitLevel-屏蔽");
                if (back)
                    back();
                return false;
            }
            if (fullData.level < limitLevel) {
                console.warn("popUPFullScreen-limitLevel-屏蔽");
                if (back)
                    back();
                return false;
            }
            if (fullData.proptype == PropType.BigItem) {
                console.log("创建大界面");
                SDKViewMgr.popUpView(PropType.BigItem, () => {
                    console.log("大界面关闭创建小界面");
                    SDKViewMgr.popUpView(PropType.SmallItem, back, fullData.level);
                }, fullData.level);
            }
            else {
                console.log("创建小界面");
                SDKViewMgr.popUpView(PropType.SmallItem, back, fullData.level);
            }
            return true;
        }
        static addelay() {
            let time = 0;
            if (this.sdk.data && this.sdk.data.BtnTime)
                time = this.sdk.data.BtnTime * 1000;
            if (this.isCurrentVersion)
                time = 0;
            return time;
        }
        static get isShortCutInstalled() {
            return this.sdk.isShortCutInstalled;
        }
        static isOffCitys() {
            if (!this.sdk.cityData.loc)
                return false;
            var len = this.sdk.cityData.loc.length;
            var list = this.data.Offcitys || [];
            for (var i = 0; i < len; i += 1) {
                if (list.indexOf(this.sdk.cityData.loc[i]) >= 0) {
                    return true;
                }
            }
            return false;
        }
        static isOpenCitys() {
            if (!this.sdk.cityData.loc)
                return false;
            var len = this.sdk.cityData.loc.length;
            var list = this.data.OPLISTS || [];
            for (var i = 0; i < len; i += 1) {
                if (list.indexOf(this.sdk.cityData.loc[i]) >= 0) {
                    return true;
                }
            }
            return false;
        }
        static getHours() {
            let nowtime = this.sdk.cityData.nowtime;
            var date = new Date(nowtime);
            return date.getHours();
        }
        static getNavigateList() {
            let list = this.sdk.getNavigateList();
            return list;
        }
        static isAderrormaxcount() {
            if (this.sdk.data.aderrormaxcount == undefined) {
                return false;
            }
            if (this.sdk.data.aderrormaxcount <= 0 || this.level <= 0) {
                return false;
            }
            return this.sdk.data.aderrormaxcount <= this.level;
        }
        static OpenAutoFN() {
            this.sdk.OpenAutoFN();
        }
        static navigateToMiniGame(msg) {
            this.sdk.navigateToMiniGame(msg);
            console.log(msg);
        }
        static showBanner() {
            this.sdk.showBanner();
        }
        static resetBanner() {
            if (this.sdk instanceof WeChat) {
                this.sdk.resetBanner();
            }
        }
        static hideBanner() {
            this.sdk.hideBanner();
        }
        static isBannerShow() {
            return this.sdk._isBannerShowing;
        }
        static showADVideo(caller, onComplete, reason, args) {
            this.videoShowing = true;
            this.sdk.showADVideo(caller, onComplete, reason, args);
        }
        static TestFun() {
            Laya.timer.once(2500, this, () => {
                GameSDK$1.MyTurn = false;
                GameSDK$1.videoShowing = false;
                console.log("  onClose  GameSDK.videoShowing = -------------------", GameSDK$1.MyTurn);
            });
        }
        static startVideoRecord(time, callback) {
            this.sdk.startVideoRecord(time, callback);
        }
        static pauseVideoRecord() {
            this.sdk.pauseVideoRecord();
        }
        static resumeVideoRecord() {
            this.sdk.resumeVideoRecord();
        }
        static stopVideoRecord() {
            this.sdk.stopVideoRecord();
        }
        static shareVideoRecord(callback) {
            this.sdk.shareVideoRecord(callback);
        }
        static isSupportShareVideo() {
            return this.sdk.isSupportShareVideo();
        }
        static vibrateShort(type) {
            this.sdk.vibrateShort(type);
        }
        static vibrateLong() {
            this.sdk.vibrateLong();
        }
        static checkFollowState(callback) {
            this.sdk.checkFollowState(callback);
        }
        static openUserProfile(callback) {
            this.sdk.openUserProfile(callback);
        }
        static isConfigUIModel(key) {
            if (!key)
                return true;
            if (!GameSDK$1.sdk.data)
                return true;
            let value = GameSDK$1.sdk.data[key];
            if (value && value.state) {
                if (value.state == "1")
                    return true;
                else if (value.state == "0")
                    return false;
                else
                    return true;
            }
            return true;
        }
        static getConfigUIModelInterval(key) {
            if (!key)
                return 0;
            if (!GameSDK$1.sdk.data)
                return 0;
            let value = GameSDK$1.sdk.data[key];
            if (value && value.interval) {
                if (typeof value.interval == "string")
                    return Number(value.interval);
                else
                    return value.interval;
            }
            return 0;
        }
        static shortCutInstalled(callback) {
            this.sdk.shortCutInstalled(callback);
        }
        static checkShortcut(callback) {
            this.sdk.checkShortcut(callback);
        }
        static getLogicScene(callback) {
            this.sdk.getLogicScene(callback);
        }
        static VIDEOID() {
            console.log("----------------VIDEOID");
            if (this.sdk.data.VIDEOID == undefined) {
                return "";
            }
            console.log("----------------VIDEOID : " + this.sdk.data.VIDEOID);
            return this.sdk.data.VIDEOID;
        }
        static JUMP_OPS() {
            console.log("----------------JUMP_OPS");
            if (this.sdk.data.JUMP_OPS == undefined) {
                return 3;
            }
            console.log("----------------JUMP_OPS : " + this.sdk.data.JUMP_OPS);
            return this.sdk.data.JUMP_OPS;
        }
        static Click_Paroba() {
            if (this.sdk.data.Click_Proba == undefined) {
                return false;
            }
            console.log("----------------Click_Proba : " + this.sdk.data.Click_Proba);
            return Math.random() < this.sdk.data.Click_Proba;
        }
        static toClickGift(level, Frequency) {
            console.log("----------------Click_Control : " + this.sdk.data.Click_Control);
            console.log("----------------Click_City : " + this.sdk.data.Click_City);
            console.log("----------------Click_Frequency : " + this.sdk.data.Click_Frequency);
            console.log("----------------Click_Level : " + this.sdk.data.Click_Level);
            console.log("----------------Click_Times : " + this.sdk.data.Click_Times);
            if (this.sdk.data.Click_Control == undefined || this.sdk.data.Click_Control == 0) {
                return false;
            }
            if (this.sdk.data.Click_Level != undefined && this.sdk.data.Click_Level > level) {
                return false;
            }
            if (this.sdk.data.Click_Frequency != undefined && this.sdk.data.Click_Frequency <= Frequency) {
                return false;
            }
            if (this.sdk.data.Click_City != undefined && this.sdk.cityData && this.sdk.cityData.loc) {
                console.log("city : " + this.sdk.cityData.loc.join(","));
                if (this.sdk.cityData.loc.indexOf(this.sdk.data.Click_City) < 0) {
                    return false;
                }
            }
            if (this.sdk.data.Click_Times != undefined && this.sdk.cityData && this.sdk.cityData.nowtime) {
                var Click_Times = this.sdk.data.Click_Times;
                let nowtime = this.sdk.cityData.nowtime;
                var date = new Date(nowtime);
                var hour = date.getHours();
                var isOk = false;
                for (var i = 0; i < Click_Times.length; i += 2) {
                    if (i + 1 < Click_Times.length && hour >= Click_Times[i] && hour < Click_Times[i + 1]) {
                        isOk = true;
                    }
                }
                if (isOk == false) {
                    return false;
                }
            }
            return true;
        }
        static createNative(value) {
            return this.sdk.createNative(value);
        }
        static isOutAdSwitch() {
            if (this.isOffCitys()) {
                return false;
            }
            else {
                return this.sdk.data.isAdvert == 1;
            }
        }
        static openDanger() {
            if (this.isCurrentVersion) {
                return false;
            }
            if (this.isOffCitys()) {
                return false;
            }
            else {
                return this.sdk.data.openDanger == 1;
            }
        }
        static showToast(str, time = 1500) {
            this.sdk.showToast(str, time);
        }
        static needShowNative() {
            return this.type == PlatType$1.TEST || this.type == PlatType$1.OPPO || this.type == PlatType$1.VIVO;
        }
        static loadSubpackage(pack, zipFileName, topath, comlete, progress) {
            this.sdk.loadSubpackage(pack, zipFileName, topath, comlete, progress);
        }
        static isShowTime() {
            let newTime = Date.now();
            if (this.sdk.data.IntervalAdTime == null || this.sdk.data.IntervalAdTime == undefined)
                return false;
            if (newTime - this.startGameTime > this.sdk.data.IntervalAdTime * 1000) {
                return true;
            }
            return false;
        }
        static isOpenBanner() {
            if (!this.isShowTime())
                return false;
            return true;
        }
        static showADInsert() {
            this.sdk.showADInsert();
        }
        static shareMsg(caller, onComplete, reason, args) {
            this.sdk.shareMsg(caller, onComplete, reason, args);
        }
        static showGamePortal() {
            this.sdk.showGamePortal();
        }
        static showGameBanner() {
            this.sdk.showGameBanner();
        }
        static closeBoxBanner() {
            this.sdk.closeBoxBanner();
        }
        static hideGameBanner() {
            this.sdk.hideGameBanner();
        }
        static closeBoxPortalAd() {
            this.sdk.closeBoxPortalAd();
        }
        static showCustomAd(isPaster) {
            this.sdk.showCustomAd(isPaster);
        }
        static closeCustomAd() {
            this.sdk.closeCustomAd();
        }
        static compareVersion(curVersion, compareVersion) {
            let v1 = curVersion;
            if (!v1 || !v1.split)
                return 0;
            let v2 = compareVersion;
            if (!v2 || !v2.split)
                return 0;
            let v1Arr = v1.split(".");
            let v2Arr = v2.split(".");
            const len = Math.max(v1Arr.length, v2Arr.length);
            while (v1Arr.length < len) {
                v1Arr.push("0");
            }
            while (v2Arr.length < len) {
                v2Arr.push("0");
            }
            for (let i = 0; i < len; i++) {
                const num1 = parseInt(v1Arr[i]);
                const num2 = parseInt(v2Arr[i]);
                if (num1 > num2) {
                    return 1;
                }
                else if (num1 < num2) {
                    return -1;
                }
            }
            return 0;
        }
        static CloseType() {
            let t = this.sdk.data["closeType"];
            if (t) {
                return Number(t);
            }
            return 0;
        }
        static hideCustomAd(type) {
            if (this.sdk instanceof WeChat) {
                this.sdk.hideCustomAd(type);
            }
        }
        static isAdUser() {
            if (this.sdk instanceof WeChat) {
                if (this.isLimit()) {
                    return false;
                }
                let info = this.sdk.getLaunchOptionsSync();
                let adUser = LocalCache$1.get("LogicData._getAdUser", "");
                if (!!!adUser) {
                    if (!!info) {
                        if (!!info.query && info.query["weixinadinfo"] != undefined && info.query["gdt_vid"] != undefined) {
                            adUser = "gdt_vid";
                        }
                        else {
                            adUser = "normal";
                        }
                        LocalCache$1.set("LogicData._getAdUser", adUser);
                    }
                }
                ReportMgr.inst.sendReport("用户进入" + adUser, false);
                if (+this.data.openAdUser != 1) {
                    adUser = "gdt_vid";
                }
                return adUser == "gdt_vid";
            }
            return false;
        }
        static isBlackScene(scene) {
            if (!!this.sdk.data && this.sdk.data.blackScene != undefined) {
                let strs = this.sdk.data.blackScene.split(",");
                for (let i of strs) {
                    if (+i == scene) {
                        return true;
                    }
                }
                return false;
            }
            return true;
        }
        static isShortScreen() {
            if (this.sdk instanceof WeChat) {
                return this.sdk.isShortScreen();
            }
            return true;
        }
        static isLimit() {
            return this.isCurrentVersion || this.isOffCitys();
        }
        static login() {
            return new Promise((resolve, reject) => {
                if (this.sdk instanceof WeChat) {
                    this.sdk.login().then(data => {
                        resolve(data);
                    }).catch(e => {
                        reject(e);
                    });
                }
                else {
                    resolve(null);
                }
            });
        }
        static getShowTriggerVideo() {
            let showVideo = false;
            let open = +this.data.ShowTriggerOpen == 1;
            if (open) {
                this._showTriggerInt = +this.data.ShowTriggerInt || 500;
                if (this._showTriggerInt > 0) {
                    let now = Date.now();
                    if (!this.isLimit() && now - this._lastShowTriggerTime >= this._showTriggerInt * 1000) {
                        this._lastShowTriggerTime = now;
                        showVideo = true;
                    }
                }
            }
            return showVideo;
        }
        static get isNewPlayer() {
            let first = LocalCache$1.get("LogickData._isNewPlayer" + SDKConfig.GAMEID, true);
            if (first) {
                let now = Date.now();
                if (!!!this._createTime) {
                    this._createTime = LocalCache$1.get("LogicData._createTime" + SDKConfig.GAMEID, now);
                    if (this._createTime == now) {
                        ToolSDK.set_cache("LogicData._createTime" + SDKConfig.GAMEID, now + "");
                    }
                }
                if (now > new Date(new Date(this._createTime).toLocaleDateString()).getTime() + 24 * 60 * 60 * 1000 - 1) {
                    first = false;
                    ToolSDK.set_cache("LogickData._isNewPlayer" + SDKConfig.GAMEID, first + "");
                }
            }
            return first;
        }
        static get isFirstPlay() {
            let first = LocalCache$1.get("LogickData._isFirstPlay" + SDKConfig.GAMEID, true);
            if (first) {
                LocalCache$1.set("LogickData._isFirstPlay" + SDKConfig.GAMEID, false);
            }
            return first;
        }
    }
    GameSDK$1.type = PlatType$1.TEST;
    GameSDK$1.startGameTime = 0;
    GameSDK$1.level = 1;
    GameSDK$1.banner = new BannerMgr();
    GameSDK$1.ctorData = null;
    GameSDK$1.isDebug = false;
    GameSDK$1.isDecode = true;
    GameSDK$1.OnlyOneTimes = false;
    GameSDK$1.newenter = true;
    GameSDK$1.videoShowing = false;
    GameSDK$1._lastShowTriggerTime = 0;
    GameSDK$1._showTriggerInt = 500;
    let golab = window;
    golab.GameSDK = GameSDK$1;
    golab.PlatType = PlatType$1;
    golab.PropType = PropType;
    const SDKEventName = {
        LONG_TIME_NO_OPERATION: "LONG_TIME_NO_OPERATION",
        OpenAutoFN: "OpenAutoFN",
    };
    class SDKEventMgr {
        constructor() {
            this._eventMap = [];
            this.m_events = new Map();
        }
        static get Int() {
            if (!this._Int) {
                this._Int = new SDKEventMgr();
            }
            return this._Int;
        }
        on(name, callBack, caller) {
            if (!callBack || !caller)
                return;
            let event = this.m_events.get(name);
            if (!event) {
                event = [];
                this.m_events.set(name, event);
            }
            event.push({ callBack, caller });
        }
        emit(name, ...param) {
            let events = this.m_events.get(name);
            if (!events) {
                return;
            }
            for (let i = 0; i < events.length; i++) {
                let value = events[i];
                if (value)
                    value.callBack.call(value.caller, ...param);
            }
        }
        off(name, callBack, caller) {
            let events = this.m_events.get(name);
            if (!events)
                return;
            for (let i = 0; i < events.length; i++) {
                let value = events[i];
                if (value)
                    if (value.callBack == callBack && value.caller == caller) {
                        events.splice(i, 1);
                        return;
                    }
            }
        }
        offAll(name) {
            let events = this.m_events.get(name);
            if (!events) {
                return;
            }
            events.length = 0;
        }
    }
    var CustomType;
    (function (CustomType) {
        CustomType[CustomType["Left_Grid"] = 0] = "Left_Grid";
        CustomType[CustomType["Right_Grid"] = 1] = "Right_Grid";
        CustomType[CustomType["Bottom_Roll"] = 2] = "Bottom_Roll";
        CustomType[CustomType["Main_Rect"] = 3] = "Main_Rect";
    })(CustomType || (CustomType = {}));

    class GameConfig {
        constructor() { }
        static init() {
            Laya.ClassUtils.regClass;
        }
    }
    GameConfig.width = 750;
    GameConfig.height = 1334;
    GameConfig.scaleMode = "fixedwidth";
    GameConfig.screenMode = "vertical";
    GameConfig.alignV = "middle";
    GameConfig.alignH = "center";
    GameConfig.startScene = "Scene/Main.scene";
    GameConfig.sceneRoot = "";
    GameConfig.debug = false;
    GameConfig.stat = false;
    GameConfig.physicsDebug = false;
    GameConfig.exportSceneToJson = true;
    GameConfig.init();

    class SDKData {
        static get data() {
            return {
                PlatType: PlatType$1.AUTO,
                callBack: () => { },
                use_count_banner: false,
                fgui_sdk_path: "res/fgui/",
                GAMEID: "20299",
                VIVO_VERSION: "1.0.1",
                OPPO_VERSION: "1.0.0",
                TOUTIAO_VERSION: "1.0.0",
                TOUTIAO_GAME_NAME: "开个寿司店",
                TOUTIAO_SHARECONTENT: [
                    "开个寿司店"
                ],
                SHARE_CONTENT: [
                    "开个寿司店"
                ],
                TOUTIAO_SHARETEMPLATEID: [
                    "48ibsn03sic4s2korb"
                ],
                WECHAT_GAME_NAME: "开个寿司店",
                WECHAT_VERSION: "1.0.15",
                WECHAT_SHARECONTENT: [
                    ""
                ],
                WECHAT_SHARETEMPLATEID: [
                    { title: "开个寿司店! ", iconPath: "" }
                ],
                HBS_VERSION: "1.0.0",
                GAME233_APPKEY: "1606253762",
                GAME233_POS: "999000000",
                APP_IOS_APPID: "5171365",
                GAME233_POSVideo: "999000000",
                GAME233_POSVideoAll: "999000001",
                GAME233_POSBanner: "999000002",
                GAME233_POSInsert: "999000003",
                PltDefaultConfig: [
                    {
                        key: PlatType$1.TOUTIAO,
                        value: {
                            BannerAd: "b040ckfc5olbbodlkj",
                            InterstAd: "piobm148hak265k0k4",
                            InterstAds: ["piobm148hak265k0k4"],
                            IntervalAdTime: 3,
                            NativeAvd: false,
                            RewardAd: "ak8i6dbekagkh9619f",
                            addelay: 0,
                            appid: "ttb34ac5f72c74400402",
                            navigateAppList: [],
                            Offcitys: [],
                            OPLISTS: [],
                            REWARDAD_MAX: 0,
                            REWARDAD_RATE: 0,
                            REWARDAD_RESTART_GAME: 0,
                            HIDE_REWARDAD_RATE: 0,
                            HIDE_REWARDAD_MAX: 0,
                            shareList: [],
                            Shareid: "cg6jlbfg6ge327i1lj",
                            Version: "1.0.0",
                            playerSkinShield: "2,3,4,5,6",
                            "is_AddDesk": { state: "0" },
                            "is_AvdFloat": { state: "0" },
                            "is_AvdList": { state: "0" },
                            "is_GameNative": { state: "0", interval: 0 },
                            "is_MoreGameBtn": { state: "0" },
                            "is_PropSceneUI": { state: "0", interval: 0 },
                            "is_banner": { state: "1", interval: 0 },
                            "ad_all_interval": 0,
                        }
                    }, {
                        key: PlatType$1.OPPO,
                        value: {
                            BannerAd: "317030",
                            IntervalAdTime: 0,
                            NativeAd: 317032,
                            InterstAd: 317033,
                            RewardAd: "317031",
                            ad_all_interval: 10,
                            aderrormaxcount: 0,
                            ErrorProba: 0.2,
                            appid: "30521975",
                            GameBanner: "317033",
                            GamePortal: "304450",
                            is_AddDesk: { state: "1" },
                            is_AvdFloat: { state: "0" },
                            is_AvdList: { state: "0" },
                            is_GameNative: { state: "1", interval: 5 },
                            is_MoreGameBtn: { state: "1" },
                            is_PropSceneUI: { state: "0", interval: 5 },
                            is_banner: { state: "1", interval: "0" },
                            isaggreation: 5,
                            navigateAppList: [],
                            Offcitys: ["北京", "深圳", "广州", "深圳", "东莞", "天津", "长沙",
                                "武汉", "西安", "杭州", "宁波", "重庆", "南京", "苏州", "济南", "青岛", "福州", "厦门", "郑州"],
                            shareList: [],
                            textDelay: 0,
                            Version: "1.0.0",
                            waterfall: "0",
                        }
                    }, {
                        key: PlatType$1.KUAIGAME,
                        value: {
                            BannerAd: "",
                            IntervalAdTime: 0,
                            NativeAd: { HomeNativeAd: 297428, WinNativeAd: 297428, FailNativeAd: 297428 },
                            NativeAvd: false,
                            RewardedVideoAd: "2300000798_01",
                            ad_all_interval: 10,
                            aderrormaxcount: 0,
                            aderrorrate: 0.2,
                            appid: "ks709035469824743963",
                            is_AddDesk: { state: "0" },
                            is_AvdFloat: { state: "0" },
                            is_AvdList: { state: "0" },
                            is_GameNative: { state: "1", interval: 5 },
                            is_MoreGameBtn: { state: "0" },
                            is_PropSceneUI: { state: "0", interval: 5 },
                            is_banner: { state: "0", interval: "0" },
                            isaggreation: 5,
                            navigateAppList: [],
                            Offcitys: ["北京", "深圳", "广州", "深圳", "东莞", "天津", "长沙",
                                "武汉", "西安", "杭州", "宁波", "重庆", "南京", "苏州", "济南", "青岛", "福州", "厦门", "郑州"],
                            shareList: [],
                            textDelay: 0,
                            version: "1.0.0",
                            waterfall: "0",
                        }
                    }, {
                        key: PlatType$1.WECHAT,
                        value: {
                            BannerAd: "",
                            IntervalAdTime: 0,
                            NativeAd: { HomeNativeAd: 297428, WinNativeAd: 297428, FailNativeAd: 297428 },
                            NativeAvd: false,
                            RewardedVideoAd: "adunit-6e428e74c14eb1f9",
                            InterstAd: "adunit-1b7b57063945cf54",
                            ad_all_interval: 10,
                            aderrormaxcount: 0,
                            aderrorrate: 0.2,
                            appid: "wxfc379dfefaa93b2e",
                            is_AddDesk: { state: "0" },
                            is_AvdFloat: { state: "1" },
                            is_AvdList: { state: "1" },
                            is_GameNative: { state: "0", interval: 5 },
                            is_MoreGameBtn: { state: "1" },
                            is_PropSceneUI: { state: "1", interval: 5 },
                            is_banner: { state: "1", interval: "0" },
                            isaggreation: 5,
                            navigateAppList: [],
                            Offcitys: ["北京", "深圳", "广州", "深圳", "东莞", "天津", "长沙",
                                "武汉", "西安", "杭州", "宁波", "重庆", "南京", "苏州", "济南", "青岛", "福州", "厦门", "郑州"],
                            shareList: [{ "title": "痘痘，黑头，粉刺一个都不能留！ ", "iconPath": "" }],
                            textDelay: 0,
                            version: "1.0.15",
                            waterfall: "0",
                            customCfg: [{
                                    id: 'adunit-6eef84c5525809bf',
                                    top: 900,
                                    left: 0,
                                    side: 0
                                }, {
                                    id: 'adunit-b3accecbe171f0e2',
                                    top: 800,
                                    left: -68,
                                    side: 2
                                }, {
                                    id: 'adunit-d0d2647459e99154',
                                    top: 1100,
                                    left: -360,
                                    side: 1
                                }, {
                                    id: 'adunit-d40e451c6a218937',
                                    top: 280,
                                    left: 0,
                                    side: 0
                                }]
                        }
                    }
                ]
            };
        }
    }

    var E_UISignItem_State;
    (function (E_UISignItem_State) {
        E_UISignItem_State[E_UISignItem_State["\u672A\u9886\u53D6"] = 0] = "\u672A\u9886\u53D6";
        E_UISignItem_State[E_UISignItem_State["\u5DF2\u9886\u53D6"] = 1] = "\u5DF2\u9886\u53D6";
    })(E_UISignItem_State || (E_UISignItem_State = {}));
    class LogicSign {
        constructor() {
            this.signinfo = { sign_index: 0, sign_time: 0 };
        }
        initData() {
            this.signinfo = LocalCache$1.get("LogicSign.signinfo", this.signinfo);
        }
        save() {
            LocalCache$1.set("LogicSign.signinfo", this.signinfo);
        }
    }
    LogicSign.instance = new LogicSign();

    class LogicTurntable {
        constructor() {
            this.oddsTotal = 0;
            this._ticketNum = 0;
            this.rotateNum = 0;
            this.rotateLvl = 0;
            this.rewardMap = {};
        }
        static get instance() {
            if (this._instance == null) {
                this._instance = new LogicTurntable();
            }
            return this._instance;
        }
        static _randomsort(a, b) {
            return Math.random() > .5 ? -1 : 1;
        }
        init() {
            this.itemList = [];
            this.viewList = [];
            this.oddsTotal = 0;
            this.rewardIndex = 0;
            this.handlerRotateComplete = Laya.Handler.create(this, this.onRotateComplete, null, false);
        }
        getItemByIndex(index) {
            return this.itemList[index];
        }
        getItemRewardNum(item) {
            if (item)
                return this.rewardMap[item.key] | 0;
            else
                return 0;
        }
        calcRewardTimeLeft() {
            for (let i = 0; i < this.itemList.length; i++) {
                let item = this.itemList[i];
                if (item && item.rewardTime > 0 && this.getItemRewardNum(item) == 0) {
                    return item;
                }
            }
        }
        getRewardTimeLeft() {
            let item = this.calcRewardTimeLeft();
            if (item) {
                return item.rewardTime - this.rotateNum;
            }
            else {
                return -1;
            }
        }
        getItemIndex(item) {
            for (let i = 0; i < this.itemList.length; i++) {
                if (item == this.itemList[i]) {
                    return i;
                }
            }
            return 0;
        }
        getRandItemIndex() {
            let r = LogicTurntable.random(0, this.oddsTotal - 1);
            let r_range = 0;
            for (let i = 0; i < this.itemList.length; i++) {
                r_range += this.itemList[i].odds;
                if (r < r_range) {
                    return i;
                }
            }
            return 0;
        }
        addItem(item) {
            this.itemList.push(item);
            this.oddsTotal += item.odds;
        }
        addItemArray(array) {
            for (let item of array) {
                this.addItem(item);
            }
        }
        randomItem() {
            LogicTurntable.randomSort(this.itemList);
        }
        get ticketNum() {
            return this._ticketNum;
        }
        set ticketNum(v) {
            this._ticketNum = v;
        }
        initData() {
            this.ticketNum = LocalCache$1.get(LogicTurntable.KEY_LUCKWHEEL_TICKET_NUM, 1);
            this.rotateNum = LocalCache$1.get(LogicTurntable.KEY_LUCKWHEEL_ROTATE_NUM, 0);
            this.rotateLvl = LocalCache$1.get(LogicTurntable.KEY_LUCKWHEEL_ROTATE_LVL, 0);
            this.rewardMap = LocalCache$1.get(LogicTurntable.KEY_LUCKWHEEL_REWARD_MAP, {});
        }
        bindView(view) {
            this.view = view;
        }
        addItemView(obj) {
            this.viewList.push(obj);
        }
        refreshView() {
            for (let i = 0; i < this.viewList.length; i++) {
                let view = this.viewList[i];
                let item = this.itemList[i];
                if (item) {
                    this.view.renderItemView(view, this.verifyItem(item).data);
                }
            }
        }
        verifyItem(item) {
            if (this.getItemRewardNum(item) > 0 && item.nextItem) {
                return this.verifyItem(item.nextItem);
            }
            else {
                return item;
            }
        }
        getTicketNum() {
            return this.ticketNum;
        }
        getRotateNum() {
            return this.rotateNum;
        }
        getRotateLvl() {
            return this.rotateLvl;
        }
        rotateWheelWithTicket() {
            if (this.ticketNum > 0) {
                this.ticketNum--;
                LocalCache$1.set(LogicTurntable.KEY_LUCKWHEEL_TICKET_NUM, this.ticketNum);
                this.rotateWheel();
            }
        }
        rotateWheel() {
            if (this.actionTurn)
                return;
            this.rotateNum++;
            let item = this.calcRewardTimeLeft();
            if (item && item.rewardTime == this.rotateNum) {
                this.rewardIndex = this.getItemIndex(item);
                this.rotateNum = 0;
            }
            else {
                this.rewardIndex = this.getRandItemIndex();
            }
            LocalCache$1.set(LogicTurntable.KEY_LUCKWHEEL_ROTATE_NUM, this.rotateNum);
            this.rotateToItemByIndex(this.rewardIndex);
        }
        clearAction() {
            if (this.actionTurn) {
                this.actionTurn.clear();
                this.actionTurn = null;
            }
        }
        rotateToItemByIndex(index) {
            this.clearAction();
            let r = LogicTurntable.random(2, 4);
            let degreeItem = -360 / this.itemList.length;
            let targetDegree = degreeItem * index + 360 * (1 + r);
            let luckWheel = this.view.luckWheel;
            luckWheel.rotation = luckWheel.rotation % 360;
            this.actionTurn = Laya.Tween.to(luckWheel, {
                rotation: targetDegree,
            }, 1000 * r, Laya.Ease.sineOut, this.handlerRotateComplete);
        }
        addItemRewardNum(item) {
            let rewardNum = this.rewardMap[item.key] | 0;
            this.rewardMap[item.key] = rewardNum + 1;
            LocalCache$1.set(LogicTurntable.KEY_LUCKWHEEL_REWARD_MAP, this.rewardMap);
        }
        onRotateComplete() {
            this.clearAction();
            let item = this.verifyItem(this.getItemByIndex(this.rewardIndex));
            this.addItemRewardNum(item);
            if (item.rewardTime > 0 && this.calcRewardTimeLeft()) {
                this.rotateNum = 0;
                LocalCache$1.set(LogicTurntable.KEY_LUCKWHEEL_ROTATE_NUM, this.rotateNum);
            }
            this.view.onRewardItem(item.data);
        }
    }
    LogicTurntable.KEY_LUCKWHEEL_TICKET_NUM = "KEY_LUCKWHEEL_TICKET_NUM";
    LogicTurntable.KEY_LUCKWHEEL_ROTATE_NUM = "KEY_LUCKWHEEL_ROTATE_NUM";
    LogicTurntable.KEY_LUCKWHEEL_ROTATE_LVL = "KEY_LUCKWHEEL_ROTATE_LVL";
    LogicTurntable.KEY_LUCKWHEEL_REWARD_MAP = "KEY_LUCKWHEEL_REWARD_MAP";
    LogicTurntable._instance = null;
    LogicTurntable.randomSort = function (array) {
        array.sort(this._randomsort);
    };
    LogicTurntable.random = function (min, max) {
        return Math.round(Math.random() * (max - min) + min);
    };

    var DownTimeVS = "#if defined(GL_FRAGMENT_PRECISION_HIGH)\nprecision highp float;precision highp int;\n#else\nprecision mediump float;precision mediump int;\n#endif\n#include \"Lighting.glsl\";\n#include \"LayaUtile.glsl\"\n#include \"Shadow.glsl\";\nattribute vec4 a_Position;\n#ifdef GPU_INSTANCE\nuniform mat4 u_ViewProjection;\n#else\nuniform mat4 u_MvpMatrix;\n#endif\nattribute vec2 a_Texcoord0;varying vec2 v_Texcoord0;attribute vec2 a_Texcoord1;varying vec2 v_Texcoord1;\n#ifdef LIGHTMAP\nuniform vec4 u_LightmapScaleOffset;varying vec2 v_LightMapUV;\n#endif\n#ifdef COLOR\nattribute vec4 a_Color;varying vec4 v_Color;\n#endif\n#ifdef BONE\nconst int c_MaxBoneCount=24;attribute vec4 a_BoneIndices;attribute vec4 a_BoneWeights;uniform mat4 u_Bones[c_MaxBoneCount];\n#endif\nattribute vec3 a_Normal;varying vec3 v_Normal;\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\nuniform vec3 u_CameraPos;varying vec3 v_ViewDir;\n#endif\n#if defined(NORMALMAP)\nattribute vec4 a_Tangent0;varying vec3 v_Tangent;varying vec3 v_Binormal;\n#endif\n#ifdef GPU_INSTANCE\nattribute mat4 a_WorldMat;\n#else\nuniform mat4 u_WorldMat;\n#endif\nvarying vec3 v_PositionWorld;\n#if defined(CALCULATE_SHADOWS)&&!defined(SHADOW_CASCADE)\nvarying vec4 v_ShadowCoord;\n#endif\n#if defined(CALCULATE_SPOTSHADOWS)\nvarying vec4 v_SpotShadowCoord;\n#endif\nuniform vec4 u_TilingOffset;void main(){vec4 position;\n#ifdef BONE\nmat4 skinTransform;\n#ifdef SIMPLEBONE\nfloat currentPixelPos;\n#ifdef GPU_INSTANCE\ncurrentPixelPos=a_SimpleTextureParams.x+a_SimpleTextureParams.y;\n#else\ncurrentPixelPos=u_SimpleAnimatorParams.x+u_SimpleAnimatorParams.y;\n#endif\nfloat offset=1.0/u_SimpleAnimatorTextureSize;skinTransform=loadMatFromTexture(currentPixelPos,int(a_BoneIndices.x),offset)*a_BoneWeights.x;skinTransform+=loadMatFromTexture(currentPixelPos,int(a_BoneIndices.y),offset)*a_BoneWeights.y;skinTransform+=loadMatFromTexture(currentPixelPos,int(a_BoneIndices.z),offset)*a_BoneWeights.z;skinTransform+=loadMatFromTexture(currentPixelPos,int(a_BoneIndices.w),offset)*a_BoneWeights.w;\n#else\nskinTransform=u_Bones[int(a_BoneIndices.x)]*a_BoneWeights.x;skinTransform+=u_Bones[int(a_BoneIndices.y)]*a_BoneWeights.y;skinTransform+=u_Bones[int(a_BoneIndices.z)]*a_BoneWeights.z;skinTransform+=u_Bones[int(a_BoneIndices.w)]*a_BoneWeights.w;\n#endif\nposition=skinTransform*a_Position;\n#else\nposition=a_Position;\n#endif\nmat4 worldMat;\n#ifdef GPU_INSTANCE\nworldMat=a_WorldMat;\n#else\nworldMat=u_WorldMat;\n#endif\n#ifdef GPU_INSTANCE\ngl_Position=u_ViewProjection*worldMat*position;\n#else\ngl_Position=u_MvpMatrix*position;\n#endif\nmat3 worldInvMat;\n#ifdef BONE\nworldInvMat=INVERSE_MAT(mat3(worldMat*skinTransform));\n#else\nworldInvMat=INVERSE_MAT(mat3(worldMat));\n#endif\nv_Normal=normalize(a_Normal*worldInvMat);\n#if defined(NORMALMAP)\nv_Tangent=normalize(a_Tangent0.xyz*worldInvMat);v_Binormal=cross(v_Normal,v_Tangent)*a_Tangent0.w;\n#endif\nvec3 positionWS=(worldMat*position).xyz;\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)||(defined(CALCULATE_SHADOWS)&&defined(SHADOW_CASCADE))||defined(CALCULATE_SPOTSHADOWS)\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\nv_ViewDir=u_CameraPos-positionWS;\n#endif\n#endif\nv_PositionWorld=positionWS;v_Texcoord0=TransformUV(a_Texcoord0,u_TilingOffset);\n#ifdef LIGHTMAP\n#ifdef UV1\nv_LightMapUV=vec2(a_Texcoord1.x,1.0-a_Texcoord1.y)*u_LightmapScaleOffset.xy+u_LightmapScaleOffset.zw;\n#else\nv_LightMapUV=vec2(a_Texcoord0.x,1.0-a_Texcoord0.y)*u_LightmapScaleOffset.xy+u_LightmapScaleOffset.zw;\n#endif\nv_LightMapUV.y=1.0-v_LightMapUV.y;\n#endif\nv_Texcoord1=a_Texcoord1;\n#if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\nv_Color=a_Color;\n#endif\n#if defined(CALCULATE_SHADOWS)&&!defined(SHADOW_CASCADE)\nv_ShadowCoord=getShadowCoord(vec4(positionWS,1.0));\n#endif\n#if defined(CALCULATE_SPOTSHADOWS)\nv_SpotShadowCoord=u_SpotViewProjectMatrix*vec4(positionWS,1.0);\n#endif\ngl_Position=remapGLPositionZ(gl_Position);}";

    var DownTimeFS = "#if defined(GL_FRAGMENT_PRECISION_HIGH)\nprecision highp float;precision highp int;\n#else\nprecision mediump float;precision mediump int;\n#endif\n#include \"Lighting.glsl\";\n#include \"Shadow.glsl\"\nuniform vec4 u_DiffuseColor;uniform float u_AlbedoIntensity;\n#if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\nvarying vec4 v_Color;\n#endif\n#ifdef ALPHATEST\nuniform float u_AlphaTestValue;\n#endif\n#ifdef DIFFUSEMAP\nuniform sampler2D u_DiffuseTexture;\n#endif\nvarying vec2 v_Texcoord0;varying vec2 v_Texcoord1;\n#ifdef LIGHTMAP\nvarying vec2 v_LightMapUV;uniform sampler2D u_LightMap;\n#ifdef LIGHTMAP_DIRECTIONAL\nuniform sampler2D u_LightMapDirection;\n#endif\n#endif\nvarying vec3 v_Normal;\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\nvarying vec3 v_ViewDir;uniform vec3 u_MaterialSpecular;uniform float u_Shininess;\n#ifdef LEGACYSINGLELIGHTING\n#ifdef DIRECTIONLIGHT\nuniform DirectionLight u_DirectionLight;\n#endif\n#ifdef POINTLIGHT\nuniform PointLight u_PointLight;\n#endif\n#ifdef SPOTLIGHT\nuniform SpotLight u_SpotLight;\n#endif\n#else\nuniform mat4 u_View;uniform vec4 u_ProjectionParams;uniform vec4 u_Viewport;uniform int u_DirationLightCount;uniform sampler2D u_LightBuffer;uniform sampler2D u_LightClusterBuffer;\n#endif\n#ifdef SPECULARMAP\nuniform sampler2D u_SpecularTexture;\n#endif\n#endif\n#ifdef NORMALMAP\nuniform sampler2D u_NormalTexture;varying vec3 v_Tangent;varying vec3 v_Binormal;\n#endif\n#ifdef FOG\nuniform float u_FogStart;uniform float u_FogRange;uniform vec3 u_FogColor;\n#endif\nvarying vec3 v_PositionWorld;\n#include \"GlobalIllumination.glsl\";\n#if defined(CALCULATE_SHADOWS)&&!defined(SHADOW_CASCADE)\nvarying vec4 v_ShadowCoord;\n#endif\n#if defined(CALCULATE_SPOTSHADOWS)\nvarying vec4 v_SpotShadowCoord;\n#endif\n#ifdef TCP2_RAMPTEXT\nuniform sampler2D u_RampTexture;\n#endif\nuniform float u_RampThreshold;uniform float u_RampSmooth;uniform vec4 u_HColor;uniform vec4 u_SColor;void main(){vec3 normal;\n#if defined(NORMALMAP)\nvec3 normalMapSample=texture2D(u_NormalTexture,v_Texcoord0).rgb;normal=normalize(NormalSampleToWorldSpace(normalMapSample,v_Normal,v_Tangent,v_Binormal));\n#else\nnormal=normalize(v_Normal);\n#endif\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\nvec3 viewDir=normalize(v_ViewDir);\n#endif\nLayaGIInput giInput;\n#ifdef LIGHTMAP\ngiInput.lightmapUV=v_LightMapUV;\n#endif\nvec3 globalDiffuse=layaGIBase(giInput,1.0,normal);vec4 mainColor=u_DiffuseColor*u_AlbedoIntensity;\n#ifdef DIFFUSEMAP\nvec4 difTexColor=texture2D(u_DiffuseTexture,v_Texcoord0);mainColor=mainColor*difTexColor;\n#endif\n#if defined(COLOR)&&defined(ENABLEVERTEXCOLOR)\nmainColor=mainColor*v_Color;\n#endif\nvec3 diffuse=vec3(0.0);vec3 specular=vec3(0.0);vec3 transmissionDiffuse=vec3(0.0);\n#if defined(DIRECTIONLIGHT)||defined(POINTLIGHT)||defined(SPOTLIGHT)\nvec3 dif,spe,transmis;float transmissionFactor;\n#ifdef SPECULARMAP\nvec3 gloss=texture2D(u_SpecularTexture,v_Texcoord0).rgb;\n#else\n#ifdef DIFFUSEMAP\nvec3 gloss=vec3(difTexColor.a);\n#else\nvec3 gloss=vec3(1.0);\n#endif\n#endif\n#ifdef THICKNESSMAP\ntransmissionFactor=texture2D(u_ThinknessTexture,v_Texcoord0).r;\n#endif\n#endif\nDirectionLight directionLight;\n#ifdef LEGACYSINGLELIGHTING\n#ifdef DIRECTIONLIGHT\ndirectionLight=u_DirectionLight;\n#endif\n#else\n#ifdef DIRECTIONLIGHT\ndirectionLight=getDirectionLight(u_LightBuffer,0);\n#endif\n#endif\nfloat NdotL=max(0.0,dot(normal,directionLight.direction*-1.0)*0.5+0.5);vec3 ramp=vec3(0.0);\n#ifdef TCP2_RAMPTEXT\nramp=texture2D(u_RampTexture,vec2(NdotL,NdotL)).rgb;\n#else\nramp=smoothstep(vec3(u_RampThreshold-u_RampSmooth*0.5),vec3(u_RampThreshold+u_RampSmooth*0.5),vec3(NdotL));\n#endif\nvec4 sColor=mix(u_HColor,u_SColor,u_SColor.a);ramp=mix(sColor.rgb,u_HColor.rgb,ramp);ramp+=(globalDiffuse*directionLight.color*gloss);mainColor.rgb=mainColor.rgb*ramp;gl_FragColor=mainColor;/*\n#ifdef LEGACYSINGLELIGHTING\n#ifdef DIRECTIONLIGHT\nLayaAirBlinnPhongDiectionLight(u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,u_DirectionLight,transmissionFactor,dif,spe,transmis);\n#if defined(CALCULATE_SHADOWS)\n#ifdef SHADOW_CASCADE\nvec4 shadowCoord=getShadowCoord(vec4(v_PositionWorld,1.0));\n#else\nvec4 shadowCoord=v_ShadowCoord;\n#endif\nfloat shadowAttenuation=sampleShadowmap(shadowCoord);dif*=shadowAttenuation;spe*=shadowAttenuation;transmis*=shadowAttenuation;\n#endif\ndiffuse+=dif;specular+=spe;transmissionDiffuse+=transmis;\n#endif\n#ifdef POINTLIGHT\nLayaAirBlinnPhongPointLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,u_PointLight,transmissionFactor,dif,spe,transmis);diffuse+=dif;specular+=spe;transmissionDiffuse+=transmis;\n#endif\n#ifdef SPOTLIGHT\nLayaAirBlinnPhongSpotLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,u_SpotLight,transmissionFactor,dif,spe,transmis);\n#if defined(CALCULATE_SPOTSHADOWS)\nvec4 spotShadowcoord=v_SpotShadowCoord;float spotShadowAttenuation=sampleSpotShadowmap(spotShadowcoord);dif*=spotShadowAttenuation;spe*=spotShadowAttenuation;transmis*=spotShadowAttenuation;\n#endif\ndiffuse+=dif;specular+=spe;transmissionDiffuse+=transmis;\n#endif\n#else\n#ifdef DIRECTIONLIGHT\nfor(int i=0;i<MAX_LIGHT_COUNT;i++){if(i>=u_DirationLightCount)break;DirectionLight directionLight=getDirectionLight(u_LightBuffer,i);\n#if defined(CALCULATE_SHADOWS)\nif(i==0){\n#ifdef SHADOW_CASCADE\nvec4 shadowCoord=getShadowCoord(vec4(v_PositionWorld,1.0));\n#else\nvec4 shadowCoord=v_ShadowCoord;\n#endif\ndirectionLight.color*=sampleShadowmap(shadowCoord);}\n#endif\nLayaAirBlinnPhongDiectionLight(u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,directionLight,transmissionFactor,dif,spe,transmis);diffuse+=dif;specular+=spe;transmissionDiffuse+=transmis;}\n#endif\n#if defined(POINTLIGHT)||defined(SPOTLIGHT)\nivec4 clusterInfo=getClusterInfo(u_LightClusterBuffer,u_View,u_Viewport,v_PositionWorld,gl_FragCoord,u_ProjectionParams);\n#ifdef POINTLIGHT\nfor(int i=0;i<MAX_LIGHT_COUNT;i++){if(i>=clusterInfo.x)break;PointLight pointLight=getPointLight(u_LightBuffer,u_LightClusterBuffer,clusterInfo,i);LayaAirBlinnPhongPointLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,pointLight,transmissionFactor,dif,spe,transmis);diffuse+=dif;specular+=spe;transmissionDiffuse+=transmis;}\n#endif\n#ifdef SPOTLIGHT\nfor(int i=0;i<MAX_LIGHT_COUNT;i++){if(i>=clusterInfo.y)break;SpotLight spotLight=getSpotLight(u_LightBuffer,u_LightClusterBuffer,clusterInfo,i);\n#if defined(CALCULATE_SPOTSHADOWS)\nif(i==0){vec4 spotShadowcoord=v_SpotShadowCoord;spotLight.color*=sampleSpotShadowmap(spotShadowcoord);}\n#endif\nLayaAirBlinnPhongSpotLight(v_PositionWorld,u_MaterialSpecular,u_Shininess,normal,gloss,viewDir,spotLight,transmissionFactor,dif,spe,transmis);diffuse+=dif;specular+=spe;transmissionDiffuse+=transmis;}\n#endif\n#endif\n#endif\n*/}";

    class ToonyColorMaterial extends Laya.BlinnPhongMaterial {
        constructor() {
            super();
            this.setShaderName("ToonyColor");
            this._RampThreshold = 0.5;
            this._RampSmooth = 0.1;
            this._HColor = new Laya.Vector4(222 / 255, 222 / 255, 222 / 255, 1.0);
            this._SColor = new Laya.Vector4(130 / 255, 130 / 255, 130 / 255, 1.0);
        }
        set _Color(value) {
            this._shaderValues.setVector(ToonyColorMaterial.u_DiffuseColor, value);
        }
        get _Color() {
            return this._shaderValues.getVector(ToonyColorMaterial.u_DiffuseColor);
        }
        get _MainTex() {
            return this._shaderValues.getTexture(ToonyColorMaterial.ALBEDOTEXTURE);
        }
        set _MainTex(value) {
            if (value)
                this._shaderValues.addDefine(ToonyColorMaterial.SHADERDEFINE_DIFFUSEMAP);
            else
                this._shaderValues.removeDefine(ToonyColorMaterial.SHADERDEFINE_DIFFUSEMAP);
            this._shaderValues.setTexture(ToonyColorMaterial.ALBEDOTEXTURE, value);
        }
        set _SColor(value) {
            this._shaderValues.setVector(ToonyColorMaterial.u_SColor, value);
        }
        get _SColor() {
            return this._shaderValues.getVector(ToonyColorMaterial.u_SColor);
        }
        set _HColor(value) {
            this._shaderValues.setVector(ToonyColorMaterial.u_HColor, value);
        }
        get _HColor() {
            return this._shaderValues.getVector(ToonyColorMaterial.u_HColor);
        }
        set _RampSmooth(value) {
            this._shaderValues.setNumber(ToonyColorMaterial.u_RampSmooth, value);
        }
        get _RampSmooth() {
            return this._shaderValues.getNumber(ToonyColorMaterial.u_RampSmooth);
        }
        set _RampThreshold(value) {
            this._shaderValues.setNumber(ToonyColorMaterial.u_RampThreshold, value);
        }
        get _RampThreshold() {
            return this._shaderValues.getNumber(ToonyColorMaterial.u_RampThreshold);
        }
        set rampTexture(value) {
            if (value) {
                this._shaderValues.addDefine(ToonyColorMaterial.TCP2_RAMPTEXT);
            }
            else {
                this._shaderValues.removeDefine(ToonyColorMaterial.TCP2_RAMPTEXT);
            }
            this._shaderValues.setTexture(ToonyColorMaterial.u_RampTexture, value);
        }
        get rampTexture() {
            return this._shaderValues.getTexture(ToonyColorMaterial.u_RampTexture);
        }
        clone() {
            let t = new ToonyColorMaterial();
            t._Color = this._Color;
            t._MainTex = this._MainTex;
            t._SColor = this._SColor;
            t._HColor = this._HColor;
            t._RampSmooth = this._RampSmooth;
            t._RampThreshold = this._RampThreshold;
            return t;
        }
        static init() {
            Laya.ClassUtils.regClass("Laya.ToonyMobile", ToonyColorMaterial);
            var attributeMap = {
                'a_Position': Laya.VertexMesh.MESH_POSITION0,
                'a_Color': Laya.VertexMesh.MESH_COLOR0,
                'a_Normal': Laya.VertexMesh.MESH_NORMAL0,
                'a_Texcoord0': Laya.VertexMesh.MESH_TEXTURECOORDINATE0,
                'a_Texcoord1': Laya.VertexMesh.MESH_TEXTURECOORDINATE1,
                'a_BoneWeights': Laya.VertexMesh.MESH_BLENDWEIGHT0,
                'a_BoneIndices': Laya.VertexMesh.MESH_BLENDINDICES0,
                'a_Tangent0': Laya.VertexMesh.MESH_TANGENT0,
                'a_WorldMat': Laya.VertexMesh.MESH_WORLDMATRIX_ROW0,
                'a_SimpleTextureParams': Laya.VertexMesh.MESH_SIMPLEANIMATOR
            };
            var uniformMap = {
                'u_Bones': Laya.Shader3D.PERIOD_CUSTOM,
                'u_DiffuseTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_SpecularTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_NormalTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_AlphaTestValue': Laya.Shader3D.PERIOD_MATERIAL,
                'u_DiffuseColor': Laya.Shader3D.PERIOD_MATERIAL,
                'u_AlbedoIntensity': Laya.Shader3D.PERIOD_MATERIAL,
                'u_MaterialSpecular': Laya.Shader3D.PERIOD_MATERIAL,
                'u_Shininess': Laya.Shader3D.PERIOD_MATERIAL,
                'u_TilingOffset': Laya.Shader3D.PERIOD_MATERIAL,
                'u_TransmissionRate': Laya.Shader3D.PERIOD_MATERIAL,
                'u_BackDiffuse': Laya.Shader3D.PERIOD_MATERIAL,
                'u_BackScale': Laya.Shader3D.PERIOD_MATERIAL,
                'u_ThinknessTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_TransmissionColor': Laya.Shader3D.PERIOD_MATERIAL,
                'u_WorldMat': Laya.Shader3D.PERIOD_SPRITE,
                'u_MvpMatrix': Laya.Shader3D.PERIOD_SPRITE,
                'u_LightmapScaleOffset': Laya.Shader3D.PERIOD_SPRITE,
                'u_LightMap': Laya.Shader3D.PERIOD_SPRITE,
                'u_LightMapDirection': Laya.Shader3D.PERIOD_SPRITE,
                'u_SimpleAnimatorTexture': Laya.Shader3D.PERIOD_SPRITE,
                'u_SimpleAnimatorParams': Laya.Shader3D.PERIOD_SPRITE,
                'u_SimpleAnimatorTextureSize': Laya.Shader3D.PERIOD_SPRITE,
                'u_CameraPos': Laya.Shader3D.PERIOD_CAMERA,
                'u_Viewport': Laya.Shader3D.PERIOD_CAMERA,
                'u_ProjectionParams': Laya.Shader3D.PERIOD_CAMERA,
                'u_View': Laya.Shader3D.PERIOD_CAMERA,
                'u_ViewProjection': Laya.Shader3D.PERIOD_CAMERA,
                'u_ReflectTexture': Laya.Shader3D.PERIOD_SCENE,
                'u_FogStart': Laya.Shader3D.PERIOD_SCENE,
                'u_FogRange': Laya.Shader3D.PERIOD_SCENE,
                'u_FogColor': Laya.Shader3D.PERIOD_SCENE,
                'u_DirationLightCount': Laya.Shader3D.PERIOD_SCENE,
                'u_LightBuffer': Laya.Shader3D.PERIOD_SCENE,
                'u_LightClusterBuffer': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientColor': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowBias': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowLightDirection': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowMap': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowParams': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowSplitSpheres': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowMatrices': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowMapSize': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotShadowMap': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotViewProjectMatrix': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowLightPosition': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHAr': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHAg': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHAb': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHBr': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHBg': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHBb': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHC': Laya.Shader3D.PERIOD_SCENE,
                'u_DirectionLight.color': Laya.Shader3D.PERIOD_SCENE,
                'u_DirectionLight.direction': Laya.Shader3D.PERIOD_SCENE,
                'u_PointLight.position': Laya.Shader3D.PERIOD_SCENE,
                'u_PointLight.range': Laya.Shader3D.PERIOD_SCENE,
                'u_PointLight.color': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.position': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.direction': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.range': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.spot': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.color': Laya.Shader3D.PERIOD_SCENE,
                'u_RampTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_RampThreshold': Laya.Shader3D.PERIOD_MATERIAL,
                'u_RampSmooth': Laya.Shader3D.PERIOD_MATERIAL,
                'u_HColor': Laya.Shader3D.PERIOD_MATERIAL,
                'u_SColor': Laya.Shader3D.PERIOD_MATERIAL
            };
            var stateMap = {
                's_Cull': Laya.Shader3D.RENDER_STATE_CULL,
                's_Blend': Laya.Shader3D.RENDER_STATE_BLEND,
                's_BlendSrc': Laya.Shader3D.RENDER_STATE_BLEND_SRC,
                's_BlendDst': Laya.Shader3D.RENDER_STATE_BLEND_DST,
                's_DepthTest': Laya.Shader3D.RENDER_STATE_DEPTH_TEST,
                's_DepthWrite': Laya.Shader3D.RENDER_STATE_DEPTH_WRITE
            };
            var shader = Laya.Shader3D.add("ToonyColor", null, null, true);
            var subShader = new Laya.SubShader(attributeMap, uniformMap);
            shader.addSubShader(subShader);
            subShader.addShaderPass(DownTimeVS, DownTimeFS, stateMap, "Forward");
        }
    }
    ToonyColorMaterial.u_RampTexture = Laya.Shader3D.propertyNameToID("u_RampTexture");
    ToonyColorMaterial.u_RampThreshold = Laya.Shader3D.propertyNameToID("u_RampThreshold");
    ToonyColorMaterial.u_RampSmooth = Laya.Shader3D.propertyNameToID("u_RampSmooth");
    ToonyColorMaterial.u_HColor = Laya.Shader3D.propertyNameToID("u_HColor");
    ToonyColorMaterial.u_SColor = Laya.Shader3D.propertyNameToID("u_SColor");
    ToonyColorMaterial.u_DiffuseColor = Laya.Shader3D.propertyNameToID("u_DiffuseColor");
    ToonyColorMaterial.ALBEDOTEXTURE = Laya.Shader3D.propertyNameToID("u_DiffuseTexture");
    ToonyColorMaterial.TCP2_RAMPTEXT = Laya.Shader3D.getDefineByName("TCP2_RAMPTEXT");
    ToonyColorMaterial.SHADERDEFINE_DIFFUSEMAP = Laya.Shader3D.getDefineByName("DIFFUSEMAP");

    var UpType;
    (function (UpType) {
        UpType[UpType["unlock"] = 1] = "unlock";
        UpType[UpType["Speed1"] = 2] = "Speed1";
        UpType[UpType["Speed2"] = 3] = "Speed2";
        UpType[UpType["Speed3"] = 4] = "Speed3";
        UpType[UpType["Storage1"] = 5] = "Storage1";
        UpType[UpType["Storage2"] = 6] = "Storage2";
        UpType[UpType["ServingCarry"] = 7] = "ServingCarry";
        UpType[UpType["PlayerSpeed"] = 8] = "PlayerSpeed";
        UpType[UpType["PlayerCarry"] = 9] = "PlayerCarry";
    })(UpType || (UpType = {}));
    class UpLevel extends Laya.Script3D {
        constructor() {
            super(...arguments);
            this.fn_type = UpType.unlock;
            this.fn_Price = 0;
            this.fn_WType = WorkType.counter;
            this.fn_MianpianId = 0;
            this.fn_ToStep = 0;
            this.unlockT = 0;
            this.cur_money = 0;
            this.unLocked = false;
            this.uplevelId = 0;
            this._unlockTaget = null;
            this._obj = null;
            this._transform = null;
            this._lastShowFreeTime = 0;
            this._noMoneyShow = false;
            this.cameraView = false;
        }
        _parse(data, interactMap = null) {
            this.fn_type = UpType[data["fn_type"]];
            this.fn_Price = Number(data["fn_Price"]);
            this.fn_WType = WorkType[data["fn_WType"]];
            this.fn_MianpianId = Number(data["fn_MianpianId"]);
            if (data["fn_ToStep"] == 0) {
                this.fn_ToStep = this.fn_MianpianId + 1;
            }
            else {
                this.fn_ToStep = Number(data["fn_ToStep"]);
            }
        }
        _cloneTo(dest) {
            dest["fn_type"] = this.fn_type;
            dest["fn_Price"] = this.fn_Price;
            dest["fn_WType"] = this.fn_WType;
            dest["fn_MianpianId"] = this.fn_MianpianId;
            dest["fn_ToStep"] = this.fn_ToStep;
        }
        onAwake() {
            this._obj = this.owner;
            this._transform = this._obj.transform;
            EventMgr$1.Int.on(EventType$1.UPDATE_UPLEVEL, this.OnActive, this);
            EventMgr$1.Int.on(EventType$1.INIT_UPLEVEL, this.InitLock, this);
            if (this.fn_type == UpType.unlock) {
                if (this.fn_WType == WorkType.normal) {
                    this.unlockT = 0;
                    let prt = this._obj.parent;
                    this._unlockTaget = prt.addComponent(LockScript);
                    this._unlockTaget.SetUplevelScript(this);
                }
                else {
                    this.unlockT = 1;
                    switch (this.fn_WType) {
                        case WorkType.cook:
                            this.InitUpLevelId(4);
                            break;
                        case WorkType.waiter:
                            this.InitUpLevelId(11);
                            break;
                        case WorkType.counter:
                            this.InitUpLevelId(9);
                            break;
                        case WorkType.fishing:
                            this.InitUpLevelId(5);
                            break;
                    }
                }
            }
            else {
                this.unlockT = 2;
                switch (this.fn_type) {
                    case UpType.Speed1:
                        this.InitUpLevelId(12);
                        break;
                    case UpType.Speed2:
                        this.InitUpLevelId(8);
                        break;
                    case UpType.Speed3:
                        this.InitUpLevelId(15);
                        break;
                    case UpType.Storage1:
                        this.InitUpLevelId(7);
                        break;
                    case UpType.Storage2:
                        this.InitUpLevelId(6);
                        break;
                    case UpType.ServingCarry:
                        this.InitUpLevelId(16);
                        break;
                    case UpType.PlayerSpeed:
                        this.InitUpLevelId(17);
                        break;
                    case UpType.PlayerCarry:
                        this.InitUpLevelId(10);
                        break;
                }
            }
            this.OnActive(null);
        }
        onEnable() {
        }
        onUpdate() {
            if (this._obj.active == true) ;
        }
        onDestroy() {
            EventMgr$1.Int.off(EventType$1.INIT_UPLEVEL, this.InitLock, this);
        }
        onTriggerEnter(other) {
            let scr = other.owner.getComponent(PlayerRole);
            if (scr) {
                UIMain$1.Int.InitGuideTip(10, false);
                this._noMoneyShow = false;
            }
        }
        onTriggerStay(other) {
            let scr = other.owner.getComponent(PlayerRole);
            if (scr) {
                let num = this.GetSubMoney();
                if (num == 0) {
                    this._showFreeMoneyUI();
                    return;
                }
                let bl = scr.SubMoney(num);
                if (bl) {
                    AudioMgr$1.instance.vibrateShort();
                    this.cur_money += num;
                    if (this.cur_money >= this.fn_Price) {
                        this.UnLock();
                    }
                }
                else {
                    this._showFreeMoneyUI();
                }
            }
        }
        _showFreeMoneyUI() {
            let now = Date.now();
            if (!this._noMoneyShow && now - this._lastShowFreeTime >= (+GameSDK$1.data.FreeMoneyInterval || 30) * 1000) {
                this._lastShowFreeTime = now;
                this._noMoneyShow = true;
                UIMgr.instance.openUI(ModuleType.FreeMoney, this.fn_Price - this.cur_money);
            }
        }
        onTriggerExit(other) {
            let scr = other.owner.getComponent(PlayerRole);
            if (scr) {
                this._noMoneyShow = false;
            }
        }
        InitUpLevelId(num) {
            this.uplevelId = num;
        }
        BuildUnLock(isInit) {
            if (this._unlockTaget) {
                let arr = this._obj.name.split("_");
                if (arr[0] == "SushibarPay") {
                    UIMain$1.Int.InitGuideTip(4, false);
                    UIMain$1.Int.InitGuideTip(5);
                    if (CanteenMgr.Int.StageId == 1) {
                        if (!isInit)
                            ReportMgr.inst.sendReport("解锁旋转吧台" + ReportMgr.inst.getNextIdByBuild(0));
                        LogicData.instance.SetTableLevel_1(Number(arr[1]));
                    }
                    else {
                        if (!isInit)
                            ReportMgr.inst.sendReport("解锁金枪鱼台" + ReportMgr.inst.getNextIdByBuild(1));
                        LogicData.instance.SetTableLevel_2(Number(arr[1]));
                    }
                    let prt = this._obj.parent;
                    let scr = prt.getComponent(CTable);
                    if (scr) {
                        scr.UpdateLevel();
                    }
                }
                this._unlockTaget.UnLock(isInit);
                this._obj.active = false;
            }
        }
        WorkUnLock() {
            RoleMgr.Int.AddWorker(this.fn_WType, this._transform.position.clone(), this._transform.rotationEuler.clone());
            if (this.fn_WType == WorkType.cook) {
                CanteenMgr.Int.TipCar();
            }
        }
        PowerUnLock() {
            LogicData.instance.AddCanteenPowerLevel(UpType[this.fn_type]);
            let tp = null;
            switch (this.fn_type) {
                case UpType.Speed1:
                    tp = WorkType.fishing;
                    break;
                case UpType.Speed2:
                    tp = WorkType.cook;
                    break;
                case UpType.Speed3:
                    tp = WorkType.waiter;
                    break;
                case UpType.Storage1:
                    tp = WorkType.fishing;
                    break;
                case UpType.Storage2:
                    tp = WorkType.cook;
                    break;
                case UpType.ServingCarry:
                    tp = WorkType.waiter;
                    break;
                case UpType.PlayerSpeed:
                    break;
                case UpType.PlayerCarry:
                    break;
            }
            let array = RoleMgr.Int.FindNpcByType(tp);
            for (let index = 0; index < array.length; index++) {
                const element = array[index];
                EffectMgr.Int.showEffect(element, 4);
            }
        }
        UnLock() {
            if (CanteenMgr.Int.StageId == 1) {
                LogicData.instance.AddReadyArr_1(this.fn_MianpianId);
            }
            else {
                LogicData.instance.AddReadyArr_2(this.fn_MianpianId);
            }
            let str = "解锁";
            if (this.fn_type == UpType.unlock) {
                if (this.fn_WType == WorkType.normal) {
                    str = "";
                }
                else {
                    switch (this.fn_WType) {
                        case WorkType.cook:
                            str += "厨师";
                            break;
                        case WorkType.waiter:
                            str += "服务员";
                            break;
                        case WorkType.counter:
                            str += "收银员";
                            break;
                        case WorkType.fishing:
                            str += "钓鱼人";
                            break;
                    }
                    str += ReportMgr.inst.getNextIdByWorkType(this.fn_WType);
                }
            }
            else {
                this.unlockT = 2;
                switch (this.fn_type) {
                    case UpType.Speed1:
                        str += "速度一";
                        break;
                    case UpType.Speed2:
                        str += "速度二";
                        break;
                    case UpType.Speed3:
                        str += "速度三";
                        break;
                    case UpType.Storage1:
                        str += "储存量一";
                        break;
                    case UpType.Storage2:
                        str += "厨师储存量";
                        break;
                    case UpType.ServingCarry:
                        str += "服务员携带量";
                        break;
                    case UpType.PlayerSpeed:
                        str += "玩家速度";
                        break;
                    case UpType.PlayerCarry:
                        str += "玩家携带量";
                        break;
                    default:
                        str += "未知属性升级";
                        break;
                }
                str += ReportMgr.inst.getNextIdByUpType(this.fn_type);
            }
            if (!!str) {
                ReportMgr.inst.sendReport(str);
            }
            this.OnActive(null);
            this.InitLock();
            StepMgr.Int.OnFinshPay(this._obj.name);
        }
        InitLock(isInit = false) {
            let arr;
            if (CanteenMgr.Int.StageId == 1) {
                arr = LogicData.instance.ReadyArr_1;
            }
            else {
                arr = LogicData.instance.ReadyArr_2;
            }
            if (arr.indexOf(this.fn_MianpianId) >= 0) {
                if (this.unlockT == 0) {
                    this.BuildUnLock(isInit);
                }
                else if (this.unlockT == 1) {
                    let self = this;
                    Laya.timer.frameOnce(10, this, function () {
                        self.WorkUnLock();
                    });
                }
                else {
                    this.PowerUnLock();
                }
                this.unLocked = true;
            }
            else {
                this.unLocked = false;
            }
        }
        InitActive() {
            let arr = LogicData.instance.ReadyArr_1;
            let level = LogicData.instance.CanteenStep_1;
            if (this.fn_MianpianId != 0 && this.fn_MianpianId <= level && arr.indexOf(this.fn_MianpianId) < 0) {
                this._obj.active = true;
            }
            else {
                this._obj.active = false;
            }
        }
        AddDot() {
            CanteenMgr.Int.CameraScript.StartDot([this._transform.position.clone()]);
        }
        OnActive(name) {
            if (this._obj.name == name) {
                this.Show();
                EventMgr$1.Int.emit(EventType$1.JIESUO_TIP1, this);
            }
            else {
                this.Hide();
            }
        }
        get UplevelId() {
            return this.uplevelId;
        }
        get NeedMoney() {
            return this.fn_Price - this.cur_money;
        }
        Hide() {
            this._obj.active = false;
        }
        Show() {
            this._obj.active = true;
        }
        GetSubMoney() {
            let r = 0;
            let num = LogicProp.instance.get(EPropNameById.diamonds);
            if (num == 0) {
                UIMain$1.Int.InitGuideTip(11);
            }
            let tNum = Math.floor(this.fn_Price * 0.025);
            let subNum = this.fn_Price - this.cur_money;
            tNum == 0 ? (tNum = 1) : (tNum = tNum);
            if (tNum >= num) {
                r = num;
            }
            else {
                r = tNum;
            }
            if (r > subNum) {
                r = subNum;
            }
            return r;
        }
    }

    var OutlineVS = "#if defined(GL_FRAGMENT_PRECISION_HIGH)\nprecision highp float;precision highp int;\n#else\nprecision mediump float;precision mediump int;\n#endif\n#include \"Lighting.glsl\";\n#include \"LayaUtile.glsl\"\n#include \"Shadow.glsl\";\nattribute vec4 a_Position;attribute vec3 a_Normal;\n#ifdef GPU_INSTANCE\nattribute mat4 a_WorldMat;\n#else\nuniform mat4 u_MvpMatrix;uniform mat4 u_WorldMat;\n#endif\nuniform mat4 u_ViewProjection;\n#ifdef BONE\nconst int c_MaxBoneCount=24;attribute vec4 a_BoneIndices;attribute vec4 a_BoneWeights;uniform mat4 u_Bones[c_MaxBoneCount];\n#endif\nuniform float u_OutlineWidth;void main(){mat4 worldMat;mat3 worldInvMat;\n#ifdef GPU_INSTANCE\nworldMat=a_WorldMat;\n#else\nworldMat=u_WorldMat;\n#endif\n#ifdef BONE\nmat4 skinTransform;\n#ifdef SIMPLEBONE\nfloat currentPixelPos;\n#ifdef GPU_INSTANCE\ncurrentPixelPos=a_SimpleTextureParams.x+a_SimpleTextureParams.y;\n#else\ncurrentPixelPos=u_SimpleAnimatorParams.x+u_SimpleAnimatorParams.y;\n#endif\nfloat offset=1.0/u_SimpleAnimatorTextureSize;skinTransform=loadMatFromTexture(currentPixelPos,int(a_BoneIndices.x),offset)*a_BoneWeights.x;skinTransform+=loadMatFromTexture(currentPixelPos,int(a_BoneIndices.y),offset)*a_BoneWeights.y;skinTransform+=loadMatFromTexture(currentPixelPos,int(a_BoneIndices.z),offset)*a_BoneWeights.z;skinTransform+=loadMatFromTexture(currentPixelPos,int(a_BoneIndices.w),offset)*a_BoneWeights.w;\n#else\nskinTransform=u_Bones[int(a_BoneIndices.x)]*a_BoneWeights.x;skinTransform+=u_Bones[int(a_BoneIndices.y)]*a_BoneWeights.y;skinTransform+=u_Bones[int(a_BoneIndices.z)]*a_BoneWeights.z;skinTransform+=u_Bones[int(a_BoneIndices.w)]*a_BoneWeights.w;\n#endif\nworldMat=worldMat*skinTransform;worldInvMat=INVERSE_MAT(mat3(worldMat));\n#else\nworldInvMat=INVERSE_MAT(mat3(worldMat));\n#endif\nvec4 positionWS=worldMat*a_Position;vec3 normalWS=normalize(a_Normal*worldInvMat);positionWS.xyz=positionWS.xyz+normalWS*u_OutlineWidth*0.01;gl_Position=u_ViewProjection*positionWS;gl_Position=remapGLPositionZ(gl_Position);}";

    var OutlineFS = "#if defined(GL_FRAGMENT_PRECISION_HIGH)\nprecision highp float;precision highp int;\n#else\nprecision mediump float;precision mediump int;\n#endif\nuniform vec4 u_OutlineColor;void main(){gl_FragColor=vec4(u_OutlineColor.rgb,1.0);}";

    class ToonyOutLineMaterial extends ToonyColorMaterial {
        constructor() {
            super();
            this._outLineWidth = 0;
            this.setShaderName("ToonyOutLine");
            this._RampThreshold = 0.5;
            this._RampSmooth = 0.1;
            this._HColor = new Laya.Vector4(222 / 255, 222 / 255, 222 / 255, 1.0);
            this._SColor = new Laya.Vector4(130 / 255, 130 / 255, 130 / 255, 1.0);
            this.outlineWidth = 0.0;
        }
        set _OutLineColor(value) {
            this._shaderValues.setVector(ToonyOutLineMaterial.OUTLINECOLOR, value);
        }
        get _OutLineColor() {
            return this._shaderValues.getVector(ToonyOutLineMaterial.OUTLINECOLOR);
        }
        set _Outline(value) {
            this._outLineWidth = value;
            this.outlineWidth = this._outLineWidth;
        }
        get _Outline() {
            return this._outLineWidth;
        }
        showOutLine() {
            this.outlineWidth = this._outLineWidth;
        }
        hideOutLine() {
            this.outlineWidth = 0.0;
        }
        set outlineWidth(value) {
            this._shaderValues.setNumber(ToonyOutLineMaterial.OUTLINEWIDTH, value);
        }
        get outlineWidth() {
            return this._shaderValues.getNumber(ToonyOutLineMaterial.OUTLINEWIDTH);
        }
        clone() {
            let t = new ToonyOutLineMaterial();
            t._Color = this._Color;
            t._MainTex = this._MainTex;
            t._SColor = this._SColor;
            t._HColor = this._HColor;
            t._RampSmooth = this._RampSmooth;
            t._RampThreshold = this._RampThreshold;
            t._Outline = this._Outline;
            t._OutLineColor = this._OutLineColor;
            t.outlineWidth = this.outlineWidth;
            return t;
        }
        static init() {
            Laya.ClassUtils.regClass("Laya.ToonyOutLine", ToonyOutLineMaterial);
            var attributeMap = {
                'a_Position': Laya.VertexMesh.MESH_POSITION0,
                'a_Color': Laya.VertexMesh.MESH_COLOR0,
                'a_Normal': Laya.VertexMesh.MESH_NORMAL0,
                'a_Texcoord0': Laya.VertexMesh.MESH_TEXTURECOORDINATE0,
                'a_Texcoord1': Laya.VertexMesh.MESH_TEXTURECOORDINATE1,
                'a_BoneWeights': Laya.VertexMesh.MESH_BLENDWEIGHT0,
                'a_BoneIndices': Laya.VertexMesh.MESH_BLENDINDICES0,
                'a_Tangent0': Laya.VertexMesh.MESH_TANGENT0,
                'a_WorldMat': Laya.VertexMesh.MESH_WORLDMATRIX_ROW0,
                'a_SimpleTextureParams': Laya.VertexMesh.MESH_SIMPLEANIMATOR
            };
            var uniformMap = {
                'u_Bones': Laya.Shader3D.PERIOD_CUSTOM,
                'u_DiffuseTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_SpecularTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_NormalTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_AlphaTestValue': Laya.Shader3D.PERIOD_MATERIAL,
                'u_DiffuseColor': Laya.Shader3D.PERIOD_MATERIAL,
                'u_AlbedoIntensity': Laya.Shader3D.PERIOD_MATERIAL,
                'u_MaterialSpecular': Laya.Shader3D.PERIOD_MATERIAL,
                'u_Shininess': Laya.Shader3D.PERIOD_MATERIAL,
                'u_TilingOffset': Laya.Shader3D.PERIOD_MATERIAL,
                'u_TransmissionRate': Laya.Shader3D.PERIOD_MATERIAL,
                'u_BackDiffuse': Laya.Shader3D.PERIOD_MATERIAL,
                'u_BackScale': Laya.Shader3D.PERIOD_MATERIAL,
                'u_ThinknessTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_TransmissionColor': Laya.Shader3D.PERIOD_MATERIAL,
                'u_WorldMat': Laya.Shader3D.PERIOD_SPRITE,
                'u_MvpMatrix': Laya.Shader3D.PERIOD_SPRITE,
                'u_LightmapScaleOffset': Laya.Shader3D.PERIOD_SPRITE,
                'u_LightMap': Laya.Shader3D.PERIOD_SPRITE,
                'u_LightMapDirection': Laya.Shader3D.PERIOD_SPRITE,
                'u_SimpleAnimatorTexture': Laya.Shader3D.PERIOD_SPRITE,
                'u_SimpleAnimatorParams': Laya.Shader3D.PERIOD_SPRITE,
                'u_SimpleAnimatorTextureSize': Laya.Shader3D.PERIOD_SPRITE,
                'u_CameraPos': Laya.Shader3D.PERIOD_CAMERA,
                'u_Viewport': Laya.Shader3D.PERIOD_CAMERA,
                'u_ProjectionParams': Laya.Shader3D.PERIOD_CAMERA,
                'u_View': Laya.Shader3D.PERIOD_CAMERA,
                'u_ViewProjection': Laya.Shader3D.PERIOD_CAMERA,
                'u_ReflectTexture': Laya.Shader3D.PERIOD_SCENE,
                'u_FogStart': Laya.Shader3D.PERIOD_SCENE,
                'u_FogRange': Laya.Shader3D.PERIOD_SCENE,
                'u_FogColor': Laya.Shader3D.PERIOD_SCENE,
                'u_DirationLightCount': Laya.Shader3D.PERIOD_SCENE,
                'u_LightBuffer': Laya.Shader3D.PERIOD_SCENE,
                'u_LightClusterBuffer': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientColor': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowBias': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowLightDirection': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowMap': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowParams': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowSplitSpheres': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowMatrices': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowMapSize': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotShadowMap': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotViewProjectMatrix': Laya.Shader3D.PERIOD_SCENE,
                'u_ShadowLightPosition': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHAr': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHAg': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHAb': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHBr': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHBg': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHBb': Laya.Shader3D.PERIOD_SCENE,
                'u_AmbientSHC': Laya.Shader3D.PERIOD_SCENE,
                'u_DirectionLight.color': Laya.Shader3D.PERIOD_SCENE,
                'u_DirectionLight.direction': Laya.Shader3D.PERIOD_SCENE,
                'u_PointLight.position': Laya.Shader3D.PERIOD_SCENE,
                'u_PointLight.range': Laya.Shader3D.PERIOD_SCENE,
                'u_PointLight.color': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.position': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.direction': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.range': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.spot': Laya.Shader3D.PERIOD_SCENE,
                'u_SpotLight.color': Laya.Shader3D.PERIOD_SCENE,
                'u_RampTexture': Laya.Shader3D.PERIOD_MATERIAL,
                'u_RampThreshold': Laya.Shader3D.PERIOD_MATERIAL,
                'u_RampSmooth': Laya.Shader3D.PERIOD_MATERIAL,
                'u_HColor': Laya.Shader3D.PERIOD_MATERIAL,
                'u_SColor': Laya.Shader3D.PERIOD_MATERIAL,
                'u_OutlineWidth': Laya.Shader3D.PERIOD_MATERIAL,
                'u_OutlineColor': Laya.Shader3D.PERIOD_MATERIAL
            };
            var stateMap = {
                's_Cull': Laya.Shader3D.RENDER_STATE_CULL,
                's_Blend': Laya.Shader3D.RENDER_STATE_BLEND,
                's_BlendSrc': Laya.Shader3D.RENDER_STATE_BLEND_SRC,
                's_BlendDst': Laya.Shader3D.RENDER_STATE_BLEND_DST,
                's_DepthTest': Laya.Shader3D.RENDER_STATE_DEPTH_TEST,
                's_DepthWrite': Laya.Shader3D.RENDER_STATE_DEPTH_WRITE
            };
            var shader = Laya.Shader3D.add("ToonyOutLine", null, null, true);
            var subShader = new Laya.SubShader(attributeMap, uniformMap);
            shader.addSubShader(subShader);
            var pass = subShader.addShaderPass(OutlineVS, OutlineFS);
            pass.renderState.cull = Laya.RenderState.CULL_FRONT;
            subShader.addShaderPass(DownTimeVS, DownTimeFS, stateMap, "Forward");
        }
    }
    ToonyOutLineMaterial.OUTLINEWIDTH = Laya.Shader3D.propertyNameToID("u_OutlineWidth");
    ToonyOutLineMaterial.OUTLINECOLOR = Laya.Shader3D.propertyNameToID("u_OutlineColor");

    class SubPackageMgr {
        static enable(callback = null) {
            Laya.loader.create("subPackConfig.json", Laya.Handler.create(this, this._onInfoLoaded, [callback]), null, Laya.Loader.JSON);
        }
        static _onInfoLoaded(callback, data) {
            if (data != undefined) {
                this.platMgrConfig = data;
            }
            callback && callback.run();
        }
        static perLoadMainPack(handler) {
            this.loadPackByphase(1, Laya.Handler.create(this, () => {
                GameSDK$1.initConfig(() => {
                    handler.run();
                });
            }));
        }
        static loadPackByphase(phase, handler) {
            var data = this.platMgrConfig[phase];
            if (data == undefined) {
                handler.run();
                return;
            }
            this.loadSubPack(data, handler);
        }
        static loadSubPack(paths, handler) {
            if (paths.length <= 0) {
                handler.run();
                return;
            }
            let config = paths.shift();
            if (this._loadPacks.indexOf(config.packName) >= 0) {
                SubPackageMgr.loadSubPack(paths, handler);
            }
            else {
                GameSDK$1.loadSubpackage(config.packName, config.zipPath, config.filePath, function () {
                    SubPackageMgr.loadSubPack(paths, handler);
                    SubPackageMgr._loadPacks.push(config.packName);
                }, undefined);
            }
        }
    }
    SubPackageMgr.platMgrConfig = {};
    SubPackageMgr._loadPacks = [];

    class TestExtData extends Laya.Script3D {
        constructor() {
            super();
        }
        onAwake() {
            console.warn("TestExtData   onAwake");
        }
        _parse(data, interactMap = null) {
            console.warn("data===================>", data, interactMap);
        }
        _cloneTo(dest) {
            console.warn("dest===================>", dest);
        }
    }
    class Main {
        constructor() {
            this.index = 0;
            let config3D = new Config3D();
            config3D.octreeCulling = false;
            config3D.enableMultiLight = false;
            config3D.isAntialias = true;
            if (window["Laya3D"])
                Laya3D.init(GameConfig.width, GameConfig.height, config3D, Laya.Handler.create(this, function () {
                    Laya["Physics"] && Laya["Physics"].enable();
                    Laya["DebugPanel"] && Laya["DebugPanel"].enable();
                    Laya.stage.scaleMode = "showall";
                    Laya.stage.screenMode = "none";
                    Laya.stage.alignV = "middle";
                    Laya.stage.alignH = "center";
                    Laya.stage.frameRate = Laya.Stage.FRAME_FAST;
                    Laya.URL.exportSceneToJson = GameConfig.exportSceneToJson;
                    if (GameConfig.debug || Laya.Utils.getQueryString("debug") == "true")
                        Laya.enableDebugPanel();
                    if (GameConfig.physicsDebug && Laya["PhysicsDebugDraw"])
                        Laya["PhysicsDebugDraw"].enable();
                    if (GameConfig.stat)
                        Laya.Stat.show();
                    Laya.alertGlobalError(true);
                    ToonyOutLineMaterial.init();
                    ToonyColorMaterial.init();
                    Laya.ClassUtils.regClass("UpLevel", UpLevel);
                    Laya.MouseManager.multiTouchEnabled = true;
                    fgui.UIConfig.packageFileExtension = "xml";
                    Laya.stage.addChild(fgui.GRoot.inst.displayObject);
                    fgui.GRoot.inst.displayObject.mouseThrough = true;
                    Laya.ResourceVersion.enable("version.json", Laya.Handler.create(this, this.onVersionLoaded), Laya.ResourceVersion.FILENAME_VERSION);
                }));
            else
                Laya.init(GameConfig.width, GameConfig.height, Laya["WebGL"]);
        }
        onVersionLoaded() {
            Laya.AtlasInfoManager.enable("fileconfig.json", Laya.Handler.create(this, this.onConfigLoaded));
        }
        onConfigLoaded() {
            ResourcesMgr$1.instance.fguiUrls = UIMgr.instance.getFguiUrl();
            window.clearFrist && window.clearFrist();
            UIMgr.instance.openUI(ModuleType.Loading, null, this.onLoading.bind(this));
        }
        onLoading() {
            let count = 2;
            let countCall = () => {
                count--;
                console.log("加载计数:", count);
                if (count <= 0) {
                    UIMgr.instance.closeUI(ModuleType.Loading, true);
                    ReportMgr.inst.sendReport(ReportType.LOADING_END);
                }
            };
            GameSDK$1.ctor(SDKData.data);
            this.initEvent();
            let self = this;
            SubPackageMgr.enable(Laya.Handler.create(this, () => {
                SubPackageMgr.perLoadMainPack(Laya.Handler.create(this, () => {
                    GameData.init(() => {
                        countCall();
                        self.initUserData();
                        CanteenMgr.Int.enter(countCall);
                    });
                }));
            }));
        }
        initUserData() {
            LogicData.instance.initData();
            LogicSkin.instance.initData();
            LogicSign.instance.initData();
            LogicProp$1.instance.initData();
            LogicShock$1.instance.initData();
            LogicTurntable.instance.initData();
        }
        OnSubPackage(func, name) {
            let self = this;
            if (Laya.Browser.onVVMiniGame || Laya.Browser.onQGMiniGame) {
                qgLoadSubpackge(name, function () {
                    self.index += 1;
                    func();
                });
                return true;
            }
            return false;
        }
        initEvent() {
            Laya.stage.on(Laya.Event.KEY_DOWN, this, this.onKeyDown);
        }
        clearEvent() {
            Laya.stage.off(Laya.Event.KEY_DOWN, this, this.onKeyDown);
        }
        onKeyDown(e) {
            if (e.keyCode == Laya.Keyboard.A) ;
        }
    }
    new Main();
    var wxLoadSubpackge = function (packName, cb) {
        let wx = Laya.Browser.window.wx;
        if (!wx) {
            if (cb) {
                cb();
            }
            return;
        }
        wx.loadSubpackage({
            name: packName,
            success: function (res) {
                console.warn("微信加载分包成功", packName);
                if (cb) {
                    cb();
                }
            },
            fail: function (res) {
                console.warn("微信加载分包失败");
            },
            complete: function () { },
        });
    };
    var qgLoadSubpackge = function (packName, cb) {
        let qg = Laya.Browser.window.qg;
        if (!qg || !qg.loadSubpackage) {
            if (cb) {
                cb();
            }
            return;
        }
        qg.loadSubpackage({
            name: packName,
            success: function (res) {
                console.warn("VIVo加载分包成功", packName);
                if (cb) {
                    cb();
                }
            },
            fail: function (res) {
                console.warn("VIVO加载分包失败");
            },
            complete: function () { },
        });
    };

    exports.qgLoadSubpackge = qgLoadSubpackge;
    exports.wxLoadSubpackge = wxLoadSubpackge;

    Object.defineProperty(exports, '__esModule', { value: true });

    return exports;

})({});
//# sourceMappingURL=bundle.js.map
